
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 5 "preproc.y"

#include "postgres_fe.h"

#include "extern.h"
#include "ecpg_config.h"
#include <unistd.h>

/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
                if (N) \
			(Current) = (Rhs)[1]; \
		else \
		        (Current) = (Rhs)[0]; \
	} while (0)

/*
 * The %name-prefix option below will make bison call base_yylex, but we
 * really want it to call filtered_base_yylex (see parser.c).
 */
#define base_yylex filtered_base_yylex

/*
 * This is only here so the string gets into the POT.  Bison uses it
 * internally.
 */
#define bison_gettext_dummy gettext_noop("syntax error")

/*
 * Variables containing simple states.
 */
int struct_level = 0;
int braces_open; /* brace level counter */
char *current_function;
int ecpg_internal_var = 0;
char	*connection = NULL;
char	*input_filename = NULL;

static int	FoundInto = 0;
static int	initializer = 0;
static int	pacounter = 1;
static char     pacounter_buffer[sizeof(int) * CHAR_BIT * 10 / 3]; /* a rough guess at the size we need */
static struct this_type actual_type[STRUCT_DEPTH];
static char *actual_startline[STRUCT_DEPTH];
static int 	varchar_counter = 1;

/* temporarily store struct members while creating the data structure */
struct ECPGstruct_member *struct_member_list[STRUCT_DEPTH] = { NULL };

/* also store struct type so we can do a sizeof() later */
static char *ECPGstruct_sizeof = NULL;

/* for forward declarations we have to store some data as well */
static char *forward_name = NULL;

struct ECPGtype ecpg_no_indicator = {ECPGt_NO_INDICATOR, NULL, NULL, NULL, {NULL}, 0};
struct variable no_indicator = {"no_indicator", &ecpg_no_indicator, 0, NULL};

struct ECPGtype ecpg_query = {ECPGt_char_variable, NULL, NULL, NULL, {NULL}, 0};

/*
 * Handle parsing errors and warnings
 */
void
mmerror(int error_code, enum errortype type, const char *error, ...)
{
	va_list ap;

	/* internationalize the error message string */
	error = _(error);

	fprintf(stderr, "%s:%d: ", input_filename, yylineno);

	switch(type)
	{
		case ET_WARNING:
			fprintf(stderr, _("WARNING: "));
			break;
		case ET_ERROR:
		case ET_FATAL:
			fprintf(stderr, _("ERROR: "));
			break;
	}

	va_start(ap, error);
	vfprintf(stderr, error, ap);
	va_end(ap);

	fprintf(stderr, "\n");

	switch(type)
	{
		case ET_WARNING:
			break;
		case ET_ERROR:
			ret_value = error_code;
			break;
		case ET_FATAL:
			if (yyin)
				fclose(yyin);
			if (yyout)
				fclose(yyout);
			
			if (strcmp(output_filename, "-") != 0 && unlink(output_filename) != 0)
			        fprintf(stderr, _("could not remove output file \"%s\"\n"), output_filename);
			exit(error_code);
	}
}

/*
 * string concatenation
 */

static char *
cat2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 2);

	strcpy(res_str, str1);
	if (strlen(str1) != 0 && strlen(str2) != 0)
		strcat(res_str, " ");
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
cat_str(int count, ...)
{
	va_list		args;
	int			i;
	char		*res_str;

	va_start(args, count);

	res_str = va_arg(args, char *);

	/* now add all other strings */
	for (i = 1; i < count; i++)
		res_str = cat2_str(res_str, va_arg(args, char *));

	va_end(args);

	return(res_str);
}

char *
make_str(const char *str)
{
	char * res_str = (char *)mm_alloc(strlen(str) + 1);

	strcpy(res_str, str);
	return res_str;
}

static char *
make2_str(char *str1, char *str2)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	free(str1);
	free(str2);
	return(res_str);
}

static char *
make3_str(char *str1, char *str2, char *str3)
{
	char * res_str	= (char *)mm_alloc(strlen(str1) + strlen(str2) +strlen(str3) + 1);

	strcpy(res_str, str1);
	strcat(res_str, str2);
	strcat(res_str, str3);
	free(str1);
	free(str2);
	free(str3);
	return(res_str);
}

/* and the rest */
static char *
make_name(void)
{
	return mm_strdup(yytext);
}

static char *
create_questionmarks(char *name, bool array)
{
	struct variable *p = find_variable(name);
	int count;
	char *result = EMPTY;

	/* In case we have a struct, we have to print as many "?" as there are attributes in the struct
	 * An array is only allowed together with an element argument
	 * This is essantially only used for inserts, but using a struct as input parameter is an error anywhere else
	 * so we don't have to worry here. */

	if (p->type->type == ECPGt_struct || (array && p->type->type == ECPGt_array && p->type->u.element->type == ECPGt_struct))
	{
		struct ECPGstruct_member *m;

		if (p->type->type == ECPGt_struct)
			m = p->type->u.members;
		else
			m = p->type->u.element->u.members;

		for (count = 0; m != NULL; m=m->next, count++);
	}
	else
		count = 1;

	for (; count > 0; count --)
	{
		sprintf(pacounter_buffer, "$%d", pacounter++);
		result = cat_str(3, result, mm_strdup(pacounter_buffer), make_str(" , "));
	}

	/* removed the trailing " ," */

	result[strlen(result)-3] = '\0';
	return(result);
}

static char *
adjust_outofscope_cursor_vars(struct cursor *cur)
{
	/* Informix accepts DECLARE with variables that are out of scope when OPEN is called.
	 * For instance you can DECLARE a cursor in one function, and OPEN/FETCH/CLOSE
	 * it in other functions. This is very useful for e.g. event-driver programming,
	 * but may also lead to dangerous programming. The limitation when this is allowed
	 * and doesn's cause problems have to be documented, like the allocated variables
	 * must not be realloc()'ed.
	 *
	 * We have to change the variables to our own struct and just store the pointer
	 * instead of the variable. Do it only for local variables, not for globals.
	 */

	char *result = make_str("");
	int insert;

	for (insert = 1; insert >= 0; insert--)
	{
		struct arguments *list;
		struct arguments *ptr;
		struct arguments *newlist = NULL;
		struct variable *newvar, *newind;

		list = (insert ? cur->argsinsert : cur->argsresult);

		for (ptr = list; ptr != NULL; ptr = ptr->next)
		{
			char temp[20];
			char *original_var;
			bool skip_set_var = false;

			/* change variable name to "ECPGget_var(<counter>)" */
			original_var = ptr->variable->name;
			sprintf(temp, "%d))", ecpg_internal_var);

			/* Don't emit ECPGset_var() calls for global variables */
			if (ptr->variable->brace_level == 0)
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type == ECPGt_char_variable) && (!strncmp(ptr->variable->name, "ECPGprepared_statement", strlen("ECPGprepared_statement"))))
			{
				newvar = ptr->variable;
				skip_set_var = true;
			}
			else if ((ptr->variable->type->type != ECPGt_varchar && ptr->variable->type->type != ECPGt_char && ptr->variable->type->type != ECPGt_unsigned_char && ptr->variable->type->type != ECPGt_string) && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->variable->type->u.element->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type, make_str("1"), ptr->variable->type->u.element->counter), ptr->variable->type->size), 0);
				sprintf(temp, "%d, (", ecpg_internal_var++);
			}
			else if ((ptr->variable->type->type == ECPGt_varchar || ptr->variable->type->type == ECPGt_char || ptr->variable->type->type == ECPGt_unsigned_char || ptr->variable->type->type == ECPGt_string) && atoi(ptr->variable->type->size) > 1)
			{
				newvar = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->variable->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->variable->type->type, ptr->variable->type->size, ptr->variable->type->counter), 0);
				if (ptr->variable->type->type == ECPGt_varchar)
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				else
					sprintf(temp, "%d, (", ecpg_internal_var++);
			}
			else if (ptr->variable->type->type == ECPGt_struct || ptr->variable->type->type == ECPGt_union)
			{
				sprintf(temp, "%d)))", ecpg_internal_var);
				newvar = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->variable->type->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->variable->type->u.members, ptr->variable->type->type, ptr->variable->type->type_name, ptr->variable->type->struct_sizeof), 0);
				sprintf(temp, "%d, &(", ecpg_internal_var++);
			}
			else if (ptr->variable->type->type == ECPGt_array)
			{
				if (ptr->variable->type->u.element->type == ECPGt_struct || ptr->variable->type->u.element->type == ECPGt_union)
				{
					sprintf(temp, "%d)))", ecpg_internal_var);
					newvar = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->variable->type->u.element->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->variable->type->u.element->u.members, ptr->variable->type->u.element->type, ptr->variable->type->u.element->type_name, ptr->variable->type->u.element->struct_sizeof), 0);
					sprintf(temp, "%d, (", ecpg_internal_var++);
				}
				else
				{
					newvar = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->variable->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_array_type(ECPGmake_simple_type(ptr->variable->type->u.element->type, ptr->variable->type->u.element->size, ptr->variable->type->u.element->counter), ptr->variable->type->size), 0);
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				}
			}
			else
			{
				newvar = new_variable(cat_str(4, make_str("*("), mm_strdup(ecpg_type_name(ptr->variable->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->variable->type->type, ptr->variable->type->size, ptr->variable->type->counter), 0);
				sprintf(temp, "%d, &(", ecpg_internal_var++);
			}

			/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
			if (!skip_set_var)
				result = cat_str(5, result, make_str("ECPGset_var("), mm_strdup(temp), mm_strdup(original_var), make_str("), __LINE__);\n"));

			/* now the indicator if there is one and it's not a global variable */
			if ((ptr->indicator->type->type == ECPGt_NO_INDICATOR) || (ptr->indicator->brace_level == 0))
			{
				newind = ptr->indicator;
			}
			else
			{
				/* change variable name to "ECPGget_var(<counter>)" */
				original_var = ptr->indicator->name;
				sprintf(temp, "%d))", ecpg_internal_var);

				if (ptr->indicator->type->type == ECPGt_struct || ptr->indicator->type->type == ECPGt_union)
				{
					sprintf(temp, "%d)))", ecpg_internal_var);
					newind = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->indicator->type->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->indicator->type->u.members, ptr->indicator->type->type, ptr->indicator->type->type_name, ptr->indicator->type->struct_sizeof), 0);
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				}
				else if (ptr->indicator->type->type == ECPGt_array)
				{
					if (ptr->indicator->type->u.element->type == ECPGt_struct || ptr->indicator->type->u.element->type == ECPGt_union)
					{
						sprintf(temp, "%d)))", ecpg_internal_var);
						newind = new_variable(cat_str(4, make_str("(*("), mm_strdup(ptr->indicator->type->u.element->type_name), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_struct_type(ptr->indicator->type->u.element->u.members, ptr->indicator->type->u.element->type, ptr->indicator->type->u.element->type_name, ptr->indicator->type->u.element->struct_sizeof), 0);
						sprintf(temp, "%d, (", ecpg_internal_var++);
					}
					else
					{
						newind = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->indicator->type->u.element->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_array_type(ECPGmake_simple_type(ptr->indicator->type->u.element->type, ptr->indicator->type->u.element->size, ptr->indicator->type->u.element->counter), ptr->indicator->type->size), 0);
						sprintf(temp, "%d, &(", ecpg_internal_var++);
					}
				}
				else if (atoi(ptr->indicator->type->size) > 1)
				{
					newind = new_variable(cat_str(4, make_str("("), mm_strdup(ecpg_type_name(ptr->indicator->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->indicator->type->type, ptr->indicator->type->size, ptr->variable->type->counter), 0);
					sprintf(temp, "%d, (", ecpg_internal_var++);
				}
				else
				{
					newind = new_variable(cat_str(4, make_str("*("), mm_strdup(ecpg_type_name(ptr->indicator->type->type)), make_str(" *)(ECPGget_var("), mm_strdup(temp)), ECPGmake_simple_type(ptr->indicator->type->type, ptr->indicator->type->size, ptr->variable->type->counter), 0);
					sprintf(temp, "%d, &(", ecpg_internal_var++);
				}

				/* create call to "ECPGset_var(<counter>, <pointer>. <line number>)" */
				result = cat_str(5, result, make_str("ECPGset_var("), mm_strdup(temp), mm_strdup(original_var), make_str("), __LINE__);\n"));
			}

			add_variable_to_tail(&newlist, newvar, newind);
		}

		if (insert)
			cur->argsinsert_oos = newlist;
		else
			cur->argsresult_oos = newlist;
	}

	return result;
}

/* This tests whether the cursor was declared and opened in the same function. */
#define SAMEFUNC(cur)	\
	((cur->function == NULL) ||		\
	 (cur->function != NULL && !strcmp(cur->function, current_function)))

static struct cursor *
add_additional_variables(char *name, bool insert)
{
	struct cursor *ptr;
	struct arguments *p;

	for (ptr = cur; ptr != NULL; ptr=ptr->next)
	{
		if (strcmp(ptr->name, name) == 0)
			break;
	}

	if (ptr == NULL)
	{
		mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" does not exist", name);
		return NULL;
	}

	if (insert)
	{
		/* add all those input variables that were given earlier
		 * note that we have to append here but have to keep the existing order */
		for (p = (SAMEFUNC(ptr) ? ptr->argsinsert : ptr->argsinsert_oos); p; p = p->next)
			add_variable_to_tail(&argsinsert, p->variable, p->indicator);
	}

	/* add all those output variables that were given earlier */
	for (p = (SAMEFUNC(ptr) ? ptr->argsresult : ptr->argsresult_oos); p; p = p->next)
		add_variable_to_tail(&argsresult, p->variable, p->indicator);

	return ptr;
}

static void
add_typedef(char *name, char * dimension, char * length, enum ECPGttype type_enum, char *type_dimension, char *type_index, int initializer, int array)
{
	/* add entry to list */
	struct typedefs *ptr, *this;

	if ((type_enum == ECPGt_struct ||
	     type_enum == ECPGt_union) &&
	    initializer == 1)
		mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in type definition");
	else if (INFORMIX_MODE && strcmp(name, "string") == 0)
		mmerror(PARSE_ERROR, ET_ERROR, "type name \"string\" is reserved in Informix mode");
	else
	{
		for (ptr = types; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp(name, ptr->name) == 0)
				/* re-definition is a bug */
				mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", name);
		}
		adjust_array(type_enum, &dimension, &length, type_dimension, type_index, array, true);

		this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

		/* initial definition */
		this->next = types;
		this->name = name;
		this->brace_level = braces_open;
		this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
		this->type->type_enum = type_enum;
		this->type->type_str = mm_strdup(name);
		this->type->type_dimension = dimension; /* dimension of array */
		this->type->type_index = length;	/* length of string */
		this->type->type_sizeof = ECPGstruct_sizeof;
		this->struct_member_list = (type_enum == ECPGt_struct || type_enum == ECPGt_union) ?
		ECPGstruct_member_dup(struct_member_list[struct_level]) : NULL;

		if (type_enum != ECPGt_varchar &&
			type_enum != ECPGt_char &&
			type_enum != ECPGt_unsigned_char &&
			type_enum != ECPGt_string &&
			atoi(this->type->type_index) >= 0)
			mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

		types = this;
	}
}


/* Line 189 of yacc.c  */
#line 544 "preproc.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SQL_ALLOCATE = 258,
     SQL_AUTOCOMMIT = 259,
     SQL_BOOL = 260,
     SQL_BREAK = 261,
     SQL_CALL = 262,
     SQL_CARDINALITY = 263,
     SQL_CONNECT = 264,
     SQL_COUNT = 265,
     SQL_DATETIME_INTERVAL_CODE = 266,
     SQL_DATETIME_INTERVAL_PRECISION = 267,
     SQL_DESCRIBE = 268,
     SQL_DESCRIPTOR = 269,
     SQL_DISCONNECT = 270,
     SQL_FOUND = 271,
     SQL_FREE = 272,
     SQL_GET = 273,
     SQL_GO = 274,
     SQL_GOTO = 275,
     SQL_IDENTIFIED = 276,
     SQL_INDICATOR = 277,
     SQL_KEY_MEMBER = 278,
     SQL_LENGTH = 279,
     SQL_LONG = 280,
     SQL_NULLABLE = 281,
     SQL_OCTET_LENGTH = 282,
     SQL_OPEN = 283,
     SQL_OUTPUT = 284,
     SQL_REFERENCE = 285,
     SQL_RETURNED_LENGTH = 286,
     SQL_RETURNED_OCTET_LENGTH = 287,
     SQL_SCALE = 288,
     SQL_SECTION = 289,
     SQL_SHORT = 290,
     SQL_SIGNED = 291,
     SQL_SQL = 292,
     SQL_SQLERROR = 293,
     SQL_SQLPRINT = 294,
     SQL_SQLWARNING = 295,
     SQL_START = 296,
     SQL_STOP = 297,
     SQL_STRUCT = 298,
     SQL_UNSIGNED = 299,
     SQL_VAR = 300,
     SQL_WHENEVER = 301,
     S_ADD = 302,
     S_AND = 303,
     S_ANYTHING = 304,
     S_AUTO = 305,
     S_CONST = 306,
     S_DEC = 307,
     S_DIV = 308,
     S_DOTPOINT = 309,
     S_EQUAL = 310,
     S_EXTERN = 311,
     S_INC = 312,
     S_LSHIFT = 313,
     S_MEMPOINT = 314,
     S_MEMBER = 315,
     S_MOD = 316,
     S_MUL = 317,
     S_NEQUAL = 318,
     S_OR = 319,
     S_REGISTER = 320,
     S_RSHIFT = 321,
     S_STATIC = 322,
     S_SUB = 323,
     S_VOLATILE = 324,
     S_TYPEDEF = 325,
     CSTRING = 326,
     CVARIABLE = 327,
     CPP_LINE = 328,
     IP = 329,
     DOLCONST = 330,
     ECONST = 331,
     NCONST = 332,
     UCONST = 333,
     UIDENT = 334,
     IDENT = 335,
     FCONST = 336,
     SCONST = 337,
     BCONST = 338,
     XCONST = 339,
     Op = 340,
     ICONST = 341,
     PARAM = 342,
     TYPECAST = 343,
     DOT_DOT = 344,
     COLON_EQUALS = 345,
     ABORT_P = 346,
     ABSOLUTE_P = 347,
     ACCESS = 348,
     ACTION = 349,
     ADD_P = 350,
     ADMIN = 351,
     AFTER = 352,
     AGGREGATE = 353,
     ALL = 354,
     ALSO = 355,
     ALTER = 356,
     ALWAYS = 357,
     ANALYSE = 358,
     ANALYZE = 359,
     AND = 360,
     ANY = 361,
     ARRAY = 362,
     AS = 363,
     ASC = 364,
     ASSERTION = 365,
     ASSIGNMENT = 366,
     ASYMMETRIC = 367,
     AT = 368,
     AUTHORIZATION = 369,
     BACKWARD = 370,
     BEFORE = 371,
     BEGIN_P = 372,
     BETWEEN = 373,
     BIGINT = 374,
     BINARY = 375,
     BIT = 376,
     BOOLEAN_P = 377,
     BOTH = 378,
     BY = 379,
     CACHE = 380,
     CALLED = 381,
     CASCADE = 382,
     CASCADED = 383,
     CASE = 384,
     CAST = 385,
     CATALOG_P = 386,
     CHAIN = 387,
     CHAR_P = 388,
     CHARACTER = 389,
     CHARACTERISTICS = 390,
     CHECK = 391,
     CHECKPOINT = 392,
     CLASS = 393,
     CLOSE = 394,
     CLUSTER = 395,
     COALESCE = 396,
     COLLATE = 397,
     COLUMN = 398,
     COMMENT = 399,
     COMMENTS = 400,
     COMMIT = 401,
     COMMITTED = 402,
     CONCURRENTLY = 403,
     CONFIGURATION = 404,
     CONNECTION = 405,
     CONSTRAINT = 406,
     CONSTRAINTS = 407,
     CONTENT_P = 408,
     CONTINUE_P = 409,
     CONVERSION_P = 410,
     COPY = 411,
     COST = 412,
     CREATE = 413,
     CREATEDB = 414,
     CREATEROLE = 415,
     CREATEUSER = 416,
     CROSS = 417,
     CSV = 418,
     CURRENT_P = 419,
     CURRENT_CATALOG = 420,
     CURRENT_DATE = 421,
     CURRENT_ROLE = 422,
     CURRENT_SCHEMA = 423,
     CURRENT_TIME = 424,
     CURRENT_TIMESTAMP = 425,
     CURRENT_USER = 426,
     CURSOR = 427,
     CYCLE = 428,
     DATA_P = 429,
     DATABASE = 430,
     DAY_P = 431,
     DEALLOCATE = 432,
     DEC = 433,
     DECIMAL_P = 434,
     DECLARE = 435,
     DEFAULT = 436,
     DEFAULTS = 437,
     DEFERRABLE = 438,
     DEFERRED = 439,
     DEFINER = 440,
     DELETE_P = 441,
     DELIMITER = 442,
     DELIMITERS = 443,
     DESC = 444,
     DICTIONARY = 445,
     DISABLE_P = 446,
     DISCARD = 447,
     DISTINCT = 448,
     DO = 449,
     DOCUMENT_P = 450,
     DOMAIN_P = 451,
     DOUBLE_P = 452,
     DROP = 453,
     EACH = 454,
     ELSE = 455,
     ENABLE_P = 456,
     ENCODING = 457,
     ENCRYPTED = 458,
     END_P = 459,
     ENUM_P = 460,
     ESCAPE = 461,
     EXCEPT = 462,
     EXCLUDE = 463,
     EXCLUDING = 464,
     EXCLUSIVE = 465,
     EXECUTE = 466,
     EXISTS = 467,
     EXPLAIN = 468,
     EXTERNAL = 469,
     EXTRACT = 470,
     FALSE_P = 471,
     FAMILY = 472,
     FETCH = 473,
     FIRST_P = 474,
     FLOAT_P = 475,
     FOLLOWING = 476,
     FOR = 477,
     FORCE = 478,
     FOREIGN = 479,
     FORWARD = 480,
     FREEZE = 481,
     FROM = 482,
     FULL = 483,
     FUNCTION = 484,
     FUNCTIONS = 485,
     GLOBAL = 486,
     GRANT = 487,
     GRANTED = 488,
     GREATEST = 489,
     GROUP_P = 490,
     HANDLER = 491,
     HAVING = 492,
     HEADER_P = 493,
     HOLD = 494,
     HOUR_P = 495,
     IDENTITY_P = 496,
     IF_P = 497,
     ILIKE = 498,
     IMMEDIATE = 499,
     IMMUTABLE = 500,
     IMPLICIT_P = 501,
     IN_P = 502,
     INCLUDING = 503,
     INCREMENT = 504,
     INDEX = 505,
     INDEXES = 506,
     INHERIT = 507,
     INHERITS = 508,
     INITIALLY = 509,
     INLINE_P = 510,
     INNER_P = 511,
     INOUT = 512,
     INPUT_P = 513,
     INSENSITIVE = 514,
     INSERT = 515,
     INSTEAD = 516,
     INT_P = 517,
     INTEGER = 518,
     INTERSECT = 519,
     INTERVAL = 520,
     INTO = 521,
     INVOKER = 522,
     IS = 523,
     ISNULL = 524,
     ISOLATION = 525,
     JOIN = 526,
     KEY = 527,
     LANGUAGE = 528,
     LARGE_P = 529,
     LAST_P = 530,
     LC_COLLATE_P = 531,
     LC_CTYPE_P = 532,
     LEADING = 533,
     LEAST = 534,
     LEFT = 535,
     LEVEL = 536,
     LIKE = 537,
     LIMIT = 538,
     LISTEN = 539,
     LOAD = 540,
     LOCAL = 541,
     LOCALTIME = 542,
     LOCALTIMESTAMP = 543,
     LOCATION = 544,
     LOCK_P = 545,
     LOGIN_P = 546,
     MAPPING = 547,
     MATCH = 548,
     MAXVALUE = 549,
     MINUTE_P = 550,
     MINVALUE = 551,
     MODE = 552,
     MONTH_P = 553,
     MOVE = 554,
     NAME_P = 555,
     NAMES = 556,
     NATIONAL = 557,
     NATURAL = 558,
     NCHAR = 559,
     NEXT = 560,
     NO = 561,
     NOCREATEDB = 562,
     NOCREATEROLE = 563,
     NOCREATEUSER = 564,
     NOINHERIT = 565,
     NOLOGIN_P = 566,
     NONE = 567,
     NOSUPERUSER = 568,
     NOT = 569,
     NOTHING = 570,
     NOTIFY = 571,
     NOTNULL = 572,
     NOWAIT = 573,
     NULL_P = 574,
     NULLIF = 575,
     NULLS_P = 576,
     NUMERIC = 577,
     OBJECT_P = 578,
     OF = 579,
     OFF = 580,
     OFFSET = 581,
     OIDS = 582,
     ON = 583,
     ONLY = 584,
     OPERATOR = 585,
     OPTION = 586,
     OPTIONS = 587,
     OR = 588,
     ORDER = 589,
     OUT_P = 590,
     OUTER_P = 591,
     OVER = 592,
     OVERLAPS = 593,
     OVERLAY = 594,
     OWNED = 595,
     OWNER = 596,
     PARSER = 597,
     PARTIAL = 598,
     PARTITION = 599,
     PASSWORD = 600,
     PLACING = 601,
     PLANS = 602,
     POSITION = 603,
     PRECEDING = 604,
     PRECISION = 605,
     PRESERVE = 606,
     PREPARE = 607,
     PREPARED = 608,
     PRIMARY = 609,
     PRIOR = 610,
     PRIVILEGES = 611,
     PROCEDURAL = 612,
     PROCEDURE = 613,
     QUOTE = 614,
     RANGE = 615,
     READ = 616,
     REAL = 617,
     REASSIGN = 618,
     RECHECK = 619,
     RECURSIVE = 620,
     REFERENCES = 621,
     REINDEX = 622,
     RELATIVE_P = 623,
     RELEASE = 624,
     RENAME = 625,
     REPEATABLE = 626,
     REPLACE = 627,
     REPLICA = 628,
     RESET = 629,
     RESTART = 630,
     RESTRICT = 631,
     RETURNING = 632,
     RETURNS = 633,
     REVOKE = 634,
     RIGHT = 635,
     ROLE = 636,
     ROLLBACK = 637,
     ROW = 638,
     ROWS = 639,
     RULE = 640,
     SAVEPOINT = 641,
     SCHEMA = 642,
     SCROLL = 643,
     SEARCH = 644,
     SECOND_P = 645,
     SECURITY = 646,
     SELECT = 647,
     SEQUENCE = 648,
     SEQUENCES = 649,
     SERIALIZABLE = 650,
     SERVER = 651,
     SESSION = 652,
     SESSION_USER = 653,
     SET = 654,
     SETOF = 655,
     SHARE = 656,
     SHOW = 657,
     SIMILAR = 658,
     SIMPLE = 659,
     SMALLINT = 660,
     SOME = 661,
     STABLE = 662,
     STANDALONE_P = 663,
     START = 664,
     STATEMENT = 665,
     STATISTICS = 666,
     STDIN = 667,
     STDOUT = 668,
     STORAGE = 669,
     STRICT_P = 670,
     STRIP_P = 671,
     SUBSTRING = 672,
     SUPERUSER_P = 673,
     SYMMETRIC = 674,
     SYSID = 675,
     SYSTEM_P = 676,
     TABLE = 677,
     TABLES = 678,
     TABLESPACE = 679,
     TEMP = 680,
     TEMPLATE = 681,
     TEMPORARY = 682,
     TEXT_P = 683,
     THEN = 684,
     TIME = 685,
     TIMESTAMP = 686,
     TO = 687,
     TRAILING = 688,
     TRANSACTION = 689,
     TREAT = 690,
     TRIGGER = 691,
     TRIM = 692,
     TRUE_P = 693,
     TRUNCATE = 694,
     TRUSTED = 695,
     TYPE_P = 696,
     UNBOUNDED = 697,
     UNCOMMITTED = 698,
     UNENCRYPTED = 699,
     UNION = 700,
     UNIQUE = 701,
     UNKNOWN = 702,
     UNLISTEN = 703,
     UNTIL = 704,
     UPDATE = 705,
     USER = 706,
     USING = 707,
     VACUUM = 708,
     VALID = 709,
     VALIDATOR = 710,
     VALUE_P = 711,
     VALUES = 712,
     VARCHAR = 713,
     VARIADIC = 714,
     VARYING = 715,
     VERBOSE = 716,
     VERSION_P = 717,
     VIEW = 718,
     VOLATILE = 719,
     WHEN = 720,
     WHERE = 721,
     WHITESPACE_P = 722,
     WINDOW = 723,
     WITH = 724,
     WITHOUT = 725,
     WORK = 726,
     WRAPPER = 727,
     WRITE = 728,
     XML_P = 729,
     XMLATTRIBUTES = 730,
     XMLCONCAT = 731,
     XMLELEMENT = 732,
     XMLFOREST = 733,
     XMLPARSE = 734,
     XMLPI = 735,
     XMLROOT = 736,
     XMLSERIALIZE = 737,
     YEAR_P = 738,
     YES_P = 739,
     ZONE = 740,
     NULLS_FIRST = 741,
     NULLS_LAST = 742,
     WITH_TIME = 743,
     POSTFIXOP = 744,
     UMINUS = 745
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 471 "preproc.y"

	double	dval;
	char	*str;
	int     ival;
	struct	when		action;
	struct	index		index;
	int		tagname;
	struct	this_type	type;
	enum	ECPGttype	type_enum;
	enum	ECPGdtype	dtype_enum;
	struct	fetch_desc	descriptor;
	struct  su_symbol	struct_union;
	struct	prep		prep;



/* Line 214 of yacc.c  */
#line 1087 "preproc.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1112 "preproc.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   94893

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  510
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  657
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2562
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4490

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   745

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   497,     2,     2,
     502,   503,   495,   493,   505,   494,   504,   496,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   507,   506,
     490,   489,   491,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   500,     2,   501,   498,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   508,     2,   509,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   492,   499
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    65,    67,    69,    71,    73,    75,    77,
      79,    81,    83,    85,    87,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   109,   111,   113,   115,   117,
     119,   121,   123,   125,   127,   129,   131,   133,   135,   137,
     139,   141,   143,   145,   147,   149,   151,   153,   155,   157,
     159,   161,   163,   165,   167,   169,   171,   173,   175,   177,
     179,   181,   183,   185,   187,   189,   191,   193,   195,   197,
     199,   201,   203,   205,   207,   209,   211,   213,   215,   217,
     219,   221,   223,   225,   227,   229,   231,   233,   235,   237,
     239,   241,   243,   245,   247,   248,   254,   256,   257,   260,
     261,   264,   265,   268,   271,   275,   279,   281,   283,   285,
     287,   289,   291,   293,   295,   297,   299,   301,   303,   307,
     311,   314,   316,   319,   322,   325,   329,   333,   339,   345,
     346,   350,   356,   362,   367,   371,   377,   381,   387,   393,
     400,   402,   404,   408,   414,   421,   426,   428,   429,   432,
     433,   435,   437,   439,   441,   443,   445,   448,   452,   456,
     460,   464,   468,   472,   476,   480,   483,   489,   492,   495,
     498,   501,   505,   509,   513,   515,   519,   521,   525,   527,
     529,   532,   535,   538,   540,   542,   544,   546,   548,   550,
     552,   556,   563,   565,   567,   569,   571,   573,   574,   576,
     578,   581,   585,   590,   594,   597,   600,   602,   606,   611,
     617,   622,   625,   630,   632,   634,   636,   638,   640,   643,
     646,   649,   652,   657,   662,   667,   672,   674,   678,   681,
     685,   690,   697,   704,   711,   717,   723,   730,   737,   742,
     750,   753,   760,   765,   769,   773,   777,   781,   785,   790,
     795,   799,   803,   807,   811,   815,   819,   824,   829,   833,
     836,   840,   844,   848,   851,   854,   858,   861,   863,   865,
     866,   869,   870,   874,   877,   878,   880,   884,   888,   890,
     896,   900,   903,   906,   917,   924,   926,   928,   930,   932,
     934,   936,   940,   943,   944,   946,   948,   952,   956,   958,
     960,   964,   968,   972,   976,   981,   983,   984,   987,   988,
     992,   993,   995,   996,   998,  1002,  1005,  1007,  1009,  1011,
    1015,  1016,  1018,  1022,  1024,  1036,  1047,  1049,  1051,  1054,
    1057,  1060,  1063,  1064,  1066,  1067,  1071,  1072,  1074,  1078,
    1080,  1084,  1086,  1088,  1090,  1092,  1094,  1098,  1103,  1106,
    1107,  1111,  1113,  1115,  1118,  1120,  1124,  1129,  1134,  1137,
    1143,  1145,  1148,  1151,  1154,  1158,  1162,  1166,  1167,  1169,
    1171,  1173,  1175,  1177,  1179,  1183,  1185,  1191,  1199,  1208,
    1218,  1230,  1234,  1235,  1237,  1241,  1243,  1246,  1249,  1252,
    1253,  1255,  1259,  1263,  1270,  1275,  1276,  1278,  1280,  1283,
    1286,  1287,  1291,  1295,  1298,  1300,  1302,  1305,  1308,  1313,
    1314,  1317,  1320,  1323,  1324,  1328,  1333,  1338,  1339,  1342,
    1343,  1348,  1349,  1355,  1359,  1360,  1362,  1366,  1368,  1371,
    1375,  1376,  1382,  1387,  1389,  1390,  1392,  1395,  1398,  1400,
    1403,  1407,  1410,  1413,  1416,  1419,  1423,  1427,  1429,  1433,
    1435,  1436,  1438,  1441,  1443,  1445,  1449,  1456,  1467,  1469,
    1470,  1472,  1475,  1478,  1479,  1482,  1485,  1487,  1488,  1494,
    1502,  1504,  1505,  1512,  1515,  1516,  1520,  1526,  1534,  1541,
    1550,  1558,  1565,  1572,  1577,  1578,  1580,  1584,  1589,  1591,
    1595,  1597,  1600,  1603,  1606,  1609,  1611,  1613,  1624,  1627,
    1628,  1631,  1634,  1636,  1637,  1642,  1649,  1655,  1660,  1665,
    1674,  1676,  1678,  1680,  1688,  1698,  1707,  1723,  1744,  1746,
    1748,  1750,  1754,  1756,  1758,  1760,  1764,  1766,  1770,  1771,
    1773,  1774,  1776,  1778,  1783,  1784,  1786,  1790,  1791,  1793,
    1795,  1797,  1799,  1801,  1803,  1806,  1807,  1809,  1812,  1814,
    1817,  1818,  1821,  1823,  1826,  1829,  1836,  1845,  1854,  1859,
    1865,  1870,  1875,  1880,  1884,  1892,  1901,  1908,  1915,  1922,
    1929,  1933,  1935,  1939,  1943,  1945,  1947,  1949,  1951,  1953,
    1955,  1959,  1963,  1967,  1969,  1973,  1977,  1979,  1980,  1982,
    1986,  2000,  2002,  2006,  2011,  2017,  2022,  2030,  2033,  2035,
    2036,  2039,  2040,  2042,  2043,  2050,  2059,  2068,  2070,  2074,
    2080,  2086,  2094,  2104,  2112,  2122,  2128,  2135,  2142,  2147,
    2149,  2151,  2153,  2155,  2157,  2159,  2161,  2163,  2167,  2171,
    2175,  2179,  2181,  2185,  2187,  2190,  2193,  2197,  2203,  2206,
    2209,  2210,  2217,  2225,  2233,  2241,  2250,  2259,  2266,  2275,
    2285,  2295,  2303,  2314,  2322,  2331,  2340,  2349,  2358,  2360,
    2362,  2364,  2366,  2368,  2370,  2372,  2374,  2376,  2378,  2380,
    2382,  2384,  2386,  2389,  2392,  2396,  2401,  2407,  2412,  2418,
    2422,  2427,  2431,  2436,  2438,  2441,  2445,  2449,  2453,  2457,
    2462,  2467,  2471,  2475,  2480,  2485,  2490,  2495,  2497,  2499,
    2501,  2502,  2510,  2518,  2529,  2531,  2533,  2536,  2541,  2547,
    2549,  2553,  2556,  2559,  2562,  2565,  2567,  2570,  2573,  2578,
    2582,  2585,  2588,  2591,  2595,  2598,  2601,  2607,  2613,  2619,
    2621,  2625,  2627,  2630,  2634,  2635,  2637,  2641,  2644,  2651,
    2658,  2668,  2672,  2673,  2677,  2678,  2684,  2687,  2688,  2692,
    2696,  2700,  2708,  2716,  2727,  2729,  2731,  2733,  2748,  2750,
    2751,  2753,  2754,  2756,  2757,  2760,  2761,  2763,  2767,  2772,
    2777,  2784,  2786,  2789,  2790,  2792,  2794,  2795,  2797,  2799,
    2800,  2810,  2823,  2831,  2834,  2835,  2839,  2842,  2844,  2848,
    2852,  2855,  2857,  2861,  2865,  2869,  2872,  2875,  2877,  2879,
    2881,  2883,  2886,  2888,  2890,  2892,  2894,  2899,  2905,  2907,
    2911,  2915,  2917,  2920,  2925,  2931,  2933,  2935,  2937,  2939,
    2943,  2947,  2950,  2953,  2956,  2959,  2961,  2964,  2967,  2969,
    2971,  2973,  2977,  2980,  2981,  2984,  2986,  2990,  2996,  2998,
    3001,  3003,  3004,  3010,  3018,  3024,  3032,  3038,  3046,  3050,
    3056,  3062,  3068,  3070,  3074,  3077,  3079,  3082,  3084,  3087,
    3099,  3110,  3121,  3124,  3127,  3128,  3138,  3141,  3142,  3147,
    3152,  3157,  3159,  3161,  3163,  3164,  3172,  3179,  3186,  3193,
    3200,  3208,  3218,  3228,  3235,  3242,  3249,  3256,  3263,  3272,
    3281,  3288,  3295,  3302,  3308,  3314,  3323,  3332,  3341,  3350,
    3357,  3359,  3360,  3363,  3364,  3372,  3379,  3386,  3393,  3400,
    3407,  3414,  3422,  3429,  3436,  3443,  3450,  3458,  3466,  3474,
    3484,  3494,  3501,  3508,  3515,  3524,  3533,  3542,  3549,  3563,
    3565,  3567,  3571,  3575,  3577,  3579,  3581,  3583,  3585,  3587,
    3589,  3590,  3592,  3594,  3596,  3598,  3600,  3602,  3603,  3610,
    3619,  3623,  3626,  3627,  3630,  3633,  3636,  3639,  3643,  3647,
    3650,  3653,  3656,  3659,  3663,  3666,  3672,  3677,  3681,  3685,
    3689,  3691,  3693,  3694,  3698,  3701,  3704,  3706,  3710,  3713,
    3715,  3716,  3725,  3736,  3740,  3745,  3750,  3751,  3754,  3760,
    3763,  3764,  3768,  3772,  3776,  3780,  3784,  3788,  3792,  3796,
    3800,  3804,  3808,  3812,  3816,  3821,  3825,  3829,  3831,  3832,
    3838,  3845,  3850,  3853,  3854,  3859,  3863,  3869,  3876,  3881,
    3888,  3895,  3901,  3909,  3911,  3912,  3919,  3931,  3943,  3955,
    3969,  3979,  3991,  4002,  4007,  4010,  4016,  4019,  4020,  4025,
    4031,  4037,  4042,  4049,  4051,  4055,  4057,  4059,  4061,  4063,
    4066,  4071,  4073,  4075,  4077,  4078,  4080,  4081,  4083,  4084,
    4088,  4089,  4092,  4097,  4101,  4107,  4109,  4111,  4113,  4115,
    4117,  4119,  4121,  4123,  4127,  4130,  4132,  4134,  4136,  4138,
    4140,  4141,  4147,  4152,  4156,  4157,  4159,  4161,  4163,  4165,
    4170,  4179,  4183,  4184,  4190,  4192,  4197,  4200,  4202,  4206,
    4209,  4213,  4214,  4221,  4224,  4225,  4231,  4235,  4236,  4239,
    4242,  4245,  4249,  4251,  4255,  4257,  4260,  4262,  4263,  4271,
    4273,  4277,  4279,  4281,  4285,  4291,  4294,  4296,  4300,  4308,
    4310,  4312,  4313,  4317,  4320,  4323,  4326,  4327,  4330,  4333,
    4335,  4337,  4341,  4345,  4347,  4350,  4355,  4360,  4363,  4367,
    4373,  4379,  4381,  4383,  4393,  4395,  4398,  4403,  4408,  4413,
    4416,  4420,  4422,  4426,  4431,  4434,  4436,  4437,  4441,  4445,
    4450,  4455,  4460,  4465,  4468,  4470,  4472,  4473,  4475,  4477,
    4478,  4480,  4486,  4488,  4489,  4491,  4492,  4496,  4498,  4502,
    4507,  4511,  4514,  4517,  4519,  4521,  4523,  4524,  4527,  4532,
    4538,  4541,  4545,  4547,  4549,  4551,  4553,  4557,  4558,  4560,
    4562,  4564,  4566,  4568,  4572,  4573,  4576,  4577,  4579,  4583,
    4585,  4586,  4588,  4591,  4596,  4601,  4604,  4605,  4608,  4612,
    4615,  4616,  4618,  4622,  4624,  4627,  4629,  4632,  4638,  4645,
    4651,  4653,  4656,  4658,  4663,  4667,  4672,  4678,  4683,  4689,
    4694,  4700,  4703,  4708,  4710,  4713,  4716,  4719,  4721,  4723,
    4724,  4729,  4732,  4734,  4737,  4740,  4745,  4747,  4751,  4753,
    4756,  4760,  4762,  4765,  4766,  4769,  4774,  4775,  4777,  4781,
    4784,  4787,  4791,  4797,  4804,  4807,  4811,  4815,  4820,  4821,
    4823,  4825,  4827,  4829,  4831,  4834,  4840,  4842,  4844,  4846,
    4848,  4851,  4855,  4859,  4860,  4862,  4864,  4866,  4868,  4870,
    4873,  4876,  4879,  4882,  4885,  4887,  4891,  4892,  4894,  4896,
    4898,  4900,  4906,  4909,  4911,  4913,  4915,  4917,  4923,  4926,
    4929,  4932,  4934,  4938,  4942,  4945,  4947,  4948,  4952,  4953,
    4959,  4962,  4968,  4971,  4973,  4976,  4980,  4981,  4983,  4985,
    4987,  4989,  4991,  4993,  4997,  5001,  5005,  5009,  5013,  5017,
    5021,  5022,  5024,  5029,  5031,  5035,  5041,  5044,  5047,  5051,
    5055,  5059,  5063,  5067,  5071,  5075,  5079,  5083,  5087,  5090,
    5093,  5097,  5101,  5104,  5108,  5114,  5119,  5126,  5130,  5136,
    5141,  5148,  5153,  5160,  5166,  5174,  5178,  5181,  5186,  5189,
    5193,  5197,  5202,  5206,  5211,  5215,  5220,  5226,  5233,  5240,
    5248,  5255,  5263,  5270,  5278,  5282,  5287,  5292,  5299,  5302,
    5306,  5311,  5313,  5317,  5320,  5323,  5327,  5331,  5335,  5339,
    5343,  5347,  5351,  5355,  5359,  5363,  5366,  5369,  5375,  5382,
    5389,  5397,  5401,  5406,  5408,  5410,  5413,  5418,  5420,  5422,
    5424,  5427,  5430,  5433,  5436,  5438,  5443,  5449,  5456,  5465,
    5472,  5480,  5488,  5494,  5496,  5498,  5503,  5505,  5510,  5512,
    5517,  5519,  5524,  5526,  5528,  5530,  5532,  5534,  5536,  5543,
    5548,  5553,  5558,  5563,  5570,  5576,  5582,  5588,  5593,  5600,
    5605,  5610,  5615,  5620,  5626,  5634,  5642,  5652,  5657,  5664,
    5670,  5678,  5686,  5694,  5697,  5701,  5705,  5709,  5714,  5715,
    5720,  5722,  5726,  5730,  5732,  5734,  5736,  5739,  5742,  5743,
    5746,  5747,  5749,  5753,  5757,  5760,  5763,  5764,  5771,  5773,
    5774,  5778,  5779,  5782,  5785,  5786,  5788,  5793,  5796,  5799,
    5802,  5805,  5808,  5813,  5817,  5823,  5825,  5827,  5829,  5831,
    5833,  5835,  5837,  5839,  5841,  5843,  5845,  5847,  5849,  5851,
    5853,  5858,  5860,  5865,  5867,  5872,  5874,  5877,  5879,  5882,
    5884,  5888,  5890,  5894,  5896,  5900,  5902,  5906,  5910,  5914,
    5917,  5919,  5923,  5927,  5928,  5930,  5932,  5934,  5936,  5938,
    5940,  5942,  5944,  5949,  5953,  5956,  5960,  5961,  5965,  5969,
    5972,  5975,  5977,  5978,  5981,  5984,  5988,  5991,  5993,  5995,
    5999,  6005,  6007,  6010,  6015,  6018,  6019,  6021,  6022,  6024,
    6027,  6030,  6033,  6037,  6043,  6045,  6048,  6049,  6052,  6054,
    6055,  6057,  6059,  6061,  6065,  6069,  6071,  6075,  6079,  6082,
    6084,  6086,  6088,  6092,  6094,  6097,  6099,  6103,  6105,  6107,
    6109,  6111,  6113,  6115,  6117,  6120,  6122,  6124,  6126,  6128,
    6130,  6133,  6139,  6142,  6146,  6153,  6155,  6157,  6159,  6161,
    6163,  6165,  6167,  6169,  6171,  6174,  6177,  6179,  6181,  6183,
    6185,  6187,  6189,  6191,  6193,  6195,  6197,  6199,  6201,  6203,
    6205,  6207,  6209,  6211,  6213,  6215,  6217,  6219,  6221,  6223,
    6225,  6227,  6229,  6231,  6233,  6235,  6237,  6239,  6241,  6243,
    6245,  6247,  6249,  6251,  6253,  6255,  6257,  6259,  6261,  6263,
    6265,  6267,  6269,  6271,  6273,  6275,  6277,  6279,  6281,  6283,
    6285,  6287,  6289,  6291,  6293,  6295,  6297,  6299,  6301,  6303,
    6305,  6307,  6309,  6311,  6313,  6315,  6317,  6319,  6321,  6323,
    6325,  6327,  6329,  6331,  6333,  6335,  6337,  6339,  6341,  6343,
    6345,  6347,  6349,  6351,  6353,  6355,  6357,  6359,  6361,  6363,
    6365,  6367,  6369,  6371,  6373,  6375,  6377,  6379,  6381,  6383,
    6385,  6387,  6389,  6391,  6393,  6395,  6397,  6399,  6401,  6403,
    6405,  6407,  6409,  6411,  6413,  6415,  6417,  6419,  6421,  6423,
    6425,  6427,  6429,  6431,  6433,  6435,  6437,  6439,  6441,  6443,
    6445,  6447,  6449,  6451,  6453,  6455,  6457,  6459,  6461,  6463,
    6465,  6467,  6469,  6471,  6473,  6475,  6477,  6479,  6481,  6483,
    6485,  6487,  6489,  6491,  6493,  6495,  6497,  6499,  6501,  6503,
    6505,  6507,  6509,  6511,  6513,  6515,  6517,  6519,  6521,  6523,
    6525,  6527,  6529,  6531,  6533,  6535,  6537,  6539,  6541,  6543,
    6545,  6547,  6549,  6551,  6553,  6555,  6557,  6559,  6561,  6563,
    6565,  6567,  6569,  6571,  6573,  6575,  6577,  6579,  6581,  6583,
    6585,  6587,  6589,  6591,  6593,  6595,  6597,  6599,  6601,  6603,
    6605,  6607,  6609,  6611,  6613,  6615,  6617,  6619,  6621,  6623,
    6625,  6627,  6629,  6631,  6633,  6635,  6637,  6639,  6641,  6643,
    6645,  6647,  6649,  6651,  6653,  6655,  6657,  6659,  6661,  6663,
    6665,  6667,  6669,  6671,  6673,  6675,  6677,  6679,  6681,  6683,
    6685,  6687,  6689,  6691,  6693,  6695,  6697,  6699,  6701,  6703,
    6705,  6707,  6709,  6711,  6713,  6715,  6717,  6719,  6721,  6723,
    6725,  6727,  6729,  6731,  6733,  6735,  6737,  6739,  6741,  6743,
    6745,  6747,  6749,  6751,  6753,  6755,  6757,  6759,  6761,  6763,
    6765,  6767,  6769,  6771,  6773,  6775,  6777,  6779,  6781,  6783,
    6785,  6787,  6789,  6791,  6793,  6795,  6797,  6799,  6801,  6803,
    6805,  6807,  6809,  6811,  6813,  6815,  6817,  6819,  6821,  6823,
    6825,  6827,  6829,  6831,  6833,  6835,  6837,  6839,  6841,  6843,
    6845,  6847,  6849,  6851,  6853,  6855,  6857,  6859,  6861,  6863,
    6865,  6867,  6869,  6871,  6873,  6875,  6877,  6879,  6881,  6883,
    6885,  6887,  6889,  6891,  6893,  6895,  6897,  6899,  6901,  6903,
    6905,  6907,  6909,  6911,  6913,  6915,  6917,  6919,  6921,  6923,
    6925,  6927,  6929,  6931,  6933,  6935,  6937,  6939,  6940,  6943,
    6948,  6952,  6955,  6957,  6959,  6961,  6963,  6965,  6966,  6975,
    6978,  6984,  6988,  6991,  6994,  6998,  7006,  7008,  7010,  7012,
    7013,  7016,  7019,  7021,  7022,  7024,  7028,  7030,  7033,  7034,
    7037,  7038,  7041,  7042,  7044,  7048,  7053,  7057,  7059,  7061,
    7063,  7065,  7068,  7069,  7072,  7077,  7078,  7081,  7084,  7087,
    7089,  7091,  7099,  7103,  7105,  7107,  7109,  7111,  7114,  7115,
    7117,  7121,  7125,  7129,  7133,  7134,  7139,  7145,  7151,  7152,
    7154,  7156,  7158,  7161,  7164,  7166,  7169,  7170,  7178,  7179,
    7185,  7186,  7191,  7194,  7197,  7198,  7201,  7203,  7205,  7207,
    7209,  7211,  7213,  7215,  7217,  7219,  7221,  7223,  7229,  7232,
    7234,  7238,  7241,  7244,  7248,  7249,  7255,  7257,  7258,  7264,
    7267,  7270,  7272,  7274,  7276,  7279,  7282,  7286,  7288,  7291,
    7294,  7298,  7302,  7307,  7310,  7312,  7315,  7317,  7319,  7322,
    7325,  7329,  7331,  7333,  7335,  7337,  7338,  7340,  7344,  7350,
    7351,  7354,  7355,  7357,  7360,  7364,  7367,  7369,  7371,  7373,
    7374,  7376,  7378,  7380,  7382,  7384,  7387,  7390,  7394,  7395,
    7397,  7400,  7402,  7407,  7411,  7416,  7420,  7423,  7425,  7429,
    7431,  7433,  7435,  7437,  7440,  7443,  7445,  7448,  7451,  7453,
    7455,  7457,  7462,  7467,  7472,  7477,  7482,  7484,  7485,  7489,
    7493,  7498,  7500,  7504,  7508,  7513,  7515,  7519,  7523,  7525,
    7527,  7529,  7536,  7538,  7542,  7546,  7553,  7555,  7559,  7563,
    7565,  7567,  7570,  7573,  7575,  7577,  7579,  7581,  7583,  7585,
    7587,  7589,  7591,  7593,  7595,  7597,  7599,  7601,  7603,  7605,
    7610,  7615,  7617,  7619,  7624,  7629,  7633,  7634,  7642,  7644,
    7645,  7646,  7654,  7658,  7663,  7667,  7669,  7671,  7673,  7676,
    7680,  7686,  7689,  7695,  7698,  7700,  7702,  7704,  7706,  7708,
    7710,  7712,  7714,  7716,  7718,  7720,  7722,  7724,  7726,  7728,
    7730,  7732,  7734,  7736,  7738,  7740,  7742,  7744,  7746,  7748,
    7750,  7752,  7754,  7756,  7758,  7760,  7762,  7764,  7766,  7768,
    7770,  7772,  7774,  7776,  7778,  7780,  7782,  7784,  7786,  7788,
    7790,  7792,  7794,  7796,  7798,  7800,  7802,  7804,  7806,  7808,
    7810,  7812,  7814,  7816,  7818,  7820,  7822,  7824,  7826,  7828,
    7830,  7832,  7834,  7836,  7838,  7840,  7842,  7844,  7846,  7848,
    7850,  7852,  7854,  7856,  7858,  7860,  7862,  7864,  7866,  7868,
    7870,  7872,  7874,  7876,  7878,  7880,  7882,  7884,  7886,  7888,
    7890,  7892,  7894,  7898,  7900,  7901,  7903,  7906,  7908,  7911,
    7913,  7915,  7917,  7920,  7923,  7925,  7927,  7929,  7931,  7933,
    7935,  7937,  7939,  7941,  7943,  7945,  7947,  7949,  7951,  7953,
    7955,  7958,  7962,  7964,  7967,  7969,  7973,  7975,  7979,  7981,
    7983,  7985,  7987,  7989,  7991,  7993,  7995,  7997,  7999,  8001,
    8003,  8005,  8007,  8009,  8011,  8013,  8015,  8017,  8019,  8021,
    8023,  8025,  8027,  8029,  8031,  8033,  8035,  8037,  8039,  8041,
    8043,  8045,  8047,  8049,  8051,  8053,  8055,  8057,  8059,  8061,
    8063,  8065,  8067,  8069,  8071,  8073,  8075,  8077,  8079,  8081,
    8083,  8085,  8087,  8089,  8091,  8093,  8095,  8097,  8099,  8101,
    8104,  8108,  8111,  8115,  8117,  8121,  8125,  8129,  8133,  8137,
    8141,  8143,  8145,  8146,  8149,  8152,  8154,  8156,  8159,  8161,
    8163,  8165,  8166
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     511,     0,    -1,  1018,    -1,   811,    -1,   812,    -1,   730,
      -1,   817,    -1,   640,    -1,   654,    -1,   764,    -1,   528,
      -1,   785,    -1,   786,    -1,   620,    -1,   553,    -1,   522,
      -1,   520,    -1,   820,    -1,   819,    -1,   658,    -1,   524,
      -1,   523,    -1,   827,    -1,   551,    -1,   563,    -1,   822,
      -1,   708,    -1,   548,    -1,   564,    -1,  1020,    -1,   674,
      -1,   775,    -1,   821,    -1,   816,    -1,   638,    -1,   649,
      -1,   745,    -1,   527,    -1,   687,    -1,   693,    -1,   694,
      -1,   627,    -1,   531,    -1,   619,    -1,   579,    -1,   635,
      -1,   659,    -1,   513,    -1,   519,    -1,   655,    -1,   807,
      -1,  1161,    -1,   862,    -1,   676,    -1,   849,    -1,   552,
      -1,   772,    -1,   675,    -1,   777,    -1,   639,    -1,   653,
      -1,   530,    -1,   697,    -1,   698,    -1,   699,    -1,   633,
      -1,   794,    -1,   701,    -1,   637,    -1,   673,    -1,   525,
      -1,   526,    -1,   657,    -1,   815,    -1,   842,    -1,   833,
      -1,   711,    -1,   715,    -1,   726,    -1,   735,    -1,   844,
      -1,   797,    -1,   806,    -1,   851,    -1,   795,    -1,   839,
      -1,   700,    -1,   779,    -1,   768,    -1,   767,    -1,   769,
      -1,   782,    -1,   716,    -1,   727,    -1,   787,    -1,   866,
      -1,   799,    -1,   706,    -1,   798,    -1,   855,    -1,   824,
      -1,   545,    -1,   535,    -1,   547,    -1,   804,    -1,  1097,
      -1,  1023,    -1,  1040,    -1,  1098,    -1,  1080,    -1,  1095,
      -1,  1081,    -1,  1041,    -1,  1085,    -1,  1107,    -1,  1099,
      -1,  1086,    -1,  1115,    -1,  1117,    -1,  1110,    -1,  1102,
      -1,  1118,    -1,  1121,    -1,  1123,    -1,    -1,   158,   381,
    1012,   514,   515,    -1,   469,    -1,    -1,   515,   518,    -1,
      -1,   516,   517,    -1,    -1,   345,  1151,    -1,   345,   319,
      -1,   203,   345,  1151,    -1,   444,   345,  1151,    -1,   418,
      -1,   313,    -1,   252,    -1,   310,    -1,   159,    -1,   307,
      -1,   160,    -1,   308,    -1,   161,    -1,   309,    -1,   291,
      -1,   311,    -1,   150,   283,  1013,    -1,   454,   449,  1151,
      -1,   451,  1002,    -1,   517,    -1,   420,  1011,    -1,    96,
    1002,    -1,   381,  1002,    -1,   247,   381,  1002,    -1,   247,
     235,  1002,    -1,   158,   451,  1012,   514,   515,    -1,   101,
     381,  1012,   514,   516,    -1,    -1,   247,   175,  1004,    -1,
     101,   381,  1012,   521,   546,    -1,   101,   451,  1012,   514,
     516,    -1,   101,   451,  1012,   546,    -1,   198,   381,  1002,
      -1,   198,   381,   242,   212,  1002,    -1,   198,   451,  1002,
      -1,   198,   451,   242,   212,  1002,    -1,   158,   235,  1012,
     514,   515,    -1,   101,   235,  1012,   529,   451,  1002,    -1,
      95,    -1,   198,    -1,   198,   235,  1002,    -1,   198,   235,
     242,   212,  1002,    -1,   158,   387,   532,   114,  1012,   533,
      -1,   158,   387,  1131,   533,    -1,  1131,    -1,    -1,   533,
     534,    -1,    -1,   579,    -1,   735,    -1,   619,    -1,   659,
      -1,   715,    -1,   804,    -1,   399,   536,    -1,   399,   286,
     536,    -1,   399,   397,   536,    -1,   537,   432,   538,    -1,
     537,   489,   538,    -1,   537,   432,   181,    -1,   537,   489,
     181,    -1,   537,   227,   164,    -1,   430,   485,   542,    -1,
     434,   802,    -1,   397,   135,   108,   434,   802,    -1,   131,
    1151,    -1,   387,  1151,    -1,   301,   543,    -1,   381,   544,
      -1,   397,   114,   544,    -1,   397,   114,   181,    -1,   474,
     331,   950,    -1,  1130,    -1,   537,   504,  1131,    -1,   539,
      -1,   538,   505,   539,    -1,   541,    -1,   625,    -1,   361,
     443,    -1,   361,   147,    -1,   371,   361,    -1,   395,    -1,
     438,    -1,   216,    -1,   328,    -1,   544,    -1,  1151,    -1,
    1153,    -1,   937,  1151,   939,    -1,   937,   502,  1011,   503,
    1151,   939,    -1,   625,    -1,   181,    -1,   286,    -1,  1151,
      -1,   181,    -1,    -1,  1131,    -1,  1151,    -1,   374,   537,
      -1,   374,   430,   485,    -1,   374,   434,   270,   281,    -1,
     374,   397,   114,    -1,   374,    99,    -1,   399,   536,    -1,
     545,    -1,   402,   537,  1164,    -1,   402,   430,   485,  1164,
      -1,   402,   434,   270,   281,  1164,    -1,   402,   397,   114,
    1164,    -1,   402,    99,    -1,   399,   152,   549,   550,    -1,
      99,    -1,  1000,    -1,   184,    -1,   244,    -1,   137,    -1,
     192,    99,    -1,   192,   425,    -1,   192,   427,    -1,   192,
     347,    -1,   101,   422,   909,   554,    -1,   101,   250,  1001,
     554,    -1,   101,   393,  1001,   554,    -1,   101,   463,  1001,
     554,    -1,   555,    -1,   554,   505,   555,    -1,    95,   587,
      -1,    95,   143,   587,    -1,   101,   783,  1131,   556,    -1,
     101,   783,  1131,   198,   314,   319,    -1,   101,   783,  1131,
     399,   314,   319,    -1,   101,   783,  1131,   399,   411,  1013,
      -1,   101,   783,  1131,   399,   559,    -1,   101,   783,  1131,
     374,   559,    -1,   101,   783,  1131,   399,   414,  1131,    -1,
     198,   783,   242,   212,  1131,   557,    -1,   198,   783,  1131,
     557,    -1,   101,   783,  1131,   784,   441,   917,   558,    -1,
      95,   596,    -1,   198,   151,   242,   212,  1003,   557,    -1,
     198,   151,  1003,   557,    -1,   399,   469,   327,    -1,   399,
     470,   327,    -1,   140,   328,  1003,    -1,   399,   470,   140,
      -1,   201,   436,  1003,    -1,   201,   102,   436,  1003,    -1,
     201,   373,   436,  1003,    -1,   201,   436,    99,    -1,   201,
     436,   451,    -1,   191,   436,  1003,    -1,   191,   436,    99,
      -1,   191,   436,   451,    -1,   201,   385,  1003,    -1,   201,
     102,   385,  1003,    -1,   201,   373,   385,  1003,    -1,   191,
     385,  1003,    -1,   252,  1001,    -1,   306,   252,  1001,    -1,
     341,   432,  1012,    -1,   399,   424,  1003,    -1,   399,   559,
      -1,   374,   559,    -1,   399,   181,   941,    -1,   198,   181,
      -1,   127,    -1,   376,    -1,    -1,   452,   941,    -1,    -1,
     502,   561,   503,    -1,   469,   559,    -1,    -1,   562,    -1,
     561,   505,   562,    -1,  1133,   489,   680,    -1,  1133,    -1,
    1133,   504,  1133,   489,   680,    -1,  1133,   504,  1133,    -1,
     139,   863,    -1,   139,    99,    -1,   156,   570,  1001,   598,
     571,   565,   566,   572,   514,   567,    -1,   156,   867,   432,
     566,   514,   567,    -1,   227,    -1,   432,    -1,  1151,    -1,
     412,    -1,   413,    -1,   568,    -1,   502,   574,   503,    -1,
     568,   569,    -1,    -1,   120,    -1,   327,    -1,   187,   818,
    1151,    -1,   319,   818,  1151,    -1,   163,    -1,   238,    -1,
     359,   818,  1151,    -1,   206,   818,  1151,    -1,   223,   359,
     599,    -1,   223,   359,   495,    -1,   223,   314,   319,   599,
      -1,   120,    -1,    -1,   469,   327,    -1,    -1,   573,   188,
    1151,    -1,    -1,   452,    -1,    -1,   575,    -1,   574,   505,
     575,    -1,  1133,   576,    -1,   541,    -1,   625,    -1,   495,
      -1,   502,   577,   503,    -1,    -1,   578,    -1,   577,   505,
     578,    -1,   541,    -1,   158,   580,   422,  1001,   502,   581,
     503,   609,   610,   611,   612,    -1,   158,   580,   422,  1001,
     324,   704,   582,   610,   611,   612,    -1,   427,    -1,   425,
      -1,   286,   427,    -1,   286,   425,    -1,   231,   427,    -1,
     231,   425,    -1,    -1,   583,    -1,    -1,   502,   584,   503,
      -1,    -1,   585,    -1,   583,   505,   585,    -1,   586,    -1,
     584,   505,   586,    -1,   587,    -1,   593,    -1,   596,    -1,
     588,    -1,   596,    -1,  1131,   917,   589,    -1,  1131,   469,
     332,   589,    -1,   589,   590,    -1,    -1,   151,  1003,   591,
      -1,   591,    -1,   592,    -1,   314,   319,    -1,   319,    -1,
     446,   761,   613,    -1,   354,   272,   761,   613,    -1,   136,
     502,   941,   503,    -1,   181,   942,    -1,   366,  1001,   598,
     601,   605,    -1,   183,    -1,   314,   183,    -1,   254,   184,
      -1,   254,   244,    -1,   282,  1001,   594,    -1,   594,   248,
     595,    -1,   594,   209,   595,    -1,    -1,   182,    -1,   152,
      -1,   251,    -1,   414,    -1,   145,    -1,    99,    -1,   151,
    1003,   597,    -1,   597,    -1,   136,   502,   941,   503,   670,
      -1,   446,   502,   599,   503,   761,   613,   670,    -1,   354,
     272,   502,   599,   503,   761,   613,   670,    -1,   208,   739,
     502,   602,   503,   761,   613,   604,   670,    -1,   224,   272,
     502,   599,   503,   366,  1001,   598,   601,   605,   670,    -1,
     502,   599,   503,    -1,    -1,   600,    -1,   599,   505,   600,
      -1,  1131,    -1,   293,   228,    -1,   293,   343,    -1,   293,
     404,    -1,    -1,   603,    -1,   602,   505,   603,    -1,   741,
     469,   771,    -1,   741,   469,   330,   502,   771,   503,    -1,
     466,   502,   941,   503,    -1,    -1,   606,    -1,   607,    -1,
     606,   607,    -1,   607,   606,    -1,    -1,   328,   450,   608,
      -1,   328,   186,   608,    -1,   306,    94,    -1,   376,    -1,
     127,    -1,   399,   319,    -1,   399,   181,    -1,   253,   502,
    1000,   503,    -1,    -1,   469,   559,    -1,   469,   327,    -1,
     470,   327,    -1,    -1,   328,   146,   198,    -1,   328,   146,
     186,   384,    -1,   328,   146,   351,   384,    -1,    -1,   424,
    1003,    -1,    -1,   452,   250,   424,  1003,    -1,    -1,  1001,
     615,   610,   611,   612,    -1,   502,   616,   503,    -1,    -1,
     617,    -1,   616,   505,   617,    -1,  1131,    -1,   469,   174,
      -1,   469,   306,   174,    -1,    -1,   158,   580,   393,  1001,
     621,    -1,   101,   393,  1001,   622,    -1,   622,    -1,    -1,
     623,    -1,   622,   623,    -1,   125,   625,    -1,   173,    -1,
     306,   173,    -1,   249,   624,   625,    -1,   294,   625,    -1,
     296,   625,    -1,   306,   294,    -1,   306,   296,    -1,   340,
     124,   704,    -1,   409,   514,   625,    -1,   375,    -1,   375,
     514,   625,    -1,   124,    -1,    -1,  1150,    -1,   494,  1150,
      -1,  1013,    -1,   625,    -1,   626,   505,   625,    -1,   158,
     746,   628,   634,   273,   544,    -1,   158,   746,   628,   634,
     273,   544,   236,   629,   630,   632,    -1,   440,    -1,    -1,
    1003,    -1,  1003,   705,    -1,   255,   629,    -1,    -1,   455,
     629,    -1,   306,   455,    -1,   631,    -1,    -1,   198,   634,
     273,   544,   557,    -1,   198,   634,   273,   242,   212,   544,
     557,    -1,   357,    -1,    -1,   158,   424,  1003,   636,   289,
    1151,    -1,   341,  1003,    -1,    -1,   198,   424,  1003,    -1,
     198,   424,   242,   212,  1003,    -1,   158,   224,   174,   472,
    1003,   632,   641,    -1,   198,   224,   174,   472,  1003,   557,
      -1,   198,   224,   174,   472,   242,   212,  1003,   557,    -1,
     101,   224,   174,   472,  1003,   631,   643,    -1,   101,   224,
     174,   472,  1003,   631,    -1,   101,   224,   174,   472,  1003,
     643,    -1,   332,   502,   642,   503,    -1,    -1,   646,    -1,
     642,   505,   646,    -1,   332,   502,   644,   503,    -1,   645,
      -1,   644,   505,   645,    -1,   646,    -1,   399,   646,    -1,
      95,   646,    -1,   198,   647,    -1,   647,   648,    -1,  1133,
      -1,  1151,    -1,   158,   396,  1003,   650,   652,   224,   174,
     472,  1003,   641,    -1,   441,  1151,    -1,    -1,   462,  1151,
      -1,   462,   319,    -1,   651,    -1,    -1,   198,   396,  1003,
     557,    -1,   198,   396,   242,   212,  1003,   557,    -1,   101,
     396,  1003,   651,   643,    -1,   101,   396,  1003,   651,    -1,
     101,   396,  1003,   643,    -1,   158,   451,   292,   222,   656,
     396,  1003,   641,    -1,   171,    -1,   451,    -1,  1012,    -1,
     198,   451,   292,   222,   656,   396,  1003,    -1,   198,   451,
     292,   242,   212,   222,   656,   396,  1003,    -1,   101,   451,
     292,   222,   656,   396,  1003,   643,    -1,   158,   436,  1003,
     660,   661,   328,  1001,   663,   666,   211,   358,  1009,   502,
     667,   503,    -1,   158,   151,   436,  1003,    97,   661,   328,
    1001,   669,   670,   222,   199,   383,   666,   211,   358,  1009,
     502,   667,   503,    -1,   116,    -1,    97,    -1,   662,    -1,
     661,   333,   662,    -1,   260,    -1,   186,    -1,   450,    -1,
     450,   324,   599,    -1,   439,    -1,   222,   664,   665,    -1,
      -1,   199,    -1,    -1,   383,    -1,   410,    -1,   465,   502,
     941,   503,    -1,    -1,   668,    -1,   667,   505,   668,    -1,
      -1,  1011,    -1,  1150,    -1,  1151,    -1,  1149,    -1,    84,
      -1,  1131,    -1,   227,  1001,    -1,    -1,   671,    -1,   671,
     672,    -1,   672,    -1,   672,   671,    -1,    -1,   314,   183,
      -1,   183,    -1,   254,   244,    -1,   254,   184,    -1,   198,
     436,  1003,   328,  1001,   557,    -1,   198,   436,   242,   212,
    1003,   328,  1001,   557,    -1,   158,   110,  1003,   136,   502,
     941,   503,   670,    -1,   198,   110,  1003,   557,    -1,   158,
      98,  1009,   681,   677,    -1,   158,    98,  1009,   682,    -1,
     158,   330,   771,   677,    -1,   158,   441,   704,   677,    -1,
     158,   441,   704,    -1,   158,   441,   704,   108,   502,   915,
     503,    -1,   158,   441,   704,   108,   205,   502,   685,   503,
      -1,   158,   428,   389,   342,   704,   677,    -1,   158,   428,
     389,   190,   704,   677,    -1,   158,   428,   389,   426,   704,
     677,    -1,   158,   428,   389,   149,   704,   677,    -1,   502,
     678,   503,    -1,   679,    -1,   678,   505,   679,    -1,  1133,
     489,   680,    -1,  1133,    -1,   755,    -1,  1017,    -1,   967,
      -1,   625,    -1,  1151,    -1,   502,   972,   503,    -1,   502,
     495,   503,    -1,   502,   683,   503,    -1,   684,    -1,   683,
     505,   684,    -1,  1153,   489,   680,    -1,   686,    -1,    -1,
    1151,    -1,   686,   505,  1151,    -1,   158,   330,   138,   704,
     690,   222,   441,   917,   452,  1005,   691,   108,   688,    -1,
     689,    -1,   688,   505,   689,    -1,   330,  1011,   771,   692,
      -1,   330,  1011,   771,   770,   692,    -1,   229,  1011,  1009,
     747,    -1,   229,  1011,   502,   972,   503,  1009,   747,    -1,
     414,   917,    -1,   181,    -1,    -1,   217,   704,    -1,    -1,
     364,    -1,    -1,   158,   330,   217,   704,   452,  1005,    -1,
     101,   330,   217,   704,   452,  1005,    95,   688,    -1,   101,
     330,   217,   704,   452,  1005,   198,   695,    -1,   696,    -1,
     695,   505,   696,    -1,   330,  1011,   502,   972,   503,    -1,
     229,  1011,   502,   972,   503,    -1,   198,   330,   138,   704,
     452,  1005,   557,    -1,   198,   330,   138,   242,   212,   704,
     452,  1005,   557,    -1,   198,   330,   217,   704,   452,  1005,
     557,    -1,   198,   330,   217,   242,   212,   704,   452,  1005,
     557,    -1,   198,   340,   124,  1002,   557,    -1,   363,   340,
     124,  1002,   432,  1003,    -1,   198,   702,   242,   212,   703,
     557,    -1,   198,   702,   703,   557,    -1,   422,    -1,   393,
      -1,   463,    -1,   250,    -1,   441,    -1,   196,    -1,   155,
      -1,   387,    -1,   428,   389,   342,    -1,   428,   389,   190,
      -1,   428,   389,   426,    -1,   428,   389,   149,    -1,   704,
      -1,   703,   505,   704,    -1,  1131,    -1,  1131,   705,    -1,
     504,  1006,    -1,   705,   504,  1006,    -1,   439,   876,   910,
     707,   557,    -1,   154,   241,    -1,   375,   241,    -1,    -1,
     144,   328,   709,   704,   268,   710,    -1,   144,   328,    98,
    1009,   681,   268,   710,    -1,   144,   328,   229,  1009,   747,
     268,   710,    -1,   144,   328,   330,   771,   770,   268,   710,
      -1,   144,   328,   151,  1003,   328,   704,   268,   710,    -1,
     144,   328,   385,  1003,   328,   704,   268,   710,    -1,   144,
     328,   385,  1003,   268,   710,    -1,   144,   328,   436,  1003,
     328,   704,   268,   710,    -1,   144,   328,   330,   138,   704,
     452,  1005,   268,   710,    -1,   144,   328,   330,   217,   704,
     452,  1005,   268,   710,    -1,   144,   328,   274,   323,   625,
     268,   710,    -1,   144,   328,   130,   502,   917,   108,   917,
     503,   268,   710,    -1,   144,   328,   634,   273,   704,   268,
     710,    -1,   144,   328,   428,   389,   342,   704,   268,   710,
      -1,   144,   328,   428,   389,   190,   704,   268,   710,    -1,
     144,   328,   428,   389,   426,   704,   268,   710,    -1,   144,
     328,   428,   389,   149,   704,   268,   710,    -1,   143,    -1,
     175,    -1,   387,    -1,   250,    -1,   393,    -1,   422,    -1,
     196,    -1,   441,    -1,   463,    -1,   155,    -1,   424,    -1,
     381,    -1,  1151,    -1,   319,    -1,   218,   712,    -1,   299,
     712,    -1,   218,   712,  1165,    -1,   218,   225,   863,  1166,
      -1,   218,   225,   713,   863,  1166,    -1,   218,   115,   863,
    1166,    -1,   218,   115,   713,   863,  1166,    -1,   299,   225,
     863,    -1,   299,   225,   713,   863,    -1,   299,   115,   863,
      -1,   299,   115,   713,   863,    -1,   863,    -1,   713,   863,
      -1,   305,   714,   863,    -1,   355,   714,   863,    -1,   219,
     714,   863,    -1,   275,   714,   863,    -1,    92,  1013,   714,
     863,    -1,   368,  1013,   714,   863,    -1,  1013,   714,   863,
      -1,    99,   714,   863,    -1,   225,  1013,   714,   863,    -1,
     225,    99,   714,   863,    -1,   115,  1013,   714,   863,    -1,
     115,    99,   714,   863,    -1,   227,    -1,   247,    -1,   713,
      -1,    -1,   232,   717,   328,   720,   432,   721,   723,    -1,
     379,   717,   328,   720,   227,   721,   557,    -1,   379,   232,
     331,   222,   717,   328,   720,   227,   721,   557,    -1,   718,
      -1,    99,    -1,    99,   356,    -1,    99,   502,   599,   503,
      -1,    99,   356,   502,   599,   503,    -1,   719,    -1,   718,
     505,   719,    -1,   392,   598,    -1,   366,   598,    -1,   158,
     598,    -1,  1131,   598,    -1,  1000,    -1,   422,  1000,    -1,
     393,  1000,    -1,   224,   174,   472,  1002,    -1,   224,   396,
    1002,    -1,   229,   724,    -1,   175,  1002,    -1,   273,  1002,
      -1,   274,   323,   626,    -1,   387,  1002,    -1,   424,  1002,
      -1,    99,   423,   247,   387,  1002,    -1,    99,   394,   247,
     387,  1002,    -1,    99,   230,   247,   387,  1002,    -1,   722,
      -1,   721,   505,   722,    -1,  1012,    -1,   235,  1012,    -1,
     469,   232,   331,    -1,    -1,   725,    -1,   724,   505,   725,
      -1,  1009,   747,    -1,   232,   718,   432,  1002,   728,   729,
      -1,   379,   718,   227,  1002,   729,   557,    -1,   379,    96,
     331,   222,   718,   227,  1002,   729,   557,    -1,   469,    96,
     331,    -1,    -1,   233,   124,  1012,    -1,    -1,   101,   181,
     356,   731,   733,    -1,   731,   732,    -1,    -1,   247,   387,
    1002,    -1,   222,   381,  1002,    -1,   222,   451,  1002,    -1,
     232,   717,   328,   734,   432,   721,   723,    -1,   379,   717,
     328,   734,   227,   721,   557,    -1,   379,   232,   331,   222,
     717,   328,   734,   227,   721,   557,    -1,   423,    -1,   230,
      -1,   394,    -1,   158,   736,   250,   737,   738,   328,  1001,
     739,   502,   740,   503,   560,   612,   913,    -1,   446,    -1,
      -1,   148,    -1,    -1,  1007,    -1,    -1,   452,  1005,    -1,
      -1,   741,    -1,   740,   505,   741,    -1,  1131,   742,   743,
     744,    -1,   944,   742,   743,   744,    -1,   502,   941,   503,
     742,   743,   744,    -1,   704,    -1,   452,   704,    -1,    -1,
     109,    -1,   189,    -1,    -1,   486,    -1,   487,    -1,    -1,
     158,   746,   229,  1009,   749,   378,   754,   757,   761,    -1,
     158,   746,   229,  1009,   749,   378,   422,   502,   763,   503,
     757,   761,    -1,   158,   746,   229,  1009,   749,   757,   761,
      -1,   333,   372,    -1,    -1,   502,   748,   503,    -1,   502,
     503,    -1,   751,    -1,   748,   505,   751,    -1,   502,   750,
     503,    -1,   502,   503,    -1,   756,    -1,   750,   505,   756,
      -1,   752,   753,   755,    -1,   753,   752,   755,    -1,   753,
     755,    -1,   752,   755,    -1,   755,    -1,   247,    -1,   335,
      -1,   257,    -1,   247,   335,    -1,   459,    -1,  1132,    -1,
     755,    -1,   917,    -1,  1132,   705,   497,   441,    -1,   400,
    1132,   705,   497,   441,    -1,   751,    -1,   751,   181,   941,
      -1,   751,   489,   941,    -1,   759,    -1,   757,   759,    -1,
     126,   328,   319,   258,    -1,   378,   319,   328,   319,   258,
      -1,   415,    -1,   245,    -1,   407,    -1,   464,    -1,   214,
     391,   185,    -1,   214,   391,   267,    -1,   391,   185,    -1,
     391,   267,    -1,   157,   625,    -1,   384,   625,    -1,   546,
      -1,   108,   760,    -1,   273,   544,    -1,   468,    -1,   758,
      -1,  1151,    -1,  1151,   505,  1151,    -1,   469,   677,    -1,
      -1,   753,   755,    -1,   762,    -1,   763,   505,   762,    -1,
     101,   229,   725,   765,   766,    -1,   758,    -1,   765,   758,
      -1,   376,    -1,    -1,   198,   229,  1009,   747,   557,    -1,
     198,   229,   242,   212,  1009,   747,   557,    -1,   198,    98,
    1009,   681,   557,    -1,   198,    98,   242,   212,  1009,   681,
     557,    -1,   198,   330,   771,   770,   557,    -1,   198,   330,
     242,   212,   771,   770,   557,    -1,   502,   917,   503,    -1,
     502,   917,   505,   917,   503,    -1,   502,   312,   505,   917,
     503,    -1,   502,   917,   505,   312,   503,    -1,   964,    -1,
    1131,   504,   771,    -1,   194,   773,    -1,   774,    -1,   773,
     774,    -1,  1151,    -1,   273,   544,    -1,   158,   130,   502,
     917,   108,   917,   503,   469,   229,   725,   776,    -1,   158,
     130,   502,   917,   108,   917,   503,   470,   229,   776,    -1,
     158,   130,   502,   917,   108,   917,   503,   469,   257,   776,
      -1,   108,   246,    -1,   108,   111,    -1,    -1,   198,   130,
     778,   502,   917,   108,   917,   503,   557,    -1,   242,   212,
      -1,    -1,   367,   780,  1001,   781,    -1,   367,   421,  1003,
     781,    -1,   367,   175,  1003,   781,    -1,   250,    -1,   422,
      -1,   223,    -1,    -1,   101,    98,  1009,   681,   370,   432,
    1003,    -1,   101,   155,   704,   370,   432,  1003,    -1,   101,
     175,  1004,   370,   432,  1004,    -1,   101,   229,   725,   370,
     432,  1003,    -1,   101,   235,  1012,   370,   432,  1012,    -1,
     101,   634,   273,  1003,   370,   432,  1003,    -1,   101,   330,
     138,   704,   452,  1005,   370,   432,  1003,    -1,   101,   330,
     217,   704,   452,  1005,   370,   432,  1003,    -1,   101,   387,
    1003,   370,   432,  1003,    -1,   101,   422,   909,   370,   432,
    1003,    -1,   101,   393,  1001,   370,   432,  1003,    -1,   101,
     463,  1001,   370,   432,  1003,    -1,   101,   250,  1001,   370,
     432,  1003,    -1,   101,   422,   909,   370,   783,  1003,   432,
    1003,    -1,   101,   436,  1003,   328,  1001,   370,   432,  1003,
      -1,   101,   381,  1012,   370,   432,  1012,    -1,   101,   451,
    1012,   370,   432,  1012,    -1,   101,   424,  1003,   370,   432,
    1003,    -1,   101,   424,  1003,   399,   559,    -1,   101,   424,
    1003,   374,   559,    -1,   101,   428,   389,   342,   704,   370,
     432,  1003,    -1,   101,   428,   389,   190,   704,   370,   432,
    1003,    -1,   101,   428,   389,   426,   704,   370,   432,  1003,
      -1,   101,   428,   389,   149,   704,   370,   432,  1003,    -1,
     101,   441,   704,   370,   432,  1003,    -1,   143,    -1,    -1,
     399,   174,    -1,    -1,   101,    98,  1009,   681,   399,   387,
    1003,    -1,   101,   196,   704,   399,   387,  1003,    -1,   101,
     229,   725,   399,   387,  1003,    -1,   101,   422,   909,   399,
     387,  1003,    -1,   101,   393,  1001,   399,   387,  1003,    -1,
     101,   463,  1001,   399,   387,  1003,    -1,   101,   441,   704,
     399,   387,  1003,    -1,   101,    98,  1009,   681,   341,   432,
    1012,    -1,   101,   155,   704,   341,   432,  1012,    -1,   101,
     175,  1004,   341,   432,  1012,    -1,   101,   196,   704,   341,
     432,  1012,    -1,   101,   229,   725,   341,   432,  1012,    -1,
     101,   634,   273,  1003,   341,   432,  1012,    -1,   101,   274,
     323,   625,   341,   432,  1012,    -1,   101,   330,   771,   770,
     341,   432,  1012,    -1,   101,   330,   138,   704,   452,  1005,
     341,   432,  1012,    -1,   101,   330,   217,   704,   452,  1005,
     341,   432,  1012,    -1,   101,   387,  1003,   341,   432,  1012,
      -1,   101,   441,   704,   341,   432,  1012,    -1,   101,   424,
    1003,   341,   432,  1012,    -1,   101,   428,   389,   190,   704,
     341,   432,  1012,    -1,   101,   428,   389,   149,   704,   341,
     432,  1012,    -1,   101,   224,   174,   472,  1003,   341,   432,
    1012,    -1,   101,   396,  1003,   341,   432,  1012,    -1,   158,
     746,   385,  1003,   108,   328,   792,   432,  1001,   913,   194,
     793,   788,    -1,   315,    -1,   790,    -1,   502,   789,   503,
      -1,   789,   506,   791,    -1,   791,    -1,   866,    -1,   844,
      -1,   855,    -1,   849,    -1,   795,    -1,   790,    -1,    -1,
     392,    -1,   450,    -1,   186,    -1,   260,    -1,   261,    -1,
     100,    -1,    -1,   198,   385,  1003,   328,  1001,   557,    -1,
     198,   385,   242,   212,  1003,   328,  1001,   557,    -1,   316,
    1131,   796,    -1,   505,  1151,    -1,    -1,   284,  1131,    -1,
     448,  1131,    -1,   448,   495,    -1,    91,   800,    -1,   117,
     800,   803,    -1,   409,   434,   803,    -1,   146,   800,    -1,
     204,   800,    -1,   382,   800,    -1,   386,  1131,    -1,   369,
     386,  1131,    -1,   369,  1131,    -1,   382,   800,   432,   386,
    1131,    -1,   382,   800,   432,  1131,    -1,   352,   434,  1151,
      -1,   146,   353,  1151,    -1,   382,   353,  1151,    -1,   471,
      -1,   434,    -1,    -1,   270,   281,   540,    -1,   361,   329,
      -1,   361,   473,    -1,   801,    -1,   802,   505,   801,    -1,
     802,   801,    -1,   802,    -1,    -1,   158,   580,   463,  1001,
     598,   108,   866,   805,    -1,   158,   333,   372,   580,   463,
    1001,   598,   108,   866,   805,    -1,   469,   136,   331,    -1,
     469,   128,   136,   331,    -1,   469,   286,   136,   331,    -1,
      -1,   285,  1008,    -1,   158,   175,  1004,   514,   808,    -1,
     808,   809,    -1,    -1,   424,   810,  1003,    -1,   424,   810,
     181,    -1,   289,   810,  1151,    -1,   289,   810,   181,    -1,
     426,   810,  1003,    -1,   426,   810,   181,    -1,   202,   810,
    1151,    -1,   202,   810,  1011,    -1,   202,   810,   181,    -1,
     276,   810,  1151,    -1,   276,   810,   181,    -1,   277,   810,
    1151,    -1,   277,   810,   181,    -1,   150,   283,   810,  1013,
      -1,   341,   810,  1003,    -1,   341,   810,   181,    -1,   489,
      -1,    -1,   101,   175,  1004,   514,   813,    -1,   101,   175,
    1004,   399,   424,  1003,    -1,   101,   175,  1004,   546,    -1,
     813,   814,    -1,    -1,   150,   283,   810,  1013,    -1,   198,
     175,  1004,    -1,   198,   175,   242,   212,  1004,    -1,   158,
     196,   704,   818,   917,   589,    -1,   101,   196,   704,   556,
      -1,   101,   196,   704,   198,   314,   319,    -1,   101,   196,
     704,   399,   314,   319,    -1,   101,   196,   704,    95,   596,
      -1,   101,   196,   704,   198,   151,  1003,   557,    -1,   108,
      -1,    -1,   101,   428,   389,   190,   704,   677,    -1,   101,
     428,   389,   149,   704,    95,   292,   222,  1002,   469,   703,
      -1,   101,   428,   389,   149,   704,   101,   292,   222,  1002,
     469,   703,    -1,   101,   428,   389,   149,   704,   101,   292,
     372,   704,   469,   704,    -1,   101,   428,   389,   149,   704,
     101,   292,   222,  1002,   372,   704,   469,   704,    -1,   101,
     428,   389,   149,   704,   198,   292,   222,  1002,    -1,   101,
     428,   389,   149,   704,   198,   292,   242,   212,   222,  1002,
      -1,   158,   690,   155,   704,   222,  1151,   432,  1151,   227,
     704,    -1,   140,   829,  1001,   823,    -1,   140,   829,    -1,
     140,   829,  1007,   328,  1001,    -1,   452,  1007,    -1,    -1,
     453,   830,   831,   829,    -1,   453,   830,   831,   829,  1001,
      -1,   453,   830,   831,   829,   827,    -1,   453,   502,   825,
     503,    -1,   453,   502,   825,   503,  1001,   832,    -1,   826,
      -1,   825,   505,   826,    -1,   828,    -1,   461,    -1,   226,
      -1,   228,    -1,   828,   829,    -1,   828,   829,  1001,   832,
      -1,   104,    -1,   103,    -1,   461,    -1,    -1,   228,    -1,
      -1,   226,    -1,    -1,   502,  1002,   503,    -1,    -1,   213,
     834,    -1,   213,   828,   829,   834,    -1,   213,   461,   834,
      -1,   213,   502,   835,   503,   834,    -1,   866,    -1,   844,
      -1,   855,    -1,   849,    -1,   862,    -1,  1020,    -1,   842,
      -1,   836,    -1,   835,   505,   836,    -1,   837,   838,    -1,
    1131,    -1,   828,    -1,   461,    -1,   541,    -1,   625,    -1,
      -1,   352,  1039,   840,   108,   841,    -1,   352,  1039,   227,
    1084,    -1,   502,   972,   503,    -1,    -1,   866,    -1,   844,
      -1,   855,    -1,   849,    -1,   211,  1039,   843,  1163,    -1,
     158,   580,   422,   614,   108,   211,  1039,   843,    -1,   502,
     969,   503,    -1,    -1,   260,   266,  1001,   845,   848,    -1,
     866,    -1,   502,   846,   503,   866,    -1,   181,   457,    -1,
     847,    -1,   846,   505,   847,    -1,  1131,   993,    -1,   377,
     998,  1164,    -1,    -1,   186,   227,   911,   850,   914,   848,
      -1,   452,   902,    -1,    -1,   290,   876,   910,   852,   854,
      -1,   247,   853,   297,    -1,    -1,    93,   401,    -1,   383,
     401,    -1,   383,   210,    -1,   401,   450,   210,    -1,   401,
      -1,   401,   383,   210,    -1,   210,    -1,    93,   210,    -1,
     318,    -1,    -1,   450,   911,   399,   856,   901,   914,   848,
      -1,   857,    -1,   856,   505,   857,    -1,   858,    -1,   859,
      -1,   860,   489,   995,    -1,   502,   861,   503,   489,   997,
      -1,  1131,   993,    -1,   860,    -1,   861,   505,   860,    -1,
     180,   863,   864,   172,   865,   222,   866,    -1,  1003,    -1,
    1144,    -1,    -1,   864,   306,   388,    -1,   864,   388,    -1,
     864,   120,    -1,   864,   259,    -1,    -1,   469,   239,    -1,
     470,   239,    -1,   868,    -1,   867,    -1,   502,   868,   503,
      -1,   502,   867,   503,    -1,   870,    -1,   869,   880,    -1,
     869,   879,   895,   884,    -1,   869,   879,   883,   896,    -1,
     871,   869,    -1,   871,   869,   880,    -1,   871,   869,   879,
     895,   884,    -1,   871,   869,   879,   883,   896,    -1,   870,
      -1,   867,    -1,   392,   878,   998,   874,   901,   913,   893,
     894,   952,    -1,   900,    -1,   422,   909,    -1,   869,   445,
     877,   869,    -1,   869,   264,   877,   869,    -1,   869,   207,
     877,   869,    -1,   469,   872,    -1,   469,   365,   872,    -1,
     873,    -1,   872,   505,   873,    -1,  1003,   832,   108,   867,
      -1,   266,   875,    -1,  1164,    -1,    -1,   427,   876,  1001,
      -1,   425,   876,  1001,    -1,   286,   427,   876,  1001,    -1,
     286,   425,   876,  1001,    -1,   231,   427,   876,  1001,    -1,
     231,   425,   876,  1001,    -1,   422,  1001,    -1,  1001,    -1,
     422,    -1,    -1,    99,    -1,   193,    -1,    -1,   193,    -1,
     193,   328,   502,   969,   503,    -1,    99,    -1,    -1,   880,
      -1,    -1,   334,   124,   881,    -1,   882,    -1,   881,   505,
     882,    -1,   941,   452,   967,   744,    -1,   941,   743,   744,
      -1,   885,   886,    -1,   886,   885,    -1,   885,    -1,   886,
      -1,   883,    -1,    -1,   283,   887,    -1,   283,   887,   505,
     888,    -1,   218,   892,   889,   891,   329,    -1,   326,   888,
      -1,   326,   890,   891,    -1,   941,    -1,    99,    -1,   941,
      -1,  1013,    -1,   502,   941,   503,    -1,    -1,   943,    -1,
     383,    -1,   384,    -1,   219,    -1,   305,    -1,   235,   124,
     969,    -1,    -1,   237,   941,    -1,    -1,   897,    -1,   222,
     361,   329,    -1,   895,    -1,    -1,   898,    -1,   897,   898,
      -1,   222,   450,   899,   854,    -1,   222,   401,   899,   854,
      -1,   324,  1000,    -1,    -1,   457,   997,    -1,   900,   505,
     997,    -1,   227,   902,    -1,    -1,   903,    -1,   902,   505,
     903,    -1,   909,    -1,   909,   905,    -1,   912,    -1,   912,
     905,    -1,   912,   108,   502,   915,   503,    -1,   912,   108,
    1131,   502,   915,   503,    -1,   912,  1131,   502,   915,   503,
      -1,   867,    -1,   867,   905,    -1,   904,    -1,   502,   904,
     503,   905,    -1,   502,   904,   503,    -1,   903,   162,   271,
     903,    -1,   903,   906,   271,   903,   908,    -1,   903,   271,
     903,   908,    -1,   903,   303,   906,   271,   903,    -1,   903,
     303,   271,   903,    -1,   108,  1131,   502,  1002,   503,    -1,
     108,  1131,    -1,  1131,   502,  1002,   503,    -1,  1131,    -1,
     228,   907,    -1,   280,   907,    -1,   380,   907,    -1,   256,
      -1,   336,    -1,    -1,   452,   502,  1002,   503,    -1,   328,
     941,    -1,  1001,    -1,  1001,   495,    -1,   329,  1001,    -1,
     329,   502,  1001,   503,    -1,   909,    -1,   910,   505,   909,
      -1,   909,    -1,   909,  1131,    -1,   909,   108,  1131,    -1,
     944,    -1,   466,   941,    -1,    -1,   466,   941,    -1,   466,
     164,   324,  1003,    -1,    -1,   916,    -1,   915,   505,   916,
      -1,  1131,   917,    -1,   919,   918,    -1,   400,   919,   918,
      -1,   919,   107,   500,  1011,   501,    -1,   400,   919,   107,
     500,  1011,   501,    -1,   919,   107,    -1,   400,   919,   107,
      -1,   918,   500,   501,    -1,   918,   500,  1162,   501,    -1,
      -1,   921,    -1,   923,    -1,   925,    -1,   929,    -1,   936,
      -1,   937,   939,    -1,   937,   502,  1011,   503,   939,    -1,
     923,    -1,   926,    -1,   930,    -1,   936,    -1,  1132,   922,
      -1,  1132,   705,   922,    -1,   502,   969,   503,    -1,    -1,
     262,    -1,   263,    -1,   405,    -1,   119,    -1,   362,    -1,
     220,   924,    -1,   197,   350,    -1,   179,   922,    -1,   178,
     922,    -1,   322,   922,    -1,   122,    -1,   502,  1011,   503,
      -1,    -1,   927,    -1,   928,    -1,   927,    -1,   928,    -1,
     121,   934,   502,   969,   503,    -1,   121,   934,    -1,   931,
      -1,   932,    -1,   931,    -1,   932,    -1,   933,   502,  1011,
     503,   935,    -1,   933,   935,    -1,   134,   934,    -1,   133,
     934,    -1,   458,    -1,   302,   134,   934,    -1,   302,   133,
     934,    -1,   304,   934,    -1,   460,    -1,    -1,   134,   399,
    1131,    -1,    -1,   431,   502,  1011,   503,   938,    -1,   431,
     938,    -1,   430,   502,  1011,   503,   938,    -1,   430,   938,
      -1,   265,    -1,   488,   485,    -1,   470,   430,   485,    -1,
      -1,   483,    -1,   298,    -1,   176,    -1,   240,    -1,   295,
      -1,   940,    -1,   483,   432,   298,    -1,   176,   432,   240,
      -1,   176,   432,   295,    -1,   176,   432,   940,    -1,   240,
     432,   295,    -1,   240,   432,   940,    -1,   295,   432,   940,
      -1,    -1,   390,    -1,   390,   502,  1011,   503,    -1,   943,
      -1,   941,    88,   917,    -1,   941,   113,   430,   485,   941,
      -1,   493,   941,    -1,   494,   941,    -1,   941,   493,   941,
      -1,   941,   494,   941,    -1,   941,   495,   941,    -1,   941,
     496,   941,    -1,   941,   497,   941,    -1,   941,   498,   941,
      -1,   941,   490,   941,    -1,   941,   491,   941,    -1,   941,
     489,   941,    -1,   941,   966,   941,    -1,   966,   941,    -1,
     941,   966,    -1,   941,   105,   941,    -1,   941,   333,   941,
      -1,   314,   941,    -1,   941,   282,   941,    -1,   941,   282,
     941,   206,   941,    -1,   941,   314,   282,   941,    -1,   941,
     314,   282,   941,   206,   941,    -1,   941,   243,   941,    -1,
     941,   243,   941,   206,   941,    -1,   941,   314,   243,   941,
      -1,   941,   314,   243,   941,   206,   941,    -1,   941,   403,
     432,   941,    -1,   941,   403,   432,   941,   206,   941,    -1,
     941,   314,   403,   432,   941,    -1,   941,   314,   403,   432,
     941,   206,   941,    -1,   941,   268,   319,    -1,   941,   269,
      -1,   941,   268,   314,   319,    -1,   941,   317,    -1,   962,
     338,   962,    -1,   941,   268,   438,    -1,   941,   268,   314,
     438,    -1,   941,   268,   216,    -1,   941,   268,   314,   216,
      -1,   941,   268,   447,    -1,   941,   268,   314,   447,    -1,
     941,   268,   193,   227,   941,    -1,   941,   268,   314,   193,
     227,   941,    -1,   941,   268,   324,   502,   972,   503,    -1,
     941,   268,   314,   324,   502,   972,   503,    -1,   941,   118,
     994,   942,   105,   942,    -1,   941,   314,   118,   994,   942,
     105,   942,    -1,   941,   118,   419,   942,   105,   942,    -1,
     941,   314,   118,   419,   942,   105,   942,    -1,   941,   247,
     984,    -1,   941,   314,   247,   984,    -1,   941,   968,   963,
     867,    -1,   941,   968,   963,   502,   941,   503,    -1,   446,
     867,    -1,   941,   268,   195,    -1,   941,   268,   314,   195,
      -1,   943,    -1,   942,    88,   917,    -1,   493,   942,    -1,
     494,   942,    -1,   942,   493,   942,    -1,   942,   494,   942,
      -1,   942,   495,   942,    -1,   942,   496,   942,    -1,   942,
     497,   942,    -1,   942,   498,   942,    -1,   942,   490,   942,
      -1,   942,   491,   942,    -1,   942,   489,   942,    -1,   942,
     966,   942,    -1,   966,   942,    -1,   942,   966,    -1,   942,
     268,   193,   227,   942,    -1,   942,   268,   314,   193,   227,
     942,    -1,   942,   268,   324,   502,   972,   503,    -1,   942,
     268,   314,   324,   502,   972,   503,    -1,   942,   268,   195,
      -1,   942,   268,   314,   195,    -1,   990,    -1,  1010,    -1,
    1148,   993,    -1,   502,   941,   503,   993,    -1,   985,    -1,
     944,    -1,   867,    -1,   867,   992,    -1,   212,   867,    -1,
     107,   867,    -1,   107,   973,    -1,   962,    -1,  1009,   502,
     503,   955,    -1,  1009,   502,   970,   503,   955,    -1,  1009,
     502,   459,   971,   503,   955,    -1,  1009,   502,   970,   505,
     459,   971,   503,   955,    -1,  1009,   502,   970,   880,   503,
     955,    -1,  1009,   502,    99,   970,   879,   503,   955,    -1,
    1009,   502,   193,   970,   879,   503,   955,    -1,  1009,   502,
     495,   503,   955,    -1,   166,    -1,   169,    -1,   169,   502,
    1011,   503,    -1,   170,    -1,   170,   502,  1011,   503,    -1,
     287,    -1,   287,   502,  1011,   503,    -1,   288,    -1,   288,
     502,  1011,   503,    -1,   167,    -1,   171,    -1,   398,    -1,
     451,    -1,   165,    -1,   168,    -1,   130,   502,   941,   108,
     917,   503,    -1,   215,   502,   975,   503,    -1,   339,   502,
     977,   503,    -1,   348,   502,   979,   503,    -1,   417,   502,
     980,   503,    -1,   435,   502,   941,   108,   917,   503,    -1,
     437,   502,   123,   983,   503,    -1,   437,   502,   278,   983,
     503,    -1,   437,   502,   433,   983,   503,    -1,   437,   502,
     983,   503,    -1,   320,   502,   941,   505,   941,   503,    -1,
     141,   502,   969,   503,    -1,   234,   502,   969,   503,    -1,
     279,   502,   969,   503,    -1,   476,   502,   969,   503,    -1,
     477,   502,   300,  1133,   503,    -1,   477,   502,   300,  1133,
     505,   947,   503,    -1,   477,   502,   300,  1133,   505,   969,
     503,    -1,   477,   502,   300,  1133,   505,   947,   505,   969,
     503,    -1,   478,   502,   948,   503,    -1,   479,   502,   950,
     941,   951,   503,    -1,   480,   502,   300,  1133,   503,    -1,
     480,   502,   300,  1133,   505,   941,   503,    -1,   481,   502,
     941,   505,   945,   946,   503,    -1,   482,   502,   950,   941,
     108,   919,   503,    -1,   462,   941,    -1,   462,   306,   456,
      -1,   505,   408,   484,    -1,   505,   408,   306,    -1,   505,
     408,   306,   456,    -1,    -1,   475,   502,   948,   503,    -1,
     949,    -1,   948,   505,   949,    -1,   941,   108,  1133,    -1,
     941,    -1,   195,    -1,   153,    -1,   351,   467,    -1,   416,
     467,    -1,    -1,   468,   953,    -1,    -1,   954,    -1,   953,
     505,   954,    -1,  1131,   108,   956,    -1,   337,   956,    -1,
     337,  1131,    -1,    -1,   502,   957,   958,   879,   959,   503,
      -1,  1131,    -1,    -1,   344,   124,   969,    -1,    -1,   360,
     960,    -1,   384,   960,    -1,    -1,   961,    -1,   118,   961,
     105,   961,    -1,   442,   349,    -1,   442,   221,    -1,   164,
     383,    -1,   941,   349,    -1,   941,   221,    -1,   383,   502,
     969,   503,    -1,   383,   502,   503,    -1,   502,   969,   505,
     941,   503,    -1,   106,    -1,   406,    -1,    99,    -1,    85,
      -1,   965,    -1,   493,    -1,   494,    -1,   495,    -1,   496,
      -1,   497,    -1,   498,    -1,   490,    -1,   491,    -1,   489,
      -1,    85,    -1,   330,   502,   771,   503,    -1,   964,    -1,
     330,   502,   771,   503,    -1,   964,    -1,   330,   502,   771,
     503,    -1,   282,    -1,   314,   282,    -1,   243,    -1,   314,
     243,    -1,   941,    -1,   969,   505,   941,    -1,   971,    -1,
     970,   505,   971,    -1,   941,    -1,   753,    90,   941,    -1,
     917,    -1,   972,   505,   917,    -1,   500,   969,   501,    -1,
     500,   974,   501,    -1,   500,   501,    -1,   973,    -1,   974,
     505,   973,    -1,   976,   227,   941,    -1,    -1,  1153,    -1,
     483,    -1,   298,    -1,   176,    -1,   240,    -1,   295,    -1,
     390,    -1,  1151,    -1,   941,   978,   981,   982,    -1,   941,
     978,   981,    -1,   346,   941,    -1,   942,   247,   942,    -1,
      -1,   941,   981,   982,    -1,   941,   982,   981,    -1,   941,
     981,    -1,   941,   982,    -1,   969,    -1,    -1,   227,   941,
      -1,   222,   941,    -1,   941,   227,   969,    -1,   227,   969,
      -1,   969,    -1,   867,    -1,   502,   969,   503,    -1,   129,
     989,   986,   988,   204,    -1,   987,    -1,   986,   987,    -1,
     465,   941,   429,   941,    -1,   200,   941,    -1,    -1,   941,
      -1,    -1,  1131,    -1,  1131,   992,    -1,   504,  1006,    -1,
     504,   495,    -1,   500,   941,   501,    -1,   500,   941,   507,
     941,   501,    -1,   991,    -1,   992,   991,    -1,    -1,   993,
     991,    -1,   112,    -1,    -1,   941,    -1,   181,    -1,   995,
      -1,   996,   505,   995,    -1,   502,   996,   503,    -1,   999,
      -1,   998,   505,   999,    -1,   941,   108,  1133,    -1,   941,
    1153,    -1,   941,    -1,   495,    -1,  1001,    -1,  1000,   505,
    1001,    -1,  1131,    -1,  1131,   992,    -1,  1003,    -1,  1002,
     505,  1003,    -1,  1131,    -1,  1131,    -1,  1131,    -1,  1133,
      -1,  1131,    -1,  1151,    -1,  1132,    -1,  1131,   992,    -1,
    1011,    -1,  1150,    -1,  1151,    -1,  1149,    -1,    84,    -1,
    1009,  1151,    -1,  1009,   502,   970,   503,  1151,    -1,   920,
    1151,    -1,   937,  1151,   939,    -1,   937,   502,  1011,   503,
    1151,   939,    -1,   438,    -1,   216,    -1,   319,    -1,  1145,
      -1,  1143,    -1,    86,    -1,  1131,    -1,  1011,    -1,  1145,
      -1,   493,  1011,    -1,   494,  1011,    -1,    91,    -1,    92,
      -1,    93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,
      -1,    98,    -1,   100,    -1,   101,    -1,   102,    -1,   110,
      -1,   111,    -1,   113,    -1,   115,    -1,   116,    -1,   117,
      -1,   124,    -1,   125,    -1,   126,    -1,   127,    -1,   128,
      -1,   131,    -1,   132,    -1,   135,    -1,   137,    -1,   138,
      -1,   139,    -1,   140,    -1,   144,    -1,   145,    -1,   146,
      -1,   147,    -1,   149,    -1,   152,    -1,   153,    -1,   154,
      -1,   155,    -1,   156,    -1,   157,    -1,   159,    -1,   160,
      -1,   161,    -1,   163,    -1,   172,    -1,   173,    -1,   174,
      -1,   175,    -1,   177,    -1,   180,    -1,   182,    -1,   184,
      -1,   185,    -1,   186,    -1,   187,    -1,   188,    -1,   190,
      -1,   191,    -1,   192,    -1,   195,    -1,   196,    -1,   197,
      -1,   198,    -1,   199,    -1,   201,    -1,   202,    -1,   203,
      -1,   205,    -1,   206,    -1,   208,    -1,   209,    -1,   210,
      -1,   211,    -1,   213,    -1,   214,    -1,   217,    -1,   219,
      -1,   221,    -1,   223,    -1,   225,    -1,   229,    -1,   230,
      -1,   231,    -1,   233,    -1,   236,    -1,   238,    -1,   239,
      -1,   241,    -1,   242,    -1,   244,    -1,   245,    -1,   246,
      -1,   248,    -1,   249,    -1,   250,    -1,   251,    -1,   252,
      -1,   253,    -1,   255,    -1,   259,    -1,   260,    -1,   261,
      -1,   267,    -1,   270,    -1,   272,    -1,   273,    -1,   274,
      -1,   275,    -1,   276,    -1,   277,    -1,   281,    -1,   284,
      -1,   285,    -1,   286,    -1,   289,    -1,   290,    -1,   291,
      -1,   292,    -1,   293,    -1,   294,    -1,   296,    -1,   297,
      -1,   299,    -1,   300,    -1,   301,    -1,   305,    -1,   306,
      -1,   307,    -1,   308,    -1,   309,    -1,   310,    -1,   311,
      -1,   313,    -1,   315,    -1,   316,    -1,   318,    -1,   321,
      -1,   323,    -1,   324,    -1,   325,    -1,   327,    -1,   330,
      -1,   331,    -1,   332,    -1,   340,    -1,   341,    -1,   342,
      -1,   343,    -1,   344,    -1,   345,    -1,   347,    -1,   349,
      -1,   352,    -1,   353,    -1,   351,    -1,   355,    -1,   356,
      -1,   357,    -1,   358,    -1,   359,    -1,   360,    -1,   361,
      -1,   363,    -1,   364,    -1,   365,    -1,   367,    -1,   368,
      -1,   369,    -1,   370,    -1,   371,    -1,   372,    -1,   373,
      -1,   374,    -1,   375,    -1,   376,    -1,   378,    -1,   379,
      -1,   381,    -1,   382,    -1,   384,    -1,   385,    -1,   386,
      -1,   387,    -1,   388,    -1,   389,    -1,   391,    -1,   393,
      -1,   394,    -1,   395,    -1,   396,    -1,   397,    -1,   399,
      -1,   401,    -1,   402,    -1,   404,    -1,   407,    -1,   408,
      -1,   409,    -1,   410,    -1,   411,    -1,   412,    -1,   413,
      -1,   414,    -1,   415,    -1,   416,    -1,   418,    -1,   420,
      -1,   421,    -1,   423,    -1,   424,    -1,   425,    -1,   426,
      -1,   427,    -1,   428,    -1,   434,    -1,   436,    -1,   439,
      -1,   440,    -1,   441,    -1,   442,    -1,   443,    -1,   444,
      -1,   447,    -1,   448,    -1,   449,    -1,   450,    -1,   453,
      -1,   454,    -1,   455,    -1,   456,    -1,   460,    -1,   462,
      -1,   463,    -1,   464,    -1,   467,    -1,   470,    -1,   471,
      -1,   472,    -1,   473,    -1,   474,    -1,   484,    -1,   485,
      -1,   118,    -1,   119,    -1,   121,    -1,   122,    -1,   134,
      -1,   141,    -1,   178,    -1,   179,    -1,   212,    -1,   215,
      -1,   220,    -1,   234,    -1,   257,    -1,   263,    -1,   265,
      -1,   279,    -1,   302,    -1,   304,    -1,   312,    -1,   320,
      -1,   322,    -1,   335,    -1,   339,    -1,   348,    -1,   350,
      -1,   362,    -1,   383,    -1,   400,    -1,   405,    -1,   417,
      -1,   430,    -1,   431,    -1,   435,    -1,   437,    -1,   458,
      -1,   475,    -1,   476,    -1,   477,    -1,   478,    -1,   479,
      -1,   480,    -1,   481,    -1,   482,    -1,   114,    -1,   120,
      -1,   148,    -1,   162,    -1,   168,    -1,   226,    -1,   228,
      -1,   243,    -1,   256,    -1,   268,    -1,   269,    -1,   271,
      -1,   280,    -1,   282,    -1,   303,    -1,   317,    -1,   336,
      -1,   337,    -1,   338,    -1,   380,    -1,   403,    -1,   461,
      -1,    99,    -1,   103,    -1,   104,    -1,   105,    -1,   106,
      -1,   107,    -1,   108,    -1,   109,    -1,   112,    -1,   123,
      -1,   129,    -1,   130,    -1,   136,    -1,   142,    -1,   143,
      -1,   151,    -1,   158,    -1,   165,    -1,   166,    -1,   167,
      -1,   169,    -1,   170,    -1,   171,    -1,   181,    -1,   183,
      -1,   189,    -1,   193,    -1,   194,    -1,   200,    -1,   204,
      -1,   207,    -1,   216,    -1,   218,    -1,   222,    -1,   224,
      -1,   227,    -1,   232,    -1,   235,    -1,   237,    -1,   247,
      -1,   254,    -1,   264,    -1,   266,    -1,   278,    -1,   283,
      -1,   287,    -1,   288,    -1,   314,    -1,   319,    -1,   326,
      -1,   328,    -1,   329,    -1,   333,    -1,   334,    -1,   346,
      -1,   354,    -1,   366,    -1,   377,    -1,   392,    -1,   398,
      -1,   406,    -1,   419,    -1,   422,    -1,   429,    -1,   433,
      -1,   438,    -1,   446,    -1,   451,    -1,   452,    -1,   459,
      -1,   465,    -1,   466,    -1,   468,    -1,   469,    -1,    -1,
    1018,  1019,    -1,  1140,  1022,   512,   506,    -1,  1140,   512,
     506,    -1,  1140,  1042,    -1,  1047,    -1,  1159,    -1,    73,
      -1,   508,    -1,   509,    -1,    -1,   158,   580,   422,   614,
     108,  1021,   866,   618,    -1,   113,  1083,    -1,     9,   432,
    1024,  1031,  1032,    -1,     9,   432,   181,    -1,     9,  1033,
      -1,   175,  1024,    -1,  1025,  1028,  1030,    -1,  1026,   507,
    1027,  1030,   496,  1025,  1036,    -1,  1035,    -1,  1151,    -1,
    1004,    -1,    -1,  1153,  1147,    -1,    85,  1029,    -1,  1027,
      -1,    -1,  1131,    -1,  1131,   504,  1029,    -1,    74,    -1,
     507,  1011,    -1,    -1,   108,  1083,    -1,    -1,   451,  1033,
      -1,    -1,  1034,    -1,  1034,   496,  1034,    -1,  1034,    21,
     124,  1034,    -1,  1034,   452,  1034,    -1,  1012,    -1,  1151,
      -1,  1145,    -1,  1147,    -1,    85,  1037,    -1,    -1,  1131,
    1038,    -1,  1131,  1038,    85,  1037,    -1,    -1,   489,  1011,
      -1,   489,  1153,    -1,   489,  1145,    -1,  1003,    -1,  1035,
      -1,   180,   863,   864,   172,   865,   222,  1039,    -1,   211,
     244,  1084,    -1,  1043,    -1,  1054,    -1,  1056,    -1,   625,
      -1,   505,   625,    -1,    -1,   939,    -1,   483,   432,   295,
      -1,   483,   432,   390,    -1,   176,   432,   176,    -1,   298,
     432,   298,    -1,    -1,  1049,  1048,  1051,  1050,    -1,  1140,
     117,   180,    34,   506,    -1,  1140,   204,   180,    34,   506,
      -1,    -1,  1052,    -1,  1043,    -1,    73,    -1,  1052,  1043,
      -1,  1052,    73,    -1,  1056,    -1,  1053,  1056,    -1,    -1,
      70,  1055,  1063,  1079,  1135,   918,   506,    -1,    -1,  1060,
    1063,  1057,  1076,   506,    -1,    -1,  1063,  1058,  1076,   506,
      -1,  1066,   506,    -1,   507,  1011,    -1,    -1,  1061,  1062,
      -1,  1061,    -1,  1062,    -1,    56,    -1,    67,    -1,    65,
      -1,    50,    -1,    51,    -1,    69,    -1,  1072,    -1,  1068,
      -1,  1064,    -1,  1135,   502,  1044,  1045,   503,    -1,  1135,
    1046,    -1,  1070,    -1,   205,  1129,  1065,    -1,   205,  1065,
      -1,   205,  1129,    -1,   508,  1157,   509,    -1,    -1,  1070,
    1067,   508,  1053,   509,    -1,  1066,    -1,    -1,  1071,  1069,
     508,  1053,   509,    -1,    43,  1129,    -1,   445,  1129,    -1,
      43,    -1,   445,    -1,  1073,    -1,  1075,  1074,    -1,    44,
      35,    -1,    44,    35,   262,    -1,    44,    -1,    44,   262,
      -1,    44,    25,    -1,    44,    25,   262,    -1,    44,    25,
      25,    -1,    44,    25,    25,   262,    -1,    44,   133,    -1,
      35,    -1,    35,   262,    -1,   262,    -1,    25,    -1,    25,
     262,    -1,    25,    25,    -1,    25,    25,   262,    -1,     5,
      -1,   133,    -1,   197,    -1,    36,    -1,    -1,  1077,    -1,
    1076,   505,  1077,    -1,  1079,  1134,   918,  1059,  1078,    -1,
      -1,   489,  1158,    -1,    -1,   495,    -1,   495,   495,    -1,
     180,   410,  1153,    -1,    15,  1082,    -1,  1083,    -1,   164,
      -1,    99,    -1,    -1,  1004,    -1,   181,    -1,  1035,    -1,
    1035,    -1,    71,    -1,    17,   863,    -1,    17,    99,    -1,
      28,   863,  1087,    -1,    -1,  1088,    -1,   452,  1092,    -1,
    1089,    -1,   452,    37,    14,  1154,    -1,   452,    14,  1003,
      -1,   266,    37,    14,  1154,    -1,   266,    14,  1003,    -1,
     266,  1003,    -1,  1093,    -1,  1093,   505,  1092,    -1,  1094,
      -1,  1145,    -1,  1143,    -1,  1011,    -1,   493,  1011,    -1,
     494,  1011,    -1,  1150,    -1,   493,  1150,    -1,   494,  1150,
      -1,  1151,    -1,  1149,    -1,  1152,    -1,    13,   258,  1039,
    1089,    -1,    13,  1096,  1039,  1089,    -1,    13,  1096,  1039,
    1090,    -1,    13,   258,  1039,  1091,    -1,    13,  1096,  1039,
    1091,    -1,    29,    -1,    -1,     3,    14,  1154,    -1,   177,
      14,  1154,    -1,    18,    14,  1154,  1100,    -1,  1101,    -1,
    1100,   505,  1101,    -1,  1147,   489,  1106,    -1,   399,    14,
    1154,  1103,    -1,  1104,    -1,  1103,   505,  1104,    -1,  1106,
     489,  1105,    -1,  1011,    -1,  1147,    -1,    10,    -1,    18,
      14,  1154,   456,  1105,  1108,    -1,  1109,    -1,  1108,   505,
    1109,    -1,  1147,   489,  1114,    -1,   399,    14,  1154,   456,
    1105,  1111,    -1,  1112,    -1,  1111,   505,  1112,    -1,  1114,
     489,  1113,    -1,  1150,    -1,  1105,    -1,   494,  1150,    -1,
     494,  1011,    -1,  1151,    -1,     8,    -1,   174,    -1,    11,
      -1,    12,    -1,    22,    -1,    23,    -1,    24,    -1,   300,
      -1,    26,    -1,    27,    -1,   350,    -1,    31,    -1,    32,
      -1,    33,    -1,   441,    -1,   399,     4,   489,  1116,    -1,
     399,     4,   432,  1116,    -1,   328,    -1,   325,    -1,   399,
     150,   432,  1083,    -1,   399,   150,   489,  1083,    -1,   399,
     150,  1083,    -1,    -1,   441,  1119,  1135,   268,  1063,   918,
    1120,    -1,    30,    -1,    -1,    -1,    45,  1122,  1133,   268,
    1063,   918,  1120,    -1,    46,    38,  1124,    -1,    46,   314,
      16,  1124,    -1,    46,    40,  1124,    -1,   154,    -1,    39,
      -1,    42,    -1,    20,  1003,    -1,    19,   432,  1003,    -1,
     194,  1003,   502,  1141,   503,    -1,   194,     6,    -1,     7,
    1003,   502,  1141,   503,    -1,     7,  1003,    -1,  1126,    -1,
    1127,    -1,     6,    -1,     7,    -1,     8,    -1,    10,    -1,
      11,    -1,    12,    -1,    16,    -1,    19,    -1,    20,    -1,
      21,    -1,    22,    -1,    23,    -1,    24,    -1,    26,    -1,
      27,    -1,    31,    -1,    32,    -1,    33,    -1,    34,    -1,
      37,    -1,    38,    -1,    39,    -1,    40,    -1,    42,    -1,
       9,    -1,    13,    -1,    15,    -1,    28,    -1,    45,    -1,
      46,    -1,     5,    -1,    25,    -1,    29,    -1,    35,    -1,
      43,    -1,    36,    -1,    44,    -1,  1133,    -1,  1153,    -1,
    1014,    -1,  1015,    -1,  1138,    -1,  1125,    -1,  1136,    -1,
     133,    -1,   457,    -1,  1153,    -1,  1137,    -1,  1015,    -1,
    1125,    -1,  1136,    -1,   133,    -1,   457,    -1,  1153,    -1,
    1137,    -1,  1016,    -1,  1125,    -1,  1136,    -1,  1128,    -1,
    1134,    -1,  1128,    -1,   133,    -1,   164,    -1,   258,    -1,
     262,    -1,   432,    -1,   445,    -1,   457,    -1,  1136,    -1,
    1138,    -1,  1135,    -1,  1014,    -1,  1017,    -1,  1127,    -1,
     150,    -1,  1153,    -1,  1015,    -1,  1016,    -1,  1126,    -1,
      50,    -1,    51,    -1,    56,    -1,    65,    -1,    67,    -1,
      70,    -1,    69,    -1,  1014,    -1,  1138,    -1,   150,    -1,
     176,    -1,   240,    -1,   295,    -1,   298,    -1,   390,    -1,
     483,    -1,  1142,    -1,  1139,   505,  1142,    -1,    41,    -1,
      -1,  1157,    -1,  1147,  1146,    -1,  1147,    -1,  1147,  1146,
      -1,  1035,    -1,  1147,    -1,  1147,    -1,    22,  1147,    -1,
      22,  1003,    -1,    72,    -1,    87,    -1,    83,    -1,    81,
      -1,    82,    -1,    76,    -1,    77,    -1,    78,    -1,    75,
      -1,    84,    -1,    80,    -1,    71,    -1,    79,    -1,  1003,
      -1,  1035,    -1,  1160,    -1,   502,   503,    -1,   502,  1156,
     503,    -1,  1155,    -1,  1156,  1155,    -1,  1158,    -1,  1157,
     505,  1158,    -1,  1156,    -1,   508,  1157,   509,    -1,  1160,
      -1,   502,    -1,   503,    -1,   505,    -1,   506,    -1,  1153,
      -1,  1011,    -1,  1150,    -1,  1151,    -1,   495,    -1,   493,
      -1,   494,    -1,   496,    -1,   497,    -1,   319,    -1,    47,
      -1,    48,    -1,    49,    -1,    50,    -1,    51,    -1,    52,
      -1,    53,    -1,    54,    -1,    55,    -1,    56,    -1,    57,
      -1,    58,    -1,    60,    -1,    59,    -1,    61,    -1,    62,
      -1,    63,    -1,    64,    -1,    65,    -1,    66,    -1,    67,
      -1,    68,    -1,    70,    -1,    69,    -1,     5,    -1,   205,
      -1,   240,    -1,   262,    -1,    25,    -1,   295,    -1,   298,
      -1,   390,    -1,    35,    -1,    36,    -1,    43,    -1,    44,
      -1,   483,    -1,   133,    -1,   220,    -1,   432,    -1,   445,
      -1,   458,    -1,   500,    -1,   501,    -1,   489,    -1,   507,
      -1,   177,  1039,    -1,   177,   352,  1039,    -1,   177,    99,
      -1,   177,   352,    99,    -1,  1011,    -1,   502,  1162,   503,
      -1,  1162,   493,  1162,    -1,  1162,   494,  1162,    -1,  1162,
     495,  1162,    -1,  1162,   496,  1162,    -1,  1162,   497,  1162,
      -1,  1151,    -1,  1131,    -1,    -1,  1088,  1164,    -1,  1164,
    1088,    -1,  1088,    -1,  1164,    -1,   266,  1139,    -1,  1090,
      -1,  1164,    -1,  1089,    -1,    -1,  1165,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1340,  1340,  1343,  1345,  1347,  1349,  1351,  1353,  1355,
    1357,  1359,  1361,  1363,  1365,  1367,  1369,  1371,  1373,  1375,
    1377,  1379,  1381,  1383,  1385,  1403,  1405,  1407,  1409,  1411,
    1413,  1415,  1417,  1419,  1421,  1423,  1425,  1427,  1429,  1431,
    1433,  1435,  1437,  1439,  1441,  1443,  1445,  1447,  1449,  1451,
    1453,  1455,  1459,  1461,  1463,  1465,  1467,  1469,  1471,  1473,
    1475,  1477,  1479,  1481,  1483,  1485,  1487,  1489,  1491,  1493,
    1495,  1497,  1499,  1501,  1503,  1505,  1507,  1509,  1511,  1513,
    1515,  1517,  1519,  1521,  1523,  1525,  1532,  1534,  1536,  1538,
    1540,  1542,  1544,  1546,  1548,  1550,  1552,  1558,  1560,  1562,
    1564,  1566,  1568,  1570,  1572,  1574,  1580,  1590,  1594,  1600,
    1604,  1614,  1624,  1625,  1639,  1646,  1652,  1663,  1669,  1678,
    1685,  1691,  1700,  1707,  1715,  1720,  1728,  1733,  1739,  1744,
    1750,  1755,  1761,  1765,  1769,  1773,  1777,  1781,  1785,  1789,
    1793,  1797,  1801,  1805,  1809,  1813,  1817,  1821,  1825,  1829,
    1833,  1841,  1845,  1849,  1853,  1857,  1861,  1869,  1877,  1886,
    1888,  1896,  1904,  1912,  1920,  1924,  1932,  1936,  1944,  1952,
    1960,  1964,  1972,  1976,  1984,  1988,  1996,  2001,  2007,  2012,
    2018,  2022,  2026,  2030,  2034,  2038,  2046,  2050,  2054,  2062,
    2066,  2070,  2074,  2078,  2082,  2086,  2090,  2094,  2099,  2103,
    2107,  2111,  2115,  2119,  2127,  2131,  2139,  2143,  2151,  2155,
    2169,  2173,  2177,  2181,  2189,  2193,  2197,  2201,  2209,  2213,
    2217,  2221,  2225,  2229,  2233,  2241,  2245,  2250,  2256,  2260,
    2268,  2272,  2276,  2280,  2284,  2292,  2296,  2304,  2308,  2312,
    2316,  2320,  2329,  2337,  2341,  2349,  2353,  2361,  2369,  2373,
    2377,  2381,  2389,  2393,  2397,  2401,  2409,  2413,  2421,  2425,
    2429,  2433,  2437,  2441,  2445,  2449,  2453,  2457,  2461,  2465,
    2469,  2473,  2477,  2481,  2485,  2489,  2493,  2497,  2501,  2505,
    2509,  2513,  2517,  2521,  2525,  2529,  2533,  2537,  2541,  2545,
    2549,  2553,  2557,  2561,  2565,  2573,  2577,  2585,  2589,  2594,
    2600,  2605,  2611,  2619,  2624,  2630,  2634,  2642,  2646,  2650,
    2654,  2662,  2667,  2675,  2686,  2697,  2701,  2709,  2713,  2717,
    2725,  2729,  2737,  2742,  2748,  2752,  2756,  2760,  2764,  2768,
    2772,  2776,  2780,  2784,  2788,  2796,  2801,  2807,  2812,  2818,
    2823,  2829,  2834,  2840,  2844,  2852,  2860,  2864,  2868,  2872,
    2877,  2883,  2887,  2895,  2903,  2907,  2915,  2919,  2923,  2927,
    2931,  2935,  2940,  2946,  2951,  2957,  2962,  2968,  2972,  2980,
    2984,  2992,  2996,  3000,  3008,  3012,  3020,  3028,  3036,  3041,
    3047,  3051,  3055,  3063,  3067,  3071,  3075,  3079,  3083,  3087,
    3095,  3099,  3103,  3107,  3115,  3123,  3127,  3132,  3138,  3142,
    3146,  3150,  3154,  3158,  3166,  3170,  3178,  3183,  3187,  3191,
    3195,  3203,  3208,  3214,  3218,  3226,  3234,  3238,  3243,  3248,
    3254,  3258,  3266,  3270,  3278,  3283,  3289,  3293,  3297,  3301,
    3306,  3312,  3320,  3328,  3332,  3336,  3340,  3344,  3352,  3357,
    3363,  3367,  3371,  3376,  3382,  3386,  3390,  3395,  3401,  3406,
    3412,  3417,  3423,  3431,  3436,  3442,  3446,  3454,  3462,  3466,
    3471,  3477,  3485,  3493,  3498,  3504,  3508,  3516,  3520,  3524,
    3528,  3532,  3536,  3540,  3544,  3548,  3552,  3556,  3560,  3568,
    3573,  3579,  3583,  3587,  3595,  3599,  3607,  3611,  3619,  3624,
    3630,  3634,  3642,  3647,  3653,  3657,  3665,  3670,  3676,  3680,
    3688,  3693,  3699,  3707,  3712,  3718,  3722,  3730,  3738,  3742,
    3750,  3754,  3758,  3766,  3771,  3777,  3781,  3789,  3797,  3801,
    3809,  3813,  3817,  3821,  3829,  3837,  3845,  3853,  3861,  3866,
    3872,  3876,  3884,  3889,  3895,  3899,  3907,  3911,  3915,  3923,
    3931,  3935,  3939,  3947,  3951,  3959,  3967,  3971,  3979,  3983,
    3991,  3995,  4003,  4007,  4011,  4015,  4019,  4027,  4032,  4038,
    4043,  4049,  4053,  4061,  4066,  4072,  4076,  4081,  4087,  4091,
    4095,  4099,  4103,  4107,  4115,  4120,  4126,  4130,  4137,  4141,
    4149,  4155,  4159,  4167,  4171,  4179,  4183,  4191,  4200,  4209,
    4213,  4217,  4221,  4225,  4229,  4233,  4237,  4241,  4245,  4249,
    4257,  4265,  4269,  4277,  4281,  4289,  4293,  4297,  4301,  4305,
    4313,  4317,  4325,  4333,  4337,  4345,  4353,  4358,  4364,  4368,
    4376,  4384,  4388,  4396,  4400,  4404,  4408,  4412,  4420,  4425,
    4431,  4436,  4442,  4448,  4454,  4462,  4466,  4474,  4478,  4486,
    4490,  4498,  4502,  4510,  4514,  4522,  4530,  4538,  4542,  4550,
    4554,  4558,  4562,  4566,  4570,  4574,  4578,  4582,  4586,  4590,
    4594,  4602,  4606,  4614,  4618,  4626,  4630,  4638,  4646,  4650,
    4655,  4661,  4665,  4669,  4673,  4677,  4681,  4685,  4689,  4693,
    4697,  4701,  4705,  4709,  4713,  4717,  4721,  4725,  4733,  4737,
    4741,  4745,  4749,  4753,  4757,  4761,  4765,  4769,  4773,  4777,
    4785,  4789,  4797,  4801,  4805,  4809,  4815,  4821,  4827,  4833,
    4839,  4845,  4851,  4861,  4872,  4883,  4894,  4905,  4916,  4927,
    4943,  4959,  4975,  4986,  5002,  5013,  5029,  5044,  5048,  5056,
    5061,  5067,  5075,  5079,  5087,  5091,  5095,  5099,  5103,  5111,
    5115,  5123,  5127,  5131,  5135,  5143,  5147,  5151,  5155,  5159,
    5163,  5167,  5171,  5175,  5179,  5183,  5187,  5191,  5195,  5203,
    5207,  5215,  5219,  5227,  5232,  5238,  5242,  5250,  5258,  5266,
    5270,  5278,  5283,  5289,  5294,  5300,  5308,  5313,  5319,  5323,
    5327,  5335,  5339,  5343,  5351,  5355,  5359,  5367,  5375,  5380,
    5386,  5391,  5397,  5402,  5408,  5413,  5419,  5423,  5431,  5435,
    5439,  5447,  5451,  5456,  5462,  5466,  5471,  5477,  5481,  5486,
    5492,  5496,  5500,  5508,  5513,  5519,  5523,  5531,  5535,  5543,
    5547,  5555,  5559,  5567,  5571,  5575,  5579,  5583,  5591,  5595,
    5599,  5603,  5607,  5615,  5623,  5631,  5635,  5639,  5647,  5651,
    5655,  5663,  5667,  5675,  5679,  5683,  5687,  5691,  5695,  5699,
    5703,  5707,  5711,  5715,  5719,  5723,  5731,  5735,  5739,  5743,
    5751,  5755,  5763,  5768,  5774,  5782,  5786,  5794,  5802,  5806,
    5814,  5819,  5825,  5829,  5837,  5841,  5849,  5853,  5861,  5865,
    5869,  5873,  5881,  5885,  5893,  5901,  5905,  5913,  5917,  5925,
    5929,  5933,  5941,  5945,  5950,  5956,  5964,  5969,  5975,  5979,
    5983,  5991,  5995,  6003,  6008,  6014,  6018,  6022,  6026,  6030,
    6034,  6038,  6042,  6046,  6050,  6054,  6058,  6062,  6066,  6070,
    6074,  6078,  6082,  6086,  6090,  6094,  6098,  6102,  6106,  6110,
    6118,  6123,  6129,  6134,  6140,  6144,  6148,  6152,  6156,  6160,
    6164,  6172,  6176,  6180,  6184,  6188,  6192,  6196,  6200,  6204,
    6208,  6212,  6216,  6220,  6224,  6228,  6232,  6236,  6244,  6252,
    6256,  6260,  6268,  6272,  6280,  6284,  6288,  6292,  6296,  6304,
    6309,  6315,  6319,  6323,  6327,  6335,  6339,  6344,  6350,  6354,
    6362,  6370,  6375,  6381,  6389,  6393,  6401,  6405,  6409,  6413,
    6417,  6421,  6425,  6429,  6433,  6437,  6441,  6445,  6449,  6453,
    6461,  6465,  6470,  6476,  6480,  6484,  6492,  6496,  6500,  6508,
    6513,  6519,  6523,  6531,  6536,  6541,  6547,  6553,  6561,  6569,
    6574,  6580,  6584,  6588,  6592,  6596,  6600,  6604,  6608,  6612,
    6616,  6620,  6624,  6628,  6632,  6636,  6640,  6648,  6653,  6659,
    6663,  6671,  6679,  6684,  6690,  6698,  6702,  6710,  6718,  6722,
    6726,  6730,  6734,  6742,  6747,  6753,  6761,  6765,  6769,  6773,
    6777,  6781,  6789,  6797,  6801,  6805,  6813,  6818,  6824,  6828,
    6832,  6836,  6840,  6848,  6852,  6860,  6864,  6868,  6872,  6880,
    6884,  6892,  6896,  6904,  6909,  6915,  6920,  6926,  6931,  6937,
    6942,  6948,  6952,  6956,  6960,  6968,  6972,  6976,  6980,  6984,
    6988,  6992,  7000,  7004,  7012,  7020,  7024,  7028,  7036,  7040,
    7045,  7051,  7057,  7067,  7072,  7078,  7082,  7086,  7090,  7098,
    7100,  7108,  7113,  7119,  7127,  7131,  7135,  7143,  7147,  7155,
    7163,  7168,  7174,  7182,  7187,  7193,  7201,  7206,  7212,  7216,
    7220,  7224,  7228,  7232,  7236,  7240,  7248,  7253,  7259,  7267,
    7271,  7279,  7283,  7291,  7299,  7307,  7315,  7319,  7327,  7379,
    7383,  7396,  7398,  7402,  7406,  7410,  7419,  7425,  7429,  7437,
    7441,  7449,  7453,  7461,  7465,  7469,  7473,  7477,  7481,  7485,
    7489,  7497,  7501,  7509,  7513,  7517,  7521,  7525,  7529,  7537,
    7541,  7549,  7553,  7561,  7569,  7574,  7576,  7582,  7586,  7590,
    7594,  7598,  7602,  7606,  7610,  7618,  7623,  7629,  7633,  7638,
    7644,  7648,  7652,  7657,  7663,  7668,  7674,  7682,  7686,  7694,
    7698,  7706,  7710,  7714,  7718,  7726,  7731,  7737,  7741,  7746,
    7754,  7758,  7766,  7770,  7778,  7786,  7790,  7795,  7801,  7809,
    7813,  7821,  7825,  7833,  7838,  7844,  7849,  7855,  7859,  7867,
    7872,  7878,  7882,  7890,  7894,  7902,  7907,  7913,  7917,  7925,
    7930,  7936,  7940,  7948,  7952,  7956,  7960,  7964,  7968,  7972,
    7976,  7982,  7986,  7990,  7998,  8002,  8006,  8010,  8014,  8018,
    8026,  8030,  8034,  8038,  8046,  8050,  8054,  8058,  8066,  8071,
    8077,  8081,  8089,  8093,  8097,  8101,  8109,  8113,  8121,  8125,
    8129,  8137,  8145,  8150,  8156,  8160,  8165,  8171,  8175,  8183,
    8191,  8193,  8195,  8199,  8203,  8207,  8215,  8225,  8236,  8245,
    8249,  8253,  8257,  8261,  8265,  8269,  8277,  8281,  8285,  8289,
    8297,  8301,  8309,  8314,  8320,  8324,  8328,  8332,  8336,  8340,
    8344,  8348,  8352,  8356,  8360,  8368,  8373,  8379,  8383,  8391,
    8395,  8403,  8411,  8419,  8423,  8431,  8435,  8443,  8451,  8459,
    8463,  8467,  8471,  8475,  8479,  8487,  8492,  8498,  8503,  8509,
    8513,  8517,  8521,  8529,  8537,  8541,  8546,  8552,  8556,  8560,
    8564,  8568,  8572,  8576,  8580,  8584,  8588,  8592,  8596,  8600,
    8605,  8611,  8615,  8623,  8627,  8631,  8635,  8639,  8643,  8647,
    8651,  8655,  8659,  8663,  8667,  8671,  8675,  8679,  8683,  8687,
    8691,  8695,  8699,  8703,  8707,  8711,  8715,  8719,  8723,  8727,
    8731,  8735,  8739,  8743,  8747,  8751,  8755,  8759,  8763,  8767,
    8771,  8775,  8779,  8783,  8787,  8791,  8795,  8799,  8803,  8807,
    8811,  8815,  8819,  8823,  8827,  8831,  8835,  8839,  8843,  8848,
    8852,  8860,  8864,  8868,  8872,  8876,  8880,  8884,  8888,  8892,
    8896,  8900,  8904,  8908,  8912,  8916,  8920,  8924,  8928,  8932,
    8936,  8940,  8944,  8952,  8956,  8960,  8964,  8968,  8972,  8976,
    8980,  8984,  8988,  8992,  8996,  9004,  9008,  9012,  9016,  9020,
    9024,  9028,  9032,  9036,  9040,  9044,  9048,  9052,  9056,  9060,
    9064,  9068,  9072,  9076,  9080,  9084,  9088,  9092,  9096,  9100,
    9104,  9108,  9112,  9116,  9120,  9124,  9128,  9132,  9136,  9140,
    9144,  9148,  9152,  9156,  9160,  9164,  9168,  9172,  9176,  9180,
    9184,  9188,  9192,  9200,  9204,  9212,  9216,  9220,  9225,  9231,
    9239,  9243,  9251,  9255,  9263,  9267,  9275,  9279,  9284,  9290,
    9295,  9301,  9305,  9313,  9321,  9325,  9330,  9336,  9344,  9348,
    9355,  9360,  9366,  9371,  9376,  9382,  9386,  9394,  9398,  9402,
    9406,  9410,  9418,  9422,  9426,  9434,  9438,  9442,  9450,  9454,
    9462,  9466,  9470,  9474,  9478,  9482,  9486,  9490,  9494,  9502,
    9506,  9514,  9518,  9526,  9530,  9534,  9538,  9542,  9546,  9554,
    9558,  9566,  9570,  9578,  9582,  9590,  9594,  9602,  9606,  9610,
    9618,  9622,  9630,  9635,  9641,  9645,  9649,  9653,  9657,  9661,
    9665,  9669,  9677,  9681,  9689,  9697,  9702,  9708,  9712,  9716,
    9720,  9724,  9729,  9735,  9743,  9751,  9755,  9759,  9767,  9771,
    9779,  9787,  9791,  9799,  9807,  9812,  9818,  9823,  9829,  9833,
    9841,  9845,  9849,  9853,  9861,  9865,  9874,  9876,  9884,  9889,
    9895,  9899,  9907,  9911,  9919,  9927,  9931,  9939,  9943,  9947,
    9951,  9959,  9963,  9971,  9975,  9983,  9987,  9995, 10003, 10011,
   10019, 10027, 10035, 10043, 10047, 10055, 10059, 10063, 10067, 10071,
   10075, 10079, 10083, 10087, 10091, 10095, 10099, 10103, 10107, 10108,
   10113, 10119, 10127, 10131, 10132, 10136, 10144, 10148, 10152, 10156,
   10160, 10164, 10168, 10172, 10176, 10180, 10184, 10188, 10192, 10196,
   10200, 10204, 10208, 10212, 10216, 10220, 10224, 10228, 10232, 10236,
   10240, 10244, 10248, 10252, 10256, 10260, 10264, 10268, 10272, 10276,
   10280, 10284, 10288, 10292, 10296, 10300, 10304, 10308, 10312, 10316,
   10320, 10324, 10328, 10332, 10336, 10340, 10344, 10348, 10352, 10356,
   10360, 10364, 10368, 10372, 10376, 10380, 10384, 10388, 10392, 10396,
   10400, 10404, 10408, 10412, 10416, 10420, 10424, 10428, 10432, 10436,
   10440, 10444, 10448, 10452, 10456, 10460, 10464, 10468, 10472, 10476,
   10480, 10484, 10488, 10492, 10496, 10500, 10504, 10508, 10512, 10516,
   10520, 10524, 10528, 10532, 10536, 10540, 10544, 10548, 10552, 10556,
   10560, 10564, 10568, 10572, 10576, 10580, 10584, 10588, 10592, 10596,
   10600, 10604, 10608, 10612, 10616, 10620, 10624, 10628, 10632, 10636,
   10640, 10644, 10648, 10652, 10656, 10660, 10664, 10668, 10672, 10676,
   10680, 10684, 10688, 10692, 10696, 10700, 10704, 10708, 10712, 10716,
   10720, 10724, 10728, 10732, 10736, 10740, 10744, 10748, 10752, 10756,
   10760, 10764, 10768, 10772, 10776, 10780, 10784, 10788, 10792, 10796,
   10800, 10804, 10808, 10812, 10816, 10820, 10824, 10828, 10832, 10836,
   10840, 10844, 10848, 10852, 10856, 10860, 10864, 10868, 10872, 10876,
   10880, 10884, 10888, 10892, 10896, 10900, 10904, 10908, 10912, 10916,
   10920, 10924, 10928, 10932, 10936, 10940, 10944, 10948, 10952, 10956,
   10960, 10964, 10968, 10972, 10976, 10980, 10984, 10988, 10992, 10996,
   11000, 11004, 11008, 11012, 11016, 11020, 11024, 11028, 11032, 11036,
   11040, 11044, 11048, 11052, 11056, 11060, 11064, 11068, 11072, 11076,
   11080, 11084, 11088, 11092, 11096, 11100, 11104, 11108, 11116, 11120,
   11124, 11128, 11132, 11136, 11140, 11144, 11148, 11152, 11156, 11160,
   11164, 11168, 11172, 11176, 11180, 11184, 11188, 11192, 11196, 11200,
   11204, 11208, 11212, 11216, 11220, 11224, 11228, 11232, 11236, 11240,
   11244, 11248, 11252, 11256, 11260, 11264, 11268, 11272, 11276, 11280,
   11284, 11292, 11296, 11300, 11304, 11308, 11312, 11316, 11320, 11324,
   11328, 11332, 11336, 11340, 11344, 11348, 11352, 11356, 11360, 11364,
   11368, 11372, 11376, 11384, 11388, 11392, 11396, 11400, 11404, 11408,
   11412, 11416, 11420, 11424, 11428, 11432, 11436, 11440, 11444, 11448,
   11452, 11456, 11460, 11464, 11468, 11472, 11476, 11480, 11484, 11488,
   11492, 11496, 11500, 11504, 11508, 11512, 11516, 11520, 11524, 11528,
   11532, 11536, 11540, 11544, 11548, 11552, 11556, 11560, 11564, 11568,
   11572, 11576, 11580, 11584, 11588, 11592, 11596, 11600, 11604, 11608,
   11612, 11616, 11620, 11624, 11628, 11632, 11636, 11640, 11644, 11648,
   11652, 11656, 11660, 11664, 11668, 11672, 11676, 11686, 11687, 11690,
   11691, 11692, 11698, 11699, 11700, 11701, 11702, 11715, 11715, 11724,
   11740, 11742, 11745, 11747, 11751, 11763, 11779, 11783, 11794, 11795,
   11798, 11810, 11819, 11820, 11823, 11824, 11825, 11828, 11829, 11832,
   11833, 11836, 11837, 11840, 11842, 11844, 11846, 11850, 11857, 11864,
   11880, 11914, 11924, 11927, 11929, 11942, 11943, 11945, 11947, 11951,
   11964, 11971, 12031, 12040, 12042, 12043, 12046, 12048, 12049, 12052,
   12053, 12054, 12055, 12056, 12063, 12062, 12072, 12074, 12076, 12077,
   12080, 12081, 12082, 12083, 12086, 12087, 12091, 12090, 12107, 12105,
   12121, 12120, 12134, 12140, 12141, 12144, 12146, 12147, 12150, 12151,
   12152, 12153, 12156, 12157, 12160, 12168, 12185, 12193, 12216, 12322,
   12356, 12358, 12360, 12364, 12368, 12367, 12418, 12420, 12419, 12434,
   12440, 12447, 12452, 12455, 12456, 12459, 12460, 12461, 12462, 12463,
   12464, 12465, 12473, 12481, 12484, 12485, 12486, 12487, 12488, 12489,
   12497, 12505, 12506, 12507, 12510, 12511, 12514, 12516, 12520, 12608,
   12609, 12616, 12617, 12618, 12624, 12633, 12636, 12637, 12638, 12639,
   12642, 12643, 12644, 12647, 12649, 12657, 12658, 12664, 12672, 12673,
   12676, 12677, 12680, 12685, 12692, 12697, 12704, 12711, 12711, 12713,
   12720, 12721, 12724, 12725, 12726, 12727, 12728, 12729, 12730, 12731,
   12732, 12738, 12745, 12757, 12763, 12770, 12778, 12779, 12791, 12802,
   12813, 12817, 12818, 12821, 12826, 12830, 12831, 12834, 12840, 12848,
   12851, 12858, 12862, 12863, 12866, 12869, 12873, 12874, 12877, 12883,
   12891, 12892, 12901, 12910, 12922, 12923, 12924, 12925, 12926, 12927,
   12928, 12929, 12930, 12931, 12932, 12933, 12934, 12935, 12936, 12943,
   12944, 12947, 12948, 12955, 12956, 12957, 12964, 12963, 12980, 12981,
   12988, 12987, 13057, 13063, 13069, 13077, 13083, 13089, 13095, 13101,
   13107, 13113, 13119, 13125, 13136, 13137, 13140, 13141, 13142, 13143,
   13144, 13145, 13146, 13147, 13148, 13149, 13150, 13151, 13152, 13153,
   13154, 13155, 13156, 13157, 13158, 13159, 13160, 13161, 13162, 13163,
   13166, 13167, 13168, 13169, 13170, 13171, 13175, 13176, 13177, 13178,
   13179, 13180, 13181, 13184, 13187, 13188, 13189, 13190, 13191, 13192,
   13193, 13194, 13207, 13208, 13209, 13210, 13211, 13212, 13213, 13218,
   13219, 13220, 13221, 13222, 13223, 13229, 13230, 13231, 13232, 13233,
   13234, 13235, 13236, 13237, 13238, 13239, 13242, 13243, 13244, 13245,
   13246, 13249, 13250, 13251, 13252, 13255, 13256, 13257, 13258, 13259,
   13260, 13261, 13278, 13279, 13280, 13283, 13284, 13285, 13286, 13287,
   13288, 13292, 13292, 13295, 13301, 13302, 13305, 13307, 13312, 13322,
   13333, 13340, 13341, 13342, 13345, 13378, 13380, 13382, 13385, 13395,
   13405, 13415, 13416, 13419, 13421, 13422, 13423, 13426, 13428, 13436,
   13437, 13438, 13442, 13443, 13447, 13448, 13451, 13452, 13455, 13456,
   13457, 13458, 13459, 13462, 13463, 13464, 13465, 13466, 13467, 13468,
   13469, 13470, 13471, 13472, 13473, 13474, 13475, 13476, 13477, 13478,
   13479, 13480, 13481, 13482, 13483, 13484, 13485, 13486, 13487, 13488,
   13489, 13490, 13491, 13492, 13493, 13494, 13495, 13496, 13497, 13498,
   13499, 13500, 13501, 13502, 13503, 13504, 13505, 13506, 13507, 13508,
   13509, 13510, 13511, 13512, 13513, 13514, 13515, 13516, 13517, 13520,
   13521, 13522, 13523, 13526, 13527, 13528, 13529, 13530, 13531, 13532,
   13533, 13534, 13537, 13538, 13539, 13540, 13541, 13544, 13545, 13548,
   13549, 13560, 13561
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SQL_ALLOCATE", "SQL_AUTOCOMMIT",
  "SQL_BOOL", "SQL_BREAK", "SQL_CALL", "SQL_CARDINALITY", "SQL_CONNECT",
  "SQL_COUNT", "SQL_DATETIME_INTERVAL_CODE",
  "SQL_DATETIME_INTERVAL_PRECISION", "SQL_DESCRIBE", "SQL_DESCRIPTOR",
  "SQL_DISCONNECT", "SQL_FOUND", "SQL_FREE", "SQL_GET", "SQL_GO",
  "SQL_GOTO", "SQL_IDENTIFIED", "SQL_INDICATOR", "SQL_KEY_MEMBER",
  "SQL_LENGTH", "SQL_LONG", "SQL_NULLABLE", "SQL_OCTET_LENGTH", "SQL_OPEN",
  "SQL_OUTPUT", "SQL_REFERENCE", "SQL_RETURNED_LENGTH",
  "SQL_RETURNED_OCTET_LENGTH", "SQL_SCALE", "SQL_SECTION", "SQL_SHORT",
  "SQL_SIGNED", "SQL_SQL", "SQL_SQLERROR", "SQL_SQLPRINT",
  "SQL_SQLWARNING", "SQL_START", "SQL_STOP", "SQL_STRUCT", "SQL_UNSIGNED",
  "SQL_VAR", "SQL_WHENEVER", "S_ADD", "S_AND", "S_ANYTHING", "S_AUTO",
  "S_CONST", "S_DEC", "S_DIV", "S_DOTPOINT", "S_EQUAL", "S_EXTERN",
  "S_INC", "S_LSHIFT", "S_MEMPOINT", "S_MEMBER", "S_MOD", "S_MUL",
  "S_NEQUAL", "S_OR", "S_REGISTER", "S_RSHIFT", "S_STATIC", "S_SUB",
  "S_VOLATILE", "S_TYPEDEF", "CSTRING", "CVARIABLE", "CPP_LINE", "IP",
  "DOLCONST", "ECONST", "NCONST", "UCONST", "UIDENT", "IDENT", "FCONST",
  "SCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION",
  "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS",
  "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "AUTHORIZATION", "BACKWARD", "BEFORE",
  "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH",
  "BY", "CACHE", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLUMN", "COMMENT", "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY",
  "CONFIGURATION", "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P",
  "CONTINUE_P", "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB",
  "CREATEROLE", "CREATEUSER", "CROSS", "CSV", "CURRENT_P",
  "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA",
  "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE",
  "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P",
  "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER",
  "DELETE_P", "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P",
  "DISCARD", "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P",
  "DROP", "EACH", "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P",
  "ENUM_P", "ESCAPE", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE",
  "EXECUTE", "EXISTS", "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE",
  "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS",
  "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING",
  "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSWORD", "PLACING", "PLANS",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "','", "';'", "':'", "'{'", "'}'", "$accept",
  "prog", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem", "ClosePortalStmt",
  "CopyStmt", "copy_from", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace",
  "create_as_target", "OptCreateAs", "CreateAsList", "CreateAsElement",
  "opt_with_data", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "RoleId", "SignedIconst", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "statements", "statement", "CreateAsStmt", "$@1", "at", "ECPGConnect",
  "connection_target", "opt_database_name", "db_prefix", "server",
  "opt_server", "server_name", "opt_port", "opt_connection_name",
  "opt_user", "ora_user", "user_name", "char_variable", "opt_options",
  "connect_options", "opt_opt_value", "prepared_name", "ECPGCursorStmt",
  "ECPGExecuteImmediateStmt", "ECPGVarDeclaration",
  "single_vt_declaration", "precision", "opt_scale", "ecpg_interval",
  "ECPGDeclaration", "$@2", "sql_startdeclare", "sql_enddeclare",
  "var_type_declarations", "vt_declarations", "variable_declarations",
  "type_declaration", "$@3", "var_declaration", "$@4", "$@5",
  "opt_bit_field", "storage_declaration", "storage_clause",
  "storage_modifier", "var_type", "enum_type", "enum_definition",
  "struct_union_type_with_symbol", "$@6", "struct_union_type", "$@7",
  "s_struct_union_symbol", "s_struct_union", "simple_type",
  "unsigned_type", "signed_type", "opt_signed", "variable_list",
  "variable", "opt_initializer", "opt_pointer", "ECPGDeclare",
  "ECPGDisconnect", "dis_name", "connection_object", "execstring",
  "ECPGFree", "ECPGOpen", "opt_ecpg_using", "ecpg_using",
  "using_descriptor", "into_descriptor", "into_sqlda", "using_list",
  "UsingValue", "UsingConst", "ECPGDescribe", "opt_output",
  "ECPGAllocateDescr", "ECPGDeallocateDescr", "ECPGGetDescriptorHeader",
  "ECPGGetDescHeaderItems", "ECPGGetDescHeaderItem",
  "ECPGSetDescriptorHeader", "ECPGSetDescHeaderItems",
  "ECPGSetDescHeaderItem", "IntConstVar", "desc_header_item",
  "ECPGGetDescriptor", "ECPGGetDescItems", "ECPGGetDescItem",
  "ECPGSetDescriptor", "ECPGSetDescItems", "ECPGSetDescItem",
  "AllConstVar", "descriptor_item", "ECPGSetAutocommit", "on_off",
  "ECPGSetConnection", "ECPGTypedef", "$@8", "opt_reference", "ECPGVar",
  "$@9", "ECPGWhenever", "action", "ECPGKeywords", "ECPGKeywords_vanames",
  "ECPGKeywords_rest", "ECPGTypeName", "symbol", "ECPGColId", "ColId",
  "type_function_name", "ColLabel", "ECPGColLabel", "ECPGColLabelCommon",
  "ECPGCKeywords", "all_unreserved_keyword", "ECPGunreserved_interval",
  "into_list", "ecpgstart", "c_args", "coutputvariable", "civarind",
  "char_civar", "civar", "indicator", "cvariable", "ecpg_param",
  "ecpg_bconst", "ecpg_fconst", "ecpg_sconst", "ecpg_xconst", "ecpg_ident",
  "quoted_ident_stringvar", "c_stuff_item", "c_stuff", "c_list", "c_term",
  "c_thing", "c_anything", "DeallocateStmt", "Iresult", "execute_rest",
  "ecpg_into", "ecpg_fetch_into", "opt_ecpg_fetch_into", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,    61,
      60,    62,   744,    43,    45,    42,    47,    37,    94,   745,
      91,    93,    40,    41,    46,    44,    59,    58,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   510,   511,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   512,   512,   512,   512,   512,
     512,   512,   512,   512,   512,   513,   514,   514,   515,   515,
     516,   516,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   517,
     517,   518,   518,   518,   518,   518,   518,   519,   520,   521,
     521,   522,   523,   524,   525,   525,   526,   526,   527,   528,
     529,   529,   530,   530,   531,   531,   532,   532,   533,   533,
     534,   534,   534,   534,   534,   534,   535,   535,   535,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     536,   536,   536,   536,   537,   537,   538,   538,   539,   539,
     540,   540,   540,   540,   541,   541,   541,   541,   542,   542,
     542,   542,   542,   542,   542,   543,   543,   543,   544,   544,
     545,   545,   545,   545,   545,   546,   546,   547,   547,   547,
     547,   547,   548,   549,   549,   550,   550,   551,   552,   552,
     552,   552,   553,   553,   553,   553,   554,   554,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   556,   556,   557,   557,   557,
     558,   558,   559,   560,   560,   561,   561,   562,   562,   562,
     562,   563,   563,   564,   564,   565,   565,   566,   566,   566,
     567,   567,   568,   568,   569,   569,   569,   569,   569,   569,
     569,   569,   569,   569,   569,   570,   570,   571,   571,   572,
     572,   573,   573,   574,   574,   575,   576,   576,   576,   576,
     576,   577,   577,   578,   579,   579,   580,   580,   580,   580,
     580,   580,   580,   581,   581,   582,   582,   583,   583,   584,
     584,   585,   585,   585,   586,   586,   587,   588,   589,   589,
     590,   590,   590,   591,   591,   591,   591,   591,   591,   591,
     592,   592,   592,   592,   593,   594,   594,   594,   595,   595,
     595,   595,   595,   595,   596,   596,   597,   597,   597,   597,
     597,   598,   598,   599,   599,   600,   601,   601,   601,   601,
     602,   602,   603,   603,   604,   604,   605,   605,   605,   605,
     605,   606,   607,   608,   608,   608,   608,   608,   609,   609,
     610,   610,   610,   610,   611,   611,   611,   611,   612,   612,
     613,   613,   614,   615,   615,   616,   616,   617,   618,   618,
     618,   619,   620,   621,   621,   622,   622,   623,   623,   623,
     623,   623,   623,   623,   623,   623,   623,   623,   623,   624,
     624,   625,   625,   625,   626,   626,   627,   627,   628,   628,
     629,   629,   630,   630,   631,   631,   632,   632,   633,   633,
     634,   634,   635,   636,   636,   637,   637,   638,   639,   639,
     640,   640,   640,   641,   641,   642,   642,   643,   644,   644,
     645,   645,   645,   645,   646,   647,   648,   649,   650,   650,
     651,   651,   652,   652,   653,   653,   654,   654,   654,   655,
     656,   656,   656,   657,   657,   658,   659,   659,   660,   660,
     661,   661,   662,   662,   662,   662,   662,   663,   663,   664,
     664,   665,   665,   666,   666,   667,   667,   667,   668,   668,
     668,   668,   668,   668,   669,   669,   670,   670,   670,   670,
     670,   671,   671,   672,   672,   673,   673,   674,   675,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     677,   678,   678,   679,   679,   680,   680,   680,   680,   680,
     681,   681,   682,   683,   683,   684,   685,   685,   686,   686,
     687,   688,   688,   689,   689,   689,   689,   689,   690,   690,
     691,   691,   692,   692,   693,   694,   694,   695,   695,   696,
     696,   697,   697,   698,   698,   699,   700,   701,   701,   702,
     702,   702,   702,   702,   702,   702,   702,   702,   702,   702,
     702,   703,   703,   704,   704,   705,   705,   706,   707,   707,
     707,   708,   708,   708,   708,   708,   708,   708,   708,   708,
     708,   708,   708,   708,   708,   708,   708,   708,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   709,   709,   709,
     710,   710,   711,   711,   711,   711,   711,   711,   711,   711,
     711,   711,   711,   712,   712,   712,   712,   712,   712,   712,
     712,   712,   712,   712,   712,   712,   712,   713,   713,   714,
     714,   715,   716,   716,   717,   717,   717,   717,   717,   718,
     718,   719,   719,   719,   719,   720,   720,   720,   720,   720,
     720,   720,   720,   720,   720,   720,   720,   720,   720,   721,
     721,   722,   722,   723,   723,   724,   724,   725,   726,   727,
     727,   728,   728,   729,   729,   730,   731,   731,   732,   732,
     732,   733,   733,   733,   734,   734,   734,   735,   736,   736,
     737,   737,   738,   738,   739,   739,   740,   740,   741,   741,
     741,   742,   742,   742,   743,   743,   743,   744,   744,   744,
     745,   745,   745,   746,   746,   747,   747,   748,   748,   749,
     749,   750,   750,   751,   751,   751,   751,   751,   752,   752,
     752,   752,   752,   753,   754,   755,   755,   755,   756,   756,
     756,   757,   757,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   758,   758,   758,   758,   759,   759,   759,   759,
     760,   760,   761,   761,   762,   763,   763,   764,   765,   765,
     766,   766,   767,   767,   768,   768,   769,   769,   770,   770,
     770,   770,   771,   771,   772,   773,   773,   774,   774,   775,
     775,   775,   776,   776,   776,   777,   778,   778,   779,   779,
     779,   780,   780,   781,   781,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     783,   783,   784,   784,   785,   785,   785,   785,   785,   785,
     785,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   786,   786,   787,   788,
     788,   788,   789,   789,   790,   790,   790,   790,   790,   791,
     791,   792,   792,   792,   792,   793,   793,   793,   794,   794,
     795,   796,   796,   797,   798,   798,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   799,   799,   799,   799,   799,
     800,   800,   800,   801,   801,   801,   802,   802,   802,   803,
     803,   804,   804,   805,   805,   805,   805,   806,   807,   808,
     808,   809,   809,   809,   809,   809,   809,   809,   809,   809,
     809,   809,   809,   809,   809,   809,   809,   810,   810,   811,
     811,   812,   813,   813,   814,   815,   815,   816,   817,   817,
     817,   817,   817,   818,   818,   819,   820,   820,   820,   820,
     820,   820,   821,   822,   822,   822,   823,   823,   824,   824,
     824,   824,   824,   825,   825,   826,   826,   826,   826,   827,
     827,   828,   828,   829,   829,   830,   830,   831,   831,   832,
     832,   833,   833,   833,   833,   834,   834,   834,   834,   834,
     834,   834,   835,   835,   836,   837,   837,   837,   838,   838,
     838,   839,   839,   840,   840,   841,   841,   841,   841,   842,
     842,   843,   843,   844,   845,   845,   845,   846,   846,   847,
     848,   848,   849,   850,   850,   851,   852,   852,   853,   853,
     853,   853,   853,   853,   853,   853,   854,   854,   855,   856,
     856,   857,   857,   858,   859,   860,   861,   861,   862,   863,
     863,   864,   864,   864,   864,   864,   865,   865,   865,   866,
     866,   867,   867,   868,   868,   868,   868,   868,   868,   868,
     868,   869,   869,   870,   870,   870,   870,   870,   870,   871,
     871,   872,   872,   873,   874,   874,   874,   875,   875,   875,
     875,   875,   875,   875,   875,   876,   876,   877,   877,   877,
     878,   878,   878,   878,   879,   879,   880,   881,   881,   882,
     882,   883,   883,   883,   883,   884,   884,   885,   885,   885,
     886,   886,   887,   887,   888,   889,   889,   889,   890,   891,
     891,   892,   892,   893,   893,   894,   894,   895,   895,   896,
     896,   897,   897,   898,   898,   899,   899,   900,   900,   901,
     901,   902,   902,   903,   903,   903,   903,   903,   903,   903,
     903,   903,   903,   903,   904,   904,   904,   904,   904,   904,
     905,   905,   905,   905,   906,   906,   906,   906,   907,   907,
     908,   908,   909,   909,   909,   909,   910,   910,   911,   911,
     911,   912,   913,   913,   914,   914,   914,   915,   915,   916,
     917,   917,   917,   917,   917,   917,   918,   918,   918,   919,
     919,   919,   919,   919,   919,   919,   920,   920,   920,   920,
     921,   921,   922,   922,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   924,   924,   925,   925,   926,
     926,   927,   928,   929,   929,   930,   930,   931,   932,   933,
     933,   933,   933,   933,   933,   934,   934,   935,   935,   936,
     936,   936,   936,   937,   938,   938,   938,   939,   939,   939,
     939,   939,   939,   939,   939,   939,   939,   939,   939,   939,
     939,   940,   940,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,   941,   941,   941,
     941,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   943,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   943,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   945,   945,   946,   946,   946,   946,   947,
     948,   948,   949,   949,   950,   950,   951,   951,   951,   952,
     952,   953,   953,   954,   955,   955,   955,   956,   957,   957,
     958,   958,   959,   959,   959,   960,   960,   961,   961,   961,
     961,   961,   962,   962,   962,   963,   963,   963,   964,   964,
     965,   965,   965,   965,   965,   965,   965,   965,   965,   966,
     966,   967,   967,   968,   968,   968,   968,   968,   968,   969,
     969,   970,   970,   971,   971,   972,   972,   973,   973,   973,
     974,   974,   975,   975,   976,   976,   976,   976,   976,   976,
     976,   976,   977,   977,   978,   979,   979,   980,   980,   980,
     980,   980,   980,   981,   982,   983,   983,   983,   984,   984,
     985,   986,   986,   987,   988,   988,   989,   989,   990,   990,
     991,   991,   991,   991,   992,   992,   993,   993,   994,   994,
     995,   995,   996,   996,   997,   998,   998,   999,   999,   999,
     999,  1000,  1000,  1001,  1001,  1002,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1009,  1010,  1010,  1010,  1010,  1010,
    1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,  1010,
    1011,  1012,  1013,  1013,  1013,  1013,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,
    1014,  1014,  1014,  1014,  1014,  1014,  1014,  1014,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1018,  1018,  1019,
    1019,  1019,  1019,  1019,  1019,  1019,  1019,  1021,  1020,  1022,
    1023,  1023,  1023,  1023,  1024,  1024,  1024,  1024,  1025,  1025,
    1026,  1027,  1028,  1028,  1029,  1029,  1029,  1030,  1030,  1031,
    1031,  1032,  1032,  1033,  1033,  1033,  1033,  1034,  1034,  1034,
    1035,  1036,  1036,  1037,  1037,  1038,  1038,  1038,  1038,  1039,
    1039,  1040,  1041,  1042,  1043,  1043,  1044,  1045,  1045,  1046,
    1046,  1046,  1046,  1046,  1048,  1047,  1049,  1050,  1051,  1051,
    1052,  1052,  1052,  1052,  1053,  1053,  1055,  1054,  1057,  1056,
    1058,  1056,  1056,  1059,  1059,  1060,  1060,  1060,  1061,  1061,
    1061,  1061,  1062,  1062,  1063,  1063,  1063,  1063,  1063,  1063,
    1064,  1064,  1064,  1065,  1067,  1066,  1068,  1069,  1068,  1070,
    1070,  1071,  1071,  1072,  1072,  1073,  1073,  1073,  1073,  1073,
    1073,  1073,  1073,  1073,  1074,  1074,  1074,  1074,  1074,  1074,
    1074,  1074,  1074,  1074,  1075,  1075,  1076,  1076,  1077,  1078,
    1078,  1079,  1079,  1079,  1080,  1081,  1082,  1082,  1082,  1082,
    1083,  1083,  1083,  1084,  1084,  1085,  1085,  1086,  1087,  1087,
    1088,  1088,  1089,  1089,  1090,  1090,  1091,  1092,  1092,  1093,
    1093,  1093,  1094,  1094,  1094,  1094,  1094,  1094,  1094,  1094,
    1094,  1095,  1095,  1095,  1095,  1095,  1096,  1096,  1097,  1098,
    1099,  1100,  1100,  1101,  1102,  1103,  1103,  1104,  1105,  1105,
    1106,  1107,  1108,  1108,  1109,  1110,  1111,  1111,  1112,  1113,
    1113,  1113,  1113,  1113,  1114,  1114,  1114,  1114,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1115,
    1115,  1116,  1116,  1117,  1117,  1117,  1119,  1118,  1120,  1120,
    1122,  1121,  1123,  1123,  1123,  1124,  1124,  1124,  1124,  1124,
    1124,  1124,  1124,  1124,  1125,  1125,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1127,  1127,  1127,  1127,  1127,  1127,  1128,  1128,  1128,  1128,
    1128,  1128,  1128,  1129,  1130,  1130,  1130,  1130,  1130,  1130,
    1130,  1130,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1132,
    1132,  1132,  1132,  1132,  1132,  1133,  1133,  1133,  1133,  1133,
    1133,  1133,  1133,  1133,  1133,  1133,  1134,  1134,  1134,  1134,
    1134,  1135,  1135,  1135,  1135,  1136,  1136,  1136,  1136,  1136,
    1136,  1136,  1137,  1137,  1137,  1138,  1138,  1138,  1138,  1138,
    1138,  1139,  1139,  1140,  1141,  1141,  1142,  1142,  1143,  1144,
    1145,  1146,  1146,  1146,  1147,  1148,  1149,  1150,  1151,  1151,
    1151,  1151,  1151,  1152,  1153,  1153,  1153,  1154,  1154,  1155,
    1155,  1155,  1156,  1156,  1157,  1157,  1158,  1158,  1159,  1159,
    1159,  1159,  1159,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,
    1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1160,  1161,
    1161,  1161,  1161,  1162,  1162,  1162,  1162,  1162,  1162,  1162,
    1162,  1162,  1163,  1163,  1163,  1163,  1163,  1164,  1164,  1165,
    1165,  1166,  1166
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     1,     0,     2,     0,
       2,     0,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       2,     1,     2,     2,     2,     3,     3,     5,     5,     0,
       3,     5,     5,     4,     3,     5,     3,     5,     5,     6,
       1,     1,     3,     5,     6,     4,     1,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     5,     2,     2,     2,
       2,     3,     3,     3,     1,     3,     1,     3,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     1,     1,     1,     1,     1,     0,     1,     1,
       2,     3,     4,     3,     2,     2,     1,     3,     4,     5,
       4,     2,     4,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     4,     4,     4,     4,     1,     3,     2,     3,
       4,     6,     6,     6,     5,     5,     6,     6,     4,     7,
       2,     6,     4,     3,     3,     3,     3,     3,     4,     4,
       3,     3,     3,     3,     3,     3,     4,     4,     3,     2,
       3,     3,     3,     2,     2,     3,     2,     1,     1,     0,
       2,     0,     3,     2,     0,     1,     3,     3,     1,     5,
       3,     2,     2,    10,     6,     1,     1,     1,     1,     1,
       1,     3,     2,     0,     1,     1,     3,     3,     1,     1,
       3,     3,     3,     3,     4,     1,     0,     2,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     3,
       0,     1,     3,     1,    11,    10,     1,     1,     2,     2,
       2,     2,     0,     1,     0,     3,     0,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     3,     4,     2,     0,
       3,     1,     1,     2,     1,     3,     4,     4,     2,     5,
       1,     2,     2,     2,     3,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     1,     5,     7,     8,     9,
      11,     3,     0,     1,     3,     1,     2,     2,     2,     0,
       1,     3,     3,     6,     4,     0,     1,     1,     2,     2,
       0,     3,     3,     2,     1,     1,     2,     2,     4,     0,
       2,     2,     2,     0,     3,     4,     4,     0,     2,     0,
       4,     0,     5,     3,     0,     1,     3,     1,     2,     3,
       0,     5,     4,     1,     0,     1,     2,     2,     1,     2,
       3,     2,     2,     2,     2,     3,     3,     1,     3,     1,
       0,     1,     2,     1,     1,     3,     6,    10,     1,     0,
       1,     2,     2,     0,     2,     2,     1,     0,     5,     7,
       1,     0,     6,     2,     0,     3,     5,     7,     6,     8,
       7,     6,     6,     4,     0,     1,     3,     4,     1,     3,
       1,     2,     2,     2,     2,     1,     1,    10,     2,     0,
       2,     2,     1,     0,     4,     6,     5,     4,     4,     8,
       1,     1,     1,     7,     9,     8,    15,    20,     1,     1,
       1,     3,     1,     1,     1,     3,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     2,     0,     1,     2,     1,     2,
       0,     2,     1,     2,     2,     6,     8,     8,     4,     5,
       4,     4,     4,     3,     7,     8,     6,     6,     6,     6,
       3,     1,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     0,     1,     3,
      13,     1,     3,     4,     5,     4,     7,     2,     1,     0,
       2,     0,     1,     0,     6,     8,     8,     1,     3,     5,
       5,     7,     9,     7,     9,     5,     6,     6,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     1,     3,     1,     2,     2,     3,     5,     2,     2,
       0,     6,     7,     7,     7,     8,     8,     6,     8,     9,
       9,     7,    10,     7,     8,     8,     8,     8,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     3,     4,     5,     4,     5,     3,
       4,     3,     4,     1,     2,     3,     3,     3,     3,     4,
       4,     3,     3,     4,     4,     4,     4,     1,     1,     1,
       0,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     3,     2,     2,     5,     5,     5,     1,
       3,     1,     2,     3,     0,     1,     3,     2,     6,     6,
       9,     3,     0,     3,     0,     5,     2,     0,     3,     3,
       3,     7,     7,    10,     1,     1,     1,    14,     1,     0,
       1,     0,     1,     0,     2,     0,     1,     3,     4,     4,
       6,     1,     2,     0,     1,     1,     0,     1,     1,     0,
       9,    12,     7,     2,     0,     3,     2,     1,     3,     3,
       2,     1,     3,     3,     3,     2,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     4,     5,     1,     3,
       3,     1,     2,     4,     5,     1,     1,     1,     1,     3,
       3,     2,     2,     2,     2,     1,     2,     2,     1,     1,
       1,     3,     2,     0,     2,     1,     3,     5,     1,     2,
       1,     0,     5,     7,     5,     7,     5,     7,     3,     5,
       5,     5,     1,     3,     2,     1,     2,     1,     2,    11,
      10,    10,     2,     2,     0,     9,     2,     0,     4,     4,
       4,     1,     1,     1,     0,     7,     6,     6,     6,     6,
       7,     9,     9,     6,     6,     6,     6,     6,     8,     8,
       6,     6,     6,     5,     5,     8,     8,     8,     8,     6,
       1,     0,     2,     0,     7,     6,     6,     6,     6,     6,
       6,     7,     6,     6,     6,     6,     7,     7,     7,     9,
       9,     6,     6,     6,     8,     8,     8,     6,    13,     1,
       1,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     1,     1,     1,     1,     1,     0,     6,     8,
       3,     2,     0,     2,     2,     2,     2,     3,     3,     2,
       2,     2,     2,     3,     2,     5,     4,     3,     3,     3,
       1,     1,     0,     3,     2,     2,     1,     3,     2,     1,
       0,     8,    10,     3,     4,     4,     0,     2,     5,     2,
       0,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     1,     0,     5,
       6,     4,     2,     0,     4,     3,     5,     6,     4,     6,
       6,     5,     7,     1,     0,     6,    11,    11,    11,    13,
       9,    11,    10,     4,     2,     5,     2,     0,     4,     5,
       5,     4,     6,     1,     3,     1,     1,     1,     1,     2,
       4,     1,     1,     1,     0,     1,     0,     1,     0,     3,
       0,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     1,     1,     1,     1,
       0,     5,     4,     3,     0,     1,     1,     1,     1,     4,
       8,     3,     0,     5,     1,     4,     2,     1,     3,     2,
       3,     0,     6,     2,     0,     5,     3,     0,     2,     2,
       2,     3,     1,     3,     1,     2,     1,     0,     7,     1,
       3,     1,     1,     3,     5,     2,     1,     3,     7,     1,
       1,     0,     3,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     1,     2,     4,     4,     4,     2,
       3,     1,     3,     4,     2,     1,     0,     3,     3,     4,
       4,     4,     4,     2,     1,     1,     0,     1,     1,     0,
       1,     5,     1,     0,     1,     0,     3,     1,     3,     4,
       3,     2,     2,     1,     1,     1,     0,     2,     4,     5,
       2,     3,     1,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     3,     0,     2,     0,     1,     3,     1,
       0,     1,     2,     4,     4,     2,     0,     2,     3,     2,
       0,     1,     3,     1,     2,     1,     2,     5,     6,     5,
       1,     2,     1,     4,     3,     4,     5,     4,     5,     4,
       5,     2,     4,     1,     2,     2,     2,     1,     1,     0,
       4,     2,     1,     2,     2,     4,     1,     3,     1,     2,
       3,     1,     2,     0,     2,     4,     0,     1,     3,     2,
       2,     3,     5,     6,     2,     3,     3,     4,     0,     1,
       1,     1,     1,     1,     2,     5,     1,     1,     1,     1,
       2,     3,     3,     0,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     1,     3,     0,     1,     1,     1,
       1,     5,     2,     1,     1,     1,     1,     5,     2,     2,
       2,     1,     3,     3,     2,     1,     0,     3,     0,     5,
       2,     5,     2,     1,     2,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       0,     1,     4,     1,     3,     5,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     3,     2,     3,     5,     4,     6,     3,     5,     4,
       6,     4,     6,     5,     7,     3,     2,     4,     2,     3,
       3,     4,     3,     4,     3,     4,     5,     6,     6,     7,
       6,     7,     6,     7,     3,     4,     4,     6,     2,     3,
       4,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     5,     6,     6,
       7,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     4,     5,     6,     8,     6,
       7,     7,     5,     1,     1,     4,     1,     4,     1,     4,
       1,     4,     1,     1,     1,     1,     1,     1,     6,     4,
       4,     4,     4,     6,     5,     5,     5,     4,     6,     4,
       4,     4,     4,     5,     7,     7,     9,     4,     6,     5,
       7,     7,     7,     2,     3,     3,     3,     4,     0,     4,
       1,     3,     3,     1,     1,     1,     2,     2,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     2,     2,     0,     1,     4,     2,     2,     2,
       2,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     3,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     3,     0,     3,     3,     2,
       2,     1,     0,     2,     2,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     5,     1,     2,     0,     2,     1,     0,
       1,     1,     1,     3,     3,     1,     3,     3,     2,     1,
       1,     1,     3,     1,     2,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     5,     2,     3,     6,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     4,
       3,     2,     1,     1,     1,     1,     1,     0,     8,     2,
       5,     3,     2,     2,     3,     7,     1,     1,     1,     0,
       2,     2,     1,     0,     1,     3,     1,     2,     0,     2,
       0,     2,     0,     1,     3,     4,     3,     1,     1,     1,
       1,     2,     0,     2,     4,     0,     2,     2,     2,     1,
       1,     7,     3,     1,     1,     1,     1,     2,     0,     1,
       3,     3,     3,     3,     0,     4,     5,     5,     0,     1,
       1,     1,     2,     2,     1,     2,     0,     7,     0,     5,
       0,     4,     2,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     2,     1,
       3,     2,     2,     3,     0,     5,     1,     0,     5,     2,
       2,     1,     1,     1,     2,     2,     3,     1,     2,     2,
       3,     3,     4,     2,     1,     2,     1,     1,     2,     2,
       3,     1,     1,     1,     1,     0,     1,     3,     5,     0,
       2,     0,     1,     2,     3,     2,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     2,     2,     3,     0,     1,
       2,     1,     4,     3,     4,     3,     2,     1,     3,     1,
       1,     1,     1,     2,     2,     1,     2,     2,     1,     1,
       1,     4,     4,     4,     4,     4,     1,     0,     3,     3,
       4,     1,     3,     3,     4,     1,     3,     3,     1,     1,
       1,     6,     1,     3,     3,     6,     1,     3,     3,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     1,     1,     4,     4,     3,     0,     7,     1,     0,
       0,     7,     3,     4,     3,     1,     1,     1,     2,     3,
       5,     2,     5,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     0,     1,     2,     1,     2,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     1,     2,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       3,     2,     3,     1,     3,     3,     3,     3,     3,     3,
       1,     1,     0,     2,     2,     1,     1,     2,     1,     1,
       1,     0,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    2087,     0,     2,     1,  2517,  2521,  2525,  2526,  2443,  2527,
    2528,  2493,  2494,  2495,  2496,  2497,  2498,  2499,  2500,  2501,
    2502,  2503,  2504,  2506,  2505,  2507,  2508,  2509,  2510,  2511,
    2512,  2513,  2514,  2516,  2515,  2465,  2094,  2462,  2459,  2460,
    2461,  2466,  2464,  2457,  2458,  1700,  2530,  2518,  2531,  2519,
    2520,  2522,  2523,  2492,  2524,  2532,  2533,  2534,  2529,  2537,
    2488,  2489,  2487,  2490,  2491,  2535,  2536,  2479,  2480,  2481,
    2482,  2538,  2095,  2096,  2484,  2088,  2092,  2154,  2225,  2485,
    2486,  2483,  2093,  2478,  2225,     0,  2346,  2347,  2348,     0,
    2349,  2350,  2351,  2277,  2239,  2352,     0,     0,  2353,  2354,
    2355,  2356,  2357,  2358,  2359,  2360,     0,  2361,  2362,  2363,
    2364,  2224,  2365,  2366,  2367,  2368,  2369,  2201,  2207,  2330,
       0,  2181,  2182,  2178,  2180,  2179,  2183,  2166,  1002,   501,
    1082,  1081,     0,  1991,  1002,  1948,  1949,  1992,  1950,  1951,
    1952,   247,     0,  1084,  1953,     0,  1002,  1993,   336,   814,
    1994,  1995,  2109,     0,  1954,  1955,     0,     0,     0,     0,
     501,  1002,     0,     0,  1956,     0,  1957,     0,  1958,  1996,
    1997,     0,  1959,  1998,  1999,  1960,     0,  1961,  1962,  2000,
    2001,  2002,  1963,  2003,  2004,     0,     0,  1206,     0,  1964,
    2005,  1965,  1966,     0,  2006,  1967,  1968,  1969,  2007,  2008,
    2009,  1970,  1971,  1972,     0,  1973,     0,     0,     0,     0,
       0,  2010,  1002,  1974,     0,  1213,     0,  1975,     0,  2011,
    1976,     0,  1977,     0,  1978,  1979,  1980,  1981,  1206,  2326,
    2202,     0,     0,  1086,     0,  1982,  2012,     0,  1983,  1984,
    1985,  1986,  1987,  1988,  1989,  1990,     0,     0,    47,    48,
      16,    15,    21,    20,    70,    71,    37,    10,    61,    42,
     102,   101,   103,    27,    23,    55,    14,    24,    28,    44,
      43,    13,    41,    65,    45,    68,    34,    59,     7,    35,
      60,     8,    49,    72,    19,    46,    69,    30,    57,    53,
      38,    39,    40,    62,    63,    64,    86,    67,    97,    26,
      76,    77,    92,    78,    93,     5,    79,    36,     9,    89,
      88,    90,    56,    31,    58,    87,    91,    11,    12,    94,
      66,    84,    81,    98,    96,   104,    82,    50,     3,     4,
      73,    33,     6,    18,    17,    32,    25,   100,    22,  1084,
      75,    85,    74,    80,    54,    83,    99,    52,    95,  1182,
    1169,  1215,  1181,     0,  1184,  2422,  2423,    29,   124,   106,
     107,   112,  2091,  2143,  2144,  2145,  2225,  2176,  2177,  2170,
    2186,  2196,  2185,  2189,  2197,  2184,  2203,     0,   109,   111,
     113,   116,   110,   105,   108,   115,   120,   114,   119,   117,
     118,   121,   122,   123,  2424,  1390,  2421,    51,  2161,  2160,
       0,  2225,     0,  2370,  2371,  2372,  2373,  2374,  2375,  2425,
    2426,  2427,  2428,  2429,  2431,  2430,  2454,  1706,  1707,  1708,
    1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,
    1729,  2397,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  2434,  1740,  1741,  1742,  1743,  1744,  1745,  1746,
    1747,  1748,  1749,  1750,  1751,  1752,  1753,  2435,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  2436,  1793,  1794,
    1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,
    1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,
    1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,
    1825,  2437,  1826,  1827,  2438,  1828,  1829,  1830,  1831,  1832,
    1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,
    1853,  1854,  1855,  1856,  1857,  1860,  1858,  1859,  1861,  1862,
    1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,
    1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  2439,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  2109,  1920,
    1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,
    1931,  1932,  1933,  1934,  1935,  2398,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  2440,  1946,  1947,  2127,
    2432,  2394,  2102,  2123,  2395,  2344,  2345,  1701,  2396,  2393,
    2433,  2129,  2450,  2128,  2392,  2276,     0,     0,  2238,  2237,
    2241,  2240,  2242,  2235,  2236,  1678,  2130,  2246,  2245,  1159,
    2449,  1677,  1160,     0,  2248,  2376,  2377,  2378,  2379,  2381,
    2380,  2382,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,
    2021,  2022,  2023,  2024,  2407,  2025,  2026,  2027,  2420,  2028,
    2029,  2408,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2409,  2410,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2411,  2077,  2078,  2412,  2079,  2080,  2081,  2413,  2082,
    2083,  2084,  2085,  2086,  2417,  2418,  2419,  2406,  2199,  2383,
    2405,  2416,  2414,  2415,  2209,  2205,  2213,  2208,     0,     0,
       0,     0,  2225,  1001,  1000,   986,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   500,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2099,     0,  1010,   312,   311,  1083,  1064,   501,     0,   989,
     335,     0,     0,     0,     0,     0,     0,     0,   628,     0,
       0,     0,     0,     0,     0,     0,     0,   177,     0,     0,
     357,   356,     0,     0,     0,   788,     0,     0,     0,     0,
     489,  2108,  2103,  2113,     0,  2106,  2107,  2392,     0,  2541,
    1858,  2139,  2140,  2539,  1904,  1161,     0,   248,   251,   249,
     250,     0,   884,   885,   887,     0,     0,   897,   655,     0,
     654,     0,     0,     0,   652,     0,     0,     0,     0,   656,
     650,     0,   649,     0,     0,     0,   653,     0,   651,     0,
       0,   990,     0,  2191,  2192,  1795,  1122,   362,     0,     0,
       0,     0,  1084,  1091,  1101,  1096,  1098,  1097,  1099,  1095,
    1100,  1707,   730,  1720,   730,  1785,   727,   728,   730,   730,
     730,  1872,     0,     0,   702,     0,   713,  1702,   730,  1703,
    2450,   735,   412,   412,   412,     0,   734,   739,   412,     0,
     983,  1017,  1682,  1205,     0,  1720,  1785,   703,   982,  1920,
    1114,     0,     0,   901,     0,   902,     0,  1887,   994,   234,
    2390,  1896,  1978,  1920,  2391,   230,  2385,  2386,  2388,   204,
    2389,  2387,  2384,  1711,     0,     0,   734,     0,   991,   992,
    1212,  1210,     0,     0,     0,  1728,     0,  1740,  1819,   227,
    1883,  1888,  1896,  1978,  1920,  1945,   186,     0,   241,  1896,
    1978,  1920,     0,  1010,     0,  1185,  1292,  1673,     0,     0,
    2200,   985,   984,  1298,     0,  1085,     0,  1088,     0,  1257,
    1870,  1189,  1191,  1090,  1182,     0,  2090,  1079,  1209,  1209,
       0,  1209,     0,  1174,  1182,  1177,  1181,     0,  1002,     0,
    2168,  2196,  2175,  2231,  2172,     0,     0,  2221,  2217,  2214,
    2222,  2223,  2216,  2204,  1379,  1380,  1381,  1378,  1391,  1377,
       0,  2149,  1382,  2188,  2155,     0,  2163,  2162,  2467,  2468,
    2278,  2101,  2120,     0,     0,     0,     0,     0,     0,     0,
    2247,  2249,  2251,  2211,  2210,  2206,     0,     0,     0,     0,
    2336,  2337,  2335,     0,  2332,  2334,     0,  2231,     0,  2401,
    2395,  2404,     0,  1683,  2396,  2393,  2392,     0,   663,   127,
     777,     0,     0,     0,     0,     0,     0,     0,  1578,  1732,
    1781,  1588,  1586,  1587,  1580,  1581,  1582,  1583,  1584,  1585,
       0,   882,  1579,     0,   127,     0,     0,     0,     0,     0,
       0,     0,     0,  1823,   127,     0,     0,     0,     0,     0,
    1006,  1009,   987,  1067,     0,  1673,     0,     0,   688,     0,
     697,   689,   694,     0,   691,     0,     0,   699,     0,   690,
     692,   693,   698,     0,     0,   695,   696,     0,     0,   998,
     412,     0,     0,     0,     0,     0,   127,  1054,     0,   361,
     360,   127,   359,   358,  1732,  1781,     0,   813,   127,     0,
     179,   529,   504,     0,     0,   593,  1823,   127,     0,     0,
       0,     0,   791,     0,     0,   488,   501,     0,  2112,  2118,
       0,  2110,  2279,  2542,  2540,  2234,     0,  1134,   888,   228,
     229,   886,  1794,     0,   299,     0,     0,  1794,  1045,     0,
    1794,     0,  1794,   172,  1675,  1732,  1781,  1794,     0,     0,
    1794,   164,  1794,     0,  1794,   299,  1794,   505,     0,  1794,
       0,  1794,  1823,   166,     0,  1794,   299,   661,     0,     0,
    2472,  2476,     0,  2474,  2469,  2190,  2244,  2243,  2142,     0,
    2552,     0,  1161,  1093,  2398,  1107,  1106,     0,  1102,  1110,
    1105,     0,   730,   729,     0,   730,     0,  2561,   730,     0,
     730,     0,  2561,   730,     0,     0,     0,   730,  1704,  1705,
       0,     0,  2560,  2558,  2559,   704,   714,     0,   736,     0,
       0,   743,   742,   741,     0,     0,     0,   744,     0,  1296,
    1137,     0,   711,     0,   709,     0,   980,   997,     0,     0,
       0,     0,   904,   904,   904,   993,   233,   231,     0,     0,
       0,     0,     0,     0,   999,     0,     0,  2456,  1689,  1589,
    2455,     0,  1949,  1950,  1951,  1647,     0,  2397,  1952,  1953,
    1506,  1493,  1502,  1507,  1494,  1496,  1503,  1954,  1955,  1767,
    1956,  1957,  1696,  1958,  1959,  1334,  1961,  1962,  1963,  1498,
    1500,  1964,  1965,     0,  1697,  1967,  1968,  1847,  1970,  1971,
    1973,  1974,  1504,  1976,  1977,  1978,  1979,  1980,  1981,  1695,
       0,  1505,  1982,  1984,  1985,  1986,  1987,  1988,  1989,  1990,
       0,     0,  1670,     0,  1479,     0,  1326,  1327,  1349,  1350,
    1328,  1355,  1356,  1368,  1329,     0,  1669,  1393,  1478,  1484,
       0,  1477,  1473,  1196,  1665,     0,  1474,  1685,  1648,  1699,
    1698,  2450,  1656,  1688,  1686,  1687,     0,     0,     0,   197,
       0,     0,  2325,   243,     0,   244,  1671,  1896,   187,   226,
     199,   225,   200,   198,     0,  1730,   188,     0,   195,     0,
       0,     0,     0,     0,     0,     0,   237,   988,     0,  1294,
    1293,     0,     0,  1654,  1674,   670,     0,     0,  1299,     0,
    1077,  1078,  1076,     0,  1073,  1075,  1087,  1084,  1661,  1660,
    1662,     0,  1190,     0,     0,     0,  1172,  1171,  1090,  1207,
    1208,     0,     0,     0,     0,     0,     0,     0,     0,  1250,
    1223,  1224,  1226,  1247,  1251,     0,  1178,  1258,  2089,  2231,
    2232,     0,  2226,     0,  2225,  2225,  2219,  2218,  2215,     0,
       0,     0,     0,     0,     0,     0,  2146,   483,  2148,   481,
       0,     0,  2122,     0,  2126,  2124,     0,  2271,  2274,     0,
    2272,  2273,  2275,     0,  2280,  2281,     0,     0,     0,  2463,
       0,     0,  2262,  2250,  2257,  2259,  2261,  2260,  2269,  2265,
    2268,  2270,  2212,  2225,  2343,     0,  2338,  2341,     0,  2333,
       0,     0,     0,  1684,     0,     0,     0,   664,     0,     0,
       0,   126,  1043,   236,  1041,     0,     0,     0,     0,     0,
    1048,     0,     0,     0,     0,   846,     0,     0,     0,     0,
       0,     0,   847,   845,   848,   855,   868,   871,     0,   767,
     170,   171,     0,     0,     0,   931,     0,     0,   931,     0,
       0,     0,     0,     0,     0,     0,   253,   256,     0,     0,
       0,     0,     0,     0,     0,     0,   131,     0,     0,     0,
       0,   468,   480,     0,     0,     0,     0,     0,   477,     0,
     127,   254,   462,   465,     0,     0,     0,   538,   537,   931,
       0,   252,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   131,   163,     0,
       0,   255,     0,  2156,     0,  1004,  1005,     0,  1008,     0,
    1063,     0,     0,     0,     0,     0,     0,  1732,  1781,     0,
       0,     0,     0,     0,     0,   338,   318,   319,   127,   317,
       0,     0,   590,     0,  1337,  1366,  1344,  1366,  1366,  1333,
    1333,  1346,  1335,  1373,     0,  1366,  1333,  1338,     0,  1336,
    1376,  1376,  1361,     0,  1318,  1319,  1320,  1321,  1347,  1348,
    1322,  1353,  1354,  1323,  1390,  2402,  1333,  2403,  2400,  2399,
       0,  1020,  1053,     0,     0,   129,   629,     0,     0,   591,
       0,   129,     0,   175,     0,   533,     0,     0,     0,     0,
       0,     0,   549,   548,     0,     0,   592,     0,   129,   464,
       0,   454,   412,     0,   790,   793,     0,     0,     0,  2116,
    2111,  2114,     0,  2104,  2118,  1164,  1166,  1165,     0,  1163,
       0,  1306,     0,   299,   297,   298,   588,   896,     0,     0,
       0,     0,   299,     0,     0,  1794,     0,  1794,     0,     0,
     299,   299,     0,     0,     0,     0,   534,     0,   660,   658,
     657,   659,     0,     0,     0,     0,     0,  1794,   299,     0,
       0,   648,  2470,     0,     0,  2473,     0,  2193,  1599,     0,
    2555,  1119,  2556,     0,     0,     0,     0,   215,   216,   214,
    1108,   217,  1109,  1104,  1092,     0,   722,     0,  2561,  2562,
     707,     0,   717,     0,  2561,   705,     0,   718,   715,   716,
       0,     0,     0,  2557,  2441,  2447,   721,     0,     0,   413,
     415,     0,     0,  1753,     0,  1786,  1811,  1812,  1888,  1892,
       0,  1915,     0,   745,   772,   740,     0,     0,  1131,  1124,
       0,     0,  1147,   712,   710,   981,  1112,  1605,     0,     0,
       0,   903,   900,   899,   898,   232,   205,     0,     0,     0,
     774,  1887,   996,     0,     0,  1482,  1483,  1365,  1352,  1646,
       0,     0,  1360,  1359,     0,     0,     0,     0,  1342,  1341,
    1340,  1481,  1613,     0,  1339,     0,     0,     0,     0,  1366,
    1366,  1364,  1412,     0,  1343,     0,     0,  1626,     0,  1632,
       0,     0,     0,  1372,     0,  1370,     0,     0,  1448,     0,
       0,     0,     0,     0,     0,     0,  1396,  1397,  1479,  1599,
       0,  1480,  1692,     0,     0,  1358,     0,  1390,  1589,     0,
       0,     0,     0,  1659,  1597,     0,     0,  1426,  1595,     0,
    1428,     0,     0,     0,  1588,  1586,  1587,  1580,  1581,  1582,
    1583,  1584,  1585,  1593,  1409,     0,  1668,     0,  1408,     0,
       0,  1260,  1195,     0,  1690,  1649,     0,  2448,  2451,  1475,
    2322,  2321,  2320,  2319,  2290,     0,  2284,  2285,     0,  2323,
    2324,   245,   246,   242,     0,     0,   202,   201,     0,   223,
     224,   194,   222,     0,   218,   219,  1545,  1544,   203,   193,
     191,   189,   206,   208,   209,   192,   190,   240,   238,     0,
       0,     0,  1651,  1650,  1680,  1655,     0,     0,   299,  2225,
    1300,     0,  1260,  1149,  1151,  1152,     0,  1656,  1071,     0,
    1068,  1664,     0,  1192,     0,     0,  1080,  1188,  1187,  1216,
    1217,   806,  1186,  1241,  1242,  1237,     0,  1256,  1256,  1233,
    1227,  1232,  1230,     0,  1234,  1393,  1249,  1176,  1221,  1222,
    1225,  1175,     0,  1252,  1250,  1226,     0,  2233,  2231,  2171,
    1318,  2225,  2164,  2225,  2220,  2152,  1384,  1385,  1386,  1387,
    1388,  1389,  2153,     0,  2150,  1383,  2151,   482,     0,     0,
       0,  2119,     0,  2100,  2125,  2256,  2365,  2288,     0,  2289,
       0,     0,  2253,     0,  2263,  2266,  2264,  2267,     0,  1318,
    2444,  2339,  2444,  1318,     0,     0,     0,     0,     0,     0,
       0,   665,     0,     0,     0,  1915,   235,  1039,     0,     0,
       0,     0,   776,   775,     0,     0,   795,     0,     0,     0,
    1051,   405,     0,   296,     0,     0,     0,     0,     0,     0,
       0,   853,     0,     0,     0,     0,   854,   851,   852,  1888,
     870,   869,   867,   828,   830,   829,     0,   832,   816,     0,
     817,     0,     0,   827,   835,   833,     0,     0,     0,  1775,
     258,   270,     0,   930,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   289,     0,     0,     0,     0,   294,
       0,     0,     0,   293,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,   158,   161,     0,     0,   467,   479,
       0,   471,   472,   469,   473,   474,     0,     0,     0,     0,
       0,     0,   466,     0,     0,   531,   530,   536,     0,     0,
       0,     0,     0,   924,   923,     0,     0,     0,     0,     0,
       0,     0,     0,   540,   541,     0,   542,     0,   162,     0,
       0,     0,     0,     0,     0,   213,  1003,  1007,  1066,  1681,
    1065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     323,     0,   613,  2399,   589,     0,  1318,     0,  1314,  1310,
    1379,  1378,  1377,     0,  1324,  1333,  1330,     0,  1018,   379,
     497,   168,     0,     0,     0,   601,   604,     0,   125,   179,
     362,     0,   178,   180,   182,   183,   184,   181,   185,   528,
     532,     0,   503,     0,     0,     0,     0,     0,   553,   552,
     556,   554,     0,   550,     0,     0,     0,   157,   461,   463,
    2097,     0,   364,   443,     0,     0,     0,   792,     0,     0,
       0,     0,     0,  2117,     0,     0,     0,     0,  1162,     0,
    1270,  1133,  1261,  1272,  1263,  1265,  1301,     0,  1673,     0,
    1131,     0,   874,     0,  1046,  1794,   299,     0,   872,   173,
    1676,     0,     0,     0,     0,     0,   876,   645,   165,     0,
     299,   299,   506,     0,   299,   167,     0,     0,     0,   498,
     299,   662,  2471,  2477,  2475,  1121,     0,  2553,  2554,   454,
    1166,  1094,  1103,   719,   726,   708,   725,   724,   706,   723,
     720,  2255,     0,     0,  2446,     0,   737,     0,   411,     0,
       0,     0,   751,     0,     0,   750,   765,   752,     0,   754,
     747,   746,   755,     0,     0,   774,  1126,     0,  1127,  1656,
       0,  1123,     0,  1144,     0,  1142,     0,  1297,  1146,  1135,
    1113,     0,  1111,  1116,  1118,  1117,  1115,     0,     0,     0,
     734,     0,     0,   299,   995,     0,  1609,     0,  1610,     0,
       0,     0,  1645,  1641,     0,     0,     0,     0,     0,  1617,
    1618,  1619,  1616,  1620,  1615,     0,     0,  1621,  1614,     0,
       0,     0,     0,     0,  1363,  1362,     0,     0,     0,     0,
       0,     0,     0,  1451,  1484,     0,     0,  1573,     0,  1599,
    1631,     0,     0,  1374,     0,     0,     0,     0,     0,     0,
       0,  1599,  1637,     0,     0,     0,  1543,     0,  1540,     0,
       0,     0,     0,  1656,     0,     0,     0,     0,  1693,  1394,
    1410,  1667,     0,  1658,     0,     0,  1417,     0,  1638,  1444,
       0,  1449,  1432,     0,  1425,     0,  1430,  1434,  1413,  1659,
    1598,     0,  1596,     0,     0,  1411,     0,  1406,  1404,  1405,
    1398,  1399,  1400,  1401,  1402,  1403,  1407,  1577,  1575,  1576,
       0,     0,     0,  1429,  1788,  1819,     0,  1206,  1206,  1194,
    1204,  1666,     0,  1303,     0,     0,     0,     0,  1556,     0,
    1603,     0,  1601,  1683,  2453,  2452,  1657,     0,     0,     0,
    1672,     0,     0,  1390,     0,   239,  1295,  1652,     0,   668,
     669,   667,  1318,  1156,     0,     0,  1306,     0,  1155,  1090,
    1074,  1070,  1069,  1663,  1089,  1193,     0,   804,   805,     0,
     809,     0,     0,  1235,  1248,     0,  1147,  1147,     0,  1239,
    1240,  1231,  1180,  1179,  2169,  2227,  2174,  2195,  2165,  2198,
    1392,  2147,  2187,     0,  2121,  2291,  2292,     0,  2282,  2283,
    2252,  2258,  2329,     0,  2445,     0,     0,   611,   610,     0,
       0,     0,   942,   906,   666,   943,   907,  1040,     0,  1042,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   299,  1049,   944,   295,  1050,   935,     0,
       0,     0,   511,   512,     0,   849,   850,   945,   908,     0,
     936,   831,  1333,   815,     0,     0,   826,     0,   825,  1333,
    1333,   909,   169,   259,   379,   933,   275,   288,   283,   284,
     282,  1794,   299,  1794,   299,     0,     0,     0,     0,   285,
     280,   281,   277,   290,   291,   917,     0,   305,   308,   292,
     273,   276,   274,   257,     0,     0,  1679,     0,     0,   878,
       0,     0,   160,   920,     0,   140,   142,   144,     0,   138,
     146,   141,   143,   145,   139,   147,   137,     0,   136,     0,
       0,     0,   130,   951,   913,   470,   475,   915,   478,   938,
     476,  1710,  1768,  1897,     0,   518,   520,     0,   525,   957,
     914,     0,   937,   953,   922,     0,     0,     0,     0,     0,
       0,     0,  1055,     0,     0,     0,   952,   929,   940,     0,
     921,   916,   939,     0,     0,   211,   210,   212,     0,     0,
       0,     0,     0,     0,     0,     0,   701,   677,   700,     0,
       0,     0,     0,     0,     0,     0,   671,   337,   315,   316,
       0,     0,   314,   320,   612,     0,     0,     0,  1315,  1311,
       0,     0,     0,     0,     0,     0,  1331,     0,     0,  1038,
    1038,  1038,  1038,  1038,  1038,  1038,  1019,  1047,   496,   514,
       0,     0,     0,     0,   151,   128,     0,   634,   600,     0,
       0,   412,   174,     0,     0,     0,   502,   599,   597,   596,
     598,     0,     0,     0,   617,     0,  1307,     0,     0,     0,
       0,   366,     0,     0,   363,   367,   371,   372,   373,     0,
     455,   457,     0,     0,   447,     0,     0,     0,   820,     0,
     838,   821,     0,     0,     0,   858,   863,   859,   841,     0,
     486,  2115,  2109,  1167,  1168,     0,  1182,     0,  1272,     0,
    1271,  1283,     0,     0,  1289,  1287,     0,  1289,     0,  1289,
       0,  1264,     0,  1266,  1283,     0,  1674,     0,  1304,  1132,
     299,     0,     0,   508,   299,     0,   299,     0,   299,   299,
       0,   978,   535,     0,   585,     0,     0,   299,   647,  1600,
       0,     0,  2254,  2442,   738,   414,     0,     0,     0,     0,
     749,     0,   484,   753,     0,   764,   759,   761,     0,   768,
       0,     0,  1129,     0,  1145,  1138,  1140,  1139,     0,     0,
    1136,  1606,   646,     0,     0,   299,     0,   769,  1211,  1607,
    1608,     0,     0,     0,     0,  1642,     0,     0,  1519,  1495,
    1497,  1332,  1509,     0,  1345,  1520,  1521,  1499,  1501,     0,
    1590,     0,     0,  1510,  1453,  1454,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1466,
    1465,  1511,  1572,     0,     0,  1629,  1630,  1512,  1375,  1376,
    1376,     0,     0,  1636,     0,     0,     0,  1517,  1522,     0,
       0,  1527,     0,  1548,     0,     0,     0,  1476,  1600,  1367,
    1368,     0,     0,     0,     0,     0,     0,     0,     0,  1450,
    1433,  1427,     0,  1431,  1435,     0,     0,     0,     0,  1419,
    1445,  1415,     0,     0,  1421,     0,  1446,  1206,  1206,  1206,
    1206,  1203,     0,     0,  1259,     0,  1244,  1215,  1215,     0,
    1556,     0,  1485,     0,  1556,     0,     0,  2304,  2306,  2307,
    2308,  2309,  2310,  2312,  2313,  2315,  2316,  2317,  2305,  2311,
    2314,  2318,  2295,  2296,     0,  2286,  2287,   196,     0,   220,
     207,     0,  2329,     0,     0,  1150,  1131,  1153,  1072,  1218,
       0,  1591,   809,   807,   808,  1220,     0,     0,  1255,  1254,
    1253,  1228,     0,  2229,  2157,     0,     0,  2328,  2331,  2342,
    2340,  2167,   941,   905,   934,  1038,   779,   780,     0,   778,
       0,     0,     0,   404,   794,     0,     0,     0,     0,  1052,
     495,     0,   494,   490,   510,   843,     0,  1333,   818,   823,
     824,     0,   376,     0,     0,     0,   260,     0,     0,   272,
       0,   268,   286,   278,   287,   279,   302,     0,     0,     0,
     947,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     948,     0,     0,   133,   132,     0,   150,     0,   522,   523,
     521,   517,     0,   524,   526,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   946,   910,   672,
       0,     0,   673,   681,     0,     0,   674,     0,     0,     0,
       0,     0,     0,   683,   340,     0,   343,   350,   324,   328,
    1054,  1054,     0,   329,  1054,   325,  1054,   322,   614,     0,
    1847,  1580,  1581,   608,   615,   605,   607,   606,   609,   580,
       0,     0,     0,  1316,     0,  2543,  2551,  2550,     0,  1390,
       0,  1038,  1037,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   390,     0,     0,   384,     0,     0,   863,
     378,   381,   382,     0,   507,   153,     0,     0,   154,   152,
       0,   602,   603,     0,   362,     0,     0,   555,   558,   551,
       0,   616,   618,   594,     0,  1309,   514,  1122,   460,     0,
     443,   397,   439,     0,   453,     0,   441,   440,   442,     0,
     449,  1016,     0,   795,   819,     0,     0,     0,   856,   860,
     857,     0,     0,   834,     0,   842,   812,   973,   974,   971,
     972,     0,     0,  2132,  1158,  2141,  1274,  1281,     0,  1262,
       0,  1288,  1284,     0,  1285,     0,     0,  1286,     0,     0,
    1281,     0,     0,     0,   875,     0,   299,   873,     0,   641,
       0,   643,   877,   299,   299,   543,     0,   499,   457,     0,
       0,     0,     0,   748,   766,     0,   762,     0,     0,   731,
     771,  1125,  1128,  1130,  1143,  1141,   774,     0,   732,   773,
    1611,  1351,     0,  1644,  1640,     0,  1612,     0,  1624,  1623,
    1452,  1625,     0,  1471,     0,     0,  1463,  1461,  1462,  1455,
    1456,  1457,  1458,  1459,  1460,  1464,  1634,  1633,  1627,  1628,
    1371,  1369,     0,  1514,  1515,  1516,  1635,  1523,     0,  1542,
    1541,     0,     0,     0,  1529,     0,     0,  1538,     0,  1574,
    1357,  1390,  1395,     0,     0,  1418,  1639,  1436,     0,     0,
       0,  1414,     0,     0,     0,     0,  1423,  1590,     0,     0,
       0,     0,     0,     0,  1198,  1197,  1302,     0,  1246,     0,
       0,  1214,     0,  1556,  1492,  1559,  1554,  1555,  1604,  1486,
    1691,     0,  1602,  1556,     0,     0,     0,  1653,  2327,     0,
    1157,  1148,     0,  1219,  1236,  1229,  2173,     0,  2228,  2293,
    2294,     0,   785,   786,   784,     0,     0,     0,   580,     0,
       0,   420,     0,   803,   803,     0,     0,   863,   956,   491,
     844,     0,   836,     0,   265,   932,     0,     0,     0,   264,
       0,   299,   299,   306,   307,   310,     0,     0,     0,     0,
       0,   635,   621,     0,     0,   636,   637,     0,     0,   880,
     881,   879,   148,   134,   135,   149,   519,   918,     0,     0,
       0,     0,     0,   955,   928,   954,   926,   925,   927,   919,
     545,     0,   675,     0,     0,   676,   687,   685,   684,   686,
     678,   341,   127,     0,   321,     0,   348,     0,   346,   345,
     347,     0,     0,     0,     0,     0,     0,   582,     0,     0,
     587,   576,   578,     0,     0,     0,  1312,     0,     0,     0,
       0,     0,     0,  1317,  1325,   575,     0,  1029,  1028,  1027,
    1031,  1030,  1033,  1032,  1024,  1023,  1036,  1035,  1022,  1021,
    1026,  1025,     0,     0,   388,   392,   393,   391,   383,   863,
     412,   451,     0,   156,   155,     0,     0,     0,     0,   560,
     564,   595,     0,  1308,   539,  1120,     0,  2098,     0,   369,
     374,   375,     0,   447,   394,     0,   443,   368,   456,     0,
       0,   452,     0,  1011,     0,     0,   822,   839,   840,     0,
       0,   863,   862,     0,   493,     0,  2105,  1273,     0,     0,
    1275,     0,     0,  1277,  1279,     0,     0,     0,     0,     0,
    1677,  1556,  1305,   299,   509,   299,   299,   979,   586,     0,
     758,   757,   756,   485,     0,   760,   299,     0,  1643,  1508,
    1518,  1622,     0,     0,  1472,     0,     0,  1513,  1983,     0,
       0,  1546,  1547,  1528,     0,  1832,  1533,     0,     0,     0,
    1694,  1442,  1440,  1437,     0,  1438,     0,     0,  1420,  1416,
       0,  1422,  1447,  1202,  1201,  1200,  1199,     0,     0,  1550,
    1556,  1556,  1487,  1561,  1558,     0,  1489,  2297,     0,  2300,
    2298,  2299,  2303,  1390,  1154,     0,  2230,  1044,     0,     0,
       0,   406,     0,   863,     0,     0,     0,   801,   806,   806,
       0,   863,   451,   837,   261,   262,   263,   266,   301,   271,
     267,     0,   949,   911,     0,     0,   627,     0,     0,     0,
       0,   950,   912,     0,     0,     0,  1060,     0,     0,   679,
     680,   323,     0,   344,   353,     0,   351,   326,   331,     0,
     333,   332,   327,   330,   584,   583,   581,   577,   579,  1313,
       0,   894,   894,  2544,  2545,  2546,  2547,  2548,  2549,     0,
     580,  1034,     0,     0,   380,   451,   419,     0,   385,     0,
     515,     0,  1016,   364,   514,   559,     0,     0,     0,   619,
     458,     0,   365,     0,     0,   449,     0,     0,     0,   447,
       0,   444,     0,   448,     0,     0,     0,     0,     0,   861,
       0,   865,     0,   833,   810,  1303,     0,   497,  2131,  2135,
       0,  1282,  1291,     0,  1278,  1276,  1267,     0,  1269,   895,
     642,   644,   544,   763,   770,   299,  1467,     0,     0,     0,
       0,  1524,     0,  1525,  1530,  1534,     0,  1531,  1532,  1439,
    1443,  1441,  1424,  1243,  1245,     0,  1183,  1490,  1491,     0,
    1215,  1556,  2302,  2301,   221,  1592,   764,     0,   299,   803,
     451,   421,  1847,   422,   802,   809,   809,     0,   451,   580,
       0,   269,   309,     0,     0,   633,   622,     0,     0,   638,
       0,     0,     0,     0,     0,   682,   313,   339,   349,     0,
     334,   894,     0,   891,   890,   574,     0,   387,   386,     0,
     430,     0,   513,     0,   631,  1012,   527,   561,   562,   557,
       0,     0,   459,   370,   379,   355,   403,   402,   399,   398,
     400,   401,   396,   395,     0,   449,   445,   446,     0,  1013,
       0,  1062,     0,   796,   864,     0,     0,     0,   492,   487,
       0,  2133,  1280,     0,  1268,   733,  1468,     0,  1469,     0,
       0,  1536,  1535,  1549,  1551,     0,     0,  1564,  1488,   781,
       0,   782,   806,   425,     0,   799,   798,   412,   580,   407,
     300,     0,   625,   632,   623,   633,     0,     0,  1056,     0,
    1057,  1058,  1061,   352,   889,   893,   892,     0,   416,   417,
     418,     0,   389,   426,   427,     0,   516,     0,     0,     0,
       0,   377,   438,   354,  1014,  1015,   304,     0,   863,   866,
     977,  2136,  2138,  2137,     0,  1290,  1470,  1539,  1526,  1537,
       0,     0,  1560,     0,     0,     0,     0,   809,     0,   580,
       0,   419,   408,     0,   624,   640,   639,     0,     0,     0,
       0,     0,   428,     0,   429,   450,   630,     0,   563,     0,
       0,   449,   797,   811,   976,   975,     0,  2134,  1552,  1553,
    1948,     0,  1925,     0,  1562,  1565,  1563,  1557,   299,   800,
       0,   409,   423,   430,     0,  1059,   564,   435,     0,   434,
       0,   432,   431,   620,   567,   303,  1303,   959,   970,   958,
     960,   968,   965,   967,   966,   964,     0,  1569,  1568,  1567,
    1571,  1570,   783,     0,   580,   626,     0,   433,   437,   436,
     572,     0,   565,   568,   573,   571,   569,   570,   787,     0,
     969,   963,  1182,  1169,     0,   424,   410,     0,   546,     0,
     961,   970,  1566,     0,   566,   962,     0,   567,     0,   547
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   247,   248,  1652,  2451,  2354,  3054,  3055,   249,
     250,  1707,   251,   252,   253,   254,   255,   256,   257,  1683,
     258,   259,  1239,  1833,  2462,   260,  2266,  1037,  2141,  2142,
    2406,  2143,  2131,  1510,  1931,  1653,  1675,   262,   263,  1504,
    2123,   264,   265,   266,  1696,  1697,  1660,  1876,  4221,  2343,
    4401,  2916,  2917,   267,   268,  3020,  1778,  3022,  3023,  3487,
     851,  2429,  3842,  3843,  3475,  3476,  3849,  4085,  4086,   269,
    1830,  3083,  3560,  3084,  3918,  3085,  3919,  3086,  3920,  3047,
    3530,  3531,  3532,  3087,  3924,  4272,  3088,  2281,  1361,  1958,
    1959,  4250,  3770,  3771,  4379,  4342,  4343,  4344,  4431,  3926,
    3094,  3570,  3931,  4118,  1850,  2493,  3089,  3090,  3917,   270,
     271,  2488,  1722,  1723,  2360,  3493,  3173,   272,  1256,  3392,
    4157,  3048,  3049,   273,   839,   274,  1837,   275,   276,   277,
     278,  3534,  4119,  1727,  2964,  2965,  2966,  2967,  3443,   279,
    1835,  1728,  2471,   280,   281,   282,  2395,   283,   284,   285,
    1844,  2482,  2483,  3910,  4126,  4259,  4128,  4461,  4462,  4110,
    3860,  3861,  3862,   286,   287,   288,   289,  1829,  2454,  2455,
    3494,  1642,  1782,  2431,  2432,  3550,  3551,   290,  3801,  3802,
     878,  4348,  4324,   291,   292,  3805,  3806,   293,   294,   295,
     296,   297,   930,  1306,  1307,  2890,   298,  2158,   299,  1218,
    3007,   300,   964,  1333,  1334,   301,   302,   975,  2620,   977,
    1972,  3175,  3176,  3639,  2585,  1153,   303,   304,  2595,  2623,
     305,  1655,  2272,  2273,  3765,   306,   879,  1855,  2496,  2859,
    4282,  3772,  4048,  2800,  3355,   307,   880,  1679,  2309,  2499,
    3099,  3100,  2311,  2759,  3582,  2313,  3101,  3106,  3107,  3108,
    3578,  3586,  4151,  4152,   308,  1677,  2302,   309,   310,   311,
    1702,  1170,   312,   902,   903,   313,  4243,   314,  1276,   315,
     996,  1992,   316,  2324,  3407,   317,   318,   319,  4439,  4469,
    4470,  4471,  3591,  4406,   320,  4441,  1376,   322,   323,   324,
     842,  1190,  1191,  1192,   325,  3933,   326,   327,  2448,  3046,
    3513,   328,   329,  2267,  2849,   330,   331,   332,  1823,   333,
     334,   335,   336,  1760,   337,  1543,  1544,   338,   339,   846,
    1057,  1547,  1555,   340,   943,  1327,  1328,  1329,  1933,   341,
    1380,  2612,   944,  1320,   945,  1978,  2597,  2598,  2601,   946,
    1871,   345,  1982,  2606,  2609,   947,  2162,  2163,  2164,  2165,
    2166,  2784,   948,   966,  1266,  2507,   949,  1464,   350,   351,
     352,   353,  1061,  1062,  2101,  2749,   984,  1561,  1022,  1072,
    3731,  2179,  2180,  2200,  2201,  1570,  1571,  2190,  2192,  2802,
    2193,  2811,  2185,  3728,  4019,  2196,  2197,  1573,  1574,  2806,
     354,  2753,  2511,  2512,  2513,  3120,  3130,  3602,  3953,  2514,
    1370,  1054,  2515,  3306,  2520,  3075,  3076,  2314,  2439,  1804,
    1465,  1805,  2446,  1466,  2024,  1807,  1467,  1468,  1469,  1810,
    1470,  1471,  1472,  1473,  2008,  2065,  1474,  1475,  2043,  1101,
    1102,  1918,  2662,  1477,  1478,  3697,  3998,  3989,  2687,  2688,
    2138,  3693,  4196,  4303,  4304,  3739,  3736,  4023,  4200,  4375,
    4414,  4415,  1479,  2740,  2093,  1172,  1480,  3496,  2095,  2682,
    2761,  2762,  2255,  2006,  2629,  2645,  2646,  2659,  3222,  2666,
    2671,  3245,  3246,  2683,  2709,  1481,  2632,  2633,  3206,  2010,
    1482,  1533,  1534,  2109,  2705,  1550,  1551,  1059,  1483,  1484,
    1973,  1046,  3949,  1284,   691,  2925,  2153,  1194,   981,  1485,
    1486,  1487,  3177,  1597,   670,   671,  1139,   795,     2,    75,
     950,  3080,   358,   359,   882,   883,   884,  1258,  1259,  1860,
    1863,  1602,  2233,   672,   673,   700,  3946,  4158,  4291,   936,
     360,   361,   362,   363,  1598,  2229,  1103,    76,    84,    77,
    1104,   400,   401,  2211,   364,   812,   365,  1579,  1083,  3363,
     366,   367,   368,   369,   370,   933,   371,  1085,   372,  1086,
     373,   374,   375,   376,  1093,   377,  1581,  1582,  3758,  1583,
     378,   379,   693,   694,  1318,   380,   381,  1120,  1121,  1352,
    1353,  1608,  1623,  1624,  1625,   382,   687,   383,   384,   385,
    1614,  1615,   386,  2116,  2117,  2238,  2118,   387,  2825,  2826,
     388,  3332,  3333,  4030,  3334,   389,  2112,   390,   391,  1049,
    3368,   392,   808,   393,  1134,   674,   675,   676,  1141,   798,
    1009,   701,  1143,  2968,   800,   801,   678,   679,   680,  1953,
      78,  2833,  1954,  1489,   702,  1490,  2107,  1491,  1492,  1493,
    1494,  1495,  1631,   684,  1110,  1310,  1311,  2834,  1313,    82,
    1314,   397,  3508,  1921,  1354,  1939,  1940
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3887
static const int yypact[] =
{
   -3887,   386, 18954, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, 20272, -3887,
   -3887, -3887, -3887, -3887, 92503,   435, -3887, -3887, -3887, 58903,
   -3887, -3887, -3887,   371, 64183, -3887, 67543,   762, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, 71383, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, 51211,  1159, -3887,
     441, -3887, -3887, -3887, -3887, -3887, -3887, -3887,  1217,  6407,
   -3887, -3887, 68023, -3887,   326, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, 68503,   -66, -3887,   586,   997, -3887,   103, 10371,
   -3887, -3887, 59863, 65143, -3887, -3887, 71863,   999,   218,  1428,
    8578,  1217, 19789, 72343, -3887,  2391, -3887, 48290, -3887, -3887,
   -3887, 64663, -3887, -3887, -3887, -3887,  1077, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, 78583,  2030,   860, 48779, -3887,
   -3887, -3887, -3887, 78583, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, 72823, -3887,  1154,   541, 79063, 79543,
   61783, -3887,  1170, -3887, 78583,   777, 50730, -3887, 80023, -3887,
   -3887,  1102, -3887, 73303, -3887, -3887, -3887, -3887,   860, -3887,
   51211, 45861, 73303,    67,  1171, -3887, -3887, 80503, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,  1974,  1305, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,   -66,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,   739,
   -3887,  1197,   753,  1425,  1317, -3887, -3887, -3887, 19184, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, 93934,  1300, -3887, -3887,
   -3887,  1336, -3887,  1352, -3887, -3887, -3887,  1900, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887,   891, -3887, -3887, -3887, -3887,
    1852, 92980, 71383, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, 59383, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887,   183, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, 71383, 71383, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, 71383,  1454, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887,   253,  1715, -3887, -3887, 51211,  2149,
    2149,  1967, 93934, -3887, -3887, -3887, 52173, 78583, 78583,  1633,
   78583,  1850, 52173, 78583, 78583,  1738, 41940, -3887, 78583, 78583,
   78583, 78583, 73303, 78583,  1689, 78583, 78583, 80983, 78583,  1829,
   -3887,  2086,   540, -3887, -3887, -3887, 78583,  3152,  2030, -3887,
   -3887, 78583,  1706, 52173, 78583,  1652,  1728, 78583, -3887, 78583,
    1997,  1213, 78583,  1694, 42433,  1804, 78583, 78583, 78583, 78583,
   -3887, -3887,  1801, 78583, 78583, -3887, 81463,   704,  2045,  1969,
     534, -3887, -3887,  2164,  1748, -3887, -3887,  2168, 71383, -3887,
   68983, -3887, -3887, -3887,  1867, -3887, 73303, -3887, -3887, -3887,
   -3887, 62263,  1428, -3887, -3887, 52654, 78583,  2003, -3887, 81943,
   -3887,  2088, 53135, 82423, -3887, 42926,  2145, 82903, 83383, -3887,
   -3887, 83863, -3887, 84343,  1895, 84823, -3887, 85303, -3887,  1992,
   85783, -3887, 15381, -3887,  1791,  1872,  1803,   893, 71383, 71383,
    2575, 37575,   -66, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887,   275,  1527, 49268,  1193, 49757, -3887, -3887,  1250,  1282,
    1434,   275,  2235,  2235,    41, 71383, -3887, -3887,  1527, -3887,
     566,   -48,  1835,  1835,  1835,  1982,  1020, -3887,  1835, 78583,
   -3887, -3887, -3887, -3887, 73303, 49268, 49757, -3887,  1837,  2030,
     158,  2221, 78583, -3887, 78583, -3887, 78583, 78583, -3887, -3887,
   -3887,  2240,  1861,  2107, -3887,  1854, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887,  2050,  2055,  2066,    78,  2030,  1963, -3887,
   -3887,  2072, 26703,   -99, 71383,  2030, 50246, 73783, 90583,   261,
   62263,  2030, 86263,  1918,   540,  2090, -3887,   445, -3887,  2295,
    1925,  2143,    68,   540, 39511, -3887,  1933,   615, 73303, 94411,
   -3887, -3887, -3887, 86743,  2035, -3887,   210,  2215, 27201, -3887,
   78583,  1943, -3887,  1952,  1957,  1960, -3887, 78583,  1098,  1098,
    2348,  1098,  1238,  1247, -3887,  2608, -3887,  1171,  1217,  1971,
   -3887, -3887, -3887,  1990, -3887,  2001,  2011, -3887,   439,  2236,
   -3887, -3887, -3887, -3887,  2106,  2112,  2116,  2137,  2064,  2162,
     128, -3887, -3887, -3887, -3887,  2371, -3887, -3887, -3887, -3887,
   -3887, -3887,  2473,  2479, 59863, 59863,   587,   597,   134,   184,
   -3887, -3887, -3887,  2335, -3887, -3887,  2349, 78583,  2180, 78583,
   -3887, -3887, -3887, 87223, -3887, -3887,  2149,  1990,  2114, -3887,
     339, -3887,   615, -3887,   381,   390,   422,   768,  2117,  1385,
   -3887,   396,  2166,  3372,  2140,   710,  3148,   128, -3887, 78583,
   78583, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
    2147, -3887, -3887,  2146,    36,  1181,  7477,   800,  3236,  1016,
     459,  2325,  1382,  2423,  1214,  3837, 78583,  2153,  2381,   741,
   -3887,   529, -3887,  2222,  2359,   340, 52173,  2194, -3887, 78583,
   -3887, -3887, -3887, 52173, -3887,  2376, 43419, -3887, 78583, -3887,
   -3887, -3887, -3887,  2311, 78583, -3887, -3887,  2432, 78583, -3887,
    1835,  1068,  2216,  2586, 55540, 78583,  2257,  2631,  2272, -3887,
   -3887,  2257, -3887, -3887, 78583, 78583,  2246,   722,  2257,  2642,
    2643,  2322,  2430,   525,  1588,   100,  2554,  2257, 78583, 78583,
   78583, 78583,  2633, 52173, 78583, -3887,  2425, 74263, -3887,  2278,
    2164, -3887, -3887, -3887, -3887, -3887,  1112,  2354, -3887, -3887,
   -3887, -3887,  2599,  2114,   282,  2611,  2342,  2612, -3887,  2373,
    2634,  2140,  2635,  2346, -3887, 87703, 88183,  2637,  2147, 78583,
    2644,  2346,  2649,  2525,  2650,   282,  2651, -3887,   684,  2655,
    2526,  2656,  1538,  2346, 62743,  2657,    98, -3887, 21691, 15381,
   -3887, 22252,  1216, -3887, -3887, -3887, -3887, -3887, -3887, 30687,
     609,  2433, -3887, -3887,  1171, -3887, -3887,  1705, -3887, 47801,
   -3887,  2575,  1527, -3887, 71383,  1527, 71383,    41,  1527, 71383,
    1527, 71383,    41,  1527, 71383, 71383, 71383,  1527, -3887, -3887,
    1634,  1727, -3887, -3887, -3887, -3887, -3887, 71383,  2374, 78583,
   78583, -3887, -3887, -3887, 65623, 78583, 66103, -3887,   784, -3887,
      63, 71383, -3887, 71383, -3887,  2030, -3887, -3887,  1872, 55540,
    2765, 78583,  2658,  2658,  2658, -3887, -3887, -3887,  2602, 78583,
    2662,  2664, 65623, 78583, -3887, 88663,  2385, -3887, -3887, -3887,
   -3887,  1729,  2476,   249,  2638, 30687,  2387,   288,   288,  2393,
   -3887, -3887, -3887,   456,  2394,  2396, -3887,   503,   503,  2549,
    2412,  2417, -3887,   511,  2418, -3887,  2702,   522,  2419,  2420,
    2421,  1836,   288, 30687, -3887,  2424,   503,  2426,  2429,  2431,
    2713,  2436, -3887,  2723,  2438,   355,   368,  2444,  2447, -3887,
    2412, -3887,   478,  2449,  2450,  2451,  2452,  2453,  2454,  2457,
   30687, 30687, -3887, 25707,   615,  2030, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887,    73, -3887,   562,  3693, -3887, -3887,  2587,
   30687, -3887, -3887,     8, -3887,   811, -3887, -3887,   615, -3887,
   -3887,   346, -3887, -3887, -3887, -3887,  1690,  1690,   178, -3887,
   68023, 68023, -3887, -3887,  1372,  2422, -3887,   747, -3887, -3887,
   -3887, -3887, -3887, -3887, 60343,  2852, -3887,  1014,   529,  1337,
    2799, 46823, 47312,  2698,  2698,  2685, -3887, -3887, 78583, -3887,
   -3887, 30687, 44899, -3887,   615,   101,  2700, 78583, -3887, 39995,
   -3887, -3887, -3887,  1755, -3887, -3887, -3887,   -66, -3887,  9338,
   -3887,  1788,  1943, 78583, 78583,  2861, -3887, -3887,  1952, -3887,
   -3887,  1425,  1425, 30687,  1425,  1120,   994, 27699, 30687,  2748,
    2646,   678,  1329,  2751, -3887,  1238,  1247, -3887, -3887,  1990,
    2481,  1526, -3887, 57463, 93457, 93457,  2716, -3887, -3887,   803,
     853,  2589,  2683,  2235,   876,   366, -3887, -3887,  2477, -3887,
    2810, 68023,  2540, 59863, -3887, -3887, 78583, -3887, -3887, 74743,
   -3887, -3887, -3887,  1817,  2487, -3887,  2504, 78583,  2980, -3887,
     366,   366, -3887, -3887,  2490, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, 93934,  2496, 78583, -3887,  2499,  2500, -3887,
   94411, 45380,  1450,   615,  2572,  2573, 51211,  2506,  2579,  2580,
   91063, -3887, -3887, -3887, -3887,  1270,   967,  1001,  2583,   622,
   -3887, 78583,  2688,   128,  2626, -3887,  2588,  2590,  2708,   128,
     935, 91543, -3887, -3887, -3887, -3887, -3887,  2979, 23753, -3887,
   -3887, -3887,  2597,  2568, 60823,  2888,  2705,  1129,  1716,   122,
   78583,  2782,  2603,  2604,  2535,  1657,  2533, -3887,  2699,  2593,
    2594, 54578,  2706, 43912,  2864,  2609, -3887,  1313,  2616,  2619,
     128, -3887,  2928,   128,   128,  1518,  2930,  2623,   594,  1316,
    2257,  2533,  2361, -3887,  2557,  2624,  1600, -3887,  2728,   115,
    1400,  2533,  2630,  2636,  2535,  2535, 78583, 78583, 78583, 78583,
   78583,  2652,  2660,  2679, 69463,  2663, 90583, -3887, -3887,  2665,
    1630,  2533,  1290, -3887,  1368, -3887, -3887,   540, -3887, 78583,
   -3887, 78583,  2114, 55540,  2739,  2140,   128, 78583, 78583,  2147,
    1291,   835,  2741, 78583,  2802,  2605, -3887, -3887,  2257, -3887,
   45380,  2246, -3887,  2574, -3887,  2615, -3887,  2615,  2615,  2592,
    2592,  2596, -3887, -3887,  1836,  2615,  2592, -3887, 56502, -3887,
    1288,  1440, -3887,  2974,  2981, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887,   926, -3887,  1802, -3887, -3887, -3887,
    2992, -3887, -3887, 55540, 78583, -3887,  2915,  2647, 51211, -3887,
    2639, -3887, 78583,   192,  2030,  2645, 78583,  2814, 78583, 78583,
   78583, 78583, -3887, -3887,   621,    35, -3887, 69463, -3887,  2361,
    3001,   560,  1835,  2889, -3887, 78583,  2613,  3002,  2841, -3887,
   -3887,  2614,  2235, -3887,  2278, -3887,  1582, -3887,  2733, -3887,
   34657,  2667, 52173,   282, -3887, -3887, -3887, -3887, 55540, 78583,
   89143, 52173,   282, 78583, 78583,  2904,  2670,  2912,  2674, 43912,
     282,   114, 78583, 78583, 78583, 78583, -3887, 78583, -3887, -3887,
   -3887, -3887, 78583, 78583, 78583, 69463,  2916,  2918,   282, 78583,
   78583, -3887, -3887, 21779,  1479, -3887, 15381, -3887,  9338,  1810,
    2698, -3887,  1454, 78583,  1113,  2575, 66583, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, 71383, -3887, 71383,    41, -3887,
   -3887, 71383, -3887, 71383,    41, -3887, 71383, -3887, -3887, -3887,
   71383, 78583,  3117,  2629, -3887,   346, -3887, 78583,  1814, -3887,
   -3887,  1831,   527, 78583,   106, 52173, 78583,  2812, 78583, 78583,
   78583, 78583,  2710,  2422,   273, -3887,  2680, 39027,  2761, -3887,
     213, 73303,  2821, -3887, -3887, -3887, -3887, -3887,  1846,  1556,
    1063, -3887, -3887, -3887, -3887, -3887, -3887, 66103, 64663,  2917,
      46, 78583, -3887, 30687, 26205, -3887, -3887, -3887,  2648,  9338,
    2678, 30687, -3887, -3887, 30687,  2235,  2235, 30687, -3887, -3887,
   -3887, -3887,  1797,  2235, -3887, 30687, 30687,  2235,  2235,  2615,
    2615, -3887,  5182, 30687, -3887, 43912, 30687, 32181, 23254, 30687,
    2715,  2661,  2235, -3887,  2235, -3887, 30687, 25209, -3887, 30687,
    2847, 30687,  1337,  2854, 30687,  1337,  3064,  3064,  2056,  4596,
    2659,   615, -3887,  2756,  2235, -3887,  2235,   810,   222, 55540,
   30687, 51211,  2730,   124, 30687,  2666,  1766, -3887, 30687,   734,
   -3887,  2668, 30687,  2734, 30687, 30687, 30687, 30687, 30687, 30687,
   30687, 30687, 30687, -3887, 33177,   306, -3887,   -42,   887, 67063,
   26703,  2935, -3887, 22755, -3887,   277, 71383, -3887, -3887,   615,
   -3887, -3887, -3887, -3887, -3887,  1817,  2669, -3887,  2676, -3887,
   -3887, -3887, -3887, -3887, 78583,  2852, -3887, -3887,  2735, -3887,
   -3887, -3887, -3887,   851, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887,  2672, -3887, -3887, -3887, -3887,  2672, -3887, -3887,  2698,
    2675,  4114, -3887, -3887, -3887, -3887,  2926,  2931,   282, 93934,
   -3887, 78583,   113, -3887, -3887, -3887,  2684, -3887, 78583,   210,
   69943, -3887, 27201, -3887,  1847,  2412, -3887,  2919, -3887,  2677,
   -3887,  7222,  2919, -3887, -3887,   148,  2850,  2856,  2856, -3887,
    2686,  9338, -3887,  1684,  9338,  1746, -3887, -3887, -3887, -3887,
   -3887, -3887,   -30, -3887,  2748,  1329,  1628, -3887,  1990, -3887,
   -3887, 20749, -3887, 21228, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887,  2681, -3887, -3887, -3887, -3887,   128,  2682,
    3147, -3887, 59863, -3887, -3887, -3887,  3117, -3887,  2168, -3887,
    2168,  3179, -3887, 71383, -3887, -3887, -3887, -3887,  1153, -3887,
   15381, -3887, 15381, -3887,  2691,  1860,  2763,  2764,  2813, 78583,
   78583, -3887, 51211, 78583, 78583, 78583, -3887,  3047,   461, 64663,
    2815, 63223, -3887, -3887,  2697, 78583,  2749,  2932,  2933,  2701,
   -3887, -3887, 78583, -3887,  2890, 78583, 30687,  2893, 78583,  1069,
    2894, -3887,  1110, 78583, 78583,  2886, -3887, -3887, -3887, 62263,
   -3887, -3887, -3887,  2880, -3887, -3887, 56502, -3887, -3887,  1864,
   -3887, 56021, 53616, -3887, -3887,   270, 78583, 78583, 78583,  1172,
   -3887, -3887, 55540, -3887, 78583, 78583, 78583, 70423, 89623, 90103,
    1133,  1223, 78583, 70903, -3887, 78583, 78583, 78583, 51211, -3887,
   78583,  2891,   159, -3887,  2027,  2785, 78583, 78583,  2714,  1868,
    2788, -3887, 78583, 78583,  3573, -3887, 78583, 78583, -3887, -3887,
     128, -3887, -3887, -3887, -3887, -3887, 78583, 78583,   128, 78583,
     128,  1100, -3887, 51692, 78583, -3887, -3887, -3887, 78583, 78583,
   78583, 78583, 78583, -3887, -3887,  1202,    28,  2851,  2853,  2855,
   78583, 78583, 78583, -3887, -3887,  2830, -3887, 78583,  3573, 78583,
   78583,  2795,  2797,    80,  2867, -3887, -3887, -3887, -3887, -3887,
   -3887,  2962,  3124, 78583,  2965,  2966,  2783,  2784,  2969,  1719,
   78583, 78583, 78583, 78583, 78583, 78583,  2971,  1719,  2913,   513,
    2742,  1875, -3887,  2752, -3887, 30687,  3138, 55540,  2753,  2755,
    2816, -3887,  2819,  2235, -3887,  1885, -3887,   621,  1783, -3887,
     610,  6363,  3030, 78583,  1915, -3887,  2767, 78583,  6363, -3887,
     605, 64663, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887,  3034, -3887,  2030,  2246,  2246,  2246,  2246, -3887, -3887,
   -3887,  2936,  1598, -3887,  2757, 78583,  2865,  6363, -3887,  2361,
    3046, 78583, 61303,  1757,  3154,  2030,  2937, -3887, 24238,  3033,
    2939, 62263, 74263, -3887,  2768,  3029,  3031,  3049, -3887, 34173,
   75223,  2769,  2099, -3887, 75223, 75703, -3887,  2773,   615, 28197,
    2761,  2114, -3887,  3169, -3887,  3068,   282,  2140, -3887,  2346,
   -3887, 78583, 78583, 78583, 78583,  2147, -3887, -3887,  2346,  2953,
     282,   282, -3887,  2955,   282,  2346,  2895,  3063, 62263, -3887,
      98, -3887, -3887, -3887, -3887, -3887, 30687, -3887, -3887,  2787,
    1582, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, 71383,  2168, -3887,  1930, -3887, 78583, -3887,  3040,
    3045,  3050,  2346,  2824, 78583,  2793, -3887,  2346,   128,  2346,
    2422,  2422,  2346, 76183,  3203,  3067, -3887,  1934, -3887, -3887,
   26703, -3887,    86, -3887,   110,   -10,  3004, -3887, -3887, -3887,
   -3887, 55540, -3887, -3887, -3887, -3887, -3887, 78583,   119,  2977,
    2803, 76183,  3178,   282, -3887,  1939, -3887,  1578, -3887,  1583,
   30687, 30687,    54, -3887,  8397,  1944,  2806,  2807,  1948, -3887,
   -3887, -3887, -3887, -3887, -3887,  2808,  3086, -3887, -3887,  2811,
    1961,  1975,  2818,  2820, -3887, -3887,  4514,  2822,  8758,  2825,
   32181, 32181,  1220, -3887, -3887, 32181,  2826, -3887,  1979,  7923,
    2831,  2827,  2832, -3887,  2835,  2838,  9061, 28695, 30687, 28695,
   28695,  9185,  2831,  2839,  1986, 51211,  9072,  1987, -3887, 30687,
   51211,  4541, 30687, -3887, 30687, 78583,  2840,  2844, -3887, -3887,
    5182, -3887,  2833, -3887, 32181, 32181,  2491, 25707, -3887, -3887,
    3088, -3887, -3887,  1834, -3887,  2817, -3887, -3887,  4010,   140,
   30687,  2666, 30687,  2884, 43912,  9950, 30687,  7251,  2129,  2129,
     188,   188,   129,   129,   129,  1733,   887, -3887, -3887, -3887,
    2842,  2436, 30687, -3887,  2078,  2079, 78583,  9582, 10383, -3887,
   -3887, -3887, 34657,  2858, 30687, 30687, 30687,  2848,  3013,  3262,
    9338,   685, -3887,  3264, -3887, -3887, -3887,   370,  3179,  1817,
   -3887,   540,  2235,   810, 47801, -3887, -3887, -3887, 30687, -3887,
   -3887, -3887, -3887, -3887,  2015, 39995,  2667, 27201,   615,  1952,
   -3887, -3887, -3887, -3887, -3887, -3887, 30687, -3887, -3887,   499,
    1808, 30687,  1684, -3887, -3887, 78583,  2821,  2821, 30687, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,  1380, -3887, -3887, -3887,
   -3887, -3887, -3887,  2859, -3887,  2863, -3887,  2870, -3887, -3887,
   -3887, -3887,   155,  2872,  2875,  2874,  1457, -3887, -3887, 78583,
   78583, 78583, -3887, -3887, -3887, -3887, -3887, -3887,  3073, -3887,
   78583, 78583,  3036, 78583,  3035,  3054, 30687,   945, 78583,  2882,
    2885,  2887, 78583,   282, -3887, -3887,  9338, -3887, -3887,  2906,
    2956, 78583,  2728, -3887,  3132, -3887, -3887, -3887, -3887,  3072,
   -3887, -3887,  1802, -3887, 53616, 56021, -3887, 56021, -3887,  1802,
    1592, -3887,  2346, -3887, -3887,   637, -3887, -3887, -3887, -3887,
   -3887,  3181,   282,  3183,   282, 78583, 78583, 78583, 78583, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,  2022, -3887,  1418, -3887,
   -3887, -3887, -3887, -3887, 78583,  1349, -3887,  1143, 55540, -3887,
   55059, 78583, -3887, -3887,  3113, -3887, -3887, -3887,  3052, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887,  1876, -3887,  3053,
   78583,  2950, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, 51211, 51211, 51211,  2032, -3887, -3887,  2030, -3887, -3887,
   -3887,  2973, -3887, -3887, -3887,  3109,  3116,  3118,  2982,  2983,
    2986,  2987, -3887,  2988,  2990,  2991, -3887, -3887, -3887, 78583,
   -3887, -3887, -3887, 78583, 78583, -3887, -3887, -3887,  1719, 55540,
    3141,  1719,  1719, 78583, 78583,  1719, -3887, -3887, -3887,  3144,
    3145,  3160,  3161,  3168,  3170,  1719, -3887, -3887, -3887, -3887,
    1068, 51211, -3887,  1973, -3887,  1867, 41447,  4651,  2942,  2755,
    2941,  2235, 37091,  1015,  3149,  2943, -3887,  1627,  3162,  2963,
    2963,  2963,  2963,  2963,  2963,  2963, -3887,  2707, -3887,  3119,
   78583,   579, 78583,  2235, -3887, -3887,  3015, -3887, -3887, 51211,
   41447,  1835,   192,  3089,   735,  3284, -3887, -3887, -3887, -3887,
   -3887, 78583, 78583,   621,  2030,  2036, -3887, 55540, 78583, 71383,
    1974,  2958, 78583,  2959,  2967, -3887, -3887, -3887, -3887,  2042,
   -3887, 55540,   575,  3137,  3143,  1974,  3041, 78583, -3887,  2052,
      72, -3887,  2030, 62263, 54097, -3887,  2200, -3887, -3887,   898,
    3238, -3887, 78583, -3887, -3887, 38543, 36109,  2099,  2975, 78583,
   -3887,  2984, 34657,  3205,  3157, -3887, 34657,  3157,  1318,  3157,
    3208, -3887, 40479, -3887,  2993, 22755,  1720,  3159,  9338, -3887,
     282, 55540, 78583, -3887,   282,  3044,   282,  3051,   282,   282,
   78583, -3887, -3887, 78583, -3887, 78583, 69463,   282, -3887,  9338,
   78583,  3259, -3887, -3887, -3887, -3887,  3112,  3121,  3123, 78583,
    2346, 52173, -3887,  2999, 78583,   907, -3887, -3887,  3175, -3887,
    1974, 78583,   615,   182, -3887, -3887, -3887, -3887,  3306,  3307,
   -3887, -3887, -3887, 78583, 65623,   146, 78583, -3887, -3887, -3887,
   -3887,  3020,  2059,  9895, 30687, -3887,  3319, 55540, -3887, -3887,
   -3887, -3887, -3887, 30687, -3887, -3887, -3887, -3887, -3887, 30687,
   -3887, 30687,  3297, -3887,  3437,  3437, 55540, 32181,  1279,  2426,
   32181, 32181, 32181, 32181, 32181, 32181, 32181, 32181, 32181, 33675,
    1401, -3887, -3887, 30687, 30687,  3304,  3297, -3887, -3887,  1364,
    1364, 55540,  3024,  2831,  3025,  3027, 30687, -3887, -3887,  2062,
   51211, -3887, 30687,  8251,  2067,  3069,  9263,   615,  4995, -3887,
    3398,  2030, 30687,   774,  1551, 30687,  2077, 30687,  3311, -3887,
   -3887, -3887,  3032, -3887, -3887, 55540, 30687, 32181, 32181,  5299,
   -3887,  5891, 30687,  3037,  7111, 25707, -3887,   860,   860,   860,
     860, -3887, 78583, 78583,  2769, 30687,  3308,   530,   530,  3038,
    3013, 40963, -3887, 30687,  1761, 29193,  3055, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887,  3043, -3887,  3060, -3887, -3887,   529,  3057, -3887,
   -3887,  7099,   155,  3065, 78583, -3887,  2761, -3887, -3887, -3887,
    3059, -3887,  1808, -3887, -3887, -3887,  5097,  3223,  2422, -3887,
   -3887, -3887,  2235,  3066, -3887,  2168,   370, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887,  2963,  2346,  2346,   712,  2346,
    3334,   712,  5653, -3887, -3887, 35141, 78583, 78583,  2082, -3887,
   -3887, 78583, -3887,  2117, -3887, -3887,  3309,  1697, -3887, -3887,
   -3887,  3127,  2707,   820,  2535,   785, -3887,  3128, 78583, -3887,
   78583, -3887, -3887, -3887, -3887, -3887, -3887, 51211, 41447, 51211,
   -3887,  3130,  3139,    89,   616,  3146,  3150,  3061,  3076,  3078,
   -3887,   275,  2030, -3887, -3887,  2030,  2346,  2030, -3887, -3887,
   -3887, -3887, 51692, -3887, -3887, 78583,  3353,    97,  1611, 78583,
   78583, 78583, 78583, 78583, 78583, 78583,  2728, -3887, -3887, -3887,
    3080,  1719, -3887, -3887,  3316,  3317, -3887,  1719,  1719,  1719,
    1719,  1719,  1719, -3887,    69,  2087, -3887, 36594, -3887, -3887,
    2631,  2631,  1094, -3887,  2631, -3887,  2631, -3887, -3887,  2752,
    3059,  2235,   366, -3887, -3887, -3887, -3887, -3887, -3887,  1182,
    2235,  1859,  3091, -3887, 38059, -3887, -3887, -3887,  2188,   810,
   78583,  2963, -3887,  2157,  1889,  2330,  2392, 76663, 77143, 77623,
    3085, 78583, 32181, -3887,  1422,   173, -3887,  3318, 78583,  3125,
   -3887, -3887, -3887,  3093, -3887,  2346, 78583, 78583,  2346, -3887,
   55540, -3887, -3887,  3489,   893, 78583,  3126,  3095,  3379, -3887,
    3100,  3099, -3887, -3887, 78583, -3887,  3119,  1803,  3136, 63703,
    1757, -3887,  3354, 61303, -3887, 78583, -3887, -3887, -3887,  3462,
    3185,  3142,  2030,  2749, -3887, 53616, 30687, 30687, -3887,  3114,
   -3887,  3122,  3861, -3887,  2246, -3887, -3887, -3887, -3887, -3887,
   -3887,  3186, 78583,  3536, -3887, -3887, 75223,  3131, 78583,  2099,
   34657, -3887, -3887,  1283, -3887, 34657,  3352, -3887, 34657, 78583,
    3134, 78583,   946, 78583, -3887,  3135,   282, -3887, 78583, -3887,
   78583, -3887, -3887,   282,   282, -3887,  3229, -3887, -3887,  1974,
   78583, 78583, 78583,  2346, -3887,   128, -3887,  3394, 76183, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,    46,  3400, -3887, -3887,
   -3887, -3887, 30687,  9338, -3887,  3151,  9338,  5700,  9338,  3304,
   -3887,  2182,  3402, -3887,  1169,  3155,  2182,  1620,  1620,   291,
     291,   117,   117,   117,  3437,  1401,  9338,  9338, -3887, -3887,
   -3887, -3887,  3153, -3887, -3887, -3887,  2831, -3887, 31185, -3887,
   -3887,  3163,  3167,  3156, -3887, 30687, 31683,  3140, 56502, -3887,
   -3887,   810,  3064, 32181, 32181,  1514, -3887,  1309, 30687, 55540,
    2125,  1514,  2213,  2256, 30687, 30687,  7771,   378, 30687,  5918,
   78583, 78583, 78583, 78583, -3887, -3887,  9338,  3515,  3403, 30687,
    3158, -3887,  3165,  3013, -3887, 92023, -3887, -3887,  9338, -3887,
   -3887, 30687, -3887,  3013,   370,   216,  2030, -3887, -3887,  1171,
   -3887, -3887, 43912, -3887, -3887, -3887, -3887, 15381, -3887, -3887,
   -3887,   275, -3887, -3887, -3887,  3209, 64663,  3419,  1182, 30687,
    2126, -3887,  3180, 78103, 24723,  2134,  2141,  3125, -3887,  2506,
   -3887,  3206, -3887,  3329, -3887, -3887,  3331,   275, 78583, -3887,
   55540,   282,   282, -3887, -3887,  3164, 78583, 78583,  2235,  2235,
   55540,  3166, -3887,  2235,  2235,  3173, -3887, 78583, 78583, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, 78583, 78583,
   78583, 78583,  3439, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887,  3392, -3887,  1719,  1719, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887,  2257,  3477, -3887, 51211, -3887, 58423, -3887, -3887,
   -3887,  2030,  2030,  3347, 46342,  2030,  2030, -3887,  1451,  3491,
   -3887,  3418,   869,  3174,  1509,  3450, -3887,  2020, 38059, 38059,
   38059, 38059, 38059, -3887, -3887,  3453,   275, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, 30687,  1000,  2182, -3887, -3887, -3887, -3887,  3125,
    1835,  3230, 51211,  2346,  2346,  3231,  1974,   574, 78583,  3482,
    3219, -3887,  2030, -3887, -3887, -3887,   864, -3887,  2155, -3887,
   -3887, -3887,  3216,  3143,  1151,  3184,  1757, -3887, -3887,   708,
   78583, -3887,  1334, -3887,  3461,  3189, -3887,  9338,  9338,  2030,
   56983,  2200, -3887, 78583,  3438, 78583, -3887, -3887, 78583,  2160,
   -3887, 30687,  3190, -3887, -3887, 34657,  1283,  2183, 78583,  2189,
   55540,  3013, -3887,   282, -3887,   282,   282, -3887, -3887, 78583,
    2346,  2346,  2346, -3887,  3364, -3887,   282, 76183,  9338, -3887,
   -3887, -3887, 32181,  3470, -3887,  3196, 55540, -3887,  3198,  2218,
    2224, -3887, -3887, -3887,  5958,  3245,  9338,  3295,  3201,  3211,
   -3887,  1497,  1497,  1309,  2227, -3887, 32181, 32181,  1514,  1514,
   30687,  1514, -3887, -3887, -3887, -3887, -3887, 30687, 30687,  3240,
    3013,  3013, -3887,  3362, -3887,  3213, -3887, -3887,   366, -3887,
   -3887, -3887, -3887,   810, -3887,  3217, -3887, -3887, 76183,  3381,
   76183, -3887,  6197,  3125, 35141, 44405, 78583, -3887,  1018,  1018,
    3345,  3125,  3230, -3887, -3887, -3887, -3887, -3887,  3260, -3887,
   -3887, 41447, -3887, -3887, 35625, 43912, -3887,    89,  3222,  3224,
     616, -3887, -3887,  1188,   986,  3250,  2346,  3499,  1719, -3887,
   -3887,  2742,  2030, -3887, -3887,  2232, -3887, -3887, -3887, 78583,
   -3887,  3095, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   52173,  3617,  3617, -3887,  1501,  1501, -3887, -3887, -3887, 78583,
    1182, -3887,  6666,  3409, -3887,  3230,  3436,  3480, -3887,  2237,
   -3887, 78583,  3142, 61303,  3119, -3887,  1243,  3235,  3520, -3887,
   -3887,  3564, -3887, 63703,  3408,  3185,   425,   425, 78583,  3143,
    3361, -3887,  3363, -3887,  3613,  3420,  3616, 78583, 35141, -3887,
   56021, -3887,  2259, -3887, -3887,  2858, 78583,   610, -3887,  3265,
    2263, -3887,  9338, 78583, -3887, -3887, -3887,  2264, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887,   146,  1507, 32181, 55540,  2291,
   30687, -3887, 30687, -3887, -3887, -3887,   598, -3887, -3887, -3887,
    1497,  1497,  1514,  2831,  9338, 78583, -3887, -3887, -3887,  3633,
    3424,  3013, -3887, -3887, -3887, -3887,   907,   712,   146, 78103,
    3230, -3887,  3257, -3887, -3887,  1808,  1808, 78583,  3230,  1182,
   30687, -3887, -3887, 55540,  2140,   -29, -3887, 55540, 55540, -3887,
   78583, 78583, 78583, 78583, 78583, -3887, -3887, -3887, -3887, 58423,
    3095,  3617,  1011, -3887, -3887, -3887,  3540, -3887, -3887,   697,
    3441,  3341, -3887, 51211,  3549, -3887, -3887, -3887, -3887, -3887,
   30687,  3412, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887,  2299,  3185, -3887, -3887,  3443, -3887,
    3444, -3887,  2304, -3887, -3887,  3861, 56983,  3583, -3887, -3887,
    2344,  3682, -3887,  2309, -3887, -3887,  1507,  2313, -3887,  2314,
    2317,  3326, -3887,  3278, -3887,  3676, 30687,  1466, -3887, -3887,
    3558, -3887,  1018,  3320, 43912, -3887, -3887,  1835,  1182, -3887,
    9338,  2324, -3887, -3887, -3887,  3425,  2329,  2333,  3283,  3321,
    3283, -3887,  2346, -3887, -3887, -3887, -3887,  3592, -3887, -3887,
   -3887,    95, -3887,  3464,  3465, 78583, -3887, 78583,  3686,  6959,
   52173,  2707, -3887, -3887, -3887, -3887,  3327, 35141,  2200, -3887,
     200, -3887, -3887, -3887, 78583, -3887, -3887, -3887, -3887, -3887,
   78583,  3298,  2831, 29691, 29691,  3294, 76183,  1808,  3300,  1182,
    3296,  3436, -3887, 52173, -3887, -3887, -3887, 78583,  3426,   565,
     565,  3621, -3887,  3358, -3887, -3887, -3887,    89, -3887,  3301,
    2535,  3185, -3887, -3887, -3887, -3887,  1890, -3887, -3887, -3887,
   32679,  3427,   854,  8748, -3887, -3887, -3887, -3887,   146, -3887,
   30687, -3887, -3887,  3441,  2140, -3887,  3219, -3887,  3718, -3887,
     177, -3887, -3887,  3166, 57943, -3887,  2858, -3887,  2139, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,  3708, -3887, -3887, -3887,
   -3887, -3887, -3887,  6983,  1182, -3887,  3603, -3887, -3887, -3887,
   -3887,  2334, -3887, -3887, -3887, -3887, -3887, -3887, -3887,  1513,
   -3887, -3887,  1669,  1960, 30189, -3887, -3887,  3457, -3887, 57943,
   -3887,  2139, -3887, 52173, -3887, -3887,  3315, 57943,  2337, -3887
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3887, -3887,  3463, -3887, -1147,   -80,  2076,  -856, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887,  1360, -3887, -3887,   -56,  1711,  2302,  1052,
   -3887, -1307, -3887, -3887,  -851,   170,  -966, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887,   879,  1483,   933,  1845, -3887, -1659,
   -3887, -3887,   412, -3887, -3887, -3887,   813,  -246, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887,    -7, -3887, -3887,  -400, -1750,
    -107, -3887, -3887, -3887, -3887,   278,  -293, -1520, -3887, -2821,
   -3887,   -51, -3887, -3887, -3887,  -294, -1625,   991,  -957, -1324,
    1274,  -526, -3887,  -188, -3887,  -564,  -484,  -482,  -519, -3887,
   -3350, -3638, -3608, -3748, -3887, -3887, -3887,   307, -3887, -1738,
   -3887, -3887,  2024, -1569, -3887,  -981, -3887, -3887, -3887, -3402,
   -3887,  1585,  -282, -3887,   -16, -3887, -3887, -3887, -3887, -3887,
   -3887, -3381, -3887, -1657, -3887,   434, -2855,   915, -3887, -3887,
   -3887,  2043, -3887, -3887, -3887, -3887, -1753, -3887, -3887, -1729,
   -3887,  1432,   812, -3887, -3887, -3887,  -539,  -598,  -589, -3887,
   -3596,    26,    30, -3887, -3887, -3887, -3887, -1199, -3887,   834,
   -2936, -1115, -3887, -3887,   870, -3887, -3887, -3887,  -501,  -169,
    2073, -3887,  -425, -3887, -3887, -3887,  -168, -3887, -3887, -3887,
   -3887, -3887, -3887, -1870,  2796, -1103, -3887, -3887, -3887, -3887,
   -2307, -3887,  3713,   -18,   290, -1720, -3887,  -200,  -114,  2537,
   -1332, -2553,   266,  -301, -3887, -1917, -3887, -3887, -3887, -2473,
   -3887, -3887, -3887, -3887, -3255, -1718, -3887, -3887, -3887,   333,
   -3887, -3709, -3579, -3314, -3209, -3887, -3887, -1276, -3887, -3887,
   -3887, -1567,  1595, -1638, -3887, -2226,   334, -3420,  -972, -3018,
   -3887, -3389,  -375, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -1275,  -834, -3887, -3887,  3010, -3887, -3338, -3887, -3887, -3887,
   -3887,   797, -3887,   -59, -3887, -3887, -3887, -3887, -3887, -3887,
    -493,  -567, -3887, -3887, -3887,   237, -3887, -3887, -3887, -3887,
    1853, -1144,  -971,  2873, -1717,  -207, -3887, -3887, -3887, -3887,
   -2812, -3887, -3887, -3887, -3887, -3887, -3887, -3887, -1329, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,  1751,  1747,  -113,  -212,
   -3887, -3887, -1478, -3887,  -811, -3887,  1995, -3887, -3887, -3887,
   -3887, -3887,   252,   365,   -76, -3887, -3887,   743, -2373,   -74,
   -3887, -3887, -3887, -3887,  -591,   -71, -3887,  1140, -3887, -3887,
   -2043, -3887,   298,    93,  2617,  1366,   -72,    -9,  -245,  -236,
    -215, -3887,  2881,  2380, -3887, -3887,  -219,  1563, -3887, -1051,
    -339, -3887,  1138,  -878,  1737,  2372,  2378, -3887,  1136, -3887,
   -3887,  1149, -3887, -3887, -3887,  -875,  1750, -3887,  2384,  1770,
   -3887,  1805,  1207, -2395,  1455, -2379,   837,  -436,     7,  -130,
    2920,  3070, -3887, -3886,  1184, -3396,   417,   199, -2037, -1749,
   -3887, -3887, -1362,  7407, -3887, -3887, -3887,  8952, 10278, -3887,
   -3887, 11799, 13519, -3887, -1221,   702, 14030,  4797, -1393, -1756,
   -1492, 14665, -2415, -1090, -1696, -3887, -3887, -3887,  -206,   711,
     137, -3887, -3887, -3887,  -392, -2604,  -391, -3887, -3887, -3887,
    -395, -3072,  -330, -3887,  -823, -3887, 15425,  1183, -3887, -1300,
   -2483, -2608, -1353, -1903, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -1338, -3042,  -394,  1260, -3887, -3887,  1351, -3887, -3887,
   -3887, -1452, -1104, -1974,  1265, -2005, -3887, -1059,  1386,  1888,
   -1013,  4580,  1739, 12703,  -129, -2257, -1518, -1414, -3887,  -661,
   -3887,    59,  1660,  -159,   -84,   -50,   225, -2889, -3887, -3887,
     311, -3887, -3887, -3887,  3355,   873, -3887,  2732, -3887,  1488,
    2130, -3887, -3887,  1763,  -913,   -22, -3887,  -367, -3887,  -138,
   -3887, -3887, -3887,   138, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887, -3887, -3887,  2413, -3887, -3887, -1407, -3887, -3887, -3887,
   -3887, -3887,  3634,  -304, -3887,  3071,  -296, -3887, -3887, -3887,
   -3887, -3887, -3887, -3887, -3887, -3887,  2427,  1792, -3887,  2871,
   -3887, -3887, -3887,   -43,  2654, -3887, -3887, -3887, -1169,  -599,
    2892,  2902,  1754, -3887, -3887, -3887, -3887, -3887, -3887, -3887,
   -3887,  1771, -3887, -3887,  1244, -2051,  1780, -3887, -3887,   657,
   -3887, -3887,   281, -3887,   663, -3887,  2536, -3887, -3887, -3887,
     694, -3887, -3887, -3887,  -572, 10479,   245,   -97,   102,  1375,
   -3887,  5896,  8114,   -85,  2456,    25,  8491, 14323,   195, -3887,
    3637,  1790,  1470,  -996, -3887,   -46,  2089, 13807, -3887, -1108,
      23,    -2, -3887,  2641,  -649, -1142,  2737,  -689, -1865, -3887,
    4046, -3887, -3021, -3887,  -998,  3090, -1177
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2404
static const yytype_int16 yytable[] =
{
      80,  1065,   343,  1171,   344,  1882,   348,   346,   968,  1048,
    1015,  1628,  1073,  1890,  1505,   893,  1362,  1363,  1577,  1919,
     796,  1367,  1930,   881,  1575,    79,  1988,  1706,   355,   968,
    1236,  2280,   799,   794,   355,  2339,  1961,  1747,  1643,  2550,
    2312,  1171,   877,   681,  1526,  1647,  1846,  1758,  2586,  2436,
    1268,  2554,   942,  2045,  1118,  2018,  2019,   976,  2444,  2321,
    1999,    74,  1080,  1518,  2767,   796,   990,   355,  3195,   349,
    1081,  2377,   692,  3402,  2034,  2383,  2384,   799,   794,  1821,
    2176,  1288,  2155,  2463,  1825,  2886,  2888,   683,  3585,   840,
    2927,  1831,  1171,  1045,  2486,  2464,  1016,  2218,  2220,  2221,
    1848,  2628,  1053,   395,  2465,  1122,  3438,  1781,  3440,   395,
     692,  2310,   355,  2466,  3117,  2467,  2468,  1075,  2783,  1596,
    3016,   969,  3179,  1626,  3542,  1006,  3767,  1067,  2261,  1323,
     885,   892,  1006,   796,  1006,  3131,  3133,  3497,  1076,   852,
    3901,   892,   969,  3753,   929,   799,   794,  3139,  3309,   965,
     886,  1920,  2546,  2372,  3312,  1138,   349,   904,  1873,  1007,
    1036,  1154,  3941,  2060,  2320,  1945,  1007,  2793,  1007,  1915,
     965,  3497,  4041,  2816,  2516,  3914,  1698,  2212,  2212,  1512,
     355,  1676,   892,  1654,   982,  3367,  2012,  2013,  2114,   698,
    3944,  2155,  1222,  2788,  1569,  4049,  3057,  1572,  1617,   704,
     416,  1604,  1605,  3678,  1113,  3226,   416,  2063,  1845,    43,
    3923,  2031,  2832,  3957,    45,  3959,  2836,  2069,  1748,   797,
     416,  1618,   399,   850,  2330,  1874,   967,  2995,  3514,  3515,
    3516,  3517,  3518,  3519,    45,   844,  2703,  1064,  1135,  1262,
    2484,  1874,  2072,  1312,  1273,  3224,  3225,   967,   261,   895,
    3240,  1281,  2703,  3576,  3204,  2156,   416,  -342,  2323,    37,
      38,    39,    40,  1775,   797,    43,    44,  1397,  1619,  4287,
      45,  3307,  3308,  1874,  2099,  3146,  2069,  3148,  1123,  2622,
    2583,  4389,   343,  1704,   344,  4135,   348,   346,   416,  3273,
    3274,    37,    38,    39,    40,  1055,  3184,    43,    44,  2921,
    4404,  2072,    45,   356,  4219,  1393,  2602,  1350,  1358,   356,
    1980,  2698,   803,   130,   131,   321,   355,   897,  3798,  3819,
    3186, -1578,  1922,   394, -1366, -1366, -1366, -1366, -1578,   394,
     342, -1366,   797,  1496,  1350,  4323,    37,    38,    39,    40,
    2752,  2741,   356,    44,  1074,  2408,  3193,   416,  1932,   349,
    2460,   355, -1684, -1684, -1684, -1684,  3897,   803,  4458, -1684,
    2061,    45,   394, -1366, -1366, -1366, -1366,  4248,  2106,  2980,
   -1366,  2187,  1769,  3188,  1758,  1498,   347, -1333,  3317,  3226,
    1109,  3318,  3319,  1171,  2105,  1378,     3,   356,  4052,   357,
    1497,   395,  3320,  3321,  3322,   845,  3323,  3324,  2981,  3029,
     685,  3325,  3326,  3327,  1011,  2737,  1705,   394,  2045,  1874,
    -159,  1011,  2738,  1011, -2402, -2402, -2402, -2402,   416,  3799,
    2188, -2402, -1366,  2603,  2461,   803,   395,  2018,  2019, -2402,
   -1376, -1376, -1376, -1376,  2034,  -159,  1540, -1376,  1541,  4283,
    3189,  2497,  1509, -1376, -1376, -1376, -1376,    43,  1350,   402,
   -1376, -1333,    45,  1908,  1359,   356, -2403, -2403, -2403, -2403,
    2742,  4405,  4313, -2403,  1586, -2400, -2400, -2400, -2400,  3820,
    4318, -2403, -2400,  1701,  1875,   394,  2157, -1594,  2195,   809,
   -2400,   810,  3794,  3867, -1594,  2102,  2922,  3185, -1830,  2414,
    1875,  1656,  3898,  1351,  2418,  2331,  4459, -2399, -2399, -2399,
   -2399,  4275,  2584,  3800, -2399,  1651,   841,  2332,  1137,   881,
    4115,  3187, -2399,  2100,  4246,  1124,  1081,  1607,  1610,  2631,
    1934,  3841,  1875,  2996,  4266,  2147,  2148,  4265,   261,  3497,
    1828, -1995, -1995, -1995, -1995,  1762,  2132,  2485, -1995,  1107,
    2144,  2144,  1765,  2704,  3328,  4390, -1995,  2378,  1116,  1117,
    4468,  1884,  4154, -1361, -1361, -1361, -1361,  2436,  2333,  3287,
   -1361,  3577,  4167,  3761,  1639,   898,  2012,  2013,  1981,  1056,
    4267,  2368,  1389,  2370,  2031,  2064,  4139,  4268, -1333, -1333,
   -1333, -1333,  2434,  1366,  1158, -1333, -1346, -1346, -1346, -1346,
    1613,   356,  1856, -1346,  1657,   321,  2604, -1373, -1373, -1373,
   -1373,  3384,  1828,  1910, -1373,   246,  1981,  4269,  1736,  2155,
     342,   394, -1361,  2407,  2605,  3238,   885,  3981,  2785,  1884,
    1914,   962,  1595,  4319,  1366,  3182,   356,  2092, -1578,   686,
    4312,  2430,  2873,  2575,  2115,  1114,   886,    37,    38,    39,
      40,   962,   963,   899,    44,   900,   394,  2411,  4402,  1737,
    2801,  3638,  3612,  2155,  4210,  3032,   347,  2766,  1875,  3399,
    1379,  3400,  4218,  2127,   892,   892,  -127,  4353, -1681,   357,
    3329,  1542,  1520,  2885,  1838,  -127,  4270,  1620,  1621,  1115,
    -127,  1109,  2291,  2089,  2090,  2091,  2092,  2100,  2296,  1149,
    2234,  3459,  4427, -1830,  3462,  3463,  1065,  2204,  3466,  3876,
    2205,  1587,  1178,  2625,  2627,  2301,  3734,  3742,  3473,  2007,
    4028,   796,  2739,  2445,  2635,  1839,   992,  2638,  3336,  3267,
    3330,  1122,  4382,  1126,   794,  2650,  2651,  3599,  1226,  2358,
    1331,  3603,  2361,  2362,  4215,  4216,  1576,  1658,  2668,  2670,
    3018,  2355,  2594,  4256,  2844,  3342,  3464,  3465,  2007,  2684,
   -1830, -1366,  1264,  2558,  4288,   811,   856,  2579,   355, -1333,
     813,  2565,   355,  1253,  4244, -1830,  1053,  2568,   962,   963,
   -1333,  1915,  2017, -1333,  1646, -1333,   703,  1531,  1884, -1684,
    1278,  1532,  3347,  4421, -1594,  2415,  3235,  3236,  3237,  3238,
   -1366,   993,  1332,  4436,  1338,  1659,  1343,   814,  2893,  1188,
    3495,  1738,  1347,  2286,  2818,  1680,  2818,  2478,  2654,  2655,
    1188,  3331,  3661,  2516,  3536,  3666,  3667,  3668,  3669,  3670,
    3671,  3672,  3673,  3674,  3675,  2040,  1338,  1343,  1326,  3350,
    1321,  1217, -2130,  1898,  3495,  3403,   861,   395,  2040,  4271,
    1531, -2402,  2850,  2041,  1532,  3803,  1219,  4104,  4105,  4106,
    4107,  4108,  2719,  1606,  1369,  -789,  2041,  2042,  4476,  1399,
    2312,  1514,  3226,  1609,  1070,  4358,  1109,  1840,   892,  2351,
    2044,  4428,  3712,  3713,  1899,  1350,  1020,  1521,  3583,  3703,
    1171,  2479,  2125, -2403,  2491,  1739,    37,    38,    39,    40,
    1189,   863, -2400,    44,  4140,  2494,  1565, -1170,  2491,  1270,
     904,  1189,  3566,  4334,  4301,   969,  4141,   969,  1681,   969,
     797, -1173,  2851,  1317,   847,   969,  2869,   892,  1369,  1254,
    2372,  2580,  2557,  3585, -2399,  4338,    37,    38,    39,    40,
      80,   349,  1064,    44,  1522,  1336,  2287,  1341,  3063,   969,
     969,  4429,  3762,  1545,  1006,  3019,  3804,  2663,  1006,  1389,
    2581,  1841,  4310,   861,  2061,    79,  2590,  2591, -1995,  3785,
    3537,  1567,   994,   995,  4430,  1976,  2286,  1371,  1373,  4403,
    1021, -1170,  1508,  3751,  1255,  2069,  1516,  2720,  1007,  2215,
   -1361,  2721,  1007,  1502,  2421, -1173,  2440,  1377,  1161,  1162,
    1163,    74,  1164,  1165,  1166,  1167,  1168,  1169,  4377,   355,
    2072,  2283,  1109,   803,   692,  2017,  4315,  4316,   863,  2288,
     967,  3404,   967,  2023,   967,  1394,  2722,  3339, -2130,  1070,
     967,  1348,  1349,  1499, -1373,  2422,  1900,  1511,  1270,  1513,
     870,  1322,   871,   356,  1757,  3729,  3405,   356,  4130,  1351,
    4339,   873,  3228,  2216,   967,   967,  1337,  4120,  1342,  1351,
    1095,   875,  3857,   394,   969,  2535,  2516,   394,  1356,  4142,
    2480,  1119,  2492,  1651,  2066,  2871,  1171,  1094,   681,   681,
    1755,  2481, -2130,  1627,  1536,  4448,  4123,  2338,  1372,  1374,
    1682,  2274,  4302,  3036,  3587,    35,   416,  -127,  -127,    37,
      38,    39,    40,    41,    42,    43,    44,  1248,  2217,  3786,
      45,  4340,  2440,  2274,  3229,  1096,  3763,  3894,  2441,  1644,
    1901,   969,   683,   683,  2561,  1531, -1170,  1630,  2275,  1532,
    2297,  3742,  4335,  1599,   861,  4222,  1249,  2797,  1248,  4022,
   -1173,  1095,  1724,  4025,  3783,  3764,  3520,  2723,  1645,  4026,
    1628,  1725,  1629,    37,    38,    39,    40,   870,  2219,   871,
      44,  2775,  2282,  2276,  3832,  2076,  2077,  3545,  3588,   967,
    3835,  3836,  3837,  3838,  3839,  3840,  1095,  1250,  4419,  2277,
    4131,  2224,  3497,  3976,  2225,  2276,   215,  2423,  1622,   863,
    1599,  3522,  2283,  3859,   804,  -362,  1096,  2982,  3314,  1097,
    3315,  2277,  3495,  1098,   805,  2129,  3787,  1559,  1250,  3788,
    1098,  2657,  2298,  4449,  2080,  3950,   223,  2798, -1170,  2517,
    3954,  2521,  1171,  3956,  1756,  3394,   967,  3947,  1065,  1779,
    2527,  1096, -1173,  1011,  2441,   416,   896,  1011,    37,    38,
      39,    40,  1865,  1865,    43,    44,  1397,  1619,  3423,    45,
    1858,   234, -1170,  1098,  1339, -1170,  2312,  2821,  1344,  1345,
    1346,  3144,  1626,   237,  3634,  2216, -1173,  4336,  1357, -1173,
    3149,  2424,  1726,  3230,  3231,  3232,  2226,  3233,  3234,  3235,
    3236,  3237,  3238,  2363,   356,  3067,  3068,  3069,  3070,  1793,
    1070,  1098,   983,   969,  1866,  2560,  1977,  2338,  4001,  4002,
    3589,  1560,   806,  2442,   394,  2875,  1979,  2975,  3650,  2278,
    2130,  3750,  1270,  2976,  1154,  1399,    80,    80,  3226,    80,
    2217,  3348,  2463,  2103,  4113,  2284,  1098,  3398,   870,  3526,
     871,  2278,   349,  1122,  2464,  2177,  2178,  1270,  2182,  2249,
    3202,    79,    79,  2465,    79,  2170,  2766,  1081,  4446,  2183,
    3585,  3424,  2466,   979,  2467,  2468,  1076,  1076,  3590,  1076,
     848,   122,  1599,  2772,  3527,  2186,  1317,  1732,  4231,   349,
    4136,  3965,  3983,  3966,  3984,  3857,  3528,    74,    74,   126,
      74,  1867,  1867,  1985,  1099,  2869,  3637,  2876,  3253,  2955,
    2087,  2088,  2089,  2090,  2091,  2092,  1733,  2958,   967,  2960,
    1734,  2279,  2005,  1100,  2364,  2187,  2365,  2069,  4346,  4137,
    2977,  1724,  4482,  3626,  1068,  1098,  3140,  3276,  3853,  2442,
    2870,  2021,  3638,  2279,  3136,  1735,  4197,  4198,  1868,  1868,
     956,   807,  2072,  1803,  4175,  2184,  2516,  1936,  2443,  1938,
    2516,   813,  1942,  3567,  1944,   796,  3858,  1947,  1948,  1949,
     957,  2048,  2060,  4351,  2188,  3123,  3529,  2154,   794,  3961,
    1956,  3315,  1365,  3854,  2058,  4232,  1565,  2119,  2120, -1782,
    1566,  1069,  4144,  2062,  1983, -1214,  1984,  3227,   814, -1214,
    4145,   969,  3662,  2067,  3663,   969,   969,   956,   692,   692,
    1776,  1777,   355,  2104,  3425,  4206,   796,  4208,  3228,  3226,
    2136,  1884,  2268,  3985,   991,  2617,  3859,   957,  2952,   794,
    1869,  1869,  2269,    37,    38,    39,    40,   962,  1595,   956,
      44,  3124,  1270,  3426,  2326,  2134, -1813,  2270,  2905,  1270,
    1270,  1567,  1708,  1017,  2871,  1366,  4079,  4080,  3036,   957,
   -1214,  1070,  2137,   355,   355,   355,  1043,   934,  3388,  3125,
    1599,  2218,  2952,  2978,  1599,  1599,  3124,  1565, -1831,   796,
    3229,  1709,  1074,  1074,  3126,  1074,  2121,   681,  2231,  2419,
    4164,  2154,   794,  3127,  1568,  2327,  1006,  4176,  1884,  2906,
    2663,  2663,  2979, -1214,  3125,  2663,   967, -2404,  1987,   692,
     967,   967,  1399,   355,  1745,  3226,  3128,  1006,   209,  3605,
     355,  4190,  4191,  3664,  2830,  3226,   355,  4308,  3127,  2068,
    1007,   683,  2069,  3665,   813,  1050,  3895,  3172,  2907,   395,
     395,  3951,  1567,  1746,  2663,  2663,  2122,   969,  2227,  2420,
    4146,  1007,  1935,   969,  2858,  1937,  4257,  2072,  1941,  2329,
    1943,  2401,  2073,  1946,   797,  4094,  1399,  1950,  1229,  3226,
    1230,   814,  1071,  2245,  2247, -1782,  1620,  1621,  1951,  2271,
    3110,   813,  2223,  4258,  1349,  1568,  3704,  4230,   395,  2908,
    2402,   956,  1006,  3129,   969,  2253,  3896,   969,   969,  3228,
    2379,  1952,  2237,  1058,  -795,    37,    38,    39,    40,  2244,
    2246,   957,    44,  1651,  2155,  1842,  1599,   209,   814,  3773,
    3421,  2363,  1599,  1884,  4029,  4095,  1007,  3157,  3129, -1782,
   -1861,   901, -1813,  2369,  1843,  1399,   416,  2664,  3226,  3230,
    3231,  3232,  1746,  3233,  3234,  3235,  3236,  3237,  3238,  3422,
     969,  1916,   967,  1741,  2376,  1917,  1648,   803,   967,  2403,
    2766,   796,  1065,  1599, -1831,  3952,  1599,  1599,  4100,  2404,
    2340,  1617,   157,  2456,   794,  3784,  3789,  3547,   797,   669,
    2524,  2458,  1742,  3874,   956,  1649, -1813,   356,  2040,   209,
    1905,  2075,  4296,  2405,  1618,  3228,  4101,  2743,  2487,   967,
    2335,  4235,   967,   967,   957, -2404,  2041,   394,   355,  3397,
    1906,  1743,  2076,  2077,  1650,  2341,  2342,  2380, -1831,  1599,
    2042,  2256,  3358,  2144,    37,    38,    39,    40,  2619,  3830,
    3337,    44,  2087,  2088,  2089,  2090,  2091,  2092,   356,   356,
     356,  1066,  2364,  1326,  2365,  2766,   176,   215,  2338,  3228,
    2257,  2069,  1077,  4418,  2340,   967,  4373,  3229,   394,   394,
     394,  2080,  2469,  3821,  2040,  3495,    37,    38,    39,    40,
    1987,   803,  1084,    44,  2081,  1011,  2072,   223,  2517,  2258,
    4374,  2607,  2041,  3822,  1651,  2782,  3680,  3681,   356,  2323,
   -2194,  2510,  3647,  1081,  4254,   356,  1011,  2328,    35,  2341,
    2342,   356,    37,    38,    39,    40,    41,    42,   394,    44,
    3032,  3229,   234,  2618,  3659,   394, -1861,  3362,  3228,   416,
    3293,   394,  4036,     8,  3233,  3234,  3235,  3236,  3237,  3238,
    2349,  1171,  2338,    45,  2516,  1087,  1119,  3418,  3679,  2516,
    2040,    80,  2516,  2613,    80,  2614,   349,  2616,  2615,  2375,
    1005,  2503,  3419,  3162,  4284,  1088,  3072,   246,  2041,  1042,
     797,  3073,  3710,  3038,  3921,  1089,    79,  2312,    35,    79,
   -1861,  1011,  2044,  1316,   416,  4000,    41,    42,   215,  3999,
    3229,    37,    38,    39,    40,  3510,  3686,  3032,    44,  2710,
    3073,  2711,  2412,  3371,    37,    38,    39,    40,  1064,  2029,
    2030,    44,    74,  2639,   796,    74,  3351,  1125,   223,  1987,
     349,   815,  2712,  1136,  1916,  3039,  2701,   794,  2553,  1150,
    3233,  3234,  3235,  3236,  3237,  3238,  3870,  3871,  3872,   849,
    3233,  3234,  3235,  3236,  3237,  3238,   232,  2087,  2088,  2089,
    2090,  2091,  2092,   234,   931,  2110,  4480,  2400,  2111,  4481,
    2647,   355,  2449,   803,  1152,   237,  2803,  3278,  2563,  3279,
    2564,  2208,  2209,  1090,  2566,  3036,  2567,  2640,  3006,  2569,
    3230,  3231,  3232,  2570,  3233,  3234,  3235,  3236,  3237,  3238,
    3280,  2505,  2506,   356,  2340,  1721,  1545,  1731,   246,  3040,
    3041,  1157,  3775,  3776,  1751,  1018,  2708,  2809,  2810,  2852,
    3880,  2855,  3042,   394,  2636,  2637,   157,  2523,  1180,  3199,
    2713,  2340,  2649,  2556,  3200,  2714,  2652,  2653,  3201,  3401,
    2715,  2517,  2641,  3478,  2017,  2642,  2262,  1091,  3311,  2341,
    2342,  2674,  1186,  2675,  3543,    37,    38,    39,    40,   355,
   -2404, -2404,    44,  3233,  3234,  3235,  3236,  3237,  3238,  1232,
    1187,  1233,  1684,  2696,  3043,  2697,  2341,  2342,  1685, -1238,
   -1238,  2773,  2338,  2208,  2814,  2846,  3479,  2663,  1221,   969,
    2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,  2663,
     176,  3851,  3852,  3281,  1224,  3855,  1127,  3856,  3282,  2338,
    3480,   355,  1092,   355,  1225,   796,  2795,  1686,  1128,  1129,
    3848,  1228,  1556,   797,  2237, -1170,  1237,  2154,   794,  3481,
    1993,  1994,   969,  4241,   395,  3643,   681,  2643,  1130,  2689,
    1243,  1131,  2692,  1758,  3781,  3433,  3482,  2663,  2663,  2017,
    1251,  2262,  1627,  3351,  2716,  4437,   193,  3044,  1925,  3045,
    1926,  3483,   355,  2717,  2068,  3359,  3360,  2069,  1687,  1252,
    1531,  1109, -1684,  2932,  1532,  1688,  3092,  3093,  1689,  2004,
     683,   246,    37,    38,    39,    40,   395,  3351,   395,    44,
     416,   796,  2072,    45,   967,  1275,  1630,  2073,    80,  1257,
      80,  1599,  3580,  2918,   794,  1260,  3730,  3732,  2168,  2516,
    2169,  3123,  1279, -1182,  1065,  1304,   803,  1399,  2699,  1289,
    3226,  1629,  3283,    79, -1182,    79,   796,  4204, -1182,  1690,
    2644,  3284,   215,  3252,  1298,  3254,  3255,   967,   355,   794,
    3779,  2171,  3484,  2172,  3353,  3354,   356,  1513,  1399,   932,
    3485,  3226,  4150,  1132,  2017,  1319,  1646,  1622,  3102,    74,
    1364,    74,   223,  2555,   969,  2556,   394,  2576,  4006,  2577,
   -1182,    45,   969,   355,   969,   157,  1662,  3124,  3864,  3865,
    2664,  2664,  3486,  1691,  2578,  2664,  2577,  1360,  3877, -1182,
     232,  1399,  1375,  1133,  3226,  1381,  1387,   234,  3773,  2610,
    2794,  2611,  1884,  3064,  1386,  3125,  4004,  1663,  1389,   237,
    4328,  4007,  4330,  2838,   797,  2611,   215,  2883,  1692,  2884,
    3126,  2929,  2074,  2930,  2664,  2664,  2075,  1388,  3024,  3127,
    3025,  1390, -1182,  1599,   356,  3942,  1391,  2017,  3990,  2262,
   -1182,  1599,  4438,  1599,  1392,  1395,   223,  2076,  2077,   176,
    1396,  1694,  3128,  1517,   394,    37,    38,    39,    40,  1523,
    1524,  2078,    44,  1525,  1664,    35,   416,  3008,  3058,   967,
    3059,  1519,  3316,    41,    42,  3008,  1695,   967,  1530,   967,
      45,   234,  2663,  3164,  1539,  2577,   356,  3180,   356,  3181,
     797,  1546,  3198,   237,  2556,  1665,  2080,  3208,  1553,  2556,
    3228,  3211,  3773,  2556,  1554,   193,   394,   803,   394,  2081,
    1556,  2517,  1065,  1557,  3215,  2517,  2556,    37,    38,    39,
      40,  3066,  1563,  3103,    44,   797,   246,  1578,  3216,  3129,
    2556,  3228,  3242,  1155,  2556,  1580,  1710,   356,  1174,  3258,
    3261,  2556,  3262,  3096,   130,   131,  3850,  1184,  1588,  1270,
    3116, -1182,  3035,  3297,  3299,  3298,  3300,   394,  3921,  1584,
    1154,  3882,  3229,  3868,  3869,  3870,  3871,  3872,  3343,  1585,
    3344,  2894,  1231,  4103,  3228,  3416,  1238,  3417,  3302,  3303,
    4091,   215,  2083,   803,  1711,  3441,  1247,  3442,  1589,  3553,
    4084,  3554,   969,  3229,  1590,  3564,  1270,  3565,  1591,   937,
    1109, -1337, -1337, -1337, -1337,  3574,  1531,  3575, -1337,  1556,
    1532,   223,  3651,   356,  2556,  3687,  1593,  3688,   803,  1592,
    3694,   938,  3695,  3884,   209,  1600,  2068,   157,  1668,  2069,
    3706,  1601,  2556,   394,  1669,  3777,  3229,  2577,   796,   232,
    3844,  1670,  3845,   796,  1594,  3351,   234,  1632,   356,  1746,
    3259,   794,   939,  1603,  2072,  3264,   794,  1672,   237,  2073,
    1712,  1599,  1635,  2663,  2663,  1673,  1641,  1633,   394, -2404,
   -2404,  1646,  2087,  2088,  2089,  2090,  2091,  2092,  4005,  4043,
    2611,  4044,  1562,  4179,  1564,   355,  3030,  4050,  1661,  2577,
     355,   246,  1678,    81,  4051,  1744,  2577,   967,  4150,  1701,
    1703,   176,  1283,  1740,  3973,  1713,  1291,  1714,  4132,  1753,
    4133,  3773,  1754,  4161,  1674,  1884,  1303,  2371,  3105,  3584,
    1643,  3230,  3231,  3232,  1759,  3233,  3234,  3235,  3236,  3237,
    3238,  3868,  3869,  3870,  3871,  3872,  4166,  1761,  3554,  3873,
    4034,  3604,  4168,  3607,  3554,  4081,  1763,  3275,  2058,  1766,
    1771,  1716,  3230,  3231,  3232,  1773,  3233,  3234,  3235,  3236,
    3237,  3238,  2708, -1344, -1344, -1344, -1344,  4193,  1780,   396,
   -1344,  4181,  1783,  4182,  2517,   396,  1651,  4183,   969,  2556,
    4189,  3296,  2611,   937, -2404,  4238,  1718,  4239,  2075,  1822,
    4252,  4435,  4253,  2510,  1824,  3230,  3231,  3232,  1828,  3233,
    3234,  3235,  3236,  3237,  3238,   938,  1832,  -176,   396,  2076,
    2077,   157,  4285,  1834,  4286,  4240,  4292,  4294,  1884,  3554,
    1720,  1836,  1270, -2404,   669,   669,  1847, -1335, -1335, -1335,
   -1335,  1854,   827,   215, -1335,  1862,   939,   797, -1338, -1338,
   -1338, -1338,   797,   887,  4298, -1338,  2611,  1599, -1336, -1336,
   -1336, -1336,  4352,   396,  2124, -1336,  1870,  4356,  2080,  4357,
    3191,  1872,  4365,   223,  1884,  1068,  4366,  4367,  2611,  3262,
    4368,  2081,  2556,  1877,  1879,  4297, -1215,  4383,  2237,  2611,
   -1215,  3338,  4385,   967,  2611,   176,  4386,  4478,  2611,  4479,
    4489,   232,  4479,  3520,  1878,  1880,  1881,  1883,   234,  1889,
    1012,  1884,   940,  1894,  1903,  1923,  1892,  1012,  3521,  1012,
     237,  1893,  1895,  1897,   796,   796,   796,  1902,  1904,  1909,
    4321,   396,  1069,  1989,  4326,  4327,  1957,   794,   794,   794,
     803,  1991,  4300,  1995,  1997,   803,  1998,  2003,  3522,  2011,
    3523, -1215,  2663,   941, -2404,  2014,  2015,  2664,  2016,  2020,
    2664,  2664,  2664,  2664,  2664,  2664,  2664,  2664,  2664,  2664,
     356,   355,   355,   355,   246,   356,  2663,  2663,  4035,  2022,
    2025,  2026,  2027,  2028,   796,  2097,  2033,  2124,  2035,  1171,
     394,  2036,  4084,  2037, -1215,   394,  3477,   794,  2038,  2517,
    2039,  3557,  1070,  4116,  2517,  3434,  2046,  2517,  4322,  2047,
    4325,  2049,  2050,  2051,  2052,  2053,  2054,  2664,  2664,  2055,
    2128,  3524,   796,  2139,  1350,  3444,  2149,   215,  2159,  2175,
    1566,   355,  1568,  2202,  2456,   794,  2207,  3595,  2214,  1098,
     969,  2222,  2228,   881,  2087,  2088,  2089,  2090,  2091,  2092,
    2230,  2232,  2240,  2241,  2243,  2248,  3008,   223,  2250,  3008,
    3008, -2346,  2252,  3008,  2259,  2260,  4372,   396,  3558,   355,
    2262,  2263,  2264,  3008,   969,  2285,  2290,  2292,  1779,  2317,
    2293,  3525,  2294,  3571,  3498,   232,  3526,  2295,  1891,  2316,
    3507,  2323,   234,  2325,  2335,  2336,  2337,  2338,  2344,  2352,
    2345,  2353,   396,  3594,   237,  2346,  2347,  2350,  2356,  1599,
    1065,  2357,  2359,  1071,  2366,  2367,  2374,   892,  3498,  2373,
    1724,  3527,  2381,   797,   797,   797,  2392,  2413,  2382,  2425,
    2427,   349,  3552,  3528,  2428,  2007,  2435,   246,  3720,  3721,
    3722,  3723,  2437,  1599,  2390,   967,   349,  2663,  2438,  2447,
    3502,  3505,  2391,   892,  2017,  2397,   858,  2399,  2023,  2453,
    3579,  1270,  2457,  2473,  1974,  1662,   349,  1726,  3641,  2490,
    2500,  2495,  3539,  2510,  2501,  2498,  2531,  2510,  2502,   967,
    1990,  2508,  2532,   797,  2533,  4274,  2534,  3427,  2547,  3429,
    2548,  2572,  2000,  2519,  2573,  2588,  1663,  2596,  2600,  2608,
    1896,  3102,  2593,  2631,  2621,  2672,  2673,  2685,  4455,  4307,
    2630,  1911,  2069,  3529,  2690,  2695,   803,   803,   803,  1662,
    2702,   797,  2752,   796,  2694,  2769,  2726,  2779,  2707,  2771,
    2724,   349,  2780,  2787,  2768,  3689,   794,  2774,  2776,  2804,
    2805,  2823,  2796,  1069,  2820,  2822,   356,   356,   356,  2114,
    1663,  2808,  2664,  1664,  2837,  2839,  2840,  2848,  3460,  2856,
    2841,  2858,  2853,  2862,  2860,  2861,   394,   394,   394,  2864,
     355,  4213,  2867,  2874,  2879,  2881,   803,  2924,  2920,  2928,
    2931,  2983,  1171,  2984,  1665,  2985,  2989,  2993,  2997,  2994,
    2998,  4225,  2999,  3001,  3002,  3003,  3004,  3005,  3351,  3015,
    3017,  3026,  1171,  1684,  3021,  3028,   356,  1664,  3033,  1685,
    1196,  3034,  3056,  3031,   803,  3032,  3060,  3079,  3065,  3074,
    3071,  3078,  3095,   669,  3112,  3097,   394,  3109,  3113,  3701,
    3114,  3115,  3812,  3316,  3122,  3135,  3555,  3141,  1665,   887,
    3142,  3150,  1197,  3153,   356,  3156,  2058,  3166,  1686,  3160,
    2894,  3155,  3167,  2174,  2517,  1198,  3169,  3168,  3171,  3178,
    2622,  3190,  3196,  1199,   394,  3194,  3103,  1200,  1366,  3209,
    3210,  3212,  3740,  3213,  3214,  3277,  3292,  3248,  3272,  3285,
     796,  3217,   796,  3218,  3305,  3220,  4465,  1201,  3223,  3241,
    3247,  1684,  2918,   794,  3795,   794,  2556,  1685,  3249,  1687,
    3615,  3250,  3257,  3270,  3295,   796,  1688,  3271,  1202,  1689,
    3311,  3310,  3313,   209,  -833,  2300,  3375,  1668,   794,  3366,
    4381,  3390,   797,  1669,  3378,  3364,  3380,   355,  3365,   355,
    1670,  4465,   969,  2664,  2664,  3369,  1686,  3370,  1746,  4465,
    1916,  1203,  3381,  2517,  3385,   969,  1672,  3386,  3391,  3387,
    3395,  3396,   355,  3408,  1673,  3410,  3431,  3432,  3435,  3437,
    1690,  3446,  1204,  4224,  2396,  3445,  3655,   209,  3447,  3461,
    3448,  3104,  3467,  3468,  3449,  3450,  3498,  1669,  3451,  3452,
    3453,  3756,  3454,  3455,  1670,  3660,  1205,  1687,  3469,  3470,
    3813,   969,  1746,  3814,  1688,  3815,  3471,  1689,  3472,  1154,
    1672,  1599,  3500,  1674,  3501,  3511,  3509,  2225,  1673,   396,
    3682,  3533,  3512,   396,  1691,   803,  3540,  1146,  3546,  3008,
    3559,  3544,  3562,  1146,  3568,  3008,  3008,  3008,  3008,  3008,
    3008,  3569,  3563,  3572,  3592,  1270,  3600,   967,  3596,  3608,
    4380,  3629,  1206,  3613,  1987,   356,  3598,  2517,  1690,  1692,
     967,  1171,  2459,  3601,  1146,  3611,  3618,  1674,  1662,  3630,
    1599,  3105,  3507,  3620,  3635,   394,  3640,  2396,  3631,   827,
    3632,  3879,  3881,  3883,  3885,  2227,  3644,  3645,  1693,   797,
    2004,   797,  1694,  3654,  3244,  3226,  3243,  3683,  3684,  1663,
    3685,  3696,  2063,  1207,  3709,  1265,   967,  1208,  3708,  1209,
    3717,  3733,  1691,  3727,   797,  1210,  1146,  1695,  3744,  3745,
    1348,  1349,  3755,  1146,  3749,  3757,  3766,  3594,  3743,  3863,
    3746,  3752,  3796,  3505,  3809,  2396,  4039,  3780,  3782,  3790,
    3934,  3797,  3878,    81,  1211,  3818,  1212,  1692,  3807,  3810,
    1213,  3811,  3808,  3831,  3833,  3834,  1664,  3892,  1214,   969,
    3899,  2510,  3866,  1215,  3584,  3902,  2510,  3906,  3908,  2510,
    2577,  3909,  4037,  3911,  3912,  3916,  1729,  3925,  3929,  3930,
    1694,  3932,   803,  1147,   803,  1216,  1151,  1665,  3943,  3939,
     349,  3945,  2529,  3955,  3940,  3969,  3974,  3977,  4056,  3982,
    3991,  2538,  1182,  3948,  3992,  1730,  3958,   803,  3963,  4017,
    4018,  4038,   356,  2545,   356,  3997,  4040,  4053,  4054,  4045,
    4055,  4077,  2664,  4061,  3979,  1227,  3987,  3986,  1599,  3993,
    4078,  4020,   394,  1146,   394,  4082,  4089,   356,  4021,  1012,
    1245,  4067,  3858,  1012,  4096,  4099,  2664,  2664,  4070,  4102,
    4109,  4125,  4117,  4121,  4127,  4134,  4138,   394,  4147,  4399,
     396,  4148,  4163,  4156,   967,  4173,  2517,  4177,  4178,  1146,
    4180,  4185,  2582,  4186,  4187,  2587,  4199,  2589,  4195,  4207,
    2592,  4217,  4220,  1666,  4188,   969,  4201,  4111,  2522,  4233,
    4205,  4234,  4424,  2934,  4227,  4242,  4228,  2528,  3898,  4249,
    4251,  4261,  2935,  2936,  2937,  2536,  2537,  4260,  4262,  3905,
    4264,   969,  1667,  4032,  4033,  4276,   209,  4277,   796,  4278,
    1668,  4279,  4280,  2549,  4290,    80,  1669,  4306,  1070,  4314,
    3477,   794,  4337,  1670,    35,  4345,  4347,  4364,  4031,  4341,
    4350,  1671,    41,    42,  4354,  4355,  2938,  4360,  2068,  1672,
      79,  2069,  4369,  4370,  4371,  4376,  4378,  1673,  1910,  4323,
    4387,  4388,  4391,  4393,  4397,   355,  4400,  4417,  2070,  4422,
    3735,  2071,  4420,  4434,  2237,   796,  2072,  4389,  4390,  4426,
    4447,  2073,  4457,  4474,  4477,  4483,    74,  4487,   794,  3062,
     967,  1079,  4486,  2398,  2146,  2939,  3340,  2923,  3406,  3793,
     969,  3008,  3008,  3474,  4122,  4236,  1674,  1146,  4083,  4333,
    4263,  3927,  4114,  4273,  1146,  1270,   967,  2664,  3383,  4087,
    4088,  3165,   355,  4092,  4093,  4423,  4211,  4064,  4065,  4454,
    4394,  4392,  4068,  4069,  2940,  1819,  3507,  3507,  3507,  3507,
    3507,  4432,  3928,  2489,  2872,  4289,  3816,  3439,  2470,  3037,
    2941,  2942,  2943,  2944,  2945,  3549,  2946,  4456,  4098,  4488,
    4484,  4097,   669,  3541,  1146,  3488,  4433,   349,  4226,  2452,
    4384,   987,  4229,  1975,  3975,  4309,  3935,  2887,  1987,  3936,
    4129,  4359,  1271,  4440,  4485,  4255,  1527,  2791,  2947,  2842,
    2790,  2562,  3915,  2845,  3642,  3345,  3161,  3505,  3505,  3505,
    3505,  3505,  1684,  2173,  3349,   967,  2074,  4149,  1685,  1924,
    2075,  1552,  2813,  2199,  3361,  2865,  2510,   797,  2198,    81,
      81,  3357,    81,  2877,  2812,  1699,  1700,  2203,  2807,  3304,
    1146,  2076,  2077,  4165,  3118,  3606,  1267,  2786,  1535,  3102,
    3346,  3913,  3700,  3690,  4299,  2078,  2891,  1686,  4408,  4416,
    4409,  3290,  3352,  3205,  3288,  3593,  3183,  1662,  2751,  4058,
    3111,  2948,  1864,  1112,  2504,  2824,  2914,  4407,  2213,  4066,
    2815,  1082,  2831,  2781,   797,  1315,  2206,  2079,  1640,  1611,
    2080,  2828,  3335,  2933,  1774,   969,  2953,  2949,  1663,  1612,
    1819,  2829,  3759,  2081,  2950,  4027,  2082,  2951,  1687,  3760,
    1826,  1827,  1986,  2113,  2969,  1688,  3748,  1105,  1689,  2210,
     803,  2973,  2835,  3163,  2574,  1913,  1146,  1853,    83,     0,
    2986,  4203,     0,     0,  1355,     0,  2892,  2990,     0,  3498,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     356,     0,     0,     0,  1146,  1664,  3008,     0,     0,     0,
    4237,  1886,  1888,     0,  1599,     0,     0,  4202,     0,  1690,
     394,     0,     0,     0,     0,  2068,  2083,   803,  2069,     0,
       0,  1146,  1146,     0,  1146,     0,  1665,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2096,     0,     0,
     967,  1146,     0,  2072,     0,     0,     0,   356,  2073,     0,
       0,     0,     0,     0,  3103,     0,     0,     0,     0,     0,
       0,     0,     0,  1691,     0,     0,     0,   394,     0,     0,
       0,     0,     0,     0,     0,     0,   796,     0,  2135,  3555,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   794,
       0,     0,  1146,   396,     0,     0,     0,     0,  1692,     0,
       0,     0,  2084,  2085,  2086,  1987,  2087,  2088,  2089,  2090,
    2091,  2092,     0,  4473,     0,     0,     0,     0,     0,  2068,
       0,     0,  2069,   355,  1146,     0,     0,  1749,  1146,  1146,
       0,  1694,     0,     0,     0,     0,  3286,     0,     0,  2070,
       0,     0,     0,     0,   396,   396,   396,  2072,     0,     0,
       0,     0,  2073,     0,     0,   209,  1750,  1270,     0,  1668,
       0,     0,     0,     0,  4362,  1669,     0,     0,     0,     0,
       0,     0,  1670, -2404,     0,     0,     0,  2075,     0,     0,
    1746,     0,     0,     0,     0,     0,     0,     0,  1672,     0,
       0,     0,     0,     0,   396,     0,  1673,     0,  2076,  2077,
       0,   396,  1819,     0,     0,     0,     0,   396,     0,     0,
       0,  1012, -2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1012,     0,     0,     0,     0,     0,     0,  1819,
       0,     0,     0,  3170,     0,  1674,     0,  2080,     0,  3105,
    4442,     0,  4443,     0,  4445,  4444,     0,     0,     0,     0,
    2081,     0,  1819,     0,     0,     0,     0,     0,     0,  4361,
       0,     0,     0,     0,     0,   797,     0,  2074,     0,     0,
       0,  2075,  4442,     0,  4443,     0,  4445,  4444,     0,     0,
       0,  3143,     0,     0,     0,     0,     0,  1987,     0,     0,
       0,     0,  2076,  2077,     0,  3151,  3152,  1012,     0,  3154,
       0,     0,     0,     0,     0,  3158,  2078,   349,     0,     0,
       0,     0,     0,     0,  1819,  4442,     0,  4443,     0,  4445,
    4444,     0,     0, -2404,     0,     0,     0,     0,     0,     0,
       0,  2433,  1987,     0,     0,     0,  1987,  1987,  2079,  4472,
       0,  2080,  4467,     0,     0,     0,     0,     0,     0,  1819,
       0,     0,     0,     0,  2081,     0,     0,  2082,   803,     0,
       0,     0,     0,     0,     0,     0,     0,  4466,     0,     0,
       0,     0,     0,     0,  1819,     0,     0,     0,  3197,   396,
       0,     0,   349,     0,     0,     0,     0,  4467,   356,     0,
       0,     0,     0,     0,     0,  4467,     0,     0,     0,     0,
       0,     0,     0,  4463,     0,     0,     0,     0,   394,  3372,
       0,     0,  4466,  2087,  2088,  2089,  2090,  2091,  2092,     0,
    4466,  1146,     0,  1146,     0,     0,     0,  2083,     0,  1819,
       0,     0,  1146,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2385,  2386,  2387,  2388,     0,     0,  4463,     0,
       0,     0,     0,     0,     0,     0,  4463,     0,     0,     0,
       0,     0,     0,     0,    81,     0,     0,    81,     0,     0,
       0,     0,     0,  2416,  2417,     0,     0,     0,     0,  2426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3420,     0,     0,     0,     0,  3376,
    3377,  3430,  3379,     0,     0,     0,     0,     0,     0,  2068,
       0,     0,  2069,  2084,  2085,  2086,  1146,  2087,  2088,  2089,
    2090,  2091,  2092,     0,     0,  2777,     0,     0,     0,  2070,
       0,  2778,     0,     0,     0,     0,  2068,  2072,     0,  2069,
       0,     0,  2073,     0,  2474,  2475,  2476,  2477,     0,     0,
       0,     0,     0,     0,  1146,  1146,  2070,     0,     0,     0,
       0,     0,  1146,  3457,  2072,  1146,     0,     0,  1146,  2073,
       0,     0,     0,  2648,     0,     0,  1146,  1146,     0,     0,
       0,     0,     0,     0,  1146,     0,     0,  1146,  1146,  1146,
    1146,  2068,     0,     0,  2069,     0,     0,  1146,  1146,  3436,
    1146,     0,  1146,     0,     0,  1146,     0,     0,     0,     0,
       0,  2070,     0,     0,     0,     0,  2551,     0,  3389,  2072,
    1819,  1146,   396,     0,  2073,  1146,     0,     0,     0,  1146,
       0,     0,     0,  1146,     0,  1146,  1146,  1146,  1146,  1146,
    1146,  1146,  1146,  1146,     0,  1146,  2068,     0,     0,  2069,
       0,  1146,     0,     0,  1146,     0,     0,  3409,     0,  3411,
       0,     0,     0,     0,     0,     0,  2070,  2074,     0,     0,
       0,  2075,     0,     0,  2072,     0,     0,     0,     0,  2073,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2076,  2077,  2074,     0,     0,     0,  2075,  3535,
       0,  3538,     0,     0,     0,     0,  2078,     0,     0,     0,
     396,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
    2077,     0,     0,  1146,     0,     0,  2396,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,     0,  2079,     0,
       0,  2080,     0,     0,  3636,     0,     0,     0,     0,  2074,
       0,     0,     0,  2075,  2081,     0,     0,  2082,     0,     0,
       0,     0,   396,     0,   396,  2079,  3649,     0,  2080,     0,
       0,     0,     0,     0,  2076,  2077,     0,     0,     0,     0,
       0,  2081,     0,     0,  2082,     0,     0,     0,  2078,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    81,     0,    81,  2074,     0,     0,     0,  2075,     0,
       0,     0,     0,   396,     0,     0,     0,     0,  3633,     0,
    2079,     0,     0,  2080,     0,     0,     0,  2083,     0,  2076,
    2077,     0,     0,     0,     0,     0,  2081,  1146,     0,  2082,
       0,     0,  3646,  2078,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2083,     0,     0,  1819,     0,     0,
       0,     0,  1819,  1819,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1819,     0,  2079,     0,     0,  2080,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   396,
       0,  2081,     0,     0,  2082,  3614,     0,     0,     0,  3617,
       0,  3619,     0,  3621,  3622,     0,     0,     0,     0,  2083,
       0,     0,  3627,  2084,  2085,  2086,     0,  2087,  2088,  2089,
    2090,  2091,  2092,     0,   396,     0,     0,     0,     0,  3219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,
    3648,     0,     0,     0,     0,     0,  3265,     0,     0,     0,
       0,  3778,     0,     0,  2083,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1146,     0,  1819,     0,
    2068,     0,     0,  2069,     0,  2084,  2085,  2086,     0,  2087,
    2088,  2089,  2090,  2091,  2092,     0,     0,     0,     0,  2693,
    2070,     0,     0,     0,     0,     0,     0,     0,  2072,  3823,
       0,  3825,     0,  2073,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1819,
    2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,
    1146,     0,     0,     0,  3499,     0,     0,     0,     0,     0,
    1146,     0,  2956,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2068,     0,     0,  2069,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1146,     0,     0,
       0,     0,  2070,     0,     0,     0,     0,     0,     0,  3000,
    2072,     0,     0,     0,     0,  2073,  3009,  3010,  3011,  3012,
    3013,  3014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2074,     0,
       0,  1146,  2075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1819,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2076,  2077,     0,     0,  2068,     0,     0,
    2069,  1146,  1146,     0,     0,  3903,  3904,  2078,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3081,     0,     0,
       0,     0,     0,     0,     0,  2072,     0,     0,     0,     0,
    2073,  1146,  1146,     0,     0,     0,  1146,     0,     0,  2079,
       0,     0,  2080,     0,     0,     0,     0,     0,  1146,  1146,
    1146,  1146,     0,     0,     0,  2081,   396,  3145,  2082,  3147,
    1146,   396,     0,  1146,     0,  1146,     0,     0,     0,     0,
    2074,     0,     0,     0,  2075,  1146,  1146,     0,  1146,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1146,     0,  1146,     0,  2076,  2077,  1146,     0,  3970,
    3971,  3972,     0,     0,     0,     0,     0,     0,     0,  2078,
       0,     0,     0,  1146,  2068,     0,     0,  2069,     0,     0,
       0,     0,     0,  1146,     0,  1146,  1146,  1146,  2083,     0,
       0,     0,     0,     0,  1156,     0,     0,     0,     0,     0,
    1176,  2079,  2072,     0,  2080,     0,     0,  2073,  1185,  1146,
       0,     0,     0,     0,     0,  2074,  1193,  2081,  1146,  2075,
    2082,  1220,     0,     0,     0,     0,     0,  1146,     0,     0,
       0,     0,  1146,     0,     0,     0,     0,     0,     0,  1146,
    2076,  2077,     0,     0,     0,     0,  4062,     0,     0,     0,
       0,  3964,     0,     0,  2078,     0,     0,  4071,  3967,  3968,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2084,  2085,  2086,     0,  2087,  2088,
    2089,  2090,  2091,  2092,     0,     0,  2079,  1146,  3699,  2080,
    2083,     0,     0,     0,     0,  3714,     0,     0,     0,     0,
       0,     0,  2081,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1819,  1819,     0,  1819,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2404,     0,     0,     0,  2075,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4073,  4074,  1368,
    4076,     0,     0,     0,     0,     0,     0,  2076,  2077,  1819,
       0,  1819,     0,     0,     0,     0,  1384,     0,     0,     0,
       0, -2404,     0,     0,     0,  2083,  2084,  2085,  2086,     0,
    2087,  2088,  2089,  2090,  2091,  2092,     0,     0,     0,     0,
    3754,     0,   396,   396,   396,     0,     0,  1506,     0,     0,
       0,     0,     0,     0,     0,     0,  2080,     0,     0,     0,
       0,     0,     0,     0,  1529,     0,     0,     0,     0,  2081,
       0,     0,     0,     0,     0,     0,  4059,  4060,     0,     0,
    1819,     0,     0,     0,     0,     0,     0,  1558,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   396,     0,     0,     0,  3489,  1819,     0,     0,
       0,  2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,
    2092,     0,     0,     0,     0,     0,     0,  4160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4160,     0,     0,
     396,  1819, -2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1819,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1819,     0,     0,     0,     0,     0,  2068,     0,
       0,  2069,     0,     0,     0,  1819,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2070,     0,
       0,     0,     0,  1146,     0,     0,  2072,  1146,     0,     0,
       0,  2073,     0,     0,     0,     0,  1146,     0,     0,     0,
       0,     0,  1819,     0,     0,  2068,     0,     0,  2069,     0,
       0,     0,  2087,  2088,  2089,  2090,  2091,  2092,     0,     0,
       0,     0,     0,     0,     0,  2070,     0,     0,  4169,     0,
    4170,  4171,  1146,  2072,     0,     0,     0,     0,  2073,     0,
       0,  4174,     0,     0,     0,     0,     0,     0,  1849,  1851,
    1852,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1146,     0,     0,  1819,     0,
       0,     0,     0,     0,  1146,     0,     0,     0,     0,     0,
    1146,     0,  1146,     0,     0,     0,     0,  1819,  1146,     0,
       0,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,  1146,
    1146,     0,     0,     0,  1146,  1146,     0,     0,     0,     0,
       0,     0,  1819,     0,     0,     0,  2074,  1146,     0,     0,
    2075,   396,  4293,  1146,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1146,     0,     0,  1146,     0,  1146,     0,
       0,  2076,  2077,     0,     0,     0,  1819,  1146,  1146,  1146,
       0,     0,     0,  1146,     0,  2078,  1146,     0,     0,     0,
       0,     0,     0,  2074,  1506,     0,  1146,  2075,     0,     0,
       0,     0,     0,     0,  1146,     0,  1146,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2079,  2076,  2077,
    2080,     0,  1506,  4332,     0,     0,  2068,     0,     0,  2069,
       0,     0,  2078,  2081,     0,   677,  2082,     0,     0,     0,
     695,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2068,  2072,     0,  2069,     0,     0,  2073,
       0,     0,     0,     0,  2079,     0,     0,  2080,     0,     0,
    4295,  1814,     0,  2070,     0,     0,  1146,     0,   695,     0,
    2081,  2072,     0,  2082,     0,     0,  2073,     0,     0,     0,
       0,     0,     0,  2068,     0,     0,  2069,     0,   695,     0,
       0,     0,     0,  4311,     0,     0,  2083,     0,   396,  1819,
     396,     0,     0,  2070,     0,     0,     0,   978,     0,     0,
       0,  2072,     0,     0,     0,     0,  2073,     0,     0,     0,
       0,   980,     0,   396,     0,     0,     0,     0,     0,   988,
       0,     0,     0,     0,     0,     0,     0,  3715,     0,     0,
       0,     0,     0,  2083,   998,     0,   978,     0,  2150,     0,
    1019,     0,     0,     0,     0,     0,     0,     0,     0,  1047,
       0,     0,     0,     0,     0,     0,     0,  1052,  1047,     0,
       0,     0,     0,     0, -2404,     0,     0,     0,  2075,     0,
       0,     0,  2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,
    2091,  2092,     0,     0,     0,     0,  3768,     0,     0,  2076,
    2077,  2074,     0,  1146,     0,  2075,     0,     0,     0,     0,
       0,     0,     0, -2404,     0,     0,  1814,     0,     0,     0,
       0,  1819,     0,     0,     0,     0,  2076,  2077,     0,  2084,
    2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,     0,
    2078,  2074,     0,  3980,     0,  2075,     0,     0,  2080,     0,
       0,     0,     0,     0,     0,     0,  1819,  1146,  1146,     0,
       0,  2081,     0,     0,     0,     0,  2076,  2077,     0,     0,
       0,     0,  2079,     0,     0,  2080,     0,     0,     0,     0,
    2078,  1146,     0,     0,     0,     0,  1146,     0,  2081,  1146,
       0,  2082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4452,     0,     0,     0,     0,     0,     0,
    2334,     0,  2079,     0,     0,  2080,     0,     0,     0,     0,
       0,     0,  2068,     0,     0,  2069,     0,     0,  2081,     0,
       0,  2082,     0,  1146, -2404,     0,     0,     0,     0,     0,
       0,     0,  2070,     0,     0,     0,     0,     0,     0,     0,
    2072,     0,     0,     0,  2133,  2073,     0,     0,     0,     0,
    2389,  2083,     0,     0,     0,     0,     0,     0,     0,  1146,
       0,     0,     0,     0,     0,     0,  1146,  1146,     0,  1819,
       0,  2410,     0,     0,  1146,  1146,     0,     0,     0,  1146,
    1819,     0,     0,     0,     0,  1146,  1146,     0,     0,  1146,
       0,  2083,     0,     0,     0,     0,     0,     0,     0,     0,
    1146,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1146,     0,  2087,  2088,  2089,  2090,  2091,  2092,
       0,     0,     0,     0,     0,     0,     0,     0,    81,     0,
       0,     0,     0,     0,     0,     0,     0,  2084,  2085,  2086,
    1146,  2087,  2088,  2089,  2090,  2091,  2092,     0,     0,     0,
       0,  4012,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1819,     0,     0,     0,     0,     0,     0,  1814,     0,
    2074,  1819,     0,     0,  2075,     0,     0,  2084,  2085,  2086,
       0,  2087,  2088,  2089,  2090,  2091,  2092,     0,     0,  3050,
       0,  4184,     0,     0,     0,  2076,  2077,     0,     0,     0,
       0,     0,     0,     0,  2540,  1814,     0,     0,     0,  2078,
       0,     0,     0,  2544,     0,     0,   396,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1814,     0,
       0,     0,     0,  2559,     0,   816,     0,     0,     0,     0,
       0,  2079,     0,  2934,  2080,     0,     0,     0,     0,     0,
       0,     0,  2935,  2936,  2937,     0,     0,  2081,     0,     0,
    2082,     0,     0,  1146,   695,     0,     0,     0,     0,     0,
       0,     0,     0,   396,     0,     0,     0,     0,     0,  1506,
    1506,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1814,     0,   817,     0,     0,     0,  2938,     0,     0,  4047,
    4047,     0,     0,     0,     0,     0,     0,  1814,     0,     0,
       0,  1819,   818,     0,     0,     0,     0,     0,   819,     0,
       0,     0,  1146,     0,     0,  1814,  1146,     0,     0,     0,
    2083,  1819,     0,   820,     0,     0,     0,     0,     0,     0,
    3051,     0,     0,     0,     0,  2939,  4075,     0,     0,     0,
    1814,     0,     0,  1146,     0,     0,     0,  1819,     0,     0,
       0,   821,     0,     0,     0,     0,   822,     0,     0,     0,
       0,     0,   823,     0,     0,     0,     0,  1146,  1146,     0,
       0,  1146,     0,     0,  2940,     0,     0,   824,  1146,  1146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2941,  2942,  2943,  2944,  2945,  1814,  2946,     0,     0,  2750,
       0,   825,     0,     0,     0,  1146,  2084,  2085,  2086,     0,
    2087,  2088,  2089,  2090,  2091,  2092,     0,     0,     0,     0,
    4209,     0,  1819,     0,  2770,  1146,     0,     0,  2947,     0,
       0,     0,  1142,  1148,   695,     0,  1148,     0,  1142,   677,
    1047,     0,  1173,     0,   677,     0,  1047,     0,  1047,     0,
       0,     0,  1148,   677,  1047,     0,     0,   826,     0,     0,
       0,  1146,  1195,     0,  3052,     0,     0,  1047,  2789,  1142,
    2792,  2068,     0,   695,  2069,  1148,     0,     0,   677,     0,
    1173,     0,   677,  1240,   827,     0,     0,     0,     0,     0,
    1148,  2070,   677,     0,     0,     0,     0,     0,     0,  2072,
       0,  2948,     0,  3053,  2073,     0,     0,     0,   828,  1146,
       0,  1819,  1047,     0,   829,     0,     0,  1269,     0,     0,
     830,  1142,     0,   831,     0,   695,     0,  2949,  1142,     0,
       0,  1173,     0,     0,  2950,     0,     0,  2951,  1146,  1819,
       0,  1146,     0,  1146,     0,     0,  1148,     0,     0,   832,
       0,   833,     0,     0,     0,   834,     0,  1330,     0,     0,
       0,     0,  4214,   835,     0,     0,     0,     0,   836,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   837,     0,
       0,  1146,     0,     0,  1819,     0,  1814,     0,  1819,  1819,
     838,     0,     0,     0,     0,  1047,     0,     0,     0,     0,
    1047,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1047,  1385,   396,     0,     0,     0,     0,     0,
       0,  1146,     0,     0,     0,     0,     0,     0,     0,  2074,
       0,     0,     0,  2075,     0,  2913,     0,     0,  1488,     0,
       0,     0,   695,  1047,     0,     0,  1269,  1819,     0,     0,
       0,  4363,     0,     0,  2076,  2077,     0,     0,     0,     0,
    1047,     0,     0,  4281,  1047,     0,     0,  1146,  2078,  1538,
       0,     0,     0,     0,  1488,     0,     0,     0,     0,     0,
       0,     0,     0,  1047,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2079,     0,     0,  2080,     0,     0,     0,     0,     0,     0,
       0,  1146,     0,     0,     0,     0,  2081,     0,  1146,  2082,
       0,     0,     0,     0,     0,  4047,     0,     0,     0,     0,
     677,   677,     0,     0,  1146,  1146,     0,     0,     0,     0,
       0,     0,     0,     0,  1146,     0,     0,  4329,     0,  4331,
       0,     0,     0,     0,     0,     0,     0,  3061,     0,     0,
       0,     0,     0,     0,  2068,     0,     0,  2069,     0,     0,
       0,  1146,     0,     0,     0,  1148,  1148,     0,     0,     0,
       0,  1146,     0,     0,  2070,     0,     0,     0,  2068,  2083,
       0,  2069,  2072,     0,     0,     0,     0,  2073,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2070,     0,
       0,     0,  1142,     0,     0,     0,  2072,     0,     0,  1142,
       0,  2073,  1173,  1814,     0,     0,     0,     0,  1814,  1814,
       0,     0,     0,     0,  1148,  1146,     0,     0,     0,  1814,
       0,     0,     0,     0,  1146,     0,     0,     0,     0,     0,
    1148,  1148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4396,  1047,  1047,  1047,  1148,     0,  1142,
       0,     0,     0,  1861,     0,  2084,  2085,  2086,     0,  2087,
    2088,  2089,  2090,  2091,  2092,     0,     0,     0,     0,  4247,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1148,  1148,  4425,  2068,     0,     0,  2069,     0,     0,
       0,     0,     0,     0,     0,     0,  2068,     0,     0,  2069,
    1269,     0,  2074,     0,  2070,     0,  2075,     0,     0,     0,
       0,     0,  2072,     0,     0,  1488,     0,  2073,     0,     0,
       0,     0,     0,     0,  2072,  1269,  2074,  2076,  2077,  2073,
    2075,     0,     0,     0,  1814,     0,     0,     0,     0,     0,
       0,  2078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2076,  2077,     0,     0,  1960,  1960,     0,     0,     0,
    1047,     0,   978,     0,     0,  2078,     0,     0,     0,     0,
       0,     0,     0,  2079,     0,     0,  2080,     0,     0,     0,
       0,     0,     0,     0,     0,  1996,     0,     0,  1047,  2081,
       0,  2002,  2082,     0,     0,  1814,     0,  2079,     0,     0,
    2080,  1488,     0,     0,     0,     0,     0,  2068,     0,     0,
    2069,     0,     0,  2081,     0,     0,  2082,  3718,     0,     0,
       0,     0,     0,     0,     0,     0,  3301,  2070,     0,  1488,
       0,  2797,     0,     0,     0,  2072,  2068,     0,     0,  2069,
    2073,     0,  2074,     0,     0,     0,  2075,     0,     0,     0,
       0,     0,     0,     0, -2404,     0,  1488,  1488,  2075,  1488,
       0,     0,  2083,     0,  2072,     0,     0,  2076,  2077,  2073,
       0,     0,     0,     0,     0,     0,  1488,     0,     0,  2076,
    2077,  2078,     0,     0,     0,  1506,  2083,     0,     0,     0,
       0,     0,     0, -2404,     0,     0,   695,   695,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1814,     0,
    1269,  2798,     0,  2079,     0,     0,  2080,  1269,  1269,     0,
       0,     0,     0,     0,  1047,     0,     0,  1488,  2080,  2081,
       0,     0,  2082,  2160,     0,  2167,     0,     0,     0,     0,
       0,  2081,     0,     0,     0,     0,     0,     0,  2084,  2085,
    2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,     0,  1488,
       0,     0,  4398,  1488,  1488,  2074,     0,     0,     0,  2075,
       0,     0,  2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,
    2091,  2092,     0,     0,     0,     0,  4475,     0,     0,     0,
    2076,  2077,     0,     0,  2074,     0,     0,   695,  2075,   677,
       0,     0,  2083,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0, -2404,     0,     0,     0,     0,  2076,
    2077,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2078,     0,     0,  2079,     0,     0,  2080,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2081,     0,     0,  2082,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2080,     0,
       0,     0,  1684,     0,     0,     0,     0,     0,  1685,     0,
    2322,  2081,     0,     0,     0,     0,  1047,     0,  2084,  2085,
    2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,     0,  1173,
    3747,     0,  1710,     0,  2087,  2088,  2089,  2090,  2091,  2092,
       0,     0,     0,     0,     0,     0,     0,  1686,     0,     0,
       0,     0,     0,     0,     0,  2083,     0,     0,     0,     0,
       0,     0,  1148,  1148,  1148,  1148,  1047,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1711,     0,  3548,     0,  2083,  2409,     0,  1047,     0,     0,
       0,     0,  3561,  1148,  1148,     0,     0,     0,  1687,  1148,
       0,     0,     0,     0,  2799,  1688,     0,  3573,  1689,     0,
       0,  1814,  1814,     0,  1814,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,
    2092,     0,     0,     0,     0,  1814,  1712,  1814,   677,  1690,
    3623,     0,     0,  3624,  1148,  1148,  1148,  1148,     0,     0,
    2084,  2085,  2086,   677,  2087,  2088,  2089,  2090,  2091,  2092,
       0,  2409,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2518,     0,  1142,     0,
       0,  1713,     0,  1714,  1506,   695,     0,  1142,     0,     0,
       0,     0,     0,  1715,     0,  1173,     0,     0,     0,     0,
    1047,     0,     0,     0,     0,     0,  1814,     0,     0,  1047,
       0,   677,     0,     0,     0,  1148,  1148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1716,  1692,  1047,
       0,     0,  1330,  1814,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1717,     0,     0,
       0,  1694,  1718,  1960,     0,     0,  2068,  1814,     0,  2069,
       0,  1142,     0,     0,     0,  1047,  1047,     0,     0,     0,
       0,     0,     0,  2599,  1814,     0,  1719,  1047,     0,     0,
       0,     0,  3724,  3725,  2072,     0,  1720,     0,  1814,  2073,
       0,     0,     0,   978,   978,     0,     0,  2624,     0,  1488,
    1488,  1814,     0,     0,     0,     0,     0,  1488,     0,     0,
    1488,     0,     0,  1488,     0,     0,     0,     0,     0,     0,
       0,  1488,  1488,     0,     0,     0,     0,     0,     0,  1488,
       0,  1173,  1488,  1488,  1488,  1488,     0,     0,  1814,     0,
       0,     0,  1488,  1488,     0,  1488,     0,  1488,     0,     0,
    1488,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1488,     0,     0,     0,
    1488,     0,     0,     0,  1488,     0,     0,  4010,  1488,     0,
    1488,  1488,  1488,  1488,  1488,  1488,  1488,  1488,  1488,     0,
    1488,     0,     0,     0,     0,  1047,  1488,     0,     0,  1488,
       0,     0,     0,     0,  1814,     0,     0,     0,  2068,     0,
       0,  2069,     0,     0, -2404,     0,     0,     0,  2075,     0,
    1047,     0,     0,  1814,     0,     0,     0,     0,  2070,     0,
       0,     0,     0,     0,     0,     0,  2072,     0,     0,  2076,
    2077,  2073,     0,     0,     0,     0,     0,     0,  1814,     0,
       0,     0,     0, -2404,     0,     0,     0,  2167,     0,     0,
       0,     0,     0,     0,  1047,     0,  1047,     0,  1488,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1814,     0,     0,     0,     0,     0,  2080,     0,
    3875,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2081,     0,     0,     0,     0,     0,     0,  3900,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3907,     0,     0,   677,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3243,     0,     0,     0,     0,
    3244,     0,     0,     0,     0,   677,     0,     0,     0,   677,
     695,     0,     0,     0,     0,   978,  2074,   978,     0,     0,
    2075,     0,     0,     0, -2404,     0,     0,     0,     0,     0,
       0,   677,  1488,     0,     0,     0,     0,     0,     0,   677,
       0,  2076,  2077,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2078,     0,     0,     0,     0,
       0,     0,   677,     0,  2322,  1814,     0,     0,     0,     0,
    2895,     0,     0,     0,     0,  2904,     0,     0,     0,     0,
       0,  1047,   677,     0,     0,     0,     0,  2079,     0,     0,
    2080,     0,  2926,  2926,     0,     0,     0,     0,   695,   677,
       0,     0,   677,  2081,     0,     0,  2082,     0,     0,     0,
       0,     0,  1148,     0,  2087,  2088,  2089,  2090,  2091,  2092,
     677,     0,     0,     0,     0,     0,     0,   677,     0,     0,
       0,     0,     0,     0,     0,     0,   677,     0,     0,     0,
       0,     0,     0,   677,     0,     0,     0,     0,     0,     0,
    4013,  4014,  4015,  4016,     0,     0,     0,     0,     0,  1148,
       0,     0,     0,     0,     0,     0,  1148,  1148,  1148,  1148,
    1148,  1148,     0,     0,     0,     0,  2083,     0,     0,     0,
       0,  1488,     0,     0,     0,     0,  2068,  1814,     0,  2069,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2926,
       0,     0,     0,  1047,     0,     0,  2070,   978,     0,     0,
       0,     0,     0,     0,  2072,     0,     0,     0,     0,  2073,
       0,     0,  1814,     0,     0,     0,     0,     0,     0,     0,
       0,  3077,     0,     0,     0,     0,     0,  1148,  3091,     0,
       0,     0,     0,     0,     0,     0,     0,  1269,  1861,     0,
       0,     0,     0,     0,     0,  2518,  3121,     0,     0,     0,
    3121,  3134,  2084,  2085,  2086,  1488,  2087,  2088,  2089,  2090,
    2091,  2092,     0,     0,     0,     0,     0,  1148,  2926,  1148,
    2926,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1269,     0,     0,     0,     0,     0,
       0,     0,  1488,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1960,     0,     0,     0,     0,     0,     0,
       0,     0,  2068,     0,     0,  2069,     0,     0,     0,   677,
       0,     0,     0,     0,  2074,  1814,  1488,     0,  2075,     0,
       0,     0,  2070,     0,     0,  3207,  1814,     0,     0,     0,
    2072,     0,     0,     0,     0,  2073,     0,   677,     0,  2076,
    2077,     0,     0,  4155,     0,     0,  1488,  1488,     0,     0,
       0,     0,     0,  2078,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1488,  1488,     0,     0,
       0,  1488,     0,     0,     0,  2079,     0,     0,  2080,     0,
       0,     0,     0,  1488,  1488,  1488,  1488,     0,     0,     0,
       0,  2081,     0,     0,  2082,  1488,     0,  1814,  1488,     0,
    1488,  3269,     0,     0,     0,     0,     0,  1814,     0,     0,
    1488,  1488,  3691,  1488,     0,     0,     0,     0,   802,     0,
       0,     0,     0,     0,     0,     0,  1488,     0,  1488,     0,
    1173,     0,  1488,     0,     0,     0,     0,     0,     0,     0,
       0,  1806,     0,     0,     0,     0,     0,     0,  1488,     0,
    2074,     0,  1047,     0,  2075,     0,     0,     0,  2518,     0,
    1488,  1488,  1488,   802,  2083,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2076,  2077,  3692,     0,     0,
    1269,     0,     0,     0,  1488,     0,   905,     0,     0,  2078,
       0,  2167,     0,  1488,     0,     0,     0,     0,   906,  4245,
       0,     0,  1488,     0,     0,     0,     0,  1488,     0,     0,
    1010,  1047,     0,     0,  1488,     0,     0,  1010,   907,  1010,
       0,  2079,     0,     0,  2080,     0,     0,     0,  1506,     0,
       0,   802,     0,     0,     0,     0,     0,  2081,     0,     0,
    2082,     0,     0,   908,     0,   677,     0,     0,     0,     0,
    2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,
       0,     0,  1488,   909,  2926,     0,     0,  1814,  1960,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,     0,     0,     0,
       0,     0,     0,  1814,     0,     0,  1806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4317,     0,     0,
    2083,     0,   911,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,   677,   914,     0,
       0,     0,     0,  2068,     0,     0,  2069,     0,     0,     0,
       0,     0,     0,  2068,     0,     0,  2069,     0,     0,     0,
       0,     0,     0,  2070,     0,     0,     0,     0,  1814,     0,
       0,  2072,     0,  2070,     0,     0,  2073,     0,     0,     0,
       0,  2072,     0,     0,     0,     0,  2073,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2084,  2085,  2086,   677,
    2087,  2088,  2089,  2090,  2091,  2092,     0,     0,     0,  2926,
    2926,     0,     0,     0,     0,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   916,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3506,     0,
       0,     0,     0,     0,     0,   827,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1814,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   917,
       0,     0,     0,   918,     0,   919,     0,  1960,  1047,  4450,
       0,   920,     0,     0,   921,  1814,     0,     0,  1047,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2074,     0,  1047,     0,  2075,     0,     0,     0,  1269,
     922,  2074,   923,     0,     0,  2075,   924,     0,   695,     0,
       0,     0,  3121,     0,   925,  3597,  2076,  2077,  2518,   926,
    1814,     0,  2518,     0,  1814,  1814,  2076,  2077,  3610,   927,
    2078,  1488,     0,     0,     0,     0,     0,     0,     0,     0,
    2078,   928,     0,     0,     0,     0,  1047,     0,  1806,  1047,
       0,     0,   677,     0,     0,     0,  3628,     0,     0,     0,
       0,     0,  2079,     0,     0,  2080,     0,  1142,     0,     0,
     677,     0,  2079,     0,     0,  2080,     0,  2599,  2081,     0,
       0,  2082,     0,     0,     0,  1806,     0,     0,  2081,     0,
    1047,  2082,   677,     0,     0,     0,     0,  4451,     0,     0,
    1488,     0,     0,     0,  3221,     0,     0,     0,  1806,  1488,
       0,     0,     0,     0,     0,  1488,     0,  1488,     0,     0,
       0,     0,     0,  1488,     0,     0,  1488,  1488,  1488,  1488,
    1488,  1488,  1488,  1488,  1488,  1488,     0,     0,     0,  1488,
    1488,     0,     0,     0,     0,     0,  2068,     0,     0,  2069,
       0,  2083,  1488,     0,     0,     0,     0,  2068,  1488,     0,
    2069,  2083,     0,     0,     0,     0,  2070,     0,  1488,  3251,
    1806,  1488,     0,  1488,  2072,     0,     0,  2070,     0,  2073,
    3260,     0,  1488,  1488,  1488,  2072,     0,  1806,  1488,     0,
    2073,  1488,     0,     0,     0,     0,     0,     0,  1047,  1047,
       0,  1488,     0,     0,     0,  1806,     0,  3737,     0,  1488,
       0,  1488,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1806,     0,     0,     0,     0,     0,     0,  2084,  2085,  2086,
    2167,  2087,  2088,  2089,  2090,  2091,  2092,  2084,  2085,  2086,
       0,  2087,  2088,  2089,  2090,  2091,  2092,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2068,     0,     0,  2069,     0,     0,     0,     0,     0,     0,
       0,  3774,  1960,  1960,     0,  1806,     0,   677,     0,     0,
    2070,     0,     0,     0,     0,     0,     0,     0,  2072,   802,
       0,     0,     0,  2073,  2074,     0,  3792,  1144,  2075,     0,
       0,     0,     0,  1144,     0,  2074,     0,     0,     0,  2075,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2076,
    2077,     0,     0,     0,     0,     0,     0,     0,  1816,     0,
    2076,  2077,     0,  2078,  1144,   677,     0,   677,  2068,     0,
       0,  2069,     0,     0,  2078,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2070,     0,
       0,  3698,     0,  1269,     0,  2079,  2072,     0,  2080,     0,
       0,  2073,     0,     0,     0,     0,  2079,     0,     0,  2080,
       0,  2081,     0,     0,  2082,     0,  1144,     0,     0,     0,
    3506,     0,  2081,  1144,     0,  2082,  1047,     0,     0,     0,
       0,     0,  3256,     0,     0,     0,     0,     0,  1488,     0,
       0,     0,     0,  2068,  1047,     0,  2069,     0,  2074,     0,
       0,     0,  2075,     0,     0,     0,     0,     0,     0,     0,
       0,  1047,     0,  2070,     0,     0,     0,     0,     0,     0,
    3077,  2072,     0,  2076,  2077,  3922,  2073,     0,     0,  2322,
       0,  3628,     0,     0,  2083,     0,     0,  2078,     0,     0,
       0,     0,  1488,  1488,     0,  2083,  1806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3121,  1816,     0,     0,  2518,     0,     0,  2079,
       0,  2518,  2080,     0,  2518,  3077,  2074,  3960,     0,     0,
    2075,     0,     0,  1144,  2926,  2081,  2926,     0,  2082,  1010,
       0,     0,     0,  1010,     0,     0,     0,     0,     0,     0,
       0,  2076,  2077,     0,   677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2078,     0,     0,  1488,  1144,
    2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,
       0,  2084,  2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,
    2092,     0,     0,     0,     0,     0,     0,  2079,     0,     0,
    2080,  2074,     0,     0,  1488,  2075,     0,     0,  2083,     0,
       0,  1488,  1488,  2081,     0,     0,  2082,     0,     0,  1488,
    1488,     0,     0,     0,  1488,     0,  2076,  2077,     0,     0,
    1488,  1488,     0,     0,  1488,     0,  1047,  1047,  1047,  1047,
    2078,     0,     0,     0,     0,  1488,     0,     0,     0,     0,
       0,  4024,     0,     0,     0,     0,     0,  1488,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1173,     0,
       0,     0,  2079,     0,     0,  2080,     0,     0,     0,     0,
       0,     0,   978,     0,     0,  1488,  2083,     0,  2081,  1148,
    1148,  2082,     0,     0,  2084,  2085,  2086,     0,  2087,  2088,
    2089,  2090,  2091,  2092,  4057,     0,     0,  1144,     0,     0,
       0,     0,   677,     0,  1144,     0,     0,     0,     0,     0,
       0,     0,     0,   677,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1806,     0,  1817,  1148,     0,  1806,  1806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1806,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1916,  2083,     0,  1269,  1144,     0,     0,     0,     0,     0,
    1960,     0,  2084,  2085,  2086,  1816,  2087,  2088,  2089,  2090,
    2091,  2092,     0,     0,  3506,  3506,  3506,  3506,  3506,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1488, -1916,
       0,     0,  2315,     0,     0,     0,     0,     0,     0,     0,
   -1916,     0,     0,     0, -1916,     0,     0,     0,     0, -1916,
    1144,     0,     0,     0, -1916,  1816,     0, -1916,     0, -1916,
       0,     0,     0,     0,     0,     0,     0,  2084,  2085,  2086,
       0,  2087,  2088,  2089,  2090,  2091,  2092,     0,     0,  1047,
       0,  4159,     0,     0,  1806,     0, -1916,  1488,     0,     0,
       0,  2518,     0,     0,  3960,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -1916,     0,     0,     0,     0,
    1817,     0,     0,   677,     0,     0,     0,  1816,  1488,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1816,     0,  1144,     0,     0,     0,
       0,     0,  1488,  1488,     0,  1806,  1488,     0, -1916,     0,
       0,     0,  1816,  1488,  1488,     0, -1916,     0,     0,     0,
       0,     0,     0,     0,  1144,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   677,     0,   677,  1816,     0,     0,
    3774,  1173,  1148,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,  1144,     0,  1144,     0,     0,     0,     0, -1916,
    1142,  1173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,     0,     0,     0,     0,     0,     0,
    2068,     0,     0,  2069,     0,  1960,     0,     0,     0,     0,
       0,     0,  1816,     0,     0,     0,  1142,     0,     0,     0,
    2070,     0,     0,     0,   983,  1047,     0,     0,  2072,     0,
       0,     0,     0,  2073,     0,     0,     0,  2926,  1806,  2322,
       0,     0,  1144,   802,     0,     0,     0, -1916,     0,  3922,
       0,     0,     0,     0,  1047,  2068,     0,     0,  2069,     0,
       0,     0,     0,  1148,  3774,     0,     0,     0, -1916,     0,
   -1916, -1916,     0,     0,  1144,  2070,     0,     0,  1144,  1144,
       0,     0,     0,  2072,     0,     0,     0,     0,  2073,     0,
       0,     0,     0,  1488,     0,     0,  1488,     0,  1488,     0,
       0,     0, -1916,     0,     0, -1916, -1916,     0, -1916,     0,
       0,  4305,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1148,     0,     0,     0,     0,
       0,     0,     0,  1047,     0,     0,  1488,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1148,  1148,  1148,  1148,
       0,     0,  1817,     0,     0,  1269,     0,   802,  2074,     0,
       0,  1010,  2075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1488,     0,     0,     0,
       0,     0,  1010,  2076,  2077,     0,     0,     0,     0,  1817,
       0,     0,     0,     0,     0,     0,  1808,  2078,     0,     0,
       0,     0,     0,  1816,     0,     0,     0,     0,     0,     0,
       0,     0,  1817,  2074,     0,     0,     0,  2075,     0,     0,
       0,     0,  1488,     0,     0,     0,     0,     0,     0,  2079,
    1173,     0,  2080,     0,     0,     0,     0,  2763,  2076,  2077,
       0,     0,     0,     0,     0,  2081,     0,     0,  2082,     0,
       0,     0,  2078,     0,     0,     0,     0,  1010,     0,     0,
       0,     0,     0,  1148,     0,     0,  1142,     0,     0,     0,
       0,     0,     0,  3774,  1817,     0,     0,     0,     0,     0,
    4159,     0,     0,     0,  2079,     0,  4305,  2080,     0,  1488,
    1488,  1817,   677,     0,     0,     0,     0,     0,     0,  1142,
    2081,     0,     0,  1148,     0,     0,     0,     0,     0,  1817,
       0,  1806,  1806,     0,  1806,     0,     0,     0,  2083,     0,
       0,     0,     0,     0,     0,     0,  1488,     0,     0,     0,
       0,     0,     0,     0,  1817,     0,  1488,     0,     0,   802,
       0,     0,     0,     0,  3652,     0,     0,     0,     0,     0,
    4464,  1808,     0,     0,     0,  1806,     0,  1806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2083,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,  1144,     0,     0,     0,     0,     0,  1817,
    1488,     0,  1144,     0,     0,  4464,     0,     0,     0,  1142,
       0,     0,     0,  4464,  2084,  2085,  2086,     0,  2087,  2088,
    2089,  2090,  2091,  2092,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1806,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2882,     0,     0,     0,     0,  2315,  2889,     0,     0,     0,
       0,     0,     0,  1806,     0,     0,  1816,     0,     0,  2084,
    2085,  2086,     0,  2087,  2088,  2089,  2090,  2091,  2092,     0,
       0,     0,     0,     0,     0,     0,  1144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1806,     0,   853,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   854,     0,     0,  1806,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1144,  1144,     0,     0,  1806,     0,
       0,   855,  1144,     0,     0,  1144,     0,     0,  1144,     0,
       0,  1806,     0,     0,     0,     0,  1144,  1144,     0,     0,
       0,     0,   856,     0,  1144,     0,  -629,  1144,  1144,  1144,
    1144,     0,     0,     0,     0,     0,     0,  1144,  1144,     0,
    1144, -1918,  1144,     0,     0,  1144,   857,     0,  1806,     0,
       0,  1816,   858,     0,     0,     0,     0,     0,     0,     0,
    1817,  1144,   802,     0,     0,  1144,     0,   859,     0,  1144,
       0,     0,     0,  1144,     0,  1144,  1144,  1144,  1144,  1144,
    1144,  1144,  1144,  1144,     0,  1144,     0,     0,     0,     0,
   -1918,  1144,     0,  1808,  1144,   860,     0,     0,     0,     0,
       0, -1918,   861,     0,     0, -1918,   862,     0,     0,     0,
   -1918,     0,  2315,     0,  1806, -1918,     0,     0, -1918,     0,
   -1918,  -789,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,  1806,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0, -1918,     0,     0,
       0,     0,     0,  1808,     0,     0,     0,   863,  1806,     0,
       0,     0,     0,  1144,     0,     0, -1918,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1008,     0,
       0,     0,  1806,     0,     0,  1008,     0,  1008,     0,     0,
       0,   864,     0,     0,   865,     0,     0,     0,     0, -1918,
       0,     0,     0,     0,     0,  1808,     0, -1918,     0,     0,
       0,     0,     0,     0,     0,  1816,     0,     0,     0,     0,
       0,     0,  1808,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,   866,   802,     0,     0,     0,     0,   867,     0,
   -1918,     0,     0,     0,  -362,     0,     0,   868,     0,     0,
       0,     0,     0,     0,     0,  1808,     0,  1144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -362,     0,   869,   870,  1817,   871,   872,
       0,     0,  1817,  1817,     0,   983,     0,   873,     0,     0,
       0,     0,   874,  1817,     0,     0,     0,   875,     0,     0,
       0,     0,   876,     0,     0,  1806,     0,     0, -1918,   802,
    1808,     0,     0,     0,  -362,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1918,
       0, -1918, -1918,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   802,     0,     0,     0,  2763,  2763,
    2763,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -1918,     0,     0, -1918, -1918,     0, -1918,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1144,     0,  1817,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1806,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1806,     0,     0,     0,     0,     0,     0,  1817,
       0,     0,     0,     0,     0,     0,     0,     0,  2315,  2889,
    1144,  2889,     0,     0,     0,     0,     0,     0,     0,     0,
    1144,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1816,     0,  1816,     0,     0,  1144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1817,     0,     0,  1806,     0,     0,     0,     0,
       0,     0,     0,  1816,     0,     0,  1806,     0,     0,     0,
       0,  1144,  1144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2889,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,  1144,     0,     0,     0,  1144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1144,  1144,
    1144,  1144,     0,     0,  2889,     0,   802,     0,     0,     0,
    1144,   802,     0,  1144,     0,  1144,     0,     0,     0,     0,
       0,  1816,     0,     0,     0,  1144,  1144,  1806,  1144,     0,
       0,     0,     0,     0,     0,  1816,     0,  1806,     0,     0,
       0,  1144,     0,  1144,     0,     0,     0,  1144,  2889,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,  1144,  1144,  1144,     0,  2763,
       0,     0,     0,     0,     0,  1816,     0,     0,  1808,     0,
       0,     0,     0,  1808,  1808,     0,     0,     0,     0,  1144,
       0,     0,     0,     0,  1808,     0,     0,     0,  1144,     0,
       0,     0,     0,     0,     0,     0,     0,  1144,     0,     0,
       0,     0,  1144,     0,     0,  1140,     0,     0,     0,  1144,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1816,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
    1816,     0,     0,     0,     0,     0,     0,  1144,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1816,     0,  1806,     0,     0,
       0,     0,     0,     0,     0,  1817,  1817,     0,  1817,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,  1808,
       0,  1140,     0,  1806,     0,     0,     0,     0,     0,  1816,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1817,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,  2763,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,   802,   802,   802,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1817,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,  1809,     0,     0,     0,     0,  1008,     0,     0,
       0,  1008,   802,     0,     0,     0,     0,  1817,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2889,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     802,  1817,     0,     0,     0,     0,     0,  1806,     0,     0,
       0,     0,     0,  1808,     0,     0,     0,     0,  1817,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1817,     0,     0,  1806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1817,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,  1144,     0,     0,
       0,     0,     0,     0,     0,     0,  1144,     0,     0,     0,
    1806,     0,  1817,     0,  1806,  1806,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1816,     0,     0,  1809,     0,     0,
       0,     0,  1144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,  2315,
       0,     0,     0,     0,     0,  1144,     0,     0,  1817,     0,
       0,     0,     0,  1815,  1144,     0,     0,     0,     0,     0,
    1144,     0,  1144,     0,     0,     0,     0,  1817,  1144,     0,
       0,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,  1144,
    1144,     0,  1140,     0,  1144,  1144,     0,     0,     0,     0,
       0,     0,  1817,     0,     0,     0,     0,  1144,     0,     0,
       0,   802,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,  1144,     0,  1144,     0,
       0,     0,     0,     0,     0,     0,  1817,  1144,  1144,  1144,
       0,     0,     0,  1144,     0,     0,  1144,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1144,     0,  1140,     0,
       0,     0,     0,     0,  1144,     0,  1144,     0,     0,     0,
       0,     0,  1816,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1816,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1808,  1808,     0,  1808,
       0,     0,     0,  2763,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2763,     0,     0,  1815,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1144,     0,     0,     0,
    1808,     0,  1808,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1816,     0,     0,     0,   802,  1817,
     802,     0,  1140,     0,  1816,     0,     0,     0,     0,  1809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   802,     0,     0,     0,     0,     0,  1140,
    1140,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,     0,     0,     0,     0,  1809,     0,     0,  1140,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,  1809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,  1808,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1808,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1809,  1140,  1808,     0,     0,  1140,  1140,     0,     0,
       0,     0,     0,     0,  4153,     0,  1808,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,  1817,  1144,  1144,     0,
       0,     0,     0,     0,  1816,     0,  1809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,  1808,     0,     0,  1144,     0,     0,  1144,
    1816,  1809,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1815,     0,     0,     0,     0,     0,     0,     0,     0,  1008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,     0,     0,     0,
    1008,     0,     0,     0,     0,     0,  1809,  1815,     0,  1808,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2889,     0,     0,  1808,  1144,
    1815,     0,     0,     0,     0,     0,  1144,  1144,     0,  1817,
       0,     0,     0,     0,  1144,  1144,     0,     0,     0,  1144,
    1817,     0,     0,  1808,     0,  1144,  1144,     0,     0,  1144,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1144,     0,     0,     0,     0,  1008,     0,     0,     0,     0,
       0,     0,  1144,     0,     0,     0,     0,  1808,     0,     0,
       0,     0,  1815,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
    1144,     0,     0,     0,  2889,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1815,     0,     0,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1817,  1816,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1815,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   802,  1816,     0,     0,
       0,  1816,  1816,     0,     0,     0,     0,  1809,     0,  1140,
       0,  1140,     0,     0,     0,     0,     0,  1815,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   802,     0,     0,     0,     0,     0,     0,
    4153,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1144,     0,  1140,     0,  1144,     0,     0,     0,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1144,     0,     0,     0,  1817,     0,     0,
       0,     0,  1140,  1140,     0,     0,     0,     0,     0,     0,
    1140,     0,  1808,  1140,     0,     0,  1140,  1144,  1144,     0,
       0,  1144,     0,     0,  1140,  1140,     0,     0,  1144,  1144,
       0,     0,  1140,     0,     0,  1140,  1140,  1140,  1140,     0,
       0,     0,     0,     0,     0,  1140,  1140,  1808,  1140,     0,
    1140,     0,     0,  1140,     0,  1144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1815,  1140,
       0,     0,  1817,  1140,     0,  1144,     0,  1140,     0,     0,
       0,  1140,     0,  1140,  1140,  1140,  1140,  1140,  1140,  1140,
    1140,  1140,     0,  1140,     0,     0,     0,     0,     0,  1140,
       0,     0,  1140,     0,  1809,     0,     0,     0,     0,  1809,
    1809,  1144,     0,     0,     0,     0,     0,     0,     0,     0,
    1809,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1144,
       0,  1817,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1808,     0,     0,     0,     0,     0,     0,  1144,  1817,
       0,  1144,     0,  1144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,  1817,  1809,     0,     0,  1817,  1817,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1808,     0,   802,     0,     0,     0,     0,     0,
       0,  1144,  1808,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1809,  1817,     0,     0,
       0,     0,     0,     0,     0,  1815,     0,     0,     0,     0,
    1815,  1815,     0,     0,     0,     0,     0,  1144,     0,   699,
       0,  1815,     0,     0,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,     0,   699,     0,     0,  1144,     0,
       0,     0,     0,     0,     0,     0,   891,     0,     0,   699,
       0,     0,     0,     0,  1144,  1144,   891,     0,     0,     0,
     699,     0,     0,     0,  1144,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1809,
       0,   699,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1144,     0,     0,     0,     0,     0,   891,     0,     0,
       0,  1144,  1808,     0,  1140,     0,  1815,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1808,     0,
    1063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1144,     0,     0,     0,     0,
       0,     0,     0,     0,  1144,     0,     0,  1815,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1808,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1811,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1815,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1808,     0,     0,  1108,     0,     0,     0,  1140,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1808,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
    1140,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1140,  1140,  1140,  1140,
       0,     0,  1809,  1809,     0,  1809,     0,     0,  1140,     0,
       0,  1140,     0,  1140,     0,  1808,     0,     0,  1811,  1808,
    1808,     0,     0,  1140,  1140,     0,  1140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
       0,  1140,     0,     0,     0,  1140,  1809,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,  1140,  1140,  1140,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,  1140,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,  1809,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1809,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1809,     0,     0,     0,     0,
       0,     0,     0,  1815,  1815,     0,  1815,     0,     0,  1809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1809,     0,     0,     0,     0,     0,     0,   891,
     891,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1108,  1815,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,  1815,     0,
       0,     0,     0,     0,     0,  1809,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,  1809,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1809,
       0,     0,  1175,     0,  1177,     0,  1179,     0,  1181,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1815,  1223,     0,     0,
       0,     0,  1811,  1809,     0,     0,     0,     0,     0,     0,
    1815,  1241,  1242,     0,     0,     0,  1244,     0,     0,  1811,
       0,     0,     0,  1815,     0,     0,     0,     0,     0,     0,
       0,  1108,     0,   891,     0,     0,     0,  1811,     0,     0,
       0,  1140,     0,     0,     0,  1140,     0,     0,     0,  1274,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
    1815,  1293,  1811,     0,  1295,     0,  1297,     0,  1300,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,   891,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,     0,     0,     0,     0,   699,     0,   699,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   699,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
       0,     0,     0,  1140,     0,     0,  1815,     0,   699,   699,
       0,     0,  1140,     0,     0,  1382,  1809,  1383,  1140,     0,
    1140,     0,     0,     0,     0,  1815,  1140,     0,     0,  1140,
    1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,  1140,     0,
       0,     0,  1140,  1140,     0,     0,     0,  1108,     0,     0,
    1815,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,  1140,     0,  1140,     0,     0,     0,
       0,     0,     0,  1063,  1815,  1140,  1140,  1140,     0,     0,
       0,  1140,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,  1140,     0,  1140,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1634,     0,  1636,     0,     0,     0,  1638,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1809,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1140,     0,     0,     0,  1811,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1752,
       0,     0,     0,     0,     0,     0,   682,  1815,     0,     0,
       0,   696,  1764,   696,     0,     0,     0,     0,     0,     0,
       0,  1770,     0,   696,     0,     0,     0,  1772,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1820,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   696,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   696,
       0,     0,     0,     0,     0,     0,     0,  1857,     0,   696,
     696,     0,     0,   696,     0,     0,     0,     0,     0,     0,
     696,     0,     0,     0,   970,     0,  1809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1809,     0,     0,
       0,     0,     0,     0,     0,   970,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   696,     0,     0,     0,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   699,     0,   699,
       0,     0,   699,     0,   699,     0,     0,   699,   699,   699,
       0,     0,     0,     0,  1815,  1140,  1140,     0,     0,     0,
     699,     0,     0,     0,     0,     0,     0,     0,  1809,     0,
       0,     0,     0,     0,   699,     0,   699,     0,  1809,  1140,
       0,     0,     0,     0,  1140,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1811,     0,     0,     0,     0,
    1811,  1811,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1811,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,  1140,  1140,     0,  1815,     0,     0,
       0,     0,  1140,  1140,     0,     0,     0,  1140,  1815,     0,
       0,     0,     0,  1140,  1140,     0,     0,  1140,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,   696,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1140,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1811,     0,  1809,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1140,     0,
       0,     0,     0,     0,     0,     0,  1063,     0,     0,     0,
       0,     0,     0,     0,  1809,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2235,
       0,     0,  2235,     0,     0,     0,     0,     0,     0,     0,
    2242,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2251,  1809,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2289,     0,     0,     0,     0,     0,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,     0,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,  1809,     0,
    1140,     0,     0,     0,  1140,     0,     0,     0,     0,  1815,
       0,     0,     0,     0,     0,   696,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1809,     0,     0,     0,
       0,  1140,     0,     0,     0,  1815,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,  1140,     0,     0,  1140,
       0,     0,     0,   696,   696,     0,  1140,  1140,     0,     0,
       0,  1809,     0,     0,     0,  1809,  1809,     0,     0,     0,
     696,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1140,     0,     0,     0,  2450,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2472,
    1815,     0,     0,  1140,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
       0,     0,     0,  2526,     0,     0,     0,  2530,     0,     0,
       0,     0,     0,     0,     0,     0,  2539,     0,  2541,     0,
    2542,     0,     0,     0,     0,  2543,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1140,     0,  1815,
       0,     0,     0,     0,     0,     0,     0,     0,   699,     0,
     699,     0,     0,     0,   699,     0,   699,     0,     0,   699,
       0,     0,     0,   699,  2571,     0,  1140,  1815,     0,  1140,
       0,  1140,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1811,  1811,     0,  1811,     0,     0,     0,
       0,     0,     0,     0,  1261,   696,     0,   696,     0,  1140,
       0,     0,  1815,     0,     0,     0,  1815,  1815,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,  1811,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
       0,     0,   696,  1812,     0,   696,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   682,     0,
     970,     0,   970,     0,     0,  1815,     0,     0,   682,     0,
       0,     0,   696,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1140,     0,     0,     0,     0,
       0,     0,   970,   970,     0,     0,     0,     0,  1811,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2764,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1811,     0,     0,     0,  1140,
       0,   696,     0,   696,     0,     0,  1140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1140,  1140,     0,     0,     0,     0,     0,  1811,
       0,     0,  1140,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1811,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1140,
    1811,     0,     0,     0,     0,     0,     0,     0,  1812,  1140,
       0,     0,     0,  1811,     0,     0,     0,   682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   682,   682,     0,     0,  1616,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,     0,     0,  1108,     0,     0,     0,
       0,     0,     0,  1140,     0,     0,     0,     0,     0,     0,
       0,     0,  1140,  2843,   682,     0,     0,     0,  2847,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2857,     0,
       0,     0,     0,     0,     0,  2863,     0,     0,     0,     0,
       0,  2868,     0,     0,     0,     0,     0,  2878,     0,     0,
       0,     0,  2880,     0,     0,     0,  1811,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1811,     0,     0,  2896,  2897,
    2900,  2902,     0,     0,     0,  2909,  2912,     0,     0,     0,
    2915,     0,     0,  2919,     0,     0,     0,     0,     0,     0,
    1811,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2954,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2957,     0,  2959,     0,     0,     0,     0,     0,     0,     0,
       0,  2970,  2971,  2972,  1811,  2974,     0,     0,     0,     0,
       0,     0,     0,     0,  2987,  2988,     0,     0,     0,     0,
       0,     0,  2991,  2992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   682,     0,     0,  1145,
       0,   696,     0,   696,     0,  1145,   696,     0,   696,     0,
       0,   696,   696,   696,     0,     0,     0,  1955,     0,     0,
    1812,     0,     0,     0,   696,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,   696,     0,
     696,     0,     0,     0,     0,   696,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
    1812,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,  1812,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2108,  1812,
       0,     0,     0,     0,     0,     0,     0,   696,   696,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
    3192,     0,     0,     0,   682,     0,     0,     0,   682,   682,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1811,
       0,     0,  1812,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1811,     0,     0,     0,     0,     0,
       0,  1145,     0,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
       0,     0,     0,     0,     0,     0,     5,     0,   696,  1813,
     682,     0,     0,     0,     0,     0,     6,     7,     0,     0,
    2239,     0,     0,     0,     9,    10,     0,     0,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     0,    45,     0,     0,
     682,     0,     0,     0,     0,     0,   682,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1811,     0,
       0,     0,     0,     0,    46,     0,     0,   682,     0,  1145,
     682,   682,     0,     0,     0,     0,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3373,  3374,     0,     0,  1818,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   682,  3393,     0,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    47,     0,  1812,  1811,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1811,
       0,    48,     0,     0,     0,     0,     0,     0,  3412,  3413,
    3414,  3415,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,    50,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1813,     0,     0,     0,     0,    51,     0,     0,    52,
       0,     0,     0,     0,     0,     0,     0,  1476,     0,     0,
       0,     0,  3456,     0,     0,     0,     0,  3458,     0,     0,
      53,     0,  1818,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1549,     0,     0,     0,     0,  1145,     0,
       0,  1813,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   696,     0,   696,     0,     0,     0,   696,     0,
     696,     0,     0,   696,     0,     0,  1145,   696,     0,  1811,
       0,     0,  2108,     0,     0,     0,     0,     0,     0,     0,
       0,    54,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3556,   891,  1145,  1145,  1811,  1145,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,    55,     0,     0,     0,     0,   891,     0,
       0,     0,     0,     0,     0,  1812,    56,     0,  1813,     0,
    1812,  1812,     0,     0,     0,     0,     0,     0,     0,    57,
       0,  1812,     0,     0,     0,  3616,     0,     0,     0,     0,
       0,     0,     0,  1813,  1145,     0,     0,     0,  3625,     0,
    1811,     0,     0,     0,    58,     0,     0,     0,     0,     0,
      59,     0,     0,     0,    60,    61,    62,    63,    64,     0,
       0,    65,    66,  1308,     0,     0,  1145,     0,    71,  1309,
    1145,  1145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1955,     0,  1813,     0,
       0,     0,     0,  2765,     0,     0,     0,     0,     0,     0,
       0,     0,  2239,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1811,
       0,     0,     0,     0,     0,     0,  1812,     0,     0,     0,
       0,     0,     0,     0,  1818,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   682,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
       0,     0,  1811,     0,  1818,     0,  1811,  1811,     0,     0,
       0,     0,     0,     0,     0,   682,     0,     0,     0,   682,
       0,     0,     0,     0,     0,  2827,     0,  1616,     0,     0,
     696,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2009,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1818,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2032,  1813,
       0,     0,     0,  1818,     0,     0,     0,     0,     0,     0,
       0,  3791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,     0,     0,     0,  2056,  2057,     0,  2059,     0,
    1812,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2098,  1818,     0,  3817,     0,
       0,     0,     0,  3824,     0,  3826,  3827,  3828,  3829,     0,
       0,     0,     0,     0,     0,     0,     0,   682,     0,     0,
       0,     0,     0,     0,     0,   682,     0,   682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,  1145,  2151,     0,     0,     0,
       0,  1818,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3887,  3889,  3891,     0,  3893,     0,     0,     0,  2181,     0,
       0,     0,  2191,  2194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,  3393,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3962,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,  1145,     0,     0,
       0,     0,     0,     0,  1145,     0,  1813,  1145,     0,     0,
    1145,  1813,  1813,     0,     0,     0,     0,     0,  1145,  1145,
       0,     0,  1813,     0,     0,     0,  1145,     0,     0,  1145,
    1145,  1145,  1145,     0,     0,     0,     0,     0,     0,  1145,
    1145,     0,  1145,     0,  1145,     0,     0,  1145,     0,   696,
    1955,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1818,  1145,     0,   682,     0,  1145,     0,     0,
       0,  1145,     0,  1812,  1812,  1145,  1812,  1145,  1145,  1145,
    1145,  1145,  1145,  1145,  1145,  1145,     0,  1145,     0,     0,
       0,     0,     0,  1145,     0,     0,  1145,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,  1812,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1813,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
    4063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4072,     0,     0,     0,     0,     0,     0,  1812,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2239,     0,     0,  1812,
       0,   682,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1812,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1145,
    1812,  4124,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1812,     0,     0,     0,     0,     0,  1818,
       0,     0,     0,  4143,  1818,  1818,     0,     0,     0,     0,
       0,  1813,     0,     0,     0,  1818,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1812,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4172,     0,     0,     0,  2634,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2656,     0,
       0,  2658,     0,     0,  2669,     0,     0,     0,     0,     0,
       0,  2676,  2681,     0,     0,     0,  2686,     0,     0,  2691,
       0,     0,     0,     0,     0,     0,  1812,     0,     0,     0,
       0,     0,     0,     0,     0,  2700,     0,     0,     0,  2706,
       0,     0,     0,  2718,     0,  1812,     0,  2725,     0,  2727,
    2728,  2729,  2730,  2731,  2732,  2733,  2734,  2735,  1145,  2736,
    1818,     0,     0,     0,     0,  1476,     0,     0,  2760,     0,
    1812,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1812,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,   682,     0,     0,     0,  1549,     0,     0,
       0,     0,  1145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3393,
       0,     0,     0,     0,     0,     0,     0,   682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,     0,     0,     0,   696,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1813,  1813,     0,  1813,     0,     0,
       0,     0,   696,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1818,     0,     0,  1812,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2866,     0,  1145,  1145,     0,     0,     0,  1813,     0,
    1813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2094,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,  1145,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1145,  1145,  1145,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,     0,     0,  1145,     0,  1145,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1145,  1145,  1813,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,  1145,     0,     0,  4395,  1145,
       0,     0,     0,     0,     0,     0,  1813,     0,     0,  1812,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,  1145,  1145,  1145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,     0,  1812,     0,     0,     0,     0,     0,
    3027,  1145,     0,     0,     0,     0,     0,  1813,     0,     0,
    1145,     0,     0,     0,     0,     0,     0,     0,     0,  1145,
       0,  1813,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,  1145,     0,     0,  1813,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1813,  2827,     0,     0,     0,     0,     0,     0,  1145,
       0,     0,     0,     0,  3138,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1818,  1818,     0,
    1818,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
       0,  3159,     0,     0,     0,   682,     0,     0,  1812,     0,
       0,     0,     0,     0,     0,     0,     0,  1813,   682,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,     0,  1818,     0,     0,  1813,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1813,     0,     0,   682,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3203,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1812,
       0,     0,     0,     0,     0,  1813,     0,     0,     0,  1812,
       0,     0,  1818,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2681,  2094,  2681,  2681,     0,     0,     0,  1818,
       0,     0,     0,     0,  3263,     0,     0,  3266,     0,  3268,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1818,     0,  3289,     0,  3291,     0,     0,
       0,  3294,     0,     0,     0,     0,     0,     0,     0,     0,
    1818,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1818,     0,     0,     0,     0,  2760,
    2760,  2760,     0,     0,     0,     0,     0,  1818,     0,     0,
       0,     0,     0,     0,  2094,     0,     0,     0,     0,     0,
       0,     0,   682,  3341,     0,  1145,     0,     0,  1813,  1145,
       0,     0,  1549,     0,     0,     0,     0,  2094,  1145,     0,
       0,  2181,  2665,     0,  1818,     0,  3356,     0,     0,     0,
       0,     0,     0,  2194,     0,     0,     0,     0,     0,  1812,
       0,  2094,  2094,     0,  2094,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1812,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3382,     0,  2094,     0,     0,     0,  1145,     0,     0,
    1818,     0,     0,     0,     0,     0,  1145,     0,     0,     0,
       0,     0,  1145,     0,  1145,     0,     0,     0,     0,  1818,
    1145,     0,  2239,  1145,  1145,  1145,  1145,  1145,  1145,  1145,
    1145,  1145,  1145,     0,     0,     0,  1145,  1145,   682,     0,
    1813,     0,     0,     0,  1818,     0,  2094,     0,     0,  1145,
    1812,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,   682,  1145,     0,     0,  1145,     0,
    1145,     0,     0,     0,     0,  1813,  2094,     0,  1818,  1145,
    1145,  1145,     0,     0,     0,  1145,  2094,     0,  1145,  2094,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,  1145,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1812,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   682,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1812,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1813,
       0,  1818,  1812,     0,     0,     0,  1812,  1812,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1818,     0,     0,     0,     0,   682,  3653,
       0,     0,     0,     0,     0,     0,     0,     0,  3656,     0,
       0,     0,     0,     0,  3657,     0,  3658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1818,  1145,
    1145,     0,     0,     0,     0,     0,     0,     0,  3676,  3677,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,  2686,  1145,     0,
       0,  1145,     0,     0,     0,     0,     0,  3702,     0,     0,
    3705,     0,  3707,     0,     0,     0,     0,     0,     0,     0,
       0,  3711,     0,     0,     0,     0,     0,  3716,     0,     0,
    3719,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3726,     0,     0,     0,     0,  1145,     0,     0,  3738,     0,
    2760,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1145,     0,     0,     0,     0,  1813,     0,  1145,  1145,
       0,  1818,     0,     0,     0,     0,  1145,  1145,     0,     0,
       0,  1145,  1818,     0,     0,     0,     0,  1145,  1145,     0,
       0,  1145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1145,     0,     0,     0,     0,     0,     0,  2094,
       0,     0,     0,     0,  1145,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2094,     0,  2094,     0,  2665,  2665,  3239,     0,     0,
    2665,  1813,  1145,     0,  2094,     0,     0,   682,     0,     0,
       0,  2094,     0,     0,     0,     0,  2094,     0,     0,     0,
       0,  2094,     0,  1818,     0,     0,  2094,     0,     0,     0,
       0,     0,     0,  1818,     0,  2094,     0,     0,     0,  2665,
    2665,  2094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2094,     0,     0,     0,     0,     0,     0,
    2094,     0,  2094,  2094,  2094,  2094,  2094,  2094,  2094,  2094,
    2094,  2094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1813,     0,     0,     0,     0,  2094,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1813,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3937,  3938,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1813,     0,     0,     0,  1813,  1813,     0,
       0,     0,     0,  1818,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1145,     0,     0,     0,  1145,     0,
       0,     0,     0,  1818,     0,     0,     0,     0,     0,     0,
       0,  2094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1145,     0,     0,     0,  1818,
       0,     0,     0,     0,     0,     0,     0,  3978,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1145,
    1145,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
    1145,  1145,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3994,  3996,     0,     0,     0,     0,     0,  1145,     0,     0,
       0,     0,     0,  4003,     0,     0,     0,     0,     0,  4008,
    4009,     0,     0,  4011,  1818,     0,     0,  1145,     0,     0,
       0,     0,     0,     0,  2760,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2760,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4042,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2094,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1145,     0,  1818,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1145,  1818,     0,  1145,     0,  1145,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,  1818,     0,     0,     0,
    1818,  1818,     0,     0,     0,     0,     0,  4112,     0,     0,
       0,     0,     0,  2094,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,  2094,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1818,
       0,     0,     0,     0,     0,     0,  4162,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2094,  1145,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3239,
    3239,     0,  2665,     0,     0,  2665,  2665,  2665,  2665,  2665,
    2665,  2665,  2665,  2665,  2665,  3239,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,  4192,     0,     0,     0,     0,
    1145,     0,     0,  4194,     0,     0,     0,     0,  2094,     0,
       0,  2094,     0,  2094,     0,     0,  1145,  1145,  3239,  3239,
       0,     0,     0,     0,     0,     0,  1145,     0,     0,     0,
       0,     0,  2665,  2665,  2094,     0,  2094,     0,     0,  2094,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1145,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2094,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2094,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1145,     0,     0,
       0,     0,     0,     0,     0,     0,  1145,  2094,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2686,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4320,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4349,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2665,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     4,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     6,
       7,     0,     0,     0,     0,     8,     0,     9,    10,     0,
       0,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,     0,    36,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,  4413,  4413,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4413,     0,     0,  2094,     0,
       0,  2094,  2094,  2094,     0,  4453,  3239,    46,     0,     0,
       0,  3239,  3239,  3239,  3239,  3239,  3239,  3239,  3239,  3239,
    3239,  2094,  2094,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2094,  2665,  2665,
    2094,     0,  2094,     0,     0,     0,  2094,  3239,  3239,  4413,
       0,  2094,     0,     0,  2094,     0,     0,     0,     0,     0,
       0,  2094,     0,     0,     0,     0,     0,     0,     0,    47,
       0,     0,     0,  2094,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    85,     0,     0,
       0,     0,     0,    89,    49,     0,     0,    93,     0,    94,
       0,    96,    97,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   106,     0,     0,     0,    50,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   119,
     120,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    51,
       0,     0,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,   128,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   129,     0,   130,   131,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1078,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3239,
       0,   141,     0,   142,   143,     0,     0,     0,   145,     0,
     146,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     148,     0,   149,     0,    54,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
       0,   153,  2094,  2094,   156,     0,     0,     0,     0,     0,
     157,     0,     0,     0,     0,     0,   158,     0,   159,     0,
       0,     0,   160,     0,     0,     0,    55,     0,   161,     0,
       0,     0,     0,     0,     0,   163,     0,   165,     0,    56,
       0,     0,   167,  2094,     0,     0,     0,  2665,     0,     0,
       0,     0,    57,     0,     0,     0,   171,     0,     0,  2094,
       0,  2094,     0,     0,     0,     0,  3239,  3239,  2094,     0,
       0,  2665,  2665,  2094,  2094,     0,  2094,    58,     0,     0,
       0,     0,     0,    59,   176,     0,     0,    60,    61,    62,
      63,    64,     0,     0,    65,    66,    67,    68,     0,    69,
      70,    71,    72,    73,     0,     0,     0,  2094,   185,   186,
       0,     0,     0,     0,   187,     0,     0,     0,     0,     0,
       0,     0,     0,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     193,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   204,  2094,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   206,     0,     0,
       0,   207,     0,   208,     0,     0,     0,     0,   209,     0,
       0,     0,     0,   210,     0,     0,   212,     0,     0,     0,
     214,     0,     0,     0,     0,     0,   215,     0,     0,     0,
       0,     0,     0,   216,     0,     0,   218,  2094,     0,     0,
       0,     0,     0,   221,     0,     0,     0,     0,     0,     0,
       0,  3239,  2665,     0,     0,     0,   223,     0,     0,     0,
       0,     0,     0,     0,     0,  3239,  3239,  2094,     0,  2094,
       0,     0,     0,   228,     0,   229,     0,     0,     0,     0,
       0,     0,   231,     0,   232,     0,     0,   233,     0,     0,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   246,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3239,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2094,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2094,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,  2094,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,  2094,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   712,   425,
     426,   427,   713,   714,   715,   716,   717,   718,   719,   428,
     429,   720,   430,   133,   431,   432,   433,   135,   136,   137,
     138,   139,   721,   434,   435,   436,   437,   438,   722,   723,
     439,   440,   724,   140,   442,   725,   443,   444,   445,   446,
     144,   726,   727,   447,   448,   449,   450,   147,   451,   728,
     729,   453,   454,   455,   456,   457,   458,   730,   459,   460,
     461,   150,   462,   731,   732,   733,   734,   151,   735,   736,
     737,   463,   464,   465,   466,   467,   468,   154,   155,   469,
     738,   470,   739,   471,   472,   473,   474,   475,   740,   476,
     477,   478,   741,   742,   479,   480,   481,   482,   483,   743,
     484,   485,   486,   744,   487,   488,   745,   489,   490,   491,
     492,   164,   493,   494,   166,   746,   495,   747,   496,   168,
     497,   748,   498,   749,   499,   169,   750,   170,   500,   501,
     502,   751,   503,   172,   752,   504,   753,   505,   506,   507,
     508,   509,   173,   510,   511,   512,   754,   513,   514,   515,
     516,   517,   518,   755,   519,   174,   175,   756,   520,   521,
     522,   757,   177,   758,   178,   759,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,   760,   182,   183,
     531,   184,   761,   532,   533,   534,   762,   763,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,   190,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,   764,   556,   557,   194,   558,   765,   195,
     559,   196,   560,   561,   562,   766,   563,   767,   768,   564,
     565,   566,   769,   770,   197,   198,   199,   200,   201,   567,
     568,   569,   570,   571,   572,   771,   573,   202,   574,   203,
     575,   576,   577,   772,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,   773,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   774,   598,   599,   211,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,   775,   610,   611,   612,   613,   614,   776,   615,   217,
     616,   617,   219,   618,   220,   777,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,   778,   630,
     631,   779,   632,   633,   634,   635,   636,   637,   780,   224,
     225,   781,   782,   639,   226,   640,   227,   783,   641,   642,
     643,   644,   645,   646,   784,   785,   647,   648,   649,   650,
     786,   787,   651,   652,   653,   654,   788,   235,   789,   656,
     236,   657,   658,   659,   790,   791,   660,   792,   793,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,    85,     0,     0,    86,    87,
      88,    89,    90,    91,    92,    93,     0,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   932,   104,   105,
     106,     0,     0,   107,   108,   109,   110,     0,   111,   112,
     113,   114,   115,     0,   116,   117,   118,   119,   120,     0,
       0,     0,   121,   122,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,   124,     0,   125,
       0,   126,   127,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   129,     0,   130,   131,     0,     0,     0,
       0,     0,     0,     0,     0,   132,   133,     0,     0,   134,
     135,   136,   137,   138,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   140,     0,     0,   141,
       0,   142,   143,   144,     0,     0,   145,     0,   146,     0,
     147,     0,     0,     0,     0,     0,     0,     0,   148,     0,
     149,     0,     0,     0,   150,     0,     0,     0,     0,     0,
     151,     0,     0,     0,     0,     0,     0,   152,     0,   153,
     154,   155,   156,     0,     0,     0,     0,     0,   157,     0,
       0,     0,     0,     0,   158,     0,   159,     0,     0,     0,
     160,     0,     0,     0,     0,     0,   161,   162,     0,     0,
       0,     0,     0,   163,   164,   165,     0,   166,     0,     0,
     167,     0,   168,     0,     0,     0,     0,     0,   169,     0,
     170,     0,     0,     0,   171,     0,   172,     0,     0,     0,
       0,     0,     0,     0,     0,   173,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   174,   175,
       0,     0,   176,     0,     0,   177,     0,   178,     0,     0,
     179,   180,     0,   181,     0,     0,     0,     0,     0,     0,
       0,   182,   183,     0,   184,     0,   185,   186,     0,     0,
       0,     0,   187,     0,     0,     0,     0,     0,     0,     0,
       0,   188,     0,     0,   189,   190,   191,     0,     0,     0,
       0,     0,     0,     0,   192,     0,     0,     0,   193,   194,
       0,     0,   195,     0,   196,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,   198,   199,
     200,   201,     0,     0,     0,     0,     0,     0,     0,     0,
     202,     0,   203,     0,   204,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   205,   206,     0,     0,     0,   207,
       0,   208,     0,     0,     0,     0,   209,     0,     0,     0,
       0,   210,   211,     0,   212,   213,     0,     0,   214,     0,
       0,     0,     0,     0,   215,     0,     0,     0,     0,     0,
       0,   216,   217,     0,   218,   219,     0,   220,     0,     0,
       0,   221,     0,     0,     0,     0,     0,     0,     0,   222,
       0,     0,     0,     0,   223,     0,     0,     0,     0,     0,
       0,     0,   224,   225,     0,     0,     0,   226,     0,   227,
       0,   228,     0,   229,     0,     0,     0,   230,     0,     0,
     231,     0,   232,     0,     0,   233,     0,     0,     0,   234,
     235,     0,     0,   236,     0,     0,     0,     0,     0,     0,
       0,   237,     0,     0,     0,     0,     0,   238,   239,   240,
     241,   242,   243,   244,   245,    86,    87,    88,     0,    90,
      91,    92,     0,     0,     0,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   246,   104,   105,     0,  -124,     0,
     107,   108,   109,   110,     0,   111,   112,   113,   114,   115,
       0,   116,   117,   118,     0,     0,     0,     0,     0,   121,
     122,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,     0,     0,     0,   124,     0,   125,     0,   126,     0,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   133,     0,     0,     0,   135,   136,   137,
     138,   139,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   140,     0,     0,     0,     0,     0,     0,
     144,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   150,     0,     0,     0,     0,     0,   151,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   162,     0,     0,     0,     0,     0,
       0,   164,     0,     0,   166,     0,     0,     0,     0,   168,
       0,     0,     0,     0,     0,   169,     0,   170,     0,     0,
       0,     0,     0,   172,     0,     0,     0,     0,     0,     0,
       0,     0,   173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   174,   175,     0,     0,     0,
       0,     0,   177,     0,   178,     0,     0,   179,   180,     0,
     181,     0,     0,     0,     0,     0,     0,     0,   182,   183,
       0,   184,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   189,   190,   191,     0,     0,     0,     0,     0,     0,
       0,   192,     0,     0,     0,     0,   194,     0,     0,   195,
       0,   196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   197,   198,   199,   200,   201,     0,
       0,     0,     0,     0,     0,     0,     0,   202,     0,   203,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,   213,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,   219,     0,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   224,
     225,     0,     0,     0,   226,     0,   227,     0,     0,     0,
       0,     0,     0,     0,   230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   235,     0,     0,
     236,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   238,   239,   240,   241,   242,   243,
     244,   245,     0,     0,    86,    87,    88,     0,    90,    91,
      92,     0,     0,     0,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,     0,     0,  2817,   107,
     108,   109,   110,     0,   111,   112,   113,   114,   115,     0,
     116,   117,   118,     0,     0,     0,     0,     0,   121,   122,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,   124,     0,   125,     0,   126,     0,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   133,     0,     0,     0,   135,   136,   137,   138,
     139,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   140,     0,     0,     0,     0,     0,     0,   144,
       0,     0,     0,     0,     0,     0,   147,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     150,     0,     0,     0,     0,     0,   151,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   154,   155,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   162,     0,     0,     0,     0,     0,     0,
     164,     0,     0,   166,     0,     0,     0,     0,   168,     0,
       0,     0,     0,     0,   169,     0,   170,     0,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
       0,   173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   174,   175,     0,     0,     0,     0,
       0,   177,     0,   178,     0,     0,   179,   180,     0,   181,
       0,     0,     0,     0,     0,     0,     0,   182,   183,     0,
     184,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     189,   190,   191,     0,     0,     0,     0,     0,     0,     0,
     192,     0,     0,     0,     0,   194,     0,     0,   195,     0,
     196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   197,   198,   199,   200,   201,     0,     0,
       0,     0,     0,     0,     0,     0,   202,     0,   203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     205,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,     0,
       0,   213,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   217,     0,
       0,   219,     0,   220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   222,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   225,
       0,     0,     0,   226,     0,   227,     0,     0,     0,     0,
       0,     0,     0,   230,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,     0,     0,   236,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,   238,   239,   240,   241,   242,   243,   244,
     245,     0,     0,     0,     0,     0,     5,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     6,     7,     0,     0,
       0,     0,     0,     0,     9,    10,     0,  2819,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     0,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     0,    45,     0,     0,
       0,     0,     0,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     6,     7,     0,     0,     0,     0,
       0,     0,     9,    10,    46,     0,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,     0,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,     0,     0,     0,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    47,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,    46,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    47,     0,    51,     0,     0,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,     0,     0,     0,     0,     0,     0,    49,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    51,     0,     0,    52,     0,     0,
       0,    54,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    55,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    56,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    57,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    54,
       0,     0,     0,     0,    58,     0,     0,     0,     0,     0,
      59,     0,     0,     0,    60,    61,    62,    63,    64,     0,
       0,    65,    66,  1308,  1912,     0,     0,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    55,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    56,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     4,     0,     0,
       0,     0,    58,     0,     0,     0,     0,     0,    59,     0,
       0,     0,    60,    61,    62,    63,    64,     5,     0,    65,
      66,  1308,  2552,     0,     0,     0,    71,     6,     7,     0,
       0,     0,     0,     0,     0,     9,    10,     0,     0,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,     0,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    45,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    47,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    48,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    50,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    51,     0,     0,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    53,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    54,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    55,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    58,     0,     0,     0,     0,
       0,    59,     0,     0,     0,    60,    61,    62,    63,    64,
       0,     0,    65,    66,  1308,     0,     0,     0,     0,    71,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,   416,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1397,  1398,
    1399,    45,  1400,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,  2754,   425,   426,   427,     0,     0,
       0,     0,  1401,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,   135,  1402,   137,  1403,  1404,     0,   434,
     435,   436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,
     442,     0,   443,   444,   445,   446,  1409,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,
     466,   467,   468,  1417,  1418,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,  2755,     0,
     479,   480,  1419,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,  1420,   493,   494,
    1421,  1422,   495,     0,   496,  1423,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,  1424,
       0,   504,     0,   505,   506,   507,   508,   509,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,  1425,  1426,     0,
    1427,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,  1428,   183,   531,   184,     0,   532,
     533,   534,  1429,  1430,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1431,   190,  1432,
     548,   549,   550,   551,   552,   553,   554,   192,   555,  1433,
     556,   557,   194,   558,  1434,  1435,   559,  1436,   560,   561,
     562,     0,   563,     0,     0,  1437,   565,   566,     0,     0,
     197,   198,   199,   200,  1438,   567,   568,   569,   570,   571,
     572,     0,   573,  1439,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,  1440,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,  1441,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,  1442,   615,   217,   616,   617,   219,   618,
    1443,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,  1444,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,  1445,  1446,     0,     0,   639,
    1447,   640,  1448,  1449,   641,   642,   643,   644,   645,   646,
       0,  1450,   647,   648,   649,   650,  1451,     0,   651,   652,
     653,   654,   655,  1452,  2756,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,
     668,     0,     0,     0,     0,     0,     0,     0,  1460,  1461,
    2757,     0,     0,     0,     0,     0,     0,  1463,  2758,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,   416,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,  1397,  1398,  1399,
      45,  1400,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,  1401,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,   135,  1402,   137,  1403,  1404,     0,   434,   435,
     436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,
       0,   443,   444,   445,   446,  1409,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,     0,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,
     467,   468,  1417,  1418,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,  1419,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,  1420,   493,   494,  1421,
    1422,   495,     0,   496,  1423,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,  1424,     0,
     504,     0,   505,   506,   507,   508,   509,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,   175,     0,   520,   521,   522,  1425,  1426,     0,  1427,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,  1428,   183,   531,   184,     0,   532,   533,
     534,  1429,  1430,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,  1431,   190,  1432,   548,
     549,   550,   551,   552,   553,   554,   192,   555,  1433,   556,
     557,   194,   558,  1434,  1435,   559,  1436,   560,   561,   562,
       0,   563,     0,     0,  1437,   565,   566,     0,     0,   197,
     198,   199,   200,  1438,   567,   568,   569,   570,   571,   572,
       0,   573,  1439,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,  1440,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,  1441,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,  1442,   615,   217,   616,   617,   219,   618,  1443,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,  1444,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,  1445,  1446,     0,     0,   639,  1447,
     640,  1448,  1449,   641,   642,   643,   644,   645,   646,     0,
    1450,   647,   648,   649,   650,  1451,     0,   651,   652,   653,
     654,   655,  1452,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
    1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,
       0,     0,     0,     0,     0,     0,     0,  1460,  1461,     0,
       0,     0,     0,     0,     0,     0,  1463,  2667,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,     0,  1784,   137,  1785,  1786,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,  1787,  1788,   442,     0,
     443,   444,   445,   446,     0,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,     0,     0,
       0,   151,     0,     0,     0,   463,   464,   465,   466,   467,
     468,  1789,  1790,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
    1419,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,     0,   496,  1791,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,     0,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
    2303,   513,   514,   515,   516,   517,   518,     0,   519,   174,
    2304,     0,   520,   521,   522,  1425,  1792,     0,  1793,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,     0,   183,   531,   184,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,  1794,   190,  1795,   548,   549,
     550,   551,   552,   553,   554,     0,   555,     0,   556,   557,
     194,   558,     0,     0,   559,  1796,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,  2305,   198,
     199,   200,     0,   567,   568,   569,   570,   571,   572,     0,
     573,     0,   574,     0,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,  1797,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,  2306,   616,   617,   219,   618,  1799,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
       0,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1800,  1801,     0,     0,   639,     0,   640,
       0,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
       0,  1802,  2307,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,     0,     0,
       0,     0,     0,     0,     0,     0,   666,   667,   668,     0,
       0,     0,     0,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,  2308,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,     0,  1784,   137,  1785,
    1786,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,  1787,  1788,   442,     0,   443,   444,   445,   446,     0,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,     0,     0,     0,   151,     0,     0,     0,
     463,   464,   465,   466,   467,   468,  1789,  1790,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
       0,   493,   494,     0,     0,   495,     0,   496,  1791,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,     0,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,  2303,   513,   514,   515,   516,
     517,   518,     0,   519,   174,  2304,     0,   520,   521,   522,
    1425,  1792,     0,  1793,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,     0,   183,   531,
     184,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1794,   190,  1795,   548,   549,   550,   551,   552,   553,   554,
       0,   555,     0,   556,   557,   194,   558,     0,     0,   559,
    1796,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,  2305,   198,   199,   200,     0,   567,   568,
     569,   570,   571,   572,     0,   573,     0,   574,     0,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1797,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,  2306,   616,
     617,   219,   618,  1799,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,     0,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1800,  1801,
       0,     0,   639,     0,   640,     0,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,     0,  1802,  2307,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,     0,     0,     0,     0,     0,     0,     0,
       0,   666,   667,   668,     0,     0,     0,     0,     0,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,  3098,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,  4046,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,     0,     0,   705,    86,    87,    88,   403,    90,
      91,    92,   404,  1531,   405,    95,     0,  1532,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,   416,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,  1401,     0,     0,   428,
     429,     0,   430,   133,   431,   432,   433,   135,  1402,   137,
    1403,  1404,  2677,   434,   435,   436,   437,   438,  1405,  1406,
     439,   440,  1407,  1408,   442,     0,   443,   444,   445,   446,
    1409,     0,     0,   447,   448,   449,   450,   147,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,   463,   464,   465,   466,   467,   468,  1417,  1418,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,  1419,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,  1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,
     497,     0,   498,     0,   499,   169,  2678,   170,   500,   501,
     502,     0,   503,  1424,     0,   504,     0,   505,   506,   507,
     508,   509,   173,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,   174,   175,     0,   520,   521,
     522,  1425,  1426,     0,  1427,     0,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,  2679,  1428,   183,
     531,   184,     0,   532,   533,   534,  1429,  1430,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1431,   190,  1432,   548,   549,   550,   551,   552,   553,
     554,   192,   555,  1433,   556,   557,   194,   558,  1434,  1435,
     559,  1436,   560,   561,   562,     0,   563,     0,     0,  1437,
     565,   566,     0,     0,   197,   198,   199,   200,  1438,   567,
     568,   569,   570,   571,   572,     0,   573,  1439,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,  1440,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,   211,
     600,   601,  1441,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,  1442,   615,   217,
     616,   617,   219,   618,  1443,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,  1444,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,  1445,
    1446,     0,  2680,   639,  1447,   640,  1448,  1449,   641,   642,
     643,   644,   645,   646,     0,  1450,   647,   648,   649,   650,
    1451,     0,   651,   652,   653,   654,   655,  1452,     0,   656,
     236,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,
    1458,  1459,   666,   667,   668,     0,     0,     0,     0,     0,
       0,     0,  1460,  1461,     0,     0,     0,     0,     0,     0,
       0,  1463,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,  1401,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,   135,  1402,   137,  1403,  1404,
       0,   434,   435,   436,   437,   438,  1405,  1406,   439,   440,
    1407,  1408,   442,     0,   443,   444,   445,   446,  1409,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,
     464,   465,   466,   467,   468,  1417,  1418,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,  1419,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,  1420,
     493,   494,  1421,  1422,   495,     0,   496,  1423,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,  1424,     0,   504,     0,   505,   506,   507,   508,   509,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,  1425,
    1426,     0,  1427,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,  1428,   183,   531,   184,
       0,   532,   533,   534,  1429,  1430,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1431,
     190,  1432,   548,   549,   550,   551,   552,   553,   554,   192,
     555,  1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,
     560,   561,   562,     0,   563,     0,     0,  1437,   565,   566,
       0,     0,   197,   198,   199,   200,  1438,   567,   568,   569,
     570,   571,   572,     0,   573,  1439,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,  1440,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
    1441,   602,   603,   604,   605,   606,   607,   608,   609,   215,
     610,   611,   612,   613,   614,  1442,   615,   217,   616,   617,
     219,   618,  1443,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,  1444,   629,     0,   630,   631,   223,
     632,   633,   634,   635,   636,   637,     0,  1445,  1446,     0,
       0,   639,  1447,   640,  1448,  1449,   641,   642,   643,   644,
     645,   646,     0,  1450,   647,   648,   649,   650,  1451,     0,
     651,   652,   653,   654,  1324,  1452,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,   237,   661,   662,   663,
     664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
    1460,  1461,     0,     0,     0,     0,     0,     0,     0,  1463,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,   416,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1397,  1398,
    1399,    45,  1400,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,  1401,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,   135,  1402,   137,  1403,  1404,     0,   434,
     435,   436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,
     442,     0,   443,   444,   445,   446,  1409,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,
     466,   467,   468,  1417,  1418,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,  1419,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,  1420,   493,   494,
    1421,  1422,   495,     0,   496,  1423,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,  1424,
       0,   504,     0,   505,   506,   507,   508,   509,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,  1425,  1426,     0,
    1427,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,  1428,   183,   531,   184,     0,   532,
     533,   534,  1429,  1430,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1431,   190,  1432,
     548,   549,   550,   551,   552,   553,   554,   192,   555,  1433,
     556,   557,   194,   558,  1434,  1435,   559,  1436,   560,   561,
     562,     0,   563,     0,     0,  1437,   565,   566,     0,     0,
     197,   198,   199,   200,  1438,   567,   568,   569,   570,   571,
     572,     0,   573,  1439,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,  1440,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,  1441,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,  1442,   615,   217,   616,   617,   219,   618,
    1443,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,  1444,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,  1445,  1446,     0,     0,   639,
    1447,   640,  1448,  1449,   641,   642,   643,   644,   645,   646,
       0,  1450,   647,   648,   649,   650,  1451,     0,   651,   652,
     653,   654,   655,  1452,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,
     668,     0,     0,     0,     0,     0,     0,     0,  1460,  1461,
       0,     0,     0,     0,     0,  2004,  2626,  1463,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1397,  1398,  1399,    45,
    1400,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
    1401,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,   135,  1402,   137,  1403,  1404,     0,   434,   435,   436,
     437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,
     443,   444,   445,   446,  1409,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,  1410,  1411,
    1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,
     468,  1417,  1418,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
    1419,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,  1420,   493,   494,  1421,  1422,
     495,     0,   496,  1423,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,  1424,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
     175,     0,   520,   521,   522,  1425,  1426,     0,  1427,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,  1428,   183,   531,   184,     0,   532,   533,   534,
    1429,  1430,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,  1431,   190,  1432,   548,   549,
     550,   551,   552,   553,   554,   192,   555,  1433,   556,   557,
     194,   558,  1434,  1435,   559,  1436,   560,   561,   562,     0,
     563,     0,     0,  1437,   565,   566,     0,     0,   197,   198,
     199,   200,  1438,   567,   568,   569,   570,   571,   572,     0,
     573,  1439,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,  1440,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,  1441,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,  1442,   615,   217,   616,   617,   219,   618,  1443,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
    1444,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1445,  1446,     0,     0,   639,  1447,   640,
    1448,  1449,   641,   642,   643,   644,   645,   646,     0,  1450,
     647,   648,   649,   650,  1451,     0,   651,   652,   653,   654,
     655,  1452,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,  1453,
    1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,
       0,     0,     0,     0,     0,     0,  1460,  1461,  1462,     0,
       0,     0,     0,     0,     0,  1463,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,   416,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,  1401,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,   135,
    1402,   137,  1403,  1404,     0,   434,   435,   436,   437,   438,
    1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,   444,
     445,   446,  1409,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,
    1414,  1415,  1416,   463,   464,   465,   466,   467,   468,  1417,
    1418,   469,  1548,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,  1419,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,  1420,   493,   494,  1421,  1422,   495,     0,
     496,  1423,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,  1424,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,   174,   175,     0,
     520,   521,   522,  1425,  1426,     0,  1427,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
    1428,   183,   531,   184,     0,   532,   533,   534,  1429,  1430,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1431,   190,  1432,   548,   549,   550,   551,
     552,   553,   554,   192,   555,  1433,   556,   557,   194,   558,
    1434,  1435,   559,  1436,   560,   561,   562,     0,   563,     0,
       0,  1437,   565,   566,     0,     0,   197,   198,   199,   200,
    1438,   567,   568,   569,   570,   571,   572,     0,   573,  1439,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,  1440,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,  1441,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,  1442,
     615,   217,   616,   617,   219,   618,  1443,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,  1444,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,  1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,
     641,   642,   643,   644,   645,   646,     0,  1450,   647,   648,
     649,   650,  1451,     0,   651,   652,   653,   654,   655,  1452,
       0,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,  1453,  1454,  1455,
    1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,     0,
       0,     0,     0,     0,  1460,  1461,     0,     0,     0,     0,
       0,     0,     0,  1463,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,   416,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,  2189,   425,
     426,   427,     0,     0,     0,     0,  1401,     0,     0,   428,
     429,     0,   430,   133,   431,   432,   433,   135,  1402,   137,
    1403,  1404,     0,   434,   435,   436,   437,   438,  1405,  1406,
     439,   440,  1407,  1408,   442,     0,   443,   444,   445,   446,
    1409,     0,     0,   447,   448,   449,   450,   147,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   150,   462,     0,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,   463,   464,   465,   466,   467,   468,  1417,  1418,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,  1419,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,  1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,
     497,     0,   498,     0,   499,   169,     0,   170,   500,   501,
     502,     0,   503,  1424,     0,   504,     0,   505,   506,   507,
     508,   509,   173,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,   174,   175,     0,   520,   521,
     522,  1425,  1426,     0,  1427,     0,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,     0,  1428,   183,
     531,   184,     0,   532,   533,   534,  1429,  1430,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1431,   190,  1432,   548,   549,   550,   551,   552,   553,
     554,   192,   555,  1433,   556,   557,   194,   558,  1434,  1435,
     559,  1436,   560,   561,   562,     0,   563,     0,     0,  1437,
     565,   566,     0,     0,   197,   198,   199,   200,  1438,   567,
     568,   569,   570,   571,   572,     0,   573,  1439,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,  1440,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,   211,
     600,   601,  1441,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,  1442,   615,   217,
     616,   617,   219,   618,  1443,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,  1444,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,  1445,
    1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,   642,
     643,   644,   645,   646,     0,  1450,   647,   648,   649,   650,
    1451,     0,   651,   652,   653,   654,   655,  1452,     0,   656,
     236,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,
    1458,  1459,   666,   667,   668,     0,     0,     0,     0,     0,
       0,     0,  1460,  1461,     0,     0,     0,     0,     0,     0,
       0,  1463,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,  1401,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,   135,  1402,   137,  1403,  1404,
       0,   434,   435,   436,   437,   438,  1405,  1406,   439,   440,
    1407,  1408,   442,     0,   443,   444,   445,   446,  1409,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,  3137,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,
     464,   465,   466,   467,   468,  1417,  1418,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,  1419,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,  1420,
     493,   494,  1421,  1422,   495,     0,   496,  1423,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,  1424,     0,   504,     0,   505,   506,   507,   508,   509,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,  1425,
    1426,     0,  1427,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,  1428,   183,   531,   184,
       0,   532,   533,   534,  1429,  1430,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1431,
     190,  1432,   548,   549,   550,   551,   552,   553,   554,   192,
     555,  1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,
     560,   561,   562,     0,   563,     0,     0,  1437,   565,   566,
       0,     0,   197,   198,   199,   200,  1438,   567,   568,   569,
     570,   571,   572,     0,   573,  1439,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,  1440,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
    1441,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,  1442,   615,   217,   616,   617,
     219,   618,  1443,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,  1444,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,  1445,  1446,     0,
       0,   639,  1447,   640,  1448,  1449,   641,   642,   643,   644,
     645,   646,     0,  1450,   647,   648,   649,   650,  1451,     0,
     651,   652,   653,   654,   655,  1452,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
    1460,  1461,     0,     0,     0,     0,     0,     0,     0,  1463,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,   416,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1397,  1398,
    1399,    45,  1400,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,  1401,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,   135,  1402,   137,  1403,  1404,     0,   434,
     435,   436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,
     442,     0,   443,   444,   445,   446,  1409,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,
     466,   467,   468,  1417,  1418,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,  1419,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,  1420,   493,   494,
    1421,  1422,   495,     0,   496,  1423,   497,     0,   498,     0,
     499,   169,  2678,   170,   500,   501,   502,     0,   503,  1424,
       0,   504,     0,   505,   506,   507,   508,   509,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,  1425,  1426,     0,
    1427,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,  1428,   183,   531,   184,     0,   532,
     533,   534,  1429,  1430,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1431,   190,  1432,
     548,   549,   550,   551,   552,   553,   554,   192,   555,  1433,
     556,   557,   194,   558,  1434,  1435,   559,  1436,   560,   561,
     562,     0,   563,     0,     0,  1437,   565,   566,     0,     0,
     197,   198,   199,   200,  1438,   567,   568,   569,   570,   571,
     572,     0,   573,  1439,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,  1440,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,  1441,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,  1442,   615,   217,   616,   617,   219,   618,
    1443,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,  1444,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,  1445,  1446,     0,     0,   639,
    1447,   640,  1448,  1449,   641,   642,   643,   644,   645,   646,
       0,  1450,   647,   648,   649,   650,  1451,     0,   651,   652,
     653,   654,   655,  1452,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,
     668,     0,     0,     0,     0,     0,     0,     0,  1460,  1461,
       0,     0,     0,     0,     0,     0,     0,  1463,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1397,  1398,  1399,    45,
    1400,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
    1401,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,   135,  1402,   137,  1403,  1404,     0,   434,   435,   436,
     437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,
     443,   444,   445,   446,  1409,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,  1410,  1411,
    1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,
     468,  1417,  1418,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
    1419,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,  1420,   493,   494,  1421,  1422,
     495,     0,   496,  1423,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,  1424,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
     175,     0,   520,   521,   522,  1425,  1426,     0,  1427,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,  1428,   183,   531,   184,     0,   532,   533,   534,
    1429,  1430,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,  1431,   190,  1432,   548,   549,
     550,   551,   552,   553,   554,   192,   555,  1433,   556,   557,
     194,   558,  1434,  1435,   559,  1436,   560,   561,   562,     0,
     563,     0,     0,  1437,   565,   566,     0,     0,   197,   198,
     199,   200,  1438,   567,   568,   569,   570,   571,   572,     0,
     573,  1439,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,  1440,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,  1441,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,  1442,   615,   217,   616,   617,   219,   618,  1443,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
    1444,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1445,  1446,     0,     0,   639,  1447,   640,
    1448,  1449,   641,   642,   643,   644,   645,   646,     0,  1450,
     647,   648,   649,   650,  1451,     0,   651,   652,   653,   654,
     655,  1452,  3741,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,  1453,
    1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,
       0,     0,     0,     0,     0,     0,  1460,  1461,     0,     0,
       0,     0,     0,     0,     0,  1463,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,   416,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,  1401,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,  4410,
    1402,   137,  1403,  1404,     0,   434,   435,   436,   437,   438,
    1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,   444,
     445,   446,  1409,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,  4411,  1410,  1411,  1412,  1413,
    1414,  1415,  1416,   463,   464,   465,   466,   467,   468,  1417,
    1418,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,  1419,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,  1420,   493,   494,  1421,  1422,   495,     0,
     496,  1423,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,  1424,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,   174,   175,     0,
     520,   521,   522,  1425,  1426,     0,  1427,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
    1428,   183,   531,   184,     0,   532,   533,   534,  1429,  1430,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1431,   190,  1432,   548,   549,   550,   551,
     552,   553,   554,   192,   555,  1433,   556,   557,   194,   558,
    1434,  1435,   559,  1436,   560,   561,   562,     0,   563,     0,
       0,  1437,   565,   566,     0,     0,   197,   198,   199,   200,
    1438,   567,   568,   569,   570,   571,   572,     0,   573,  1439,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,  1440,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,  1441,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,  1442,
     615,   217,   616,   617,   219,   618,  1443,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,  1444,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,  1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,
     641,   642,   643,  4412,   645,   646,     0,  1450,   647,   648,
     649,   650,  1451,     0,   651,   652,   653,   654,   655,  1452,
       0,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,  1453,  1454,  1455,
    1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,     0,
       0,     0,     0,     0,  1460,  1461,     0,     0,     0,     0,
       0,     0,     0,  1463,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,   416,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,  1401,     0,     0,   428,
     429,     0,   430,   133,   431,   432,   433,   135,  1402,   137,
    1403,  1404,     0,   434,   435,   436,   437,   438,  1405,  1406,
     439,   440,  1407,  1408,   442,     0,   443,   444,   445,   446,
    1409,     0,     0,   447,   448,   449,   450,   147,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   150,   462,  4411,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,   463,   464,   465,   466,   467,   468,  1417,  1418,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,  1419,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,  1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,
     497,     0,   498,     0,   499,   169,     0,   170,   500,   501,
     502,     0,   503,  1424,     0,   504,     0,   505,   506,   507,
     508,   509,   173,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,   174,   175,     0,   520,   521,
     522,  1425,  1426,     0,  1427,     0,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,     0,  1428,   183,
     531,   184,     0,   532,   533,   534,  1429,  1430,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1431,   190,  1432,   548,   549,   550,   551,   552,   553,
     554,   192,   555,  1433,   556,   557,   194,   558,  1434,  1435,
     559,  1436,   560,   561,   562,     0,   563,     0,     0,  1437,
     565,   566,     0,     0,   197,   198,   199,   200,  1438,   567,
     568,   569,   570,   571,   572,     0,   573,  1439,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,  1440,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,   211,
     600,   601,  1441,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,  1442,   615,   217,
     616,   617,   219,   618,  1443,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,  1444,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,  1445,
    1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,   642,
     643,  4412,   645,   646,     0,  1450,   647,   648,   649,   650,
    1451,     0,   651,   652,   653,   654,   655,  1452,     0,   656,
     236,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,
    1458,  1459,   666,   667,   668,     0,     0,     0,     0,     0,
       0,     0,  1460,  1461,     0,     0,     0,     0,     0,     0,
       0,  1463,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,  1401,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,   135,  1402,   137,  1403,  1404,
       0,   434,   435,   436,   437,   438,  1405,  1406,   439,   440,
    1407,  1408,   442,     0,   443,   444,   445,   446,  1409,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,
     464,   465,   466,   467,   468,  1417,  1418,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,  1419,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,  1420,
     493,   494,  1421,  1422,   495,     0,   496,  1423,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,  1424,     0,   504,     0,   505,   506,   507,   508,   509,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,  1425,
    1426,     0,  1427,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,  1428,   183,   531,   184,
       0,   532,   533,   534,  1429,  1430,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1431,
     190,  1432,   548,   549,   550,   551,   552,   553,   554,   192,
     555,  1433,   556,   557,   194,   558,  1434,  1435,   559,  1436,
     560,   561,   562,     0,   563,     0,     0,  1437,   565,   566,
       0,     0,   197,   198,   199,   200,  1438,   567,   568,   569,
     570,   571,   572,     0,   573,  1439,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,  1440,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
    1441,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,  1442,   615,   217,   616,   617,
     219,   618,  1443,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,  1444,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,  1445,  1446,     0,
       0,   639,  1447,   640,  1448,  1449,   641,   642,   643,   644,
     645,   646,     0,  1450,   647,   648,   649,   650,  1451,     0,
     651,   652,   653,   654,   655,  1452,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
    1460,  1461,     0,     0,     0,     0,     0,     0,     0,  1463,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,   416,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1397,  1398,
    1399,    45,  1400,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,  1401,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,   135,  1402,   137,  1403,  1404,     0,   434,
     435,   436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,
     442,     0,   443,   444,   445,   446,  1409,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,
     466,   467,   468,  1417,  1418,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,  1419,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,  1420,   493,   494,
    1421,  1422,   495,     0,   496,  1423,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,  1424,
       0,   504,     0,   505,   506,   507,   508,   509,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,  1425,  1426,     0,
    1427,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,  1428,   183,   531,   184,     0,   532,
     533,   534,  1429,  1430,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1431,   190,  1432,
     548,   549,   550,   551,   552,   553,   554,   192,   555,  1433,
     556,   557,   194,   558,  1434,  1435,   559,  1436,   560,   561,
     562,     0,   563,     0,     0,  1437,   565,   566,     0,     0,
     197,   198,   199,   200,  1438,   567,   568,   569,   570,   571,
     572,     0,   573,  1439,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,  1440,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,  1441,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,  1442,   615,   217,   616,   617,   219,   618,
    1443,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,  1444,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,  1445,  1446,     0,     0,   639,
    1447,   640,  1448,  1449,   641,   642,   643,   644,   645,   646,
       0,  1450,   647,   648,   649,   650,  1451,     0,   651,   652,
     653,   654,   655,  1452,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
    3988,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,
     668,     0,     0,     0,     0,     0,     0,     0,  1460,  1461,
       0,     0,     0,     0,     0,     0,     0,  1463,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1397,  1398,  1399,    45,
    1400,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
    1401,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,   135,  1402,   137,  1403,  1404,     0,   434,   435,   436,
     437,   438,  1405,  1406,   439,   440,  1407,  1408,   442,     0,
     443,   444,   445,   446,  1409,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,  1410,  1411,
    1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,
     468,  1417,  1418,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
    1419,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,  1420,   493,   494,  1421,  1422,
     495,     0,   496,  1423,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,  1424,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
     175,     0,   520,   521,   522,  1425,  1426,     0,  1427,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,  1428,   183,   531,   184,     0,   532,   533,   534,
    1429,  1430,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,  1431,   190,  1432,   548,  3995,
     550,   551,   552,   553,   554,   192,   555,  1433,   556,   557,
     194,   558,  1434,  1435,   559,  1436,   560,   561,   562,     0,
     563,     0,     0,  1437,   565,   566,     0,     0,   197,   198,
     199,   200,  1438,   567,   568,   569,   570,   571,   572,     0,
     573,  1439,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,  1440,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,  1441,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,  1442,   615,   217,   616,   617,   219,   618,  1443,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
    1444,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1445,  1446,     0,     0,   639,  1447,   640,
    1448,  1449,   641,   642,   643,   644,   645,   646,     0,  1450,
     647,   648,   649,   650,  1451,     0,   651,   652,   653,   654,
     655,  1452,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,  1453,
    1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,
       0,     0,     0,     0,     0,     0,  1460,  1461,     0,     0,
       0,     0,     0,     0,     0,  1463,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,   416,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,  1397,  1398,  1399,    45,  1400,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,  1401,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,   135,
    1402,   137,  1403,  1404,     0,   434,   435,   436,   437,   438,
    1405,  1406,   439,   440,  1407,  1408,   442,     0,   443,   444,
     445,   446,  1409,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,
    1414,  1415,  1416,   463,   464,   465,   466,   467,   468,  1417,
    1418,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,  1419,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,  1420,   493,   494,  1421,  1422,   495,     0,
     496,  1423,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,  1424,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,   174,   175,     0,
     520,   521,   522,  1425,  1426,     0,  1427,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
    1428,   183,   531,   184,     0,   532,   533,   534,  1429,  1430,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1431,   190,  1432,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,   194,   558,
    1434,  1435,   559,  1436,   560,   561,   562,     0,   563,     0,
       0,  1437,   565,   566,     0,     0,   197,   198,   199,   200,
    1438,   567,   568,   569,   570,   571,   572,     0,   573,  1439,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,  1440,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,  1441,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,  1442,
     615,   217,   616,   617,   219,   618,  1443,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,  1444,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,  1445,  1446,     0,     0,   639,  1447,   640,  1448,  1449,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,  1451,     0,   651,   652,   653,   654,   655,  1452,
       0,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,  1453,  1454,  1455,
    1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,     0,
       0,     0,     0,     0,  2660,  2661,     0,     0,     0,     0,
       0,     0,     0,  1463,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,   416,     0,     0,    37,    38,    39,    40,    41,    42,
      43,    44,  1397,  1398,  1399,    45,  1400,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,  1401,     0,     0,   428,
     429,     0,   430,   133,   431,   432,   433, -2404,  1402,   137,
    1403,  1404,     0,   434,   435,   436,   437,   438,  1405,  1406,
     439,   440,  1407,  1408,   442,     0,   443,   444,   445,   446,
    1409,     0,     0,   447,   448,   449,   450,   147,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   150,   462,  4411,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,   463,   464,   465,   466,   467,   468,  1417,  1418,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,  1419,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,  1420,   493,   494,  1421,  1422,   495,     0,   496,  1423,
     497,     0,   498,     0,   499,   169,     0,   170,   500,   501,
     502,     0,   503,  1424,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,   174,   175,     0,   520,   521,
     522,  1425,  1426,     0,  1427,     0,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,     0,  1428,   183,
     531,     0,     0,   532,   533,   534,  1429,  1430,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1431,   190,  1432,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,   194,   558,  1434,  1435,
     559,  1436,   560,   561,   562,     0,   563,     0,     0,  1437,
     565,   566,     0,     0,   197,   198,   199,   200,  1438,   567,
     568,   569,   570,   571,   572,     0,   573,  1439,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,  1440,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,   211,
     600,   601,  1441,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,  1442,   615,   217,
     616,   617,     0,   618,  1443,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,  1444,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,  1445,
    1446,     0,     0,   639,  1447,   640,  1448,  1449,   641,   642,
     643,  4412,   645,   646,     0,  1450,   647,   648,   649,   650,
    1451,     0,   651,   652,   653,   654,   655,  1452,     0,   656,
     236,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,  1453,  1454,  1455,  1456,  1457,
    1458,  1459,   666,   667,   668,     0,     0,     0,     0,     0,
       0,     0,  1460,  1461,     0,     0,     0,     0,     0,     0,
       0,  1463,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
    1397,  1398,  1399,    45,  1400,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,  1401,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,     0,  1402,   137,  1403,  1404,
       0,   434,   435,   436,   437,   438,  1405,  1406,   439,   440,
    1407,  1408,   442,     0,   443,   444,   445,   446,  1409,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,
     464,   465,   466,   467,   468,  1417,  1418,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,  1419,   482,   483,     0,   484,   485,
     486,     0,   487,     0,     0,   489,   490,   491,   492,  1420,
     493,   494,  1421,  1422,   495,     0,   496,  1423,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,  1424,     0,   504,     0,   505,   506,   507,   508,   509,
       0,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,  1425,
    1426,     0,  1427,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,  1428,   183,   531,     0,
       0,   532,   533,   534,  1429,  1430,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1431,
     190,  1432,   548,   549,   550,   551,   552,   553,   554,   192,
     555,     0,   556,   557,   194,   558,  1434,  1435,   559,  1436,
     560,   561,   562,     0,   563,     0,     0,  1437,   565,   566,
       0,     0,   197,   198,   199,   200,  1438,   567,   568,   569,
     570,   571,   572,     0,   573,  1439,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,  1440,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
    1441,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,  1442,   615,   217,   616,   617,
       0,   618,  1443,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,  1444,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,  1445,  1446,     0,
       0,   639,  1447,   640,  1448,  1449,   641,   642,   643,   644,
     645,   646,     0,  1450,   647,   648,   649,   650,  1451,     0,
     651,   652,   653,   654,   655,  1452,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
    1460,  1461,     0,     0,     0,     0,     0,     0,     0,  1463,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,   416,     0,     0,
      37,    38,    39,    40,    41,    42,    43,    44,  1397,  1398,
    1399,    45,  1400,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,  1401,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,     0,  1402,   137,  1403,  1404,     0,   434,
     435,   436,   437,   438,  1405,  1406,   439,   440,  1407,  1408,
     442,     0,   443,   444,   445,   446,  1409,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
    1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,   464,   465,
     466,   467,   468,  1417,  1418,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,  1419,   482,   483,     0,   484,   485,   486,     0,
     487,     0,     0,   489,   490,   491,   492,  1420,   493,   494,
    1421,  1422,   495,     0,   496,  1423,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,  1424,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,  1425,  1426,     0,
    1427,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,  1428,   183,   531,     0,     0,   532,
     533,   534,  1429,  1430,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,  1431,   190,  1432,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,   194,   558,  1434,  1435,   559,  1436,   560,   561,
     562,     0,   563,     0,     0,  1437,   565,   566,     0,     0,
     197,   198,   199,   200,  1438,   567,   568,   569,   570,   571,
     572,     0,   573,  1439,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,  1440,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,  1441,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,  1442,   615,   217,   616,   617,     0,   618,
    1443,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,  1444,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,  1445,  1446,     0,     0,   639,
    1447,   640,  1448,  1449,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,  1451,     0,   651,   652,
     653,   654,   655,  1452,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,   666,   667,
     668,     0,     0,     0,     0,     0,     0,     0,  2660,  2661,
       0,     0,     0,     0,     0,     0,     0,  1463,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,   135,   136,   137,   138,   139,     0,   434,   435,   436,
     437,   438,     0,  1406,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,  1409,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,  1410,  1411,
    1412,  1413,  1414,  1415,  1416,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,  1421,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,  1424,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,  1428,   183,   531,   184,     0,   532,   533,   534,
    1429,  1430,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,   190,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
     194,   558,     0,  1435,   559,   196,   560,   561,   562,     0,
     563,     0,  1044,   564,   565,   566,     0,     0,   197,   198,
     199,   200,  1438,   567,   568,   569,   570,   571,   572,     0,
     573,  1439,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,   215,   610,   611,   612,   613,
     614,  1442,   615,   217,   616,   617,   219,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
    1444,   629,     0,   630,   631,   223,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,  1447,   640,
    1448,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,  1451,     0,   651,   652,   653,   654,
    1324,   235,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,   237,   661,   662,   663,   664,   665,   238,  1453,
    1454,  1455,  1456,  1457,  1458,  1459,   666,   667,   668,     0,
       0,     0,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,  2509,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,   135,   136,   137,   138,   139,
       0,   434,   435,   436,   437,   438,     0,  1406,   439,   440,
     441,   140,   442,     0,   443,   444,   445,   446,  1409,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,  1410,  1411,  1412,  1413,  1414,  1415,  1416,   463,
     464,   465,   466,   467,   468,   154,   155,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,   481,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,   164,
     493,   494,  1421,     0,   495,     0,   496,   168,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,  1424,     0,   504,     0,   505,   506,   507,   508,   509,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,   175,     0,   520,   521,   522,     0,
     177,     0,   178,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,  1428,   183,   531,   184,
       0,   532,   533,   534,  1429,  1430,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   189,
     190,   191,   548,   549,   550,   551,   552,   553,   554,   192,
     555,     0,   556,   557,   194,   558,     0,  1435,   559,   196,
     560,   561,   562,     0,   563,     0,  1044,   564,   565,   566,
       0,     0,   197,   198,   199,   200,  1438,   567,   568,   569,
     570,   571,   572,     0,   573,  1439,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,   205,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
     213,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,  1442,   615,   217,   616,   617,
     219,   618,   220,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,  1444,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,   224,   225,     0,
       0,   639,  1447,   640,  1448,     0,   641,   642,   643,   644,
     645,   646,     0,     0,   647,   648,   649,   650,  1451,     0,
     651,   652,   653,   654,   655,   235,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,  1453,  1454,  1455,  1456,  1457,  1458,  1459,
     666,   667,   668,     0,     0,     0,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,  2509,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,   135,
     136,   137,   138,   139,     0,   434,   435,   436,   437,   438,
       0,  1406,   439,   440,   441,   140,   442,     0,   443,   444,
     445,   446,  1409,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,     0,  1410,  1411,  1412,  1413,
    1414,  1415,  1416,   463,   464,   465,   466,   467,   468,   154,
     155,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,   481,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,   164,   493,   494,  1421,     0,   495,     0,
     496,   168,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,  1424,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,   174,   175,     0,
     520,   521,   522,     0,   177,     0,   178,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
    1428,   183,   531,   184,     0,   532,   533,   534,  1429,  1430,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,   190,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,   194,   558,
       0,  1435,   559,   196,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,   197,   198,   199,   200,
    1438,   567,   568,   569,   570,   571,   572,     0,   573,  1439,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,  1442,
     615,   217,   616,   617,   219,   618,   220,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,  1444,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,   224,   225,     0,     0,   639,  1447,   640,  1448,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,  1451,     0,   651,   652,   653,   654,   655,   235,
       0,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,  1453,  1454,  1455,
    1456,  1457,  1458,  1459,   666,   667,   668,     0,     0,     0,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,  3769,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,   135,   136,   137,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
       0,     0,     0,   151,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,   182,   183,   531,   184,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,   190,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,   194,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
     197,   198,   199,   200,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,   219,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,     0,     0,     0,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,  4223,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,  3119,     0,   428,
     429,     0,   430,     0,   431,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,   444,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461, -1270,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,   495,     0,   496,   168,
     497,     0,   498,     0,   499,     0,     0, -1270,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519, -1270,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
   -1270,   525,   526,   527,   528,   529,   530,     0,   182, -1270,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189, -1270,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599, -1270,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,     0,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,     0,     0,     0,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,  1556,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   406,     0,     0,   107,   108,   109,   110,     0,
       0,   112,   113,   114,   115,     0,   116,     0,     0,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,   416,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,     0,     0,     0,
      45,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,     0,   431,
     432,   433,   135,   136,     0,   138,   139,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,   144,     0,     0,   447,   448,
     449,   450,     0,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,     0,   462,     0,     0,
       0,     0,     0,     0,     0,     0,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,   166,
    1927,   495,     0,   496,   168,   497,     0,   498,     0,   499,
       0,     0,     0,   500,   501,   502,     0,   503,   172,     0,
     504,     0,   505,   506,   507,   508,   509,     0,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
       0,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,     0,     0,   524,     0,   525,   526,   527,   528,
     529,   530,     0,   182,     0,   531,     0,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,     0,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,     0,   558,     0,   195,   559,   196,   560,   561,   562,
       0,   563,  1928,     0,   564,   565,   566,     0,     0,   197,
       0,     0,     0,   201,   567,   568,   569,   570,   571,   572,
       0,   573,   202,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,     0,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,   217,   616,   617,     0,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,   226,
     640,   227,  1929,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,   655,   235,     0,   656,     0,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
       0,     0,     0,     0,     0,     0,     0,   962,  1595,  3846,
       0,     0,     0,     0,     0,     0,  3847,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   406,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,    37,    38,    39,    40,
      41,    42,     0,    44,     0,     0,     0,    45,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,     0,   431,   432,   433,   135,
     136,     0,   138,   139,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,   441,   140,   442,     0,   443,   444,
     445,   446,   144,     0,     0,   447,   448,   449,   450,     0,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,     0,   462,     0,     0,     0,     0,     0,
       0,     0,     0,   463,   464,   465,   466,   467,   468,   154,
     155,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,   481,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,   164,   493,   494,   166,     0,   495,     0,
     496,   168,   497,     0,   498,     0,   499,     0,     0,     0,
     500,   501,   502,     0,   503,   172,     0,   504,     0,   505,
     506,   507,   508,   509,     0,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   175,     0,
     520,   521,   522,     0,   177,     0,   178,     0,   523,     0,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     182,     0,   531,     0,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,     0,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,     0,   558,
       0,   195,   559,   196,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,   197,     0,     0,     0,
     201,   567,   568,   569,   570,   571,   572,     0,   573,   202,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,     0,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,   217,   616,   617,     0,   618,   220,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   222,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,   224,   225,     0,     0,   639,   226,   640,   227,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,   655,   235,
       0,   656,     0,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,   239,   240,   241,
     242,   243,   244,   245,   666,   667,   668,     0,     0,     0,
       0,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,  3503,  3504,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   406,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,   130,   131,
       0,     0,     0,     0,     0,   428,   429,     0,   430,     0,
     431,   432,   433,   135,   136,     0,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,     0,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,     0,     0,     0,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,     0,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   182,     0,   531,     0,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,     0,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,     0,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
     197,     0,     0,     0,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,     0,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,   215,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,     0,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,   223,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,  1324,   235,     0,   656,  1325,   657,   658,   659,
       0,     0,   660,     0,   237,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,     0,     0,     0,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,   246,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,    37,    38,    39,    40,    41,    42,
       0,    44,     0,     0,     0,    45,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,     0,   431,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,   444,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,     0,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,   495,     0,   496,   168,
     497,     0,   498,     0,   499,     0,     0,     0,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   182,     0,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,     0,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,     0,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,     0,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,     0,     0,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,  3504,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,   215,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,   223,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1324,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,   237,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,     0,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,   246,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   406,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,   115,     0,   116,
       0,     0,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,   428,   429,     0,
     430,     0,   431,   432,   433,   135,   136,     0,   138,   139,
       0,   434,   435,   436,   437,   438,     0,     0,   439,   440,
     441,   140,   442,     0,   443,   444,   445,   446,   144,     0,
       0,   447,   448,   449,   450,     0,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,     0,
     462,     0,     0,     0,     0,     0,     0,     0,     0,   463,
     464,   465,   466,   467,   468,   154,   155,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,   481,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,   164,
     493,   494,   166,     0,   495,     0,   496,   168,   497,     0,
     498,     0,   499,     0,     0,     0,   500,   501,   502,     0,
     503,   172,     0,   504,     0,   505,   506,   507,   508,   509,
       0,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   175,     0,   520,   521,   522,     0,
     177,     0,   178,     0,   523,     0,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   182,     0,   531,     0,
       0,   532,   533,   534,     0,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   189,
       0,   191,   548,   549,   550,   551,   552,   553,   554,   192,
     555,     0,   556,   557,     0,   558,     0,   195,   559,   196,
     560,   561,   562,     0,   563,     0,     0,   564,   565,   566,
       0,     0,   197,     0,     0,     0,   201,   567,   568,   569,
     570,   571,   572,     0,   573,   202,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,   205,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,     0,   600,   601,
     213,   602,   603,   604,   605,   606,   607,   608,   609,   215,
     610,   611,   612,   613,   614,     0,   615,   217,   616,   617,
       0,   618,   220,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   222,   629,     0,   630,   631,   223,
     632,   633,   634,   635,   636,   637,     0,   224,   225,     0,
       0,   639,   226,   640,   227,     0,   641,   642,   643,   644,
     645,   646,     0,     0,   647,   648,   649,   650,     0,     0,
     651,   652,   653,   654,  1324,   235,     0,   656,     0,   657,
     658,   659,     0,     0,   660,     0,   237,   661,   662,   663,
     664,   665,   238,   239,   240,   241,   242,   243,   244,   245,
     666,   667,   668,     0,     0,     0,     0,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,   246,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   406,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,     0,   431,   432,   433,   135,
     136,     0,   138,   139,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,   441,   140,   442,     0,   443,   444,
     445,   446,   144,     0,     0,   447,   448,   449,   450,     0,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,     0,   462,     0,     0,     0,     0,     0,
       0,     0,     0,   463,   464,   465,   466,   467,   468,   154,
     155,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,   481,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,   164,   493,   494,   166,     0,   495,     0,
     496,   168,   497,     0,   498,     0,   499,     0,     0,     0,
     500,   501,   502,     0,   503,   172,     0,   504,     0,   505,
     506,   507,   508,   509,     0,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   175,     0,
     520,   521,   522,     0,   177,     0,   178,     0,   523,     0,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     182,     0,   531,     0,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,     0,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,     0,   558,
       0,   195,   559,   196,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,   197,     0,     0,     0,
     201,   567,   568,   569,   570,   571,   572,     0,   573,   202,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,     0,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,   217,   616,   617,     0,   618,   220,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   222,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,   224,   225,     0,     0,   639,   226,   640,   227,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,   655,   235,
       0,   656,     0,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,   239,   240,   241,
     242,   243,   244,   245,   666,   667,   668,     0,     0,     0,
       0,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,  1528,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   406,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,     0,
     431,   432,   433,   135,   136,     0,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,     0,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,     0,     0,     0,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,     0,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   182,     0,   531,     0,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,     0,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,     0,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
     197,     0,     0,     0,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,     0,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,     0,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,     0,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,     0,     0,     0,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,  2161,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,     0,   431,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,   444,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,     0,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,   495,     0,   496,   168,
     497,     0,   498,     0,   499,     0,     0,     0,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   182,     0,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,     0,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,     0,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,     0,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,     0,     0,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,  3609,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,  3735,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
       0,     0,  1158,    45,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,   712,   425,   426,   427,
     713,   714,   715,   716,   717,   718,   719,   428,   429,   720,
     430,   133,   431,   432,   433,     0,  1784,   137,  1785,  1786,
     721,   434,   435,   436,   437,   438,   722,   723,   439,   440,
    1787,  1788,   442,   725,   443,   444,   445,   446,     0,   726,
     727,   447,   448,   449,   450,   147,   451,   452,   729,   453,
     454,   455,   456,   457,   458,   730,   459,   460,   461,   150,
     462,     0,   732,   733,   734,   151,   735,   736,   737,   463,
     464,   465,   466,   467,   468,  1789,  1790,   469,   738,   470,
     739,   471,   472,   473,   474,   475,   740,   476,   477,   478,
     741,   742,   479,   480,  1419,   482,   483,   743,   484,   485,
     486,   744,   487,   488,   745,   489,   490,   491,   492,     0,
     493,   494,     0,   746,   495,   747,   496,  1791,   497,   748,
     498,   749,   499,   169,   750,   170,   500,   501,   502,   751,
     503,     0,   752,   504,   753,   505,   506,   507,   508,   509,
     173,   510,   511,   512,   754,   513,   514,   515,   516,   517,
     518,   755,   519,   174,     0,     0,   520,   521,   522,  1425,
    1792,   758,  1793,   759,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,   760,     0,   183,   531,   184,
     761,   532,   533,   534,   762,   763,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1794,
     190,  1795,   548,   549,   550,   551,   552,   553,   554,     0,
     555,   764,   556,   557,   194,   558,   765,     0,   559,  1796,
     560,   561,   562,   766,   563,   767,   768,  3490,   565,   566,
     769,   770,     0,   198,   199,   200,     0,   567,   568,   569,
     570,   571,   572,   771,   573,     0,   574,     0,   575,   576,
     577,   772,   578,   579,   580,   581,   582,   583,   584,  1797,
     585,   586,   587,   773,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   774,   598,   599,   211,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,   775,
     610,   611,   612,   613,   614,   776,   615,  2306,   616,   617,
     219,   618,  1799,   777,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,     0,   629,   778,   630,   631,   779,
     632,   633,   634,   635,   636,   637,   780,  1800,  1801,     0,
     782,   639,     0,   640,     0,   783,   641,   642,   643,   644,
     645,   646,     0,   785,   647,   648,   649,   650,   786,   787,
     651,   652,   653,   654,     0,  1802,   789,   656,   236,   657,
     658,   659,   790,   791,   660,   792,   793,   661,   662,   663,
     664,   665,     0,     0,     0,     0,     0,     0,     0,     0,
     666,   667,   668,     0,     0,     0,  1161,  1162,  1163,     0,
    3491,  3492,  1166,  1167,  1168,  1169,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   406,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,  1158,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,     0,   431,   432,   433,   135,   136,
       0,   138,   139,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,   441,   140,   442,     0,   443,  1159,   445,
     446,   144,     0,     0,   447,   448,   449,   450,     0,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,     0,   462,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   154,   155,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,   481,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,   164,   493,   494,   166,     0,  1160,     0,   496,
     168,   497,     0,   498,     0,   499,     0,     0,     0,   500,
     501,   502,     0,   503,   172,     0,   504,     0,   505,   506,
     507,   508,   509,     0,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   175,     0,   520,
     521,   522,     0,   177,     0,   178,     0,   523,     0,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   182,
       0,   531,     0,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   189,     0,   191,   548,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,     0,   558,     0,
     195,   559,   196,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,   197,     0,     0,     0,   201,
     567,   568,   569,   570,   571,   572,     0,   573,   202,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,   205,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
       0,   600,   601,   213,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,     0,   615,
     217,   616,   617,     0,   618,   220,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   222,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
     224,   225,     0,     0,   639,   226,   640,   227,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,   655,   235,     0,
     656,     0,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,   239,   240,   241,   242,
     243,   244,   245,   666,   667,   668,     0,     0,     0,  1161,
    1162,  1163,     0,  1164,  1165,  1166,  1167,  1168,  1169,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,  1158,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,  1234,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
    1235,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,  1161,  1162,  1163,     0,  1164,  1165,  1166,  1167,
    1168,  1169,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,  1158,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,  1285,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,  1286,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,  1287,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,     0,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,     0,  1161,  1162,  1163,     0,  1164,
    1165,  1166,  1167,  1168,  1169,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,  1158,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,     0,   431,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,  1767,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,     0,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,  1768,     0,   496,   168,
     497,     0,   498,     0,   499,     0,     0,     0,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
       0,   525,   526,   527,   528,   529,   530,     0,   182,     0,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,     0,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,     0,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,     0,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,     0,  1161,  1162,
    1163,     0,  1164,  1165,  1166,  1167,  1168,  1169,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,  1158,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,   495,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,  1161,  1162,  1163,     0,  1164,  1165,  1166,  1167,  1168,
    1169,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   406,     0,     0,   107,   108,   109,   110,
       0,     0,   112,   113,   114,   115,     0,   116,     0,     0,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
    1158,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,     0,
     431,   432,   433,   135,   136,     0,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,     0,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,     0,   462,     0,
       0,     0,     0,     0,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,     0,     0,     0,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,   509,     0,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,     0,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,     0,     0,   524,     0,   525,   526,   527,
     528,   529,   530,     0,   182,     0,   531,     0,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,     0,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,     0,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,  4212,   565,   566,     0,     0,
     197,     0,     0,     0,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,     0,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,     0,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,     0,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,     0,     0,     0,  1161,  1162,  1163,     0,  1164,  1165,
    1166,  1167,  1168,  1169,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,   712,   425,
     426,   427,   713,   714,   715,   716,   717,   718,   719,   428,
     429,   720,   430,   133,   431,   432,   433,   135,   136,   137,
     138,   139,   721,   434,   435,   436,   437,   438,   722,   723,
     439,   440,   724,   140,   442,   725,   443,   444,   445,   446,
     144,   726,   727,   447,   448,   449,   450,   147,   451,   728,
     729,   453,   454,   455,   456,   457,   458,   730,   459,   460,
     461,   150,   462,   731,   732,   733,   734,   151,   735,   736,
     737,   463,   464,   465,   466,   467,   468,   154,   155,   469,
     738,   470,   739,   471,   472,   473,   474,   475,   740,   476,
     477,   478,   741,   742,   479,   480,   481,   482,   483,   743,
     484,   485,   486,   744,   487,   488,   745,   489,   490,   491,
     492,   164,   493,   494,   166,   746,   495,   747,   496,   168,
     497,   748,   498,   749,   499,   169,   750,   170,   500,   501,
     502,   751,   503,   172,   752,   504,   753,   505,   506,   507,
     508,   509,   173,   510,   511,   512,   754,   513,   514,   515,
     516,   517,   518,   755,   519,   174,   175,   756,   520,   521,
     522,   757,   177,   758,   178,   759,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,   760,   182,   183,
     531,   184,   761,   532,   533,   534,   762,   763,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,   190,   191,   548,   549,   550,   551,   552,   553,
     554,   192,   555,   764,   556,   557,   194,   558,   765,   195,
     559,   196,   560,   561,   562,   766,   563,   767,   768,   564,
     565,   566,   769,   770,   197,   198,   199,   200,   201,   567,
     568,   569,   570,   571,   572,   771,   573,   202,   574,   203,
     575,   576,   577,   772,   578,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,   773,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   774,   598,   599,   211,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,   775,   610,   611,   612,   613,   614,   776,   615,   217,
     616,   617,   219,   618,   220,   777,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,   778,   630,
     631,   779,   632,   633,   634,   635,   636,   637,   780,   224,
     225,   781,   782,   639,   226,   640,   227,   783,   641,   642,
     643,   644,   645,   646,   784,   785,   647,   648,   649,   650,
     786,   787,   651,   652,   653,   654,   788,   235,   789,   656,
     236,   657,   658,   659,   790,   791,   660,   792,   793,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,   705,    86,    87,    88,   403,
      90,    91,    92,   404,  2152,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,     0,  1784,
     137,  1785,  1786,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,  1787,  1788,   442,     0,   443,   444,   445,
     446,     0,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,     0,     0,     0,   151,     0,
       0,     0,   463,   464,   465,   466,   467,   468,  1789,  1790,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,     0,   496,
    1791,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,     0,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,     0,     0,   520,
     521,   522,  1425,  1792,     0,  1793,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,     0,
     183,   531,   184,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1794,   190,  1795,   548,   549,   550,   551,   552,
     553,   554,     0,   555,     0,   556,   557,   194,   558,     0,
       0,   559,  1796,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,     0,   198,   199,   200,     0,
     567,   568,   569,   570,   571,   572,     0,   573,     0,   574,
       0,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1797,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,     0,   615,
    1798,   616,   617,   219,   618,  1799,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,     0,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
    1800,  1801,     0,     0,   639,     0,   640,     0,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,     0,  1802,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,     0,     0,     0,     0,     0,
       0,     0,     0,   666,   667,   668,     0,    86,    87,    88,
     403,    90,    91,    92,   404,  2254,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   406,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,     0,   431,   432,   433,   135,
     136,     0,   138,   139,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,   441,   140,   442,     0,   443,   444,
     445,   446,   144,     0,     0,   447,   448,   449,   450,     0,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,     0,   462,     0,     0,     0,     0,     0,
       0,     0,     0,   463,   464,   465,   466,   467,   468,   154,
     155,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,   481,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,   164,   493,   494,   166,     0,   495,     0,
     496,   168,   497,     0,   498,     0,   499,     0,     0,     0,
     500,   501,   502,     0,   503,   172,     0,   504,     0,   505,
     506,   507,   508,   509,     0,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   175,     0,
     520,   521,   522,     0,   177,     0,   178,     0,   523,     0,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     182,     0,   531,     0,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,     0,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,     0,   558,
       0,   195,   559,   196,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,   197,     0,     0,     0,
     201,   567,   568,   569,   570,   571,   572,     0,   573,   202,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,     0,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,   217,   616,   617,     0,   618,   220,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   222,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,   224,   225,     0,     0,   639,   226,   640,   227,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,   655,   235,
       0,   656,     0,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,   239,   240,   241,
     242,   243,   244,   245,   666,   667,   668,     0,    86,    87,
      88,   403,    90,    91,    92,   404,  1051,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,     0,   495,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,    86,
      87,    88,   403,    90,    91,    92,   404,  4090,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,     0,     0,     0,    45,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,  2140,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,  1927,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,  1928,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,  1929,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,     0,
       0,     0,     0,     0,     0,     0,   962,  1595,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     406,     0,     0,   107,   108,   109,   110,     0,     0,   112,
     113,   114,   115,     0,   116,     0,     0,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,   416,     0,     0,    37,    38,    39,
      40,    41,    42,    43,    44,     0,     0,     0,    45,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,     0,   431,   432,   433,
     135,   136,     0,   138,   139,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,   441,   140,   442,     0,   443,
     444,   445,   446,   144,     0,     0,   447,   448,   449,   450,
       0,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,     0,   462,     0,     0,     0,     0,
       0,     0,     0,     0,   463,   464,   465,   466,   467,   468,
     154,   155,   469,  2145,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,   481,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,   164,   493,   494,   166,  1927,   495,
       0,   496,   168,   497,     0,   498,     0,   499,     0,     0,
       0,   500,   501,   502,     0,   503,   172,     0,   504,     0,
     505,   506,   507,   508,   509,     0,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,     0,   175,
       0,   520,   521,   522,     0,   177,     0,   178,     0,   523,
       0,     0,   524,     0,   525,   526,   527,   528,   529,   530,
       0,   182,     0,   531,     0,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,     0,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,     0,   556,   557,     0,
     558,     0,   195,   559,   196,   560,   561,   562,     0,   563,
    1928,     0,   564,   565,   566,     0,     0,   197,     0,     0,
       0,   201,   567,   568,   569,   570,   571,   572,     0,   573,
     202,   574,   203,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,     0,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,   217,   616,   617,     0,   618,   220,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,   224,   225,     0,     0,   639,   226,   640,   227,
    1929,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,   655,
     235,     0,   656,     0,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,     0,     0,
       0,     0,     0,     0,     0,   962,  1595,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,   406,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,   416,     0,     0,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     0,    45,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,     0,   431,   432,   433,   135,
     136,     0,   138,   139,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,   441,   140,   442,     0,   443,   444,
     445,   446,   144,     0,     0,   447,   448,   449,   450,     0,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,     0,   462,     0,     0,     0,     0,     0,
       0,     0,     0,   463,   464,   465,   466,   467,   468,   154,
     155,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,   481,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,   164,   493,   494,   166,  1927,   495,     0,
     496,   168,   497,     0,   498,     0,   499,     0,     0,     0,
     500,   501,   502,     0,   503,   172,     0,   504,     0,   505,
     506,   507,   508,   509,     0,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,     0,   175,     0,
     520,   521,   522,     0,   177,     0,   178,     0,   523,     0,
       0,   524,     0,   525,   526,   527,   528,   529,   530,     0,
     182,     0,   531,     0,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,     0,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,     0,   556,   557,     0,   558,
       0,   195,   559,   196,   560,   561,   562,     0,   563,  1928,
       0,   564,   565,   566,     0,     0,   197,     0,     0,     0,
     201,   567,   568,   569,   570,   571,   572,     0,   573,   202,
     574,   203,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,     0,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,   217,   616,   617,     0,   618,   220,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   222,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,   224,   225,     0,     0,   639,   226,   640,   227,  1929,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,   655,   235,
       0,   656,     0,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,   238,   239,   240,   241,
     242,   243,   244,   245,   666,   667,   668,     0,     0,     0,
       0,     0,     0,     0,   962,  1595,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   406,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,   416,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,    45,     0,     0,     0,
       0,   417,   951,   419,   420,   421,   422,   423,   424,   952,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,     0,   953,   432,   433,   135,   136,
       0,   138,   139,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,   441,   140,   442,     0,   443,   444,   445,
     446,   144,     0,     0,   447,   448,   449,   450,     0,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,     0,   462,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   154,   155,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,   481,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,   164,   493,   494,   166,     0,   495,     0,   954,
     168,   497,     0,   498,     0,   955,     0,   956,     0,   500,
     501,   502,     0,   503,   172,     0,   504,     0,   505,   506,
     507,   508,   509,     0,   510,   511,   512,   957,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   175,     0,   520,
     521,   522,     0,   177,     0,   178,     0,   523,     0,     0,
     524,     0,   525,   526,   527,   958,   529,   530,     0,   182,
       0,   531,     0,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   189,     0,   191,   959,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,     0,   558,     0,
     195,   559,   196,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,   197,     0,     0,     0,   201,
     567,   568,   569,   570,   571,   572,     0,   573,   202,   574,
     203,   575,   576,   577,     0,   960,   579,   580,   581,   582,
     583,   584,   205,   585,   586,   587,     0,   588,   961,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
       0,   600,   601,   213,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,     0,   615,
     217,   616,   617,     0,   618,   220,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   222,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
     224,   225,     0,     0,   639,   226,   640,   227,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,   655,   235,     0,
     656,     0,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,   238,   239,   240,   241,   242,
     243,   244,   245,   666,   667,   668,     0,     0,     0,     0,
       0,     0,     0,   962,   963,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   406,     0,     0,
     107,   108,   109,   110,     0,     0,   112,   113,   114,   115,
       0,   116,     0,     0,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,   416,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,    45,     0,     0,     0,     0,
     417,   951,   419,   420,   421,   422,   423,   424,   952,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,     0,   985,   432,   433,   135,   136,     0,
     138,   139,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,   441,   140,   442,     0,   443,   444,   445,   446,
     144,     0,     0,   447,   448,   449,   450,     0,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,     0,   462,     0,     0,     0,     0,     0,     0,     0,
       0,   463,   464,   465,   466,   467,   468,   154,   155,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,   481,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,   164,   493,   494,   166,     0,   495,     0,   954,   168,
     497,     0,   498,     0,   986,     0,   956,     0,   500,   501,
     502,     0,   503,   172,     0,   504,     0,   505,   506,   507,
     508,   509,     0,   510,   511,   512,   957,   513,   514,   515,
     516,   517,   518,     0,   519,     0,   175,     0,   520,   521,
     522,     0,   177,     0,   178,     0,   523,     0,     0,   524,
       0,   525,   526,   527,   958,   529,   530,     0,   182,     0,
     531,     0,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   189,     0,   191,   959,   549,   550,   551,   552,   553,
     554,   192,   555,     0,   556,   557,     0,   558,     0,   195,
     559,   196,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,   197,     0,     0,     0,   201,   567,
     568,   569,   570,   571,   572,     0,   573,   202,   574,   203,
     575,   576,   577,     0,   960,   579,   580,   581,   582,   583,
     584,   205,   585,   586,   587,     0,   588,   961,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,     0,
     600,   601,   213,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,   217,
     616,   617,     0,   618,   220,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   222,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,   224,
     225,     0,     0,   639,   226,   640,   227,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,   655,   235,     0,   656,
       0,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,   238,   239,   240,   241,   242,   243,
     244,   245,   666,   667,   668,     0,     0,     0,     0,     0,
       0,     0,   962,   963,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   406,     0,     0,   107,
     108,   109,   110,     0,     0,   112,   113,   114,   115,     0,
     116,     0,     0,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
     416,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,    45,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,  1335,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,     0,   431,   432,   433,   135,   136,     0,   138,
     139,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,   441,   140,   442,     0,   443,   444,   445,   446,   144,
       0,     0,   447,   448,   449,   450,     0,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
       0,   462,     0,     0,     0,     0,     0,     0,     0,     0,
     463,   464,   465,   466,   467,   468,   154,   155,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,   481,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
     164,   493,   494,   166,     0,   495,     0,   496,   168,   497,
       0,   498,     0,   499,     0,   956,     0,   500,   501,   502,
       0,   503,   172,     0,   504,     0,   505,   506,   507,   508,
     509,     0,   510,   511,   512,   957,   513,   514,   515,   516,
     517,   518,     0,   519,     0,   175,     0,   520,   521,   522,
       0,   177,     0,   178,     0,   523,     0,     0,   524,     0,
     525,   526,   527,   528,   529,   530,     0,   182,     0,   531,
       0,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     189,     0,   191,   548,   549,   550,   551,   552,   553,   554,
     192,   555,     0,   556,   557,     0,   558,     0,   195,   559,
     196,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,   197,     0,     0,     0,   201,   567,   568,
     569,   570,   571,   572,     0,   573,   202,   574,   203,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
     205,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,     0,   600,
     601,   213,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,   217,   616,
     617,     0,   618,   220,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   222,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,   224,   225,
       0,     0,   639,   226,   640,   227,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,   655,   235,     0,   656,     0,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,   238,   239,   240,   241,   242,   243,   244,
     245,   666,   667,   668,     0,     0,     0,     0,     0,     0,
       0,   962,   963,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   406,     0,     0,   107,   108,
     109,   110,     0,     0,   112,   113,   114,   115,     0,   116,
       0,     0,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,   416,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,    45,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,  1340,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,   428,   429,     0,
     430,     0,   431,   432,   433,   135,   136,     0,   138,   139,
       0,   434,   435,   436,   437,   438,     0,     0,   439,   440,
     441,   140,   442,     0,   443,   444,   445,   446,   144,     0,
       0,   447,   448,   449,   450,     0,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,     0,
     462,     0,     0,     0,     0,     0,     0,     0,     0,   463,
     464,   465,   466,   467,   468,   154,   155,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,   481,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,   164,
     493,   494,   166,     0,   495,     0,   496,   168,   497,     0,
     498,     0,   499,     0,   956,     0,   500,   501,   502,     0,
     503,   172,     0,   504,     0,   505,   506,   507,   508,   509,
       0,   510,   511,   512,   957,   513,   514,   515,   516,   517,
     518,     0,   519,     0,   175,     0,   520,   521,   522,     0,
     177,     0,   178,     0,   523,     0,     0,   524,     0,   525,
     526,   527,   528,   529,   530,     0,   182,     0,   531,     0,
       0,   532,   533,   534,     0,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   189,
       0,   191,   548,   549,   550,   551,   552,   553,   554,   192,
     555,     0,   556,   557,     0,   558,     0,   195,   559,   196,
     560,   561,   562,     0,   563,     0,     0,   564,   565,   566,
       0,     0,   197,     0,     0,     0,   201,   567,   568,   569,
     570,   571,   572,     0,   573,   202,   574,   203,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,   205,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,     0,   600,   601,
     213,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,     0,   615,   217,   616,   617,
       0,   618,   220,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   222,   629,     0,   630,   631,     0,
     632,   633,   634,   635,   636,   637,     0,   224,   225,     0,
       0,   639,   226,   640,   227,     0,   641,   642,   643,   644,
     645,   646,     0,     0,   647,   648,   649,   650,     0,     0,
     651,   652,   653,   654,   655,   235,     0,   656,     0,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,   238,   239,   240,   241,   242,   243,   244,   245,
     666,   667,   668,     0,     0,     0,     0,     0,     0,     0,
     962,   963,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   406,     0,     0,   107,   108,   109,
     110,     0,     0,   112,   113,   114,   115,     0,   116,     0,
       0,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,   416,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
       0,   431,   432,   433,   135,   136,     0,   138,   139,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,   441,
     140,   442,     0,   443,   444,   445,   446,   144,     0,     0,
     447,   448,   449,   450,     0,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,     0,   462,
       0,     0,     0,     0,     0,     0,     0,     0,   463,   464,
     465,   466,   467,   468,   154,   155,   469,   690,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,   481,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,   164,   493,
     494,   166,     0,   495,     0,   496,   168,   497,     0,   498,
       0,   499,     0,     0,     0,   500,   501,   502,     0,   503,
     172,     0,   504,     0,   505,   506,   507,   508,   509,     0,
     510,   511,   512,     0,   513,   514,   515,   516,   517,   518,
       0,   519,     0,   175,     0,   520,   521,   522,     0,   177,
       0,   178,     0,   523,     0,     0,   524,     0,   525,   526,
     527,   528,   529,   530,     0,   182,     0,   531,     0,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   189,     0,
     191,   548,   549,   550,   551,   552,   553,   554,   192,   555,
       0,   556,   557,     0,   558,     0,   195,   559,   196,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,   197,     0,     0,     0,   201,   567,   568,   569,   570,
     571,   572,     0,   573,   202,   574,   203,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,   205,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,     0,   600,   601,   213,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,   217,   616,   617,     0,
     618,   220,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   222,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,   224,   225,  1500,     0,
     639,   226,   640,   227,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,   655,   235,     0,   656,     0,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,   238,   239,   240,   241,   242,   243,   244,   245,   666,
     667,   668,     0,     0,  1023,  1501,    86,    87,    88,   403,
      90,    91,    92,   404,  1024,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   406,     0,
       0,   107,   108,   109,   110,     0,     0,   112,   113,   114,
     115,     0,   116,     0,     0,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,     0,   431,   432,   433,   135,   136,
       0,   138,   139,     0,   434,   435,   436,   437,   438,     0,
       0,  1025,   440,  1000,   140,   442,     0,   443,   444,   445,
     446,   144,     0,     0,   447,   448,   449,   450,     0,   451,
    1026,     0,  1027,   454,   455,   456,   457,   458,     0,   459,
     460,   461,     0,   462,     0,     0,     0,     0,     0,     0,
       0,     0,   463,   464,   465,   466,   467,   468,   154,   155,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,   481,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,   164,   493,   494,   166,     0,   495,     0,   496,
     168,   497,     0,   498,     0,   499,     0,     0,     0,   500,
     501,   502,     0,   503,   172,     0,   504,     0,   505,   506,
     507,   508,   509,     0,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,     0,   175,     0,   520,
     521,   522,     0,   177,     0,   178,     0,   523,     0,     0,
     524,     0,   525,   526,   527,   528,   529,   530,     0,   182,
       0,   531,     0,     0,   532,   533,  1028,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,  1029,   189,     0,   191,   548,   549,   550,   551,   552,
     553,   554,   192,   555,     0,   556,   557,     0,   558,     0,
     195,   559,   196,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,   197,     0,     0,     0,   201,
     567,   568,   569,   570,   571,   572,     0,   573,   202,   574,
     203,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,   205,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
       0,  1030,   601,   213,   602,   603,   604,  1031,   606,   607,
     608,   609,     0,   610,   611,   612,   613,  1032,     0,   615,
     217,   616,   617,     0,   618,   220,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   222,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
    1033,   225,     0,     0,  1034,   226,   640,   227,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,  1004,   235,     0,
     656,     0,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,  1035,   238,   239,   240,   241,   242,
     243,   244,   245,   666,   667,   668,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
     712,   425,   426,   427,   713,   714,   715,   716,   717,   718,
     719,   428,   429,   720,   430,   133,   431,   432,   433,   135,
     136,   137,   138,   139,   721,   434,   435,   436,   437,   438,
     722,   723,   439,   440,   724,   140,   442,   725,   443,   444,
     445,   446,   144,   726,   727,   447,   448,   449,   450,   147,
     451,   728,   729,   453,   454,   455,   456,   457,   458,   730,
     459,   460,   461,   150,   462,   731,   732,   733,   734,   151,
     735,   736,   737,   463,   464,   465,   466,   467,   468,   154,
     155,   469,   738,   470,   739,   471,   472,   473,   474,   475,
     740,   476,   477,   478,   741,   742,   479,   480,   481,   482,
     483,   743,   484,   485,   486,   744,   487,   488,   745,   489,
     490,   491,   492,   164,   493,   494,   166,   746,   495,   747,
     496,   168,   497,   748,   498,   749,   499,   169,   750,   170,
     500,   501,   502,   751,   503,   172,   752,   504,   753,   505,
     506,   507,   508,   509,   173,   510,   511,   512,   754,   513,
     514,   515,   516,   517,   518,   755,   519,   174,   175,   756,
     520,   521,   522,   757,   177,   758,   178,   759,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,   760,
     182,   183,   531,   184,   761,   532,   533,   534,   762,   763,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   189,   190,   191,   548,   549,   550,   551,
     552,   553,   554,   192,   555,   764,   556,   557,   194,   558,
     765,   195,   559,   196,   560,   561,   562,   766,   563,   767,
     768,   564,   565,   566,   769,   770,   197,   198,   199,   200,
     201,   567,   568,   569,   570,   571,   572,   771,   573,   202,
     574,   203,   575,   576,   577,   772,   578,   579,   580,   581,
     582,   583,   584,   205,   585,   586,   587,   773,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   774,   598,
     599,   211,   600,   601,   213,   602,   603,   604,   605,   606,
     607,   608,   609,   775,   610,   611,   612,   613,   614,   776,
     615,   217,   616,   617,   219,   618,   220,   777,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   222,   629,
     778,   630,   631,   779,   632,   633,   634,   635,   636,   637,
     780,   224,   225,   781,   782,   639,   226,   640,   227,   783,
     641,   642,   643,   644,   645,   646,   784,   785,   647,   648,
     649,   650,   786,   787,   651,   652,   653,   654,   788,   235,
     789,   656,   236,   657,   658,   659,   790,   791,   660,   792,
     793,   661,   662,   663,   664,   665,   238,   239,   240,   241,
     242,   243,   244,   245,   666,   667,   668,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,  2961,   422,   423,
     424,   712,   425,   426,   427,   713,   714,   715,   716,   717,
     718,   719,   428,   429,   720,   430,   133,   431,   432,   433,
     135,   136,   137,   138,   139,   721,   434,   435,   436,   437,
     438,   722,   723,   439,   440,   724,   140,   442,   725,   443,
     444,   445,   446,   144,   726,   727,   447,   448,   449,   450,
     147,   451,   728,   729,   453,   454,   455,   456,   457,   458,
     730,   459,   460,   461,   150,   462,   731,   732,   733,   734,
     151,   735,   736,   737,   463,   464,   465,   466,   467,   468,
     154,   155,   469,   738,   470,   739,   471,   472,   473,   474,
     475,   740,   476,   477,   478,   741,   742,   479,   480,   481,
    2962,   483,   743,   484,   485,   486,   744,   487,   488,   745,
     489,   490,   491,   492,   164,   493,   494,   166,   746,   495,
     747,   496,   168,   497,   748,   498,   749,   499,   169,   750,
     170,   500,   501,   502,   751,   503,   172,   752,   504,   753,
     505,   506,   507,   508,   509,   173,   510,   511,   512,   754,
     513,   514,   515,   516,   517,   518,   755,   519,   174,   175,
     756,   520,   521,   522,   757,   177,   758,   178,   759,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
     760,   182,   183,   531,   184,   761,   532,   533,   534,   762,
     763,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   189,   190,   191,   548,   549,   550,
     551,   552,   553,   554,   192,   555,   764,   556,   557,   194,
     558,   765,   195,   559,   196,   560,   561,   562,   766,   563,
     767,   768,   564,   565,   566,   769,   770,   197,   198,   199,
     200,   201,   567,   568,   569,   570,   571,   572,   771,   573,
     202,   574,   203,   575,   576,   577,   772,   578,   579,   580,
     581,   582,   583,   584,   205,   585,   586,   587,   773,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   774,
     598,   599,   211,   600,   601,   213,   602,   603,   604,   605,
     606,   607,   608,   609,   775,   610,   611,   612,   613,   614,
     776,  2963,   217,   616,   617,   219,   618,   220,   777,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   222,
     629,   778,   630,   631,   779,   632,   633,   634,   635,   636,
     637,   780,   224,   225,   781,   782,   639,   226,   640,   227,
     783,   641,   642,   643,   644,   645,   646,   784,   785,   647,
     648,   649,   650,   786,   787,   651,   652,   653,   654,   788,
     235,   789,   656,   236,   657,   658,   659,   790,   791,   660,
     792,   793,   661,   662,   663,   664,   665,   238,   239,   240,
     241,   242,   243,   244,   245,   666,   667,   668,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,   135,   136,   137,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,     0,     0,
       0,   151,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,   182,   183,   531,   184,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,   190,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
     194,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,   198,
     199,   200,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,   219,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,   705,
      86,    87,    88,   403,    90,    91,    92,   404,     0,   405,
      95,     0,     0,    98,    99,   100,   101,   102,   103,   706,
     104,   105,   406,   707,     0,   107,   108,   109,   110,   708,
     709,   112,   113,   114,   115,     0,   116,   710,   711,   407,
     408,     0,     0,     0,   409,   410,     0,     0,     0,     0,
     411,     0,     0,     0,     0,     0,     0,     0,     0,   412,
       0,   413,     0,   414,   415,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   417,   418,   419,   420,   421,
     422,   423,   424,     0,   425,   426,   427,     0,     0,     0,
       0,     0,     0,     0,   428,   429,     0,   430,   133,   431,
     432,   433,   135,   136,   137,   138,   139,     0,   434,   435,
     436,   437,   438,     0,     0,   439,   440,   441,   140,   442,
       0,   443,   444,   445,   446,   144,     0,     0,   447,   448,
     449,   450,   147,   451,   452,     0,   453,   454,   455,   456,
     457,   458,     0,   459,   460,   461,   150,   462,     0,     0,
       0,     0,   151,     0,     0,     0,   463,   464,   465,   466,
     467,   468,   154,   155,   469,     0,   470,     0,   471,   472,
     473,   474,   475,     0,   476,   477,   478,     0,     0,   479,
     480,   481,   482,   483,     0,   484,   485,   486,     0,   487,
     488,     0,   489,   490,   491,   492,   164,   493,   494,   166,
       0,   495,     0,   496,   168,   497,     0,   498,     0,   499,
     169,     0,   170,   500,   501,   502,     0,   503,   172,     0,
     504,     0,   505,   506,   507,   508,  1272,   173,   510,   511,
     512,     0,   513,   514,   515,   516,   517,   518,     0,   519,
     174,   175,     0,   520,   521,   522,     0,   177,     0,   178,
       0,   523,   179,   180,   524,   181,   525,   526,   527,   528,
     529,   530,     0,   182,   183,   531,   184,     0,   532,   533,
     534,     0,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   189,   190,   191,   548,
     549,   550,   551,   552,   553,   554,   192,   555,     0,   556,
     557,   194,   558,     0,   195,   559,   196,   560,   561,   562,
       0,   563,     0,     0,   564,   565,   566,     0,     0,   197,
     198,   199,   200,   201,   567,   568,   569,   570,   571,   572,
       0,   573,   202,   574,   203,   575,   576,   577,     0,   578,
     579,   580,   581,   582,   583,   584,   205,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,     0,   598,   599,   211,   600,   601,   213,   602,   603,
     604,   605,   606,   607,   608,   609,     0,   610,   611,   612,
     613,   614,     0,   615,   217,   616,   617,   219,   618,   220,
       0,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   222,   629,     0,   630,   631,     0,   632,   633,   634,
     635,   636,   637,     0,   224,   225,     0,     0,   639,   226,
     640,   227,     0,   641,   642,   643,   644,   645,   646,     0,
       0,   647,   648,   649,   650,     0,     0,   651,   652,   653,
     654,   655,   235,     0,   656,   236,   657,   658,   659,     0,
       0,   660,     0,     0,   661,   662,   663,   664,   665,   238,
     239,   240,   241,   242,   243,   244,   245,   666,   667,   668,
     705,    86,    87,    88,   403,    90,    91,    92,   404,     0,
     405,    95,     0,     0,    98,    99,   100,   101,   102,   103,
     706,   104,   105,   406,   707,     0,   107,   108,   109,   110,
     708,   709,   112,   113,   114,   115,     0,   116,   710,   711,
     407,   408,     0,     0,     0,   409,   410,     0,     0,     0,
       0,   411,     0,     0,     0,     0,     0,     0,     0,     0,
     412,     0,   413,     0,   414,   415,    35,     0,     0,     0,
       0,     0,     0,     0,    41,    42,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,   426,   427,     0,     0,
       0,     0,     0,     0,     0,   428,   429,     0,   430,   133,
     431,   432,   433,   135,   136,   137,   138,   139,     0,   434,
     435,   436,   437,   438,     0,     0,   439,   440,   441,   140,
     442,     0,   443,   444,   445,   446,   144,     0,     0,   447,
     448,   449,   450,   147,   451,   452,     0,   453,   454,   455,
     456,   457,   458,     0,   459,   460,   461,   150,   462,     0,
       0,     0,     0,   151,     0,     0,     0,   463,   464,   465,
     466,   467,   468,   154,   155,   469,     0,   470,     0,   471,
     472,   473,   474,   475,     0,   476,   477,   478,     0,     0,
     479,   480,   481,   482,   483,     0,   484,   485,   486,     0,
     487,   488,     0,   489,   490,   491,   492,   164,   493,   494,
     166,     0,   495,     0,   496,   168,   497,     0,   498,     0,
     499,   169,     0,   170,   500,   501,   502,     0,   503,   172,
       0,   504,     0,   505,   506,   507,   508,  1280,   173,   510,
     511,   512,     0,   513,   514,   515,   516,   517,   518,     0,
     519,   174,   175,     0,   520,   521,   522,     0,   177,     0,
     178,     0,   523,   179,   180,   524,   181,   525,   526,   527,
     528,   529,   530,     0,   182,   183,   531,   184,     0,   532,
     533,   534,     0,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   189,   190,   191,
     548,   549,   550,   551,   552,   553,   554,   192,   555,     0,
     556,   557,   194,   558,     0,   195,   559,   196,   560,   561,
     562,     0,   563,     0,     0,   564,   565,   566,     0,     0,
     197,   198,   199,   200,   201,   567,   568,   569,   570,   571,
     572,     0,   573,   202,   574,   203,   575,   576,   577,     0,
     578,   579,   580,   581,   582,   583,   584,   205,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,     0,   598,   599,   211,   600,   601,   213,   602,
     603,   604,   605,   606,   607,   608,   609,     0,   610,   611,
     612,   613,   614,     0,   615,   217,   616,   617,   219,   618,
     220,     0,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   222,   629,     0,   630,   631,     0,   632,   633,
     634,   635,   636,   637,     0,   224,   225,     0,     0,   639,
     226,   640,   227,     0,   641,   642,   643,   644,   645,   646,
       0,     0,   647,   648,   649,   650,     0,     0,   651,   652,
     653,   654,   655,   235,     0,   656,   236,   657,   658,   659,
       0,     0,   660,     0,     0,   661,   662,   663,   664,   665,
     238,   239,   240,   241,   242,   243,   244,   245,   666,   667,
     668,   705,    86,    87,    88,   403,    90,    91,    92,   404,
       0,   405,    95,     0,     0,    98,    99,   100,   101,   102,
     103,   706,   104,   105,   406,   707,     0,   107,   108,   109,
     110,   708,   709,   112,   113,   114,   115,     0,   116,   710,
     711,   407,   408,     0,     0,     0,   409,   410,     0,     0,
       0,     0,   411,     0,     0,     0,     0,     0,     0,     0,
       0,   412,     0,   413,     0,   414,   415,    35,     0,     0,
       0,     0,     0,     0,     0,    41,    42,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,   426,   427,     0,
       0,     0,     0,     0,     0,     0,   428,   429,     0,   430,
     133,   431,   432,   433,     0,  1784,   137,  1785,  1786,     0,
     434,   435,   436,   437,   438,     0,     0,   439,   440,  1787,
    1788,   442,     0,   443,   444,   445,   446,     0,     0,     0,
     447,   448,   449,   450,   147,   451,   452,     0,   453,   454,
     455,   456,   457,   458,     0,   459,   460,   461,   150,   462,
       0,     0,     0,     0,   151,     0,     0,     0,   463,   464,
     465,   466,   467,   468,  1789,  1790,   469,     0,   470,     0,
     471,   472,   473,   474,   475,     0,   476,   477,   478,     0,
       0,   479,   480,  1419,   482,   483,     0,   484,   485,   486,
       0,   487,   488,     0,   489,   490,   491,   492,     0,   493,
     494,     0,     0,   495,     0,   496,  1791,   497,     0,   498,
       0,   499,   169,     0,   170,   500,   501,   502,     0,   503,
       0,     0,   504,     0,   505,   506,   507,   508,   509,   173,
     510,   511,   512,  2303,   513,   514,   515,   516,   517,   518,
       0,   519,   174,  2304,     0,   520,   521,   522,  1425,  1792,
       0,  1793,     0,   523,   179,   180,   524,   181,   525,   526,
     527,   528,   529,   530,     0,     0,   183,   531,   184,     0,
     532,   533,   534,     0,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,  1794,   190,
    1795,   548,   549,   550,   551,   552,   553,   554,     0,   555,
       0,   556,   557,   194,   558,     0,     0,   559,  1796,   560,
     561,   562,     0,   563,     0,     0,   564,   565,   566,     0,
       0,  2305,   198,   199,   200,     0,   567,   568,   569,   570,
     571,   572,     0,   573,     0,   574,     0,   575,   576,   577,
       0,   578,   579,   580,   581,   582,   583,   584,  1797,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,     0,   598,   599,   211,   600,   601,     0,
     602,   603,   604,   605,   606,   607,   608,   609,     0,   610,
     611,   612,   613,   614,     0,   615,  2306,   616,   617,   219,
     618,  1799,     0,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,     0,   629,     0,   630,   631,     0,   632,
     633,   634,   635,   636,   637,     0,  1800,  1801,     0,     0,
     639,     0,   640,     0,     0,   641,   642,   643,   644,   645,
     646,     0,     0,   647,   648,   649,   650,     0,     0,   651,
     652,   653,   654,     0,  1802,  2307,   656,   236,   657,   658,
     659,     0,     0,   660,     0,     0,   661,   662,   663,   664,
     665,     0,     0,     0,     0,     0,     0,     0,     0,   666,
     667,   668,   705,    86,    87,    88,   403,    90,    91,    92,
     404,     0,   405,    95,     0,     0,    98,    99,   100,   101,
     102,   103,   706,   104,   105,   406,   707,     0,   107,   108,
     109,   110,   708,   709,   112,   113,   114,   115,     0,   116,
     710,   711,   407,   408,     0,     0,     0,   409,   410,     0,
       0,     0,     0,   411,     0,     0,     0,     0,     0,     0,
       0,     0,   412,     0,   413,     0,   414,   415,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   417,   418,
     419,   420,   421,   422,   423,   424,     0,   425,   426,   427,
       0,     0,     0,     0,     0,     0,     0,   428,   429,     0,
     430,   133,   431,   432,   433,     0,  1784,   137,  1785,  1786,
       0,   434,   435,   436,   437,   438,     0,     0,   439,   440,
    1787,  1788,   442,     0,   443,   444,   445,   446,     0,     0,
       0,   447,   448,   449,   450,   147,   451,   452,     0,   453,
     454,   455,   456,   457,   458,     0,   459,   460,   461,   150,
     462,     0,     0,     0,     0,   151,     0,     0,     0,   463,
     464,   465,   466,   467,   468,  1789,  1790,   469,     0,   470,
       0,   471,   472,   473,   474,   475,     0,   476,   477,   478,
       0,     0,   479,   480,  1419,   482,   483,     0,   484,   485,
     486,     0,   487,   488,     0,   489,   490,   491,   492,     0,
     493,   494,     0,     0,   495,     0,   496,  1791,   497,     0,
     498,     0,   499,   169,     0,   170,   500,   501,   502,     0,
     503,     0,     0,   504,     0,   505,   506,   507,   508,   509,
     173,   510,   511,   512,     0,   513,   514,   515,   516,   517,
     518,     0,   519,   174,     0,     0,   520,   521,   522,  1425,
    1792,     0,  1793,     0,   523,   179,   180,   524,   181,   525,
     526,   527,   528,   529,   530,     0,     0,   183,   531,   184,
       0,   532,   533,   534,     0,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,  1794,
     190,  1795,   548,   549,   550,   551,   552,   553,   554,     0,
     555,     0,   556,   557,   194,   558,  2295,     0,   559,  1796,
     560,   561,   562,     0,   563,     0,     0,   564,   565,   566,
       0,     0,     0,   198,   199,   200,     0,   567,   568,   569,
     570,   571,   572,     0,   573,     0,   574,     0,   575,   576,
     577,     0,   578,   579,   580,   581,   582,   583,   584,  1797,
     585,   586,   587,     0,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,     0,   598,   599,   211,   600,   601,
       0,   602,   603,   604,   605,   606,   607,   608,   609,     0,
     610,   611,   612,   613,   614,     0,   615,  2306,   616,   617,
     219,   618,  1799,     0,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,     0,   629,     0,   630,   631,  3581,
     632,   633,   634,   635,   636,   637,     0,  1800,  1801,     0,
       0,   639,     0,   640,     0,     0,   641,   642,   643,   644,
     645,   646,     0,     0,   647,   648,   649,   650,     0,     0,
     651,   652,   653,   654,     0,  1802,     0,   656,   236,   657,
     658,   659,     0,     0,   660,     0,     0,   661,   662,   663,
     664,   665,     0,     0,     0,     0,     0,     0,     0,     0,
     666,   667,   668,   705,    86,    87,    88,   403,    90,    91,
      92,   404,     0,   405,    95,     0,     0,    98,    99,   100,
     101,   102,   103,   706,   104,   105,   406,   707,     0,   107,
     108,   109,   110,   708,   709,   112,   113,   114,   115,     0,
     116,   710,   711,   407,   408,     0,     0,     0,   409,   410,
       0,     0,     0,     0,   411,     0,     0,     0,     0,     0,
       0,     0,     0,   412,     0,   413,     0,   414,   415,    35,
       0,     0,     0,     0,     0,     0,     0,    41,    42,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,   426,
     427,     0,     0,     0,     0,     0,     0,     0,   428,   429,
       0,   430,   133,   431,   432,   433,     0,  1784,   137,  1785,
    1786,     0,   434,   435,   436,   437,   438,     0,     0,   439,
     440,  1787,  1788,   442,     0,   443,   444,   445,   446,     0,
       0,     0,   447,   448,   449,   450,   147,   451,   452,     0,
     453,   454,   455,   456,   457,   458,     0,   459,   460,   461,
     150,   462,     0,     0,     0,     0,   151,     0,     0,     0,
     463,   464,   465,   466,   467,   468,  1789,  1790,   469,     0,
     470,     0,   471,   472,   473,   474,   475,     0,   476,   477,
     478,     0,     0,   479,   480,  1419,   482,   483,     0,   484,
     485,   486,     0,   487,   488,     0,   489,   490,   491,   492,
       0,   493,   494,     0,     0,   495,     0,   496,  1791,   497,
       0,   498,     0,   499,   169,     0,   170,   500,   501,   502,
       0,   503,     0,     0,   504,     0,   505,   506,   507,   508,
     509,   173,   510,   511,   512,     0,   513,   514,   515,   516,
     517,   518,     0,   519,   174,     0,     0,   520,   521,   522,
    1425,  1792,     0,  1793,     0,   523,   179,   180,   524,   181,
     525,   526,   527,   528,   529,   530,     0,     0,   183,   531,
     184,     0,   532,   533,   534,     0,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
    1794,   190,  1795,   548,   549,   550,   551,   552,   553,   554,
    2348,   555,     0,   556,   557,   194,   558,     0,     0,   559,
    1796,   560,   561,   562,     0,   563,     0,     0,   564,   565,
     566,     0,     0,     0,   198,   199,   200,     0,   567,   568,
     569,   570,   571,   572,     0,   573,     0,   574,     0,   575,
     576,   577,     0,   578,   579,   580,   581,   582,   583,   584,
    1797,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,     0,   598,   599,   211,   600,
     601,     0,   602,   603,   604,   605,   606,   607,   608,   609,
       0,   610,   611,   612,   613,   614,     0,   615,  1798,   616,
     617,   219,   618,  1799,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,     0,   629,     0,   630,   631,
       0,   632,   633,   634,   635,   636,   637,     0,  1800,  1801,
       0,     0,   639,     0,   640,     0,     0,   641,   642,   643,
     644,   645,   646,     0,     0,   647,   648,   649,   650,     0,
       0,   651,   652,   653,   654,     0,  1802,     0,   656,   236,
     657,   658,   659,     0,     0,   660,     0,     0,   661,   662,
     663,   664,   665,     0,     0,     0,     0,     0,     0,     0,
       0,   666,   667,   668,   705,    86,    87,    88,   403,    90,
      91,    92,   404,     0,   405,    95,     0,     0,    98,    99,
     100,   101,   102,   103,   706,   104,   105,   406,   707,     0,
     107,   108,   109,   110,   708,   709,   112,   113,   114,   115,
       0,   116,   710,   711,   407,   408,     0,     0,     0,   409,
     410,     0,     0,     0,     0,   411,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,   413,     0,   414,   415,
      35,     0,     0,     0,     0,     0,     0,     0,    41,    42,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
     426,   427,     0,     0,     0,     0,     0,     0,     0,   428,
     429,     0,   430,   133,   431,   432,   433,     0,  1784,   137,
    1785,  1786,     0,   434,   435,   436,   437,   438,     0,     0,
     439,   440,  1787,  1788,   442,     0,   443,   444,   445,   446,
       0,     0,     0,   447,   448,   449,   450,   147,   451,   452,
       0,   453,   454,   455,   456,   457,   458,     0,   459,   460,
     461,   150,   462,     0,     0,     0,     0,   151,     0,     0,
       0,   463,   464,   465,   466,   467,   468,  1789,  1790,   469,
       0,   470,     0,   471,   472,   473,   474,   475,     0,   476,
     477,   478,     0,     0,   479,   480,  1419,   482,   483,     0,
     484,   485,   486,     0,   487,   488,     0,   489,   490,   491,
     492,     0,   493,   494,     0,     0,   495,     0,   496,  1791,
     497,     0,   498,     0,   499,   169,     0,   170,   500,   501,
     502,     0,   503,     0,     0,   504,     0,   505,   506,   507,
     508,   509,   173,   510,   511,   512,     0,   513,   514,   515,
     516,   517,   518,     0,   519,   174,     0,     0,   520,   521,
     522,  1425,  1792,     0,  1793,     0,   523,   179,   180,   524,
     181,   525,   526,   527,   528,   529,   530,     0,     0,   183,
     531,   184,     0,   532,   533,   534,     0,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,  1794,   190,  1795,   548,   549,   550,   551,   552,   553,
     554,  3428,   555,     0,   556,   557,   194,   558,     0,     0,
     559,  1796,   560,   561,   562,     0,   563,     0,     0,   564,
     565,   566,     0,     0,     0,   198,   199,   200,     0,   567,
     568,   569,   570,   571,   572,     0,   573,     0,   574,     0,
     575,   576,   577,     0,   578,   579,   580,   581,   582,   583,
     584,  1797,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,     0,   598,   599,   211,
     600,   601,     0,   602,   603,   604,   605,   606,   607,   608,
     609,     0,   610,   611,   612,   613,   614,     0,   615,  1798,
     616,   617,   219,   618,  1799,     0,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,     0,   629,     0,   630,
     631,     0,   632,   633,   634,   635,   636,   637,     0,  1800,
    1801,     0,     0,   639,     0,   640,     0,     0,   641,   642,
     643,   644,   645,   646,     0,     0,   647,   648,   649,   650,
       0,     0,   651,   652,   653,   654,     0,  1802,     0,   656,
     236,   657,   658,   659,     0,     0,   660,     0,     0,   661,
     662,   663,   664,   665,     0,     0,     0,     0,     0,     0,
       0,     0,   666,   667,   668,   705,    86,    87,    88,   403,
      90,    91,    92,   404,     0,   405,    95,     0,     0,    98,
      99,   100,   101,   102,   103,   706,   104,   105,   406,   707,
       0,   107,   108,   109,   110,   708,   709,   112,   113,   114,
     115,     0,   116,   710,   711,   407,   408,     0,     0,     0,
     409,   410,     0,     0,     0,     0,   411,     0,     0,     0,
       0,     0,     0,     0,     0,   412,     0,   413,     0,   414,
     415,    35,     0,     0,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   418,   419,   420,   421,   422,   423,   424,     0,
     425,   426,   427,     0,     0,     0,     0,     0,     0,     0,
     428,   429,     0,   430,   133,   431,   432,   433,     0,  1784,
     137,  1785,  1786,     0,   434,   435,   436,   437,   438,     0,
       0,   439,   440,  1787,  1788,   442,     0,   443,   444,   445,
     446,     0,     0,     0,   447,   448,   449,   450,   147,   451,
     452,     0,   453,   454,   455,   456,   457,   458,     0,   459,
     460,   461,   150,   462,     0,     0,     0,     0,   151,     0,
       0,     0,   463,   464,   465,   466,   467,   468,  1789,  1790,
     469,     0,   470,     0,   471,   472,   473,   474,   475,     0,
     476,   477,   478,     0,     0,   479,   480,  1419,   482,   483,
       0,   484,   485,   486,     0,   487,   488,     0,   489,   490,
     491,   492,     0,   493,   494,     0,     0,   495,     0,   496,
    1791,   497,     0,   498,     0,   499,   169,     0,   170,   500,
     501,   502,     0,   503,     0,     0,   504,     0,   505,   506,
     507,   508,   509,   173,   510,   511,   512,     0,   513,   514,
     515,   516,   517,   518,     0,   519,   174,     0,     0,   520,
     521,   522,  1425,  1792,     0,  1793,     0,   523,   179,   180,
     524,   181,   525,   526,   527,   528,   529,   530,     0,     0,
     183,   531,   184,     0,   532,   533,   534,     0,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,  1794,   190,  1795,   548,   549,   550,   551,   552,
     553,   554,     0,   555,     0,   556,   557,   194,   558,     0,
       0,   559,  1796,   560,   561,   562,     0,   563,     0,     0,
     564,   565,   566,     0,     0,     0,   198,   199,   200,     0,
     567,   568,   569,   570,   571,   572,     0,   573,     0,   574,
       0,   575,   576,   577,     0,   578,   579,   580,   581,   582,
     583,   584,  1797,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,     0,   598,   599,
     211,   600,   601,     0,   602,   603,   604,   605,   606,   607,
     608,   609,     0,   610,   611,   612,   613,   614,     0,   615,
    1798,   616,   617,   219,   618,  1799,     0,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,     0,   629,     0,
     630,   631,     0,   632,   633,   634,   635,   636,   637,     0,
    1800,  1801,     0,     0,   639,     0,   640,     0,     0,   641,
     642,   643,   644,   645,   646,     0,     0,   647,   648,   649,
     650,     0,     0,   651,   652,   653,   654,     0,  1802,     0,
     656,   236,   657,   658,   659,     0,     0,   660,     0,     0,
     661,   662,   663,   664,   665,     0,     0,     0,     0,     0,
       0,     0,     0,   666,   667,   668,   705,    86,    87,    88,
     403,    90,    91,    92,   404,     0,   405,    95,     0,     0,
      98,    99,   100,   101,   102,   103,   706,   104,   105,   406,
     707,     0,   107,   108,   109,   110,   708,   709,   112,   113,
     114,   115,     0,   116,   710,   711,   407,   408,     0,     0,
       0,   409,   410,     0,     0,     0,     0,   411,     0,     0,
       0,     0,     0,     0,     0,     0,   412,     0,   413,     0,
     414,   415,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,   426,   427,     0,     0,     0,     0,     0,     0,
       0,   428,   429,     0,   430,   133,   431,   432,   433,     0,
    1784,   137,  1785,  1786,     0,   434,   435,   436,   437,   438,
       0,     0,   439,   440,  1787,  1788,   442,     0,   443,   444,
     445,   446,     0,     0,     0,   447,   448,   449,   450,   147,
     451,   452,     0,   453,   454,   455,   456,   457,   458,     0,
     459,   460,   461,   150,   462,     0,     0,     0,     0,   151,
       0,     0,     0,   463,   464,   465,   466,   467,   468,  1789,
    1790,   469,     0,   470,     0,   471,   472,   473,   474,   475,
       0,   476,   477,   478,     0,     0,   479,   480,  1419,   482,
     483,     0,   484,   485,   486,     0,   487,   488,     0,   489,
     490,   491,   492,     0,   493,   494,     0,     0,   495,     0,
     496,  1791,   497,     0,   498,     0,   499,   169,     0,   170,
     500,   501,   502,     0,   503,     0,     0,   504,     0,   505,
     506,   507,   508,   509,   173,   510,   511,   512,     0,   513,
     514,   515,   516,   517,   518,     0,   519,   174,     0,     0,
     520,   521,   522,  1425,  1792,     0,  1793,     0,   523,   179,
     180,   524,   181,   525,   526,   527,   528,   529,   530,     0,
       0,   183,   531,   184,     0,   532,   533,   534,     0,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,  1794,   190,  1795,   548,   549,   550,   551,
     552,   553,   554,     0,   555,     0,   556,   557,   194,   558,
       0,     0,   559,  1796,   560,   561,   562,     0,   563,     0,
       0,   564,   565,   566,     0,     0,     0,   198,   199,   200,
       0,   567,   568,   569,   570,   571,   572,     0,   573,     0,
     574,     0,   575,   576,   577,     0,   578,   579,   580,   581,
     582,   583,   584,  1797,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,     0,   598,
     599,   211,   600,   601,     0,   602,   603,   604,   605,   606,
     607,   608,   609,     0,   610,   611,   612,   613,   614,     0,
     615,  2306,   616,   617,   219,   618,  1799,     0,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,     0,   629,
       0,   630,   631,     0,   632,   633,   634,   635,   636,   637,
       0,  1800,  1801,     0,     0,   639,     0,   640,     0,     0,
     641,   642,   643,   644,   645,   646,     0,     0,   647,   648,
     649,   650,     0,     0,   651,   652,   653,   654,     0,  1802,
       0,   656,   236,   657,   658,   659,     0,     0,   660,     0,
       0,   661,   662,   663,   664,   665,     0,     0,     0,     0,
       0,     0,     0,     0,   666,   667,   668,   705,    86,    87,
      88,   403,    90,    91,    92,   404,     0,   405,    95,     0,
       0,    98,    99,   100,   101,   102,   103,   706,   104,   105,
     406,   707,     0,   107,   108,   109,   110,   708,   709,   112,
     113,   114,   115,     0,   116,   710,   711,   407,   408,     0,
       0,     0,   409,   410,     0,     0,     0,     0,   411,     0,
       0,     0,     0,     0,     0,     0,     0,   412,     0,   413,
       0,   414,   415,    35,     0,     0,     0,     0,     0,     0,
       0,    41,    42,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,   426,   427,     0,     0,     0,     0,     0,
       0,     0,   428,   429,     0,   430,   133,   431,   432,   433,
       0,  1784,   137,  1785,  1786,     0,   434,   435,   436,   437,
     438,     0,     0,   439,   440,  1787,  1788,   442,     0,   443,
     444,   445,   446,     0,     0,     0,   447,   448,   449,   450,
     147,   451,   452,     0,   453,   454,   455,   456,   457,   458,
       0,   459,   460,   461,   150,   462,     0,     0,     0,     0,
     151,     0,     0,     0,   463,   464,   465,   466,   467,   468,
    1789,  1790,   469,     0,   470,     0,   471,   472,   473,   474,
     475,     0,   476,   477,   478,     0,     0,   479,   480,  1419,
     482,   483,     0,   484,   485,   486,     0,   487,   488,     0,
     489,   490,   491,   492,     0,   493,   494,     0,     0,   495,
       0,   496,  1791,   497,     0,   498,     0,   499,   169,     0,
     170,   500,   501,   502,     0,   503,     0,     0,   504,     0,
     505,   506,   507,   508,   509,   173,   510,   511,   512,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   174,     0,
       0,   520,   521,   522,  1425,  1792,     0,  1793,     0,   523,
     179,   180,   524,   181,   525,   526,   527,   528,   529,   530,
       0,     0,   183,   531,   184,     0,   532,   533,   534,     0,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,  1794,   190,  1795,   548,   549,   550,
     551,   552,   553,   554,     0,   555,     0,   556,   557,   194,
     558,     0,     0,   559,  1796,   560,   561,   562,     0,   563,
       0,     0,   564,   565,   566,     0,     0,     0,   198,   199,
     200,     0,   567,   568,   569,   570,   571,   572,     0,   573,
       0,   574,     0,   575,   576,   577,     0,   578,   579,   580,
     581,   582,   583,   584,  1797,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,     0,
     598,   599,   211,   600,   601,     0,   602,   603,   604,   605,
     606,   607,   608,   609,     0,   610,   611,   612,   613,   614,
       0,   615,     0,   616,   617,   219,   618,  1799,     0,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,     0,
     629,     0,   630,   631,     0,   632,   633,   634,   635,   636,
     637,     0,  1800,  1801,     0,     0,   639,     0,   640,     0,
       0,   641,   642,   643,   644,   645,   646,     0,     0,   647,
     648,   649,   650,     0,     0,   651,   652,   653,   654,     0,
    1802,     0,   656,   236,   657,   658,   659,     0,     0,   660,
       0,     0,   661,   662,   663,   664,   665,     0,     0,     0,
       0,     0,     0,     0,     0,   666,   667,   668,   705,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,   706,   104,
     105,   406,   707,     0,   107,   108,   109,   110,   708,   709,
     112,   113,   114,   115,     0,   116,   710,   711,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,   133,   431,   432,
     433,     0,     0,   137,     0,     0,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,     0,     0,   442,     0,
     443,   444,   445,   446,     0,     0,     0,   447,   448,   449,
     450,   147,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,   150,   462,     0,     0,     0,
       0,   151,     0,     0,     0,   463,   464,   465,   466,   467,
     468,     0,     0,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,     0,   493,   494,     0,     0,
     495,     0,   496,     0,   497,     0,   498,     0,   499,   169,
       0,   170,   500,   501,   502,     0,   503,     0,     0,   504,
       0,   505,   506,   507,   508,   509,   173,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,   174,
       0,     0,   520,   521,   522,     0,     0,     0,     0,     0,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,     0,     0,   183,   531,   184,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,     0,   190,     0,   548,   549,
     550,   551,   552,   553,   554,     0,   555,     0,   556,   557,
     194,   558,     0,     0,   559,     0,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,     0,   198,
     199,   200,     0,   567,   568,   569,   570,   571,   572,     0,
     573,     0,   574,     0,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,     0,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,   211,   600,   601,     0,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,     0,   616,   617,   219,   618,     0,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
       0,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,     0,     0,     0,     0,   639,     0,   640,
       0,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
       0,     0,     0,   656,   236,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,     0,     0,
       0,     0,     0,     0,     0,     0,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   712,   425,   426,   427,   713,   714,   715,   716,
     717,   718,   719,   428,   429,   720,   430,   133,   431,   432,
     433,   135,   136,   137,   138,   139,   721,   434,   435,   436,
     437,   438,   722,   723,   439,   440,     0,   140,   442,   725,
     443,   444,   445,   446,   144,   726,   727,   447,   448,   449,
     450,   147,   451,   728,   729,   453,   454,   455,   456,   457,
     458,   730,   459,   460,   461,   150,   462,     0,   732,   733,
     734,   151,   735,   736,   737,   463,   464,   465,   466,     0,
     468,   154,   155,   469,   738,   470,   739,   471,   472,   473,
     474,   475,   740,   476,   477,   478,   741,   742,   479,   480,
     481,   482,   483,   743,   484,   485,   486,   744,   487,   488,
     745,   489,   490,   491,   492,   164,   493,   494,   166,   746,
     495,   747,   496,   168,   497,   748,   498,   749,   499,   169,
     750,   170,   500,   501,   502,   751,   503,   172,   752,   504,
     753,   505,   506,     0,   508,   509,   173,   510,   511,   512,
     754,   513,   514,   515,   516,   517,   518,   755,   519,   174,
     175,     0,   520,   521,   522,     0,   177,   758,   178,   759,
     523,   179,   180,   524,   181,   525,   526,   527,   528,   529,
     530,   760,   182,   183,   531,   184,   761,   532,   533,   534,
     762,   763,   535,   536,   537,   538,   539,   540,     0,   542,
     543,     0,   545,   546,   547,   189,   190,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,   764,   556,   557,
     194,   558,   765,   195,   559,   196,   560,   561,   562,   766,
     563,   767,   768,   564,   565,   566,   769,   770,   197,   198,
     199,   200,   201,   567,   568,   569,   570,   571,   572,   771,
     573,   202,   574,   203,   575,   576,   577,   772,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,   773,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     774,   598,   599,   211,   600,   601,   213,   602,   603,   604,
     605,   606,   607,     0,   609,   775,   610,   611,   612,   613,
     614,   776,   615,   217,   616,   617,   219,   618,   220,   777,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,   778,   630,   631,   779,   632,   633,   634,   635,
     636,   637,   780,   224,   225,     0,   782,   639,   226,   640,
     227,   783,   641,   642,   643,   644,   645,   646,     0,   785,
     647,   648,   649,   650,   786,   787,   651,   652,   653,   654,
       0,   235,   789,   656,   236,   657,   658,   659,   790,   791,
     660,   792,   793,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,     0,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,  1397,  4460,     0,    45,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,  1927,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,  1928,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,  1929,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,   638,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,  1111,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,  2126,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,  2274,
     443,   444,   445,   446,   144,     0,  2318,   447,   448,   449,
     450,     0,   451,   452,  2275,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,  2319,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,  2277,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,  2278,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,  2279,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,  2274,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,  2275,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,  2319,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,  2277,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,  3082,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,  2278,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,  2279,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,  1013,
     423,   424,   971,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,   972,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,  1014,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,   973,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,   974,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1907,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   971,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,   972,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,  2854,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,   973,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,   974,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,  2274,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,  2275,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,  2319,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,  2277,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,  2278,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,  2279,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   688,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,   689,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,   690,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   971,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,   972,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,   973,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,   974,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,   888,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   889,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   890,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,  1962,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,  1963,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,  1964,   499,     0,
       0,     0,  1965,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,  1966,  1967,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
    1968,   606,   607,   608,   609,     0,  1969,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,  1970,   632,  1971,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,   972,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,   973,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,   974,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   130,   131,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,  1325,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,  1951,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
    2236,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,  2744,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,  2745,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,  2746,   632,   633,  2747,   635,
    2748,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   697,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,   690,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   843,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,  1263,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,  2393,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,  2394,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,   130,   131,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,  2898,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,  2899,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,  2910,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,  2911,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   894,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   935,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,   416,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   989,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,  1044,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,  1503,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,  1859,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,  1951,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
    2236,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,  3119,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,  3132,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,  3174,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,  3886,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,  3888,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,  3890,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,  4046,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   997,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,   999,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,  1000,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1001,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1002,   225,     0,     0,  1003,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,  1038,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,  1000,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1039,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1040,   225,     0,     0,  1041,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,  1060,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,  1183,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,  1246,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1277,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1282,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1290,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1292,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1294,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1296,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1299,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1301,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,  1302,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1305,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,  1514,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,  1025,   440,  1000,   140,  1515,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,  1029,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,  1030,   601,   213,   602,   603,   604,
    1031,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1507,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1033,   225,     0,     0,  1034,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,  1035,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,  1537,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,     0,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,  1637,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1885,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  1887,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,  2001,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  2525,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  2901,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,  2903,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,   602,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,  1025,   440,  1000,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,  1029,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,  1030,   601,   213,   602,   603,   604,
    1031,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1507,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1033,   225,     0,     0,  1034,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,  1035,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,  1025,   440,  1000,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,  1029,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,  1030,   601,   213,   602,   603,   604,
    1031,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1507,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,  2265,   634,   635,
     636,   637,     0,  1033,   225,     0,     0,  1034,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,  1035,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,  1025,   440,  1000,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,     0,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,  1029,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,   571,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,   583,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,  1030,   601,   213,   602,   603,   604,
    2299,   606,   607,   608,   609,     0,   610,   611,   612,   613,
    1507,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,  1033,   225,     0,     0,  1034,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
    1004,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,  1035,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,   403,    90,    91,    92,   404,     0,   405,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   406,     0,     0,   107,   108,   109,   110,     0,     0,
     112,   113,   114,   115,     0,   116,     0,     0,   407,   408,
       0,     0,     0,   409,   410,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,   412,     0,
     413,     0,   414,   415,    35,     0,     0,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   417,   418,   419,   420,   421,   422,
     423,   424,     0,   425,   426,   427,     0,     0,     0,     0,
       0,     0,     0,   428,   429,     0,   430,     0,   431,   432,
     433,   135,   136,     0,   138,   139,     0,   434,   435,   436,
     437,   438,     0,     0,   439,   440,   441,   140,   442,     0,
     443,   444,   445,   446,   144,     0,     0,   447,   448,   449,
     450,     0,   451,   452,     0,   453,   454,   455,   456,   457,
     458,     0,   459,   460,   461,     0,   462,     0,     0,     0,
       0,     0,     0,     0,     0,   463,   464,   465,   466,   467,
     468,   154,   155,   469,     0,   470,     0,   471,   472,   473,
     474,   475,     0,   476,   477,   478,     0,     0,   479,   480,
     481,   482,   483,     0,   484,   485,   486,     0,   487,   488,
       0,   489,   490,   491,   492,   164,   493,   494,   166,     0,
     495,     0,   496,   168,   497,     0,   498,     0,   499,     0,
       0,     0,   500,   501,   502,     0,   503,   172,     0,   504,
       0,   505,   506,   507,   508,   509,     0,   510,   511,   512,
       0,   513,   514,   515,   516,   517,   518,     0,   519,     0,
     175,     0,   520,   521,   522,     0,   177,     0,   178,     0,
     523,     0,     0,   524,     0,   525,   526,   527,   528,   529,
     530,     0,   182,     0,   531,     0,     0,   532,   533,   534,
       0,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   189,     0,   191,   548,   549,
     550,   551,   552,   553,   554,   192,   555,     0,   556,   557,
       0,   558,     0,   195,   559,   196,   560,   561,   562,     0,
     563,     0,     0,   564,   565,   566,     0,     0,   197,     0,
       0,     0,   201,   567,   568,   569,   570,     0,   572,     0,
     573,   202,   574,   203,   575,   576,   577,     0,   578,   579,
     580,   581,   582,     0,   584,   205,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
       0,   598,   599,     0,   600,   601,   213,     0,   603,   604,
     605,   606,   607,   608,   609,     0,   610,   611,   612,   613,
     614,     0,   615,   217,   616,   617,     0,   618,   220,     0,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     222,   629,     0,   630,   631,     0,   632,   633,   634,   635,
     636,   637,     0,   224,   225,     0,     0,   639,   226,   640,
     227,     0,   641,   642,   643,   644,   645,   646,     0,     0,
     647,   648,   649,   650,     0,     0,   651,   652,   653,   654,
     655,   235,     0,   656,     0,   657,   658,   659,     0,     0,
     660,     0,     0,   661,   662,   663,   664,   665,   238,   239,
     240,   241,   242,   243,   244,   245,   666,   667,   668,    86,
      87,    88,     0,    90,    91,    92,     0,     0,     0,    95,
       0,     0,    98,    99,   100,   101,   102,   103,     0,   104,
     105,     0,     0,     0,   107,   108,   109,   110,     0,   111,
     112,   113,   114,   115, -2158,   116,   117,   118,     0,     0,
       0,     0,     0,   121,   122,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,   124,     0,
     125,     0,   126,   127,    35,     0,   398,     0,     0,     0,
       0,     0,    41,    42,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   133,     0,     0,
       0,   135,   136,   137,   138,   139,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,     0,     0,
       0,     0,     0,     0,   144,     0,     0,     0,     0,     0,
       0,   147,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   150,     0,     0,     0,     0,
       0,   151,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,   155,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   162,     0,
       0,     0,     0,     0,     0,   164,     0,     0,   166,     0,
       0,     0,     0,   168,     0,     0,     0,     0,     0,   169,
       0,   170,     0,     0,     0,     0,     0,   172,     0,     0,
       0,     0,     0,     0,     0,     0,   173,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,     0,     0,     0,     0,     0,   177,     0,   178,     0,
       0,   179,   180,     0,   181,     0,     0,     0,     0,     0,
       0,     0,   182,   183,     0,   184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,   191,     0,     0,
       0,     0,     0,     0,     0,   192,     0,     0,     0,     0,
     194,     0,     0,   195,     0,   196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   197,   198,
     199,   200,   201,     0,     0,     0,     0,     0,     0,     0,
       0,   202,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   205,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,     0,     0,   219,     0,   220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     222,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   224,   225,     0,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,     0,   230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   235,     0,     0,   236,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   238,   239,
     240,   241,   242,   243,   244,   245,    86,    87,    88,     0,
      90,    91,    92,     0,     0,     0,    95,     0,     0,    98,
      99,   100,   101,   102,   103,     0,   104,   105,     0,     0,
       0,   107,   108,   109,   110,     0,   111,   112,   113,   114,
     115, -2159,   116,   117,   118,     0,     0,     0,     0,     0,
     121,   122,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,   124,     0,   125,     0,   126,
     127,    35,     0,  1106,     0,     0,     0,     0,     0,    41,
      42,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   133,     0,     0,     0,   135,   136,
     137,   138,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   140,     0,     0,     0,     0,     0,
       0,   144,     0,     0,     0,     0,     0,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   150,     0,     0,     0,     0,     0,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   154,   155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   162,     0,     0,     0,     0,
       0,     0,   164,     0,     0,   166,     0,     0,     0,     0,
     168,     0,     0,     0,     0,     0,   169,     0,   170,     0,
       0,     0,     0,     0,   172,     0,     0,     0,     0,     0,
       0,     0,     0,   173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   174,   175,     0,     0,
       0,     0,     0,   177,     0,   178,     0,     0,   179,   180,
       0,   181,     0,     0,     0,     0,     0,     0,     0,   182,
     183,     0,   184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   189,   190,   191,     0,     0,     0,     0,     0,
       0,     0,   192,     0,     0,     0,     0,   194,     0,     0,
     195,     0,   196,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   197,   198,   199,   200,   201,
       0,     0,     0,     0,     0,     0,     0,     0,   202,     0,
     203,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   205,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,   213,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,     0,     0,   219,     0,   220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,     0,     0,     0,   226,     0,   227,     0,     0,
       0,     0,     0,     0,     0,   230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,     0,
       0,   236,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   238,   239,   240,   241,   242,
     243,   244,   245,    86,    87,    88,     0,    90,    91,    92,
       0,     0,     0,    95,     0,     0,    98,    99,   100,   101,
     102,   103,     0,   104,   105,     0,     0,     0,   107,   108,
     109,   110,     0,   111,   112,   113,   114,   115,     0,   116,
     117,   118,     0,     0,     0,     0,     0,   121,   122,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,   124,     0,   125,     0,   126,     0,    35,     0,
       0,     0,     0,     0,     0,     0,    41,    42,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   133,     0,     0,     0,   135,   136,   137,   138,   139,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   140,     0,     0,     0,     0,     0,     0,   144,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   150,
       0,     0,     0,     0,     0,   151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   162,     0,     0,     0,     0,     0,     0,   164,
       0,     0,   166,     0,     0,     0,     0,   168,     0,     0,
       0,     0,     0,   169,     0,   170,     0,     0,     0,     0,
       0,   172,     0,     0,     0,     0,     0,     0,     0,     0,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   174,   175,     0,     0,     0,     0,     0,
     177,     0,   178,     0,     0,   179,   180,     0,   181,     0,
       0,     0,     0,     0,     0,     0,   182,   183,     0,   184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   189,
     190,   191,     0,     0,     0,     0,     0,     0,     0,   192,
       0,     0,     0,     0,   194,     0,     0,   195,     0,   196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,   198,   199,   200,   201,     0,     0,     0,
       0,     0,     0,     0,     0,   202,     0,   203,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   205,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,     0,     0,
     213,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,     0,     0,
     219,     0,   220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   224,   225,     0,
       0,     0,   226,     0,   227,     0,     0,     0,     0,     0,
       0,     0,   230,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,     0,     0,   236,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   238,   239,   240,   241,   242,   243,   244,   245,
      86,    87,    88,     0,    90,    91,    92,     0,     0,     0,
      95,     0,     0,    98,    99,   100,   101,   102,   103,     0,
     104,   105,     0,     0,     0,   107,   108,   109,   110,     0,
     111,   112,   113,   114,   115,     0,   116,   117,   118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    35,     0,     0,     0,     0,
       0,     0,     0,    41,    42,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   133,     0,
       0,     0,   135,   136,   137,   138,   139,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   140,     0,
       0,     0,     0,     0,     0,   144,     0,     0,     0,     0,
       0,     0,   147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   150,     0,     0,     0,
       0,     0,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   154,   155,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   162,
       0,     0,     0,     0,     0,     0,   164,     0,     0,   166,
       0,     0,     0,     0,   168,     0,     0,     0,     0,     0,
     169,     0,   170,     0,     0,     0,     0,     0,   172,     0,
       0,     0,     0,     0,     0,     0,     0,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     174,   175,     0,     0,     0,     0,     0,   177,     0,   178,
       0,     0,   179,   180,     0,   181,     0,     0,     0,     0,
       0,     0,     0,   182,   183,     0,   184,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,   190,   191,     0,
       0,     0,     0,     0,     0,     0,   192,     0,     0,     0,
       0,   194,     0,     0,   195,     0,   196,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   197,
     198,   199,   200,   201,     0,     0,     0,     0,     0,     0,
       0,     0,   202,     0,   203,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   205,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,     0,     0,   213,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   217,     0,     0,   219,     0,   220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   225,     0,     0,     0,   226,
       0,   227,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   235,     0,     0,   236,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   238,
     239,   240,   241,   242,   243,   244,   245,    86,    87,    88,
       0,    90,    91,    92,     0,     0,     0,    95,     0,     0,
      98,    99,   100,   101,   102,   103,     0,   104,   105,     0,
       0,     0,   107,   108,   109,   110,     0,     0,   112,   113,
     114,   115,     0,   116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,     0,     0,     0,     0,     0,     0,
      41,    42,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   133,     0,     0,     0,   135,
     136,   137,   138,   139,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   140,     0,     0,     0,     0,
       0,     0,   144,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   150,     0,     0,     0,     0,     0,   151,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   154,
     155,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   164,     0,     0,   166,     0,     0,     0,
       0,   168,     0,     0,     0,     0,     0,   169,     0,   170,
       0,     0,     0,     0,     0,   172,     0,     0,     0,     0,
       0,     0,     0,     0,   173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   174,   175,     0,
       0,     0,     0,     0,   177,     0,   178,     0,     0,   179,
     180,     0,   181,     0,     0,     0,     0,     0,     0,     0,
     182,   183,     0,   184,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   189,   190,   191,     0,     0,     0,     0,
       0,     0,     0,   192,     0,     0,     0,     0,   194,     0,
       0,   195,     0,   196,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   197,   198,   199,   200,
     201,     0,     0,     0,     0,     0,     0,     0,     0,   202,
       0,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   205,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,     0,     0,   213,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   217,     0,     0,   219,     0,   220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,   225,     0,     0,     0,   226,     0,   227,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
       0,     0,   236,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   238,   239,   240,   241,
     242,   243,   244,   245
};

static const yytype_int16 yycheck[] =
{
       2,   246,    78,   826,    78,  1281,    78,    78,   167,   228,
     210,  1119,   351,  1288,  1027,   153,   973,   974,  1077,  1319,
     117,   978,  1329,   152,  1075,     2,  1379,  1174,    78,   188,
     864,  1656,   117,   117,    84,  1694,  1360,  1184,  1142,  1909,
    1678,   864,   149,    89,  1042,  1148,  1245,  1191,  1965,  1798,
     901,  1916,   165,  1446,   703,  1417,  1418,   171,  1814,  1684,
    1392,     2,   366,  1034,  2115,   162,   204,   117,  2621,    78,
     366,  1728,    94,  2894,  1436,  1734,  1735,   162,   162,  1226,
    1558,   915,  1534,  1833,  1231,  2311,  2312,    89,  3106,   132,
    2347,  1238,   915,   223,  1847,  1833,   210,  1589,  1590,  1591,
    1247,  2004,   232,    78,  1833,   704,  2961,  1222,  2963,    84,
     132,  1678,   162,  1833,  2509,  1833,  1833,   353,  2161,  1100,
    2427,   167,  2595,  1119,  3060,   209,  3381,   339,  1646,   940,
     152,   153,   216,   230,   218,  2514,  2515,  3026,   353,   148,
    3529,   163,   188,  3352,   160,   230,   230,  2520,  2756,   167,
     152,  1320,  1905,  1722,  2758,   816,   165,   159,  1273,   209,
     216,   822,  3582,  1463,  1684,  1342,   216,  2172,   218,  1311,
     188,  3060,  3768,  2210,  1870,  3556,  1157,  1584,  1585,  1030,
     230,  1153,   204,  1149,   186,    30,  1407,  1408,    10,    96,
    3592,  1643,   853,  2167,  1072,  3774,  2453,  1072,    14,   106,
      72,  1114,  1115,  3245,    21,    88,    72,   134,   108,    81,
    3560,  1432,  2249,  3609,    86,  3611,  2253,    88,  1184,   117,
      72,    37,    84,   120,   102,   127,   167,   147,  3040,  3041,
    3042,  3043,  3044,  3045,    86,   142,   112,   246,   810,   888,
     205,   127,   113,   932,   905,  2660,  2661,   188,    78,   156,
    2665,   912,   112,   181,   200,   154,    72,   188,   143,    75,
      76,    77,    78,  1220,   162,    81,    82,    83,    84,  4155,
      86,  2754,  2755,   127,   266,  2532,    88,  2534,    25,   233,
     174,   186,   358,   247,   358,  3923,   358,   358,    72,  2704,
    2705,    75,    76,    77,    78,   228,   210,    81,    82,   140,
     100,   113,    86,    78,  4052,   227,    93,   266,   356,    84,
     247,  2067,   117,   103,   104,    78,   366,    99,   229,   222,
     210,    99,  1320,    78,    75,    76,    77,    78,   106,    84,
      78,    82,   230,   432,   266,   364,    75,    76,    77,    78,
     227,   383,   117,    82,   353,  1759,   227,    72,  1329,   358,
     158,   401,    75,    76,    77,    78,   183,   162,   181,    82,
    1464,    86,   117,    75,    76,    77,    78,  4115,    22,   341,
      82,   401,  1206,   383,  1518,  1024,    78,   107,     8,    88,
     402,    11,    12,  1206,  1488,   227,     0,   162,  3777,    78,
     489,   366,    22,    23,    24,   461,    26,    27,   370,  2436,
      29,    31,    32,    33,   209,    99,   370,   162,  1801,   127,
     374,   216,   106,   218,    75,    76,    77,    78,    72,   330,
     450,    82,   134,   210,   232,   230,   401,  1789,  1790,    90,
      75,    76,    77,    78,  1796,   399,   226,    82,   228,  4148,
     450,  1855,   181,    75,    76,    77,    78,    81,   266,    14,
      82,   181,    86,  1304,   502,   230,    75,    76,    77,    78,
     502,   261,  4210,    82,    25,    75,    76,    77,    78,   372,
    4218,    90,    82,   502,   376,   230,   375,    99,  1568,    38,
      90,    40,  3418,  3504,   106,  1483,   327,   401,   227,  1765,
     376,    95,   319,   452,  1769,   373,   319,    75,    76,    77,
      78,  4139,   396,   414,    82,   469,   180,   385,   812,   638,
    3899,   401,    90,   505,  4110,   262,   812,  1116,  1117,   465,
    1331,   452,   376,   443,    99,  1523,  1524,  4135,   358,  3418,
     502,    75,    76,    77,    78,  1196,  1517,   502,    82,   401,
    1521,  1522,  1203,   419,   174,   450,    90,   432,   686,   687,
    4436,   505,  3941,    75,    76,    77,    78,  2306,   436,   419,
      82,   489,  3958,  3375,  1136,   347,  1787,  1788,   505,   502,
     145,  1718,   504,  1720,  1795,   502,  3926,   152,    75,    76,
      77,    78,  1781,   505,    85,    82,    75,    76,    77,    78,
     456,   366,  1253,    82,   198,   358,   383,    75,    76,    77,
      78,  2858,   502,   505,    82,   502,   505,   182,   149,  2061,
     358,   366,   134,  1757,   401,   498,   638,  3659,   505,   505,
    1309,   493,   494,  4219,   505,  2599,   401,   498,   406,   258,
    4209,  1778,  2289,  1957,   456,   452,   638,    75,    76,    77,
      78,   493,   494,   425,    82,   427,   401,  1762,  4357,   190,
     502,   505,  3135,  2105,  4043,   500,   358,  2109,   376,  2885,
     502,  2887,  4051,  1514,   686,   687,    72,  4275,   328,   358,
     300,   461,   227,  2311,   149,    81,   251,   493,   494,   496,
      86,   703,  1663,   495,   496,   497,   498,   505,  1669,   818,
    1603,  2998,   127,   432,  3001,  3002,   941,  1575,  3005,  3511,
    1575,   262,   832,  2003,  2004,  1677,  3310,  3315,  3015,   460,
     494,   808,   406,  1816,  2014,   190,   175,  2017,  2769,  2693,
     350,  1320,  4318,   808,   808,  2025,  2026,  3122,   857,  1710,
     942,  3126,  1713,  1714,  4048,  4049,  1075,   341,  2038,  2039,
     227,  1707,   469,  4124,  2262,  2782,  3003,  3004,   460,  2049,
     489,   502,   890,  1922,  4156,   314,   151,   230,   808,   489,
     434,  1938,   812,   229,  4102,   504,   896,  1944,   493,   494,
     500,  1913,   502,   503,   504,   505,    14,   500,   505,   502,
     909,   504,  2787,  4379,   406,  1766,   495,   496,   497,   498,
     502,   250,   951,  4401,   953,   399,   955,   471,  2318,   270,
    3026,   342,   961,   181,  2211,    95,  2213,   186,  2029,  2030,
     270,   441,  3227,  2509,   235,  3230,  3231,  3232,  3233,  3234,
    3235,  3236,  3237,  3238,  3239,   470,   985,   986,   941,   330,
     937,   847,   266,   149,  3060,   198,   231,   812,   470,   414,
     500,   502,   381,   488,   504,   229,   848,  3868,  3869,  3870,
    3871,  3872,   118,   266,   984,   250,   488,   502,  4454,    85,
    2498,   114,    88,   266,   334,  4285,   888,   342,   890,  1703,
     502,   306,  3287,  3288,   190,   266,    99,   432,  3104,   105,
    1703,   260,   135,   502,   324,   426,    75,    76,    77,    78,
     361,   286,   502,    82,   186,  1852,   218,   158,   324,   901,
     902,   361,   327,  4241,   306,   951,   198,   953,   198,   955,
     808,   158,   451,   935,   328,   961,   306,   939,  1048,   385,
    2489,   394,  1920,  3941,   502,   228,    75,    76,    77,    78,
     932,   940,   941,    82,   489,   953,   314,   955,   333,   985,
     986,   376,   230,  1056,  1028,   432,   330,  2037,  1032,   504,
     423,   426,  4207,   231,  2058,   932,  1969,  1970,   502,   174,
     381,   283,   421,   422,   399,   181,   181,   985,   986,  4358,
     193,   232,  1028,  3346,   440,    88,  1032,   243,  1028,   176,
     502,   247,  1032,  1026,   149,   232,   176,   989,   489,   490,
     491,   932,   493,   494,   495,   496,   497,   498,  4312,  1049,
     113,   181,  1024,   808,  1026,   502,  4215,  4216,   286,   387,
     951,   374,   953,   502,   955,  1017,   282,  2773,   452,   334,
     961,   962,   963,  1025,   502,   190,   342,  1029,  1030,  1031,
     425,   938,   427,   808,   505,   505,   399,   812,   174,   452,
     343,   436,   268,   240,   985,   986,   953,  3902,   955,   452,
     240,   446,   183,   808,  1100,  1889,  2752,   812,   965,   351,
     439,   452,   502,   469,   502,   455,  1889,   176,  1114,  1115,
     329,   450,   506,  1119,  1049,   221,   502,   502,   985,   986,
     370,   136,   484,  2445,   186,    71,    72,   493,   494,    75,
      76,    77,    78,    79,    80,    81,    82,   393,   295,   314,
      86,   404,   176,   136,   330,   295,   394,  3522,   298,   341,
     426,  1157,  1114,  1115,  1925,   500,   377,  1119,   151,   504,
     185,  3729,   111,  1100,   231,  4061,   422,   109,   393,  3733,
     377,   240,   332,  3741,   314,   423,   136,   403,   370,  3743,
    2248,   341,  1119,    75,    76,    77,    78,   425,   295,   427,
      82,  2149,   151,   208,  3461,   268,   269,   422,   260,  1100,
    3467,  3468,  3469,  3470,  3471,  3472,   240,   463,  4377,   224,
     306,   295,  4061,  3646,   298,   208,   392,   342,  1119,   286,
    1157,   181,   181,   314,    25,   463,   295,  2386,   503,   298,
     505,   224,  3418,   390,    35,   181,   411,    99,   463,   414,
     390,  2035,   267,   349,   317,  3600,   422,   189,   469,  1870,
    3605,  1872,  2035,  3608,   473,  2872,  1157,  3596,  1463,  1221,
    1881,   295,   469,  1028,   298,    72,   227,  1032,    75,    76,
      77,    78,   120,   120,    81,    82,    83,    84,    95,    86,
    1256,   457,   503,   390,   954,   506,  2884,  2228,   958,   959,
     960,  2527,  2248,   469,  3171,   240,   503,   246,   968,   506,
    2535,   426,   462,   489,   490,   491,   390,   493,   494,   495,
     496,   497,   498,   173,  1049,  2474,  2475,  2476,  2477,   265,
     334,   390,   422,  1329,   172,   172,   502,   502,  3703,  3704,
     392,   193,   133,   483,  1049,   185,  1368,    95,  3201,   354,
     286,  3344,  1304,   101,  1965,    85,  1308,  1309,    88,  1311,
     295,  2789,  3062,   502,   314,   314,   390,  2884,   425,   319,
     427,   354,  1331,  1922,  3062,  1561,  1562,  1329,  1564,  1633,
    2630,  1308,  1309,  3062,  1311,  1547,  2788,  1633,  4410,   219,
    4358,   198,  3062,   266,  3062,  3062,  1561,  1562,   450,  1564,
     353,    51,  1329,   502,   354,   361,  1378,   341,   372,  1368,
     209,  3618,   193,  3620,   195,   183,   366,  1308,  1309,    69,
    1311,   259,   259,  1375,   483,   306,   469,   267,  2678,  2360,
     493,   494,   495,   496,   497,   498,   370,  2368,  1329,  2370,
     374,   446,  1401,   502,   294,   401,   296,    88,  4253,   248,
     198,   332,  4474,  3156,   207,   390,  2521,  2707,   314,   483,
     341,  1420,   505,   446,  2518,   399,  4020,  4021,   306,   306,
     227,   262,   113,  1224,  3977,   305,  3122,  1334,   502,  1336,
    3126,   434,  1339,  3092,  1341,  1532,   254,  1344,  1345,  1346,
     247,  1450,  2742,  4264,   450,   162,   446,  1532,  1532,   503,
    1357,   505,   432,   359,  1463,   469,   218,  1500,  1501,   266,
     222,   264,   128,  1465,  1371,   218,  1373,   247,   471,   222,
     136,  1517,   193,  1475,   195,  1521,  1522,   227,  1500,  1501,
     412,   413,  1532,  1485,   341,  4038,  1583,  4040,   268,    88,
     153,   505,   222,   324,   340,   432,   314,   247,  2354,  1583,
     388,   388,   232,    75,    76,    77,    78,   493,   494,   227,
      82,   228,  1514,   370,   385,  1517,   266,   247,   385,  1521,
    1522,   283,   341,   353,   455,   505,  3833,  3834,  2890,   247,
     283,   334,   195,  1583,  1584,  1585,   434,   162,  2862,   256,
    1517,  3033,  2398,   341,  1521,  1522,   228,   218,   266,  1646,
     330,   370,  1561,  1562,   271,  1564,   184,  1603,  1601,   268,
    3955,  1646,  1646,   280,   326,   436,  1650,  3982,   505,   436,
    2660,  2661,   370,   326,   256,  2665,  1517,   268,  1379,  1601,
    1521,  1522,    85,  1633,   370,    88,   303,  1671,   374,   271,
    1640,  4006,  4007,   314,  2243,    88,  1646,  4201,   280,    85,
    1650,  1603,    88,   324,   434,   230,   184,  2588,   385,  1584,
    1585,   328,   283,   399,  2704,  2705,   244,  1663,  1595,   328,
     286,  1671,  1332,  1669,   452,  1335,   383,   113,  1338,  1688,
    1340,   341,   118,  1343,  1532,   184,    85,  1347,   425,    88,
     427,   471,   445,  1620,  1621,   452,   493,   494,    14,   379,
    2501,   434,  1593,   410,  1595,   326,   105,   469,  1633,   436,
     370,   227,  1746,   380,  1710,  1640,   244,  1713,  1714,   268,
    1729,    37,  1613,   502,   502,    75,    76,    77,    78,  1620,
    1621,   247,    82,   469,  3136,    97,  1663,   374,   471,  3385,
     341,   173,  1669,   505,  3745,   244,  1746,  2548,   380,   506,
     266,   273,   452,   387,   116,    85,    72,  2037,    88,   489,
     490,   491,   399,   493,   494,   495,   496,   497,   498,   370,
    1766,   505,  1663,   341,  1726,   509,   341,  1532,  1669,   361,
    3182,  1828,  1977,  1710,   452,   452,  1713,  1714,   229,   371,
     424,    14,   186,  1828,  1828,  3404,  3405,  3071,  1646,    89,
    1879,  1831,   370,  3509,   227,   370,   506,  1532,   470,   374,
     222,   247,  4177,   395,    37,   268,   257,  2097,  1848,  1710,
     252,  4078,  1713,  1714,   247,   268,   488,  1532,  1828,  2882,
     242,   399,   268,   269,   399,   469,   470,   387,   506,  1766,
     502,   341,  2805,  2774,    75,    76,    77,    78,  1998,  3456,
    2771,    82,   493,   494,   495,   496,   497,   498,  1583,  1584,
    1585,   506,   294,  1926,   296,  3267,   260,   392,   502,   268,
     370,    88,   505,  4376,   424,  1766,   360,   330,  1583,  1584,
    1585,   317,  1834,   222,   470,  4061,    75,    76,    77,    78,
    1641,  1646,   506,    82,   330,  1650,   113,   422,  2509,   399,
     384,  1981,   488,   242,   469,  2159,  3249,  3250,  1633,   143,
     508,  1870,  3194,  2159,  4121,  1640,  1671,   151,    71,   469,
     470,  1646,    75,    76,    77,    78,    79,    80,  1633,    82,
     500,   330,   457,  1997,  3222,  1640,   452,   507,   268,    72,
    2724,  1646,  3757,    41,   493,   494,   495,   496,   497,   498,
    1701,  2724,   502,    86,  3600,     5,   452,   489,  3246,  3605,
     470,  1913,  3608,  1989,  1916,  1989,  1925,  1989,  1989,   319,
     209,  1862,   504,  2572,  4150,    25,   328,   502,   488,   218,
    1828,   333,  3285,   150,  3559,    35,  1913,  3575,    71,  1916,
     506,  1746,   502,    71,    72,  3701,    79,    80,   392,  3698,
     330,    75,    76,    77,    78,   328,  3256,   500,    82,   193,
     333,   195,  1763,   506,    75,    76,    77,    78,  1977,   133,
     134,    82,  1913,   176,  2071,  1916,  2799,   262,   422,  1780,
    1989,   128,   216,    16,   505,   202,  2071,  2071,   509,   356,
     493,   494,   495,   496,   497,   498,   495,   496,   497,   146,
     493,   494,   495,   496,   497,   498,   450,   493,   494,   495,
     496,   497,   498,   457,   161,   325,   503,   387,   328,   506,
    2022,  2071,  1823,  1828,   174,   469,  2185,   193,  1935,   195,
    1937,   505,   506,   133,  1941,  3397,  1943,   240,   319,  1946,
     489,   490,   491,  1950,   493,   494,   495,   496,   497,   498,
     216,   469,   470,  1828,   424,  1176,  2169,  1178,   502,   276,
     277,   323,  3386,  3387,  1185,   212,  2075,   383,   384,  2269,
     181,  2271,   289,  1828,  2015,  2016,   186,  1878,   389,   501,
     314,   424,  2023,   505,   501,   319,  2027,  2028,   505,   497,
     324,  2752,   295,   120,   502,   298,   504,   197,   337,   469,
     470,  2042,   273,  2044,  3061,    75,    76,    77,    78,  2159,
     490,   491,    82,   493,   494,   495,   496,   497,   498,   425,
      34,   427,    95,  2064,   341,  2066,   469,   470,   101,   383,
     384,  2133,   502,   505,   506,  2264,   163,  3227,   432,  2185,
    3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,
     260,  3480,  3481,   319,   502,  3484,     7,  3486,   324,   502,
     187,  2211,   262,  2213,   436,  2262,  2175,   140,    19,    20,
    3477,   174,   503,  2071,  2115,   506,   372,  2262,  2262,   206,
    1383,  1384,  2228,  4100,  2159,  3183,  2232,   390,    39,  2052,
     389,    42,  2055,  3337,   497,   319,   223,  3287,  3288,   502,
     155,   504,  2248,  3026,   438,   315,   316,   424,   503,   426,
     505,   238,  2262,   447,    85,  2806,  2807,    88,   191,   250,
     500,  2243,   502,  2352,   504,   198,   469,   470,   201,   500,
    2232,   502,    75,    76,    77,    78,  2211,  3060,  2213,    82,
      72,  2338,   113,    86,  2185,   242,  2248,   118,  2250,    85,
    2252,  2228,  3103,  2338,  2338,   507,  3307,  3308,   503,  3955,
     505,   162,   174,   207,  2509,   273,  2071,    85,  2069,   124,
      88,  2248,   438,  2250,   218,  2252,  2373,  4033,   222,   252,
     483,   447,   392,  2677,   389,  2679,  2680,  2228,  2338,  2373,
    3393,   503,   319,   505,   486,   487,  2071,  2299,    85,   508,
     327,    88,  3940,   154,   502,   502,   504,  2248,   108,  2250,
     328,  2252,   422,   503,  2360,   505,  2071,   503,   105,   505,
     264,    86,  2368,  2373,  2370,   186,   126,   228,   469,   470,
    2660,  2661,   359,   306,   503,  2665,   505,   502,   181,   283,
     450,    85,   505,   194,    88,   124,   485,   457,  4044,   503,
     503,   505,   505,  2460,   114,   256,  3709,   157,   504,   469,
    4230,   105,  4232,   503,  2262,   505,   392,   503,   341,   505,
     271,   503,   243,   505,  2704,  2705,   247,   270,   503,   280,
     505,   331,   326,  2360,  2159,  3584,   331,   502,  3688,   504,
     334,  2368,   502,  2370,   328,   432,   422,   268,   269,   260,
     328,   374,   303,   485,  2159,    75,    76,    77,    78,   114,
     485,   282,    82,   270,   214,    71,    72,  2419,   503,  2360,
     505,   331,  2761,    79,    80,  2427,   399,  2368,   495,  2370,
      86,   457,  3522,   503,   399,   505,  2211,   503,  2213,   505,
    2338,   226,   503,   469,   505,   245,   317,   503,   505,   505,
     268,   503,  4148,   505,   502,   316,  2211,  2262,  2213,   330,
     503,  3122,  2707,   503,   503,  3126,   505,    75,    76,    77,
      78,  2473,   124,   273,    82,  2373,   502,   506,   503,   380,
     505,   268,   503,   823,   505,   495,   125,  2262,   828,   503,
     503,   505,   505,  2495,   103,   104,  3477,   837,   262,  2501,
    2509,   445,  2443,   425,   425,   427,   427,  2262,  4133,   508,
    3171,   181,   330,   493,   494,   495,   496,   497,   503,   508,
     505,  2322,   862,   503,   268,   503,   866,   505,  2747,  2748,
    3854,   392,   403,  2338,   173,   503,   876,   505,   432,   503,
    3847,   505,  2588,   330,   432,   503,  2548,   505,   432,   158,
    2572,    75,    76,    77,    78,   503,   500,   505,    82,   503,
     504,   422,   503,  2338,   505,   503,   502,   505,  2373,   432,
     503,   180,   505,   181,   374,   204,    85,   186,   378,    88,
     503,   108,   505,  2338,   384,   503,   330,   505,  2685,   450,
     503,   391,   505,  2690,   432,  3418,   457,   262,  2373,   399,
    2685,  2685,   211,   124,   113,  2690,  2690,   407,   469,   118,
     249,  2588,   432,  3703,  3704,   415,   502,   268,  2373,   490,
     491,   504,   493,   494,   495,   496,   497,   498,   503,   503,
     505,   505,  1069,  3986,  1071,  2685,  2437,   503,   472,   505,
    2690,   502,   502,     2,   503,   222,   505,  2588,  4286,   502,
     504,   260,   913,   328,  3635,   294,   917,   296,   503,   506,
     505,  4357,   281,   503,   464,   505,   927,   306,   468,   469,
    3774,   489,   490,   491,   452,   493,   494,   495,   496,   497,
     498,   493,   494,   495,   496,   497,   503,   328,   505,   501,
    3749,  3127,   503,  3129,   505,  3842,   502,   206,  2707,   323,
     389,   340,   489,   490,   491,   273,   493,   494,   495,   496,
     497,   498,  2721,    75,    76,    77,    78,  4017,   502,    78,
      82,   503,   136,   505,  3385,    84,   469,   503,  2774,   505,
     503,  2740,   505,   158,   243,   503,   375,   505,   247,   108,
     503,  4400,   505,  2752,   472,   489,   490,   491,   502,   493,
     494,   495,   496,   497,   498,   180,   114,   114,   117,   268,
     269,   186,   503,   441,   505,  4089,   503,   503,   505,   505,
     409,   341,  2774,   282,  1114,  1115,   222,    75,    76,    77,
      78,   148,   357,   392,    82,   507,   211,  2685,    75,    76,
      77,    78,  2690,   152,   503,    82,   505,  2774,    75,    76,
      77,    78,   503,   162,   505,    82,   452,   503,   317,   505,
    2611,   212,   503,   422,   505,   207,   503,   503,   505,   505,
     503,   330,   505,   212,   212,  4178,   218,   503,  2769,   505,
     222,  2772,   503,  2774,   505,   260,   503,   503,   505,   505,
     503,   450,   505,   136,   502,   472,   212,   212,   457,   212,
     209,   505,   461,   328,   328,   422,   212,   216,   151,   218,
     469,   212,   212,   212,  2961,  2962,  2963,   212,   212,   212,
    4223,   230,   264,   108,  4227,  4228,   502,  2961,  2962,  2963,
    2685,   223,  4182,   281,   222,  2690,   222,   502,   181,   502,
     183,   283,  3982,   502,   403,   502,   502,  3227,   502,   350,
    3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,
    2685,  2961,  2962,  2963,   502,  2690,  4006,  4007,  3752,   502,
     502,   502,   502,   502,  3021,   338,   502,   505,   502,  3752,
    2685,   502,  4239,   502,   326,  2690,  3021,  3021,   502,  3600,
     502,  3079,   334,  3900,  3605,  2947,   502,  3608,  4224,   502,
    4225,   502,   502,   502,   502,   502,   502,  3287,  3288,   502,
     108,   254,  3059,   164,   266,  2967,   281,   392,   268,   108,
     222,  3021,   326,   222,  3059,  3059,   495,  3115,   262,   390,
    3026,   298,   505,  3112,   493,   494,   495,   496,   497,   498,
     180,   451,   505,   489,    14,   505,  2998,   422,   502,  3001,
    3002,   502,   502,  3005,   432,   432,  4306,   366,  3080,  3059,
     504,   432,   432,  3015,  3060,   432,   328,   391,  3020,   451,
     432,   314,   432,  3095,  3026,   450,   319,   319,  1289,   432,
    3032,   143,   457,   328,   252,   432,   432,   502,   505,   175,
     341,   432,   401,  3115,   469,   452,   452,   341,   432,  3026,
    3295,   432,   124,   445,   124,   432,   432,  3079,  3060,   502,
     332,   354,   432,  2961,  2962,  2963,   387,   328,   432,   328,
     268,  3080,  3074,   366,   469,   460,   502,   502,  3297,  3298,
    3299,  3300,   108,  3060,   432,  3026,  3095,  4177,   107,    97,
    3031,  3032,   432,  3115,   502,   432,   181,   432,   502,   452,
    3102,  3103,   463,   289,  1365,   126,  3115,   462,  3180,   108,
     108,   222,  3053,  3122,   273,   502,   212,  3126,   504,  3060,
    1381,   388,   452,  3021,   212,  4138,   452,  2928,   212,  2930,
     212,    14,  1393,   466,   505,   323,   157,   457,   377,   318,
    1295,   108,   432,   465,   227,   430,   485,   300,  4424,  4200,
     502,  1306,    88,   446,   300,   399,  2961,  2962,  2963,   126,
     430,  3059,   227,  3260,   505,   489,   432,   241,   502,   434,
     502,  3180,   241,   489,   505,  3260,  3260,   505,   503,   329,
     324,    34,   505,   264,   503,   503,  2961,  2962,  2963,    10,
     157,   505,  3522,   214,   503,   432,   432,   150,  2999,   502,
     387,   452,   387,   502,   272,   272,  2961,  2962,  2963,   319,
    3260,  4045,   319,   319,   328,   335,  3021,   432,   327,   505,
     432,   370,  4045,   370,   245,   370,   396,   432,   361,   432,
     268,  4065,   108,   268,   268,   452,   452,   268,  4061,   268,
     327,   489,  4065,    95,   502,   107,  3021,   214,   432,   101,
      98,   432,   222,   500,  3059,   500,   489,   211,   224,   502,
     324,   396,   108,  1603,   496,   328,  3021,   328,   239,  3271,
     239,   222,  3431,  3612,   505,   502,  3077,   108,   245,   638,
     212,   328,   130,   328,  3059,   222,  3295,   247,   140,   502,
    3091,   396,   247,  1554,  3955,   143,   472,   247,   505,    96,
     233,   297,   124,   151,  3059,   328,   273,   155,   505,   503,
     503,   503,  3314,   227,   503,   227,   432,   485,   485,   502,
    3417,   503,  3419,   503,   466,   503,  4434,   175,   503,   503,
     503,    95,  3417,  3417,  3419,  3419,   505,   101,   503,   191,
    3141,   503,   503,   503,   502,  3442,   198,   503,   196,   201,
     337,   503,    90,   374,    90,   376,   283,   378,  3442,   489,
    4317,   455,  3260,   384,   328,   506,   331,  3417,   505,  3419,
     391,  4479,  3418,  3703,  3704,   503,   140,   503,   399,  4487,
     505,   229,   328,  4044,   502,  3431,   407,   502,   432,   502,
     258,   319,  3442,   212,   415,   212,   283,   345,   345,   449,
     252,   292,   250,  4064,  1744,   432,  3207,   374,   292,   268,
     292,   378,   268,   268,   432,   432,  3418,   384,   432,   432,
     432,  3362,   432,   432,   391,  3226,   274,   191,   268,   268,
    3432,  3477,   399,  3435,   198,  3437,   268,   201,   268,  4100,
     407,  3418,   500,   464,   503,   283,   503,   298,   415,   808,
    3251,   332,   489,   812,   306,  3260,   441,   816,   174,  3461,
     502,   372,   503,   822,   327,  3467,  3468,  3469,  3470,  3471,
    3472,   328,   505,   432,   236,  3477,   271,  3418,   503,   271,
    4314,   222,   330,   324,  3285,  3260,   502,  4148,   252,   341,
    3431,  4314,  1832,   336,   853,   502,   452,   464,   126,   387,
    3477,   468,  3504,   452,   505,  3260,   331,  1847,   387,   357,
     387,  3513,  3514,  3515,  3516,  3492,   210,   210,   370,  3417,
     500,  3419,   374,   204,   227,    88,   222,   503,   503,   157,
     503,   462,   134,   381,   502,   894,  3477,   385,   227,   387,
     503,   503,   306,   235,  3442,   393,   905,   399,   505,   489,
    3491,  3492,   329,   912,   489,   489,   222,  3629,   503,  3500,
     503,   502,   432,  3504,   503,  1905,  3766,   258,   441,   441,
    3572,   432,  3513,   932,   422,   222,   424,   341,   432,   503,
     428,   503,   432,   503,   268,   268,   214,   502,   436,  3635,
     272,  3600,   501,   441,   469,   502,  3605,   108,   472,  3608,
     505,   222,  3761,   503,   505,   469,   370,   253,   146,   424,
     374,   469,  3417,   817,  3419,   463,   820,   245,   432,   505,
    3629,    85,  1883,   271,   502,   396,   232,   227,  3787,   227,
     467,  1892,   836,   502,   467,   399,   502,  3442,   503,   124,
     237,   432,  3417,  1904,  3419,   505,   227,   441,   319,   469,
     319,   212,  3982,   489,   503,   859,   503,   502,  3635,   503,
     268,   503,  3417,  1022,  3419,   188,   319,  3442,   503,  1028,
     874,   505,   254,  1032,   183,   501,  4006,  4007,   505,   229,
     227,   199,   452,   452,   465,   469,   502,  3442,   227,  4350,
    1049,   502,   502,   255,  3635,   331,  4357,   227,   502,  1058,
     502,   456,  1963,   408,   503,  1966,   344,  1968,   468,   328,
    1971,   366,   452,   341,   503,  3761,   503,  3876,  1873,   469,
     503,   222,  4383,   150,   502,   108,   502,  1882,   319,   293,
     250,   211,   159,   160,   161,  1890,  1891,   502,   174,  3540,
     332,  3787,   370,  3745,  3746,   384,   374,   384,  3845,   136,
     378,   331,   136,  1908,   489,  3757,   384,   124,   334,   502,
    3845,  3845,   222,   391,    71,   424,   217,    85,  3745,   328,
     358,   399,    79,    80,   331,   331,   203,   194,    85,   407,
    3757,    88,   456,   505,   108,   227,   466,   415,   505,   364,
     469,   199,   328,   328,   108,  3845,   469,   503,   105,   503,
     502,   108,   502,   502,  3745,  3902,   113,   186,   450,   383,
     383,   118,    94,   105,   211,   358,  3757,   502,  3902,  2459,
    3761,   358,  4483,  1747,  1522,   252,  2774,  2344,  2895,  3417,
    3876,  3833,  3834,  3020,  3906,  4081,   464,  1196,  3845,  4239,
    4133,  3563,  3893,  4137,  1203,  3847,  3787,  4177,  2857,  3851,
    3852,  2577,  3902,  3855,  3856,  4381,  4044,  3798,  3799,  4423,
    4344,  4343,  3803,  3804,   291,  1224,  3868,  3869,  3870,  3871,
    3872,  4390,  3565,  1849,  2289,  4157,  3442,  2962,  1835,  2447,
     307,   308,   309,   310,   311,  3073,   313,  4426,  3862,  4487,
    4479,  3861,  2232,  3059,  1253,  3025,  4397,  3906,  4067,  1826,
    4325,   188,  4070,  1366,  3638,  4206,  3573,  2312,  3709,  3575,
    3912,  4286,   902,  4406,  4481,  4122,  1043,  2170,   345,  2259,
    2169,  1926,  3557,  2263,  3181,  2785,  2560,  3868,  3869,  3870,
    3871,  3872,    95,  1553,  2796,  3876,   243,  3939,   101,  1322,
     247,  1060,  2205,  1571,  2808,  2285,  3955,  3845,  1570,  1308,
    1309,  2802,  1311,  2293,  2204,  1159,  1160,  1573,  2188,  2752,
    1319,   268,   269,  3956,  2509,  3128,   896,  2162,  1048,   108,
    2786,  3554,  3270,  3262,  4180,   282,  2316,   140,  4370,  4374,
    4371,  2721,  2799,  2632,  2719,  3112,  2600,   126,  2100,  3790,
    2502,   418,  1260,   638,  1864,  2232,  2336,  4364,  1585,  3800,
    2208,   367,  2248,  2158,  3902,   934,  1579,   314,  1137,  1117,
     317,  2240,  2768,  2353,  1218,  4061,  2356,   444,   157,  1117,
    1379,  2241,  3365,   330,   451,  3744,   333,   454,   191,  3366,
    1234,  1235,  1378,  1497,  2374,   198,  3342,   400,   201,  1583,
    3845,  2381,  2252,  2573,  1955,  1308,  1405,  1251,     2,    -1,
    2390,  4028,    -1,    -1,   964,    -1,  2317,  2397,    -1,  4061,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3845,    -1,    -1,    -1,  1433,   214,  4078,    -1,    -1,    -1,
    4082,  1285,  1286,    -1,  4061,    -1,    -1,  4028,    -1,   252,
    3845,    -1,    -1,    -1,    -1,    85,   403,  3902,    88,    -1,
      -1,  1460,  1461,    -1,  1463,    -1,   245,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1476,    -1,    -1,
    4061,  1480,    -1,   113,    -1,    -1,    -1,  3902,   118,    -1,
      -1,    -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   306,    -1,    -1,    -1,  3902,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4253,    -1,  1517,  3960,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4253,
      -1,    -1,  1531,  1532,    -1,    -1,    -1,    -1,   341,    -1,
      -1,    -1,   489,   490,   491,  3986,   493,   494,   495,   496,
     497,   498,    -1,  4438,    -1,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    88,  4253,  1563,    -1,    -1,   370,  1567,  1568,
      -1,   374,    -1,    -1,    -1,    -1,   206,    -1,    -1,   105,
      -1,    -1,    -1,    -1,  1583,  1584,  1585,   113,    -1,    -1,
      -1,    -1,   118,    -1,    -1,   374,   399,  4239,    -1,   378,
      -1,    -1,    -1,    -1,  4290,   384,    -1,    -1,    -1,    -1,
      -1,    -1,   391,   243,    -1,    -1,    -1,   247,    -1,    -1,
     399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,
      -1,    -1,    -1,    -1,  1633,    -1,   415,    -1,   268,   269,
      -1,  1640,  1641,    -1,    -1,    -1,    -1,  1646,    -1,    -1,
      -1,  1650,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1671,    -1,    -1,    -1,    -1,    -1,    -1,  1678,
      -1,    -1,    -1,  2584,    -1,   464,    -1,   317,    -1,   468,
    4406,    -1,  4406,    -1,  4406,  4406,    -1,    -1,    -1,    -1,
     330,    -1,  1701,    -1,    -1,    -1,    -1,    -1,    -1,  4290,
      -1,    -1,    -1,    -1,    -1,  4253,    -1,   243,    -1,    -1,
      -1,   247,  4438,    -1,  4438,    -1,  4438,  4438,    -1,    -1,
      -1,  2526,    -1,    -1,    -1,    -1,    -1,  4178,    -1,    -1,
      -1,    -1,   268,   269,    -1,  2540,  2541,  1746,    -1,  2544,
      -1,    -1,    -1,    -1,    -1,  2550,   282,  4406,    -1,    -1,
      -1,    -1,    -1,    -1,  1763,  4481,    -1,  4481,    -1,  4481,
    4481,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1780,  4223,    -1,    -1,    -1,  4227,  4228,   314,  4438,
      -1,   317,  4434,    -1,    -1,    -1,    -1,    -1,    -1,  1798,
      -1,    -1,    -1,    -1,   330,    -1,    -1,   333,  4253,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4434,    -1,    -1,
      -1,    -1,    -1,    -1,  1823,    -1,    -1,    -1,  2623,  1828,
      -1,    -1,  4481,    -1,    -1,    -1,    -1,  4479,  4253,    -1,
      -1,    -1,    -1,    -1,    -1,  4487,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4434,    -1,    -1,    -1,    -1,  4253,  2839,
      -1,    -1,  4479,   493,   494,   495,   496,   497,   498,    -1,
    4487,  1870,    -1,  1872,    -1,    -1,    -1,   403,    -1,  1878,
      -1,    -1,  1881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1736,  1737,  1738,  1739,    -1,    -1,  4479,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4487,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1913,    -1,    -1,  1916,    -1,    -1,
      -1,    -1,    -1,  1767,  1768,    -1,    -1,    -1,    -1,  1773,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2924,    -1,    -1,    -1,    -1,  2850,
    2851,  2931,  2853,    -1,    -1,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    88,   489,   490,   491,  1965,   493,   494,   495,
     496,   497,   498,    -1,    -1,   501,    -1,    -1,    -1,   105,
      -1,   507,    -1,    -1,    -1,    -1,    85,   113,    -1,    88,
      -1,    -1,   118,    -1,  1838,  1839,  1840,  1841,    -1,    -1,
      -1,    -1,    -1,    -1,  2003,  2004,   105,    -1,    -1,    -1,
      -1,    -1,  2011,  2993,   113,  2014,    -1,    -1,  2017,   118,
      -1,    -1,    -1,  2022,    -1,    -1,  2025,  2026,    -1,    -1,
      -1,    -1,    -1,    -1,  2033,    -1,    -1,  2036,  2037,  2038,
    2039,    85,    -1,    -1,    88,    -1,    -1,  2046,  2047,  2950,
    2049,    -1,  2051,    -1,    -1,  2054,    -1,    -1,    -1,    -1,
      -1,   105,    -1,    -1,    -1,    -1,  1910,    -1,  2863,   113,
    2069,  2070,  2071,    -1,   118,  2074,    -1,    -1,    -1,  2078,
      -1,    -1,    -1,  2082,    -1,  2084,  2085,  2086,  2087,  2088,
    2089,  2090,  2091,  2092,    -1,  2094,    85,    -1,    -1,    88,
      -1,  2100,    -1,    -1,  2103,    -1,    -1,  2902,    -1,  2904,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   243,    -1,    -1,
      -1,   247,    -1,    -1,   113,    -1,    -1,    -1,    -1,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   268,   269,   243,    -1,    -1,    -1,   247,  3050,
      -1,  3052,    -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,
    2159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,
     269,    -1,    -1,  2172,    -1,    -1,  3156,    -1,    -1,    -1,
      -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,   314,    -1,
      -1,   317,    -1,    -1,  3174,    -1,    -1,    -1,    -1,   243,
      -1,    -1,    -1,   247,   330,    -1,    -1,   333,    -1,    -1,
      -1,    -1,  2211,    -1,  2213,   314,  3196,    -1,   317,    -1,
      -1,    -1,    -1,    -1,   268,   269,    -1,    -1,    -1,    -1,
      -1,   330,    -1,    -1,   333,    -1,    -1,    -1,   282,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2250,    -1,  2252,   243,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,  2262,    -1,    -1,    -1,    -1,  3169,    -1,
     314,    -1,    -1,   317,    -1,    -1,    -1,   403,    -1,   268,
     269,    -1,    -1,    -1,    -1,    -1,   330,  2286,    -1,   333,
      -1,    -1,  3193,   282,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,  2306,    -1,    -1,
      -1,    -1,  2311,  2312,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2322,    -1,   314,    -1,    -1,   317,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2338,
      -1,   330,    -1,    -1,   333,  3140,    -1,    -1,    -1,  3144,
      -1,  3146,    -1,  3148,  3149,    -1,    -1,    -1,    -1,   403,
      -1,    -1,  3157,   489,   490,   491,    -1,   493,   494,   495,
     496,   497,   498,    -1,  2373,    -1,    -1,    -1,    -1,   505,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
    3195,    -1,    -1,    -1,    -1,    -1,   505,    -1,    -1,    -1,
      -1,  3391,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2435,    -1,  2437,    -1,
      85,    -1,    -1,    88,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,   503,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,  3449,
      -1,  3451,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2498,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
    2509,    -1,    -1,    -1,   503,    -1,    -1,    -1,    -1,    -1,
    2519,    -1,  2366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2556,    -1,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,  2413,
     113,    -1,    -1,    -1,    -1,   118,  2420,  2421,  2422,  2423,
    2424,  2425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,
      -1,  2600,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   268,   269,    -1,    -1,    85,    -1,    -1,
      88,  2630,  2631,    -1,    -1,  3536,  3537,   282,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2491,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,
     118,  2660,  2661,    -1,    -1,    -1,  2665,    -1,    -1,   314,
      -1,    -1,   317,    -1,    -1,    -1,    -1,    -1,  2677,  2678,
    2679,  2680,    -1,    -1,    -1,   330,  2685,  2531,   333,  2533,
    2689,  2690,    -1,  2692,    -1,  2694,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,   247,  2704,  2705,    -1,  2707,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2720,    -1,  2722,    -1,   268,   269,  2726,    -1,  3630,
    3631,  3632,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,
      -1,    -1,    -1,  2742,    85,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    -1,  2752,    -1,  2754,  2755,  2756,   403,    -1,
      -1,    -1,    -1,    -1,   824,    -1,    -1,    -1,    -1,    -1,
     830,   314,   113,    -1,   317,    -1,    -1,   118,   838,  2778,
      -1,    -1,    -1,    -1,    -1,   243,   846,   330,  2787,   247,
     333,   851,    -1,    -1,    -1,    -1,    -1,  2796,    -1,    -1,
      -1,    -1,  2801,    -1,    -1,    -1,    -1,    -1,    -1,  2808,
     268,   269,    -1,    -1,    -1,    -1,  3796,    -1,    -1,    -1,
      -1,  3616,    -1,    -1,   282,    -1,    -1,  3807,  3623,  3624,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,    -1,    -1,   314,  2856,   503,   317,
     403,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2884,  2885,    -1,  2887,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,    -1,   247,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3818,  3819,   979,
    3821,    -1,    -1,    -1,    -1,    -1,    -1,   268,   269,  2928,
      -1,  2930,    -1,    -1,    -1,    -1,   996,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,   403,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,
     503,    -1,  2961,  2962,  2963,    -1,    -1,  1027,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1044,    -1,    -1,    -1,    -1,   330,
      -1,    -1,    -1,    -1,    -1,    -1,  3791,  3792,    -1,    -1,
    2999,    -1,    -1,    -1,    -1,    -1,    -1,  1067,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3021,    -1,    -1,    -1,  3025,  3026,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,    -1,    -1,    -1,    -1,  3948,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3958,    -1,    -1,
    3059,  3060,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3077,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3091,    -1,    -1,    -1,    -1,    -1,    85,    -1,
      -1,    88,    -1,    -1,    -1,  3104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,  3122,    -1,    -1,   113,  3126,    -1,    -1,
      -1,   118,    -1,    -1,    -1,    -1,  3135,    -1,    -1,    -1,
      -1,    -1,  3141,    -1,    -1,    85,    -1,    -1,    88,    -1,
      -1,    -1,   493,   494,   495,   496,   497,   498,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,  3963,    -1,
    3965,  3966,  3171,   113,    -1,    -1,    -1,    -1,   118,    -1,
      -1,  3976,    -1,    -1,    -1,    -1,    -1,    -1,  1248,  1249,
    1250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3204,    -1,    -1,  3207,    -1,
      -1,    -1,    -1,    -1,  3213,    -1,    -1,    -1,    -1,    -1,
    3219,    -1,  3221,    -1,    -1,    -1,    -1,  3226,  3227,    -1,
      -1,  3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,
    3239,    -1,    -1,    -1,  3243,  3244,    -1,    -1,    -1,    -1,
      -1,    -1,  3251,    -1,    -1,    -1,   243,  3256,    -1,    -1,
     247,  3260,  4163,  3262,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3272,    -1,    -1,  3275,    -1,  3277,    -1,
      -1,   268,   269,    -1,    -1,    -1,  3285,  3286,  3287,  3288,
      -1,    -1,    -1,  3292,    -1,   282,  3295,    -1,    -1,    -1,
      -1,    -1,    -1,   243,  1364,    -1,  3305,   247,    -1,    -1,
      -1,    -1,    -1,    -1,  3313,    -1,  3315,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   314,   268,   269,
     317,    -1,  1392,  4234,    -1,    -1,    85,    -1,    -1,    88,
      -1,    -1,   282,   330,    -1,    89,   333,    -1,    -1,    -1,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    85,   113,    -1,    88,    -1,    -1,   118,
      -1,    -1,    -1,    -1,   314,    -1,    -1,   317,    -1,    -1,
    4175,  1224,    -1,   105,    -1,    -1,  3385,    -1,   132,    -1,
     330,   113,    -1,   333,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    88,    -1,   152,    -1,
      -1,    -1,    -1,  4208,    -1,    -1,   403,    -1,  3417,  3418,
    3419,    -1,    -1,   105,    -1,    -1,    -1,   171,    -1,    -1,
      -1,   113,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,   185,    -1,  3442,    -1,    -1,    -1,    -1,    -1,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,    -1,   403,   208,    -1,   210,    -1,  1528,    -1,
     214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   223,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,   247,    -1,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,   503,    -1,    -1,   268,
     269,   243,    -1,  3522,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   282,    -1,    -1,  1379,    -1,    -1,    -1,
      -1,  3540,    -1,    -1,    -1,    -1,   268,   269,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
     282,   243,    -1,   503,    -1,   247,    -1,    -1,   317,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3575,  3576,  3577,    -1,
      -1,   330,    -1,    -1,    -1,    -1,   268,   269,    -1,    -1,
      -1,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,    -1,
     282,  3600,    -1,    -1,    -1,    -1,  3605,    -1,   330,  3608,
      -1,   333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4418,    -1,    -1,    -1,    -1,    -1,    -1,
    1690,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    88,    -1,    -1,   330,    -1,
      -1,   333,    -1,  3652,   403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     113,    -1,    -1,    -1,  1517,   118,    -1,    -1,    -1,    -1,
    1740,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3688,
      -1,    -1,    -1,    -1,    -1,    -1,  3695,  3696,    -1,  3698,
      -1,  1761,    -1,    -1,  3703,  3704,    -1,    -1,    -1,  3708,
    3709,    -1,    -1,    -1,    -1,  3714,  3715,    -1,    -1,  3718,
      -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3729,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3741,    -1,   493,   494,   495,   496,   497,   498,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3757,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
    3769,   493,   494,   495,   496,   497,   498,    -1,    -1,    -1,
      -1,   503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3790,    -1,    -1,    -1,    -1,    -1,    -1,  1641,    -1,
     243,  3800,    -1,    -1,   247,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,    96,
      -1,   503,    -1,    -1,    -1,   268,   269,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1894,  1678,    -1,    -1,    -1,   282,
      -1,    -1,    -1,  1903,    -1,    -1,  3845,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1701,    -1,
      -1,    -1,    -1,  1923,    -1,    98,    -1,    -1,    -1,    -1,
      -1,   314,    -1,   150,   317,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,   160,   161,    -1,    -1,   330,    -1,    -1,
     333,    -1,    -1,  3892,   638,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,    -1,  1969,
    1970,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1763,    -1,   155,    -1,    -1,    -1,   203,    -1,    -1,  3773,
    3774,    -1,    -1,    -1,    -1,    -1,    -1,  1780,    -1,    -1,
      -1,  3940,   175,    -1,    -1,    -1,    -1,    -1,   181,    -1,
      -1,    -1,  3951,    -1,    -1,  1798,  3955,    -1,    -1,    -1,
     403,  3960,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
     247,    -1,    -1,    -1,    -1,   252,  3820,    -1,    -1,    -1,
    1823,    -1,    -1,  3982,    -1,    -1,    -1,  3986,    -1,    -1,
      -1,   224,    -1,    -1,    -1,    -1,   229,    -1,    -1,    -1,
      -1,    -1,   235,    -1,    -1,    -1,    -1,  4006,  4007,    -1,
      -1,  4010,    -1,    -1,   291,    -1,    -1,   250,  4017,  4018,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     307,   308,   309,   310,   311,  1878,   313,    -1,    -1,  2099,
      -1,   274,    -1,    -1,    -1,  4044,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,
     503,    -1,  4061,    -1,  2124,  4064,    -1,    -1,   345,    -1,
      -1,    -1,   816,   817,   818,    -1,   820,    -1,   822,   823,
     824,    -1,   826,    -1,   828,    -1,   830,    -1,   832,    -1,
      -1,    -1,   836,   837,   838,    -1,    -1,   330,    -1,    -1,
      -1,  4100,   846,    -1,   381,    -1,    -1,   851,  2168,   853,
    2170,    85,    -1,   857,    88,   859,    -1,    -1,   862,    -1,
     864,    -1,   866,   867,   357,    -1,    -1,    -1,    -1,    -1,
     874,   105,   876,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,   418,    -1,   420,   118,    -1,    -1,    -1,   381,  4148,
      -1,  4150,   896,    -1,   387,    -1,    -1,   901,    -1,    -1,
     393,   905,    -1,   396,    -1,   909,    -1,   444,   912,    -1,
      -1,   915,    -1,    -1,   451,    -1,    -1,   454,  4177,  4178,
      -1,  4180,    -1,  4182,    -1,    -1,   930,    -1,    -1,   422,
      -1,   424,    -1,    -1,    -1,   428,    -1,   941,    -1,    -1,
      -1,    -1,  4046,   436,    -1,    -1,    -1,    -1,   441,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   451,    -1,
      -1,  4220,    -1,    -1,  4223,    -1,  2069,    -1,  4227,  4228,
     463,    -1,    -1,    -1,    -1,   979,    -1,    -1,    -1,    -1,
     984,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   996,   997,  4253,    -1,    -1,    -1,    -1,    -1,
      -1,  4260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,
      -1,    -1,    -1,   247,    -1,  2335,    -1,    -1,  1022,    -1,
      -1,    -1,  1026,  1027,    -1,    -1,  1030,  4286,    -1,    -1,
      -1,  4290,    -1,    -1,   268,   269,    -1,    -1,    -1,    -1,
    1044,    -1,    -1,  4147,  1048,    -1,    -1,  4306,   282,  1053,
      -1,    -1,    -1,    -1,  1058,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1067,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     314,    -1,    -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4350,    -1,    -1,    -1,    -1,   330,    -1,  4357,   333,
      -1,    -1,    -1,    -1,    -1,  4209,    -1,    -1,    -1,    -1,
    1114,  1115,    -1,    -1,  4373,  4374,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4383,    -1,    -1,  4231,    -1,  4233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2457,    -1,    -1,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,
      -1,  4410,    -1,    -1,    -1,  1159,  1160,    -1,    -1,    -1,
      -1,  4420,    -1,    -1,   105,    -1,    -1,    -1,    85,   403,
      -1,    88,   113,    -1,    -1,    -1,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,  1196,    -1,    -1,    -1,   113,    -1,    -1,  1203,
      -1,   118,  1206,  2306,    -1,    -1,    -1,    -1,  2311,  2312,
      -1,    -1,    -1,    -1,  1218,  4474,    -1,    -1,    -1,  2322,
      -1,    -1,    -1,    -1,  4483,    -1,    -1,    -1,    -1,    -1,
    1234,  1235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4347,  1248,  1249,  1250,  1251,    -1,  1253,
      -1,    -1,    -1,  1257,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,    -1,    -1,    -1,    -1,   503,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1285,  1286,  4387,    85,    -1,    -1,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,    88,
    1304,    -1,   243,    -1,   105,    -1,   247,    -1,    -1,    -1,
      -1,    -1,   113,    -1,    -1,  1319,    -1,   118,    -1,    -1,
      -1,    -1,    -1,    -1,   113,  1329,   243,   268,   269,   118,
     247,    -1,    -1,    -1,  2437,    -1,    -1,    -1,    -1,    -1,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   268,   269,    -1,    -1,  1359,  1360,    -1,    -1,    -1,
    1364,    -1,  1366,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1389,    -1,    -1,  1392,   330,
      -1,  1395,   333,    -1,    -1,  2498,    -1,   314,    -1,    -1,
     317,  1405,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      88,    -1,    -1,   330,    -1,    -1,   333,   206,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2746,   105,    -1,  1433,
      -1,   109,    -1,    -1,    -1,   113,    85,    -1,    -1,    88,
     118,    -1,   243,    -1,    -1,    -1,   247,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   243,    -1,  1460,  1461,   247,  1463,
      -1,    -1,   403,    -1,   113,    -1,    -1,   268,   269,   118,
      -1,    -1,    -1,    -1,    -1,    -1,  1480,    -1,    -1,   268,
     269,   282,    -1,    -1,    -1,  2805,   403,    -1,    -1,    -1,
      -1,    -1,    -1,   282,    -1,    -1,  1500,  1501,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2611,    -1,
    1514,   189,    -1,   314,    -1,    -1,   317,  1521,  1522,    -1,
      -1,    -1,    -1,    -1,  1528,    -1,    -1,  1531,   317,   330,
      -1,    -1,   333,  1537,    -1,  1539,    -1,    -1,    -1,    -1,
      -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,  1563,
      -1,    -1,   503,  1567,  1568,   243,    -1,    -1,    -1,   247,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,   503,    -1,    -1,    -1,
     268,   269,    -1,    -1,   243,    -1,    -1,  1601,   247,  1603,
      -1,    -1,   403,    -1,   282,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   282,    -1,    -1,   314,    -1,    -1,   317,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   330,    -1,    -1,   333,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,    -1,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,   101,    -1,
    1684,   330,    -1,    -1,    -1,    -1,  1690,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,    -1,  1703,
     501,    -1,   125,    -1,   493,   494,   495,   496,   497,   498,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,
      -1,    -1,  1736,  1737,  1738,  1739,  1740,    -1,    -1,    -1,
    1744,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,    -1,  3072,    -1,   403,  1759,    -1,  1761,    -1,    -1,
      -1,    -1,  3082,  1767,  1768,    -1,    -1,    -1,   191,  1773,
      -1,    -1,    -1,    -1,   452,   198,    -1,  3097,   201,    -1,
      -1,  2884,  2885,    -1,  2887,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,    -1,    -1,  2928,   249,  2930,  1832,   252,
    3150,    -1,    -1,  3153,  1838,  1839,  1840,  1841,    -1,    -1,
     489,   490,   491,  1847,   493,   494,   495,   496,   497,   498,
      -1,  1855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1870,    -1,  1872,    -1,
      -1,   294,    -1,   296,  3194,  1879,    -1,  1881,    -1,    -1,
      -1,    -1,    -1,   306,    -1,  1889,    -1,    -1,    -1,    -1,
    1894,    -1,    -1,    -1,    -1,    -1,  2999,    -1,    -1,  1903,
      -1,  1905,    -1,    -1,    -1,  1909,  1910,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   340,   341,  1923,
      -1,    -1,  1926,  3026,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,
      -1,   374,   375,  1957,    -1,    -1,    85,  3060,    -1,    88,
      -1,  1965,    -1,    -1,    -1,  1969,  1970,    -1,    -1,    -1,
      -1,    -1,    -1,  1977,  3077,    -1,   399,  1981,    -1,    -1,
      -1,    -1,  3302,  3303,   113,    -1,   409,    -1,  3091,   118,
      -1,    -1,    -1,  1997,  1998,    -1,    -1,  2001,    -1,  2003,
    2004,  3104,    -1,    -1,    -1,    -1,    -1,  2011,    -1,    -1,
    2014,    -1,    -1,  2017,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2025,  2026,    -1,    -1,    -1,    -1,    -1,    -1,  2033,
      -1,  2035,  2036,  2037,  2038,  2039,    -1,    -1,  3141,    -1,
      -1,    -1,  2046,  2047,    -1,  2049,    -1,  2051,    -1,    -1,
    2054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2070,    -1,    -1,    -1,
    2074,    -1,    -1,    -1,  2078,    -1,    -1,   206,  2082,    -1,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,    -1,
    2094,    -1,    -1,    -1,    -1,  2099,  2100,    -1,    -1,  2103,
      -1,    -1,    -1,    -1,  3207,    -1,    -1,    -1,    85,    -1,
      -1,    88,    -1,    -1,   243,    -1,    -1,    -1,   247,    -1,
    2124,    -1,    -1,  3226,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,   268,
     269,   118,    -1,    -1,    -1,    -1,    -1,    -1,  3251,    -1,
      -1,    -1,    -1,   282,    -1,    -1,    -1,  2161,    -1,    -1,
      -1,    -1,    -1,    -1,  2168,    -1,  2170,    -1,  2172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3285,    -1,    -1,    -1,    -1,    -1,   317,    -1,
    3510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   330,    -1,    -1,    -1,    -1,    -1,    -1,  3528,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3545,    -1,    -1,  2232,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,
     227,    -1,    -1,    -1,    -1,  2259,    -1,    -1,    -1,  2263,
    2264,    -1,    -1,    -1,    -1,  2269,   243,  2271,    -1,    -1,
     247,    -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,
      -1,  2285,  2286,    -1,    -1,    -1,    -1,    -1,    -1,  2293,
      -1,   268,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,  2316,    -1,  2318,  3418,    -1,    -1,    -1,    -1,
    2324,    -1,    -1,    -1,    -1,  2329,    -1,    -1,    -1,    -1,
      -1,  2335,  2336,    -1,    -1,    -1,    -1,   314,    -1,    -1,
     317,    -1,  2346,  2347,    -1,    -1,    -1,    -1,  2352,  2353,
      -1,    -1,  2356,   330,    -1,    -1,   333,    -1,    -1,    -1,
      -1,    -1,  2366,    -1,   493,   494,   495,   496,   497,   498,
    2374,    -1,    -1,    -1,    -1,    -1,    -1,  2381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2390,    -1,    -1,    -1,
      -1,    -1,    -1,  2397,    -1,    -1,    -1,    -1,    -1,    -1,
    3720,  3721,  3722,  3723,    -1,    -1,    -1,    -1,    -1,  2413,
      -1,    -1,    -1,    -1,    -1,    -1,  2420,  2421,  2422,  2423,
    2424,  2425,    -1,    -1,    -1,    -1,   403,    -1,    -1,    -1,
      -1,  2435,    -1,    -1,    -1,    -1,    85,  3540,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2453,
      -1,    -1,    -1,  2457,    -1,    -1,   105,  2461,    -1,    -1,
      -1,    -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,   118,
      -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2485,    -1,    -1,    -1,    -1,    -1,  2491,  2492,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2501,  2502,    -1,
      -1,    -1,    -1,    -1,    -1,  2509,  2510,    -1,    -1,    -1,
    2514,  2515,   489,   490,   491,  2519,   493,   494,   495,   496,
     497,   498,    -1,    -1,    -1,    -1,    -1,  2531,  2532,  2533,
    2534,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2548,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2577,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,  2593,
      -1,    -1,    -1,    -1,   243,  3698,  2600,    -1,   247,    -1,
      -1,    -1,   105,    -1,    -1,   108,  3709,    -1,    -1,    -1,
     113,    -1,    -1,    -1,    -1,   118,    -1,  2621,    -1,   268,
     269,    -1,    -1,  3943,    -1,    -1,  2630,  2631,    -1,    -1,
      -1,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2660,  2661,    -1,    -1,
      -1,  2665,    -1,    -1,    -1,   314,    -1,    -1,   317,    -1,
      -1,    -1,    -1,  2677,  2678,  2679,  2680,    -1,    -1,    -1,
      -1,   330,    -1,    -1,   333,  2689,    -1,  3790,  2692,    -1,
    2694,  2695,    -1,    -1,    -1,    -1,    -1,  3800,    -1,    -1,
    2704,  2705,   351,  2707,    -1,    -1,    -1,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2720,    -1,  2722,    -1,
    2724,    -1,  2726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1224,    -1,    -1,    -1,    -1,    -1,    -1,  2742,    -1,
     243,    -1,  2746,    -1,   247,    -1,    -1,    -1,  2752,    -1,
    2754,  2755,  2756,   162,   403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   268,   269,   416,    -1,    -1,
    2774,    -1,    -1,    -1,  2778,    -1,    98,    -1,    -1,   282,
      -1,  2785,    -1,  2787,    -1,    -1,    -1,    -1,   110,  4109,
      -1,    -1,  2796,    -1,    -1,    -1,    -1,  2801,    -1,    -1,
     209,  2805,    -1,    -1,  2808,    -1,    -1,   216,   130,   218,
      -1,   314,    -1,    -1,   317,    -1,    -1,    -1,  4138,    -1,
      -1,   230,    -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,
     333,    -1,    -1,   155,    -1,  2839,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
      -1,    -1,  2856,   175,  2858,    -1,    -1,  3960,  2862,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3986,    -1,    -1,  1379,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4217,    -1,    -1,
     403,    -1,   224,    -1,    -1,    -1,    -1,   229,    -1,    -1,
      -1,    -1,    -1,   235,    -1,    -1,    -1,    -1,    -1,    -1,
    2924,    -1,    -1,    -1,    -1,    -1,    -1,  2931,   250,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    -1,    88,    -1,    -1,    -1,
      -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,  4061,    -1,
      -1,   113,    -1,   105,    -1,    -1,   118,    -1,    -1,    -1,
      -1,   113,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,  2993,
     493,   494,   495,   496,   497,   498,    -1,    -1,    -1,  3003,
    3004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   330,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   340,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3032,    -1,
      -1,    -1,    -1,    -1,    -1,   357,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   381,
      -1,    -1,    -1,   385,    -1,   387,    -1,  3071,  3072,   221,
      -1,   393,    -1,    -1,   396,  4178,    -1,    -1,  3082,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   243,    -1,  3097,    -1,   247,    -1,    -1,    -1,  3103,
     422,   243,   424,    -1,    -1,   247,   428,    -1,  3112,    -1,
      -1,    -1,  3116,    -1,   436,  3119,   268,   269,  3122,   441,
    4223,    -1,  3126,    -1,  4227,  4228,   268,   269,  3132,   451,
     282,  3135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     282,   463,    -1,    -1,    -1,    -1,  3150,    -1,  1641,  3153,
      -1,    -1,  3156,    -1,    -1,    -1,  3160,    -1,    -1,    -1,
      -1,    -1,   314,    -1,    -1,   317,    -1,  3171,    -1,    -1,
    3174,    -1,   314,    -1,    -1,   317,    -1,  3181,   330,    -1,
      -1,   333,    -1,    -1,    -1,  1678,    -1,    -1,   330,    -1,
    3194,   333,  3196,    -1,    -1,    -1,    -1,   349,    -1,    -1,
    3204,    -1,    -1,    -1,   346,    -1,    -1,    -1,  1701,  3213,
      -1,    -1,    -1,    -1,    -1,  3219,    -1,  3221,    -1,    -1,
      -1,    -1,    -1,  3227,    -1,    -1,  3230,  3231,  3232,  3233,
    3234,  3235,  3236,  3237,  3238,  3239,    -1,    -1,    -1,  3243,
    3244,    -1,    -1,    -1,    -1,    -1,    85,    -1,    -1,    88,
      -1,   403,  3256,    -1,    -1,    -1,    -1,    85,  3262,    -1,
      88,   403,    -1,    -1,    -1,    -1,   105,    -1,  3272,   108,
    1763,  3275,    -1,  3277,   113,    -1,    -1,   105,    -1,   118,
     108,    -1,  3286,  3287,  3288,   113,    -1,  1780,  3292,    -1,
     118,  3295,    -1,    -1,    -1,    -1,    -1,    -1,  3302,  3303,
      -1,  3305,    -1,    -1,    -1,  1798,    -1,  3311,    -1,  3313,
      -1,  3315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1823,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
    3344,   493,   494,   495,   496,   497,   498,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      85,    -1,    -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3385,  3386,  3387,    -1,  1878,    -1,  3391,    -1,    -1,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   808,
      -1,    -1,    -1,   118,   243,    -1,  3410,   816,   247,    -1,
      -1,    -1,    -1,   822,    -1,   243,    -1,    -1,    -1,   247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   268,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1224,    -1,
     268,   269,    -1,   282,   853,  3449,    -1,  3451,    85,    -1,
      -1,    88,    -1,    -1,   282,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,   108,    -1,  3477,    -1,   314,   113,    -1,   317,    -1,
      -1,   118,    -1,    -1,    -1,    -1,   314,    -1,    -1,   317,
      -1,   330,    -1,    -1,   333,    -1,   905,    -1,    -1,    -1,
    3504,    -1,   330,   912,    -1,   333,  3510,    -1,    -1,    -1,
      -1,    -1,   227,    -1,    -1,    -1,    -1,    -1,  3522,    -1,
      -1,    -1,    -1,    85,  3528,    -1,    88,    -1,   243,    -1,
      -1,    -1,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3545,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,
    3554,   113,    -1,   268,   269,  3559,   118,    -1,    -1,  3563,
      -1,  3565,    -1,    -1,   403,    -1,    -1,   282,    -1,    -1,
      -1,    -1,  3576,  3577,    -1,   403,  2069,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3596,  1379,    -1,    -1,  3600,    -1,    -1,   314,
      -1,  3605,   317,    -1,  3608,  3609,   243,  3611,    -1,    -1,
     247,    -1,    -1,  1022,  3618,   330,  3620,    -1,   333,  1028,
      -1,    -1,    -1,  1032,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   268,   269,    -1,  3638,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   282,    -1,    -1,  3652,  1058,
     489,   490,   491,    -1,   493,   494,   495,   496,   497,   498,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,    -1,    -1,    -1,    -1,    -1,    -1,   314,    -1,    -1,
     317,   243,    -1,    -1,  3688,   247,    -1,    -1,   403,    -1,
      -1,  3695,  3696,   330,    -1,    -1,   333,    -1,    -1,  3703,
    3704,    -1,    -1,    -1,  3708,    -1,   268,   269,    -1,    -1,
    3714,  3715,    -1,    -1,  3718,    -1,  3720,  3721,  3722,  3723,
     282,    -1,    -1,    -1,    -1,  3729,    -1,    -1,    -1,    -1,
      -1,  3735,    -1,    -1,    -1,    -1,    -1,  3741,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3752,    -1,
      -1,    -1,   314,    -1,    -1,   317,    -1,    -1,    -1,    -1,
      -1,    -1,  3766,    -1,    -1,  3769,   403,    -1,   330,  3773,
    3774,   333,    -1,    -1,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,  3788,    -1,    -1,  1196,    -1,    -1,
      -1,    -1,  3796,    -1,  1203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3807,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2306,    -1,  1224,  3820,    -1,  2311,  2312,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2322,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     158,   403,    -1,  3847,  1253,    -1,    -1,    -1,    -1,    -1,
    3854,    -1,   489,   490,   491,  1641,   493,   494,   495,   496,
     497,   498,    -1,    -1,  3868,  3869,  3870,  3871,  3872,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3892,   207,
      -1,    -1,  1678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,    -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,   227,
    1319,    -1,    -1,    -1,   232,  1701,    -1,   235,    -1,   237,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,   493,   494,   495,   496,   497,   498,    -1,    -1,  3943,
      -1,  3945,    -1,    -1,  2437,    -1,   264,  3951,    -1,    -1,
      -1,  3955,    -1,    -1,  3958,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
    1379,    -1,    -1,  3977,    -1,    -1,    -1,  1763,  3982,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1780,    -1,  1405,    -1,    -1,    -1,
      -1,    -1,  4006,  4007,    -1,  2498,  4010,    -1,   326,    -1,
      -1,    -1,  1798,  4017,  4018,    -1,   334,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1433,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4038,    -1,  4040,  1823,    -1,    -1,
    4044,  4045,  4046,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1460,  1461,    -1,  1463,    -1,    -1,    -1,    -1,   377,
    4064,  4065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1480,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      85,    -1,    -1,    88,    -1,  4089,    -1,    -1,    -1,    -1,
      -1,    -1,  1878,    -1,    -1,    -1,  4100,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   422,  4109,    -1,    -1,   113,    -1,
      -1,    -1,    -1,   118,    -1,    -1,    -1,  4121,  2611,  4123,
      -1,    -1,  1531,  1532,    -1,    -1,    -1,   445,    -1,  4133,
      -1,    -1,    -1,    -1,  4138,    85,    -1,    -1,    88,    -1,
      -1,    -1,    -1,  4147,  4148,    -1,    -1,    -1,   466,    -1,
     468,   469,    -1,    -1,  1563,   105,    -1,    -1,  1567,  1568,
      -1,    -1,    -1,   113,    -1,    -1,    -1,    -1,   118,    -1,
      -1,    -1,    -1,  4177,    -1,    -1,  4180,    -1,  4182,    -1,
      -1,    -1,   500,    -1,    -1,   503,   504,    -1,   506,    -1,
      -1,  4195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4217,    -1,    -1,  4220,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4230,  4231,  4232,  4233,
      -1,    -1,  1641,    -1,    -1,  4239,    -1,  1646,   243,    -1,
      -1,  1650,   247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4260,    -1,    -1,    -1,
      -1,    -1,  1671,   268,   269,    -1,    -1,    -1,    -1,  1678,
      -1,    -1,    -1,    -1,    -1,    -1,  1224,   282,    -1,    -1,
      -1,    -1,    -1,  2069,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1701,   243,    -1,    -1,    -1,   247,    -1,    -1,
      -1,    -1,  4306,    -1,    -1,    -1,    -1,    -1,    -1,   314,
    4314,    -1,   317,    -1,    -1,    -1,    -1,  2103,   268,   269,
      -1,    -1,    -1,    -1,    -1,   330,    -1,    -1,   333,    -1,
      -1,    -1,   282,    -1,    -1,    -1,    -1,  1746,    -1,    -1,
      -1,    -1,    -1,  4347,    -1,    -1,  4350,    -1,    -1,    -1,
      -1,    -1,    -1,  4357,  1763,    -1,    -1,    -1,    -1,    -1,
    4364,    -1,    -1,    -1,   314,    -1,  4370,   317,    -1,  4373,
    4374,  1780,  4376,    -1,    -1,    -1,    -1,    -1,    -1,  4383,
     330,    -1,    -1,  4387,    -1,    -1,    -1,    -1,    -1,  1798,
      -1,  2884,  2885,    -1,  2887,    -1,    -1,    -1,   403,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4410,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1823,    -1,  4420,    -1,    -1,  1828,
      -1,    -1,    -1,    -1,   429,    -1,    -1,    -1,    -1,    -1,
    4434,  1379,    -1,    -1,    -1,  2928,    -1,  2930,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1870,    -1,  1872,    -1,    -1,    -1,    -1,    -1,  1878,
    4474,    -1,  1881,    -1,    -1,  4479,    -1,    -1,    -1,  4483,
      -1,    -1,    -1,  4487,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2999,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2306,    -1,    -1,    -1,    -1,  2311,  2312,    -1,    -1,    -1,
      -1,    -1,    -1,  3026,    -1,    -1,  2322,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1965,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3060,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,    -1,    -1,  3077,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2003,  2004,    -1,    -1,  3091,    -1,
      -1,   130,  2011,    -1,    -1,  2014,    -1,    -1,  2017,    -1,
      -1,  3104,    -1,    -1,    -1,    -1,  2025,  2026,    -1,    -1,
      -1,    -1,   151,    -1,  2033,    -1,   155,  2036,  2037,  2038,
    2039,    -1,    -1,    -1,    -1,    -1,    -1,  2046,  2047,    -1,
    2049,   158,  2051,    -1,    -1,  2054,   175,    -1,  3141,    -1,
      -1,  2437,   181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2069,  2070,  2071,    -1,    -1,  2074,    -1,   196,    -1,  2078,
      -1,    -1,    -1,  2082,    -1,  2084,  2085,  2086,  2087,  2088,
    2089,  2090,  2091,  2092,    -1,  2094,    -1,    -1,    -1,    -1,
     207,  2100,    -1,  1641,  2103,   224,    -1,    -1,    -1,    -1,
      -1,   218,   231,    -1,    -1,   222,   235,    -1,    -1,    -1,
     227,    -1,  2498,    -1,  3207,   232,    -1,    -1,   235,    -1,
     237,   250,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1678,    -1,    -1,  3226,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
      -1,    -1,    -1,  1701,    -1,    -1,    -1,   286,  3251,    -1,
      -1,    -1,    -1,  2172,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209,    -1,
      -1,    -1,  3285,    -1,    -1,   216,    -1,   218,    -1,    -1,
      -1,   330,    -1,    -1,   333,    -1,    -1,    -1,    -1,   326,
      -1,    -1,    -1,    -1,    -1,  1763,    -1,   334,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2611,    -1,    -1,    -1,    -1,
      -1,    -1,  1780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1798,    -1,   381,  2262,    -1,    -1,    -1,    -1,   387,    -1,
     377,    -1,    -1,    -1,   393,    -1,    -1,   396,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1823,    -1,  2286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   422,    -1,   424,   425,  2306,   427,   428,
      -1,    -1,  2311,  2312,    -1,   422,    -1,   436,    -1,    -1,
      -1,    -1,   441,  2322,    -1,    -1,    -1,   446,    -1,    -1,
      -1,    -1,   451,    -1,    -1,  3418,    -1,    -1,   445,  2338,
    1878,    -1,    -1,    -1,   463,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   466,
      -1,   468,   469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2373,    -1,    -1,    -1,  2754,  2755,
    2756,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   500,    -1,    -1,   503,   504,    -1,   506,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2435,    -1,  2437,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3540,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,    -1,  2498,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2884,  2885,
    2509,  2887,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2069,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2928,    -1,  2930,    -1,    -1,  2556,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2611,    -1,    -1,  3698,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2999,    -1,    -1,  3709,    -1,    -1,    -1,
      -1,  2630,  2631,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2660,  2661,    -1,    -1,    -1,  2665,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2677,  2678,
    2679,  2680,    -1,    -1,  3060,    -1,  2685,    -1,    -1,    -1,
    2689,  2690,    -1,  2692,    -1,  2694,    -1,    -1,    -1,    -1,
      -1,  3077,    -1,    -1,    -1,  2704,  2705,  3790,  2707,    -1,
      -1,    -1,    -1,    -1,    -1,  3091,    -1,  3800,    -1,    -1,
      -1,  2720,    -1,  2722,    -1,    -1,    -1,  2726,  3104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2742,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2752,    -1,  2754,  2755,  2756,    -1,  3135,
      -1,    -1,    -1,    -1,    -1,  3141,    -1,    -1,  2306,    -1,
      -1,    -1,    -1,  2311,  2312,    -1,    -1,    -1,    -1,  2778,
      -1,    -1,    -1,    -1,  2322,    -1,    -1,    -1,  2787,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2796,    -1,    -1,
      -1,    -1,  2801,    -1,    -1,   816,    -1,    -1,    -1,  2808,
      -1,   822,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3207,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   853,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3226,    -1,    -1,    -1,    -1,    -1,    -1,  2856,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3251,    -1,  3960,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2884,  2885,    -1,  2887,    -1,
      -1,    -1,    -1,    -1,   905,    -1,    -1,    -1,    -1,  2437,
      -1,   912,    -1,  3986,    -1,    -1,    -1,    -1,    -1,  3285,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2928,
      -1,  2930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2498,    -1,  2961,  2962,  2963,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4061,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1022,  1224,    -1,    -1,    -1,    -1,  1028,    -1,    -1,
      -1,  1032,  3021,    -1,    -1,    -1,    -1,  3026,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3418,    -1,    -1,    -1,    -1,  1058,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3059,  3060,    -1,    -1,    -1,    -1,    -1,  4150,    -1,    -1,
      -1,    -1,    -1,  2611,    -1,    -1,    -1,    -1,  3077,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3091,    -1,    -1,  4178,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3122,    -1,    -1,    -1,  3126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3135,    -1,    -1,    -1,
    4223,    -1,  3141,    -1,  4227,  4228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3540,    -1,    -1,  1379,    -1,    -1,
      -1,    -1,  3171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1196,    -1,    -1,    -1,    -1,
      -1,    -1,  1203,    -1,    -1,    -1,    -1,    -1,    -1,  3575,
      -1,    -1,    -1,    -1,    -1,  3204,    -1,    -1,  3207,    -1,
      -1,    -1,    -1,  1224,  3213,    -1,    -1,    -1,    -1,    -1,
    3219,    -1,  3221,    -1,    -1,    -1,    -1,  3226,  3227,    -1,
      -1,  3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,
    3239,    -1,  1253,    -1,  3243,  3244,    -1,    -1,    -1,    -1,
      -1,    -1,  3251,    -1,    -1,    -1,    -1,  3256,    -1,    -1,
      -1,  3260,    -1,  3262,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3272,    -1,    -1,  3275,    -1,  3277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3285,  3286,  3287,  3288,
      -1,    -1,    -1,  3292,    -1,    -1,  3295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3305,    -1,  1319,    -1,
      -1,    -1,    -1,    -1,  3313,    -1,  3315,    -1,    -1,    -1,
      -1,    -1,  3698,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3709,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2884,  2885,    -1,  2887,
      -1,    -1,    -1,  3729,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3741,    -1,    -1,  1379,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3385,    -1,    -1,    -1,
    2928,    -1,  2930,    -1,  1405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3790,    -1,    -1,    -1,  3417,  3418,
    3419,    -1,  1433,    -1,  3800,    -1,    -1,    -1,    -1,  1641,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3442,    -1,    -1,    -1,    -1,    -1,  1460,
    1461,    -1,  1463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2999,    -1,    -1,    -1,    -1,  1678,    -1,    -1,  1480,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3026,  1701,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1531,    -1,  3060,  3522,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3077,
      -1,  3540,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1763,  1563,  3091,    -1,    -1,  1567,  1568,    -1,    -1,
      -1,    -1,    -1,    -1,  3940,    -1,  3104,    -1,  1780,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3575,  3576,  3577,    -1,
      -1,    -1,    -1,    -1,  3960,    -1,  1798,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3600,    -1,  3141,    -1,    -1,  3605,    -1,    -1,  3608,
    3986,  1823,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1641,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1650,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3652,    -1,    -1,    -1,    -1,    -1,    -1,
    1671,    -1,    -1,    -1,    -1,    -1,  1878,  1678,    -1,  3207,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4061,    -1,    -1,  3226,  3688,
    1701,    -1,    -1,    -1,    -1,    -1,  3695,  3696,    -1,  3698,
      -1,    -1,    -1,    -1,  3703,  3704,    -1,    -1,    -1,  3708,
    3709,    -1,    -1,  3251,    -1,  3714,  3715,    -1,    -1,  3718,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3729,    -1,    -1,    -1,    -1,  1746,    -1,    -1,    -1,    -1,
      -1,    -1,  3741,    -1,    -1,    -1,    -1,  3285,    -1,    -1,
      -1,    -1,  1763,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1780,
    3769,    -1,    -1,    -1,  4150,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,
      -1,  3790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3800,  4178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1823,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3845,  4223,    -1,    -1,
      -1,  4227,  4228,    -1,    -1,    -1,    -1,  2069,    -1,  1870,
      -1,  1872,    -1,    -1,    -1,    -1,    -1,  1878,    -1,    -1,
    1881,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3418,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3892,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,    -1,    -1,
    4286,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3940,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3951,    -1,  1965,    -1,  3955,    -1,    -1,    -1,
      -1,  3960,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3982,    -1,    -1,    -1,  3986,    -1,    -1,
      -1,    -1,  2003,  2004,    -1,    -1,    -1,    -1,    -1,    -1,
    2011,    -1,  3540,  2014,    -1,    -1,  2017,  4006,  4007,    -1,
      -1,  4010,    -1,    -1,  2025,  2026,    -1,    -1,  4017,  4018,
      -1,    -1,  2033,    -1,    -1,  2036,  2037,  2038,  2039,    -1,
      -1,    -1,    -1,    -1,    -1,  2046,  2047,  3575,  2049,    -1,
    2051,    -1,    -1,  2054,    -1,  4044,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2069,  2070,
      -1,    -1,  4061,  2074,    -1,  4064,    -1,  2078,    -1,    -1,
      -1,  2082,    -1,  2084,  2085,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,    -1,  2094,    -1,    -1,    -1,    -1,    -1,  2100,
      -1,    -1,  2103,    -1,  2306,    -1,    -1,    -1,    -1,  2311,
    2312,  4100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4148,
      -1,  4150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3698,  2172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3709,    -1,    -1,    -1,    -1,    -1,    -1,  4177,  4178,
      -1,  4180,    -1,  4182,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4220,    -1,    -1,  4223,  2437,    -1,    -1,  4227,  4228,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3790,    -1,  4253,    -1,    -1,    -1,    -1,    -1,
      -1,  4260,  3800,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2286,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2498,  4286,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2306,    -1,    -1,    -1,    -1,
    2311,  2312,    -1,    -1,    -1,    -1,    -1,  4306,    -1,    96,
      -1,  2322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4350,    -1,    -1,    -1,   142,    -1,    -1,  4357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,   156,
      -1,    -1,    -1,    -1,  4373,  4374,   163,    -1,    -1,    -1,
     167,    -1,    -1,    -1,  4383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2611,
      -1,   188,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4410,    -1,    -1,    -1,    -1,    -1,   204,    -1,    -1,
      -1,  4420,  3960,    -1,  2435,    -1,  2437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3986,    -1,
     237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4483,    -1,    -1,  2498,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2509,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2519,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4061,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1224,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2556,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2600,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4150,    -1,    -1,   402,    -1,    -1,    -1,  2630,
    2631,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2660,
    2661,    -1,    -1,    -1,  2665,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2677,  2678,  2679,  2680,
      -1,    -1,  2884,  2885,    -1,  2887,    -1,    -1,  2689,    -1,
      -1,  2692,    -1,  2694,    -1,  4223,    -1,    -1,  1379,  4227,
    4228,    -1,    -1,  2704,  2705,    -1,  2707,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2720,
      -1,  2722,    -1,    -1,    -1,  2726,  2928,    -1,  2930,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2742,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2752,    -1,  2754,  2755,  2756,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2778,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2787,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2796,    -1,  2999,    -1,    -1,
    2801,    -1,    -1,    -1,    -1,    -1,    -1,  2808,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2856,    -1,    -1,  3060,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3077,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2884,  2885,    -1,  2887,    -1,    -1,  3091,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3104,    -1,    -1,    -1,    -1,    -1,    -1,   686,
     687,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   703,  2928,    -1,  2930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1641,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1678,  2999,    -1,
      -1,    -1,    -1,    -1,    -1,  3207,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1701,    -1,    -1,    -1,  3226,  3026,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3251,
      -1,    -1,   829,    -1,   831,    -1,   833,    -1,   835,  3060,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3077,   854,    -1,    -1,
      -1,    -1,  1763,  3285,    -1,    -1,    -1,    -1,    -1,    -1,
    3091,   868,   869,    -1,    -1,    -1,   873,    -1,    -1,  1780,
      -1,    -1,    -1,  3104,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   888,    -1,   890,    -1,    -1,    -1,  1798,    -1,    -1,
      -1,  3122,    -1,    -1,    -1,  3126,    -1,    -1,    -1,   906,
      -1,    -1,    -1,    -1,  3135,    -1,    -1,    -1,    -1,    -1,
    3141,   918,  1823,    -1,   921,    -1,   923,    -1,   925,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   938,   939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3171,    -1,    -1,    -1,    -1,    -1,   953,    -1,   955,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   965,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1878,    -1,    -1,
      -1,    -1,    -1,  3204,    -1,    -1,  3207,    -1,   985,   986,
      -1,    -1,  3213,    -1,    -1,   992,  3418,   994,  3219,    -1,
    3221,    -1,    -1,    -1,    -1,  3226,  3227,    -1,    -1,  3230,
    3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,    -1,
      -1,    -1,  3243,  3244,    -1,    -1,    -1,  1024,    -1,    -1,
    3251,    -1,    -1,    -1,    -1,  3256,    -1,    -1,    -1,    -1,
      -1,  3262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3272,    -1,    -1,  3275,    -1,  3277,    -1,    -1,    -1,
      -1,    -1,    -1,  1060,  3285,  3286,  3287,  3288,    -1,    -1,
      -1,  3292,    -1,    -1,  3295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3313,    -1,  3315,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3540,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1127,    -1,  1129,    -1,    -1,    -1,  1133,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3385,    -1,    -1,    -1,  2069,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1186,
      -1,    -1,    -1,    -1,    -1,    -1,    89,  3418,    -1,    -1,
      -1,    94,  1199,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1208,    -1,   106,    -1,    -1,    -1,  1214,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1254,    -1,   152,
     153,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,
     163,    -1,    -1,    -1,   167,    -1,  3698,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3709,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   188,    -1,    -1,    -1,    -1,
      -1,  3522,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3540,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1334,    -1,  1336,
      -1,    -1,  1339,    -1,  1341,    -1,    -1,  1344,  1345,  1346,
      -1,    -1,    -1,    -1,  3575,  3576,  3577,    -1,    -1,    -1,
    1357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3790,    -1,
      -1,    -1,    -1,    -1,  1371,    -1,  1373,    -1,  3800,  3600,
      -1,    -1,    -1,    -1,  3605,    -1,    -1,  3608,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2306,    -1,    -1,    -1,    -1,
    2311,  2312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3652,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3688,    -1,    -1,
      -1,    -1,    -1,    -1,  3695,  3696,    -1,  3698,    -1,    -1,
      -1,    -1,  3703,  3704,    -1,    -1,    -1,  3708,  3709,    -1,
      -1,    -1,    -1,  3714,  3715,    -1,    -1,  3718,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3729,   402,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2437,    -1,  3960,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3769,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1553,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3986,    -1,    -1,    -1,    -1,  3790,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3800,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2498,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1606,
      -1,    -1,  1609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1617,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1635,  4061,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1661,    -1,    -1,    -1,    -1,    -1,
      -1,  3892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3940,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4150,    -1,
    3951,    -1,    -1,    -1,  3955,    -1,    -1,    -1,    -1,  3960,
      -1,    -1,    -1,    -1,    -1,   638,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4178,    -1,    -1,    -1,
      -1,  3982,    -1,    -1,    -1,  3986,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4006,  4007,    -1,    -1,  4010,
      -1,    -1,    -1,   686,   687,    -1,  4017,  4018,    -1,    -1,
      -1,  4223,    -1,    -1,    -1,  4227,  4228,    -1,    -1,    -1,
     703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4044,    -1,    -1,    -1,  1824,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1836,
    4061,    -1,    -1,  4064,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4100,
      -1,    -1,    -1,  1880,    -1,    -1,    -1,  1884,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1893,    -1,  1895,    -1,
    1897,    -1,    -1,    -1,    -1,  1902,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4148,    -1,  4150,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1935,    -1,
    1937,    -1,    -1,    -1,  1941,    -1,  1943,    -1,    -1,  1946,
      -1,    -1,    -1,  1950,  1951,    -1,  4177,  4178,    -1,  4180,
      -1,  4182,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2884,  2885,    -1,  2887,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   887,   888,    -1,   890,    -1,  4220,
      -1,    -1,  4223,    -1,    -1,    -1,  4227,  4228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2928,    -1,  2930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4260,
      -1,    -1,   935,  1224,    -1,   938,   939,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   951,    -1,
     953,    -1,   955,    -1,    -1,  4286,    -1,    -1,   961,    -1,
      -1,    -1,   965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4306,    -1,    -1,    -1,    -1,
      -1,    -1,   985,   986,    -1,    -1,    -1,    -1,  2999,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,  4350,
      -1,  1024,    -1,  1026,    -1,    -1,  4357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4373,  4374,    -1,    -1,    -1,    -1,    -1,  3060,
      -1,    -1,  4383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3077,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4410,
    3091,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1379,  4420,
      -1,    -1,    -1,  3104,    -1,    -1,    -1,  1100,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1114,  1115,    -1,    -1,  1118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3141,    -1,    -1,    -1,    -1,    -1,  2243,    -1,    -1,    -1,
      -1,    -1,    -1,  4474,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4483,  2260,  1157,    -1,    -1,    -1,  2265,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2275,    -1,
      -1,    -1,    -1,    -1,    -1,  2282,    -1,    -1,    -1,    -1,
      -1,  2288,    -1,    -1,    -1,    -1,    -1,  2294,    -1,    -1,
      -1,    -1,  2299,    -1,    -1,    -1,  3207,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3226,    -1,    -1,  2325,  2326,
    2327,  2328,    -1,    -1,    -1,  2332,  2333,    -1,    -1,    -1,
    2337,    -1,    -1,  2340,    -1,    -1,    -1,    -1,    -1,    -1,
    3251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2367,    -1,  2369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2378,  2379,  2380,  3285,  2382,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2391,  2392,    -1,    -1,    -1,    -1,
      -1,    -1,  2399,  2400,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1329,    -1,    -1,   816,
      -1,  1334,    -1,  1336,    -1,   822,  1339,    -1,  1341,    -1,
      -1,  1344,  1345,  1346,    -1,    -1,    -1,  1350,    -1,    -1,
    1641,    -1,    -1,    -1,  1357,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   853,    -1,  1371,    -1,
    1373,    -1,    -1,    -1,    -1,  1378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1678,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3418,    -1,    -1,
    1701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   905,    -1,
      -1,    -1,    -1,    -1,    -1,   912,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1224,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2572,    -1,    -1,    -1,    -1,
      -1,    -1,  1763,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1491,  1780,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1500,  1501,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,
    2617,    -1,    -1,    -1,  1517,    -1,    -1,    -1,  1521,  1522,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3540,
      -1,    -1,  1823,    -1,    -1,  1022,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,
      -1,  1058,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1878,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    25,    -1,  1601,  1379,
    1603,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    -1,
    1613,    -1,    -1,    -1,    43,    44,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,
    1663,    -1,    -1,    -1,    -1,    -1,  1669,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3698,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3709,    -1,
      -1,    -1,    -1,    -1,   133,    -1,    -1,  1710,    -1,  1196,
    1713,  1714,    -1,    -1,    -1,    -1,  1203,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2840,  2841,    -1,    -1,  1224,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1766,  2871,    -1,  1253,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,  2069,  3790,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3800,
      -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,  2905,  2906,
    2907,  2908,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1319,   262,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1641,    -1,    -1,    -1,    -1,   295,    -1,    -1,   298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1022,    -1,    -1,
      -1,    -1,  2989,    -1,    -1,    -1,    -1,  2994,    -1,    -1,
     319,    -1,  1379,    -1,    -1,    -1,    -1,    -1,  1678,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1058,    -1,    -1,    -1,    -1,  1405,    -1,
      -1,  1701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1935,    -1,  1937,    -1,    -1,    -1,  1941,    -1,
    1943,    -1,    -1,  1946,    -1,    -1,  1433,  1950,    -1,  3960,
      -1,    -1,  1955,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3078,  3079,  1460,  1461,  3986,  1463,    -1,    -1,    -1,
      -1,    -1,    -1,  1763,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1480,    -1,    -1,    -1,    -1,    -1,    -1,
    1780,    -1,    -1,   432,    -1,    -1,    -1,    -1,  3115,    -1,
      -1,    -1,    -1,    -1,    -1,  2306,   445,    -1,  1798,    -1,
    2311,  2312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,
      -1,  2322,    -1,    -1,    -1,  3142,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1823,  1531,    -1,    -1,    -1,  3155,    -1,
    4061,    -1,    -1,    -1,   483,    -1,    -1,    -1,    -1,    -1,
     489,    -1,    -1,    -1,   493,   494,   495,   496,   497,    -1,
      -1,   500,   501,   502,    -1,    -1,  1563,    -1,   507,   508,
    1567,  1568,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2099,    -1,  1878,    -1,
      -1,    -1,    -1,  2106,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4150,
      -1,    -1,    -1,    -1,    -1,    -1,  2437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1641,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4178,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2498,    -1,    -1,
      -1,    -1,  4223,    -1,  1701,    -1,  4227,  4228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2228,    -1,    -1,    -1,  2232,
      -1,    -1,    -1,    -1,    -1,  2238,    -1,  2240,    -1,    -1,
    2243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1763,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1433,  2069,
      -1,    -1,    -1,  1780,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1798,    -1,    -1,    -1,  1460,  1461,    -1,  1463,    -1,
    2611,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1480,  1823,    -1,  3445,    -1,
      -1,    -1,    -1,  3450,    -1,  3452,  3453,  3454,  3455,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2360,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2368,    -1,  2370,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1870,    -1,  1872,  1531,    -1,    -1,    -1,
      -1,  1878,    -1,    -1,  1881,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3517,  3518,  3519,    -1,  3521,    -1,    -1,    -1,  1563,    -1,
      -1,    -1,  1567,  1568,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1965,    -1,
      -1,    -1,    -1,    -1,    -1,  3592,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3613,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2003,  2004,    -1,    -1,
      -1,    -1,    -1,    -1,  2011,    -1,  2306,  2014,    -1,    -1,
    2017,  2311,  2312,    -1,    -1,    -1,    -1,    -1,  2025,  2026,
      -1,    -1,  2322,    -1,    -1,    -1,  2033,    -1,    -1,  2036,
    2037,  2038,  2039,    -1,    -1,    -1,    -1,    -1,    -1,  2046,
    2047,    -1,  2049,    -1,  2051,    -1,    -1,  2054,    -1,  2572,
    2573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2069,  2070,    -1,  2588,    -1,  2074,    -1,    -1,
      -1,  2078,    -1,  2884,  2885,  2082,  2887,  2084,  2085,  2086,
    2087,  2088,  2089,  2090,  2091,  2092,    -1,  2094,    -1,    -1,
      -1,    -1,    -1,  2100,    -1,    -1,  2103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2928,    -1,  2930,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2172,    -1,    -1,    -1,    -1,
    3797,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3808,    -1,    -1,    -1,    -1,    -1,    -1,  2999,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2498,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2769,    -1,    -1,  3060,
      -1,  2774,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3077,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2286,
    3091,  3908,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3104,    -1,    -1,    -1,    -1,    -1,  2306,
      -1,    -1,    -1,  3930,  2311,  2312,    -1,    -1,    -1,    -1,
      -1,  2611,    -1,    -1,    -1,  2322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3969,    -1,    -1,    -1,  2011,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2033,    -1,
      -1,  2036,    -1,    -1,  2039,    -1,    -1,    -1,    -1,    -1,
      -1,  2046,  2047,    -1,    -1,    -1,  2051,    -1,    -1,  2054,
      -1,    -1,    -1,    -1,    -1,    -1,  3207,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2070,    -1,    -1,    -1,  2074,
      -1,    -1,    -1,  2078,    -1,  3226,    -1,  2082,    -1,  2084,
    2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2435,  2094,
    2437,    -1,    -1,    -1,    -1,  2100,    -1,    -1,  2103,    -1,
    3251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3285,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2498,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2509,  3026,    -1,    -1,    -1,  2172,    -1,    -1,
      -1,    -1,  2519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4156,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3060,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2556,
      -1,    -1,    -1,    -1,    -1,    -1,  3079,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2884,  2885,    -1,  2887,    -1,    -1,
      -1,    -1,  3115,  2600,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2611,    -1,    -1,  3418,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2286,    -1,  2630,  2631,    -1,    -1,    -1,  2928,    -1,
    2930,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1549,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2660,  2661,    -1,    -1,    -1,  2665,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2677,  2678,  2679,  2680,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2689,    -1,    -1,  2692,    -1,  2694,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2704,  2705,  2999,
    2707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2720,    -1,  2722,    -1,    -1,  4345,  2726,
      -1,    -1,    -1,    -1,    -1,    -1,  3026,    -1,    -1,  3540,
      -1,    -1,    -1,    -1,    -1,  2742,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2752,    -1,  2754,  2755,  2756,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3060,    -1,    -1,    -1,  3575,    -1,    -1,    -1,    -1,    -1,
    2435,  2778,    -1,    -1,    -1,    -1,    -1,  3077,    -1,    -1,
    2787,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2796,
      -1,  3091,    -1,    -1,  2801,    -1,    -1,    -1,    -1,    -1,
      -1,  2808,    -1,    -1,  3104,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3141,  3365,    -1,    -1,    -1,    -1,    -1,    -1,  2856,
      -1,    -1,    -1,    -1,  2519,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2884,  2885,    -1,
    2887,    -1,    -1,    -1,    -1,    -1,    -1,  3698,    -1,    -1,
      -1,  2556,    -1,    -1,    -1,  3418,    -1,    -1,  3709,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3207,  3431,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2928,    -1,  2930,    -1,    -1,  3226,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2600,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3251,    -1,    -1,  3477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2631,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3790,
      -1,    -1,    -1,    -1,    -1,  3285,    -1,    -1,    -1,  3800,
      -1,    -1,  2999,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2677,  1918,  2679,  2680,    -1,    -1,    -1,  3026,
      -1,    -1,    -1,    -1,  2689,    -1,    -1,  2692,    -1,  2694,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3060,    -1,  2720,    -1,  2722,    -1,    -1,
      -1,  2726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3091,    -1,    -1,    -1,    -1,  2754,
    2755,  2756,    -1,    -1,    -1,    -1,    -1,  3104,    -1,    -1,
      -1,    -1,    -1,    -1,  2009,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3635,  2778,    -1,  3122,    -1,    -1,  3418,  3126,
      -1,    -1,  2787,    -1,    -1,    -1,    -1,  2032,  3135,    -1,
      -1,  2796,  2037,    -1,  3141,    -1,  2801,    -1,    -1,    -1,
      -1,    -1,    -1,  2808,    -1,    -1,    -1,    -1,    -1,  3960,
      -1,  2056,  2057,    -1,  2059,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3171,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3986,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2856,    -1,  2098,    -1,    -1,    -1,  3204,    -1,    -1,
    3207,    -1,    -1,    -1,    -1,    -1,  3213,    -1,    -1,    -1,
      -1,    -1,  3219,    -1,  3221,    -1,    -1,    -1,    -1,  3226,
    3227,    -1,  3745,  3230,  3231,  3232,  3233,  3234,  3235,  3236,
    3237,  3238,  3239,    -1,    -1,    -1,  3243,  3244,  3761,    -1,
    3540,    -1,    -1,    -1,  3251,    -1,  2151,    -1,    -1,  3256,
    4061,    -1,    -1,    -1,    -1,  3262,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3787,  3272,    -1,    -1,  3275,    -1,
    3277,    -1,    -1,    -1,    -1,  3575,  2181,    -1,  3285,  3286,
    3287,  3288,    -1,    -1,    -1,  3292,  2191,    -1,  3295,  2194,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3313,    -1,  3315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4150,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3876,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4178,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3385,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3698,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3709,
      -1,  3418,  4223,    -1,    -1,    -1,  4227,  4228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3800,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3522,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3540,    -1,    -1,    -1,    -1,  4061,  3204,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3213,    -1,
      -1,    -1,    -1,    -1,  3219,    -1,  3221,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3575,  3576,
    3577,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3243,  3244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3600,    -1,    -1,    -1,  3262,  3605,    -1,
      -1,  3608,    -1,    -1,    -1,    -1,    -1,  3272,    -1,    -1,
    3275,    -1,  3277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3286,    -1,    -1,    -1,    -1,    -1,  3292,    -1,    -1,
    3295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3305,    -1,    -1,    -1,    -1,  3652,    -1,    -1,  3313,    -1,
    3315,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3960,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3688,    -1,    -1,    -1,    -1,  3986,    -1,  3695,  3696,
      -1,  3698,    -1,    -1,    -1,    -1,  3703,  3704,    -1,    -1,
      -1,  3708,  3709,    -1,    -1,    -1,    -1,  3714,  3715,    -1,
      -1,  3718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3729,    -1,    -1,    -1,    -1,    -1,    -1,  2634,
      -1,    -1,    -1,    -1,  3741,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2656,    -1,  2658,    -1,  2660,  2661,  2662,    -1,    -1,
    2665,  4061,  3769,    -1,  2669,    -1,    -1,  4290,    -1,    -1,
      -1,  2676,    -1,    -1,    -1,    -1,  2681,    -1,    -1,    -1,
      -1,  2686,    -1,  3790,    -1,    -1,  2691,    -1,    -1,    -1,
      -1,    -1,    -1,  3800,    -1,  2700,    -1,    -1,    -1,  2704,
    2705,  2706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2718,    -1,    -1,    -1,    -1,    -1,    -1,
    2725,    -1,  2727,  2728,  2729,  2730,  2731,  2732,  2733,  2734,
    2735,  2736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4150,    -1,    -1,    -1,    -1,  2760,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4178,    -1,
      -1,    -1,    -1,    -1,    -1,  3892,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3576,  3577,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4223,    -1,    -1,    -1,  4227,  4228,    -1,
      -1,    -1,    -1,  3940,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3951,    -1,    -1,    -1,  3955,    -1,
      -1,    -1,    -1,  3960,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2866,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3982,    -1,    -1,    -1,  3986,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3652,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4006,
    4007,    -1,    -1,  4010,    -1,    -1,    -1,    -1,    -1,    -1,
    4017,  4018,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3695,  3696,    -1,    -1,    -1,    -1,    -1,  4044,    -1,    -1,
      -1,    -1,    -1,  3708,    -1,    -1,    -1,    -1,    -1,  3714,
    3715,    -1,    -1,  3718,  4061,    -1,    -1,  4064,    -1,    -1,
      -1,    -1,    -1,    -1,  3729,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3741,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4100,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3027,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4148,    -1,  4150,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4177,  4178,    -1,  4180,    -1,  4182,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4220,    -1,    -1,  4223,    -1,    -1,    -1,
    4227,  4228,    -1,    -1,    -1,    -1,    -1,  3892,    -1,    -1,
      -1,    -1,    -1,  3138,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4260,  3159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4286,
      -1,    -1,    -1,    -1,    -1,    -1,  3951,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3203,  4306,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3224,
    3225,    -1,  3227,    -1,    -1,  3230,  3231,  3232,  3233,  3234,
    3235,  3236,  3237,  3238,  3239,  3240,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4350,    -1,  4010,    -1,    -1,    -1,    -1,
    4357,    -1,    -1,  4018,    -1,    -1,    -1,    -1,  3263,    -1,
      -1,  3266,    -1,  3268,    -1,    -1,  4373,  4374,  3273,  3274,
      -1,    -1,    -1,    -1,    -1,    -1,  4383,    -1,    -1,    -1,
      -1,    -1,  3287,  3288,  3289,    -1,  3291,    -1,    -1,  3294,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4410,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4420,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4483,  3382,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4220,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4260,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3522,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    -1,    -1,    -1,    -1,    41,    -1,    43,    44,    -1,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,  4373,  4374,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4410,    -1,    -1,  3653,    -1,
      -1,  3656,  3657,  3658,    -1,  4420,  3661,   133,    -1,    -1,
      -1,  3666,  3667,  3668,  3669,  3670,  3671,  3672,  3673,  3674,
    3675,  3676,  3677,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3702,  3703,  3704,
    3705,    -1,  3707,    -1,    -1,    -1,  3711,  3712,  3713,  4474,
      -1,  3716,    -1,    -1,  3719,    -1,    -1,    -1,    -1,    -1,
      -1,  3726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,
      -1,    -1,    -1,  3738,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,     9,   240,    -1,    -1,    13,    -1,    15,
      -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,   262,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   319,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   101,    -1,   103,   104,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3894,
      -1,   137,    -1,   139,   140,    -1,    -1,    -1,   144,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     156,    -1,   158,    -1,   390,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,   177,  3937,  3938,   180,    -1,    -1,    -1,    -1,    -1,
     186,    -1,    -1,    -1,    -1,    -1,   192,    -1,   194,    -1,
      -1,    -1,   198,    -1,    -1,    -1,   432,    -1,   204,    -1,
      -1,    -1,    -1,    -1,    -1,   211,    -1,   213,    -1,   445,
      -1,    -1,   218,  3978,    -1,    -1,    -1,  3982,    -1,    -1,
      -1,    -1,   458,    -1,    -1,    -1,   232,    -1,    -1,  3994,
      -1,  3996,    -1,    -1,    -1,    -1,  4001,  4002,  4003,    -1,
      -1,  4006,  4007,  4008,  4009,    -1,  4011,   483,    -1,    -1,
      -1,    -1,    -1,   489,   260,    -1,    -1,   493,   494,   495,
     496,   497,    -1,    -1,   500,   501,   502,   503,    -1,   505,
     506,   507,   508,   509,    -1,    -1,    -1,  4042,   284,   285,
      -1,    -1,    -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   352,  4112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   363,    -1,    -1,
      -1,   367,    -1,   369,    -1,    -1,    -1,    -1,   374,    -1,
      -1,    -1,    -1,   379,    -1,    -1,   382,    -1,    -1,    -1,
     386,    -1,    -1,    -1,    -1,    -1,   392,    -1,    -1,    -1,
      -1,    -1,    -1,   399,    -1,    -1,   402,  4162,    -1,    -1,
      -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4176,  4177,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4190,  4191,  4192,    -1,  4194,
      -1,    -1,    -1,   439,    -1,   441,    -1,    -1,    -1,    -1,
      -1,    -1,   448,    -1,   450,    -1,    -1,   453,    -1,    -1,
      -1,   457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   469,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4320,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4349,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,  4413,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4453,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     3,    -1,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,   508,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,    -1,   103,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,
     118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,   137,
      -1,   139,   140,   141,    -1,    -1,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,    -1,
     158,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,   177,
     178,   179,   180,    -1,    -1,    -1,    -1,    -1,   186,    -1,
      -1,    -1,    -1,    -1,   192,    -1,   194,    -1,    -1,    -1,
     198,    -1,    -1,    -1,    -1,    -1,   204,   205,    -1,    -1,
      -1,    -1,    -1,   211,   212,   213,    -1,   215,    -1,    -1,
     218,    -1,   220,    -1,    -1,    -1,    -1,    -1,   226,    -1,
     228,    -1,    -1,    -1,   232,    -1,   234,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,
      -1,    -1,   260,    -1,    -1,   263,    -1,   265,    -1,    -1,
     268,   269,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   279,   280,    -1,   282,    -1,   284,   285,    -1,    -1,
      -1,    -1,   290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   299,    -1,    -1,   302,   303,   304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,   316,   317,
      -1,    -1,   320,    -1,   322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,   336,   337,
     338,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     348,    -1,   350,    -1,   352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   362,   363,    -1,    -1,    -1,   367,
      -1,   369,    -1,    -1,    -1,    -1,   374,    -1,    -1,    -1,
      -1,   379,   380,    -1,   382,   383,    -1,    -1,   386,    -1,
      -1,    -1,    -1,    -1,   392,    -1,    -1,    -1,    -1,    -1,
      -1,   399,   400,    -1,   402,   403,    -1,   405,    -1,    -1,
      -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
      -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   430,   431,    -1,    -1,    -1,   435,    -1,   437,
      -1,   439,    -1,   441,    -1,    -1,    -1,   445,    -1,    -1,
     448,    -1,   450,    -1,    -1,   453,    -1,    -1,    -1,   457,
     458,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   469,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,
     478,   479,   480,   481,   482,     6,     7,     8,    -1,    10,
      11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,   502,    26,    27,    -1,   506,    -1,
      31,    32,    33,    34,    -1,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    -1,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,    -1,   118,   119,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,
     141,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,   179,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,
      -1,   212,    -1,    -1,   215,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,   226,    -1,   228,    -1,    -1,
      -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,   257,    -1,    -1,    -1,
      -1,    -1,   263,    -1,   265,    -1,    -1,   268,   269,    -1,
     271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,   280,
      -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   302,   303,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,
      -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   335,   336,   337,   338,   339,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,   350,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,
      -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   400,
      -1,    -1,   403,    -1,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,
     431,    -1,    -1,    -1,   435,    -1,   437,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,
     461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   476,   477,   478,   479,   480,
     481,   482,    -1,    -1,     6,     7,     8,    -1,    10,    11,
      12,    -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    -1,    -1,   509,    31,
      32,    33,    34,    -1,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    -1,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,    -1,   118,   119,   120,   121,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,   179,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,    -1,   215,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   256,   257,    -1,    -1,    -1,    -1,
      -1,   263,    -1,   265,    -1,    -1,   268,   269,    -1,   271,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,   280,    -1,
     282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     302,   303,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,
     322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   335,   336,   337,   338,   339,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,   350,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,
      -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   400,    -1,
      -1,   403,    -1,   405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,   431,
      -1,    -1,    -1,   435,    -1,   437,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,   461,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   476,   477,   478,   479,   480,   481,
     482,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    -1,   509,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    44,   133,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    -1,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   220,   133,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   205,    -1,   295,    -1,    -1,   298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   295,    -1,    -1,   298,    -1,    -1,
      -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   319,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   390,
      -1,    -1,    -1,    -1,   483,    -1,    -1,    -1,    -1,    -1,
     489,    -1,    -1,    -1,   493,   494,   495,   496,   497,    -1,
      -1,   500,   501,   502,   503,    -1,    -1,    -1,   507,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,
      -1,    -1,   483,    -1,    -1,    -1,    -1,    -1,   489,    -1,
      -1,    -1,   493,   494,   495,   496,   497,    25,    -1,   500,
     501,   502,   503,    -1,    -1,    -1,   507,    35,    36,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    44,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   133,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   319,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   432,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     458,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   483,    -1,    -1,    -1,    -1,
      -1,   489,    -1,    -1,    -1,   493,   494,   495,   496,   497,
      -1,    -1,   500,   501,   502,    -1,    -1,    -1,    -1,   507,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    -1,    -1,
      -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,   193,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,    -1,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,
     495,    -1,    -1,    -1,    -1,    -1,    -1,   502,   503,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,   259,   260,   261,   262,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
     446,   447,   448,   449,   450,   451,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   502,   503,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,    -1,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,    -1,   213,   214,    -1,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,    -1,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,    -1,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,    -1,   315,   316,
     317,   318,    -1,    -1,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,    -1,
     347,    -1,   349,    -1,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
      -1,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,    -1,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
      -1,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   483,   484,   485,    -1,
      -1,    -1,    -1,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,   503,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,    -1,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
      -1,   213,   214,    -1,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,    -1,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,   257,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,    -1,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
      -1,   313,    -1,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,    -1,   347,    -1,   349,    -1,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,    -1,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,    -1,   436,    -1,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,    -1,   458,   459,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   503,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,   500,    15,    16,    -1,   504,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,    -1,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   502,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,    -1,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,
      -1,    -1,    -1,    -1,    -1,   500,   501,   502,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
     107,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,    -1,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   493,   494,   495,    -1,
      -1,    -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,    -1,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,    -1,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,    -1,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   502,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,    -1,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
     107,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,    -1,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,    -1,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,   446,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,   282,    -1,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   502,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,    -1,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,   446,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
     107,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,   259,   260,   261,   262,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,    -1,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   493,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   502,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,   107,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,    -1,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   502,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,   107,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,    -1,    -1,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,    -1,   446,   447,   448,   449,   450,
     451,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   502,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,   107,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,    -1,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,    -1,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
      -1,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,   107,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,    -1,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,   262,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,    -1,    -1,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,   451,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   502,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,   130,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,    -1,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,   502,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,   130,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,   257,    -1,   259,   260,   261,    -1,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,   317,   318,    -1,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,    -1,    -1,   447,   448,   449,   450,   451,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   502,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,   130,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,    -1,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,   257,    -1,
     259,   260,   261,    -1,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
     279,   280,   281,   282,    -1,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
      -1,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,   451,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   502,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,   502,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,   108,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,   280,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,   503,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    28,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    72,    -1,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,
     116,   117,   118,   119,    -1,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,    -1,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
      -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
      -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,   275,
     276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,    -1,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,    -1,    -1,   335,
      -1,    -1,    -1,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,    -1,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,    -1,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   493,   494,   495,
      -1,    -1,    -1,    -1,    -1,    -1,   502,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,    -1,   115,   116,   117,   118,
     119,    -1,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,    -1,   257,    -1,
     259,   260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
      -1,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,    -1,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,   501,   502,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,
     115,   116,   117,   118,   119,    -1,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,    -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,   422,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,   502,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,    -1,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   502,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,   502,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,    -1,   115,   116,   117,   118,   119,    -1,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,    -1,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,    -1,
     163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,
     263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,    -1,   279,    -1,   281,    -1,
      -1,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,    -1,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
      -1,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,    -1,   462,
     463,   464,    -1,    -1,   467,    -1,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,   502,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,    -1,   115,   116,   117,   118,
     119,    -1,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,    -1,   257,    -1,
     259,   260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
      -1,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,    -1,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,   502,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,
     115,   116,   117,   118,   119,    -1,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,    -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,    -1,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,    -1,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,   502,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,    -1,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,   502,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,   502,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    75,    76,    77,    78,    79,    80,    81,    82,
      -1,    -1,    85,    86,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,    -1,
     213,   214,    -1,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,    -1,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,    -1,
     433,   434,    -1,   436,    -1,   438,   439,   440,   441,   442,
     443,   444,    -1,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     483,   484,   485,    -1,    -1,    -1,   489,   490,   491,    -1,
     493,   494,   495,   496,   497,   498,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,    -1,   115,   116,   117,   118,   119,
      -1,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,    -1,   257,    -1,   259,
     260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,    -1,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,    -1,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,   489,
     490,   491,    -1,   493,   494,   495,   496,   497,   498,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,   489,   490,   491,    -1,   493,   494,   495,   496,
     497,   498,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,    -1,   489,   490,   491,    -1,   493,
     494,   495,   496,   497,   498,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,    -1,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,   489,   490,
     491,    -1,   493,   494,   495,   496,   497,   498,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,   489,   490,   491,    -1,   493,   494,   495,   496,   497,
     498,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    26,    27,    28,    -1,    -1,    31,    32,    33,    34,
      -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,    -1,
     115,   116,   117,   118,   119,    -1,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,    -1,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,    -1,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,    -1,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,    -1,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,   274,
     275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,    -1,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,    -1,    -1,    -1,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,    -1,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,    -1,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,    -1,    -1,    -1,   489,   490,   491,    -1,   493,   494,
     495,   496,   497,   498,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,     5,     6,     7,     8,     9,
      10,    11,    12,    13,   495,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,    -1,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,    -1,   213,   214,    -1,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,    -1,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,    -1,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,    -1,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,    -1,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,    -1,   347,    -1,   349,
      -1,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,    -1,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,    -1,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,    -1,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   483,   484,   485,    -1,     6,     7,     8,
       9,    10,    11,    12,    13,   495,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,    -1,   115,   116,   117,   118,
     119,    -1,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,    -1,   257,    -1,
     259,   260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
      -1,   320,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,    -1,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,     6,     7,
       8,     9,    10,    11,    12,    13,   495,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,     6,
       7,     8,     9,    10,    11,    12,    13,   495,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,   328,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   493,   494,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    -1,    26,    27,
      28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,
      38,    39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    72,    -1,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,   117,
     118,   119,    -1,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,   141,    -1,    -1,   144,   145,   146,   147,
      -1,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,
      -1,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,   242,    -1,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,    -1,   257,
      -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,   267,
      -1,    -1,   270,    -1,   272,   273,   274,   275,   276,   277,
      -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,    -1,   315,   316,    -1,
     318,    -1,   320,   321,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,
      -1,   339,   340,   341,   342,   343,   344,   345,    -1,   347,
     348,   349,   350,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,    -1,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,   400,   401,   402,    -1,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,   457,
     458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   493,   494,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    28,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,    -1,   115,   116,   117,   118,
     119,    -1,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,   141,    -1,    -1,   144,   145,   146,   147,    -1,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,    -1,   257,    -1,
     259,   260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,
      -1,   270,    -1,   272,   273,   274,   275,   276,   277,    -1,
     279,    -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,    -1,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    -1,   315,   316,    -1,   318,
      -1,   320,   321,   322,   323,   324,   325,    -1,   327,   328,
      -1,   330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,
     339,   340,   341,   342,   343,   344,   345,    -1,   347,   348,
     349,   350,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,    -1,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,    -1,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,   457,   458,
      -1,   460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   493,   494,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,    -1,   115,   116,   117,   118,   119,
      -1,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,    -1,   227,    -1,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,    -1,   255,    -1,   257,    -1,   259,
     260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,    -1,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,    -1,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   493,   494,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    -1,    26,    27,    28,    -1,    -1,
      31,    32,    33,    34,    -1,    -1,    37,    38,    39,    40,
      -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,    -1,   115,   116,   117,   118,   119,    -1,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
     141,    -1,    -1,   144,   145,   146,   147,    -1,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,   214,   215,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,    -1,   227,    -1,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,   238,   239,   240,
     241,   242,    -1,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,    -1,   255,    -1,   257,    -1,   259,   260,
     261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,
      -1,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,    -1,   318,    -1,   320,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,
     341,   342,   343,   344,   345,    -1,   347,   348,   349,   350,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,    -1,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,    -1,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,   457,   458,    -1,   460,
      -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   493,   494,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    -1,    26,    27,    28,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    37,    38,    39,    40,    -1,
      42,    -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,    -1,   115,   116,   117,   118,   119,    -1,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
      -1,    -1,   144,   145,   146,   147,    -1,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,    -1,   227,    -1,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,   238,   239,   240,   241,
     242,    -1,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,    -1,   255,    -1,   257,    -1,   259,   260,   261,
      -1,   263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,
     272,   273,   274,   275,   276,   277,    -1,   279,    -1,   281,
      -1,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,    -1,   318,    -1,   320,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,
     342,   343,   344,   345,    -1,   347,   348,   349,   350,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,    -1,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,    -1,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,   457,   458,    -1,   460,    -1,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   494,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    28,    -1,    -1,    31,    32,
      33,    34,    -1,    -1,    37,    38,    39,    40,    -1,    42,
      -1,    -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,    -1,   115,   116,   117,   118,   119,    -1,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,    -1,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,   141,    -1,
      -1,   144,   145,   146,   147,    -1,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,    -1,
     163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,    -1,   227,    -1,   229,   230,   231,    -1,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,   242,
      -1,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,    -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,
     263,    -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,
     273,   274,   275,   276,   277,    -1,   279,    -1,   281,    -1,
      -1,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,    -1,   315,   316,    -1,   318,    -1,   320,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,
     343,   344,   345,    -1,   347,   348,   349,   350,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,    -1,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
      -1,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,    -1,   420,   421,    -1,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,   457,   458,    -1,   460,    -1,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     493,   494,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    -1,    26,    27,    28,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    37,    38,    39,    40,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
      -1,   115,   116,   117,   118,   119,    -1,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,   141,    -1,    -1,
     144,   145,   146,   147,    -1,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,    -1,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,    -1,    -1,    -1,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,   242,    -1,
     244,   245,   246,    -1,   248,   249,   250,   251,   252,   253,
      -1,   255,    -1,   257,    -1,   259,   260,   261,    -1,   263,
      -1,   265,    -1,   267,    -1,    -1,   270,    -1,   272,   273,
     274,   275,   276,   277,    -1,   279,    -1,   281,    -1,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
      -1,   315,   316,    -1,   318,    -1,   320,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,    -1,    -1,    -1,   339,   340,   341,   342,   343,
     344,   345,    -1,   347,   348,   349,   350,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,    -1,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,    -1,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,   432,    -1,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,   457,   458,    -1,   460,    -1,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,    -1,    -1,     4,   489,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    28,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    -1,    42,    -1,    -1,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,    -1,   115,   116,   117,   118,   119,
      -1,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,   141,    -1,    -1,   144,   145,   146,   147,    -1,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,    -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,   214,   215,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,    -1,    -1,    -1,   229,
     230,   231,    -1,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,    -1,   257,    -1,   259,
     260,   261,    -1,   263,    -1,   265,    -1,   267,    -1,    -1,
     270,    -1,   272,   273,   274,   275,   276,   277,    -1,   279,
      -1,   281,    -1,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,    -1,   315,   316,    -1,   318,    -1,
     320,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,   335,    -1,    -1,    -1,   339,
     340,   341,   342,   343,   344,   345,    -1,   347,   348,   349,
     350,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,    -1,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,   457,   458,    -1,
     460,    -1,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,   279,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
     317,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,   403,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    15,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,   127,   128,    -1,    -1,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,   140,   141,    -1,    -1,   144,   145,
     146,   147,   148,   149,   150,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,   160,   161,   162,   163,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,    -1,   184,   185,
     186,   187,   188,    -1,   190,   191,   192,    -1,    -1,   195,
     196,   197,   198,   199,    -1,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,   225,
     226,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,   242,   243,   244,   245,
     246,    -1,   248,   249,   250,   251,   252,   253,    -1,   255,
     256,   257,    -1,   259,   260,   261,    -1,   263,    -1,   265,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,    -1,   279,   280,   281,   282,    -1,   284,   285,
     286,    -1,    -1,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,    -1,   315,
     316,   317,   318,    -1,   320,   321,   322,   323,   324,   325,
      -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,    -1,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,    -1,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,    -1,   393,   394,   395,
     396,   397,    -1,   399,   400,   401,   402,   403,   404,   405,
      -1,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,    -1,   420,   421,    -1,   423,   424,   425,
     426,   427,   428,    -1,   430,   431,    -1,    -1,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,    -1,
      -1,   447,   448,   449,   450,    -1,    -1,   453,   454,   455,
     456,   457,   458,    -1,   460,   461,   462,   463,   464,    -1,
      -1,   467,    -1,    -1,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      15,    16,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,   127,   128,    -1,    -1,   131,   132,   133,   134,
     135,    -1,   137,   138,   139,   140,   141,    -1,    -1,   144,
     145,   146,   147,   148,   149,   150,    -1,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,    -1,   184,
     185,   186,   187,   188,    -1,   190,   191,   192,    -1,    -1,
     195,   196,   197,   198,   199,    -1,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,    -1,   217,    -1,   219,   220,   221,    -1,   223,    -1,
     225,   226,    -1,   228,   229,   230,   231,    -1,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,   248,   249,   250,   251,   252,   253,    -1,
     255,   256,   257,    -1,   259,   260,   261,    -1,   263,    -1,
     265,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    -1,   279,   280,   281,   282,    -1,   284,
     285,   286,    -1,    -1,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,    -1,
     315,   316,   317,   318,    -1,   320,   321,   322,   323,   324,
     325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    -1,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,    -1,   393,   394,
     395,   396,   397,    -1,   399,   400,   401,   402,   403,   404,
     405,    -1,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,    -1,   420,   421,    -1,   423,   424,
     425,   426,   427,   428,    -1,   430,   431,    -1,    -1,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
      -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,   454,
     455,   456,   457,   458,    -1,   460,   461,   462,   463,   464,
      -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,   122,    -1,
     124,   125,   126,   127,   128,    -1,    -1,   131,   132,   133,
     134,   135,    -1,   137,   138,   139,   140,    -1,    -1,    -1,
     144,   145,   146,   147,   148,   149,   150,    -1,   152,   153,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,   173,
     174,   175,   176,   177,   178,   179,   180,    -1,   182,    -1,
     184,   185,   186,   187,   188,    -1,   190,   191,   192,    -1,
      -1,   195,   196,   197,   198,   199,    -1,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,    -1,   213,
     214,    -1,    -1,   217,    -1,   219,   220,   221,    -1,   223,
      -1,   225,   226,    -1,   228,   229,   230,   231,    -1,   233,
      -1,    -1,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
      -1,   255,   256,   257,    -1,   259,   260,   261,   262,   263,
      -1,   265,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,    -1,    -1,   280,   281,   282,    -1,
     284,   285,   286,    -1,    -1,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,    -1,   313,
      -1,   315,   316,   317,   318,    -1,    -1,   321,   322,   323,
     324,   325,    -1,   327,    -1,    -1,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,    -1,   340,   341,   342,   343,
     344,   345,    -1,   347,    -1,   349,    -1,   351,   352,   353,
      -1,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,    -1,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,    -1,   393,
     394,   395,   396,   397,    -1,   399,   400,   401,   402,   403,
     404,   405,    -1,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,    -1,   418,    -1,   420,   421,    -1,   423,
     424,   425,   426,   427,   428,    -1,   430,   431,    -1,    -1,
     434,    -1,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,   453,
     454,   455,   456,    -1,   458,   459,   460,   461,   462,   463,
     464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,   473,
     474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   483,
     484,   485,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    15,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,    -1,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,   122,
      -1,   124,   125,   126,   127,   128,    -1,    -1,   131,   132,
     133,   134,   135,    -1,   137,   138,   139,   140,    -1,    -1,
      -1,   144,   145,   146,   147,   148,   149,   150,    -1,   152,
     153,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   172,
     173,   174,   175,   176,   177,   178,   179,   180,    -1,   182,
      -1,   184,   185,   186,   187,   188,    -1,   190,   191,   192,
      -1,    -1,   195,   196,   197,   198,   199,    -1,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,    -1,
     213,   214,    -1,    -1,   217,    -1,   219,   220,   221,    -1,
     223,    -1,   225,   226,    -1,   228,   229,   230,   231,    -1,
     233,    -1,    -1,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,    -1,   248,   249,   250,   251,   252,
     253,    -1,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,    -1,   265,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,    -1,    -1,   280,   281,   282,
      -1,   284,   285,   286,    -1,    -1,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,    -1,
     313,    -1,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,    -1,    -1,   330,   331,   332,
      -1,    -1,    -1,   336,   337,   338,    -1,   340,   341,   342,
     343,   344,   345,    -1,   347,    -1,   349,    -1,   351,   352,
     353,    -1,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,    -1,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,    -1,
     393,   394,   395,   396,   397,    -1,   399,   400,   401,   402,
     403,   404,   405,    -1,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,    -1,   418,    -1,   420,   421,   422,
     423,   424,   425,   426,   427,   428,    -1,   430,   431,    -1,
      -1,   434,    -1,   436,    -1,    -1,   439,   440,   441,   442,
     443,   444,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
     453,   454,   455,   456,    -1,   458,    -1,   460,   461,   462,
     463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,   472,
     473,   474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     483,   484,   485,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    15,    16,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    -1,    -1,    -1,    50,    51,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,   111,
      -1,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
     122,    -1,   124,   125,   126,   127,   128,    -1,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,    -1,
      -1,    -1,   144,   145,   146,   147,   148,   149,   150,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
     172,   173,   174,   175,   176,   177,   178,   179,   180,    -1,
     182,    -1,   184,   185,   186,   187,   188,    -1,   190,   191,
     192,    -1,    -1,   195,   196,   197,   198,   199,    -1,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
      -1,   213,   214,    -1,    -1,   217,    -1,   219,   220,   221,
      -1,   223,    -1,   225,   226,    -1,   228,   229,   230,   231,
      -1,   233,    -1,    -1,   236,    -1,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,   253,    -1,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,    -1,   265,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,    -1,    -1,   280,   281,
     282,    -1,   284,   285,   286,    -1,    -1,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,    -1,   315,   316,   317,   318,    -1,    -1,   321,
     322,   323,   324,   325,    -1,   327,    -1,    -1,   330,   331,
     332,    -1,    -1,    -1,   336,   337,   338,    -1,   340,   341,
     342,   343,   344,   345,    -1,   347,    -1,   349,    -1,   351,
     352,   353,    -1,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,    -1,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
      -1,   393,   394,   395,   396,   397,    -1,   399,   400,   401,
     402,   403,   404,   405,    -1,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,    -1,   418,    -1,   420,   421,
      -1,   423,   424,   425,   426,   427,   428,    -1,   430,   431,
      -1,    -1,   434,    -1,   436,    -1,    -1,   439,   440,   441,
     442,   443,   444,    -1,    -1,   447,   448,   449,   450,    -1,
      -1,   453,   454,   455,   456,    -1,   458,    -1,   460,   461,
     462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,   471,
     472,   473,   474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   483,   484,   485,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    15,    16,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,    50,
      51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,    -1,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,   122,    -1,   124,   125,   126,   127,   128,    -1,    -1,
     131,   132,   133,   134,   135,    -1,   137,   138,   139,   140,
      -1,    -1,    -1,   144,   145,   146,   147,   148,   149,   150,
      -1,   152,   153,   154,   155,   156,   157,    -1,   159,   160,
     161,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,    -1,
      -1,   172,   173,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,    -1,   184,   185,   186,   187,   188,    -1,   190,
     191,   192,    -1,    -1,   195,   196,   197,   198,   199,    -1,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,    -1,   213,   214,    -1,    -1,   217,    -1,   219,   220,
     221,    -1,   223,    -1,   225,   226,    -1,   228,   229,   230,
     231,    -1,   233,    -1,    -1,   236,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,    -1,   248,   249,   250,
     251,   252,   253,    -1,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,    -1,   265,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,    -1,   280,
     281,   282,    -1,   284,   285,   286,    -1,    -1,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    -1,   315,   316,   317,   318,    -1,    -1,
     321,   322,   323,   324,   325,    -1,   327,    -1,    -1,   330,
     331,   332,    -1,    -1,    -1,   336,   337,   338,    -1,   340,
     341,   342,   343,   344,   345,    -1,   347,    -1,   349,    -1,
     351,   352,   353,    -1,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,    -1,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,    -1,   393,   394,   395,   396,   397,    -1,   399,   400,
     401,   402,   403,   404,   405,    -1,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,    -1,   418,    -1,   420,
     421,    -1,   423,   424,   425,   426,   427,   428,    -1,   430,
     431,    -1,    -1,   434,    -1,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,    -1,    -1,   447,   448,   449,   450,
      -1,    -1,   453,   454,   455,   456,    -1,   458,    -1,   460,
     461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,   470,
     471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   483,   484,   485,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    15,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,   111,    -1,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,    -1,   124,   125,   126,   127,   128,    -1,
      -1,   131,   132,   133,   134,   135,    -1,   137,   138,   139,
     140,    -1,    -1,    -1,   144,   145,   146,   147,   148,   149,
     150,    -1,   152,   153,   154,   155,   156,   157,    -1,   159,
     160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,   172,   173,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,    -1,   184,   185,   186,   187,   188,    -1,
     190,   191,   192,    -1,    -1,   195,   196,   197,   198,   199,
      -1,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,    -1,   213,   214,    -1,    -1,   217,    -1,   219,
     220,   221,    -1,   223,    -1,   225,   226,    -1,   228,   229,
     230,   231,    -1,   233,    -1,    -1,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,    -1,   248,   249,
     250,   251,   252,   253,    -1,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,    -1,   265,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,    -1,    -1,
     280,   281,   282,    -1,   284,   285,   286,    -1,    -1,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,    -1,   313,    -1,   315,   316,   317,   318,    -1,
      -1,   321,   322,   323,   324,   325,    -1,   327,    -1,    -1,
     330,   331,   332,    -1,    -1,    -1,   336,   337,   338,    -1,
     340,   341,   342,   343,   344,   345,    -1,   347,    -1,   349,
      -1,   351,   352,   353,    -1,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,    -1,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,    -1,   393,   394,   395,   396,   397,    -1,   399,
     400,   401,   402,   403,   404,   405,    -1,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,    -1,   418,    -1,
     420,   421,    -1,   423,   424,   425,   426,   427,   428,    -1,
     430,   431,    -1,    -1,   434,    -1,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,    -1,    -1,   447,   448,   449,
     450,    -1,    -1,   453,   454,   455,   456,    -1,   458,    -1,
     460,   461,   462,   463,   464,    -1,    -1,   467,    -1,    -1,
     470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   483,   484,   485,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    15,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    46,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,
      69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   110,   111,    -1,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,   122,    -1,   124,   125,   126,   127,   128,
      -1,    -1,   131,   132,   133,   134,   135,    -1,   137,   138,
     139,   140,    -1,    -1,    -1,   144,   145,   146,   147,   148,
     149,   150,    -1,   152,   153,   154,   155,   156,   157,    -1,
     159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,   172,   173,   174,   175,   176,   177,   178,
     179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
      -1,   190,   191,   192,    -1,    -1,   195,   196,   197,   198,
     199,    -1,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,    -1,   213,   214,    -1,    -1,   217,    -1,
     219,   220,   221,    -1,   223,    -1,   225,   226,    -1,   228,
     229,   230,   231,    -1,   233,    -1,    -1,   236,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,   248,
     249,   250,   251,   252,   253,    -1,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,    -1,   265,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,    -1,
      -1,   280,   281,   282,    -1,   284,   285,   286,    -1,    -1,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,    -1,   313,    -1,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,    -1,   327,    -1,
      -1,   330,   331,   332,    -1,    -1,    -1,   336,   337,   338,
      -1,   340,   341,   342,   343,   344,   345,    -1,   347,    -1,
     349,    -1,   351,   352,   353,    -1,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,    -1,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,    -1,   393,   394,   395,   396,   397,    -1,
     399,   400,   401,   402,   403,   404,   405,    -1,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,    -1,   418,
      -1,   420,   421,    -1,   423,   424,   425,   426,   427,   428,
      -1,   430,   431,    -1,    -1,   434,    -1,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,    -1,    -1,   447,   448,
     449,   450,    -1,    -1,   453,   454,   455,   456,    -1,   458,
      -1,   460,   461,   462,   463,   464,    -1,    -1,   467,    -1,
      -1,   470,   471,   472,   473,   474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   483,   484,   485,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    15,    16,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    67,
      -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,   111,    -1,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,   122,    -1,   124,   125,   126,   127,
     128,    -1,    -1,   131,   132,   133,   134,   135,    -1,   137,
     138,   139,   140,    -1,    -1,    -1,   144,   145,   146,   147,
     148,   149,   150,    -1,   152,   153,   154,   155,   156,   157,
      -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,    -1,
     168,    -1,    -1,    -1,   172,   173,   174,   175,   176,   177,
     178,   179,   180,    -1,   182,    -1,   184,   185,   186,   187,
     188,    -1,   190,   191,   192,    -1,    -1,   195,   196,   197,
     198,   199,    -1,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,    -1,   213,   214,    -1,    -1,   217,
      -1,   219,   220,   221,    -1,   223,    -1,   225,   226,    -1,
     228,   229,   230,   231,    -1,   233,    -1,    -1,   236,    -1,
     238,   239,   240,   241,   242,   243,   244,   245,   246,    -1,
     248,   249,   250,   251,   252,   253,    -1,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,    -1,   265,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
      -1,    -1,   280,   281,   282,    -1,   284,   285,   286,    -1,
      -1,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,    -1,   313,    -1,   315,   316,   317,
     318,    -1,    -1,   321,   322,   323,   324,   325,    -1,   327,
      -1,    -1,   330,   331,   332,    -1,    -1,    -1,   336,   337,
     338,    -1,   340,   341,   342,   343,   344,   345,    -1,   347,
      -1,   349,    -1,   351,   352,   353,    -1,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,    -1,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,    -1,   393,   394,   395,   396,   397,
      -1,   399,    -1,   401,   402,   403,   404,   405,    -1,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,    -1,
     418,    -1,   420,   421,    -1,   423,   424,   425,   426,   427,
     428,    -1,   430,   431,    -1,    -1,   434,    -1,   436,    -1,
      -1,   439,   440,   441,   442,   443,   444,    -1,    -1,   447,
     448,   449,   450,    -1,    -1,   453,   454,   455,   456,    -1,
     458,    -1,   460,   461,   462,   463,   464,    -1,    -1,   467,
      -1,    -1,   470,   471,   472,   473,   474,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   483,   484,   485,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,    -1,    -1,   120,    -1,    -1,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,    -1,    -1,   135,    -1,
     137,   138,   139,   140,    -1,    -1,    -1,   144,   145,   146,
     147,   148,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,   163,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,    -1,    -1,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,    -1,   213,   214,    -1,    -1,
     217,    -1,   219,    -1,   221,    -1,   223,    -1,   225,   226,
      -1,   228,   229,   230,   231,    -1,   233,    -1,    -1,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,   256,
      -1,    -1,   259,   260,   261,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,    -1,    -1,   280,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,    -1,   303,    -1,   305,   306,
     307,   308,   309,   310,   311,    -1,   313,    -1,   315,   316,
     317,   318,    -1,    -1,   321,    -1,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,    -1,   336,
     337,   338,    -1,   340,   341,   342,   343,   344,   345,    -1,
     347,    -1,   349,    -1,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,    -1,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,    -1,   401,   402,   403,   404,    -1,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
      -1,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,    -1,    -1,    -1,    -1,   434,    -1,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
      -1,    -1,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    -1,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,    -1,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,    -1,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,    -1,   259,   260,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,    -1,   296,
     297,    -1,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,    -1,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,    -1,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    -1,    86,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,   328,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,   432,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,   282,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,   232,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,   232,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,   446,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,   164,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,   224,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,   461,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,   422,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,   451,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,   329,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,   108,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,   108,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,   452,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,   108,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,    -1,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,    -1,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,   344,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    28,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      37,    38,    39,    40,    -1,    42,    -1,    -1,    45,    46,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,    -1,   113,    -1,   115,   116,
     117,   118,   119,    -1,   121,   122,    -1,   124,   125,   126,
     127,   128,    -1,    -1,   131,   132,   133,   134,   135,    -1,
     137,   138,   139,   140,   141,    -1,    -1,   144,   145,   146,
     147,    -1,   149,   150,    -1,   152,   153,   154,   155,   156,
     157,    -1,   159,   160,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   172,   173,   174,   175,   176,
     177,   178,   179,   180,    -1,   182,    -1,   184,   185,   186,
     187,   188,    -1,   190,   191,   192,    -1,    -1,   195,   196,
     197,   198,   199,    -1,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,    -1,   219,   220,   221,    -1,   223,    -1,   225,    -1,
      -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,   238,   239,   240,   241,   242,    -1,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,   253,    -1,   255,    -1,
     257,    -1,   259,   260,   261,    -1,   263,    -1,   265,    -1,
     267,    -1,    -1,   270,    -1,   272,   273,   274,   275,   276,
     277,    -1,   279,    -1,   281,    -1,    -1,   284,   285,   286,
      -1,    -1,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,    -1,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,    -1,   315,   316,
      -1,   318,    -1,   320,   321,   322,   323,   324,   325,    -1,
     327,    -1,    -1,   330,   331,   332,    -1,    -1,   335,    -1,
      -1,    -1,   339,   340,   341,   342,   343,    -1,   345,    -1,
     347,   348,   349,   350,   351,   352,   353,    -1,   355,   356,
     357,   358,   359,    -1,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
      -1,   378,   379,    -1,   381,   382,   383,    -1,   385,   386,
     387,   388,   389,   390,   391,    -1,   393,   394,   395,   396,
     397,    -1,   399,   400,   401,   402,    -1,   404,   405,    -1,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,    -1,   420,   421,    -1,   423,   424,   425,   426,
     427,   428,    -1,   430,   431,    -1,    -1,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,    -1,    -1,
     447,   448,   449,   450,    -1,    -1,   453,   454,   455,   456,
     457,   458,    -1,   460,    -1,   462,   463,   464,    -1,    -1,
     467,    -1,    -1,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,     6,
       7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,    16,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    26,
      27,    -1,    -1,    -1,    31,    32,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,
      67,    -1,    69,    70,    71,    -1,    73,    -1,    -1,    -1,
      -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
      -1,   118,   119,   120,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,
      -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,   179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,
      -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,   215,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,   226,
      -1,   228,    -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,
     257,    -1,    -1,    -1,    -1,    -1,   263,    -1,   265,    -1,
      -1,   268,   269,    -1,   271,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,   280,    -1,   282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,   303,   304,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,
     317,    -1,    -1,   320,    -1,   322,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,   336,
     337,   338,   339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   348,    -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   380,    -1,    -1,   383,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   400,    -1,    -1,   403,    -1,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   430,   431,    -1,    -1,    -1,   435,    -1,
     437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   458,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,
     477,   478,   479,   480,   481,   482,     6,     7,     8,    -1,
      10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,    19,
      20,    21,    22,    23,    24,    -1,    26,    27,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    67,    -1,    69,
      70,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,   118,   119,
     120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,   148,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,   179,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,   212,    -1,    -1,   215,    -1,    -1,    -1,    -1,
     220,    -1,    -1,    -1,    -1,    -1,   226,    -1,   228,    -1,
      -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   256,   257,    -1,    -1,
      -1,    -1,    -1,   263,    -1,   265,    -1,    -1,   268,   269,
      -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   279,
     280,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   302,   303,   304,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   312,    -1,    -1,    -1,    -1,   317,    -1,    -1,
     320,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   335,   336,   337,   338,   339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   348,    -1,
     350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     380,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     400,    -1,    -1,   403,    -1,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     430,   431,    -1,    -1,    -1,   435,    -1,   437,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,    -1,
      -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,   477,   478,   479,
     480,   481,   482,     6,     7,     8,    -1,    10,    11,    12,
      -1,    -1,    -1,    16,    -1,    -1,    19,    20,    21,    22,
      23,    24,    -1,    26,    27,    -1,    -1,    -1,    31,    32,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    69,    -1,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,    -1,   118,   119,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   134,    -1,    -1,    -1,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,    -1,   148,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,   179,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,    -1,   212,
      -1,    -1,   215,    -1,    -1,    -1,    -1,   220,    -1,    -1,
      -1,    -1,    -1,   226,    -1,   228,    -1,    -1,    -1,    -1,
      -1,   234,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   256,   257,    -1,    -1,    -1,    -1,    -1,
     263,    -1,   265,    -1,    -1,   268,   269,    -1,   271,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,   280,    -1,   282,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   302,
     303,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,
      -1,    -1,    -1,    -1,   317,    -1,    -1,   320,    -1,   322,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   335,   336,   337,   338,   339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   348,    -1,   350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   380,    -1,    -1,
     383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   400,    -1,    -1,
     403,    -1,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,   431,    -1,
      -1,    -1,   435,    -1,   437,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   458,    -1,    -1,   461,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   475,   476,   477,   478,   479,   480,   481,   482,
       6,     7,     8,    -1,    10,    11,    12,    -1,    -1,    -1,
      16,    -1,    -1,    19,    20,    21,    22,    23,    24,    -1,
      26,    27,    -1,    -1,    -1,    31,    32,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
      -1,    -1,   118,   119,   120,   121,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,    -1,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,   148,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,   179,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,    -1,   212,    -1,    -1,   215,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
     226,    -1,   228,    -1,    -1,    -1,    -1,    -1,   234,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     256,   257,    -1,    -1,    -1,    -1,    -1,   263,    -1,   265,
      -1,    -1,   268,   269,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   279,   280,    -1,   282,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   302,   303,   304,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,    -1,
      -1,   317,    -1,    -1,   320,    -1,   322,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   335,
     336,   337,   338,   339,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   348,    -1,   350,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   362,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   380,    -1,    -1,   383,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   400,    -1,    -1,   403,    -1,   405,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   430,   431,    -1,    -1,    -1,   435,
      -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   458,    -1,    -1,   461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     476,   477,   478,   479,   480,   481,   482,     6,     7,     8,
      -1,    10,    11,    12,    -1,    -1,    -1,    16,    -1,    -1,
      19,    20,    21,    22,    23,    24,    -1,    26,    27,    -1,
      -1,    -1,    31,    32,    33,    34,    -1,    -1,    37,    38,
      39,    40,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,   118,
     119,   120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,   148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
     179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   212,    -1,    -1,   215,    -1,    -1,    -1,
      -1,   220,    -1,    -1,    -1,    -1,    -1,   226,    -1,   228,
      -1,    -1,    -1,    -1,    -1,   234,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,   257,    -1,
      -1,    -1,    -1,    -1,   263,    -1,   265,    -1,    -1,   268,
     269,    -1,   271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     279,   280,    -1,   282,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   302,   303,   304,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,   317,    -1,
      -1,   320,    -1,   322,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   335,   336,   337,   338,
     339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   348,
      -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   400,    -1,    -1,   403,    -1,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   430,   431,    -1,    -1,    -1,   435,    -1,   437,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   458,
      -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,   478,
     479,   480,   481,   482
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   511,  1018,     0,     5,    25,    35,    36,    41,    43,
      44,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    73,    75,    76,    77,
      78,    79,    80,    81,    82,    86,   133,   205,   220,   240,
     262,   295,   298,   319,   390,   432,   445,   458,   483,   489,
     493,   494,   495,   496,   497,   500,   501,   502,   503,   505,
     506,   507,   508,   509,  1011,  1019,  1047,  1049,  1140,  1150,
    1151,  1153,  1159,  1160,  1048,     3,     6,     7,     8,     9,
      10,    11,    12,    13,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    26,    27,    28,    31,    32,    33,
      34,    36,    37,    38,    39,    40,    42,    43,    44,    45,
      46,    50,    51,    56,    65,    67,    69,    70,    91,   101,
     103,   104,   113,   114,   117,   118,   119,   120,   121,   122,
     134,   137,   139,   140,   141,   144,   146,   148,   156,   158,
     162,   168,   175,   177,   178,   179,   180,   186,   192,   194,
     198,   204,   205,   211,   212,   213,   215,   218,   220,   226,
     228,   232,   234,   243,   256,   257,   260,   263,   265,   268,
     269,   271,   279,   280,   282,   284,   285,   290,   299,   302,
     303,   304,   312,   316,   317,   320,   322,   335,   336,   337,
     338,   339,   348,   350,   352,   362,   363,   367,   369,   374,
     379,   380,   382,   383,   386,   392,   399,   400,   402,   403,
     405,   409,   417,   422,   430,   431,   435,   437,   439,   441,
     445,   448,   450,   453,   457,   458,   461,   469,   475,   476,
     477,   478,   479,   480,   481,   482,   502,   512,   513,   519,
     520,   522,   523,   524,   525,   526,   527,   528,   530,   531,
     535,   545,   547,   548,   551,   552,   553,   563,   564,   579,
     619,   620,   627,   633,   635,   637,   638,   639,   640,   649,
     653,   654,   655,   657,   658,   659,   673,   674,   675,   676,
     687,   693,   694,   697,   698,   699,   700,   701,   706,   708,
     711,   715,   716,   726,   727,   730,   735,   745,   764,   767,
     768,   769,   772,   775,   777,   779,   782,   785,   786,   787,
     794,   795,   797,   798,   799,   804,   806,   807,   811,   812,
     815,   816,   817,   819,   820,   821,   822,   824,   827,   828,
     833,   839,   842,   844,   849,   851,   855,   862,   866,   867,
     868,   869,   870,   871,   900,  1015,  1016,  1020,  1022,  1023,
    1040,  1041,  1042,  1043,  1054,  1056,  1060,  1061,  1062,  1063,
    1064,  1066,  1068,  1070,  1071,  1072,  1073,  1075,  1080,  1081,
    1085,  1086,  1095,  1097,  1098,  1099,  1102,  1107,  1110,  1115,
    1117,  1118,  1121,  1123,  1126,  1135,  1153,  1161,    73,  1043,
    1051,  1052,    14,     9,    13,    15,    28,    45,    46,    50,
      51,    56,    65,    67,    69,    70,    72,    91,    92,    93,
      94,    95,    96,    97,    98,   100,   101,   102,   110,   111,
     113,   115,   116,   117,   124,   125,   126,   127,   128,   131,
     132,   133,   135,   137,   138,   139,   140,   144,   145,   146,
     147,   149,   150,   152,   153,   154,   155,   156,   157,   159,
     160,   161,   163,   172,   173,   174,   175,   176,   177,   180,
     182,   184,   185,   186,   187,   188,   190,   191,   192,   195,
     196,   197,   198,   199,   201,   202,   203,   205,   206,   208,
     209,   210,   211,   213,   214,   217,   219,   221,   223,   225,
     229,   230,   231,   233,   236,   238,   239,   240,   241,   242,
     244,   245,   246,   248,   249,   250,   251,   252,   253,   255,
     259,   260,   261,   267,   270,   272,   273,   274,   275,   276,
     277,   281,   284,   285,   286,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   305,   306,
     307,   308,   309,   310,   311,   313,   315,   316,   318,   321,
     323,   324,   325,   327,   330,   331,   332,   340,   341,   342,
     343,   344,   345,   347,   349,   351,   352,   353,   355,   356,
     357,   358,   359,   360,   361,   363,   364,   365,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   378,   379,
     381,   382,   384,   385,   386,   387,   388,   389,   390,   391,
     393,   394,   395,   396,   397,   399,   401,   402,   404,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   418,
     420,   421,   423,   424,   425,   426,   427,   428,   432,   434,
     436,   439,   440,   441,   442,   443,   444,   447,   448,   449,
     450,   453,   454,   455,   456,   457,   460,   462,   463,   464,
     467,   470,   471,   472,   473,   474,   483,   484,   485,  1012,
    1014,  1015,  1033,  1034,  1125,  1126,  1127,  1131,  1136,  1137,
    1138,  1145,  1147,  1151,  1153,    29,   258,  1096,    99,   164,
     181,  1004,  1035,  1082,  1083,  1131,  1147,    99,   863,  1003,
    1035,  1131,  1144,    14,   863,     5,    25,    29,    35,    36,
      43,    44,    99,   103,   104,   105,   106,   107,   108,   109,
     112,   123,   129,   130,   133,   136,   142,   143,   150,   151,
     158,   164,   165,   166,   167,   169,   170,   171,   181,   183,
     189,   193,   194,   200,   204,   207,   216,   218,   222,   224,
     227,   232,   235,   237,   247,   254,   258,   262,   264,   266,
     278,   283,   287,   288,   314,   319,   326,   328,   329,   333,
     334,   346,   354,   366,   377,   392,   398,   406,   419,   422,
     429,   432,   433,   438,   445,   446,   451,   452,   457,   459,
     465,   466,   468,   469,  1014,  1017,  1127,  1128,  1129,  1133,
    1134,  1135,  1136,  1138,    25,    35,   133,   262,  1122,    38,
      40,   314,  1055,   434,   471,   800,    98,   155,   175,   181,
     196,   224,   229,   235,   250,   274,   330,   357,   381,   387,
     393,   396,   422,   424,   428,   436,   441,   451,   463,   634,
    1083,   180,   800,    99,   863,   461,   829,   328,   353,   800,
     120,   570,   867,    98,   110,   130,   151,   175,   181,   196,
     224,   231,   235,   286,   330,   333,   381,   387,   396,   424,
     425,   427,   428,   436,   441,   446,   451,   580,   690,   736,
     746,  1004,  1024,  1025,  1026,  1035,  1151,  1153,    14,    99,
     352,  1003,  1035,  1039,   410,   863,   227,    99,   347,   425,
     427,   273,   773,   774,  1151,    98,   110,   130,   155,   175,
     196,   224,   229,   235,   250,   330,   340,   381,   385,   387,
     393,   396,   422,   424,   428,   436,   441,   451,   463,   634,
     702,   800,   508,  1065,  1129,   244,  1039,   158,   180,   211,
     461,   502,   828,   834,   842,   844,   849,   855,   862,   866,
    1020,    92,    99,   115,   219,   225,   227,   247,   275,   305,
     355,   368,   493,   494,   712,   713,   863,  1011,  1013,  1145,
    1147,    99,   158,   366,   392,   717,   718,   719,  1131,   266,
    1131,  1008,  1151,   422,   876,   115,   225,   712,  1131,   434,
    1039,   340,   175,   250,   421,   422,   780,   386,  1131,    99,
     133,   397,   430,   434,   457,   537,  1014,  1015,  1125,  1130,
    1136,  1138,  1153,    96,   232,   717,   718,   353,   800,  1131,
      99,   193,   878,     4,    14,   131,   150,   152,   286,   301,
     381,   387,   397,   430,   434,   474,   536,   537,    99,   397,
     430,   434,   537,   434,   329,   909,  1001,  1131,   876,  1119,
    1129,   495,  1131,   909,   911,   228,   502,   830,   502,   997,
     365,   872,   873,  1003,   867,   868,   506,   829,   207,   264,
     334,   445,   879,   880,   867,   869,   870,   505,   117,   512,
    1063,  1066,  1062,  1058,   506,  1067,  1069,     5,    25,    35,
     133,   197,   262,  1074,   176,   240,   295,   298,   390,   483,
     502,   939,   940,  1046,  1050,  1140,    73,  1043,  1003,  1035,
    1154,   181,  1024,    21,   452,   496,  1039,  1039,  1154,   452,
    1087,  1088,  1089,    25,   262,   262,  1133,     7,    19,    20,
      39,    42,   154,   194,  1124,  1124,    16,  1063,  1009,  1016,
    1125,  1128,  1131,  1132,  1136,  1137,  1153,   704,  1131,  1004,
     356,   704,   174,   725,  1009,  1012,  1001,   323,    85,   138,
     217,   489,   490,   491,   493,   494,   495,   496,   497,   498,
     771,   964,   965,  1131,  1012,  1003,  1001,  1003,   909,  1003,
     389,  1003,   704,   292,  1012,  1001,   273,    34,   270,   361,
     801,   802,   803,  1001,  1007,  1131,    98,   130,   143,   151,
     155,   175,   196,   229,   250,   274,   330,   381,   385,   387,
     393,   422,   424,   428,   436,   441,   463,   634,   709,  1151,
    1001,   432,  1009,  1003,   502,   436,  1004,   704,   174,   425,
     427,  1012,   425,   427,   138,   217,   771,   372,  1012,   532,
    1131,  1003,  1003,   389,  1003,   704,   292,  1012,   393,   422,
     463,   155,   250,   229,   385,   440,   628,    85,  1027,  1028,
     507,  1147,  1154,    99,  1039,  1153,   864,   911,   544,  1131,
    1151,   774,   242,  1009,  1003,   242,   778,   242,  1004,   174,
     242,  1009,   242,  1002,  1003,   138,   217,   242,   771,   124,
     242,  1002,   242,  1003,   242,  1003,   242,  1003,   389,   242,
    1003,   242,   292,  1002,   273,   242,   703,   704,   502,   508,
    1155,  1156,  1157,  1158,  1160,  1065,    71,  1035,  1084,   502,
     843,   580,   863,   834,   457,   461,   828,   835,   836,   837,
    1131,   829,  1013,   713,   714,    99,   713,   863,  1013,   714,
      99,   713,   863,  1013,   714,   714,   714,  1013,  1011,  1011,
     266,   452,  1089,  1090,  1164,  1165,   863,   714,   356,   502,
     502,   598,   598,   598,   328,   432,   505,   598,  1001,   909,
     910,   713,   863,   713,   863,   505,   796,  1151,   227,   502,
     840,   124,  1003,  1003,  1001,  1131,   114,   485,   270,   504,
     331,   331,   328,   227,  1151,   432,   328,    83,    84,    85,
      87,   107,   119,   121,   122,   129,   130,   133,   134,   141,
     165,   166,   167,   168,   169,   170,   171,   178,   179,   197,
     212,   215,   216,   220,   234,   262,   263,   265,   279,   287,
     288,   302,   304,   314,   319,   320,   322,   330,   339,   348,
     362,   383,   398,   405,   417,   430,   431,   435,   437,   438,
     446,   451,   458,   476,   477,   478,   479,   480,   481,   482,
     493,   494,   495,   502,   867,   920,   923,   926,   927,   928,
     930,   931,   932,   933,   936,   937,   941,   943,   944,   962,
     966,   985,   990,   998,   999,  1009,  1010,  1011,  1131,  1143,
    1145,  1147,  1148,  1149,  1150,  1151,   432,   489,  1154,  1151,
     432,   489,  1083,    99,   549,  1000,  1001,   397,   536,   181,
     543,  1151,   544,  1151,   114,   135,   536,   485,   802,   331,
     227,   432,   489,   114,   485,   270,  1164,   803,   502,  1001,
     495,   500,   504,   991,   992,   910,  1135,   108,  1131,   399,
     226,   228,   461,   825,   826,   828,   226,   831,   181,   941,
     995,   996,   872,   505,   502,   832,   503,   503,  1001,    99,
     193,   877,   877,   124,   877,   218,   222,   283,   326,   883,
     885,   886,   895,   897,   898,   879,   880,   997,   506,  1057,
     495,  1076,  1077,  1079,   508,   508,    25,   262,   262,   432,
     432,   432,   432,   502,   432,   494,   625,  1013,  1044,  1150,
     204,   108,  1031,   124,  1034,  1034,   266,  1089,  1091,   266,
    1089,  1090,  1091,   456,  1100,  1101,  1147,    14,    37,    84,
     493,   494,  1011,  1092,  1093,  1094,  1143,  1145,  1149,  1150,
    1151,  1152,   262,   268,  1003,   432,  1003,     6,  1003,  1124,
    1079,   502,   681,   992,   341,   370,   504,   705,   341,   370,
     399,   469,   514,   545,   546,   731,    95,   198,   341,   399,
     556,   472,   126,   157,   214,   245,   341,   370,   378,   384,
     391,   399,   407,   415,   464,   546,   758,   765,   502,   747,
      95,   198,   370,   529,    95,   101,   140,   191,   198,   201,
     252,   306,   341,   370,   374,   399,   554,   555,   625,   704,
     704,   502,   770,   504,   247,   370,   514,   521,   341,   370,
     125,   173,   249,   294,   296,   306,   340,   370,   375,   399,
     409,   554,   622,   623,   332,   341,   462,   643,   651,   370,
     399,   554,   341,   370,   374,   399,   149,   190,   342,   426,
     328,   341,   370,   399,   222,   370,   399,   514,   546,   370,
     399,   554,  1003,   506,   281,   329,   473,   505,   801,   452,
     823,   328,  1009,   502,  1003,  1009,   323,   138,   217,   771,
    1003,   389,  1003,   273,   704,   598,   412,   413,   566,  1151,
     502,   681,   682,   136,   119,   121,   122,   133,   134,   178,
     179,   220,   263,   265,   302,   304,   322,   362,   400,   405,
     430,   431,   458,   917,   919,   921,   923,   925,   927,   928,
     929,   931,   932,   936,   937,  1125,  1132,  1136,  1137,  1153,
    1003,   514,   108,   818,   472,   514,   704,   704,   502,   677,
     580,   514,   114,   533,   441,   650,   341,   636,   149,   190,
     342,   426,    97,   116,   660,   108,   677,   222,   514,  1001,
     614,  1001,  1001,   704,   148,   737,  1009,  1003,   634,    74,
    1029,  1131,   507,  1030,  1027,   120,   172,   259,   306,   388,
     452,   850,   212,   681,   127,   376,   557,   212,   502,   212,
     472,   212,   747,   212,   505,   242,   704,   242,   704,   212,
     770,  1002,   212,   212,   328,   212,   557,   212,   149,   190,
     342,   426,   212,   328,   212,   222,   242,   242,   544,   212,
     505,   557,   503,  1156,  1157,  1155,   505,   509,   941,   969,
    1088,  1163,  1164,   422,   864,   503,   505,   216,   328,   438,
     541,   544,   625,   838,   834,   714,   863,   714,   863,  1165,
    1166,   714,   863,   714,   863,  1166,   714,   863,   863,   863,
     714,    14,    37,  1139,  1142,  1147,   863,   502,   599,   600,
    1131,   599,    99,   175,   224,   229,   273,   274,   387,   393,
     422,   424,   720,  1000,  1002,   719,   181,   502,   845,   866,
     247,   505,   852,   863,   863,  1151,  1084,   917,   972,   108,
    1002,   223,   781,   781,   781,   281,  1131,   222,   222,   720,
    1002,   386,  1131,   502,   500,   867,   973,   460,   934,   941,
     989,   502,   934,   934,   502,   502,   502,   502,   922,   922,
     350,   867,   502,   502,   924,   502,   502,   502,   502,   133,
     134,   934,   941,   502,   922,   502,   502,   502,   502,   502,
     470,   488,   502,   938,   502,   938,   502,   502,   867,   502,
     502,   502,   502,   502,   502,   502,   941,   941,   867,   941,
     969,   992,  1151,   134,   502,   935,   502,  1151,    85,    88,
     105,   108,   113,   118,   243,   247,   268,   269,   282,   314,
     317,   330,   333,   403,   489,   490,   491,   493,   494,   495,
     496,   497,   498,   964,   966,   968,  1153,   338,   941,   266,
     505,   874,  1164,   502,  1151,   992,    22,  1146,  1147,   993,
     325,   328,  1116,  1116,    10,   456,  1103,  1104,  1106,  1083,
    1083,   184,   244,   550,   505,   135,   181,   544,   108,   181,
     286,   542,   625,   937,  1151,  1153,   153,   195,   950,   164,
     181,   538,   539,   541,   625,   181,   538,  1164,  1164,   281,
    1001,   941,   495,  1006,  1133,   991,   154,   375,   707,   268,
    1131,   502,   856,   857,   858,   859,   860,  1131,   503,   505,
     829,   503,   505,   873,  1002,   108,   832,   869,   869,   881,
     882,   941,   869,   219,   305,   892,   361,   401,   450,    99,
     887,   941,   888,   890,   941,   943,   895,   896,   886,   885,
     883,   884,   222,   898,   883,   895,  1076,   495,   505,   506,
    1134,  1053,  1056,  1053,   262,   176,   240,   295,   940,   295,
     940,   940,   298,  1011,   295,   298,   390,  1150,   505,  1045,
     180,  1083,   451,  1032,  1034,  1003,    37,  1011,  1105,  1147,
     505,   489,  1003,    14,  1011,  1150,  1011,  1150,   505,  1063,
     502,  1003,   502,  1135,   495,   972,   341,   370,   399,   432,
     432,  1006,   504,   432,   432,   424,   536,   813,   222,   232,
     247,   379,   732,   733,   136,   151,   208,   224,   354,   446,
     596,   597,   151,   181,   314,   432,   181,   314,   387,  1003,
     328,   625,   391,   432,   432,   319,   625,   185,   267,   387,
     376,   758,   766,   247,   257,   335,   400,   459,   503,   748,
     751,   752,   753,   755,   917,  1132,   432,   451,   143,   208,
     587,   596,  1131,   143,   783,   328,   385,   436,   151,   783,
     102,   373,   385,   436,  1001,   252,   432,   432,   502,   559,
     424,   469,   470,   559,   505,   341,   452,   452,   312,   917,
     341,   771,   175,   432,   516,   546,   432,   432,   625,   124,
     624,   625,   625,   173,   294,   296,   124,   432,   514,   387,
     514,   306,   623,   502,   432,   319,  1151,   643,   432,   783,
     387,   432,   432,   559,   559,   704,   704,   704,   704,  1001,
     432,   432,   387,   171,   451,   656,  1012,   432,   516,   432,
     387,   341,   370,   361,   371,   395,   540,   801,  1007,  1131,
    1001,   681,   917,   328,   747,   625,   704,   704,   770,   268,
     328,   149,   190,   342,   426,   328,   704,   268,   469,   571,
     514,   683,   684,  1153,   677,   502,   919,   108,   107,   918,
     176,   298,   483,   502,   939,   705,   922,    97,   808,   917,
    1003,   515,   690,   452,   678,   679,  1133,   463,   515,  1012,
     158,   232,   534,   579,   619,   659,   715,   735,   804,  1151,
     651,   652,  1003,   289,   704,   704,   704,   704,   186,   260,
     439,   450,   661,   662,   205,   502,   656,   515,   621,   622,
     108,   324,   502,   615,   598,   222,   738,  1007,   502,   749,
     108,   273,   504,  1011,  1030,   469,   470,   865,   388,   502,
     867,   902,   903,   904,   909,   912,   944,  1009,  1131,   466,
     914,  1009,   557,   917,  1004,   242,  1003,  1009,   557,  1002,
    1003,   212,   452,   212,   452,   771,   557,   557,  1002,  1003,
    1001,  1003,  1003,  1003,  1001,  1002,   656,   212,   212,   557,
     703,   704,   503,   509,  1158,   503,   505,  1164,  1088,  1001,
     172,   834,   836,   863,   863,  1166,   863,   863,  1166,   863,
     863,  1003,    14,   505,  1146,   599,   503,   505,   503,   230,
     394,   423,  1002,   174,   396,   724,   725,  1002,   323,  1002,
    1000,  1000,  1002,   432,   469,   728,   457,   846,   847,  1131,
     377,   848,    93,   210,   383,   401,   853,   909,   318,   854,
     503,   505,   841,   844,   849,   855,   866,   432,   718,   717,
     718,   227,   233,   729,  1131,   969,   501,   969,   973,   974,
     502,   465,   986,   987,   941,   969,  1011,  1011,   969,   176,
     240,   295,   298,   390,   483,   975,   976,  1151,  1153,  1011,
     969,   969,  1011,  1011,   934,   934,   941,   771,   941,   977,
     493,   494,   942,   943,   962,   966,   979,   503,   969,   941,
     969,   980,   430,   485,  1011,  1011,   941,   123,   227,   278,
     433,   941,   969,   983,   969,   300,   941,   948,   949,   950,
     300,   941,   950,   503,   505,   399,  1011,  1011,   939,   917,
     941,  1133,   430,   112,   419,   994,   941,   502,   867,   984,
     193,   195,   216,   314,   319,   324,   438,   447,   941,   118,
     243,   247,   282,   403,   502,   941,   432,   941,   941,   941,
     941,   941,   941,   941,   941,   941,   941,    99,   106,   406,
     963,   383,   502,   962,   231,   286,   422,   425,   427,   875,
    1001,   999,   227,   901,    99,   193,   459,   495,   503,   753,
     941,   970,   971,  1132,  1003,  1147,   991,  1105,   505,   489,
    1001,   434,   502,  1151,   505,  1164,   503,   501,   507,   241,
     241,   557,  1063,   860,   861,   505,   901,   489,   993,  1001,
     826,   827,  1001,   995,   503,   867,   505,   109,   189,   452,
     743,   502,   889,  1013,   329,   324,   899,   899,   505,   383,
     384,   891,   896,   884,   506,  1077,   918,   509,  1056,   509,
     503,   625,   503,    34,  1033,  1108,  1109,  1147,  1101,  1106,
    1154,  1092,   918,  1141,  1157,  1141,   918,   503,   503,   432,
     432,   387,  1012,  1003,  1006,  1012,  1004,  1003,   150,   814,
     381,   451,   717,   387,   232,   717,   502,  1003,   452,   739,
     272,   272,   502,  1003,   319,  1012,   941,   319,  1003,   306,
     341,   455,   631,   643,   319,   185,   267,  1012,  1003,   328,
    1003,   335,  1132,   503,   505,   753,   755,   752,   755,  1132,
     705,  1012,  1002,   587,   917,  1131,  1003,  1003,    99,   451,
    1003,   242,  1003,   242,  1131,   385,   436,   385,   436,  1003,
      99,   451,  1003,  1001,  1012,  1003,   561,   562,  1133,  1003,
     327,   140,   327,   555,   432,  1005,  1131,  1005,   505,   503,
     505,   432,  1004,  1012,   150,   159,   160,   161,   203,   252,
     291,   307,   308,   309,   310,   311,   313,   345,   418,   444,
     451,   454,   517,  1012,  1003,   625,   704,  1003,   625,  1003,
     625,    95,   198,   399,   644,   645,   646,   647,  1133,  1012,
    1003,  1003,  1003,  1012,  1003,    95,   101,   198,   341,   370,
     341,   370,   677,   370,   370,   370,  1012,  1003,  1003,   396,
    1012,  1003,  1003,   432,   432,   147,   443,   361,   268,   108,
     704,   268,   268,   452,   452,   268,   319,   710,  1151,   704,
     704,   704,   704,   704,   704,   268,   710,   327,   227,   432,
     565,   502,   567,   568,   503,   505,   489,   941,   107,   918,
     917,   500,   500,   432,   432,  1011,   922,   661,   150,   202,
     276,   277,   289,   341,   424,   426,   809,   589,   631,   632,
      96,   247,   381,   420,   517,   518,   222,  1005,   503,   505,
     489,  1001,   533,   333,   580,   224,  1151,   677,   677,   677,
     677,   324,   328,   333,   502,   915,   916,  1131,   396,   211,
    1021,   704,   282,   581,   583,   585,   587,   593,   596,   616,
     617,  1131,   469,   470,   610,   108,  1151,   328,   503,   750,
     751,   756,   108,   273,   378,   468,   757,   758,   759,   328,
     544,  1029,   496,   239,   239,   222,   867,   903,   904,   108,
     905,  1131,   505,   162,   228,   256,   271,   280,   303,   380,
     906,   905,   108,   905,  1131,   502,   992,   164,   941,   848,
     681,   108,   212,   557,   747,   704,  1005,   704,  1005,   770,
     328,   557,   557,   328,   557,   396,   222,   544,   557,   941,
     502,   865,  1154,  1142,   503,   600,   247,   247,   247,   472,
    1002,   505,   625,   626,   235,   721,   722,  1012,    96,   729,
     503,   505,   993,   998,   210,   401,   210,   401,   383,   450,
     297,   917,  1003,   227,   328,   721,   124,   557,   503,   501,
     501,   505,   969,   941,   200,   987,   988,   108,   503,   503,
     503,   503,   503,   227,   503,   503,   503,   503,   503,   505,
     503,   346,   978,   503,   942,   942,    88,   247,   268,   330,
     489,   490,   491,   493,   494,   495,   496,   497,   498,   966,
     942,   503,   503,   222,   227,   981,   982,   503,   485,   503,
     503,   108,   983,   969,   983,   983,   227,   503,   503,  1133,
     108,   503,   505,   941,  1133,   505,   941,   993,   941,  1131,
     503,   503,   485,   942,   942,   206,   969,   227,   193,   195,
     216,   319,   324,   438,   447,   502,   206,   419,   994,   941,
     984,   941,   432,   771,   941,   502,   867,   425,   427,   425,
     427,  1001,   876,   876,   902,   466,   913,   970,   970,   971,
     503,   337,   955,    90,   503,   505,   880,     8,    11,    12,
      22,    23,    24,    26,    27,    31,    32,    33,   174,   300,
     350,   441,  1111,  1112,  1114,  1104,  1105,   802,  1011,   939,
     539,   941,   918,   503,   505,   857,   914,   995,   832,   882,
     330,   964,   967,   486,   487,   744,   941,   891,  1000,   854,
     854,   888,   507,  1059,   506,   505,   489,    30,  1120,   503,
     503,   506,  1012,  1003,  1003,   283,  1002,  1002,   328,  1002,
     331,   328,   941,   597,  1005,   502,   502,   502,   599,   557,
     455,   432,   629,  1003,   643,   258,   319,   705,   751,   755,
     755,   497,   589,   198,   374,   399,   556,   784,   212,   557,
     212,   557,  1003,  1003,  1003,  1003,   503,   505,   489,   504,
    1012,   341,   370,    95,   198,   341,   370,   917,   312,   917,
    1012,   283,   345,   319,  1151,   345,  1002,   449,   646,   647,
     646,   503,   505,   648,  1151,   432,   292,   292,   292,   432,
     432,   432,   432,   432,   432,   432,  1003,  1012,  1003,   710,
     917,   268,   710,   710,  1005,  1005,   710,   268,   268,   268,
     268,   268,   268,   710,   566,   574,   575,  1133,   120,   163,
     187,   206,   223,   238,   319,   327,   359,   569,   684,  1153,
     330,   493,   494,   625,   680,   755,   967,  1017,  1151,   503,
     500,   503,  1011,   501,   502,  1011,  1131,  1151,  1162,   503,
     328,   283,   489,   810,   810,   810,   810,   810,   810,   810,
     136,   151,   181,   183,   254,   314,   319,   354,   366,   446,
     590,   591,   592,   332,   641,  1002,   235,   381,  1002,  1011,
     441,   679,   680,   598,   372,   422,   174,   599,  1001,   662,
     685,   686,  1151,   503,   505,   917,  1003,  1039,   866,   502,
     582,  1001,   503,   505,   503,   505,   327,   559,   327,   328,
     611,   866,   432,  1001,   503,   505,   181,   489,   760,  1151,
     544,   422,   754,   755,   469,   759,   761,   186,   260,   392,
     450,   792,   236,  1025,   866,  1039,   503,  1131,   502,   903,
     271,   336,   907,   903,   907,   271,   906,   907,   271,   502,
    1131,   502,   970,   324,   557,   917,  1003,   557,   452,   557,
     452,   557,   557,  1001,  1001,  1003,   656,   557,  1131,   222,
     387,   387,   387,  1002,   725,   505,  1012,   469,   505,   723,
     331,   866,   847,  1164,   210,   210,  1002,   720,   557,  1012,
     973,   503,   429,   941,   204,   917,   941,   941,   941,   981,
     917,   942,   193,   195,   314,   324,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   941,   941,   982,   981,
     938,   938,   917,   503,   503,   503,   969,   503,   505,  1133,
     949,   351,   416,   951,   503,   505,   462,   945,   108,   503,
     935,  1151,   941,   105,   105,   941,   503,   941,   227,   502,
     972,   941,   942,   942,   206,   206,   941,   503,   206,   941,
     876,   876,   876,   876,  1001,  1001,   941,   235,   893,   505,
     879,   880,   879,   503,   955,   502,   956,  1131,   941,   955,
    1151,   459,   971,   503,   505,   489,   503,   501,  1120,   489,
     860,   848,   502,   744,   503,   329,  1011,   489,  1078,  1109,
    1114,   810,   230,   394,   423,   734,   222,   734,   503,   502,
     602,   603,   741,   944,  1131,   599,   599,   503,  1012,   705,
     258,   497,   441,   314,   559,   174,   314,   411,   414,   559,
     441,  1003,  1131,   562,   680,  1133,   432,   432,   229,   330,
     414,   688,   689,   229,   330,   695,   696,   432,   432,   503,
     503,   503,  1013,  1151,  1151,  1151,   645,  1003,   222,   222,
     372,   222,   242,  1012,  1003,  1012,  1003,  1003,  1003,  1003,
     643,   503,   710,   268,   268,   710,   710,   710,   710,   710,
     710,   452,   572,   573,   503,   505,   495,   502,   541,   576,
     625,   818,   818,   314,   359,   818,   818,   183,   254,   314,
     670,   671,   672,  1011,   469,   470,   501,  1162,   493,   494,
     495,   496,   497,   501,   939,  1001,   810,   181,  1011,  1151,
     181,  1151,   181,  1151,   181,  1151,   181,  1003,   181,  1003,
     181,  1003,   502,  1003,   942,   184,   244,   183,   319,   272,
    1001,   761,   502,  1002,  1002,   917,   108,  1001,   472,   222,
     663,   503,   505,   916,   641,   843,   469,   618,   584,   586,
     588,   596,  1131,   610,   594,   253,   609,   585,   617,   146,
     424,   612,   469,   805,  1151,   739,   756,   941,   941,   505,
     502,   757,   677,   432,   629,    85,  1036,   905,   502,  1002,
     903,   328,   452,   908,   903,   271,   903,   915,   502,   915,
    1131,   503,  1003,   503,   557,  1005,  1005,   557,   557,   396,
    1002,  1002,  1002,   625,   232,   722,   729,   227,   941,   503,
     503,   982,   227,   193,   195,   324,   502,   503,   475,   947,
     969,   467,   467,   503,   941,   306,   941,   505,   946,   919,
     939,   942,   942,   941,   972,   503,   105,   105,   941,   941,
     206,   941,   503,  1001,  1001,  1001,  1001,   124,   237,   894,
     503,   503,   955,   957,  1131,   971,   955,  1112,   494,  1105,
    1113,  1150,  1151,  1151,   997,   771,  1158,  1013,   432,   717,
     227,   670,   941,   503,   505,   469,   452,   704,   742,   742,
     503,   503,   761,   441,   319,   319,  1013,  1131,   917,   557,
     557,   489,  1012,  1003,  1011,  1011,   917,   505,  1011,  1011,
     505,  1012,  1003,  1002,  1002,   704,  1002,   212,   268,   710,
     710,   514,   188,   575,   541,   577,   578,  1151,  1151,   319,
     495,   599,  1151,  1151,   184,   244,   183,   672,   671,   501,
     229,   257,   229,   503,  1162,  1162,  1162,  1162,  1162,   227,
     669,  1013,   941,   314,   591,   761,   598,   452,   613,   642,
     646,   452,   866,   502,  1003,   199,   664,   465,   666,  1151,
     174,   306,   503,   505,   469,   611,   209,   248,   502,   610,
     186,   198,   351,  1003,   128,   136,   286,   227,   502,  1151,
     753,   762,   763,  1132,   761,  1001,   255,   630,  1037,  1131,
    1002,   503,   941,   502,   903,   908,   503,   915,   503,   557,
     557,   557,  1003,   331,   557,   721,   942,   227,   502,   972,
     502,   503,   505,   503,   503,   456,   408,   503,   503,   503,
     942,   942,   941,   969,   941,   468,   952,   955,   955,   344,
     958,   503,  1011,  1150,   939,   503,   721,   328,   721,   503,
     761,   603,   330,   771,   704,   743,   743,   366,   761,   613,
     452,   558,   680,   502,  1009,   771,   689,   502,   502,   696,
     469,   372,   469,   469,   222,   710,   567,  1151,   503,   505,
     599,   725,   108,   776,   776,  1001,   670,   503,   613,   293,
     601,   250,   503,   505,  1005,   805,   641,   383,   410,   665,
     502,   211,   174,   586,   332,   612,    99,   145,   152,   182,
     251,   414,   595,   595,  1000,   611,   384,   384,   136,   331,
     136,   704,   740,   741,   755,   503,   505,   913,   629,   632,
     489,  1038,   503,  1002,   503,   557,   942,   972,   503,   948,
     969,   306,   484,   953,   954,  1131,   124,   879,   955,   723,
     734,   557,   742,   613,   502,   744,   744,  1001,   613,   670,
     941,   972,   747,   364,   692,   770,   972,   972,   703,   704,
     703,   704,  1002,   578,   776,   111,   246,   222,   228,   343,
     404,   328,   605,   606,   607,   424,   646,   217,   691,   941,
     358,   589,   503,   612,   331,   331,   503,   505,   757,   762,
     194,  1011,  1145,  1153,    85,   503,   503,   503,   503,   456,
     505,   108,   969,   360,   384,   959,   227,   743,   466,   604,
     771,   598,   670,   503,   692,   503,   503,   469,   199,   186,
     450,   328,   607,   328,   606,  1003,   704,   108,   503,  1009,
     469,   560,   741,   761,   100,   261,   793,  1037,   954,   956,
     118,   164,   442,   941,   960,   961,   960,   503,   721,   744,
     502,   670,   503,   601,  1009,   704,   383,   127,   306,   376,
     399,   608,   608,   688,   502,   559,   612,   315,   502,   788,
     790,   795,   844,   849,   855,   866,   961,   383,   221,   349,
     221,   349,   557,   941,   605,   747,   666,    94,   181,   319,
      84,   667,   668,  1011,  1131,  1149,  1150,  1151,   913,   789,
     790,   791,   867,   868,   105,   503,   670,   211,   503,   505,
     503,   506,   961,   358,   668,   791,  1009,   502,   667,   503
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:

/* Line 1455 of yacc.c  */
#line 1344 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 1346 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 1348 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 1350 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 1352 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 1354 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 1356 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 1358 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 1360 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 1362 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 1364 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 1366 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 1368 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 1370 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 1372 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 1374 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 1376 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 1378 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 1380 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 1382 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 1384 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 1386 "preproc.y"
    {
		if (INFORMIX_MODE)
		{
			if (pg_strcasecmp((yyvsp[(1) - (1)].str)+strlen("close "), "database") == 0)
			{
				if (connection)
					mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CLOSE DATABASE statement");

				fprintf(yyout, "{ ECPGdisconnect(__LINE__, \"CURRENT\");");
				whenever_action(2);
				free((yyvsp[(1) - (1)].str));
				break;
			}
		}

		output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal);
	;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 1404 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 1406 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 1408 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 1410 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 1412 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 1414 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 1416 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 1418 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 1420 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 1422 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 1424 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 1426 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 1428 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 1430 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 1432 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 1434 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 1436 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 1438 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 1440 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 1442 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 1444 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 1446 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 1448 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 1450 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 1452 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 1454 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 1456 "preproc.y"
    {
		output_deallocate_prepare_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 1460 "preproc.y"
    { output_simple_statement((yyvsp[(1) - (1)].str)); ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 1462 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 1464 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 1466 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_normal); ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 1468 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 1470 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 1472 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 1474 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 1476 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 1478 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 1480 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 1482 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 1484 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 1486 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 1488 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1490 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1492 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1494 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1496 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1498 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1500 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1502 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1504 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_execute); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1506 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1508 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_normal); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1510 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1512 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1514 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1516 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1518 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1520 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1522 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1524 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1526 "preproc.y"
    {
		if ((yyvsp[(1) - (1)].prep).type == NULL || strlen((yyvsp[(1) - (1)].prep).type) == 0)
			output_prepare_statement((yyvsp[(1) - (1)].prep).name, (yyvsp[(1) - (1)].prep).stmt);
		else	
			output_statement(cat_str(5, make_str("prepare"), (yyvsp[(1) - (1)].prep).name, (yyvsp[(1) - (1)].prep).type, make_str("as"), (yyvsp[(1) - (1)].prep).stmt), 0, ECPGst_normal);
	;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1533 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1535 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1537 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1539 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1541 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1543 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1545 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1547 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1549 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1551 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1553 "preproc.y"
    {
		fprintf(yyout, "{ ECPGtrans(__LINE__, %s, \"%s\");", connection ? connection : "NULL", (yyvsp[(1) - (1)].str));
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1559 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1561 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1563 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 1, ECPGst_prepnormal); ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1565 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1567 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1569 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1571 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1573 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_normal); ;}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1575 "preproc.y"
    {
		fprintf(yyout,"ECPGallocate_desc(__LINE__, %s);",(yyvsp[(1) - (1)].str));
		whenever_action(0);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1581 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in CONNECT statement");

		fprintf(yyout, "{ ECPGconnect(__LINE__, %d, %s, %d); ", compat, (yyvsp[(1) - (1)].str), autocommit);
		reset_variables();
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1591 "preproc.y"
    {
		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1595 "preproc.y"
    {
		fprintf(yyout,"ECPGdeallocate_desc(__LINE__, %s);",(yyvsp[(1) - (1)].str));
		whenever_action(0);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1601 "preproc.y"
    {
		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1605 "preproc.y"
    {
		fprintf(yyout, "{ ECPGdescribe(__LINE__, %d, %s,", compat, (yyvsp[(1) - (1)].str));
		dump_variables(argsresult, 1);
		fputs("ECPGt_EORT);", yyout);
		fprintf(yyout, "}");
		output_line_number();

		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1615 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in DISCONNECT statement");

		fprintf(yyout, "{ ECPGdisconnect(__LINE__, %s);",
				(yyvsp[(1) - (1)].str) ? (yyvsp[(1) - (1)].str) : "\"CURRENT\"");
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1624 "preproc.y"
    { output_statement((yyvsp[(1) - (1)].str), 0, ECPGst_exec_immediate); ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1626 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";

		if (!strcmp((yyvsp[(1) - (1)].str), "all"))
			fprintf(yyout, "{ ECPGdeallocate_all(__LINE__, %d, %s);", compat, con);
		else if ((yyvsp[(1) - (1)].str)[0] == ':') 
			fprintf(yyout, "{ ECPGdeallocate(__LINE__, %d, %s, %s);", compat, con, (yyvsp[(1) - (1)].str)+1);
		else
			fprintf(yyout, "{ ECPGdeallocate(__LINE__, %d, %s, \"%s\");", compat, con, (yyvsp[(1) - (1)].str));

		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1640 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].descriptor).name, connection);
		output_get_descr((yyvsp[(1) - (1)].descriptor).name, (yyvsp[(1) - (1)].descriptor).str);
		free((yyvsp[(1) - (1)].descriptor).name);
		free((yyvsp[(1) - (1)].descriptor).str);
	;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1647 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].str), connection);
		output_get_descr_header((yyvsp[(1) - (1)].str));
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1653 "preproc.y"
    {
		struct cursor *ptr;

		if ((ptr = add_additional_variables((yyvsp[(1) - (1)].str), true)) != NULL)
		{
			connection = ptr->connection ? mm_strdup(ptr->connection) : NULL;
			output_statement(mm_strdup(ptr->command), 0, ECPGst_normal);
			ptr->opened = true;
		}
	;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1664 "preproc.y"
    {
		fprintf(yyout, "{ ECPGsetcommit(__LINE__, \"%s\", %s);", (yyvsp[(1) - (1)].str), connection ? connection : "NULL");
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1670 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in SET CONNECTION statement");

		fprintf(yyout, "{ ECPGsetconn(__LINE__, %s);", (yyvsp[(1) - (1)].str));
		whenever_action(2);
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1679 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].descriptor).name, connection);
		output_set_descr((yyvsp[(1) - (1)].descriptor).name, (yyvsp[(1) - (1)].descriptor).str);
		free((yyvsp[(1) - (1)].descriptor).name);
		free((yyvsp[(1) - (1)].descriptor).str);
	;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1686 "preproc.y"
    {
		lookup_descriptor((yyvsp[(1) - (1)].str), connection);
		output_set_descr_header((yyvsp[(1) - (1)].str));
		free((yyvsp[(1) - (1)].str));
	;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1692 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in TYPE statement");

		fprintf(yyout, "%s", (yyvsp[(1) - (1)].str));
		free((yyvsp[(1) - (1)].str));
		output_line_number();
	;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1701 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in VAR statement");

		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1708 "preproc.y"
    {
		if (connection)
			mmerror(PARSE_ERROR, ET_ERROR, "AT option not allowed in WHENEVER statement");

		output_simple_statement((yyvsp[(1) - (1)].str));
	;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1715 "preproc.y"
    { (yyval.str) = NULL; ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1721 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create role"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1729 "preproc.y"
    { 
 (yyval.str) = make_str("with");
;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1733 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1740 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1744 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1751 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1755 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1762 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("password"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1766 "preproc.y"
    { 
 (yyval.str) = make_str("password null");
;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1770 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("encrypted password"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1774 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("unencrypted password"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1778 "preproc.y"
    { 
 (yyval.str) = make_str("superuser");
;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1782 "preproc.y"
    { 
 (yyval.str) = make_str("nosuperuser");
;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1786 "preproc.y"
    { 
 (yyval.str) = make_str("inherit");
;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1790 "preproc.y"
    { 
 (yyval.str) = make_str("noinherit");
;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1794 "preproc.y"
    { 
 (yyval.str) = make_str("createdb");
;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1798 "preproc.y"
    { 
 (yyval.str) = make_str("nocreatedb");
;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1802 "preproc.y"
    { 
 (yyval.str) = make_str("createrole");
;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1806 "preproc.y"
    { 
 (yyval.str) = make_str("nocreaterole");
;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1810 "preproc.y"
    { 
 (yyval.str) = make_str("createuser");
;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1814 "preproc.y"
    { 
 (yyval.str) = make_str("nocreateuser");
;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1818 "preproc.y"
    { 
 (yyval.str) = make_str("login");
;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1822 "preproc.y"
    { 
 (yyval.str) = make_str("nologin");
;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1826 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("connection limit"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1830 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("valid until"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1834 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("user"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1842 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1846 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("sysid"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1850 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("admin"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1854 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("role"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1858 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in role"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1862 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in group"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1870 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create user"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1878 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter role"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1886 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1889 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in database"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1897 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter role"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1905 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter user"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1913 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter user"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1921 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop role"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1925 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop role if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1933 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop user"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1937 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop user if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1945 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create group"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1953 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter group"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("user"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1961 "preproc.y"
    { 
 (yyval.str) = make_str("add");
;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1965 "preproc.y"
    { 
 (yyval.str) = make_str("drop");
;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1973 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop group"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1977 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop group if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1985 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create schema"),(yyvsp[(3) - (6)].str),make_str("authorization"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1989 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create schema"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1997 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2001 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2008 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2012 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2019 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2023 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2027 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2031 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2035 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 2039 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 2047 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 2051 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set local"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 2055 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set session"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2063 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2067 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 2071 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("to default"));
;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 2075 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("= default"));
;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 2079 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("from current"));
;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 2083 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("time zone"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 2087 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("transaction"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 2091 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("session characteristics as transaction"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 2095 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,make_str("catalog"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 2100 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("schema"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 2104 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("names"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 2108 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("role"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 2112 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("session authorization"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 2116 "preproc.y"
    { 
 (yyval.str) = make_str("session authorization default");
;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 2120 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("xml option"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 2128 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 2132 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 2140 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 2144 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 2152 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 2156 "preproc.y"
    { 
		if ((yyvsp[(1) - (1)].str)[0] == '$')
		{
			free((yyvsp[(1) - (1)].str));
			(yyvsp[(1) - (1)].str) = make_str("$0");
		}

 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 2170 "preproc.y"
    { 
 (yyval.str) = make_str("read uncommitted");
;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 2174 "preproc.y"
    { 
 (yyval.str) = make_str("read committed");
;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 2178 "preproc.y"
    { 
 (yyval.str) = make_str("repeatable read");
;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 2182 "preproc.y"
    { 
 (yyval.str) = make_str("serializable");
;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 2190 "preproc.y"
    { 
 (yyval.str) = make_str("true");
;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 2194 "preproc.y"
    { 
 (yyval.str) = make_str("false");
;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 2198 "preproc.y"
    { 
 (yyval.str) = make_str("on");
;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 2202 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 2210 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 2214 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 2218 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 2222 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("("),(yyvsp[(3) - (6)].str),make_str(")"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 2226 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 2230 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 2234 "preproc.y"
    { 
 (yyval.str) = make_str("local");
;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 2242 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 2246 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 2250 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 2257 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 2261 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 2269 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("reset"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 2273 "preproc.y"
    { 
 (yyval.str) = make_str("reset time zone");
;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 2277 "preproc.y"
    { 
 (yyval.str) = make_str("reset transaction isolation level");
;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 2281 "preproc.y"
    { 
 (yyval.str) = make_str("reset session authorization");
;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 2285 "preproc.y"
    { 
 (yyval.str) = make_str("reset all");
;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 2293 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 2297 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 2305 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("show"),(yyvsp[(2) - (3)].str));
;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 2309 "preproc.y"
    { 
 (yyval.str) = make_str("show time zone");
;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 2313 "preproc.y"
    { 
 (yyval.str) = make_str("show transaction isolation level");
;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 2317 "preproc.y"
    { 
 (yyval.str) = make_str("show session authorization");
;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 2321 "preproc.y"
    {
		mmerror(PARSE_ERROR, ET_ERROR, "SHOW ALL is not implemented");
		(yyval.str) = EMPTY;
	;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 2330 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("set constraints"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 2338 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 2342 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 2350 "preproc.y"
    { 
 (yyval.str) = make_str("deferred");
;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 2354 "preproc.y"
    { 
 (yyval.str) = make_str("immediate");
;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 2362 "preproc.y"
    { 
 (yyval.str) = make_str("checkpoint");
;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 2370 "preproc.y"
    { 
 (yyval.str) = make_str("discard all");
;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 2374 "preproc.y"
    { 
 (yyval.str) = make_str("discard temp");
;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 2378 "preproc.y"
    { 
 (yyval.str) = make_str("discard temporary");
;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 2382 "preproc.y"
    { 
 (yyval.str) = make_str("discard plans");
;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 2390 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter table"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 2394 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter index"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 2398 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter sequence"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 2402 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter view"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 2410 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 2414 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 2422 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 2426 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add column"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 2430 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 2434 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("drop not null"));
;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 2438 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("set not null"));
;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 2442 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("set statistics"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 2446 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("set"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 2450 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("reset"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 2454 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("set storage"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 2458 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (6)].str),make_str("if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 2462 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 2466 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("alter"),(yyvsp[(2) - (7)].str),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("type"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 2470 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 2474 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop constraint if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 2478 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop constraint"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 2482 "preproc.y"
    { 
 (yyval.str) = make_str("set with oids");
;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 2486 "preproc.y"
    { 
 (yyval.str) = make_str("set without oids");
;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 2490 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cluster on"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 2494 "preproc.y"
    { 
 (yyval.str) = make_str("set without cluster");
;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 2498 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable trigger"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 2502 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable always trigger"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 2506 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable replica trigger"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 2510 "preproc.y"
    { 
 (yyval.str) = make_str("enable trigger all");
;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 2514 "preproc.y"
    { 
 (yyval.str) = make_str("enable trigger user");
;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 2518 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("disable trigger"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 2522 "preproc.y"
    { 
 (yyval.str) = make_str("disable trigger all");
;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 2526 "preproc.y"
    { 
 (yyval.str) = make_str("disable trigger user");
;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 2530 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable rule"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 2534 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable always rule"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 2538 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("enable replica rule"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 2542 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("disable rule"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 2546 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("inherit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 2550 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("no inherit"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 2554 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("owner to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 2558 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set tablespace"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 2562 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 2566 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("reset"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 2574 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set default"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 2578 "preproc.y"
    { 
 (yyval.str) = make_str("drop default");
;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2586 "preproc.y"
    { 
 (yyval.str) = make_str("cascade");
;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2590 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2594 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2601 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2605 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2612 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2620 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2624 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2631 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2635 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2643 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2647 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2651 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("."),(yyvsp[(3) - (5)].str),make_str("="),(yyvsp[(5) - (5)].str));
;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2655 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2663 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(2) - (2)].str)[0] == ':' ? make_str("$0") : (yyvsp[(2) - (2)].str);
		(yyval.str) = cat2_str(make_str("close"), cursor_marker);
	;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2668 "preproc.y"
    { 
 (yyval.str) = make_str("close all");
;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2676 "preproc.y"
    { 
			if (strcmp((yyvsp[(6) - (10)].str), "to") == 0 && strcmp((yyvsp[(7) - (10)].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY TO STDIN is not possible");
			else if (strcmp((yyvsp[(6) - (10)].str), "from") == 0 && strcmp((yyvsp[(7) - (10)].str), "stdout") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY FROM STDOUT is not possible");
			else if (strcmp((yyvsp[(6) - (10)].str), "from") == 0 && strcmp((yyvsp[(7) - (10)].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_WARNING, "COPY FROM STDIN is not implemented");

 (yyval.str) = cat_str(10,make_str("copy"),(yyvsp[(2) - (10)].str),(yyvsp[(3) - (10)].str),(yyvsp[(4) - (10)].str),(yyvsp[(5) - (10)].str),(yyvsp[(6) - (10)].str),(yyvsp[(7) - (10)].str),(yyvsp[(8) - (10)].str),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2687 "preproc.y"
    { 
			if (strcmp((yyvsp[(4) - (6)].str), "stdin") == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "COPY TO STDIN is not possible");

 (yyval.str) = cat_str(6,make_str("copy"),(yyvsp[(2) - (6)].str),make_str("to"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2698 "preproc.y"
    { 
 (yyval.str) = make_str("from");
;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2702 "preproc.y"
    { 
 (yyval.str) = make_str("to");
;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2710 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2714 "preproc.y"
    { 
 (yyval.str) = make_str("stdin");
;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2718 "preproc.y"
    { 
 (yyval.str) = make_str("stdout");
;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2726 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2730 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2738 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2742 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2749 "preproc.y"
    { 
 (yyval.str) = make_str("binary");
;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2753 "preproc.y"
    { 
 (yyval.str) = make_str("oids");
;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2757 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("delimiter"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2761 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("null"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2765 "preproc.y"
    { 
 (yyval.str) = make_str("csv");
;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2769 "preproc.y"
    { 
 (yyval.str) = make_str("header");
;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2773 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("quote"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2777 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("escape"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2781 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("force quote"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2785 "preproc.y"
    { 
 (yyval.str) = make_str("force quote *");
;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2789 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("force not null"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2797 "preproc.y"
    { 
 (yyval.str) = make_str("binary");
;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2801 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2808 "preproc.y"
    { 
 (yyval.str) = make_str("with oids");
;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2812 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2819 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("delimiters"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2823 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2830 "preproc.y"
    { 
 (yyval.str) = make_str("using");
;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2834 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2841 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2845 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2853 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2861 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2865 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2869 "preproc.y"
    { 
 (yyval.str) = make_str("*");
;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2873 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2877 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2884 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2888 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2896 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2904 "preproc.y"
    { 
 (yyval.str) = cat_str(11,make_str("create"),(yyvsp[(2) - (11)].str),make_str("table"),(yyvsp[(4) - (11)].str),make_str("("),(yyvsp[(6) - (11)].str),make_str(")"),(yyvsp[(8) - (11)].str),(yyvsp[(9) - (11)].str),(yyvsp[(10) - (11)].str),(yyvsp[(11) - (11)].str));
;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2908 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (10)].str),make_str("table"),(yyvsp[(4) - (10)].str),make_str("of"),(yyvsp[(6) - (10)].str),(yyvsp[(7) - (10)].str),(yyvsp[(8) - (10)].str),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2916 "preproc.y"
    { 
 (yyval.str) = make_str("temporary");
;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2920 "preproc.y"
    { 
 (yyval.str) = make_str("temp");
;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2924 "preproc.y"
    { 
 (yyval.str) = make_str("local temporary");
;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2928 "preproc.y"
    { 
 (yyval.str) = make_str("local temp");
;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2932 "preproc.y"
    { 
 (yyval.str) = make_str("global temporary");
;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2936 "preproc.y"
    { 
 (yyval.str) = make_str("global temp");
;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2940 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2947 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2951 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2958 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2962 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2969 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2973 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2981 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2985 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2993 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2997 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 3001 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 3009 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 3013 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 3021 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 3029 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("with options"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 3037 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 3041 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 3048 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("constraint"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 3052 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 3056 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 3064 "preproc.y"
    { 
 (yyval.str) = make_str("not null");
;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 3068 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 3072 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("unique"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 3076 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("primary key"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 3080 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("check ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 3084 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("default"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 3088 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("references"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 3096 "preproc.y"
    { 
 (yyval.str) = make_str("deferrable");
;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 3100 "preproc.y"
    { 
 (yyval.str) = make_str("not deferrable");
;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 3104 "preproc.y"
    { 
 (yyval.str) = make_str("initially deferred");
;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 3108 "preproc.y"
    { 
 (yyval.str) = make_str("initially immediate");
;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 3116 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("like"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 3124 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("including"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 3128 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("excluding"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 3132 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 3139 "preproc.y"
    { 
 (yyval.str) = make_str("defaults");
;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 3143 "preproc.y"
    { 
 (yyval.str) = make_str("constraints");
;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 3147 "preproc.y"
    { 
 (yyval.str) = make_str("indexes");
;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 3151 "preproc.y"
    { 
 (yyval.str) = make_str("storage");
;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 3155 "preproc.y"
    { 
 (yyval.str) = make_str("comments");
;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 3159 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 3167 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("constraint"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 3171 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 3179 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(4,make_str("check ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 3184 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("unique ("),(yyvsp[(3) - (7)].str),make_str(")"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 3188 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("primary key ("),(yyvsp[(4) - (8)].str),make_str(")"),(yyvsp[(6) - (8)].str),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 3192 "preproc.y"
    { 
 (yyval.str) = cat_str(9,make_str("exclude"),(yyvsp[(2) - (9)].str),make_str("("),(yyvsp[(4) - (9)].str),make_str(")"),(yyvsp[(6) - (9)].str),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 3196 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("foreign key ("),(yyvsp[(4) - (11)].str),make_str(") references"),(yyvsp[(7) - (11)].str),(yyvsp[(8) - (11)].str),(yyvsp[(9) - (11)].str),(yyvsp[(10) - (11)].str),(yyvsp[(11) - (11)].str));
;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 3204 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 3208 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 3215 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 3219 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 3227 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 3235 "preproc.y"
    { 
 (yyval.str) = make_str("match full");
;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 3239 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("match partial");
;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 3244 "preproc.y"
    { 
 (yyval.str) = make_str("match simple");
;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 3248 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 3255 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 3259 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 3267 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("with"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 3271 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (6)].str),make_str("with operator ("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 3279 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("where ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 3283 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 3290 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 3294 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 3298 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 3302 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 3306 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 3313 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("on update"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 3321 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("on delete"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 3329 "preproc.y"
    { 
 (yyval.str) = make_str("no action");
;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 3333 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 3337 "preproc.y"
    { 
 (yyval.str) = make_str("cascade");
;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 3341 "preproc.y"
    { 
 (yyval.str) = make_str("set null");
;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 3345 "preproc.y"
    { 
 (yyval.str) = make_str("set default");
;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 3353 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("inherits ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 3357 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 3364 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 3368 "preproc.y"
    { 
 (yyval.str) = make_str("with oids");
;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 3372 "preproc.y"
    { 
 (yyval.str) = make_str("without oids");
;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 3376 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 3383 "preproc.y"
    { 
 (yyval.str) = make_str("on commit drop");
;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 3387 "preproc.y"
    { 
 (yyval.str) = make_str("on commit delete rows");
;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 3391 "preproc.y"
    { 
 (yyval.str) = make_str("on commit preserve rows");
;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 3395 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 3402 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("tablespace"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 3406 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 3413 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using index tablespace"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 3417 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 3424 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 3432 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 3436 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 3443 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 3447 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 3455 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 3463 "preproc.y"
    { 
 (yyval.str) = make_str("with data");
;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 3467 "preproc.y"
    { 
 (yyval.str) = make_str("with no data");
;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 3471 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 3478 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create"),(yyvsp[(2) - (5)].str),make_str("sequence"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 3486 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter sequence"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 3494 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 3498 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 3505 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 3509 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 3517 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cache"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 3521 "preproc.y"
    { 
 (yyval.str) = make_str("cycle");
;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 3525 "preproc.y"
    { 
 (yyval.str) = make_str("no cycle");
;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 3529 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("increment"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 3533 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("maxvalue"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 3537 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("minvalue"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 3541 "preproc.y"
    { 
 (yyval.str) = make_str("no maxvalue");
;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 3545 "preproc.y"
    { 
 (yyval.str) = make_str("no minvalue");
;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 3549 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("owned by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 3553 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("start"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 3557 "preproc.y"
    { 
 (yyval.str) = make_str("restart");
;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 3561 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("restart"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 3569 "preproc.y"
    { 
 (yyval.str) = make_str("by");
;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 3573 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 3580 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 3584 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 3588 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 3596 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 3600 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 3608 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("create"),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("language"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 3612 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (10)].str),(yyvsp[(3) - (10)].str),(yyvsp[(4) - (10)].str),make_str("language"),(yyvsp[(6) - (10)].str),make_str("handler"),(yyvsp[(8) - (10)].str),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 3620 "preproc.y"
    { 
 (yyval.str) = make_str("trusted");
;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3624 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3631 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3635 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3643 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("inline"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3647 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3654 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("validator"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3658 "preproc.y"
    { 
 (yyval.str) = make_str("no validator");
;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3666 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3670 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3677 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (5)].str),make_str("language"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3681 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (7)].str),make_str("language if exists"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3689 "preproc.y"
    { 
 (yyval.str) = make_str("procedural");
;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3693 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3700 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create tablespace"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("location"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3708 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("owner"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3712 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3719 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop tablespace"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3723 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop tablespace if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3731 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create foreign data wrapper"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3739 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop foreign data wrapper"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3743 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop foreign data wrapper if exists"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3751 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter foreign data wrapper"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3755 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter foreign data wrapper"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3759 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter foreign data wrapper"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3767 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("options ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3771 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3778 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3782 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3790 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("options ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3798 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3802 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3810 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3814 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("set"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3818 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("add"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3822 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3830 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3838 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3846 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3854 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create server"),(yyvsp[(3) - (10)].str),(yyvsp[(4) - (10)].str),(yyvsp[(5) - (10)].str),make_str("foreign data wrapper"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3862 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("type"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3866 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3873 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("version"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3877 "preproc.y"
    { 
 (yyval.str) = make_str("version null");
;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3885 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3889 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3896 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop server"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3900 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop server if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3908 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter server"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3912 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter server"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3916 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter server"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3924 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create user mapping for"),(yyvsp[(5) - (8)].str),make_str("server"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3932 "preproc.y"
    { 
 (yyval.str) = make_str("current_user");
;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3936 "preproc.y"
    { 
 (yyval.str) = make_str("user");
;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3940 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3948 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop user mapping for"),(yyvsp[(5) - (7)].str),make_str("server"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3952 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop user mapping if exists for"),(yyvsp[(7) - (9)].str),make_str("server"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3960 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter user mapping for"),(yyvsp[(5) - (8)].str),make_str("server"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3968 "preproc.y"
    { 
 (yyval.str) = cat_str(13,make_str("create trigger"),(yyvsp[(3) - (15)].str),(yyvsp[(4) - (15)].str),(yyvsp[(5) - (15)].str),make_str("on"),(yyvsp[(7) - (15)].str),(yyvsp[(8) - (15)].str),(yyvsp[(9) - (15)].str),make_str("execute procedure"),(yyvsp[(12) - (15)].str),make_str("("),(yyvsp[(14) - (15)].str),make_str(")"));
;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3972 "preproc.y"
    { 
 (yyval.str) = cat_str(15,make_str("create constraint trigger"),(yyvsp[(4) - (20)].str),make_str("after"),(yyvsp[(6) - (20)].str),make_str("on"),(yyvsp[(8) - (20)].str),(yyvsp[(9) - (20)].str),(yyvsp[(10) - (20)].str),make_str("for each row"),(yyvsp[(14) - (20)].str),make_str("execute procedure"),(yyvsp[(17) - (20)].str),make_str("("),(yyvsp[(19) - (20)].str),make_str(")"));
;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3980 "preproc.y"
    { 
 (yyval.str) = make_str("before");
;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3984 "preproc.y"
    { 
 (yyval.str) = make_str("after");
;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3992 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3996 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("or"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 4004 "preproc.y"
    { 
 (yyval.str) = make_str("insert");
;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 4008 "preproc.y"
    { 
 (yyval.str) = make_str("delete");
;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 4012 "preproc.y"
    { 
 (yyval.str) = make_str("update");
;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 4016 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("update of"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 4020 "preproc.y"
    { 
 (yyval.str) = make_str("truncate");
;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 4028 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("for"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 4032 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 4039 "preproc.y"
    { 
 (yyval.str) = make_str("each");
;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 4043 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 4050 "preproc.y"
    { 
 (yyval.str) = make_str("row");
;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 4054 "preproc.y"
    { 
 (yyval.str) = make_str("statement");
;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 4062 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("when ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 4066 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 4073 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 4077 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 4081 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 4088 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 4092 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 4096 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 4100 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 4104 "preproc.y"
    { 
 (yyval.str) = make_str("xconst");
;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 4108 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 4116 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 4120 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 4127 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 4131 "preproc.y"
    { 
			if (strcmp((yyvsp[(1) - (2)].str), "deferrable") != 0 && strcmp((yyvsp[(2) - (2)].str), "initially deferrable") == 0 )
				mmerror(PARSE_ERROR, ET_ERROR, "constraint declared INITIALLY DEFERRED must be DEFERRABLE");

 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 4138 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 4142 "preproc.y"
    { 
			if (strcmp((yyvsp[(2) - (2)].str), "deferrable") != 0 && strcmp((yyvsp[(1) - (2)].str), "initially deferrable") == 0 )
				mmerror(PARSE_ERROR, ET_ERROR, "constraint declared INITIALLY DEFERRED must be DEFERRABLE");

 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 4149 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 4156 "preproc.y"
    { 
 (yyval.str) = make_str("not deferrable");
;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 4160 "preproc.y"
    { 
 (yyval.str) = make_str("deferrable");
;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 4168 "preproc.y"
    { 
 (yyval.str) = make_str("initially immediate");
;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 4172 "preproc.y"
    { 
 (yyval.str) = make_str("initially deferred");
;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 4180 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop trigger"),(yyvsp[(3) - (6)].str),make_str("on"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 4184 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop trigger if exists"),(yyvsp[(5) - (8)].str),make_str("on"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 4192 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(6,make_str("create assertion"),(yyvsp[(3) - (8)].str),make_str("check ("),(yyvsp[(6) - (8)].str),make_str(")"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 4201 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(3,make_str("drop assertion"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 4210 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create aggregate"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 4214 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create aggregate"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 4218 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create operator"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 4222 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create type"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 4226 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("create type"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 4230 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create type"),(yyvsp[(3) - (7)].str),make_str("as ("),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 4234 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create type"),(yyvsp[(3) - (8)].str),make_str("as enum ("),(yyvsp[(7) - (8)].str),make_str(")"));
;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 4238 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search parser"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 4242 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search dictionary"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 4246 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search template"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 4250 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("create text search configuration"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 4258 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 4266 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 4270 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 4278 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 4282 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 4290 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 4294 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 4298 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 4302 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 4306 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 4314 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 4318 "preproc.y"
    { 
 (yyval.str) = make_str("( * )");
;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 4326 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 4334 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 4338 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 4346 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 4354 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 4358 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 4365 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 4369 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 4377 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create operator class"),(yyvsp[(4) - (13)].str),(yyvsp[(5) - (13)].str),make_str("for type"),(yyvsp[(8) - (13)].str),make_str("using"),(yyvsp[(10) - (13)].str),(yyvsp[(11) - (13)].str),make_str("as"),(yyvsp[(13) - (13)].str));
;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 4385 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 4389 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 4397 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("operator"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 4401 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("operator"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 4405 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("function"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 4409 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("function"),(yyvsp[(2) - (7)].str),make_str("("),(yyvsp[(4) - (7)].str),make_str(")"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 4413 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("storage"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 4421 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4425 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4432 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("family"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4436 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4443 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("recheck");
;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4448 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4455 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create operator family"),(yyvsp[(4) - (6)].str),make_str("using"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4463 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (8)].str),make_str("using"),(yyvsp[(6) - (8)].str),make_str("add"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4467 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (8)].str),make_str("using"),(yyvsp[(6) - (8)].str),make_str("drop"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4475 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4479 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4487 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("operator"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4491 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("function"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4499 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator class"),(yyvsp[(4) - (7)].str),make_str("using"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4503 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator class if exists"),(yyvsp[(6) - (9)].str),make_str("using"),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4511 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator family"),(yyvsp[(4) - (7)].str),make_str("using"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4515 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop operator family if exists"),(yyvsp[(6) - (9)].str),make_str("using"),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4523 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("drop owned by"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4531 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("reassign owned by"),(yyvsp[(4) - (6)].str),make_str("to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4539 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop"),(yyvsp[(2) - (6)].str),make_str("if exists"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4543 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4551 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4555 "preproc.y"
    { 
 (yyval.str) = make_str("sequence");
;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4559 "preproc.y"
    { 
 (yyval.str) = make_str("view");
;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4563 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4567 "preproc.y"
    { 
 (yyval.str) = make_str("type");
;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4571 "preproc.y"
    { 
 (yyval.str) = make_str("domain");
;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4575 "preproc.y"
    { 
 (yyval.str) = make_str("conversion");
;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4579 "preproc.y"
    { 
 (yyval.str) = make_str("schema");
;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4583 "preproc.y"
    { 
 (yyval.str) = make_str("text search parser");
;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4587 "preproc.y"
    { 
 (yyval.str) = make_str("text search dictionary");
;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4591 "preproc.y"
    { 
 (yyval.str) = make_str("text search template");
;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4595 "preproc.y"
    { 
 (yyval.str) = make_str("text search configuration");
;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4603 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4607 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4615 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4619 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4627 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("."),(yyvsp[(2) - (2)].str));
;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4631 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4639 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("truncate"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4647 "preproc.y"
    { 
 (yyval.str) = make_str("continue identity");
;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4651 "preproc.y"
    { 
 (yyval.str) = make_str("restart identity");
;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4655 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4662 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("is"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4666 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on aggregate"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4670 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on function"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4674 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("comment on operator"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4678 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on constraint"),(yyvsp[(4) - (8)].str),make_str("on"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4682 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on rule"),(yyvsp[(4) - (8)].str),make_str("on"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4686 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on rule"),(yyvsp[(4) - (6)].str),make_str("is"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4690 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on trigger"),(yyvsp[(4) - (8)].str),make_str("on"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4694 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on operator class"),(yyvsp[(5) - (9)].str),make_str("using"),(yyvsp[(7) - (9)].str),make_str("is"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4698 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on operator family"),(yyvsp[(5) - (9)].str),make_str("using"),(yyvsp[(7) - (9)].str),make_str("is"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4702 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on large object"),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4706 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on cast ("),(yyvsp[(5) - (10)].str),make_str("as"),(yyvsp[(7) - (10)].str),make_str(") is"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4710 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("comment on"),(yyvsp[(3) - (7)].str),make_str("language"),(yyvsp[(5) - (7)].str),make_str("is"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4714 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search parser"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4718 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search dictionary"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4722 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search template"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4726 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("comment on text search configuration"),(yyvsp[(6) - (8)].str),make_str("is"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4734 "preproc.y"
    { 
 (yyval.str) = make_str("column");
;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4738 "preproc.y"
    { 
 (yyval.str) = make_str("database");
;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4742 "preproc.y"
    { 
 (yyval.str) = make_str("schema");
;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4746 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4750 "preproc.y"
    { 
 (yyval.str) = make_str("sequence");
;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4754 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4758 "preproc.y"
    { 
 (yyval.str) = make_str("domain");
;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4762 "preproc.y"
    { 
 (yyval.str) = make_str("type");
;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4766 "preproc.y"
    { 
 (yyval.str) = make_str("view");
;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4770 "preproc.y"
    { 
 (yyval.str) = make_str("conversion");
;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4774 "preproc.y"
    { 
 (yyval.str) = make_str("tablespace");
;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4778 "preproc.y"
    { 
 (yyval.str) = make_str("role");
;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4786 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4790 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4798 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("fetch"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4802 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("move"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4806 "preproc.y"
    {
		(yyval.str) = cat2_str(make_str("fetch"), (yyvsp[(2) - (3)].str));
	;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4810 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (4)].str);
		add_additional_variables((yyvsp[(3) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch forward"), cursor_marker);
	;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4816 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (5)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (5)].str);
		add_additional_variables((yyvsp[(4) - (5)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch forward from"), cursor_marker);
	;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4822 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (4)].str);
		add_additional_variables((yyvsp[(3) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch backward"), cursor_marker);
	;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4828 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (5)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (5)].str);
		add_additional_variables((yyvsp[(4) - (5)].str), false);
		(yyval.str) = cat_str(2, make_str("fetch backward from"), cursor_marker);
	;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4834 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (3)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (3)].str);
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		(yyval.str) = cat_str(2, make_str("move forward"), cursor_marker);
	;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4840 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (4)].str);
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("move forward from"), cursor_marker);
	;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4846 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(3) - (3)].str)[0] == ':' ? make_str("$0") : (yyvsp[(3) - (3)].str);
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		(yyval.str) = cat_str(2, make_str("move backward"), cursor_marker);
	;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4852 "preproc.y"
    {
		char *cursor_marker = (yyvsp[(4) - (4)].str)[0] == ':' ? make_str("$0") : (yyvsp[(4) - (4)].str);
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		(yyval.str) = cat_str(2, make_str("move backward from"), cursor_marker);
	;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4862 "preproc.y"
    { 
		add_additional_variables((yyvsp[(1) - (1)].str), false);
		if ((yyvsp[(1) - (1)].str)[0] == ':')
		{
			free((yyvsp[(1) - (1)].str));
			(yyvsp[(1) - (1)].str) = make_str("$0");
		}

 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4873 "preproc.y"
    { 
		add_additional_variables((yyvsp[(2) - (2)].str), false);
		if ((yyvsp[(2) - (2)].str)[0] == ':')
		{
			free((yyvsp[(2) - (2)].str));
			(yyvsp[(2) - (2)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4884 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("next"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4895 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("prior"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4906 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("first"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4917 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("last"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4928 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("absolute"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4944 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("relative"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4960 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}
		if ((yyvsp[(1) - (3)].str)[0] == '$')
		{
			free((yyvsp[(1) - (3)].str));
			(yyvsp[(1) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4976 "preproc.y"
    { 
		add_additional_variables((yyvsp[(3) - (3)].str), false);
		if ((yyvsp[(3) - (3)].str)[0] == ':')
		{
			free((yyvsp[(3) - (3)].str));
			(yyvsp[(3) - (3)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("all"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4987 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("forward"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 5003 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("forward all"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 5014 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}
		if ((yyvsp[(2) - (4)].str)[0] == '$')
		{
			free((yyvsp[(2) - (4)].str));
			(yyvsp[(2) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(4,make_str("backward"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 5030 "preproc.y"
    { 
		add_additional_variables((yyvsp[(4) - (4)].str), false);
		if ((yyvsp[(4) - (4)].str)[0] == ':')
		{
			free((yyvsp[(4) - (4)].str));
			(yyvsp[(4) - (4)].str) = make_str("$0");
		}

 (yyval.str) = cat_str(3,make_str("backward all"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 5045 "preproc.y"
    { 
 (yyval.str) = make_str("from");
;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 5049 "preproc.y"
    { 
 (yyval.str) = make_str("in");
;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 5057 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 5061 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 5068 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("grant"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("to"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 5076 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("from"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 5080 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke grant option for"),(yyvsp[(5) - (10)].str),make_str("on"),(yyvsp[(7) - (10)].str),make_str("from"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 5088 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 5092 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 5096 "preproc.y"
    { 
 (yyval.str) = make_str("all privileges");
;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 5100 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("all ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 5104 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("all privileges ("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 5112 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 5116 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 5124 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("select"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 5128 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("references"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 5132 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("create"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 5136 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 5144 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 5148 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("table"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 5152 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("sequence"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 5156 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("foreign data wrapper"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 5160 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("foreign server"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 5164 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("function"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 5168 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("database"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 5172 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("language"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 5176 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("large object"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 5180 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("schema"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 5184 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("tablespace"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 5188 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("all tables in schema"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 5192 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("all sequences in schema"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 5196 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("all functions in schema"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 5204 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 5208 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 5216 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 5220 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("group"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 5228 "preproc.y"
    { 
 (yyval.str) = make_str("with grant option");
;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 5232 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 5239 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 5243 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 5251 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 5259 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("grant"),(yyvsp[(2) - (6)].str),make_str("to"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 5267 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("revoke"),(yyvsp[(2) - (6)].str),make_str("from"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 5271 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("revoke admin option for"),(yyvsp[(5) - (9)].str),make_str("from"),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 5279 "preproc.y"
    { 
 (yyval.str) = make_str("with admin option");
;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 5283 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 5290 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("granted by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 5294 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 5301 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter default privileges"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 5309 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 5313 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 5320 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("in schema"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 5324 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("for role"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 5328 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("for user"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 5336 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("grant"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("to"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 5340 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke"),(yyvsp[(2) - (7)].str),make_str("on"),(yyvsp[(4) - (7)].str),make_str("from"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 5344 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("revoke grant option for"),(yyvsp[(5) - (10)].str),make_str("on"),(yyvsp[(7) - (10)].str),make_str("from"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 5352 "preproc.y"
    { 
 (yyval.str) = make_str("tables");
;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 5356 "preproc.y"
    { 
 (yyval.str) = make_str("functions");
;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 5360 "preproc.y"
    { 
 (yyval.str) = make_str("sequences");
;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5368 "preproc.y"
    { 
 (yyval.str) = cat_str(14,make_str("create"),(yyvsp[(2) - (14)].str),make_str("index"),(yyvsp[(4) - (14)].str),(yyvsp[(5) - (14)].str),make_str("on"),(yyvsp[(7) - (14)].str),(yyvsp[(8) - (14)].str),make_str("("),(yyvsp[(10) - (14)].str),make_str(")"),(yyvsp[(12) - (14)].str),(yyvsp[(13) - (14)].str),(yyvsp[(14) - (14)].str));
;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5376 "preproc.y"
    { 
 (yyval.str) = make_str("unique");
;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5380 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5387 "preproc.y"
    { 
 (yyval.str) = make_str("concurrently");
;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5391 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5398 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5402 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5409 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5413 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5420 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5424 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5432 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5436 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5440 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("("),(yyvsp[(2) - (6)].str),make_str(")"),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5448 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5452 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5456 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5463 "preproc.y"
    { 
 (yyval.str) = make_str("asc");
;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5467 "preproc.y"
    { 
 (yyval.str) = make_str("desc");
;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5471 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5478 "preproc.y"
    { 
 (yyval.str) = make_str("nulls first");
;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5482 "preproc.y"
    { 
 (yyval.str) = make_str("nulls last");
;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5486 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 810:

/* Line 1455 of yacc.c  */
#line 5493 "preproc.y"
    { 
 (yyval.str) = cat_str(9,make_str("create"),(yyvsp[(2) - (9)].str),make_str("function"),(yyvsp[(4) - (9)].str),(yyvsp[(5) - (9)].str),make_str("returns"),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5497 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (12)].str),make_str("function"),(yyvsp[(4) - (12)].str),(yyvsp[(5) - (12)].str),make_str("returns table ("),(yyvsp[(9) - (12)].str),make_str(")"),(yyvsp[(11) - (12)].str),(yyvsp[(12) - (12)].str));
;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5501 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create"),(yyvsp[(2) - (7)].str),make_str("function"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5509 "preproc.y"
    { 
 (yyval.str) = make_str("or replace");
;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5513 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5520 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 5524 "preproc.y"
    { 
 (yyval.str) = make_str("( )");
;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 5532 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 5536 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 5544 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5548 "preproc.y"
    { 
 (yyval.str) = make_str("( )");
;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5556 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5560 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5568 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5572 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5576 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5580 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5584 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5592 "preproc.y"
    { 
 (yyval.str) = make_str("in");
;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5596 "preproc.y"
    { 
 (yyval.str) = make_str("out");
;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5600 "preproc.y"
    { 
 (yyval.str) = make_str("inout");
;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5604 "preproc.y"
    { 
 (yyval.str) = make_str("in out");
;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5608 "preproc.y"
    { 
 (yyval.str) = make_str("variadic");
;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5616 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5624 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5632 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5636 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),make_str("% type"));
;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5640 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("setof"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("% type"));
;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5648 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5652 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("default"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5656 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5664 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5668 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5676 "preproc.y"
    { 
 (yyval.str) = make_str("called on null input");
;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5680 "preproc.y"
    { 
 (yyval.str) = make_str("returns null on null input");
;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5684 "preproc.y"
    { 
 (yyval.str) = make_str("strict");
;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5688 "preproc.y"
    { 
 (yyval.str) = make_str("immutable");
;}
    break;

  case 847:

/* Line 1455 of yacc.c  */
#line 5692 "preproc.y"
    { 
 (yyval.str) = make_str("stable");
;}
    break;

  case 848:

/* Line 1455 of yacc.c  */
#line 5696 "preproc.y"
    { 
 (yyval.str) = make_str("volatile");
;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5700 "preproc.y"
    { 
 (yyval.str) = make_str("external security definer");
;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5704 "preproc.y"
    { 
 (yyval.str) = make_str("external security invoker");
;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5708 "preproc.y"
    { 
 (yyval.str) = make_str("security definer");
;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5712 "preproc.y"
    { 
 (yyval.str) = make_str("security invoker");
;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5716 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cost"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5720 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rows"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5724 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5732 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("as"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5736 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("language"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5740 "preproc.y"
    { 
 (yyval.str) = make_str("window");
;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5744 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5752 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5756 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5764 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5768 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5775 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5783 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5787 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5795 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5803 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5807 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5815 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5819 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5826 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop function"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5830 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop function if exists"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5838 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop aggregate"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5842 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop aggregate if exists"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5850 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop operator"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5854 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("drop operator if exists"),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5862 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5866 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("("),(yyvsp[(2) - (5)].str),make_str(","),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5870 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("( none ,"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5874 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (5)].str),make_str(", none )"));
;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 5882 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5886 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("."),(yyvsp[(3) - (3)].str));
;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5894 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("do"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5902 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5906 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5914 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 5918 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("language"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 5926 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create cast ("),(yyvsp[(4) - (11)].str),make_str("as"),(yyvsp[(6) - (11)].str),make_str(") with function"),(yyvsp[(10) - (11)].str),(yyvsp[(11) - (11)].str));
;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 5930 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("create cast ("),(yyvsp[(4) - (10)].str),make_str("as"),(yyvsp[(6) - (10)].str),make_str(") without function"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 5934 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("create cast ("),(yyvsp[(4) - (10)].str),make_str("as"),(yyvsp[(6) - (10)].str),make_str(") with inout"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 5942 "preproc.y"
    { 
 (yyval.str) = make_str("as implicit");
;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5946 "preproc.y"
    { 
 (yyval.str) = make_str("as assignment");
;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5950 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5957 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("drop cast"),(yyvsp[(3) - (9)].str),make_str("("),(yyvsp[(5) - (9)].str),make_str("as"),(yyvsp[(7) - (9)].str),make_str(")"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5965 "preproc.y"
    { 
 (yyval.str) = make_str("if exists");
;}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5969 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5976 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("reindex"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5980 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("reindex system"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5984 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("reindex database"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5992 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5996 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 6004 "preproc.y"
    { 
 (yyval.str) = make_str("force");
;}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 6008 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 6015 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter aggregate"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("rename to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 6019 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter conversion"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 6023 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 6027 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 6031 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter group"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 6035 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter"),(yyvsp[(2) - (7)].str),make_str("language"),(yyvsp[(4) - (7)].str),make_str("rename to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 6039 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator class"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("rename to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 6043 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("rename to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 6047 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter schema"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 6051 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter table"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 6055 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter sequence"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 6059 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter view"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 6063 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter index"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 6067 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("alter table"),(yyvsp[(3) - (8)].str),make_str("rename"),(yyvsp[(5) - (8)].str),(yyvsp[(6) - (8)].str),make_str("to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 6071 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter trigger"),(yyvsp[(3) - (8)].str),make_str("on"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 6075 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter role"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 6079 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter user"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 6083 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 6087 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (5)].str),make_str("set"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 6091 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (5)].str),make_str("reset"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 6095 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search parser"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 6099 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search dictionary"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 6103 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search template"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 6107 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (8)].str),make_str("rename to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 6111 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter type"),(yyvsp[(3) - (6)].str),make_str("rename to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 6119 "preproc.y"
    { 
 (yyval.str) = make_str("column");
;}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 6123 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 6130 "preproc.y"
    { 
 (yyval.str) = make_str("set data");
;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 6134 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 6141 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter aggregate"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("set schema"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 6145 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 6149 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 6153 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter table"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 6157 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter sequence"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 6161 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter view"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 6165 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter type"),(yyvsp[(3) - (6)].str),make_str("set schema"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 941:

/* Line 1455 of yacc.c  */
#line 6173 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter aggregate"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 942:

/* Line 1455 of yacc.c  */
#line 6177 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter conversion"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 943:

/* Line 1455 of yacc.c  */
#line 6181 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 944:

/* Line 1455 of yacc.c  */
#line 6185 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 945:

/* Line 1455 of yacc.c  */
#line 6189 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter function"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 6193 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter"),(yyvsp[(2) - (7)].str),make_str("language"),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 6197 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter large object"),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 6201 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter operator"),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("owner to"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 6205 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator class"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("owner to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 6209 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter operator family"),(yyvsp[(4) - (9)].str),make_str("using"),(yyvsp[(6) - (9)].str),make_str("owner to"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 6213 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter schema"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 6217 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter type"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6221 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter tablespace"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6225 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search dictionary"),(yyvsp[(5) - (8)].str),make_str("owner to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 6229 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (8)].str),make_str("owner to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 6233 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter foreign data wrapper"),(yyvsp[(5) - (8)].str),make_str("owner to"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6237 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter server"),(yyvsp[(3) - (6)].str),make_str("owner to"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6245 "preproc.y"
    { 
 (yyval.str) = cat_str(12,make_str("create"),(yyvsp[(2) - (13)].str),make_str("rule"),(yyvsp[(4) - (13)].str),make_str("as on"),(yyvsp[(7) - (13)].str),make_str("to"),(yyvsp[(9) - (13)].str),(yyvsp[(10) - (13)].str),make_str("do"),(yyvsp[(12) - (13)].str),(yyvsp[(13) - (13)].str));
;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6253 "preproc.y"
    { 
 (yyval.str) = make_str("nothing");
;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6257 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6261 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6269 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(";"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6273 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6281 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6285 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6289 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6293 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6297 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6305 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6309 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6316 "preproc.y"
    { 
 (yyval.str) = make_str("select");
;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6320 "preproc.y"
    { 
 (yyval.str) = make_str("update");
;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6324 "preproc.y"
    { 
 (yyval.str) = make_str("delete");
;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6328 "preproc.y"
    { 
 (yyval.str) = make_str("insert");
;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6336 "preproc.y"
    { 
 (yyval.str) = make_str("instead");
;}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6340 "preproc.y"
    { 
 (yyval.str) = make_str("also");
;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6344 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6351 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop rule"),(yyvsp[(3) - (6)].str),make_str("on"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6355 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("drop rule if exists"),(yyvsp[(5) - (8)].str),make_str("on"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6363 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("notify"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6371 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str(","),(yyvsp[(2) - (2)].str));
;}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6375 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6382 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("listen"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6390 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("unlisten"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6394 "preproc.y"
    { 
 (yyval.str) = make_str("unlisten *");
;}
    break;

  case 986:

/* Line 1455 of yacc.c  */
#line 6402 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("abort"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6406 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("begin"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6410 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("start transaction"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6414 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("commit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6418 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("end"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6422 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rollback"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6426 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("savepoint"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6430 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("release savepoint"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6434 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("release"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6438 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("rollback"),(yyvsp[(2) - (5)].str),make_str("to savepoint"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6442 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("rollback"),(yyvsp[(2) - (4)].str),make_str("to"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 6446 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("prepare transaction"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 6450 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("commit prepared"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 6454 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rollback prepared"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 6462 "preproc.y"
    { 
 (yyval.str) = make_str("work");
;}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 6466 "preproc.y"
    { 
 (yyval.str) = make_str("transaction");
;}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 6470 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 6477 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("isolation level"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6481 "preproc.y"
    { 
 (yyval.str) = make_str("read only");
;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6485 "preproc.y"
    { 
 (yyval.str) = make_str("read write");
;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6493 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 6497 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 6501 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 6509 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 6513 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 6520 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("create"),(yyvsp[(2) - (8)].str),make_str("view"),(yyvsp[(4) - (8)].str),(yyvsp[(5) - (8)].str),make_str("as"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 6524 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("create or replace"),(yyvsp[(4) - (10)].str),make_str("view"),(yyvsp[(6) - (10)].str),(yyvsp[(7) - (10)].str),make_str("as"),(yyvsp[(9) - (10)].str),(yyvsp[(10) - (10)].str));
;}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 6532 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("with check option");
;}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6537 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("with cascaded check option");
;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6542 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = make_str("with local check option");
;}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6547 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6554 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("load"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6562 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("create database"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 6570 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 6574 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 6581 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("tablespace"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 6585 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("tablespace"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6589 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("location"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6593 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("location"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6597 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("template"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6601 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("template"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6605 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("encoding"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6609 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("encoding"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6613 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("encoding"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6617 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_collate"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6621 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_collate"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6625 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_ctype"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6629 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("lc_ctype"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6633 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("connection limit"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6637 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("owner"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6641 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("owner"),(yyvsp[(2) - (3)].str),make_str("default"));
;}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6649 "preproc.y"
    { 
 (yyval.str) = make_str("=");
;}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6653 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6660 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6664 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter database"),(yyvsp[(3) - (6)].str),make_str("set tablespace"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6672 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter database"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6680 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6684 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6691 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("connection limit"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6699 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop database"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6703 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("drop database if exists"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6711 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("create domain"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6719 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter domain"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6723 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("drop not null"));
;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6727 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter domain"),(yyvsp[(3) - (6)].str),make_str("set not null"));
;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6731 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter domain"),(yyvsp[(3) - (5)].str),make_str("add"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6735 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("alter domain"),(yyvsp[(3) - (7)].str),make_str("drop constraint"),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6743 "preproc.y"
    { 
 (yyval.str) = make_str("as");
;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6747 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6754 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("alter text search dictionary"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6762 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("add mapping for"),(yyvsp[(9) - (11)].str),make_str("with"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6766 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("alter mapping for"),(yyvsp[(9) - (11)].str),make_str("with"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6770 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("alter mapping replace"),(yyvsp[(9) - (11)].str),make_str("with"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6774 "preproc.y"
    { 
 (yyval.str) = cat_str(8,make_str("alter text search configuration"),(yyvsp[(5) - (13)].str),make_str("alter mapping for"),(yyvsp[(9) - (13)].str),make_str("replace"),(yyvsp[(11) - (13)].str),make_str("with"),(yyvsp[(13) - (13)].str));
;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6778 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (9)].str),make_str("drop mapping for"),(yyvsp[(9) - (9)].str));
;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6782 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("alter text search configuration"),(yyvsp[(5) - (11)].str),make_str("drop mapping if exists for"),(yyvsp[(11) - (11)].str));
;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6790 "preproc.y"
    { 
 (yyval.str) = cat_str(10,make_str("create"),(yyvsp[(2) - (10)].str),make_str("conversion"),(yyvsp[(4) - (10)].str),make_str("for"),(yyvsp[(6) - (10)].str),make_str("to"),(yyvsp[(8) - (10)].str),make_str("from"),(yyvsp[(10) - (10)].str));
;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6798 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("cluster"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6802 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("cluster"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 6806 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("cluster"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),make_str("on"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 6814 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6818 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6825 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("vacuum"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6829 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("vacuum"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6833 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("vacuum"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6837 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("vacuum ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1072:

/* Line 1455 of yacc.c  */
#line 6841 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("vacuum ("),(yyvsp[(3) - (6)].str),make_str(")"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1073:

/* Line 1455 of yacc.c  */
#line 6849 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1074:

/* Line 1455 of yacc.c  */
#line 6853 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1075:

/* Line 1455 of yacc.c  */
#line 6861 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1076:

/* Line 1455 of yacc.c  */
#line 6865 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 1077:

/* Line 1455 of yacc.c  */
#line 6869 "preproc.y"
    { 
 (yyval.str) = make_str("freeze");
;}
    break;

  case 1078:

/* Line 1455 of yacc.c  */
#line 6873 "preproc.y"
    { 
 (yyval.str) = make_str("full");
;}
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6881 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6885 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 6893 "preproc.y"
    { 
 (yyval.str) = make_str("analyze");
;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 6897 "preproc.y"
    { 
 (yyval.str) = make_str("analyse");
;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 6905 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 6909 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 6916 "preproc.y"
    { 
 (yyval.str) = make_str("full");
;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 6920 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 6927 "preproc.y"
    { 
 (yyval.str) = make_str("freeze");
;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 6931 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 6938 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 6942 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1091:

/* Line 1455 of yacc.c  */
#line 6949 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("explain"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1092:

/* Line 1455 of yacc.c  */
#line 6953 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("explain"),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1093:

/* Line 1455 of yacc.c  */
#line 6957 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("explain verbose"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1094:

/* Line 1455 of yacc.c  */
#line 6961 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("explain ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 6969 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 6973 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 6977 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 6981 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 6985 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 6989 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 6993 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 7001 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 7005 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 7013 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 7021 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 7025 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 7029 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7037 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7041 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7045 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7052 "preproc.y"
    {
		(yyval.prep).name = (yyvsp[(2) - (5)].str);
		(yyval.prep).type = (yyvsp[(3) - (5)].str);
		(yyval.prep).stmt = cat_str(3, make_str("\""), (yyvsp[(5) - (5)].str), make_str("\""));
	;}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7058 "preproc.y"
    {
		(yyval.prep).name = (yyvsp[(2) - (4)].str);
		(yyval.prep).type = NULL;
		(yyval.prep).stmt = (yyvsp[(4) - (4)].str);
	;}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7068 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7072 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7079 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7083 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7087 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7091 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7099 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (4)].str); ;}
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7101 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("create"),(yyvsp[(2) - (8)].str),make_str("table"),(yyvsp[(4) - (8)].str),make_str("as execute"),(yyvsp[(7) - (8)].str),(yyvsp[(8) - (8)].str));
;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7109 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7113 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7120 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("insert into"),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7128 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7132 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (4)].str),make_str(")"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7136 "preproc.y"
    { 
 (yyval.str) = make_str("default values");
;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7144 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7148 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7156 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7164 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("returning"),(yyvsp[(2) - (3)].str));
;}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7168 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7175 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("delete from"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7183 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("using"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7187 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7194 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("lock"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7202 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("in"),(yyvsp[(2) - (3)].str),make_str("mode"));
;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7206 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7213 "preproc.y"
    { 
 (yyval.str) = make_str("access share");
;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7217 "preproc.y"
    { 
 (yyval.str) = make_str("row share");
;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7221 "preproc.y"
    { 
 (yyval.str) = make_str("row exclusive");
;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7225 "preproc.y"
    { 
 (yyval.str) = make_str("share update exclusive");
;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7229 "preproc.y"
    { 
 (yyval.str) = make_str("share");
;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7233 "preproc.y"
    { 
 (yyval.str) = make_str("share row exclusive");
;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7237 "preproc.y"
    { 
 (yyval.str) = make_str("exclusive");
;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7241 "preproc.y"
    { 
 (yyval.str) = make_str("access exclusive");
;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7249 "preproc.y"
    { 
 (yyval.str) = make_str("nowait");
;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7253 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1148:

/* Line 1455 of yacc.c  */
#line 7260 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("update"),(yyvsp[(2) - (7)].str),make_str("set"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1149:

/* Line 1455 of yacc.c  */
#line 7268 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7272 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7280 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7284 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7292 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7300 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (5)].str),make_str(") ="),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7308 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7316 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7320 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7328 "preproc.y"
    {
		struct cursor *ptr, *this;
		char *cursor_marker = (yyvsp[(2) - (7)].str)[0] == ':' ? make_str("$0") : mm_strdup((yyvsp[(2) - (7)].str));
		char *comment, *c1, *c2;

		for (ptr = cur; ptr != NULL; ptr = ptr->next)
		{
			if (strcmp((yyvsp[(2) - (7)].str), ptr->name) == 0)
			{
				if ((yyvsp[(2) - (7)].str)[0] == ':')
                                        mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[(2) - (7)].str)+1);
                                else
					mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[(2) - (7)].str));
			}
		}

		this = (struct cursor *) mm_alloc(sizeof(struct cursor));

		this->next = cur;
		this->name = (yyvsp[(2) - (7)].str);
		this->function = (current_function ? mm_strdup(current_function) : NULL);
		this->connection = connection;
		this->opened = false;
		this->command =  cat_str(7, make_str("declare"), cursor_marker, (yyvsp[(3) - (7)].str), make_str("cursor"), (yyvsp[(5) - (7)].str), make_str("for"), (yyvsp[(7) - (7)].str));
		this->argsinsert = argsinsert;
		this->argsinsert_oos = NULL;
		this->argsresult = argsresult;
		this->argsresult_oos = NULL;
		argsinsert = argsresult = NULL;
		cur = this;

		c1 = mm_strdup(this->command);
		if ((c2 = strstr(c1, "*/")) != NULL)
		{
			/* We put this text into a comment, so we better remove [*][/]. */
			c2[0] = '.';
			c2[1] = '.';
		}
		comment = cat_str(3, make_str("/*"), c1, make_str("*/"));

		if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
			(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
				make_str("ECPG_informix_reset_sqlca();"),
				comment);
		else
			(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
	;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7380 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7384 "preproc.y"
    {
			char *curname = mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 2);
			sprintf(curname, ":%s", (yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
			(yyvsp[(1) - (1)].str) = curname;
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7396 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7399 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("no scroll"));
;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7403 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("scroll"));
;}
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7407 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("binary"));
;}
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7411 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("insensitive"));
;}
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7419 "preproc.y"
    {
		if (compat == ECPG_COMPAT_INFORMIX_SE && autocommit == true)
			(yyval.str) = make_str("with hold");
		else
			(yyval.str) = EMPTY;
	;}
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7426 "preproc.y"
    { 
 (yyval.str) = make_str("with hold");
;}
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7430 "preproc.y"
    { 
 (yyval.str) = make_str("without hold");
;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7438 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7442 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7450 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7454 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7462 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7466 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7470 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7474 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7478 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7482 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7486 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7490 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7498 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7502 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7510 "preproc.y"
    { 
 (yyval.str) = cat_str(9,make_str("select"),(yyvsp[(2) - (9)].str),(yyvsp[(3) - (9)].str),(yyvsp[(4) - (9)].str),(yyvsp[(5) - (9)].str),(yyvsp[(6) - (9)].str),(yyvsp[(7) - (9)].str),(yyvsp[(8) - (9)].str),(yyvsp[(9) - (9)].str));
;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7514 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7518 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("table"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7522 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("union"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7526 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("intersect"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7530 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("except"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7538 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7542 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("with recursive"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7550 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7554 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7562 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),make_str("as"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7570 "preproc.y"
    {
						FoundInto = 1;
						(yyval.str)= cat2_str(make_str("into"), (yyvsp[(2) - (2)].str));
					;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7574 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7576 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7583 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("temporary"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7587 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("temp"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7591 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("local temporary"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7595 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("local temp"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7599 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("global temporary"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7603 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("global temp"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7607 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("table"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7611 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7619 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7623 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7630 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7634 "preproc.y"
    { 
 (yyval.str) = make_str("distinct");
;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7638 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7645 "preproc.y"
    { 
 (yyval.str) = make_str("distinct");
;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7649 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("distinct on ("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7653 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7657 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7664 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7668 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7675 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("order by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7683 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7687 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7695 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("using"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7699 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7707 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7711 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7715 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7719 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7727 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7731 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7738 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("limit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7742 "preproc.y"
    {
                mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
                (yyval.str) = cat_str(4, make_str("limit"), (yyvsp[(2) - (4)].str), make_str(","), (yyvsp[(4) - (4)].str));
        ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7747 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("fetch"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),make_str("only"));
;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7755 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("offset"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7759 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("offset"),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7767 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7771 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 7779 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 7787 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 7791 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 7795 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 7802 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 7810 "preproc.y"
    { 
 (yyval.str) = make_str("row");
;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 7814 "preproc.y"
    { 
 (yyval.str) = make_str("rows");
;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 7822 "preproc.y"
    { 
 (yyval.str) = make_str("first");
;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 7826 "preproc.y"
    { 
 (yyval.str) = make_str("next");
;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 7834 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("group by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 7838 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 7845 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("having"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 7849 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 7856 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 7860 "preproc.y"
    { 
 (yyval.str) = make_str("for read only");
;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 7868 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 7872 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 7879 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 7883 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 7891 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("for update"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 7895 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("for share"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 7903 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("of"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 7907 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 7914 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("values"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 7918 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 7926 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 7930 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 7937 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 7941 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 7949 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 7953 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 7957 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 7961 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 7965 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (5)].str),make_str("as ("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 7969 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("as"),(yyvsp[(3) - (6)].str),make_str("("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 7973 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 7977 "preproc.y"
    { 
		mmerror(PARSE_ERROR, ET_ERROR, "subquery in FROM must have an alias");

 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 7983 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 7987 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 7991 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (4)].str),make_str(")"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 7999 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8003 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("cross join"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8007 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),(yyvsp[(2) - (5)].str),make_str("join"),(yyvsp[(4) - (5)].str),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8011 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("join"),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8015 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("natural"),(yyvsp[(3) - (5)].str),make_str("join"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8019 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("natural join"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8027 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("as"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8031 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("as"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8035 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),make_str("("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8039 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8047 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("full"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8051 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("left"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8055 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("right"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8059 "preproc.y"
    { 
 (yyval.str) = make_str("inner");
;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8067 "preproc.y"
    { 
 (yyval.str) = make_str("outer");
;}
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8071 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8078 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("using ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8082 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("on"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8090 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1293:

/* Line 1455 of yacc.c  */
#line 8094 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("*"));
;}
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 8098 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("only"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8102 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("only ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8110 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8114 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8122 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8126 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8130 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8138 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8146 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("where"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8150 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8157 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("where"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8161 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("where current of"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8165 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8172 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8176 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8184 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8192 "preproc.y"
    {	(yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].index).str); ;}
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8194 "preproc.y"
    {	(yyval.str) = cat_str(3, make_str("setof"), (yyvsp[(2) - (3)].str), (yyvsp[(3) - (3)].index).str); ;}
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8196 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (5)].str),make_str("array ["),(yyvsp[(4) - (5)].str),make_str("]"));
;}
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8200 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("setof"),(yyvsp[(2) - (6)].str),make_str("array ["),(yyvsp[(5) - (6)].str),make_str("]"));
;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8204 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("array"));
;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8208 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("setof"),(yyvsp[(2) - (3)].str),make_str("array"));
;}
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8216 "preproc.y"
    {
		(yyval.index).index1 = (yyvsp[(1) - (3)].index).index1;
		(yyval.index).index2 = (yyvsp[(1) - (3)].index).index2;
		if (strcmp((yyval.index).index1, "-1") == 0)
			(yyval.index).index1 = make_str("0");
		else if (strcmp((yyvsp[(1) - (3)].index).index2, "-1") == 0)
			(yyval.index).index2 = make_str("0");
		(yyval.index).str = cat_str(2, (yyvsp[(1) - (3)].index).str, make_str("[]"));
	;}
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8226 "preproc.y"
    {
		(yyval.index).index1 = (yyvsp[(1) - (4)].index).index1;
		(yyval.index).index2 = (yyvsp[(1) - (4)].index).index2;
		if (strcmp((yyvsp[(1) - (4)].index).index1, "-1") == 0)
			(yyval.index).index1 = strdup((yyvsp[(3) - (4)].str));
		else if (strcmp((yyvsp[(1) - (4)].index).index2, "-1") == 0)
			(yyval.index).index2 = strdup((yyvsp[(3) - (4)].str));
		(yyval.index).str = cat_str(4, (yyvsp[(1) - (4)].index).str, make_str("["), (yyvsp[(3) - (4)].str), make_str("]"));
	;}
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8236 "preproc.y"
    {
		(yyval.index).index1 = make_str("-1");
		(yyval.index).index2 = make_str("-1");
		(yyval.index).str= EMPTY;
	;}
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8246 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8250 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8254 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8258 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8262 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8266 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8270 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8278 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8282 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8286 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8290 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8298 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8302 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8310 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8314 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8321 "preproc.y"
    { 
 (yyval.str) = make_str("int");
;}
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8325 "preproc.y"
    { 
 (yyval.str) = make_str("integer");
;}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8329 "preproc.y"
    { 
 (yyval.str) = make_str("smallint");
;}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8333 "preproc.y"
    { 
 (yyval.str) = make_str("bigint");
;}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8337 "preproc.y"
    { 
 (yyval.str) = make_str("real");
;}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8341 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("float"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8345 "preproc.y"
    { 
 (yyval.str) = make_str("double precision");
;}
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8349 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("decimal"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8353 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("dec"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8357 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("numeric"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8361 "preproc.y"
    { 
 (yyval.str) = make_str("boolean");
;}
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8369 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8373 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8380 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8384 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8392 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1350:

/* Line 1455 of yacc.c  */
#line 8396 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1351:

/* Line 1455 of yacc.c  */
#line 8404 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("bit"),(yyvsp[(2) - (5)].str),make_str("("),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1352:

/* Line 1455 of yacc.c  */
#line 8412 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("bit"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1353:

/* Line 1455 of yacc.c  */
#line 8420 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1354:

/* Line 1455 of yacc.c  */
#line 8424 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1355:

/* Line 1455 of yacc.c  */
#line 8432 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1356:

/* Line 1455 of yacc.c  */
#line 8436 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1357:

/* Line 1455 of yacc.c  */
#line 8444 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1358:

/* Line 1455 of yacc.c  */
#line 8452 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1359:

/* Line 1455 of yacc.c  */
#line 8460 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("character"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1360:

/* Line 1455 of yacc.c  */
#line 8464 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("char"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1361:

/* Line 1455 of yacc.c  */
#line 8468 "preproc.y"
    { 
 (yyval.str) = make_str("varchar");
;}
    break;

  case 1362:

/* Line 1455 of yacc.c  */
#line 8472 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("national character"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1363:

/* Line 1455 of yacc.c  */
#line 8476 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("national char"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1364:

/* Line 1455 of yacc.c  */
#line 8480 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("nchar"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1365:

/* Line 1455 of yacc.c  */
#line 8488 "preproc.y"
    { 
 (yyval.str) = make_str("varying");
;}
    break;

  case 1366:

/* Line 1455 of yacc.c  */
#line 8492 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1367:

/* Line 1455 of yacc.c  */
#line 8499 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("character set"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1368:

/* Line 1455 of yacc.c  */
#line 8503 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1369:

/* Line 1455 of yacc.c  */
#line 8510 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("timestamp ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1370:

/* Line 1455 of yacc.c  */
#line 8514 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("timestamp"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1371:

/* Line 1455 of yacc.c  */
#line 8518 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("time ("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1372:

/* Line 1455 of yacc.c  */
#line 8522 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("time"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1373:

/* Line 1455 of yacc.c  */
#line 8530 "preproc.y"
    { 
 (yyval.str) = make_str("interval");
;}
    break;

  case 1374:

/* Line 1455 of yacc.c  */
#line 8538 "preproc.y"
    { 
 (yyval.str) = make_str("with time zone");
;}
    break;

  case 1375:

/* Line 1455 of yacc.c  */
#line 8542 "preproc.y"
    { 
 (yyval.str) = make_str("without time zone");
;}
    break;

  case 1376:

/* Line 1455 of yacc.c  */
#line 8546 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1377:

/* Line 1455 of yacc.c  */
#line 8553 "preproc.y"
    { 
 (yyval.str) = make_str("year");
;}
    break;

  case 1378:

/* Line 1455 of yacc.c  */
#line 8557 "preproc.y"
    { 
 (yyval.str) = make_str("month");
;}
    break;

  case 1379:

/* Line 1455 of yacc.c  */
#line 8561 "preproc.y"
    { 
 (yyval.str) = make_str("day");
;}
    break;

  case 1380:

/* Line 1455 of yacc.c  */
#line 8565 "preproc.y"
    { 
 (yyval.str) = make_str("hour");
;}
    break;

  case 1381:

/* Line 1455 of yacc.c  */
#line 8569 "preproc.y"
    { 
 (yyval.str) = make_str("minute");
;}
    break;

  case 1382:

/* Line 1455 of yacc.c  */
#line 8573 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1383:

/* Line 1455 of yacc.c  */
#line 8577 "preproc.y"
    { 
 (yyval.str) = make_str("year to month");
;}
    break;

  case 1384:

/* Line 1455 of yacc.c  */
#line 8581 "preproc.y"
    { 
 (yyval.str) = make_str("day to hour");
;}
    break;

  case 1385:

/* Line 1455 of yacc.c  */
#line 8585 "preproc.y"
    { 
 (yyval.str) = make_str("day to minute");
;}
    break;

  case 1386:

/* Line 1455 of yacc.c  */
#line 8589 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("day to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1387:

/* Line 1455 of yacc.c  */
#line 8593 "preproc.y"
    { 
 (yyval.str) = make_str("hour to minute");
;}
    break;

  case 1388:

/* Line 1455 of yacc.c  */
#line 8597 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("hour to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1389:

/* Line 1455 of yacc.c  */
#line 8601 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("minute to"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1390:

/* Line 1455 of yacc.c  */
#line 8605 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1391:

/* Line 1455 of yacc.c  */
#line 8612 "preproc.y"
    { 
 (yyval.str) = make_str("second");
;}
    break;

  case 1392:

/* Line 1455 of yacc.c  */
#line 8616 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("second ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1393:

/* Line 1455 of yacc.c  */
#line 8624 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1394:

/* Line 1455 of yacc.c  */
#line 8628 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("::"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1395:

/* Line 1455 of yacc.c  */
#line 8632 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("at time zone"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1396:

/* Line 1455 of yacc.c  */
#line 8636 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("+"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1397:

/* Line 1455 of yacc.c  */
#line 8640 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1398:

/* Line 1455 of yacc.c  */
#line 8644 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("+"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1399:

/* Line 1455 of yacc.c  */
#line 8648 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("-"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1400:

/* Line 1455 of yacc.c  */
#line 8652 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("*"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1401:

/* Line 1455 of yacc.c  */
#line 8656 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("/"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1402:

/* Line 1455 of yacc.c  */
#line 8660 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("%"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1403:

/* Line 1455 of yacc.c  */
#line 8664 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("^"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1404:

/* Line 1455 of yacc.c  */
#line 8668 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("<"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1405:

/* Line 1455 of yacc.c  */
#line 8672 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(">"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1406:

/* Line 1455 of yacc.c  */
#line 8676 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1407:

/* Line 1455 of yacc.c  */
#line 8680 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1408:

/* Line 1455 of yacc.c  */
#line 8684 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1409:

/* Line 1455 of yacc.c  */
#line 8688 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1410:

/* Line 1455 of yacc.c  */
#line 8692 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("and"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1411:

/* Line 1455 of yacc.c  */
#line 8696 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("or"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1412:

/* Line 1455 of yacc.c  */
#line 8700 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("not"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1413:

/* Line 1455 of yacc.c  */
#line 8704 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("like"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1414:

/* Line 1455 of yacc.c  */
#line 8708 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("like"),(yyvsp[(3) - (5)].str),make_str("escape"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1415:

/* Line 1455 of yacc.c  */
#line 8712 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("not like"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1416:

/* Line 1455 of yacc.c  */
#line 8716 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("not like"),(yyvsp[(4) - (6)].str),make_str("escape"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1417:

/* Line 1455 of yacc.c  */
#line 8720 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("ilike"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1418:

/* Line 1455 of yacc.c  */
#line 8724 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("ilike"),(yyvsp[(3) - (5)].str),make_str("escape"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1419:

/* Line 1455 of yacc.c  */
#line 8728 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("not ilike"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1420:

/* Line 1455 of yacc.c  */
#line 8732 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("not ilike"),(yyvsp[(4) - (6)].str),make_str("escape"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1421:

/* Line 1455 of yacc.c  */
#line 8736 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("similar to"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1422:

/* Line 1455 of yacc.c  */
#line 8740 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("similar to"),(yyvsp[(4) - (6)].str),make_str("escape"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1423:

/* Line 1455 of yacc.c  */
#line 8744 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("not similar to"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1424:

/* Line 1455 of yacc.c  */
#line 8748 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (7)].str),make_str("not similar to"),(yyvsp[(5) - (7)].str),make_str("escape"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1425:

/* Line 1455 of yacc.c  */
#line 8752 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is null"));
;}
    break;

  case 1426:

/* Line 1455 of yacc.c  */
#line 8756 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("isnull"));
;}
    break;

  case 1427:

/* Line 1455 of yacc.c  */
#line 8760 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not null"));
;}
    break;

  case 1428:

/* Line 1455 of yacc.c  */
#line 8764 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("notnull"));
;}
    break;

  case 1429:

/* Line 1455 of yacc.c  */
#line 8768 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("overlaps"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1430:

/* Line 1455 of yacc.c  */
#line 8772 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is true"));
;}
    break;

  case 1431:

/* Line 1455 of yacc.c  */
#line 8776 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not true"));
;}
    break;

  case 1432:

/* Line 1455 of yacc.c  */
#line 8780 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is false"));
;}
    break;

  case 1433:

/* Line 1455 of yacc.c  */
#line 8784 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not false"));
;}
    break;

  case 1434:

/* Line 1455 of yacc.c  */
#line 8788 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is unknown"));
;}
    break;

  case 1435:

/* Line 1455 of yacc.c  */
#line 8792 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not unknown"));
;}
    break;

  case 1436:

/* Line 1455 of yacc.c  */
#line 8796 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("is distinct from"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1437:

/* Line 1455 of yacc.c  */
#line 8800 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (6)].str),make_str("is not distinct from"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1438:

/* Line 1455 of yacc.c  */
#line 8804 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (6)].str),make_str("is of ("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1439:

/* Line 1455 of yacc.c  */
#line 8808 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (7)].str),make_str("is not of ("),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1440:

/* Line 1455 of yacc.c  */
#line 8812 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("between"),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str("and"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1441:

/* Line 1455 of yacc.c  */
#line 8816 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (7)].str),make_str("not between"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str("and"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1442:

/* Line 1455 of yacc.c  */
#line 8820 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("between symmetric"),(yyvsp[(4) - (6)].str),make_str("and"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1443:

/* Line 1455 of yacc.c  */
#line 8824 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (7)].str),make_str("not between symmetric"),(yyvsp[(5) - (7)].str),make_str("and"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1444:

/* Line 1455 of yacc.c  */
#line 8828 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("in"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1445:

/* Line 1455 of yacc.c  */
#line 8832 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("not in"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1446:

/* Line 1455 of yacc.c  */
#line 8836 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1447:

/* Line 1455 of yacc.c  */
#line 8840 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),make_str("("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1448:

/* Line 1455 of yacc.c  */
#line 8844 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,make_str("unique"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1449:

/* Line 1455 of yacc.c  */
#line 8849 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is document"));
;}
    break;

  case 1450:

/* Line 1455 of yacc.c  */
#line 8853 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not document"));
;}
    break;

  case 1451:

/* Line 1455 of yacc.c  */
#line 8861 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1452:

/* Line 1455 of yacc.c  */
#line 8865 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("::"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1453:

/* Line 1455 of yacc.c  */
#line 8869 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("+"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1454:

/* Line 1455 of yacc.c  */
#line 8873 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1455:

/* Line 1455 of yacc.c  */
#line 8877 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("+"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1456:

/* Line 1455 of yacc.c  */
#line 8881 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("-"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1457:

/* Line 1455 of yacc.c  */
#line 8885 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("*"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1458:

/* Line 1455 of yacc.c  */
#line 8889 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("/"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1459:

/* Line 1455 of yacc.c  */
#line 8893 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("%"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1460:

/* Line 1455 of yacc.c  */
#line 8897 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("^"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1461:

/* Line 1455 of yacc.c  */
#line 8901 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("<"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1462:

/* Line 1455 of yacc.c  */
#line 8905 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(">"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1463:

/* Line 1455 of yacc.c  */
#line 8909 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1464:

/* Line 1455 of yacc.c  */
#line 8913 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1465:

/* Line 1455 of yacc.c  */
#line 8917 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1466:

/* Line 1455 of yacc.c  */
#line 8921 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1467:

/* Line 1455 of yacc.c  */
#line 8925 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("is distinct from"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1468:

/* Line 1455 of yacc.c  */
#line 8929 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (6)].str),make_str("is not distinct from"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1469:

/* Line 1455 of yacc.c  */
#line 8933 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (6)].str),make_str("is of ("),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1470:

/* Line 1455 of yacc.c  */
#line 8937 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (7)].str),make_str("is not of ("),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1471:

/* Line 1455 of yacc.c  */
#line 8941 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (3)].str),make_str("is document"));
;}
    break;

  case 1472:

/* Line 1455 of yacc.c  */
#line 8945 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (4)].str),make_str("is not document"));
;}
    break;

  case 1473:

/* Line 1455 of yacc.c  */
#line 8953 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1474:

/* Line 1455 of yacc.c  */
#line 8957 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1475:

/* Line 1455 of yacc.c  */
#line 8961 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1476:

/* Line 1455 of yacc.c  */
#line 8965 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("("),(yyvsp[(2) - (4)].str),make_str(")"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1477:

/* Line 1455 of yacc.c  */
#line 8969 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1478:

/* Line 1455 of yacc.c  */
#line 8973 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1479:

/* Line 1455 of yacc.c  */
#line 8977 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1480:

/* Line 1455 of yacc.c  */
#line 8981 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1481:

/* Line 1455 of yacc.c  */
#line 8985 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("exists"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1482:

/* Line 1455 of yacc.c  */
#line 8989 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("array"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1483:

/* Line 1455 of yacc.c  */
#line 8993 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("array"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1484:

/* Line 1455 of yacc.c  */
#line 8997 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1485:

/* Line 1455 of yacc.c  */
#line 9005 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (4)].str),make_str("( )"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1486:

/* Line 1455 of yacc.c  */
#line 9009 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1487:

/* Line 1455 of yacc.c  */
#line 9013 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (6)].str),make_str("( variadic"),(yyvsp[(4) - (6)].str),make_str(")"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1488:

/* Line 1455 of yacc.c  */
#line 9017 "preproc.y"
    { 
 (yyval.str) = cat_str(7,(yyvsp[(1) - (8)].str),make_str("("),(yyvsp[(3) - (8)].str),make_str(", variadic"),(yyvsp[(6) - (8)].str),make_str(")"),(yyvsp[(8) - (8)].str));
;}
    break;

  case 1489:

/* Line 1455 of yacc.c  */
#line 9021 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("("),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),make_str(")"),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1490:

/* Line 1455 of yacc.c  */
#line 9025 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (7)].str),make_str("( all"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str(")"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1491:

/* Line 1455 of yacc.c  */
#line 9029 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (7)].str),make_str("( distinct"),(yyvsp[(4) - (7)].str),(yyvsp[(5) - (7)].str),make_str(")"),(yyvsp[(7) - (7)].str));
;}
    break;

  case 1492:

/* Line 1455 of yacc.c  */
#line 9033 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (5)].str),make_str("( * )"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1493:

/* Line 1455 of yacc.c  */
#line 9037 "preproc.y"
    { 
 (yyval.str) = make_str("current_date");
;}
    break;

  case 1494:

/* Line 1455 of yacc.c  */
#line 9041 "preproc.y"
    { 
 (yyval.str) = make_str("current_time");
;}
    break;

  case 1495:

/* Line 1455 of yacc.c  */
#line 9045 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("current_time ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1496:

/* Line 1455 of yacc.c  */
#line 9049 "preproc.y"
    { 
 (yyval.str) = make_str("current_timestamp");
;}
    break;

  case 1497:

/* Line 1455 of yacc.c  */
#line 9053 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("current_timestamp ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1498:

/* Line 1455 of yacc.c  */
#line 9057 "preproc.y"
    { 
 (yyval.str) = make_str("localtime");
;}
    break;

  case 1499:

/* Line 1455 of yacc.c  */
#line 9061 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("localtime ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1500:

/* Line 1455 of yacc.c  */
#line 9065 "preproc.y"
    { 
 (yyval.str) = make_str("localtimestamp");
;}
    break;

  case 1501:

/* Line 1455 of yacc.c  */
#line 9069 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("localtimestamp ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1502:

/* Line 1455 of yacc.c  */
#line 9073 "preproc.y"
    { 
 (yyval.str) = make_str("current_role");
;}
    break;

  case 1503:

/* Line 1455 of yacc.c  */
#line 9077 "preproc.y"
    { 
 (yyval.str) = make_str("current_user");
;}
    break;

  case 1504:

/* Line 1455 of yacc.c  */
#line 9081 "preproc.y"
    { 
 (yyval.str) = make_str("session_user");
;}
    break;

  case 1505:

/* Line 1455 of yacc.c  */
#line 9085 "preproc.y"
    { 
 (yyval.str) = make_str("user");
;}
    break;

  case 1506:

/* Line 1455 of yacc.c  */
#line 9089 "preproc.y"
    { 
 (yyval.str) = make_str("current_catalog");
;}
    break;

  case 1507:

/* Line 1455 of yacc.c  */
#line 9093 "preproc.y"
    { 
 (yyval.str) = make_str("current_schema");
;}
    break;

  case 1508:

/* Line 1455 of yacc.c  */
#line 9097 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("cast ("),(yyvsp[(3) - (6)].str),make_str("as"),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1509:

/* Line 1455 of yacc.c  */
#line 9101 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("extract ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1510:

/* Line 1455 of yacc.c  */
#line 9105 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("overlay ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1511:

/* Line 1455 of yacc.c  */
#line 9109 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("position ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1512:

/* Line 1455 of yacc.c  */
#line 9113 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("substring ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1513:

/* Line 1455 of yacc.c  */
#line 9117 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("treat ("),(yyvsp[(3) - (6)].str),make_str("as"),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1514:

/* Line 1455 of yacc.c  */
#line 9121 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ( both"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1515:

/* Line 1455 of yacc.c  */
#line 9125 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ( leading"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1516:

/* Line 1455 of yacc.c  */
#line 9129 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ( trailing"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1517:

/* Line 1455 of yacc.c  */
#line 9133 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("trim ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1518:

/* Line 1455 of yacc.c  */
#line 9137 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("nullif ("),(yyvsp[(3) - (6)].str),make_str(","),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1519:

/* Line 1455 of yacc.c  */
#line 9141 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("coalesce ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1520:

/* Line 1455 of yacc.c  */
#line 9145 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("greatest ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1521:

/* Line 1455 of yacc.c  */
#line 9149 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("least ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1522:

/* Line 1455 of yacc.c  */
#line 9153 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlconcat ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1523:

/* Line 1455 of yacc.c  */
#line 9157 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlelement ( name"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1524:

/* Line 1455 of yacc.c  */
#line 9161 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlelement ( name"),(yyvsp[(4) - (7)].str),make_str(","),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1525:

/* Line 1455 of yacc.c  */
#line 9165 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlelement ( name"),(yyvsp[(4) - (7)].str),make_str(","),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1526:

/* Line 1455 of yacc.c  */
#line 9169 "preproc.y"
    { 
 (yyval.str) = cat_str(7,make_str("xmlelement ( name"),(yyvsp[(4) - (9)].str),make_str(","),(yyvsp[(6) - (9)].str),make_str(","),(yyvsp[(8) - (9)].str),make_str(")"));
;}
    break;

  case 1527:

/* Line 1455 of yacc.c  */
#line 9173 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlforest ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1528:

/* Line 1455 of yacc.c  */
#line 9177 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlparse ("),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1529:

/* Line 1455 of yacc.c  */
#line 9181 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlpi ( name"),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1530:

/* Line 1455 of yacc.c  */
#line 9185 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("xmlpi ( name"),(yyvsp[(4) - (7)].str),make_str(","),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1531:

/* Line 1455 of yacc.c  */
#line 9189 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("xmlroot ("),(yyvsp[(3) - (7)].str),make_str(","),(yyvsp[(5) - (7)].str),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1532:

/* Line 1455 of yacc.c  */
#line 9193 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("xmlserialize ("),(yyvsp[(3) - (7)].str),(yyvsp[(4) - (7)].str),make_str("as"),(yyvsp[(6) - (7)].str),make_str(")"));
;}
    break;

  case 1533:

/* Line 1455 of yacc.c  */
#line 9201 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("version"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1534:

/* Line 1455 of yacc.c  */
#line 9205 "preproc.y"
    { 
 (yyval.str) = make_str("version no value");
;}
    break;

  case 1535:

/* Line 1455 of yacc.c  */
#line 9213 "preproc.y"
    { 
 (yyval.str) = make_str(", standalone yes");
;}
    break;

  case 1536:

/* Line 1455 of yacc.c  */
#line 9217 "preproc.y"
    { 
 (yyval.str) = make_str(", standalone no");
;}
    break;

  case 1537:

/* Line 1455 of yacc.c  */
#line 9221 "preproc.y"
    { 
 (yyval.str) = make_str(", standalone no value");
;}
    break;

  case 1538:

/* Line 1455 of yacc.c  */
#line 9225 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1539:

/* Line 1455 of yacc.c  */
#line 9232 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("xmlattributes ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1540:

/* Line 1455 of yacc.c  */
#line 9240 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1541:

/* Line 1455 of yacc.c  */
#line 9244 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1542:

/* Line 1455 of yacc.c  */
#line 9252 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1543:

/* Line 1455 of yacc.c  */
#line 9256 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1544:

/* Line 1455 of yacc.c  */
#line 9264 "preproc.y"
    { 
 (yyval.str) = make_str("document");
;}
    break;

  case 1545:

/* Line 1455 of yacc.c  */
#line 9268 "preproc.y"
    { 
 (yyval.str) = make_str("content");
;}
    break;

  case 1546:

/* Line 1455 of yacc.c  */
#line 9276 "preproc.y"
    { 
 (yyval.str) = make_str("preserve whitespace");
;}
    break;

  case 1547:

/* Line 1455 of yacc.c  */
#line 9280 "preproc.y"
    { 
 (yyval.str) = make_str("strip whitespace");
;}
    break;

  case 1548:

/* Line 1455 of yacc.c  */
#line 9284 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1549:

/* Line 1455 of yacc.c  */
#line 9291 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("window"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1550:

/* Line 1455 of yacc.c  */
#line 9295 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1551:

/* Line 1455 of yacc.c  */
#line 9302 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1552:

/* Line 1455 of yacc.c  */
#line 9306 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1553:

/* Line 1455 of yacc.c  */
#line 9314 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1554:

/* Line 1455 of yacc.c  */
#line 9322 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("over"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1555:

/* Line 1455 of yacc.c  */
#line 9326 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("over"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1556:

/* Line 1455 of yacc.c  */
#line 9330 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1557:

/* Line 1455 of yacc.c  */
#line 9337 "preproc.y"
    { 
 (yyval.str) = cat_str(6,make_str("("),(yyvsp[(2) - (6)].str),(yyvsp[(3) - (6)].str),(yyvsp[(4) - (6)].str),(yyvsp[(5) - (6)].str),make_str(")"));
;}
    break;

  case 1558:

/* Line 1455 of yacc.c  */
#line 9345 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1559:

/* Line 1455 of yacc.c  */
#line 9349 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1560:

/* Line 1455 of yacc.c  */
#line 9356 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("partition by"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1561:

/* Line 1455 of yacc.c  */
#line 9360 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1562:

/* Line 1455 of yacc.c  */
#line 9367 "preproc.y"
    { 
mmerror(PARSE_ERROR, ET_WARNING, "unsupported feature will be passed to server");
 (yyval.str) = cat_str(2,make_str("range"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1563:

/* Line 1455 of yacc.c  */
#line 9372 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("rows"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1564:

/* Line 1455 of yacc.c  */
#line 9376 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1565:

/* Line 1455 of yacc.c  */
#line 9383 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1566:

/* Line 1455 of yacc.c  */
#line 9387 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("between"),(yyvsp[(2) - (4)].str),make_str("and"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1567:

/* Line 1455 of yacc.c  */
#line 9395 "preproc.y"
    { 
 (yyval.str) = make_str("unbounded preceding");
;}
    break;

  case 1568:

/* Line 1455 of yacc.c  */
#line 9399 "preproc.y"
    { 
 (yyval.str) = make_str("unbounded following");
;}
    break;

  case 1569:

/* Line 1455 of yacc.c  */
#line 9403 "preproc.y"
    { 
 (yyval.str) = make_str("current row");
;}
    break;

  case 1570:

/* Line 1455 of yacc.c  */
#line 9407 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("preceding"));
;}
    break;

  case 1571:

/* Line 1455 of yacc.c  */
#line 9411 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),make_str("following"));
;}
    break;

  case 1572:

/* Line 1455 of yacc.c  */
#line 9419 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("row ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1573:

/* Line 1455 of yacc.c  */
#line 9423 "preproc.y"
    { 
 (yyval.str) = make_str("row ( )");
;}
    break;

  case 1574:

/* Line 1455 of yacc.c  */
#line 9427 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("("),(yyvsp[(2) - (5)].str),make_str(","),(yyvsp[(4) - (5)].str),make_str(")"));
;}
    break;

  case 1575:

/* Line 1455 of yacc.c  */
#line 9435 "preproc.y"
    { 
 (yyval.str) = make_str("any");
;}
    break;

  case 1576:

/* Line 1455 of yacc.c  */
#line 9439 "preproc.y"
    { 
 (yyval.str) = make_str("some");
;}
    break;

  case 1577:

/* Line 1455 of yacc.c  */
#line 9443 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 1578:

/* Line 1455 of yacc.c  */
#line 9451 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1579:

/* Line 1455 of yacc.c  */
#line 9455 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1580:

/* Line 1455 of yacc.c  */
#line 9463 "preproc.y"
    { 
 (yyval.str) = make_str("+");
;}
    break;

  case 1581:

/* Line 1455 of yacc.c  */
#line 9467 "preproc.y"
    { 
 (yyval.str) = make_str("-");
;}
    break;

  case 1582:

/* Line 1455 of yacc.c  */
#line 9471 "preproc.y"
    { 
 (yyval.str) = make_str("*");
;}
    break;

  case 1583:

/* Line 1455 of yacc.c  */
#line 9475 "preproc.y"
    { 
 (yyval.str) = make_str("/");
;}
    break;

  case 1584:

/* Line 1455 of yacc.c  */
#line 9479 "preproc.y"
    { 
 (yyval.str) = make_str("%");
;}
    break;

  case 1585:

/* Line 1455 of yacc.c  */
#line 9483 "preproc.y"
    { 
 (yyval.str) = make_str("^");
;}
    break;

  case 1586:

/* Line 1455 of yacc.c  */
#line 9487 "preproc.y"
    { 
 (yyval.str) = make_str("<");
;}
    break;

  case 1587:

/* Line 1455 of yacc.c  */
#line 9491 "preproc.y"
    { 
 (yyval.str) = make_str(">");
;}
    break;

  case 1588:

/* Line 1455 of yacc.c  */
#line 9495 "preproc.y"
    { 
 (yyval.str) = make_str("=");
;}
    break;

  case 1589:

/* Line 1455 of yacc.c  */
#line 9503 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1590:

/* Line 1455 of yacc.c  */
#line 9507 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("operator ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1591:

/* Line 1455 of yacc.c  */
#line 9515 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1592:

/* Line 1455 of yacc.c  */
#line 9519 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("operator ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1593:

/* Line 1455 of yacc.c  */
#line 9527 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1594:

/* Line 1455 of yacc.c  */
#line 9531 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("operator ("),(yyvsp[(3) - (4)].str),make_str(")"));
;}
    break;

  case 1595:

/* Line 1455 of yacc.c  */
#line 9535 "preproc.y"
    { 
 (yyval.str) = make_str("like");
;}
    break;

  case 1596:

/* Line 1455 of yacc.c  */
#line 9539 "preproc.y"
    { 
 (yyval.str) = make_str("not like");
;}
    break;

  case 1597:

/* Line 1455 of yacc.c  */
#line 9543 "preproc.y"
    { 
 (yyval.str) = make_str("ilike");
;}
    break;

  case 1598:

/* Line 1455 of yacc.c  */
#line 9547 "preproc.y"
    { 
 (yyval.str) = make_str("not ilike");
;}
    break;

  case 1599:

/* Line 1455 of yacc.c  */
#line 9555 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1600:

/* Line 1455 of yacc.c  */
#line 9559 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1601:

/* Line 1455 of yacc.c  */
#line 9567 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1602:

/* Line 1455 of yacc.c  */
#line 9571 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1603:

/* Line 1455 of yacc.c  */
#line 9579 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1604:

/* Line 1455 of yacc.c  */
#line 9583 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(":="),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1605:

/* Line 1455 of yacc.c  */
#line 9591 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1606:

/* Line 1455 of yacc.c  */
#line 9595 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1607:

/* Line 1455 of yacc.c  */
#line 9603 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("["),(yyvsp[(2) - (3)].str),make_str("]"));
;}
    break;

  case 1608:

/* Line 1455 of yacc.c  */
#line 9607 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("["),(yyvsp[(2) - (3)].str),make_str("]"));
;}
    break;

  case 1609:

/* Line 1455 of yacc.c  */
#line 9611 "preproc.y"
    { 
 (yyval.str) = make_str("[ ]");
;}
    break;

  case 1610:

/* Line 1455 of yacc.c  */
#line 9619 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1611:

/* Line 1455 of yacc.c  */
#line 9623 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1612:

/* Line 1455 of yacc.c  */
#line 9631 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("from"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1613:

/* Line 1455 of yacc.c  */
#line 9635 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1614:

/* Line 1455 of yacc.c  */
#line 9642 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1615:

/* Line 1455 of yacc.c  */
#line 9646 "preproc.y"
    { 
 (yyval.str) = make_str("year");
;}
    break;

  case 1616:

/* Line 1455 of yacc.c  */
#line 9650 "preproc.y"
    { 
 (yyval.str) = make_str("month");
;}
    break;

  case 1617:

/* Line 1455 of yacc.c  */
#line 9654 "preproc.y"
    { 
 (yyval.str) = make_str("day");
;}
    break;

  case 1618:

/* Line 1455 of yacc.c  */
#line 9658 "preproc.y"
    { 
 (yyval.str) = make_str("hour");
;}
    break;

  case 1619:

/* Line 1455 of yacc.c  */
#line 9662 "preproc.y"
    { 
 (yyval.str) = make_str("minute");
;}
    break;

  case 1620:

/* Line 1455 of yacc.c  */
#line 9666 "preproc.y"
    { 
 (yyval.str) = make_str("second");
;}
    break;

  case 1621:

/* Line 1455 of yacc.c  */
#line 9670 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1622:

/* Line 1455 of yacc.c  */
#line 9678 "preproc.y"
    { 
 (yyval.str) = cat_str(4,(yyvsp[(1) - (4)].str),(yyvsp[(2) - (4)].str),(yyvsp[(3) - (4)].str),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1623:

/* Line 1455 of yacc.c  */
#line 9682 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1624:

/* Line 1455 of yacc.c  */
#line 9690 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("placing"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1625:

/* Line 1455 of yacc.c  */
#line 9698 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("in"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1626:

/* Line 1455 of yacc.c  */
#line 9702 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1627:

/* Line 1455 of yacc.c  */
#line 9709 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1628:

/* Line 1455 of yacc.c  */
#line 9713 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1629:

/* Line 1455 of yacc.c  */
#line 9717 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1630:

/* Line 1455 of yacc.c  */
#line 9721 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1631:

/* Line 1455 of yacc.c  */
#line 9725 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1632:

/* Line 1455 of yacc.c  */
#line 9729 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1633:

/* Line 1455 of yacc.c  */
#line 9736 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1634:

/* Line 1455 of yacc.c  */
#line 9744 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("for"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1635:

/* Line 1455 of yacc.c  */
#line 9752 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("from"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1636:

/* Line 1455 of yacc.c  */
#line 9756 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("from"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1637:

/* Line 1455 of yacc.c  */
#line 9760 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1638:

/* Line 1455 of yacc.c  */
#line 9768 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1639:

/* Line 1455 of yacc.c  */
#line 9772 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1640:

/* Line 1455 of yacc.c  */
#line 9780 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("case"),(yyvsp[(2) - (5)].str),(yyvsp[(3) - (5)].str),(yyvsp[(4) - (5)].str),make_str("end"));
;}
    break;

  case 1641:

/* Line 1455 of yacc.c  */
#line 9788 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1642:

/* Line 1455 of yacc.c  */
#line 9792 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1643:

/* Line 1455 of yacc.c  */
#line 9800 "preproc.y"
    { 
 (yyval.str) = cat_str(4,make_str("when"),(yyvsp[(2) - (4)].str),make_str("then"),(yyvsp[(4) - (4)].str));
;}
    break;

  case 1644:

/* Line 1455 of yacc.c  */
#line 9808 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("else"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1645:

/* Line 1455 of yacc.c  */
#line 9812 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1646:

/* Line 1455 of yacc.c  */
#line 9819 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1647:

/* Line 1455 of yacc.c  */
#line 9823 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1648:

/* Line 1455 of yacc.c  */
#line 9830 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1649:

/* Line 1455 of yacc.c  */
#line 9834 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1650:

/* Line 1455 of yacc.c  */
#line 9842 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("."),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1651:

/* Line 1455 of yacc.c  */
#line 9846 "preproc.y"
    { 
 (yyval.str) = make_str(". *");
;}
    break;

  case 1652:

/* Line 1455 of yacc.c  */
#line 9850 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("["),(yyvsp[(2) - (3)].str),make_str("]"));
;}
    break;

  case 1653:

/* Line 1455 of yacc.c  */
#line 9854 "preproc.y"
    { 
 (yyval.str) = cat_str(5,make_str("["),(yyvsp[(2) - (5)].str),make_str(":"),(yyvsp[(4) - (5)].str),make_str("]"));
;}
    break;

  case 1654:

/* Line 1455 of yacc.c  */
#line 9862 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1655:

/* Line 1455 of yacc.c  */
#line 9866 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1656:

/* Line 1455 of yacc.c  */
#line 9874 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1657:

/* Line 1455 of yacc.c  */
#line 9877 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1658:

/* Line 1455 of yacc.c  */
#line 9885 "preproc.y"
    { 
 (yyval.str) = make_str("asymmetric");
;}
    break;

  case 1659:

/* Line 1455 of yacc.c  */
#line 9889 "preproc.y"
    { 
 (yyval.str)=EMPTY; ;}
    break;

  case 1660:

/* Line 1455 of yacc.c  */
#line 9896 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1661:

/* Line 1455 of yacc.c  */
#line 9900 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 1662:

/* Line 1455 of yacc.c  */
#line 9908 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1663:

/* Line 1455 of yacc.c  */
#line 9912 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1664:

/* Line 1455 of yacc.c  */
#line 9920 "preproc.y"
    { 
 (yyval.str) = cat_str(3,make_str("("),(yyvsp[(2) - (3)].str),make_str(")"));
;}
    break;

  case 1665:

/* Line 1455 of yacc.c  */
#line 9928 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1666:

/* Line 1455 of yacc.c  */
#line 9932 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1667:

/* Line 1455 of yacc.c  */
#line 9940 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str("as"),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1668:

/* Line 1455 of yacc.c  */
#line 9944 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1669:

/* Line 1455 of yacc.c  */
#line 9948 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1670:

/* Line 1455 of yacc.c  */
#line 9952 "preproc.y"
    { 
 (yyval.str) = make_str("*");
;}
    break;

  case 1671:

/* Line 1455 of yacc.c  */
#line 9960 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1672:

/* Line 1455 of yacc.c  */
#line 9964 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1673:

/* Line 1455 of yacc.c  */
#line 9972 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1674:

/* Line 1455 of yacc.c  */
#line 9976 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1675:

/* Line 1455 of yacc.c  */
#line 9984 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1676:

/* Line 1455 of yacc.c  */
#line 9988 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),make_str(","),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1677:

/* Line 1455 of yacc.c  */
#line 9996 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1678:

/* Line 1455 of yacc.c  */
#line 10004 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1679:

/* Line 1455 of yacc.c  */
#line 10012 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1680:

/* Line 1455 of yacc.c  */
#line 10020 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1681:

/* Line 1455 of yacc.c  */
#line 10028 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1682:

/* Line 1455 of yacc.c  */
#line 10036 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1683:

/* Line 1455 of yacc.c  */
#line 10044 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1684:

/* Line 1455 of yacc.c  */
#line 10048 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1685:

/* Line 1455 of yacc.c  */
#line 10056 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1686:

/* Line 1455 of yacc.c  */
#line 10060 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1687:

/* Line 1455 of yacc.c  */
#line 10064 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1688:

/* Line 1455 of yacc.c  */
#line 10068 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1689:

/* Line 1455 of yacc.c  */
#line 10072 "preproc.y"
    { 
 (yyval.str) = make_str("xconst");
;}
    break;

  case 1690:

/* Line 1455 of yacc.c  */
#line 10076 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1691:

/* Line 1455 of yacc.c  */
#line 10080 "preproc.y"
    { 
 (yyval.str) = cat_str(5,(yyvsp[(1) - (5)].str),make_str("("),(yyvsp[(3) - (5)].str),make_str(")"),(yyvsp[(5) - (5)].str));
;}
    break;

  case 1692:

/* Line 1455 of yacc.c  */
#line 10084 "preproc.y"
    { 
 (yyval.str) = cat_str(2,(yyvsp[(1) - (2)].str),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1693:

/* Line 1455 of yacc.c  */
#line 10088 "preproc.y"
    { 
 (yyval.str) = cat_str(3,(yyvsp[(1) - (3)].str),(yyvsp[(2) - (3)].str),(yyvsp[(3) - (3)].str));
;}
    break;

  case 1694:

/* Line 1455 of yacc.c  */
#line 10092 "preproc.y"
    { 
 (yyval.str) = cat_str(6,(yyvsp[(1) - (6)].str),make_str("("),(yyvsp[(3) - (6)].str),make_str(")"),(yyvsp[(5) - (6)].str),(yyvsp[(6) - (6)].str));
;}
    break;

  case 1695:

/* Line 1455 of yacc.c  */
#line 10096 "preproc.y"
    { 
 (yyval.str) = make_str("true");
;}
    break;

  case 1696:

/* Line 1455 of yacc.c  */
#line 10100 "preproc.y"
    { 
 (yyval.str) = make_str("false");
;}
    break;

  case 1697:

/* Line 1455 of yacc.c  */
#line 10104 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 1698:

/* Line 1455 of yacc.c  */
#line 10107 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1699:

/* Line 1455 of yacc.c  */
#line 10108 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1700:

/* Line 1455 of yacc.c  */
#line 10114 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 1701:

/* Line 1455 of yacc.c  */
#line 10120 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1702:

/* Line 1455 of yacc.c  */
#line 10128 "preproc.y"
    { 
 (yyval.str) = (yyvsp[(1) - (1)].str);
;}
    break;

  case 1703:

/* Line 1455 of yacc.c  */
#line 10131 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1704:

/* Line 1455 of yacc.c  */
#line 10133 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("+"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1705:

/* Line 1455 of yacc.c  */
#line 10137 "preproc.y"
    { 
 (yyval.str) = cat_str(2,make_str("-"),(yyvsp[(2) - (2)].str));
;}
    break;

  case 1706:

/* Line 1455 of yacc.c  */
#line 10145 "preproc.y"
    { 
 (yyval.str) = make_str("abort");
;}
    break;

  case 1707:

/* Line 1455 of yacc.c  */
#line 10149 "preproc.y"
    { 
 (yyval.str) = make_str("absolute");
;}
    break;

  case 1708:

/* Line 1455 of yacc.c  */
#line 10153 "preproc.y"
    { 
 (yyval.str) = make_str("access");
;}
    break;

  case 1709:

/* Line 1455 of yacc.c  */
#line 10157 "preproc.y"
    { 
 (yyval.str) = make_str("action");
;}
    break;

  case 1710:

/* Line 1455 of yacc.c  */
#line 10161 "preproc.y"
    { 
 (yyval.str) = make_str("add");
;}
    break;

  case 1711:

/* Line 1455 of yacc.c  */
#line 10165 "preproc.y"
    { 
 (yyval.str) = make_str("admin");
;}
    break;

  case 1712:

/* Line 1455 of yacc.c  */
#line 10169 "preproc.y"
    { 
 (yyval.str) = make_str("after");
;}
    break;

  case 1713:

/* Line 1455 of yacc.c  */
#line 10173 "preproc.y"
    { 
 (yyval.str) = make_str("aggregate");
;}
    break;

  case 1714:

/* Line 1455 of yacc.c  */
#line 10177 "preproc.y"
    { 
 (yyval.str) = make_str("also");
;}
    break;

  case 1715:

/* Line 1455 of yacc.c  */
#line 10181 "preproc.y"
    { 
 (yyval.str) = make_str("alter");
;}
    break;

  case 1716:

/* Line 1455 of yacc.c  */
#line 10185 "preproc.y"
    { 
 (yyval.str) = make_str("always");
;}
    break;

  case 1717:

/* Line 1455 of yacc.c  */
#line 10189 "preproc.y"
    { 
 (yyval.str) = make_str("assertion");
;}
    break;

  case 1718:

/* Line 1455 of yacc.c  */
#line 10193 "preproc.y"
    { 
 (yyval.str) = make_str("assignment");
;}
    break;

  case 1719:

/* Line 1455 of yacc.c  */
#line 10197 "preproc.y"
    { 
 (yyval.str) = make_str("at");
;}
    break;

  case 1720:

/* Line 1455 of yacc.c  */
#line 10201 "preproc.y"
    { 
 (yyval.str) = make_str("backward");
;}
    break;

  case 1721:

/* Line 1455 of yacc.c  */
#line 10205 "preproc.y"
    { 
 (yyval.str) = make_str("before");
;}
    break;

  case 1722:

/* Line 1455 of yacc.c  */
#line 10209 "preproc.y"
    { 
 (yyval.str) = make_str("begin");
;}
    break;

  case 1723:

/* Line 1455 of yacc.c  */
#line 10213 "preproc.y"
    { 
 (yyval.str) = make_str("by");
;}
    break;

  case 1724:

/* Line 1455 of yacc.c  */
#line 10217 "preproc.y"
    { 
 (yyval.str) = make_str("cache");
;}
    break;

  case 1725:

/* Line 1455 of yacc.c  */
#line 10221 "preproc.y"
    { 
 (yyval.str) = make_str("called");
;}
    break;

  case 1726:

/* Line 1455 of yacc.c  */
#line 10225 "preproc.y"
    { 
 (yyval.str) = make_str("cascade");
;}
    break;

  case 1727:

/* Line 1455 of yacc.c  */
#line 10229 "preproc.y"
    { 
 (yyval.str) = make_str("cascaded");
;}
    break;

  case 1728:

/* Line 1455 of yacc.c  */
#line 10233 "preproc.y"
    { 
 (yyval.str) = make_str("catalog");
;}
    break;

  case 1729:

/* Line 1455 of yacc.c  */
#line 10237 "preproc.y"
    { 
 (yyval.str) = make_str("chain");
;}
    break;

  case 1730:

/* Line 1455 of yacc.c  */
#line 10241 "preproc.y"
    { 
 (yyval.str) = make_str("characteristics");
;}
    break;

  case 1731:

/* Line 1455 of yacc.c  */
#line 10245 "preproc.y"
    { 
 (yyval.str) = make_str("checkpoint");
;}
    break;

  case 1732:

/* Line 1455 of yacc.c  */
#line 10249 "preproc.y"
    { 
 (yyval.str) = make_str("class");
;}
    break;

  case 1733:

/* Line 1455 of yacc.c  */
#line 10253 "preproc.y"
    { 
 (yyval.str) = make_str("close");
;}
    break;

  case 1734:

/* Line 1455 of yacc.c  */
#line 10257 "preproc.y"
    { 
 (yyval.str) = make_str("cluster");
;}
    break;

  case 1735:

/* Line 1455 of yacc.c  */
#line 10261 "preproc.y"
    { 
 (yyval.str) = make_str("comment");
;}
    break;

  case 1736:

/* Line 1455 of yacc.c  */
#line 10265 "preproc.y"
    { 
 (yyval.str) = make_str("comments");
;}
    break;

  case 1737:

/* Line 1455 of yacc.c  */
#line 10269 "preproc.y"
    { 
 (yyval.str) = make_str("commit");
;}
    break;

  case 1738:

/* Line 1455 of yacc.c  */
#line 10273 "preproc.y"
    { 
 (yyval.str) = make_str("committed");
;}
    break;

  case 1739:

/* Line 1455 of yacc.c  */
#line 10277 "preproc.y"
    { 
 (yyval.str) = make_str("configuration");
;}
    break;

  case 1740:

/* Line 1455 of yacc.c  */
#line 10281 "preproc.y"
    { 
 (yyval.str) = make_str("constraints");
;}
    break;

  case 1741:

/* Line 1455 of yacc.c  */
#line 10285 "preproc.y"
    { 
 (yyval.str) = make_str("content");
;}
    break;

  case 1742:

/* Line 1455 of yacc.c  */
#line 10289 "preproc.y"
    { 
 (yyval.str) = make_str("continue");
;}
    break;

  case 1743:

/* Line 1455 of yacc.c  */
#line 10293 "preproc.y"
    { 
 (yyval.str) = make_str("conversion");
;}
    break;

  case 1744:

/* Line 1455 of yacc.c  */
#line 10297 "preproc.y"
    { 
 (yyval.str) = make_str("copy");
;}
    break;

  case 1745:

/* Line 1455 of yacc.c  */
#line 10301 "preproc.y"
    { 
 (yyval.str) = make_str("cost");
;}
    break;

  case 1746:

/* Line 1455 of yacc.c  */
#line 10305 "preproc.y"
    { 
 (yyval.str) = make_str("createdb");
;}
    break;

  case 1747:

/* Line 1455 of yacc.c  */
#line 10309 "preproc.y"
    { 
 (yyval.str) = make_str("createrole");
;}
    break;

  case 1748:

/* Line 1455 of yacc.c  */
#line 10313 "preproc.y"
    { 
 (yyval.str) = make_str("createuser");
;}
    break;

  case 1749:

/* Line 1455 of yacc.c  */
#line 10317 "preproc.y"
    { 
 (yyval.str) = make_str("csv");
;}
    break;

  case 1750:

/* Line 1455 of yacc.c  */
#line 10321 "preproc.y"
    { 
 (yyval.str) = make_str("cursor");
;}
    break;

  case 1751:

/* Line 1455 of yacc.c  */
#line 10325 "preproc.y"
    { 
 (yyval.str) = make_str("cycle");
;}
    break;

  case 1752:

/* Line 1455 of yacc.c  */
#line 10329 "preproc.y"
    { 
 (yyval.str) = make_str("data");
;}
    break;

  case 1753:

/* Line 1455 of yacc.c  */
#line 10333 "preproc.y"
    { 
 (yyval.str) = make_str("database");
;}
    break;

  case 1754:

/* Line 1455 of yacc.c  */
#line 10337 "preproc.y"
    { 
 (yyval.str) = make_str("deallocate");
;}
    break;

  case 1755:

/* Line 1455 of yacc.c  */
#line 10341 "preproc.y"
    { 
 (yyval.str) = make_str("declare");
;}
    break;

  case 1756:

/* Line 1455 of yacc.c  */
#line 10345 "preproc.y"
    { 
 (yyval.str) = make_str("defaults");
;}
    break;

  case 1757:

/* Line 1455 of yacc.c  */
#line 10349 "preproc.y"
    { 
 (yyval.str) = make_str("deferred");
;}
    break;

  case 1758:

/* Line 1455 of yacc.c  */
#line 10353 "preproc.y"
    { 
 (yyval.str) = make_str("definer");
;}
    break;

  case 1759:

/* Line 1455 of yacc.c  */
#line 10357 "preproc.y"
    { 
 (yyval.str) = make_str("delete");
;}
    break;

  case 1760:

/* Line 1455 of yacc.c  */
#line 10361 "preproc.y"
    { 
 (yyval.str) = make_str("delimiter");
;}
    break;

  case 1761:

/* Line 1455 of yacc.c  */
#line 10365 "preproc.y"
    { 
 (yyval.str) = make_str("delimiters");
;}
    break;

  case 1762:

/* Line 1455 of yacc.c  */
#line 10369 "preproc.y"
    { 
 (yyval.str) = make_str("dictionary");
;}
    break;

  case 1763:

/* Line 1455 of yacc.c  */
#line 10373 "preproc.y"
    { 
 (yyval.str) = make_str("disable");
;}
    break;

  case 1764:

/* Line 1455 of yacc.c  */
#line 10377 "preproc.y"
    { 
 (yyval.str) = make_str("discard");
;}
    break;

  case 1765:

/* Line 1455 of yacc.c  */
#line 10381 "preproc.y"
    { 
 (yyval.str) = make_str("document");
;}
    break;

  case 1766:

/* Line 1455 of yacc.c  */
#line 10385 "preproc.y"
    { 
 (yyval.str) = make_str("domain");
;}
    break;

  case 1767:

/* Line 1455 of yacc.c  */
#line 10389 "preproc.y"
    { 
 (yyval.str) = make_str("double");
;}
    break;

  case 1768:

/* Line 1455 of yacc.c  */
#line 10393 "preproc.y"
    { 
 (yyval.str) = make_str("drop");
;}
    break;

  case 1769:

/* Line 1455 of yacc.c  */
#line 10397 "preproc.y"
    { 
 (yyval.str) = make_str("each");
;}
    break;

  case 1770:

/* Line 1455 of yacc.c  */
#line 10401 "preproc.y"
    { 
 (yyval.str) = make_str("enable");
;}
    break;

  case 1771:

/* Line 1455 of yacc.c  */
#line 10405 "preproc.y"
    { 
 (yyval.str) = make_str("encoding");
;}
    break;

  case 1772:

/* Line 1455 of yacc.c  */
#line 10409 "preproc.y"
    { 
 (yyval.str) = make_str("encrypted");
;}
    break;

  case 1773:

/* Line 1455 of yacc.c  */
#line 10413 "preproc.y"
    { 
 (yyval.str) = make_str("enum");
;}
    break;

  case 1774:

/* Line 1455 of yacc.c  */
#line 10417 "preproc.y"
    { 
 (yyval.str) = make_str("escape");
;}
    break;

  case 1775:

/* Line 1455 of yacc.c  */
#line 10421 "preproc.y"
    { 
 (yyval.str) = make_str("exclude");
;}
    break;

  case 1776:

/* Line 1455 of yacc.c  */
#line 10425 "preproc.y"
    { 
 (yyval.str) = make_str("excluding");
;}
    break;

  case 1777:

/* Line 1455 of yacc.c  */
#line 10429 "preproc.y"
    { 
 (yyval.str) = make_str("exclusive");
;}
    break;

  case 1778:

/* Line 1455 of yacc.c  */
#line 10433 "preproc.y"
    { 
 (yyval.str) = make_str("execute");
;}
    break;

  case 1779:

/* Line 1455 of yacc.c  */
#line 10437 "preproc.y"
    { 
 (yyval.str) = make_str("explain");
;}
    break;

  case 1780:

/* Line 1455 of yacc.c  */
#line 10441 "preproc.y"
    { 
 (yyval.str) = make_str("external");
;}
    break;

  case 1781:

/* Line 1455 of yacc.c  */
#line 10445 "preproc.y"
    { 
 (yyval.str) = make_str("family");
;}
    break;

  case 1782:

/* Line 1455 of yacc.c  */
#line 10449 "preproc.y"
    { 
 (yyval.str) = make_str("first");
;}
    break;

  case 1783:

/* Line 1455 of yacc.c  */
#line 10453 "preproc.y"
    { 
 (yyval.str) = make_str("following");
;}
    break;

  case 1784:

/* Line 1455 of yacc.c  */
#line 10457 "preproc.y"
    { 
 (yyval.str) = make_str("force");
;}
    break;

  case 1785:

/* Line 1455 of yacc.c  */
#line 10461 "preproc.y"
    { 
 (yyval.str) = make_str("forward");
;}
    break;

  case 1786:

/* Line 1455 of yacc.c  */
#line 10465 "preproc.y"
    { 
 (yyval.str) = make_str("function");
;}
    break;

  case 1787:

/* Line 1455 of yacc.c  */
#line 10469 "preproc.y"
    { 
 (yyval.str) = make_str("functions");
;}
    break;

  case 1788:

/* Line 1455 of yacc.c  */
#line 10473 "preproc.y"
    { 
 (yyval.str) = make_str("global");
;}
    break;

  case 1789:

/* Line 1455 of yacc.c  */
#line 10477 "preproc.y"
    { 
 (yyval.str) = make_str("granted");
;}
    break;

  case 1790:

/* Line 1455 of yacc.c  */
#line 10481 "preproc.y"
    { 
 (yyval.str) = make_str("handler");
;}
    break;

  case 1791:

/* Line 1455 of yacc.c  */
#line 10485 "preproc.y"
    { 
 (yyval.str) = make_str("header");
;}
    break;

  case 1792:

/* Line 1455 of yacc.c  */
#line 10489 "preproc.y"
    { 
 (yyval.str) = make_str("hold");
;}
    break;

  case 1793:

/* Line 1455 of yacc.c  */
#line 10493 "preproc.y"
    { 
 (yyval.str) = make_str("identity");
;}
    break;

  case 1794:

/* Line 1455 of yacc.c  */
#line 10497 "preproc.y"
    { 
 (yyval.str) = make_str("if");
;}
    break;

  case 1795:

/* Line 1455 of yacc.c  */
#line 10501 "preproc.y"
    { 
 (yyval.str) = make_str("immediate");
;}
    break;

  case 1796:

/* Line 1455 of yacc.c  */
#line 10505 "preproc.y"
    { 
 (yyval.str) = make_str("immutable");
;}
    break;

  case 1797:

/* Line 1455 of yacc.c  */
#line 10509 "preproc.y"
    { 
 (yyval.str) = make_str("implicit");
;}
    break;

  case 1798:

/* Line 1455 of yacc.c  */
#line 10513 "preproc.y"
    { 
 (yyval.str) = make_str("including");
;}
    break;

  case 1799:

/* Line 1455 of yacc.c  */
#line 10517 "preproc.y"
    { 
 (yyval.str) = make_str("increment");
;}
    break;

  case 1800:

/* Line 1455 of yacc.c  */
#line 10521 "preproc.y"
    { 
 (yyval.str) = make_str("index");
;}
    break;

  case 1801:

/* Line 1455 of yacc.c  */
#line 10525 "preproc.y"
    { 
 (yyval.str) = make_str("indexes");
;}
    break;

  case 1802:

/* Line 1455 of yacc.c  */
#line 10529 "preproc.y"
    { 
 (yyval.str) = make_str("inherit");
;}
    break;

  case 1803:

/* Line 1455 of yacc.c  */
#line 10533 "preproc.y"
    { 
 (yyval.str) = make_str("inherits");
;}
    break;

  case 1804:

/* Line 1455 of yacc.c  */
#line 10537 "preproc.y"
    { 
 (yyval.str) = make_str("inline");
;}
    break;

  case 1805:

/* Line 1455 of yacc.c  */
#line 10541 "preproc.y"
    { 
 (yyval.str) = make_str("insensitive");
;}
    break;

  case 1806:

/* Line 1455 of yacc.c  */
#line 10545 "preproc.y"
    { 
 (yyval.str) = make_str("insert");
;}
    break;

  case 1807:

/* Line 1455 of yacc.c  */
#line 10549 "preproc.y"
    { 
 (yyval.str) = make_str("instead");
;}
    break;

  case 1808:

/* Line 1455 of yacc.c  */
#line 10553 "preproc.y"
    { 
 (yyval.str) = make_str("invoker");
;}
    break;

  case 1809:

/* Line 1455 of yacc.c  */
#line 10557 "preproc.y"
    { 
 (yyval.str) = make_str("isolation");
;}
    break;

  case 1810:

/* Line 1455 of yacc.c  */
#line 10561 "preproc.y"
    { 
 (yyval.str) = make_str("key");
;}
    break;

  case 1811:

/* Line 1455 of yacc.c  */
#line 10565 "preproc.y"
    { 
 (yyval.str) = make_str("language");
;}
    break;

  case 1812:

/* Line 1455 of yacc.c  */
#line 10569 "preproc.y"
    { 
 (yyval.str) = make_str("large");
;}
    break;

  case 1813:

/* Line 1455 of yacc.c  */
#line 10573 "preproc.y"
    { 
 (yyval.str) = make_str("last");
;}
    break;

  case 1814:

/* Line 1455 of yacc.c  */
#line 10577 "preproc.y"
    { 
 (yyval.str) = make_str("lc_collate");
;}
    break;

  case 1815:

/* Line 1455 of yacc.c  */
#line 10581 "preproc.y"
    { 
 (yyval.str) = make_str("lc_ctype");
;}
    break;

  case 1816:

/* Line 1455 of yacc.c  */
#line 10585 "preproc.y"
    { 
 (yyval.str) = make_str("level");
;}
    break;

  case 1817:

/* Line 1455 of yacc.c  */
#line 10589 "preproc.y"
    { 
 (yyval.str) = make_str("listen");
;}
    break;

  case 1818:

/* Line 1455 of yacc.c  */
#line 10593 "preproc.y"
    { 
 (yyval.str) = make_str("load");
;}
    break;

  case 1819:

/* Line 1455 of yacc.c  */
#line 10597 "preproc.y"
    { 
 (yyval.str) = make_str("local");
;}
    break;

  case 1820:

/* Line 1455 of yacc.c  */
#line 10601 "preproc.y"
    { 
 (yyval.str) = make_str("location");
;}
    break;

  case 1821:

/* Line 1455 of yacc.c  */
#line 10605 "preproc.y"
    { 
 (yyval.str) = make_str("lock");
;}
    break;

  case 1822:

/* Line 1455 of yacc.c  */
#line 10609 "preproc.y"
    { 
 (yyval.str) = make_str("login");
;}
    break;

  case 1823:

/* Line 1455 of yacc.c  */
#line 10613 "preproc.y"
    { 
 (yyval.str) = make_str("mapping");
;}
    break;

  case 1824:

/* Line 1455 of yacc.c  */
#line 10617 "preproc.y"
    { 
 (yyval.str) = make_str("match");
;}
    break;

  case 1825:

/* Line 1455 of yacc.c  */
#line 10621 "preproc.y"
    { 
 (yyval.str) = make_str("maxvalue");
;}
    break;

  case 1826:

/* Line 1455 of yacc.c  */
#line 10625 "preproc.y"
    { 
 (yyval.str) = make_str("minvalue");
;}
    break;

  case 1827:

/* Line 1455 of yacc.c  */
#line 10629 "preproc.y"
    { 
 (yyval.str) = make_str("mode");
;}
    break;

  case 1828:

/* Line 1455 of yacc.c  */
#line 10633 "preproc.y"
    { 
 (yyval.str) = make_str("move");
;}
    break;

  case 1829:

/* Line 1455 of yacc.c  */
#line 10637 "preproc.y"
    { 
 (yyval.str) = make_str("name");
;}
    break;

  case 1830:

/* Line 1455 of yacc.c  */
#line 10641 "preproc.y"
    { 
 (yyval.str) = make_str("names");
;}
    break;

  case 1831:

/* Line 1455 of yacc.c  */
#line 10645 "preproc.y"
    { 
 (yyval.str) = make_str("next");
;}
    break;

  case 1832:

/* Line 1455 of yacc.c  */
#line 10649 "preproc.y"
    { 
 (yyval.str) = make_str("no");
;}
    break;

  case 1833:

/* Line 1455 of yacc.c  */
#line 10653 "preproc.y"
    { 
 (yyval.str) = make_str("nocreatedb");
;}
    break;

  case 1834:

/* Line 1455 of yacc.c  */
#line 10657 "preproc.y"
    { 
 (yyval.str) = make_str("nocreaterole");
;}
    break;

  case 1835:

/* Line 1455 of yacc.c  */
#line 10661 "preproc.y"
    { 
 (yyval.str) = make_str("nocreateuser");
;}
    break;

  case 1836:

/* Line 1455 of yacc.c  */
#line 10665 "preproc.y"
    { 
 (yyval.str) = make_str("noinherit");
;}
    break;

  case 1837:

/* Line 1455 of yacc.c  */
#line 10669 "preproc.y"
    { 
 (yyval.str) = make_str("nologin");
;}
    break;

  case 1838:

/* Line 1455 of yacc.c  */
#line 10673 "preproc.y"
    { 
 (yyval.str) = make_str("nosuperuser");
;}
    break;

  case 1839:

/* Line 1455 of yacc.c  */
#line 10677 "preproc.y"
    { 
 (yyval.str) = make_str("nothing");
;}
    break;

  case 1840:

/* Line 1455 of yacc.c  */
#line 10681 "preproc.y"
    { 
 (yyval.str) = make_str("notify");
;}
    break;

  case 1841:

/* Line 1455 of yacc.c  */
#line 10685 "preproc.y"
    { 
 (yyval.str) = make_str("nowait");
;}
    break;

  case 1842:

/* Line 1455 of yacc.c  */
#line 10689 "preproc.y"
    { 
 (yyval.str) = make_str("nulls");
;}
    break;

  case 1843:

/* Line 1455 of yacc.c  */
#line 10693 "preproc.y"
    { 
 (yyval.str) = make_str("object");
;}
    break;

  case 1844:

/* Line 1455 of yacc.c  */
#line 10697 "preproc.y"
    { 
 (yyval.str) = make_str("of");
;}
    break;

  case 1845:

/* Line 1455 of yacc.c  */
#line 10701 "preproc.y"
    { 
 (yyval.str) = make_str("off");
;}
    break;

  case 1846:

/* Line 1455 of yacc.c  */
#line 10705 "preproc.y"
    { 
 (yyval.str) = make_str("oids");
;}
    break;

  case 1847:

/* Line 1455 of yacc.c  */
#line 10709 "preproc.y"
    { 
 (yyval.str) = make_str("operator");
;}
    break;

  case 1848:

/* Line 1455 of yacc.c  */
#line 10713 "preproc.y"
    { 
 (yyval.str) = make_str("option");
;}
    break;

  case 1849:

/* Line 1455 of yacc.c  */
#line 10717 "preproc.y"
    { 
 (yyval.str) = make_str("options");
;}
    break;

  case 1850:

/* Line 1455 of yacc.c  */
#line 10721 "preproc.y"
    { 
 (yyval.str) = make_str("owned");
;}
    break;

  case 1851:

/* Line 1455 of yacc.c  */
#line 10725 "preproc.y"
    { 
 (yyval.str) = make_str("owner");
;}
    break;

  case 1852:

/* Line 1455 of yacc.c  */
#line 10729 "preproc.y"
    { 
 (yyval.str) = make_str("parser");
;}
    break;

  case 1853:

/* Line 1455 of yacc.c  */
#line 10733 "preproc.y"
    { 
 (yyval.str) = make_str("partial");
;}
    break;

  case 1854:

/* Line 1455 of yacc.c  */
#line 10737 "preproc.y"
    { 
 (yyval.str) = make_str("partition");
;}
    break;

  case 1855:

/* Line 1455 of yacc.c  */
#line 10741 "preproc.y"
    { 
 (yyval.str) = make_str("password");
;}
    break;

  case 1856:

/* Line 1455 of yacc.c  */
#line 10745 "preproc.y"
    { 
 (yyval.str) = make_str("plans");
;}
    break;

  case 1857:

/* Line 1455 of yacc.c  */
#line 10749 "preproc.y"
    { 
 (yyval.str) = make_str("preceding");
;}
    break;

  case 1858:

/* Line 1455 of yacc.c  */
#line 10753 "preproc.y"
    { 
 (yyval.str) = make_str("prepare");
;}
    break;

  case 1859:

/* Line 1455 of yacc.c  */
#line 10757 "preproc.y"
    { 
 (yyval.str) = make_str("prepared");
;}
    break;

  case 1860:

/* Line 1455 of yacc.c  */
#line 10761 "preproc.y"
    { 
 (yyval.str) = make_str("preserve");
;}
    break;

  case 1861:

/* Line 1455 of yacc.c  */
#line 10765 "preproc.y"
    { 
 (yyval.str) = make_str("prior");
;}
    break;

  case 1862:

/* Line 1455 of yacc.c  */
#line 10769 "preproc.y"
    { 
 (yyval.str) = make_str("privileges");
;}
    break;

  case 1863:

/* Line 1455 of yacc.c  */
#line 10773 "preproc.y"
    { 
 (yyval.str) = make_str("procedural");
;}
    break;

  case 1864:

/* Line 1455 of yacc.c  */
#line 10777 "preproc.y"
    { 
 (yyval.str) = make_str("procedure");
;}
    break;

  case 1865:

/* Line 1455 of yacc.c  */
#line 10781 "preproc.y"
    { 
 (yyval.str) = make_str("quote");
;}
    break;

  case 1866:

/* Line 1455 of yacc.c  */
#line 10785 "preproc.y"
    { 
 (yyval.str) = make_str("range");
;}
    break;

  case 1867:

/* Line 1455 of yacc.c  */
#line 10789 "preproc.y"
    { 
 (yyval.str) = make_str("read");
;}
    break;

  case 1868:

/* Line 1455 of yacc.c  */
#line 10793 "preproc.y"
    { 
 (yyval.str) = make_str("reassign");
;}
    break;

  case 1869:

/* Line 1455 of yacc.c  */
#line 10797 "preproc.y"
    { 
 (yyval.str) = make_str("recheck");
;}
    break;

  case 1870:

/* Line 1455 of yacc.c  */
#line 10801 "preproc.y"
    { 
 (yyval.str) = make_str("recursive");
;}
    break;

  case 1871:

/* Line 1455 of yacc.c  */
#line 10805 "preproc.y"
    { 
 (yyval.str) = make_str("reindex");
;}
    break;

  case 1872:

/* Line 1455 of yacc.c  */
#line 10809 "preproc.y"
    { 
 (yyval.str) = make_str("relative");
;}
    break;

  case 1873:

/* Line 1455 of yacc.c  */
#line 10813 "preproc.y"
    { 
 (yyval.str) = make_str("release");
;}
    break;

  case 1874:

/* Line 1455 of yacc.c  */
#line 10817 "preproc.y"
    { 
 (yyval.str) = make_str("rename");
;}
    break;

  case 1875:

/* Line 1455 of yacc.c  */
#line 10821 "preproc.y"
    { 
 (yyval.str) = make_str("repeatable");
;}
    break;

  case 1876:

/* Line 1455 of yacc.c  */
#line 10825 "preproc.y"
    { 
 (yyval.str) = make_str("replace");
;}
    break;

  case 1877:

/* Line 1455 of yacc.c  */
#line 10829 "preproc.y"
    { 
 (yyval.str) = make_str("replica");
;}
    break;

  case 1878:

/* Line 1455 of yacc.c  */
#line 10833 "preproc.y"
    { 
 (yyval.str) = make_str("reset");
;}
    break;

  case 1879:

/* Line 1455 of yacc.c  */
#line 10837 "preproc.y"
    { 
 (yyval.str) = make_str("restart");
;}
    break;

  case 1880:

/* Line 1455 of yacc.c  */
#line 10841 "preproc.y"
    { 
 (yyval.str) = make_str("restrict");
;}
    break;

  case 1881:

/* Line 1455 of yacc.c  */
#line 10845 "preproc.y"
    { 
 (yyval.str) = make_str("returns");
;}
    break;

  case 1882:

/* Line 1455 of yacc.c  */
#line 10849 "preproc.y"
    { 
 (yyval.str) = make_str("revoke");
;}
    break;

  case 1883:

/* Line 1455 of yacc.c  */
#line 10853 "preproc.y"
    { 
 (yyval.str) = make_str("role");
;}
    break;

  case 1884:

/* Line 1455 of yacc.c  */
#line 10857 "preproc.y"
    { 
 (yyval.str) = make_str("rollback");
;}
    break;

  case 1885:

/* Line 1455 of yacc.c  */
#line 10861 "preproc.y"
    { 
 (yyval.str) = make_str("rows");
;}
    break;

  case 1886:

/* Line 1455 of yacc.c  */
#line 10865 "preproc.y"
    { 
 (yyval.str) = make_str("rule");
;}
    break;

  case 1887:

/* Line 1455 of yacc.c  */
#line 10869 "preproc.y"
    { 
 (yyval.str) = make_str("savepoint");
;}
    break;

  case 1888:

/* Line 1455 of yacc.c  */
#line 10873 "preproc.y"
    { 
 (yyval.str) = make_str("schema");
;}
    break;

  case 1889:

/* Line 1455 of yacc.c  */
#line 10877 "preproc.y"
    { 
 (yyval.str) = make_str("scroll");
;}
    break;

  case 1890:

/* Line 1455 of yacc.c  */
#line 10881 "preproc.y"
    { 
 (yyval.str) = make_str("search");
;}
    break;

  case 1891:

/* Line 1455 of yacc.c  */
#line 10885 "preproc.y"
    { 
 (yyval.str) = make_str("security");
;}
    break;

  case 1892:

/* Line 1455 of yacc.c  */
#line 10889 "preproc.y"
    { 
 (yyval.str) = make_str("sequence");
;}
    break;

  case 1893:

/* Line 1455 of yacc.c  */
#line 10893 "preproc.y"
    { 
 (yyval.str) = make_str("sequences");
;}
    break;

  case 1894:

/* Line 1455 of yacc.c  */
#line 10897 "preproc.y"
    { 
 (yyval.str) = make_str("serializable");
;}
    break;

  case 1895:

/* Line 1455 of yacc.c  */
#line 10901 "preproc.y"
    { 
 (yyval.str) = make_str("server");
;}
    break;

  case 1896:

/* Line 1455 of yacc.c  */
#line 10905 "preproc.y"
    { 
 (yyval.str) = make_str("session");
;}
    break;

  case 1897:

/* Line 1455 of yacc.c  */
#line 10909 "preproc.y"
    { 
 (yyval.str) = make_str("set");
;}
    break;

  case 1898:

/* Line 1455 of yacc.c  */
#line 10913 "preproc.y"
    { 
 (yyval.str) = make_str("share");
;}
    break;

  case 1899:

/* Line 1455 of yacc.c  */
#line 10917 "preproc.y"
    { 
 (yyval.str) = make_str("show");
;}
    break;

  case 1900:

/* Line 1455 of yacc.c  */
#line 10921 "preproc.y"
    { 
 (yyval.str) = make_str("simple");
;}
    break;

  case 1901:

/* Line 1455 of yacc.c  */
#line 10925 "preproc.y"
    { 
 (yyval.str) = make_str("stable");
;}
    break;

  case 1902:

/* Line 1455 of yacc.c  */
#line 10929 "preproc.y"
    { 
 (yyval.str) = make_str("standalone");
;}
    break;

  case 1903:

/* Line 1455 of yacc.c  */
#line 10933 "preproc.y"
    { 
 (yyval.str) = make_str("start");
;}
    break;

  case 1904:

/* Line 1455 of yacc.c  */
#line 10937 "preproc.y"
    { 
 (yyval.str) = make_str("statement");
;}
    break;

  case 1905:

/* Line 1455 of yacc.c  */
#line 10941 "preproc.y"
    { 
 (yyval.str) = make_str("statistics");
;}
    break;

  case 1906:

/* Line 1455 of yacc.c  */
#line 10945 "preproc.y"
    { 
 (yyval.str) = make_str("stdin");
;}
    break;

  case 1907:

/* Line 1455 of yacc.c  */
#line 10949 "preproc.y"
    { 
 (yyval.str) = make_str("stdout");
;}
    break;

  case 1908:

/* Line 1455 of yacc.c  */
#line 10953 "preproc.y"
    { 
 (yyval.str) = make_str("storage");
;}
    break;

  case 1909:

/* Line 1455 of yacc.c  */
#line 10957 "preproc.y"
    { 
 (yyval.str) = make_str("strict");
;}
    break;

  case 1910:

/* Line 1455 of yacc.c  */
#line 10961 "preproc.y"
    { 
 (yyval.str) = make_str("strip");
;}
    break;

  case 1911:

/* Line 1455 of yacc.c  */
#line 10965 "preproc.y"
    { 
 (yyval.str) = make_str("superuser");
;}
    break;

  case 1912:

/* Line 1455 of yacc.c  */
#line 10969 "preproc.y"
    { 
 (yyval.str) = make_str("sysid");
;}
    break;

  case 1913:

/* Line 1455 of yacc.c  */
#line 10973 "preproc.y"
    { 
 (yyval.str) = make_str("system");
;}
    break;

  case 1914:

/* Line 1455 of yacc.c  */
#line 10977 "preproc.y"
    { 
 (yyval.str) = make_str("tables");
;}
    break;

  case 1915:

/* Line 1455 of yacc.c  */
#line 10981 "preproc.y"
    { 
 (yyval.str) = make_str("tablespace");
;}
    break;

  case 1916:

/* Line 1455 of yacc.c  */
#line 10985 "preproc.y"
    { 
 (yyval.str) = make_str("temp");
;}
    break;

  case 1917:

/* Line 1455 of yacc.c  */
#line 10989 "preproc.y"
    { 
 (yyval.str) = make_str("template");
;}
    break;

  case 1918:

/* Line 1455 of yacc.c  */
#line 10993 "preproc.y"
    { 
 (yyval.str) = make_str("temporary");
;}
    break;

  case 1919:

/* Line 1455 of yacc.c  */
#line 10997 "preproc.y"
    { 
 (yyval.str) = make_str("text");
;}
    break;

  case 1920:

/* Line 1455 of yacc.c  */
#line 11001 "preproc.y"
    { 
 (yyval.str) = make_str("transaction");
;}
    break;

  case 1921:

/* Line 1455 of yacc.c  */
#line 11005 "preproc.y"
    { 
 (yyval.str) = make_str("trigger");
;}
    break;

  case 1922:

/* Line 1455 of yacc.c  */
#line 11009 "preproc.y"
    { 
 (yyval.str) = make_str("truncate");
;}
    break;

  case 1923:

/* Line 1455 of yacc.c  */
#line 11013 "preproc.y"
    { 
 (yyval.str) = make_str("trusted");
;}
    break;

  case 1924:

/* Line 1455 of yacc.c  */
#line 11017 "preproc.y"
    { 
 (yyval.str) = make_str("type");
;}
    break;

  case 1925:

/* Line 1455 of yacc.c  */
#line 11021 "preproc.y"
    { 
 (yyval.str) = make_str("unbounded");
;}
    break;

  case 1926:

/* Line 1455 of yacc.c  */
#line 11025 "preproc.y"
    { 
 (yyval.str) = make_str("uncommitted");
;}
    break;

  case 1927:

/* Line 1455 of yacc.c  */
#line 11029 "preproc.y"
    { 
 (yyval.str) = make_str("unencrypted");
;}
    break;

  case 1928:

/* Line 1455 of yacc.c  */
#line 11033 "preproc.y"
    { 
 (yyval.str) = make_str("unknown");
;}
    break;

  case 1929:

/* Line 1455 of yacc.c  */
#line 11037 "preproc.y"
    { 
 (yyval.str) = make_str("unlisten");
;}
    break;

  case 1930:

/* Line 1455 of yacc.c  */
#line 11041 "preproc.y"
    { 
 (yyval.str) = make_str("until");
;}
    break;

  case 1931:

/* Line 1455 of yacc.c  */
#line 11045 "preproc.y"
    { 
 (yyval.str) = make_str("update");
;}
    break;

  case 1932:

/* Line 1455 of yacc.c  */
#line 11049 "preproc.y"
    { 
 (yyval.str) = make_str("vacuum");
;}
    break;

  case 1933:

/* Line 1455 of yacc.c  */
#line 11053 "preproc.y"
    { 
 (yyval.str) = make_str("valid");
;}
    break;

  case 1934:

/* Line 1455 of yacc.c  */
#line 11057 "preproc.y"
    { 
 (yyval.str) = make_str("validator");
;}
    break;

  case 1935:

/* Line 1455 of yacc.c  */
#line 11061 "preproc.y"
    { 
 (yyval.str) = make_str("value");
;}
    break;

  case 1936:

/* Line 1455 of yacc.c  */
#line 11065 "preproc.y"
    { 
 (yyval.str) = make_str("varying");
;}
    break;

  case 1937:

/* Line 1455 of yacc.c  */
#line 11069 "preproc.y"
    { 
 (yyval.str) = make_str("version");
;}
    break;

  case 1938:

/* Line 1455 of yacc.c  */
#line 11073 "preproc.y"
    { 
 (yyval.str) = make_str("view");
;}
    break;

  case 1939:

/* Line 1455 of yacc.c  */
#line 11077 "preproc.y"
    { 
 (yyval.str) = make_str("volatile");
;}
    break;

  case 1940:

/* Line 1455 of yacc.c  */
#line 11081 "preproc.y"
    { 
 (yyval.str) = make_str("whitespace");
;}
    break;

  case 1941:

/* Line 1455 of yacc.c  */
#line 11085 "preproc.y"
    { 
 (yyval.str) = make_str("without");
;}
    break;

  case 1942:

/* Line 1455 of yacc.c  */
#line 11089 "preproc.y"
    { 
 (yyval.str) = make_str("work");
;}
    break;

  case 1943:

/* Line 1455 of yacc.c  */
#line 11093 "preproc.y"
    { 
 (yyval.str) = make_str("wrapper");
;}
    break;

  case 1944:

/* Line 1455 of yacc.c  */
#line 11097 "preproc.y"
    { 
 (yyval.str) = make_str("write");
;}
    break;

  case 1945:

/* Line 1455 of yacc.c  */
#line 11101 "preproc.y"
    { 
 (yyval.str) = make_str("xml");
;}
    break;

  case 1946:

/* Line 1455 of yacc.c  */
#line 11105 "preproc.y"
    { 
 (yyval.str) = make_str("yes");
;}
    break;

  case 1947:

/* Line 1455 of yacc.c  */
#line 11109 "preproc.y"
    { 
 (yyval.str) = make_str("zone");
;}
    break;

  case 1948:

/* Line 1455 of yacc.c  */
#line 11117 "preproc.y"
    { 
 (yyval.str) = make_str("between");
;}
    break;

  case 1949:

/* Line 1455 of yacc.c  */
#line 11121 "preproc.y"
    { 
 (yyval.str) = make_str("bigint");
;}
    break;

  case 1950:

/* Line 1455 of yacc.c  */
#line 11125 "preproc.y"
    { 
 (yyval.str) = make_str("bit");
;}
    break;

  case 1951:

/* Line 1455 of yacc.c  */
#line 11129 "preproc.y"
    { 
 (yyval.str) = make_str("boolean");
;}
    break;

  case 1952:

/* Line 1455 of yacc.c  */
#line 11133 "preproc.y"
    { 
 (yyval.str) = make_str("character");
;}
    break;

  case 1953:

/* Line 1455 of yacc.c  */
#line 11137 "preproc.y"
    { 
 (yyval.str) = make_str("coalesce");
;}
    break;

  case 1954:

/* Line 1455 of yacc.c  */
#line 11141 "preproc.y"
    { 
 (yyval.str) = make_str("dec");
;}
    break;

  case 1955:

/* Line 1455 of yacc.c  */
#line 11145 "preproc.y"
    { 
 (yyval.str) = make_str("decimal");
;}
    break;

  case 1956:

/* Line 1455 of yacc.c  */
#line 11149 "preproc.y"
    { 
 (yyval.str) = make_str("exists");
;}
    break;

  case 1957:

/* Line 1455 of yacc.c  */
#line 11153 "preproc.y"
    { 
 (yyval.str) = make_str("extract");
;}
    break;

  case 1958:

/* Line 1455 of yacc.c  */
#line 11157 "preproc.y"
    { 
 (yyval.str) = make_str("float");
;}
    break;

  case 1959:

/* Line 1455 of yacc.c  */
#line 11161 "preproc.y"
    { 
 (yyval.str) = make_str("greatest");
;}
    break;

  case 1960:

/* Line 1455 of yacc.c  */
#line 11165 "preproc.y"
    { 
 (yyval.str) = make_str("inout");
;}
    break;

  case 1961:

/* Line 1455 of yacc.c  */
#line 11169 "preproc.y"
    { 
 (yyval.str) = make_str("integer");
;}
    break;

  case 1962:

/* Line 1455 of yacc.c  */
#line 11173 "preproc.y"
    { 
 (yyval.str) = make_str("interval");
;}
    break;

  case 1963:

/* Line 1455 of yacc.c  */
#line 11177 "preproc.y"
    { 
 (yyval.str) = make_str("least");
;}
    break;

  case 1964:

/* Line 1455 of yacc.c  */
#line 11181 "preproc.y"
    { 
 (yyval.str) = make_str("national");
;}
    break;

  case 1965:

/* Line 1455 of yacc.c  */
#line 11185 "preproc.y"
    { 
 (yyval.str) = make_str("nchar");
;}
    break;

  case 1966:

/* Line 1455 of yacc.c  */
#line 11189 "preproc.y"
    { 
 (yyval.str) = make_str("none");
;}
    break;

  case 1967:

/* Line 1455 of yacc.c  */
#line 11193 "preproc.y"
    { 
 (yyval.str) = make_str("nullif");
;}
    break;

  case 1968:

/* Line 1455 of yacc.c  */
#line 11197 "preproc.y"
    { 
 (yyval.str) = make_str("numeric");
;}
    break;

  case 1969:

/* Line 1455 of yacc.c  */
#line 11201 "preproc.y"
    { 
 (yyval.str) = make_str("out");
;}
    break;

  case 1970:

/* Line 1455 of yacc.c  */
#line 11205 "preproc.y"
    { 
 (yyval.str) = make_str("overlay");
;}
    break;

  case 1971:

/* Line 1455 of yacc.c  */
#line 11209 "preproc.y"
    { 
 (yyval.str) = make_str("position");
;}
    break;

  case 1972:

/* Line 1455 of yacc.c  */
#line 11213 "preproc.y"
    { 
 (yyval.str) = make_str("precision");
;}
    break;

  case 1973:

/* Line 1455 of yacc.c  */
#line 11217 "preproc.y"
    { 
 (yyval.str) = make_str("real");
;}
    break;

  case 1974:

/* Line 1455 of yacc.c  */
#line 11221 "preproc.y"
    { 
 (yyval.str) = make_str("row");
;}
    break;

  case 1975:

/* Line 1455 of yacc.c  */
#line 11225 "preproc.y"
    { 
 (yyval.str) = make_str("setof");
;}
    break;

  case 1976:

/* Line 1455 of yacc.c  */
#line 11229 "preproc.y"
    { 
 (yyval.str) = make_str("smallint");
;}
    break;

  case 1977:

/* Line 1455 of yacc.c  */
#line 11233 "preproc.y"
    { 
 (yyval.str) = make_str("substring");
;}
    break;

  case 1978:

/* Line 1455 of yacc.c  */
#line 11237 "preproc.y"
    { 
 (yyval.str) = make_str("time");
;}
    break;

  case 1979:

/* Line 1455 of yacc.c  */
#line 11241 "preproc.y"
    { 
 (yyval.str) = make_str("timestamp");
;}
    break;

  case 1980:

/* Line 1455 of yacc.c  */
#line 11245 "preproc.y"
    { 
 (yyval.str) = make_str("treat");
;}
    break;

  case 1981:

/* Line 1455 of yacc.c  */
#line 11249 "preproc.y"
    { 
 (yyval.str) = make_str("trim");
;}
    break;

  case 1982:

/* Line 1455 of yacc.c  */
#line 11253 "preproc.y"
    { 
 (yyval.str) = make_str("varchar");
;}
    break;

  case 1983:

/* Line 1455 of yacc.c  */
#line 11257 "preproc.y"
    { 
 (yyval.str) = make_str("xmlattributes");
;}
    break;

  case 1984:

/* Line 1455 of yacc.c  */
#line 11261 "preproc.y"
    { 
 (yyval.str) = make_str("xmlconcat");
;}
    break;

  case 1985:

/* Line 1455 of yacc.c  */
#line 11265 "preproc.y"
    { 
 (yyval.str) = make_str("xmlelement");
;}
    break;

  case 1986:

/* Line 1455 of yacc.c  */
#line 11269 "preproc.y"
    { 
 (yyval.str) = make_str("xmlforest");
;}
    break;

  case 1987:

/* Line 1455 of yacc.c  */
#line 11273 "preproc.y"
    { 
 (yyval.str) = make_str("xmlparse");
;}
    break;

  case 1988:

/* Line 1455 of yacc.c  */
#line 11277 "preproc.y"
    { 
 (yyval.str) = make_str("xmlpi");
;}
    break;

  case 1989:

/* Line 1455 of yacc.c  */
#line 11281 "preproc.y"
    { 
 (yyval.str) = make_str("xmlroot");
;}
    break;

  case 1990:

/* Line 1455 of yacc.c  */
#line 11285 "preproc.y"
    { 
 (yyval.str) = make_str("xmlserialize");
;}
    break;

  case 1991:

/* Line 1455 of yacc.c  */
#line 11293 "preproc.y"
    { 
 (yyval.str) = make_str("authorization");
;}
    break;

  case 1992:

/* Line 1455 of yacc.c  */
#line 11297 "preproc.y"
    { 
 (yyval.str) = make_str("binary");
;}
    break;

  case 1993:

/* Line 1455 of yacc.c  */
#line 11301 "preproc.y"
    { 
 (yyval.str) = make_str("concurrently");
;}
    break;

  case 1994:

/* Line 1455 of yacc.c  */
#line 11305 "preproc.y"
    { 
 (yyval.str) = make_str("cross");
;}
    break;

  case 1995:

/* Line 1455 of yacc.c  */
#line 11309 "preproc.y"
    { 
 (yyval.str) = make_str("current_schema");
;}
    break;

  case 1996:

/* Line 1455 of yacc.c  */
#line 11313 "preproc.y"
    { 
 (yyval.str) = make_str("freeze");
;}
    break;

  case 1997:

/* Line 1455 of yacc.c  */
#line 11317 "preproc.y"
    { 
 (yyval.str) = make_str("full");
;}
    break;

  case 1998:

/* Line 1455 of yacc.c  */
#line 11321 "preproc.y"
    { 
 (yyval.str) = make_str("ilike");
;}
    break;

  case 1999:

/* Line 1455 of yacc.c  */
#line 11325 "preproc.y"
    { 
 (yyval.str) = make_str("inner");
;}
    break;

  case 2000:

/* Line 1455 of yacc.c  */
#line 11329 "preproc.y"
    { 
 (yyval.str) = make_str("is");
;}
    break;

  case 2001:

/* Line 1455 of yacc.c  */
#line 11333 "preproc.y"
    { 
 (yyval.str) = make_str("isnull");
;}
    break;

  case 2002:

/* Line 1455 of yacc.c  */
#line 11337 "preproc.y"
    { 
 (yyval.str) = make_str("join");
;}
    break;

  case 2003:

/* Line 1455 of yacc.c  */
#line 11341 "preproc.y"
    { 
 (yyval.str) = make_str("left");
;}
    break;

  case 2004:

/* Line 1455 of yacc.c  */
#line 11345 "preproc.y"
    { 
 (yyval.str) = make_str("like");
;}
    break;

  case 2005:

/* Line 1455 of yacc.c  */
#line 11349 "preproc.y"
    { 
 (yyval.str) = make_str("natural");
;}
    break;

  case 2006:

/* Line 1455 of yacc.c  */
#line 11353 "preproc.y"
    { 
 (yyval.str) = make_str("notnull");
;}
    break;

  case 2007:

/* Line 1455 of yacc.c  */
#line 11357 "preproc.y"
    { 
 (yyval.str) = make_str("outer");
;}
    break;

  case 2008:

/* Line 1455 of yacc.c  */
#line 11361 "preproc.y"
    { 
 (yyval.str) = make_str("over");
;}
    break;

  case 2009:

/* Line 1455 of yacc.c  */
#line 11365 "preproc.y"
    { 
 (yyval.str) = make_str("overlaps");
;}
    break;

  case 2010:

/* Line 1455 of yacc.c  */
#line 11369 "preproc.y"
    { 
 (yyval.str) = make_str("right");
;}
    break;

  case 2011:

/* Line 1455 of yacc.c  */
#line 11373 "preproc.y"
    { 
 (yyval.str) = make_str("similar");
;}
    break;

  case 2012:

/* Line 1455 of yacc.c  */
#line 11377 "preproc.y"
    { 
 (yyval.str) = make_str("verbose");
;}
    break;

  case 2013:

/* Line 1455 of yacc.c  */
#line 11385 "preproc.y"
    { 
 (yyval.str) = make_str("all");
;}
    break;

  case 2014:

/* Line 1455 of yacc.c  */
#line 11389 "preproc.y"
    { 
 (yyval.str) = make_str("analyse");
;}
    break;

  case 2015:

/* Line 1455 of yacc.c  */
#line 11393 "preproc.y"
    { 
 (yyval.str) = make_str("analyze");
;}
    break;

  case 2016:

/* Line 1455 of yacc.c  */
#line 11397 "preproc.y"
    { 
 (yyval.str) = make_str("and");
;}
    break;

  case 2017:

/* Line 1455 of yacc.c  */
#line 11401 "preproc.y"
    { 
 (yyval.str) = make_str("any");
;}
    break;

  case 2018:

/* Line 1455 of yacc.c  */
#line 11405 "preproc.y"
    { 
 (yyval.str) = make_str("array");
;}
    break;

  case 2019:

/* Line 1455 of yacc.c  */
#line 11409 "preproc.y"
    { 
 (yyval.str) = make_str("as");
;}
    break;

  case 2020:

/* Line 1455 of yacc.c  */
#line 11413 "preproc.y"
    { 
 (yyval.str) = make_str("asc");
;}
    break;

  case 2021:

/* Line 1455 of yacc.c  */
#line 11417 "preproc.y"
    { 
 (yyval.str) = make_str("asymmetric");
;}
    break;

  case 2022:

/* Line 1455 of yacc.c  */
#line 11421 "preproc.y"
    { 
 (yyval.str) = make_str("both");
;}
    break;

  case 2023:

/* Line 1455 of yacc.c  */
#line 11425 "preproc.y"
    { 
 (yyval.str) = make_str("case");
;}
    break;

  case 2024:

/* Line 1455 of yacc.c  */
#line 11429 "preproc.y"
    { 
 (yyval.str) = make_str("cast");
;}
    break;

  case 2025:

/* Line 1455 of yacc.c  */
#line 11433 "preproc.y"
    { 
 (yyval.str) = make_str("check");
;}
    break;

  case 2026:

/* Line 1455 of yacc.c  */
#line 11437 "preproc.y"
    { 
 (yyval.str) = make_str("collate");
;}
    break;

  case 2027:

/* Line 1455 of yacc.c  */
#line 11441 "preproc.y"
    { 
 (yyval.str) = make_str("column");
;}
    break;

  case 2028:

/* Line 1455 of yacc.c  */
#line 11445 "preproc.y"
    { 
 (yyval.str) = make_str("constraint");
;}
    break;

  case 2029:

/* Line 1455 of yacc.c  */
#line 11449 "preproc.y"
    { 
 (yyval.str) = make_str("create");
;}
    break;

  case 2030:

/* Line 1455 of yacc.c  */
#line 11453 "preproc.y"
    { 
 (yyval.str) = make_str("current_catalog");
;}
    break;

  case 2031:

/* Line 1455 of yacc.c  */
#line 11457 "preproc.y"
    { 
 (yyval.str) = make_str("current_date");
;}
    break;

  case 2032:

/* Line 1455 of yacc.c  */
#line 11461 "preproc.y"
    { 
 (yyval.str) = make_str("current_role");
;}
    break;

  case 2033:

/* Line 1455 of yacc.c  */
#line 11465 "preproc.y"
    { 
 (yyval.str) = make_str("current_time");
;}
    break;

  case 2034:

/* Line 1455 of yacc.c  */
#line 11469 "preproc.y"
    { 
 (yyval.str) = make_str("current_timestamp");
;}
    break;

  case 2035:

/* Line 1455 of yacc.c  */
#line 11473 "preproc.y"
    { 
 (yyval.str) = make_str("current_user");
;}
    break;

  case 2036:

/* Line 1455 of yacc.c  */
#line 11477 "preproc.y"
    { 
 (yyval.str) = make_str("default");
;}
    break;

  case 2037:

/* Line 1455 of yacc.c  */
#line 11481 "preproc.y"
    { 
 (yyval.str) = make_str("deferrable");
;}
    break;

  case 2038:

/* Line 1455 of yacc.c  */
#line 11485 "preproc.y"
    { 
 (yyval.str) = make_str("desc");
;}
    break;

  case 2039:

/* Line 1455 of yacc.c  */
#line 11489 "preproc.y"
    { 
 (yyval.str) = make_str("distinct");
;}
    break;

  case 2040:

/* Line 1455 of yacc.c  */
#line 11493 "preproc.y"
    { 
 (yyval.str) = make_str("do");
;}
    break;

  case 2041:

/* Line 1455 of yacc.c  */
#line 11497 "preproc.y"
    { 
 (yyval.str) = make_str("else");
;}
    break;

  case 2042:

/* Line 1455 of yacc.c  */
#line 11501 "preproc.y"
    { 
 (yyval.str) = make_str("end");
;}
    break;

  case 2043:

/* Line 1455 of yacc.c  */
#line 11505 "preproc.y"
    { 
 (yyval.str) = make_str("except");
;}
    break;

  case 2044:

/* Line 1455 of yacc.c  */
#line 11509 "preproc.y"
    { 
 (yyval.str) = make_str("false");
;}
    break;

  case 2045:

/* Line 1455 of yacc.c  */
#line 11513 "preproc.y"
    { 
 (yyval.str) = make_str("fetch");
;}
    break;

  case 2046:

/* Line 1455 of yacc.c  */
#line 11517 "preproc.y"
    { 
 (yyval.str) = make_str("for");
;}
    break;

  case 2047:

/* Line 1455 of yacc.c  */
#line 11521 "preproc.y"
    { 
 (yyval.str) = make_str("foreign");
;}
    break;

  case 2048:

/* Line 1455 of yacc.c  */
#line 11525 "preproc.y"
    { 
 (yyval.str) = make_str("from");
;}
    break;

  case 2049:

/* Line 1455 of yacc.c  */
#line 11529 "preproc.y"
    { 
 (yyval.str) = make_str("grant");
;}
    break;

  case 2050:

/* Line 1455 of yacc.c  */
#line 11533 "preproc.y"
    { 
 (yyval.str) = make_str("group");
;}
    break;

  case 2051:

/* Line 1455 of yacc.c  */
#line 11537 "preproc.y"
    { 
 (yyval.str) = make_str("having");
;}
    break;

  case 2052:

/* Line 1455 of yacc.c  */
#line 11541 "preproc.y"
    { 
 (yyval.str) = make_str("in");
;}
    break;

  case 2053:

/* Line 1455 of yacc.c  */
#line 11545 "preproc.y"
    { 
 (yyval.str) = make_str("initially");
;}
    break;

  case 2054:

/* Line 1455 of yacc.c  */
#line 11549 "preproc.y"
    { 
 (yyval.str) = make_str("intersect");
;}
    break;

  case 2055:

/* Line 1455 of yacc.c  */
#line 11553 "preproc.y"
    { 
 (yyval.str) = make_str("into");
;}
    break;

  case 2056:

/* Line 1455 of yacc.c  */
#line 11557 "preproc.y"
    { 
 (yyval.str) = make_str("leading");
;}
    break;

  case 2057:

/* Line 1455 of yacc.c  */
#line 11561 "preproc.y"
    { 
 (yyval.str) = make_str("limit");
;}
    break;

  case 2058:

/* Line 1455 of yacc.c  */
#line 11565 "preproc.y"
    { 
 (yyval.str) = make_str("localtime");
;}
    break;

  case 2059:

/* Line 1455 of yacc.c  */
#line 11569 "preproc.y"
    { 
 (yyval.str) = make_str("localtimestamp");
;}
    break;

  case 2060:

/* Line 1455 of yacc.c  */
#line 11573 "preproc.y"
    { 
 (yyval.str) = make_str("not");
;}
    break;

  case 2061:

/* Line 1455 of yacc.c  */
#line 11577 "preproc.y"
    { 
 (yyval.str) = make_str("null");
;}
    break;

  case 2062:

/* Line 1455 of yacc.c  */
#line 11581 "preproc.y"
    { 
 (yyval.str) = make_str("offset");
;}
    break;

  case 2063:

/* Line 1455 of yacc.c  */
#line 11585 "preproc.y"
    { 
 (yyval.str) = make_str("on");
;}
    break;

  case 2064:

/* Line 1455 of yacc.c  */
#line 11589 "preproc.y"
    { 
 (yyval.str) = make_str("only");
;}
    break;

  case 2065:

/* Line 1455 of yacc.c  */
#line 11593 "preproc.y"
    { 
 (yyval.str) = make_str("or");
;}
    break;

  case 2066:

/* Line 1455 of yacc.c  */
#line 11597 "preproc.y"
    { 
 (yyval.str) = make_str("order");
;}
    break;

  case 2067:

/* Line 1455 of yacc.c  */
#line 11601 "preproc.y"
    { 
 (yyval.str) = make_str("placing");
;}
    break;

  case 2068:

/* Line 1455 of yacc.c  */
#line 11605 "preproc.y"
    { 
 (yyval.str) = make_str("primary");
;}
    break;

  case 2069:

/* Line 1455 of yacc.c  */
#line 11609 "preproc.y"
    { 
 (yyval.str) = make_str("references");
;}
    break;

  case 2070:

/* Line 1455 of yacc.c  */
#line 11613 "preproc.y"
    { 
 (yyval.str) = make_str("returning");
;}
    break;

  case 2071:

/* Line 1455 of yacc.c  */
#line 11617 "preproc.y"
    { 
 (yyval.str) = make_str("select");
;}
    break;

  case 2072:

/* Line 1455 of yacc.c  */
#line 11621 "preproc.y"
    { 
 (yyval.str) = make_str("session_user");
;}
    break;

  case 2073:

/* Line 1455 of yacc.c  */
#line 11625 "preproc.y"
    { 
 (yyval.str) = make_str("some");
;}
    break;

  case 2074:

/* Line 1455 of yacc.c  */
#line 11629 "preproc.y"
    { 
 (yyval.str) = make_str("symmetric");
;}
    break;

  case 2075:

/* Line 1455 of yacc.c  */
#line 11633 "preproc.y"
    { 
 (yyval.str) = make_str("table");
;}
    break;

  case 2076:

/* Line 1455 of yacc.c  */
#line 11637 "preproc.y"
    { 
 (yyval.str) = make_str("then");
;}
    break;

  case 2077:

/* Line 1455 of yacc.c  */
#line 11641 "preproc.y"
    { 
 (yyval.str) = make_str("trailing");
;}
    break;

  case 2078:

/* Line 1455 of yacc.c  */
#line 11645 "preproc.y"
    { 
 (yyval.str) = make_str("true");
;}
    break;

  case 2079:

/* Line 1455 of yacc.c  */
#line 11649 "preproc.y"
    { 
 (yyval.str) = make_str("unique");
;}
    break;

  case 2080:

/* Line 1455 of yacc.c  */
#line 11653 "preproc.y"
    { 
 (yyval.str) = make_str("user");
;}
    break;

  case 2081:

/* Line 1455 of yacc.c  */
#line 11657 "preproc.y"
    { 
 (yyval.str) = make_str("using");
;}
    break;

  case 2082:

/* Line 1455 of yacc.c  */
#line 11661 "preproc.y"
    { 
 (yyval.str) = make_str("variadic");
;}
    break;

  case 2083:

/* Line 1455 of yacc.c  */
#line 11665 "preproc.y"
    { 
 (yyval.str) = make_str("when");
;}
    break;

  case 2084:

/* Line 1455 of yacc.c  */
#line 11669 "preproc.y"
    { 
 (yyval.str) = make_str("where");
;}
    break;

  case 2085:

/* Line 1455 of yacc.c  */
#line 11673 "preproc.y"
    { 
 (yyval.str) = make_str("window");
;}
    break;

  case 2086:

/* Line 1455 of yacc.c  */
#line 11677 "preproc.y"
    { 
 (yyval.str) = make_str("with");
;}
    break;

  case 2089:

/* Line 1455 of yacc.c  */
#line 11690 "preproc.y"
    { connection = NULL; ;}
    break;

  case 2091:

/* Line 1455 of yacc.c  */
#line 11693 "preproc.y"
    {
                        fprintf(yyout, "%s", (yyvsp[(2) - (2)].str));
                        free((yyvsp[(2) - (2)].str));
                        output_line_number();
                ;}
    break;

  case 2093:

/* Line 1455 of yacc.c  */
#line 11699 "preproc.y"
    { fprintf(yyout, "%s", (yyvsp[(1) - (1)].str)); free((yyvsp[(1) - (1)].str)); ;}
    break;

  case 2094:

/* Line 1455 of yacc.c  */
#line 11700 "preproc.y"
    { fprintf(yyout, "%s", (yyvsp[(1) - (1)].str)); free((yyvsp[(1) - (1)].str)); ;}
    break;

  case 2095:

/* Line 1455 of yacc.c  */
#line 11701 "preproc.y"
    { braces_open++; fputs("{", yyout); ;}
    break;

  case 2096:

/* Line 1455 of yacc.c  */
#line 11703 "preproc.y"
    {
			remove_typedefs(braces_open);
			remove_variables(braces_open--);
			if (braces_open == 0)
			{
				free(current_function);
				current_function = NULL;
			}
			fputs("}", yyout);
		;}
    break;

  case 2097:

/* Line 1455 of yacc.c  */
#line 11715 "preproc.y"
    {FoundInto = 0;;}
    break;

  case 2098:

/* Line 1455 of yacc.c  */
#line 11716 "preproc.y"
    {
			if (FoundInto == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "CREATE TABLE AS cannot specify INTO");

			(yyval.str) = cat_str(6, make_str("create"), (yyvsp[(2) - (8)].str), make_str("table"), (yyvsp[(4) - (8)].str), make_str("as"), (yyvsp[(7) - (8)].str));
		;}
    break;

  case 2099:

/* Line 1455 of yacc.c  */
#line 11725 "preproc.y"
    {
                        connection = (yyvsp[(2) - (2)].str);
                        /*
                         *      Do we have a variable as connection target?
                         *      Remove the variable from the variable
                         *      list or else it will be used twice
                         */
                        if (argsinsert != NULL)
                                argsinsert = NULL;
                ;}
    break;

  case 2100:

/* Line 1455 of yacc.c  */
#line 11741 "preproc.y"
    { (yyval.str) = cat_str(5, (yyvsp[(3) - (5)].str), make_str(","), (yyvsp[(5) - (5)].str), make_str(","), (yyvsp[(4) - (5)].str)); ;}
    break;

  case 2101:

/* Line 1455 of yacc.c  */
#line 11743 "preproc.y"
    { (yyval.str) = make_str("NULL, NULL, NULL, \"DEFAULT\""); ;}
    break;

  case 2102:

/* Line 1455 of yacc.c  */
#line 11746 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("NULL,"), (yyvsp[(2) - (2)].str), make_str(", NULL")); ;}
    break;

  case 2103:

/* Line 1455 of yacc.c  */
#line 11748 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(2) - (2)].str), make_str(", NULL, NULL, NULL")); ;}
    break;

  case 2104:

/* Line 1455 of yacc.c  */
#line 11752 "preproc.y"
    {
			/* old style: dbname[@server][:port] */
			if (strlen((yyvsp[(2) - (3)].str)) > 0 && *((yyvsp[(2) - (3)].str)) != '@')
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\", found \"%s\"", (yyvsp[(2) - (3)].str));
			
			/* C strings need to be handled differently */
			if ((yyvsp[(1) - (3)].str)[0] == '\"')
				(yyval.str) = (yyvsp[(1) - (3)].str);
			else
				(yyval.str) = make3_str(make_str("\""), make3_str((yyvsp[(1) - (3)].str), (yyvsp[(2) - (3)].str), (yyvsp[(3) - (3)].str)), make_str("\""));
		;}
    break;

  case 2105:

/* Line 1455 of yacc.c  */
#line 11764 "preproc.y"
    {
			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
			if (strncmp((yyvsp[(1) - (7)].str), "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp((yyvsp[(1) - (7)].str), "tcp:postgresql", strlen("tcp:postgresql")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "only protocols \"tcp\" and \"unix\" and database type \"postgresql\" are supported");

			if (strncmp((yyvsp[(3) - (7)].str), "//", strlen("//")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"://\", found \"%s\"", (yyvsp[(3) - (7)].str));

			if (strncmp((yyvsp[(1) - (7)].str), "unix", strlen("unix")) == 0 &&
				strncmp((yyvsp[(3) - (7)].str) + strlen("//"), "localhost", strlen("localhost")) != 0 &&
				strncmp((yyvsp[(3) - (7)].str) + strlen("//"), "127.0.0.1", strlen("127.0.0.1")) != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "Unix-domain sockets only work on \"localhost\" but not on \"%s\"", (yyvsp[(3) - (7)].str) + strlen("//"));

			(yyval.str) = make3_str(make3_str(make_str("\""), (yyvsp[(1) - (7)].str), make_str(":")), (yyvsp[(3) - (7)].str), make3_str(make3_str((yyvsp[(4) - (7)].str), make_str("/"), (yyvsp[(6) - (7)].str)),	(yyvsp[(7) - (7)].str), make_str("\"")));
		;}
    break;

  case 2106:

/* Line 1455 of yacc.c  */
#line 11780 "preproc.y"
    {
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2107:

/* Line 1455 of yacc.c  */
#line 11784 "preproc.y"
    {
			/* We can only process double quoted strings not single quotes ones,
			 * so we change the quotes.
			 * Note, that the rule for ecpg_sconst adds these single quotes. */
			(yyvsp[(1) - (1)].str)[0] = '\"';
			(yyvsp[(1) - (1)].str)[strlen((yyvsp[(1) - (1)].str))-1] = '\"';
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2108:

/* Line 1455 of yacc.c  */
#line 11794 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2109:

/* Line 1455 of yacc.c  */
#line 11795 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2110:

/* Line 1455 of yacc.c  */
#line 11799 "preproc.y"
    {
			if (strcmp((yyvsp[(2) - (2)].str), "postgresql") != 0 && strcmp((yyvsp[(2) - (2)].str), "postgres") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"postgresql\", found \"%s\"", (yyvsp[(2) - (2)].str));

			if (strcmp((yyvsp[(1) - (2)].str), "tcp") != 0 && strcmp((yyvsp[(1) - (2)].str), "unix") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "invalid connection type: %s", (yyvsp[(1) - (2)].str));

			(yyval.str) = make3_str((yyvsp[(1) - (2)].str), make_str(":"), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2111:

/* Line 1455 of yacc.c  */
#line 11811 "preproc.y"
    {
			if (strcmp((yyvsp[(1) - (2)].str), "@") != 0 && strcmp((yyvsp[(1) - (2)].str), "//") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "expected \"@\" or \"://\", found \"%s\"", (yyvsp[(1) - (2)].str));

			(yyval.str) = make2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2112:

/* Line 1455 of yacc.c  */
#line 11819 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2113:

/* Line 1455 of yacc.c  */
#line 11820 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2114:

/* Line 1455 of yacc.c  */
#line 11823 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2115:

/* Line 1455 of yacc.c  */
#line 11824 "preproc.y"
    { (yyval.str) = make3_str((yyvsp[(1) - (3)].str), make_str("."), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2116:

/* Line 1455 of yacc.c  */
#line 11825 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2117:

/* Line 1455 of yacc.c  */
#line 11828 "preproc.y"
    { (yyval.str) = make2_str(make_str(":"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2118:

/* Line 1455 of yacc.c  */
#line 11829 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2119:

/* Line 1455 of yacc.c  */
#line 11832 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2120:

/* Line 1455 of yacc.c  */
#line 11833 "preproc.y"
    { (yyval.str) = make_str("NULL"); ;}
    break;

  case 2121:

/* Line 1455 of yacc.c  */
#line 11836 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2122:

/* Line 1455 of yacc.c  */
#line 11837 "preproc.y"
    { (yyval.str) = make_str("NULL, NULL"); ;}
    break;

  case 2123:

/* Line 1455 of yacc.c  */
#line 11841 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (1)].str), make_str(", NULL")); ;}
    break;

  case 2124:

/* Line 1455 of yacc.c  */
#line 11843 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2125:

/* Line 1455 of yacc.c  */
#line 11845 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (4)].str), make_str(","), (yyvsp[(4) - (4)].str)); ;}
    break;

  case 2126:

/* Line 1455 of yacc.c  */
#line 11847 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2127:

/* Line 1455 of yacc.c  */
#line 11851 "preproc.y"
    {
			if ((yyvsp[(1) - (1)].str)[0] == '\"')
				(yyval.str) = (yyvsp[(1) - (1)].str);
			else
				(yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\""));
		;}
    break;

  case 2128:

/* Line 1455 of yacc.c  */
#line 11858 "preproc.y"
    {
			if ((yyvsp[(1) - (1)].str)[0] == '\"')
				(yyval.str) = (yyvsp[(1) - (1)].str);
			else
				(yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\""));
		;}
    break;

  case 2129:

/* Line 1455 of yacc.c  */
#line 11865 "preproc.y"
    {
			enum ECPGttype type = argsinsert->variable->type->type;

			/* if array see what's inside */
			if (type == ECPGt_array)
				type = argsinsert->variable->type->u.element->type;

			/* handle varchars */
			if (type == ECPGt_varchar)
				(yyval.str) = make2_str(mm_strdup(argsinsert->variable->name), make_str(".arr"));
			else
				(yyval.str) = mm_strdup(argsinsert->variable->name);
		;}
    break;

  case 2130:

/* Line 1455 of yacc.c  */
#line 11881 "preproc.y"
    {
			/* check if we have a string variable */
			struct variable *p = find_variable((yyvsp[(1) - (1)].str));
			enum ECPGttype type = p->type->type;

			/* If we have just one character this is not a string */
			if (atol(p->type->size) == 1)
					mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
			else
			{
				/* if array see what's inside */
				if (type == ECPGt_array)
					type = p->type->u.element->type;

				switch (type)
				{
					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						(yyval.str) = (yyvsp[(1) - (1)].str);
						break;
					case ECPGt_varchar:
						(yyval.str) = make2_str((yyvsp[(1) - (1)].str), make_str(".arr"));
						break;
					default:
						mmerror(PARSE_ERROR, ET_ERROR, "invalid data type");
						(yyval.str) = (yyvsp[(1) - (1)].str);
						break;
				}
			}
		;}
    break;

  case 2131:

/* Line 1455 of yacc.c  */
#line 11915 "preproc.y"
    {
			if (strlen((yyvsp[(1) - (2)].str)) == 0)
				mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

			if (strcmp((yyvsp[(1) - (2)].str), "?") != 0)
				mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[(1) - (2)].str));

			(yyval.str) = make2_str(make_str("?"), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2132:

/* Line 1455 of yacc.c  */
#line 11924 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2133:

/* Line 1455 of yacc.c  */
#line 11928 "preproc.y"
    { (yyval.str) = make2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2134:

/* Line 1455 of yacc.c  */
#line 11930 "preproc.y"
    {
				if (strlen((yyvsp[(3) - (4)].str)) == 0)
					mmerror(PARSE_ERROR, ET_ERROR, "incomplete statement");

				if (strcmp((yyvsp[(3) - (4)].str), "&") != 0)
					mmerror(PARSE_ERROR, ET_ERROR, "unrecognized token \"%s\"", (yyvsp[(3) - (4)].str));

				(yyval.str) = cat_str(3, make2_str((yyvsp[(1) - (4)].str), (yyvsp[(2) - (4)].str)), (yyvsp[(3) - (4)].str), (yyvsp[(4) - (4)].str));
			;}
    break;

  case 2135:

/* Line 1455 of yacc.c  */
#line 11942 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2136:

/* Line 1455 of yacc.c  */
#line 11944 "preproc.y"
    { (yyval.str) = make2_str(make_str("="), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2137:

/* Line 1455 of yacc.c  */
#line 11946 "preproc.y"
    { (yyval.str) = make2_str(make_str("="), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2138:

/* Line 1455 of yacc.c  */
#line 11948 "preproc.y"
    { (yyval.str) = make2_str(make_str("="), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2139:

/* Line 1455 of yacc.c  */
#line 11951 "preproc.y"
    {
                                        if ((yyvsp[(1) - (1)].str)[0] == '\"' && (yyvsp[(1) - (1)].str)[strlen((yyvsp[(1) - (1)].str))-1] == '\"') /* already quoted? */
                                                (yyval.str) = (yyvsp[(1) - (1)].str);
                                        else /* not quoted => convert to lowercase */
                                        {
                                                int i;

                                                for (i = 0; i< strlen((yyvsp[(1) - (1)].str)); i++)
                                                        (yyvsp[(1) - (1)].str)[i] = tolower((unsigned char) (yyvsp[(1) - (1)].str)[i]);

                                                (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\""));
                                        }
                                ;}
    break;

  case 2140:

/* Line 1455 of yacc.c  */
#line 11964 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2141:

/* Line 1455 of yacc.c  */
#line 11972 "preproc.y"
    {
			struct cursor *ptr, *this;
			char *cursor_marker = (yyvsp[(2) - (7)].str)[0] == ':' ? make_str("$0") : mm_strdup((yyvsp[(2) - (7)].str));
			struct variable *thisquery = (struct variable *)mm_alloc(sizeof(struct variable));
			const char *con = connection ? connection : "NULL";
			char *comment;

			for (ptr = cur; ptr != NULL; ptr = ptr->next)
			{
				if (strcmp((yyvsp[(2) - (7)].str), ptr->name) == 0)
				{
					/* re-definition is a bug */
					if ((yyvsp[(2) - (7)].str)[0] == ':')
	                                        mmerror(PARSE_ERROR, ET_ERROR, "using variable \"%s\" in different declare statements is not supported", (yyvsp[(2) - (7)].str)+1);
        	                        else
						mmerror(PARSE_ERROR, ET_ERROR, "cursor \"%s\" is already defined", (yyvsp[(2) - (7)].str));
				}
			}

			this = (struct cursor *) mm_alloc(sizeof(struct cursor));

			/* initial definition */
			this->next = cur;
			this->name = (yyvsp[(2) - (7)].str);
			this->function = (current_function ? mm_strdup(current_function) : NULL);
			this->connection = connection;
			this->command =  cat_str(6, make_str("declare"), cursor_marker, (yyvsp[(3) - (7)].str), make_str("cursor"), (yyvsp[(5) - (7)].str), make_str("for $1"));
			this->argsresult = NULL;
			this->argsresult_oos = NULL;

			thisquery->type = &ecpg_query;
			thisquery->brace_level = 0;
			thisquery->next = NULL;
			thisquery->name = (char *) mm_alloc(sizeof("ECPGprepared_statement(, , __LINE__)") + strlen(con) + strlen((yyvsp[(7) - (7)].str)));
			sprintf(thisquery->name, "ECPGprepared_statement(%s, %s, __LINE__)", con, (yyvsp[(7) - (7)].str));

			this->argsinsert = NULL;
			this->argsinsert_oos = NULL;
			if ((yyvsp[(2) - (7)].str)[0] == ':')
			{
				struct variable *var = find_variable((yyvsp[(2) - (7)].str) + 1);
				remove_variable_from_list(&argsinsert, var);
				add_variable_to_head(&(this->argsinsert), var, &no_indicator);
			}
			add_variable_to_head(&(this->argsinsert), thisquery, &no_indicator);

			cur = this;

			comment = cat_str(3, make_str("/*"), mm_strdup(this->command), make_str("*/"));

			if ((braces_open > 0) && INFORMIX_MODE) /* we're in a function */
				(yyval.str) = cat_str(3, adjust_outofscope_cursor_vars(this),
					make_str("ECPG_informix_reset_sqlca();"),
					comment);
			else
				(yyval.str) = cat2_str(adjust_outofscope_cursor_vars(this), comment);
		;}
    break;

  case 2142:

/* Line 1455 of yacc.c  */
#line 12032 "preproc.y"
    { 
			  /* execute immediate means prepare the statement and
			   * immediately execute it */
			  (yyval.str) = (yyvsp[(3) - (3)].str);
			;}
    break;

  case 2144:

/* Line 1455 of yacc.c  */
#line 12042 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2145:

/* Line 1455 of yacc.c  */
#line 12043 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2146:

/* Line 1455 of yacc.c  */
#line 12046 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2147:

/* Line 1455 of yacc.c  */
#line 12048 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2148:

/* Line 1455 of yacc.c  */
#line 12049 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2149:

/* Line 1455 of yacc.c  */
#line 12052 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2150:

/* Line 1455 of yacc.c  */
#line 12053 "preproc.y"
    { (yyval.str) = make_str("year to minute"); ;}
    break;

  case 2151:

/* Line 1455 of yacc.c  */
#line 12054 "preproc.y"
    { (yyval.str) = make_str("year to second"); ;}
    break;

  case 2152:

/* Line 1455 of yacc.c  */
#line 12055 "preproc.y"
    { (yyval.str) = make_str("day to day"); ;}
    break;

  case 2153:

/* Line 1455 of yacc.c  */
#line 12056 "preproc.y"
    { (yyval.str) = make_str("month to month"); ;}
    break;

  case 2154:

/* Line 1455 of yacc.c  */
#line 12063 "preproc.y"
    { fputs("/* exec sql begin declare section */", yyout); ;}
    break;

  case 2155:

/* Line 1455 of yacc.c  */
#line 12065 "preproc.y"
    {
			fprintf(yyout, "%s/* exec sql end declare section */", (yyvsp[(3) - (4)].str));
			free((yyvsp[(3) - (4)].str));
			output_line_number();
		;}
    break;

  case 2156:

/* Line 1455 of yacc.c  */
#line 12072 "preproc.y"
    {;}
    break;

  case 2157:

/* Line 1455 of yacc.c  */
#line 12074 "preproc.y"
    {;}
    break;

  case 2158:

/* Line 1455 of yacc.c  */
#line 12076 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2159:

/* Line 1455 of yacc.c  */
#line 12077 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2160:

/* Line 1455 of yacc.c  */
#line 12080 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2161:

/* Line 1455 of yacc.c  */
#line 12081 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2162:

/* Line 1455 of yacc.c  */
#line 12082 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2163:

/* Line 1455 of yacc.c  */
#line 12083 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2164:

/* Line 1455 of yacc.c  */
#line 12086 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2165:

/* Line 1455 of yacc.c  */
#line 12087 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2166:

/* Line 1455 of yacc.c  */
#line 12091 "preproc.y"
    {
		/* reset this variable so we see if there was */
		/* an initializer specified */
		initializer = 0;
	;}
    break;

  case 2167:

/* Line 1455 of yacc.c  */
#line 12097 "preproc.y"
    {
		add_typedef((yyvsp[(5) - (7)].str), (yyvsp[(6) - (7)].index).index1, (yyvsp[(6) - (7)].index).index2, (yyvsp[(3) - (7)].type).type_enum, (yyvsp[(3) - (7)].type).type_dimension, (yyvsp[(3) - (7)].type).type_index, initializer, *(yyvsp[(4) - (7)].str) ? 1 : 0);

		fprintf(yyout, "typedef %s %s %s %s;\n", (yyvsp[(3) - (7)].type).type_str, *(yyvsp[(4) - (7)].str) ? "*" : "", (yyvsp[(5) - (7)].str), (yyvsp[(6) - (7)].index).str);
		output_line_number();
		(yyval.str) = make_str("");
	;}
    break;

  case 2168:

/* Line 1455 of yacc.c  */
#line 12107 "preproc.y"
    {
			actual_type[struct_level].type_enum = (yyvsp[(2) - (2)].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[(2) - (2)].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[(2) - (2)].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[(2) - (2)].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[(2) - (2)].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		;}
    break;

  case 2169:

/* Line 1455 of yacc.c  */
#line 12117 "preproc.y"
    {
			(yyval.str) = cat_str(5, actual_startline[struct_level], (yyvsp[(1) - (5)].str), (yyvsp[(2) - (5)].type).type_str, (yyvsp[(4) - (5)].str), make_str(";\n"));
		;}
    break;

  case 2170:

/* Line 1455 of yacc.c  */
#line 12121 "preproc.y"
    {
			actual_type[struct_level].type_enum = (yyvsp[(1) - (1)].type).type_enum;
			actual_type[struct_level].type_str = (yyvsp[(1) - (1)].type).type_str;
			actual_type[struct_level].type_dimension = (yyvsp[(1) - (1)].type).type_dimension;
			actual_type[struct_level].type_index = (yyvsp[(1) - (1)].type).type_index;
			actual_type[struct_level].type_sizeof = (yyvsp[(1) - (1)].type).type_sizeof;

			actual_startline[struct_level] = hashline_number();
		;}
    break;

  case 2171:

/* Line 1455 of yacc.c  */
#line 12131 "preproc.y"
    {
			(yyval.str) = cat_str(4, actual_startline[struct_level], (yyvsp[(1) - (4)].type).type_str, (yyvsp[(3) - (4)].str), make_str(";\n"));
		;}
    break;

  case 2172:

/* Line 1455 of yacc.c  */
#line 12135 "preproc.y"
    {
			(yyval.str) = cat2_str((yyvsp[(1) - (2)].str), make_str(";"));
		;}
    break;

  case 2173:

/* Line 1455 of yacc.c  */
#line 12140 "preproc.y"
    { (yyval.str) =cat2_str(make_str(":"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2174:

/* Line 1455 of yacc.c  */
#line 12141 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2175:

/* Line 1455 of yacc.c  */
#line 12145 "preproc.y"
    {(yyval.str) = cat2_str ((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2176:

/* Line 1455 of yacc.c  */
#line 12146 "preproc.y"
    {(yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2177:

/* Line 1455 of yacc.c  */
#line 12147 "preproc.y"
    {(yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2178:

/* Line 1455 of yacc.c  */
#line 12150 "preproc.y"
    { (yyval.str) = make_str("extern"); ;}
    break;

  case 2179:

/* Line 1455 of yacc.c  */
#line 12151 "preproc.y"
    { (yyval.str) = make_str("static"); ;}
    break;

  case 2180:

/* Line 1455 of yacc.c  */
#line 12152 "preproc.y"
    { (yyval.str) = make_str("register"); ;}
    break;

  case 2181:

/* Line 1455 of yacc.c  */
#line 12153 "preproc.y"
    { (yyval.str) = make_str("auto"); ;}
    break;

  case 2182:

/* Line 1455 of yacc.c  */
#line 12156 "preproc.y"
    { (yyval.str) = make_str("const"); ;}
    break;

  case 2183:

/* Line 1455 of yacc.c  */
#line 12157 "preproc.y"
    { (yyval.str) = make_str("volatile"); ;}
    break;

  case 2184:

/* Line 1455 of yacc.c  */
#line 12161 "preproc.y"
    {
			(yyval.type).type_enum = (yyvsp[(1) - (1)].type_enum);
			(yyval.type).type_str = mm_strdup(ecpg_type_name((yyvsp[(1) - (1)].type_enum)));
			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");
			(yyval.type).type_sizeof = NULL;
		;}
    break;

  case 2185:

/* Line 1455 of yacc.c  */
#line 12169 "preproc.y"
    {
			(yyval.type).type_str = (yyvsp[(1) - (1)].str);
			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");

			if (strncmp((yyvsp[(1) - (1)].str), "struct", sizeof("struct")-1) == 0)
			{
				(yyval.type).type_enum = ECPGt_struct;
				(yyval.type).type_sizeof = ECPGstruct_sizeof;
			}
			else
			{
				(yyval.type).type_enum = ECPGt_union;
				(yyval.type).type_sizeof = NULL;
			}
		;}
    break;

  case 2186:

/* Line 1455 of yacc.c  */
#line 12186 "preproc.y"
    {
			(yyval.type).type_str = (yyvsp[(1) - (1)].str);
			(yyval.type).type_enum = ECPGt_int;
			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");
			(yyval.type).type_sizeof = NULL;
		;}
    break;

  case 2187:

/* Line 1455 of yacc.c  */
#line 12194 "preproc.y"
    {
			if (strcmp((yyvsp[(1) - (5)].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = make_str("numeric");
			}
			else if (strcmp((yyvsp[(1) - (5)].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = make_str("decimal");
			}
			else
			{
				mmerror(PARSE_ERROR, ET_ERROR, "only data types numeric and decimal have precision/scale argument");
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = make_str("numeric");
			}

			(yyval.type).type_dimension = make_str("-1");
			(yyval.type).type_index = make_str("-1");
			(yyval.type).type_sizeof = NULL;
		;}
    break;

  case 2188:

/* Line 1455 of yacc.c  */
#line 12217 "preproc.y"
    {
			if (strlen((yyvsp[(2) - (2)].str)) != 0 && strcmp ((yyvsp[(1) - (2)].str), "datetime") != 0 && strcmp ((yyvsp[(1) - (2)].str), "interval") != 0)
				mmerror (PARSE_ERROR, ET_ERROR, "interval specification not allowed here");

			/*
			 * Check for type names that the SQL grammar treats as
			 * unreserved keywords
			 */
			if (strcmp((yyvsp[(1) - (2)].str), "varchar") == 0)
			{
				(yyval.type).type_enum = ECPGt_varchar;
				(yyval.type).type_str = EMPTY; /*make_str("varchar");*/
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "float") == 0)
			{
				(yyval.type).type_enum = ECPGt_float;
				(yyval.type).type_str = make_str("float");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "double") == 0)
			{
				(yyval.type).type_enum = ECPGt_double;
				(yyval.type).type_str = make_str("double");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "numeric") == 0)
			{
				(yyval.type).type_enum = ECPGt_numeric;
				(yyval.type).type_str = make_str("numeric");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "decimal") == 0)
			{
				(yyval.type).type_enum = ECPGt_decimal;
				(yyval.type).type_str = make_str("decimal");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "date") == 0)
			{
				(yyval.type).type_enum = ECPGt_date;
				(yyval.type).type_str = make_str("date");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "timestamp") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = make_str("timestamp");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "interval") == 0)
			{
				(yyval.type).type_enum = ECPGt_interval;
				(yyval.type).type_str = make_str("interval");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if (strcmp((yyvsp[(1) - (2)].str), "datetime") == 0)
			{
				(yyval.type).type_enum = ECPGt_timestamp;
				(yyval.type).type_str = make_str("timestamp");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else if ((strcmp((yyvsp[(1) - (2)].str), "string") == 0) && INFORMIX_MODE)
			{
				(yyval.type).type_enum = ECPGt_string;
				(yyval.type).type_str = make_str("char");
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = NULL;
			}
			else
			{
				/* this is for typedef'ed types */
				struct typedefs *this = get_typedef((yyvsp[(1) - (2)].str));

				(yyval.type).type_str = (this->type->type_enum == ECPGt_varchar) ? EMPTY : mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				if (this->type->type_sizeof && strlen(this->type->type_sizeof) != 0)
					(yyval.type).type_sizeof = this->type->type_sizeof;
				else 
					(yyval.type).type_sizeof = cat_str(3, make_str("sizeof("), mm_strdup(this->name), make_str(")"));

				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
			}
		;}
    break;

  case 2189:

/* Line 1455 of yacc.c  */
#line 12323 "preproc.y"
    {
			/* this is for named structs/unions */
			char *name;
			struct typedefs *this;
			bool forward = (forward_name != NULL && strcmp((yyvsp[(1) - (1)].struct_union).symbol, forward_name) == 0 && strcmp((yyvsp[(1) - (1)].struct_union).su, "struct") == 0);

			name = cat2_str((yyvsp[(1) - (1)].struct_union).su, (yyvsp[(1) - (1)].struct_union).symbol);
			/* Do we have a forward definition? */
			if (!forward)
			{
				/* No */

				this = get_typedef(name);
				(yyval.type).type_str = mm_strdup(this->name);
				(yyval.type).type_enum = this->type->type_enum;
				(yyval.type).type_dimension = this->type->type_dimension;
				(yyval.type).type_index = this->type->type_index;
				(yyval.type).type_sizeof = this->type->type_sizeof;
				struct_member_list[struct_level] = ECPGstruct_member_dup(this->struct_member_list);
				free(name);
			}
			else
			{
				(yyval.type).type_str = name;
				(yyval.type).type_enum = ECPGt_long;
				(yyval.type).type_dimension = make_str("-1");
				(yyval.type).type_index = make_str("-1");
				(yyval.type).type_sizeof = make_str("");
				struct_member_list[struct_level] = NULL;
			}
		;}
    break;

  case 2190:

/* Line 1455 of yacc.c  */
#line 12357 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("enum"), (yyvsp[(2) - (3)].str), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2191:

/* Line 1455 of yacc.c  */
#line 12359 "preproc.y"
    { (yyval.str) = cat2_str(make_str("enum"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2192:

/* Line 1455 of yacc.c  */
#line 12361 "preproc.y"
    { (yyval.str) = cat2_str(make_str("enum"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2193:

/* Line 1455 of yacc.c  */
#line 12365 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("{"), (yyvsp[(2) - (3)].str), make_str("}")); ;}
    break;

  case 2194:

/* Line 1455 of yacc.c  */
#line 12368 "preproc.y"
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
			forward_name = mm_strdup((yyvsp[(1) - (1)].struct_union).symbol);
		;}
    break;

  case 2195:

/* Line 1455 of yacc.c  */
#line 12375 "preproc.y"
    {
			struct typedefs *ptr, *this;
			struct this_type su_type;

			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			if (strncmp((yyvsp[(1) - (5)].struct_union).su, "struct", sizeof("struct")-1) == 0)
				su_type.type_enum = ECPGt_struct;
			else
				su_type.type_enum = ECPGt_union;
			su_type.type_str = cat2_str((yyvsp[(1) - (5)].struct_union).su, (yyvsp[(1) - (5)].struct_union).symbol);
			free(forward_name);
			forward_name = NULL;

			/* This is essantially a typedef but needs the keyword struct/union as well.
			 * So we create the typedef for each struct definition with symbol */
			for (ptr = types; ptr != NULL; ptr = ptr->next)
			{
					if (strcmp(su_type.type_str, ptr->name) == 0)
							/* re-definition is a bug */
							mmerror(PARSE_ERROR, ET_ERROR, "type \"%s\" is already defined", su_type.type_str);
			}

			this = (struct typedefs *) mm_alloc(sizeof(struct typedefs));

			/* initial definition */
			this->next = types;
			this->name = mm_strdup(su_type.type_str);
			this->brace_level = braces_open;
			this->type = (struct this_type *) mm_alloc(sizeof(struct this_type));
			this->type->type_enum = su_type.type_enum;
			this->type->type_str = mm_strdup(su_type.type_str);
			this->type->type_dimension = make_str("-1"); /* dimension of array */
			this->type->type_index = make_str("-1");	/* length of string */
			this->type->type_sizeof = ECPGstruct_sizeof;
			this->struct_member_list = struct_member_list[struct_level];

			types = this;
			(yyval.str) = cat_str(4, su_type.type_str, make_str("{"), (yyvsp[(4) - (5)].str), make_str("}"));
		;}
    break;

  case 2196:

/* Line 1455 of yacc.c  */
#line 12418 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2197:

/* Line 1455 of yacc.c  */
#line 12420 "preproc.y"
    {
			struct_member_list[struct_level++] = NULL;
			if (struct_level >= STRUCT_DEPTH)
				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
		;}
    break;

  case 2198:

/* Line 1455 of yacc.c  */
#line 12426 "preproc.y"
    {
			ECPGfree_struct_member(struct_member_list[struct_level]);
			struct_member_list[struct_level] = NULL;
			struct_level--;
			(yyval.str) = cat_str(4, (yyvsp[(1) - (5)].str), make_str("{"), (yyvsp[(4) - (5)].str), make_str("}"));
		;}
    break;

  case 2199:

/* Line 1455 of yacc.c  */
#line 12435 "preproc.y"
    {
			(yyval.struct_union).su = make_str("struct");
			(yyval.struct_union).symbol = (yyvsp[(2) - (2)].str);
			ECPGstruct_sizeof = cat_str(3, make_str("sizeof("), cat2_str(mm_strdup((yyval.struct_union).su), mm_strdup((yyval.struct_union).symbol)), make_str(")"));
		;}
    break;

  case 2200:

/* Line 1455 of yacc.c  */
#line 12441 "preproc.y"
    {
			(yyval.struct_union).su = make_str("union");
			(yyval.struct_union).symbol = (yyvsp[(2) - (2)].str);
		;}
    break;

  case 2201:

/* Line 1455 of yacc.c  */
#line 12448 "preproc.y"
    {
			ECPGstruct_sizeof = make_str(""); /* This must not be NULL to distinguish from simple types. */
			(yyval.str) = make_str("struct");
		;}
    break;

  case 2202:

/* Line 1455 of yacc.c  */
#line 12452 "preproc.y"
    { (yyval.str) = make_str("union"); ;}
    break;

  case 2203:

/* Line 1455 of yacc.c  */
#line 12455 "preproc.y"
    { (yyval.type_enum)=(yyvsp[(1) - (1)].type_enum); ;}
    break;

  case 2204:

/* Line 1455 of yacc.c  */
#line 12456 "preproc.y"
    { (yyval.type_enum)=(yyvsp[(2) - (2)].type_enum); ;}
    break;

  case 2205:

/* Line 1455 of yacc.c  */
#line 12459 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_short; ;}
    break;

  case 2206:

/* Line 1455 of yacc.c  */
#line 12460 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_short; ;}
    break;

  case 2207:

/* Line 1455 of yacc.c  */
#line 12461 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_int; ;}
    break;

  case 2208:

/* Line 1455 of yacc.c  */
#line 12462 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_int; ;}
    break;

  case 2209:

/* Line 1455 of yacc.c  */
#line 12463 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_long; ;}
    break;

  case 2210:

/* Line 1455 of yacc.c  */
#line 12464 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_long; ;}
    break;

  case 2211:

/* Line 1455 of yacc.c  */
#line 12466 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		;}
    break;

  case 2212:

/* Line 1455 of yacc.c  */
#line 12474 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_unsigned_long_long;
#else
			(yyval.type_enum) = ECPGt_unsigned_long;
#endif
		;}
    break;

  case 2213:

/* Line 1455 of yacc.c  */
#line 12481 "preproc.y"
    { (yyval.type_enum) = ECPGt_unsigned_char; ;}
    break;

  case 2214:

/* Line 1455 of yacc.c  */
#line 12484 "preproc.y"
    { (yyval.type_enum) = ECPGt_short; ;}
    break;

  case 2215:

/* Line 1455 of yacc.c  */
#line 12485 "preproc.y"
    { (yyval.type_enum) = ECPGt_short; ;}
    break;

  case 2216:

/* Line 1455 of yacc.c  */
#line 12486 "preproc.y"
    { (yyval.type_enum) = ECPGt_int; ;}
    break;

  case 2217:

/* Line 1455 of yacc.c  */
#line 12487 "preproc.y"
    { (yyval.type_enum) = ECPGt_long; ;}
    break;

  case 2218:

/* Line 1455 of yacc.c  */
#line 12488 "preproc.y"
    { (yyval.type_enum) = ECPGt_long; ;}
    break;

  case 2219:

/* Line 1455 of yacc.c  */
#line 12490 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		;}
    break;

  case 2220:

/* Line 1455 of yacc.c  */
#line 12498 "preproc.y"
    {
#ifdef HAVE_LONG_LONG_INT
			(yyval.type_enum) = ECPGt_long_long;
#else
			(yyval.type_enum) = ECPGt_long;
#endif
		;}
    break;

  case 2221:

/* Line 1455 of yacc.c  */
#line 12505 "preproc.y"
    { (yyval.type_enum) = ECPGt_bool; ;}
    break;

  case 2222:

/* Line 1455 of yacc.c  */
#line 12506 "preproc.y"
    { (yyval.type_enum) = ECPGt_char; ;}
    break;

  case 2223:

/* Line 1455 of yacc.c  */
#line 12507 "preproc.y"
    { (yyval.type_enum) = ECPGt_double; ;}
    break;

  case 2226:

/* Line 1455 of yacc.c  */
#line 12515 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2227:

/* Line 1455 of yacc.c  */
#line 12517 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2228:

/* Line 1455 of yacc.c  */
#line 12521 "preproc.y"
    {
			struct ECPGtype * type;
			char *dimension = (yyvsp[(3) - (5)].index).index1; /* dimension of array */
			char *length = (yyvsp[(3) - (5)].index).index2;    /* length of string */
			char *dim_str;
			char *vcn;

			adjust_array(actual_type[struct_level].type_enum, &dimension, &length, actual_type[struct_level].type_dimension, actual_type[struct_level].type_index, strlen((yyvsp[(1) - (5)].str)), false);

			switch (actual_type[struct_level].type_enum)
			{
				case ECPGt_struct:
				case ECPGt_union:
					if (atoi(dimension) < 0)
						type = ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof);
					else
						type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], actual_type[struct_level].type_enum, actual_type[struct_level].type_str, actual_type[struct_level].type_sizeof), dimension);

					(yyval.str) = cat_str(5, (yyvsp[(1) - (5)].str), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].index).str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					break;

				case ECPGt_varchar:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, varchar_counter), dimension);
					
					if (strcmp(dimension, "0") == 0 || abs(atoi(dimension)) == 1)
							dim_str=make_str("");
					else
							dim_str=cat_str(3, make_str("["), mm_strdup(dimension), make_str("]"));
					/* cannot check for atoi <= 0 because a defined constant will yield 0 here as well */
					if (atoi(length) < 0 || strcmp(length, "0") == 0)
						mmerror(PARSE_ERROR, ET_ERROR, "pointers to varchar are not implemented");

					/* make sure varchar struct name is unique by adding a unique counter to its definition */
					vcn = (char *) mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
					sprintf(vcn, "%d", varchar_counter);
					if (strcmp(dimension, "0") == 0)
						(yyval.str) = cat_str(7, make2_str(make_str(" struct varchar_"), vcn), make_str(" { int len; char arr["), mm_strdup(length), make_str("]; } *"), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					else
						(yyval.str) = cat_str(8, make2_str(make_str(" struct varchar_"), vcn), make_str(" { int len; char arr["), mm_strdup(length), make_str("]; } "), mm_strdup((yyvsp[(2) - (5)].str)), dim_str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					varchar_counter++;
					break;

				case ECPGt_char:
				case ECPGt_unsigned_char:
				case ECPGt_string:
					if (atoi(dimension) == -1)
					{
						int i = strlen((yyvsp[(5) - (5)].str));

						if (atoi(length) == -1 && i > 0) /* char <var>[] = "string" */
						{
							/* if we have an initializer but no string size set, let's use the initializer's length */
							free(length);
							length = mm_alloc(i+sizeof("sizeof()"));
							sprintf(length, "sizeof(%s)", (yyvsp[(5) - (5)].str)+2);
						}
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0);
					}
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, length, 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[(1) - (5)].str), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].index).str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					break;

				default:
					if (atoi(dimension) < 0)
						type = ECPGmake_simple_type(actual_type[struct_level].type_enum, make_str("1"), 0);
					else
						type = ECPGmake_array_type(ECPGmake_simple_type(actual_type[struct_level].type_enum, make_str("1"), 0), dimension);

					(yyval.str) = cat_str(5, (yyvsp[(1) - (5)].str), mm_strdup((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].index).str, (yyvsp[(4) - (5)].str), (yyvsp[(5) - (5)].str));
					break;
			}

			if (struct_level == 0)
				new_variable((yyvsp[(2) - (5)].str), type, braces_open);
			else
				ECPGmake_struct_member((yyvsp[(2) - (5)].str), type, &(struct_member_list[struct_level - 1]));

			free((yyvsp[(2) - (5)].str));
		;}
    break;

  case 2229:

/* Line 1455 of yacc.c  */
#line 12608 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2230:

/* Line 1455 of yacc.c  */
#line 12610 "preproc.y"
    {
			initializer = 1;
			(yyval.str) = cat2_str(make_str("="), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2231:

/* Line 1455 of yacc.c  */
#line 12616 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2232:

/* Line 1455 of yacc.c  */
#line 12617 "preproc.y"
    { (yyval.str) = make_str("*"); ;}
    break;

  case 2233:

/* Line 1455 of yacc.c  */
#line 12618 "preproc.y"
    { (yyval.str) = make_str("**"); ;}
    break;

  case 2234:

/* Line 1455 of yacc.c  */
#line 12625 "preproc.y"
    {
			/* this is only supported for compatibility */
			(yyval.str) = cat_str(3, make_str("/* declare statement"), (yyvsp[(3) - (3)].str), make_str("*/"));
		;}
    break;

  case 2235:

/* Line 1455 of yacc.c  */
#line 12633 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2236:

/* Line 1455 of yacc.c  */
#line 12636 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2237:

/* Line 1455 of yacc.c  */
#line 12637 "preproc.y"
    { (yyval.str) = make_str("\"CURRENT\""); ;}
    break;

  case 2238:

/* Line 1455 of yacc.c  */
#line 12638 "preproc.y"
    { (yyval.str) = make_str("\"ALL\""); ;}
    break;

  case 2239:

/* Line 1455 of yacc.c  */
#line 12639 "preproc.y"
    { (yyval.str) = make_str("\"CURRENT\""); ;}
    break;

  case 2240:

/* Line 1455 of yacc.c  */
#line 12642 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2241:

/* Line 1455 of yacc.c  */
#line 12643 "preproc.y"
    { (yyval.str) = make_str("\"DEFAULT\""); ;}
    break;

  case 2242:

/* Line 1455 of yacc.c  */
#line 12644 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2243:

/* Line 1455 of yacc.c  */
#line 12648 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2244:

/* Line 1455 of yacc.c  */
#line 12650 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2245:

/* Line 1455 of yacc.c  */
#line 12657 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2246:

/* Line 1455 of yacc.c  */
#line 12658 "preproc.y"
    { (yyval.str) = make_str("all"); ;}
    break;

  case 2247:

/* Line 1455 of yacc.c  */
#line 12665 "preproc.y"
    {
			if ((yyvsp[(2) - (3)].str)[0] == ':')
				remove_variable_from_list(&argsinsert, find_variable((yyvsp[(2) - (3)].str) + 1));
			(yyval.str) = (yyvsp[(2) - (3)].str);
		;}
    break;

  case 2248:

/* Line 1455 of yacc.c  */
#line 12672 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2249:

/* Line 1455 of yacc.c  */
#line 12673 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2250:

/* Line 1455 of yacc.c  */
#line 12676 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2251:

/* Line 1455 of yacc.c  */
#line 12677 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2252:

/* Line 1455 of yacc.c  */
#line 12681 "preproc.y"
    {
			add_variable_to_head(&argsinsert, descriptor_variable((yyvsp[(4) - (4)].str),0), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2253:

/* Line 1455 of yacc.c  */
#line 12686 "preproc.y"
    {
			add_variable_to_head(&argsinsert, sqlda_variable((yyvsp[(3) - (3)].str)), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2254:

/* Line 1455 of yacc.c  */
#line 12693 "preproc.y"
    {
			add_variable_to_head(&argsresult, descriptor_variable((yyvsp[(4) - (4)].str),1), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2255:

/* Line 1455 of yacc.c  */
#line 12698 "preproc.y"
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[(3) - (3)].str)), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2256:

/* Line 1455 of yacc.c  */
#line 12705 "preproc.y"
    {
			add_variable_to_head(&argsresult, sqlda_variable((yyvsp[(2) - (2)].str)), &no_indicator);
			(yyval.str) = EMPTY;
		;}
    break;

  case 2259:

/* Line 1455 of yacc.c  */
#line 12714 "preproc.y"
    {
			char *length = mm_alloc(32);

			sprintf(length, "%d", (int) strlen((yyvsp[(1) - (1)].str)));
			add_variable_to_head(&argsinsert, new_variable((yyvsp[(1) - (1)].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0), &no_indicator);
		;}
    break;

  case 2260:

/* Line 1455 of yacc.c  */
#line 12720 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2261:

/* Line 1455 of yacc.c  */
#line 12721 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2262:

/* Line 1455 of yacc.c  */
#line 12724 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2263:

/* Line 1455 of yacc.c  */
#line 12725 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("+"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2264:

/* Line 1455 of yacc.c  */
#line 12726 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("-"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2265:

/* Line 1455 of yacc.c  */
#line 12727 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2266:

/* Line 1455 of yacc.c  */
#line 12728 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("+"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2267:

/* Line 1455 of yacc.c  */
#line 12729 "preproc.y"
    { (yyval.str) = cat_str(2, make_str("-"), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2268:

/* Line 1455 of yacc.c  */
#line 12730 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2269:

/* Line 1455 of yacc.c  */
#line 12731 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2270:

/* Line 1455 of yacc.c  */
#line 12732 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2271:

/* Line 1455 of yacc.c  */
#line 12739 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2272:

/* Line 1455 of yacc.c  */
#line 12746 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);

		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2273:

/* Line 1455 of yacc.c  */
#line 12758 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2274:

/* Line 1455 of yacc.c  */
#line 12764 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		mmerror(PARSE_ERROR, ET_WARNING, "using unsupported DESCRIBE statement");
		(yyval.str) = (char *) mm_alloc(sizeof("1, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "1, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2275:

/* Line 1455 of yacc.c  */
#line 12771 "preproc.y"
    {
		const char *con = connection ? connection : "NULL";
		(yyval.str) = (char *) mm_alloc(sizeof("0, , ") + strlen(con) + strlen((yyvsp[(3) - (4)].str)));
		sprintf((yyval.str), "0, %s, %s", con, (yyvsp[(3) - (4)].str));
	;}
    break;

  case 2276:

/* Line 1455 of yacc.c  */
#line 12778 "preproc.y"
    { (yyval.str) = make_str("output"); ;}
    break;

  case 2277:

/* Line 1455 of yacc.c  */
#line 12779 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2278:

/* Line 1455 of yacc.c  */
#line 12792 "preproc.y"
    {
			add_descriptor((yyvsp[(3) - (3)].str),connection);
			(yyval.str) = (yyvsp[(3) - (3)].str);
		;}
    break;

  case 2279:

/* Line 1455 of yacc.c  */
#line 12803 "preproc.y"
    {
			drop_descriptor((yyvsp[(3) - (3)].str),connection);
			(yyval.str) = (yyvsp[(3) - (3)].str);
		;}
    break;

  case 2280:

/* Line 1455 of yacc.c  */
#line 12814 "preproc.y"
    {  (yyval.str) = (yyvsp[(3) - (4)].str); ;}
    break;

  case 2283:

/* Line 1455 of yacc.c  */
#line 12822 "preproc.y"
    { push_assignment((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].dtype_enum)); ;}
    break;

  case 2284:

/* Line 1455 of yacc.c  */
#line 12827 "preproc.y"
    { (yyval.str) = (yyvsp[(3) - (4)].str); ;}
    break;

  case 2287:

/* Line 1455 of yacc.c  */
#line 12835 "preproc.y"
    {
			push_assignment((yyvsp[(3) - (3)].str), (yyvsp[(1) - (3)].dtype_enum));
		;}
    break;

  case 2288:

/* Line 1455 of yacc.c  */
#line 12841 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

                        sprintf(length, "%d", (int) strlen((yyvsp[(1) - (1)].str)));
                        new_variable((yyvsp[(1) - (1)].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = (yyvsp[(1) - (1)].str);
                ;}
    break;

  case 2289:

/* Line 1455 of yacc.c  */
#line 12848 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2290:

/* Line 1455 of yacc.c  */
#line 12851 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_count; ;}
    break;

  case 2291:

/* Line 1455 of yacc.c  */
#line 12859 "preproc.y"
    {  (yyval.descriptor).str = (yyvsp[(5) - (6)].str); (yyval.descriptor).name = (yyvsp[(3) - (6)].str); ;}
    break;

  case 2294:

/* Line 1455 of yacc.c  */
#line 12866 "preproc.y"
    { push_assignment((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].dtype_enum)); ;}
    break;

  case 2295:

/* Line 1455 of yacc.c  */
#line 12870 "preproc.y"
    {  (yyval.descriptor).str = (yyvsp[(5) - (6)].str); (yyval.descriptor).name = (yyvsp[(3) - (6)].str); ;}
    break;

  case 2298:

/* Line 1455 of yacc.c  */
#line 12878 "preproc.y"
    {
			push_assignment((yyvsp[(3) - (3)].str), (yyvsp[(1) - (3)].dtype_enum));
		;}
    break;

  case 2299:

/* Line 1455 of yacc.c  */
#line 12884 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);

                        sprintf(length, "%d", (int) strlen((yyvsp[(1) - (1)].str)));
                        new_variable((yyvsp[(1) - (1)].str), ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = (yyvsp[(1) - (1)].str);
                ;}
    break;

  case 2300:

/* Line 1455 of yacc.c  */
#line 12891 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2301:

/* Line 1455 of yacc.c  */
#line 12893 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
                        char *var = cat2_str(make_str("-"), (yyvsp[(2) - (2)].str));

                        sprintf(length, "%d", (int) strlen(var));
                        new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = var;
                ;}
    break;

  case 2302:

/* Line 1455 of yacc.c  */
#line 12902 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
                        char *var = cat2_str(make_str("-"), (yyvsp[(2) - (2)].str));

                        sprintf(length, "%d", (int) strlen(var));
                        new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = var;
                ;}
    break;

  case 2303:

/* Line 1455 of yacc.c  */
#line 12911 "preproc.y"
    {
                        char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
                        char *var = (yyvsp[(1) - (1)].str) + 1;

                        var[strlen(var) - 1] = '\0';
                        sprintf(length, "%d", (int) strlen(var));
                        new_variable(var, ECPGmake_simple_type(ECPGt_const, length, 0), 0);
                        (yyval.str) = var;
                ;}
    break;

  case 2304:

/* Line 1455 of yacc.c  */
#line 12922 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_cardinality; ;}
    break;

  case 2305:

/* Line 1455 of yacc.c  */
#line 12923 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_data; ;}
    break;

  case 2306:

/* Line 1455 of yacc.c  */
#line 12924 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_di_code; ;}
    break;

  case 2307:

/* Line 1455 of yacc.c  */
#line 12925 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_di_precision; ;}
    break;

  case 2308:

/* Line 1455 of yacc.c  */
#line 12926 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_indicator; ;}
    break;

  case 2309:

/* Line 1455 of yacc.c  */
#line 12927 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_key_member; ;}
    break;

  case 2310:

/* Line 1455 of yacc.c  */
#line 12928 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_length; ;}
    break;

  case 2311:

/* Line 1455 of yacc.c  */
#line 12929 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_name; ;}
    break;

  case 2312:

/* Line 1455 of yacc.c  */
#line 12930 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_nullable; ;}
    break;

  case 2313:

/* Line 1455 of yacc.c  */
#line 12931 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_octet; ;}
    break;

  case 2314:

/* Line 1455 of yacc.c  */
#line 12932 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_precision; ;}
    break;

  case 2315:

/* Line 1455 of yacc.c  */
#line 12933 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_length; ;}
    break;

  case 2316:

/* Line 1455 of yacc.c  */
#line 12934 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_ret_octet; ;}
    break;

  case 2317:

/* Line 1455 of yacc.c  */
#line 12935 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_scale; ;}
    break;

  case 2318:

/* Line 1455 of yacc.c  */
#line 12936 "preproc.y"
    { (yyval.dtype_enum) = ECPGd_type; ;}
    break;

  case 2319:

/* Line 1455 of yacc.c  */
#line 12943 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2320:

/* Line 1455 of yacc.c  */
#line 12944 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2321:

/* Line 1455 of yacc.c  */
#line 12947 "preproc.y"
    { (yyval.str) = make_str("on"); ;}
    break;

  case 2322:

/* Line 1455 of yacc.c  */
#line 12948 "preproc.y"
    { (yyval.str) = make_str("off"); ;}
    break;

  case 2323:

/* Line 1455 of yacc.c  */
#line 12955 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2324:

/* Line 1455 of yacc.c  */
#line 12956 "preproc.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 2325:

/* Line 1455 of yacc.c  */
#line 12957 "preproc.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 2326:

/* Line 1455 of yacc.c  */
#line 12964 "preproc.y"
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		;}
    break;

  case 2327:

/* Line 1455 of yacc.c  */
#line 12970 "preproc.y"
    {
			add_typedef((yyvsp[(3) - (7)].str), (yyvsp[(6) - (7)].index).index1, (yyvsp[(6) - (7)].index).index2, (yyvsp[(5) - (7)].type).type_enum, (yyvsp[(5) - (7)].type).type_dimension, (yyvsp[(5) - (7)].type).type_index, initializer, *(yyvsp[(7) - (7)].str) ? 1 : 0);

			if (auto_create_c == false)
				(yyval.str) = cat_str(7, make_str("/* exec sql type"), mm_strdup((yyvsp[(3) - (7)].str)), make_str("is"), mm_strdup((yyvsp[(5) - (7)].type).type_str), mm_strdup((yyvsp[(6) - (7)].index).str), (yyvsp[(7) - (7)].str), make_str("*/"));
			else
				(yyval.str) = cat_str(6, make_str("typedef "), mm_strdup((yyvsp[(5) - (7)].type).type_str), *(yyvsp[(7) - (7)].str)?make_str("*"):make_str(""), mm_strdup((yyvsp[(6) - (7)].index).str), mm_strdup((yyvsp[(3) - (7)].str)), make_str(";"));
		;}
    break;

  case 2328:

/* Line 1455 of yacc.c  */
#line 12980 "preproc.y"
    { (yyval.str) = make_str("reference"); ;}
    break;

  case 2329:

/* Line 1455 of yacc.c  */
#line 12981 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2330:

/* Line 1455 of yacc.c  */
#line 12988 "preproc.y"
    {
			/* reset this variable so we see if there was */
			/* an initializer specified */
			initializer = 0;
		;}
    break;

  case 2331:

/* Line 1455 of yacc.c  */
#line 12994 "preproc.y"
    {
			struct variable *p = find_variable((yyvsp[(3) - (7)].str));
			char *dimension = (yyvsp[(6) - (7)].index).index1;
			char *length = (yyvsp[(6) - (7)].index).index2;
			struct ECPGtype * type;

			if (((yyvsp[(5) - (7)].type).type_enum == ECPGt_struct ||
				 (yyvsp[(5) - (7)].type).type_enum == ECPGt_union) &&
				initializer == 1)
				mmerror(PARSE_ERROR, ET_ERROR, "initializer not allowed in EXEC SQL VAR command");
			else
			{
				adjust_array((yyvsp[(5) - (7)].type).type_enum, &dimension, &length, (yyvsp[(5) - (7)].type).type_dimension, (yyvsp[(5) - (7)].type).type_index, *(yyvsp[(7) - (7)].str)?1:0, false);

				switch ((yyvsp[(5) - (7)].type).type_enum)
				{
					case ECPGt_struct:
					case ECPGt_union:
						if (atoi(dimension) < 0)
							type = ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[(5) - (7)].type).type_enum, (yyvsp[(5) - (7)].type).type_str, (yyvsp[(5) - (7)].type).type_sizeof);
						else
							type = ECPGmake_array_type(ECPGmake_struct_type(struct_member_list[struct_level], (yyvsp[(5) - (7)].type).type_enum, (yyvsp[(5) - (7)].type).type_str, (yyvsp[(5) - (7)].type).type_sizeof), dimension);
						break;

					case ECPGt_varchar:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0), dimension);
						break;

					case ECPGt_char:
					case ECPGt_unsigned_char:
					case ECPGt_string:
						if (atoi(dimension) == -1)
							type = ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, length, 0), dimension);
						break;

					default:
						if (atoi(length) >= 0)
							mmerror(PARSE_ERROR, ET_ERROR, "multidimensional arrays for simple data types are not supported");

						if (atoi(dimension) < 0)
							type = ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, make_str("1"), 0);
						else
							type = ECPGmake_array_type(ECPGmake_simple_type((yyvsp[(5) - (7)].type).type_enum, make_str("1"), 0), dimension);
						break;
				}

				ECPGfree_type(p->type);
				p->type = type;
			}

			(yyval.str) = cat_str(7, make_str("/* exec sql var"), mm_strdup((yyvsp[(3) - (7)].str)), make_str("is"), mm_strdup((yyvsp[(5) - (7)].type).type_str), mm_strdup((yyvsp[(6) - (7)].index).str), (yyvsp[(7) - (7)].str), make_str("*/"));
		;}
    break;

  case 2332:

/* Line 1455 of yacc.c  */
#line 13058 "preproc.y"
    {
			when_error.code = (yyvsp[(3) - (3)].action).code;
			when_error.command = (yyvsp[(3) - (3)].action).command;
			(yyval.str) = cat_str(3, make_str("/* exec sql whenever sqlerror "), (yyvsp[(3) - (3)].action).str, make_str("; */"));
		;}
    break;

  case 2333:

/* Line 1455 of yacc.c  */
#line 13064 "preproc.y"
    {
			when_nf.code = (yyvsp[(4) - (4)].action).code;
			when_nf.command = (yyvsp[(4) - (4)].action).command;
			(yyval.str) = cat_str(3, make_str("/* exec sql whenever not found "), (yyvsp[(4) - (4)].action).str, make_str("; */"));
		;}
    break;

  case 2334:

/* Line 1455 of yacc.c  */
#line 13070 "preproc.y"
    {
			when_warn.code = (yyvsp[(3) - (3)].action).code;
			when_warn.command = (yyvsp[(3) - (3)].action).command;
			(yyval.str) = cat_str(3, make_str("/* exec sql whenever sql_warning "), (yyvsp[(3) - (3)].action).str, make_str("; */"));
		;}
    break;

  case 2335:

/* Line 1455 of yacc.c  */
#line 13078 "preproc.y"
    {
			(yyval.action).code = W_NOTHING;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("continue");
		;}
    break;

  case 2336:

/* Line 1455 of yacc.c  */
#line 13084 "preproc.y"
    {
			(yyval.action).code = W_SQLPRINT;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("sqlprint");
		;}
    break;

  case 2337:

/* Line 1455 of yacc.c  */
#line 13090 "preproc.y"
    {
			(yyval.action).code = W_STOP;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("stop");
		;}
    break;

  case 2338:

/* Line 1455 of yacc.c  */
#line 13096 "preproc.y"
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = strdup((yyvsp[(2) - (2)].str));
			(yyval.action).str = cat2_str(make_str("goto "), (yyvsp[(2) - (2)].str));
		;}
    break;

  case 2339:

/* Line 1455 of yacc.c  */
#line 13102 "preproc.y"
    {
			(yyval.action).code = W_GOTO;
			(yyval.action).command = strdup((yyvsp[(3) - (3)].str));
			(yyval.action).str = cat2_str(make_str("goto "), (yyvsp[(3) - (3)].str));
		;}
    break;

  case 2340:

/* Line 1455 of yacc.c  */
#line 13108 "preproc.y"
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[(2) - (5)].str), make_str("("), (yyvsp[(4) - (5)].str), make_str(")"));
			(yyval.action).str = cat2_str(make_str("do"), mm_strdup((yyval.action).command));
		;}
    break;

  case 2341:

/* Line 1455 of yacc.c  */
#line 13114 "preproc.y"
    {
			(yyval.action).code = W_BREAK;
			(yyval.action).command = NULL;
			(yyval.action).str = make_str("break");
		;}
    break;

  case 2342:

/* Line 1455 of yacc.c  */
#line 13120 "preproc.y"
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat_str(4, (yyvsp[(2) - (5)].str), make_str("("), (yyvsp[(4) - (5)].str), make_str(")"));
			(yyval.action).str = cat2_str(make_str("call"), mm_strdup((yyval.action).command));
		;}
    break;

  case 2343:

/* Line 1455 of yacc.c  */
#line 13126 "preproc.y"
    {
			(yyval.action).code = W_DO;
			(yyval.action).command = cat2_str((yyvsp[(2) - (2)].str), make_str("()"));
			(yyval.action).str = cat2_str(make_str("call"), mm_strdup((yyval.action).command));
		;}
    break;

  case 2344:

/* Line 1455 of yacc.c  */
#line 13136 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2345:

/* Line 1455 of yacc.c  */
#line 13137 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2346:

/* Line 1455 of yacc.c  */
#line 13140 "preproc.y"
    { (yyval.str) = make_str("break"); ;}
    break;

  case 2347:

/* Line 1455 of yacc.c  */
#line 13141 "preproc.y"
    { (yyval.str) = make_str("call"); ;}
    break;

  case 2348:

/* Line 1455 of yacc.c  */
#line 13142 "preproc.y"
    { (yyval.str) = make_str("cardinality"); ;}
    break;

  case 2349:

/* Line 1455 of yacc.c  */
#line 13143 "preproc.y"
    { (yyval.str) = make_str("count"); ;}
    break;

  case 2350:

/* Line 1455 of yacc.c  */
#line 13144 "preproc.y"
    { (yyval.str) = make_str("datetime_interval_code"); ;}
    break;

  case 2351:

/* Line 1455 of yacc.c  */
#line 13145 "preproc.y"
    { (yyval.str) = make_str("datetime_interval_precision"); ;}
    break;

  case 2352:

/* Line 1455 of yacc.c  */
#line 13146 "preproc.y"
    { (yyval.str) = make_str("found"); ;}
    break;

  case 2353:

/* Line 1455 of yacc.c  */
#line 13147 "preproc.y"
    { (yyval.str) = make_str("go"); ;}
    break;

  case 2354:

/* Line 1455 of yacc.c  */
#line 13148 "preproc.y"
    { (yyval.str) = make_str("goto"); ;}
    break;

  case 2355:

/* Line 1455 of yacc.c  */
#line 13149 "preproc.y"
    { (yyval.str) = make_str("identified"); ;}
    break;

  case 2356:

/* Line 1455 of yacc.c  */
#line 13150 "preproc.y"
    { (yyval.str) = make_str("indicator"); ;}
    break;

  case 2357:

/* Line 1455 of yacc.c  */
#line 13151 "preproc.y"
    { (yyval.str) = make_str("key_member"); ;}
    break;

  case 2358:

/* Line 1455 of yacc.c  */
#line 13152 "preproc.y"
    { (yyval.str) = make_str("length"); ;}
    break;

  case 2359:

/* Line 1455 of yacc.c  */
#line 13153 "preproc.y"
    { (yyval.str) = make_str("nullable"); ;}
    break;

  case 2360:

/* Line 1455 of yacc.c  */
#line 13154 "preproc.y"
    { (yyval.str) = make_str("octet_length"); ;}
    break;

  case 2361:

/* Line 1455 of yacc.c  */
#line 13155 "preproc.y"
    { (yyval.str) = make_str("returned_length"); ;}
    break;

  case 2362:

/* Line 1455 of yacc.c  */
#line 13156 "preproc.y"
    { (yyval.str) = make_str("returned_octet_length"); ;}
    break;

  case 2363:

/* Line 1455 of yacc.c  */
#line 13157 "preproc.y"
    { (yyval.str) = make_str("scale"); ;}
    break;

  case 2364:

/* Line 1455 of yacc.c  */
#line 13158 "preproc.y"
    { (yyval.str) = make_str("section"); ;}
    break;

  case 2365:

/* Line 1455 of yacc.c  */
#line 13159 "preproc.y"
    { (yyval.str) = make_str("sql"); ;}
    break;

  case 2366:

/* Line 1455 of yacc.c  */
#line 13160 "preproc.y"
    { (yyval.str) = make_str("sqlerror"); ;}
    break;

  case 2367:

/* Line 1455 of yacc.c  */
#line 13161 "preproc.y"
    { (yyval.str) = make_str("sqlprint"); ;}
    break;

  case 2368:

/* Line 1455 of yacc.c  */
#line 13162 "preproc.y"
    { (yyval.str) = make_str("sqlwarning"); ;}
    break;

  case 2369:

/* Line 1455 of yacc.c  */
#line 13163 "preproc.y"
    { (yyval.str) = make_str("stop"); ;}
    break;

  case 2370:

/* Line 1455 of yacc.c  */
#line 13166 "preproc.y"
    { (yyval.str) = make_str("connect"); ;}
    break;

  case 2371:

/* Line 1455 of yacc.c  */
#line 13167 "preproc.y"
    { (yyval.str) = make_str("describe"); ;}
    break;

  case 2372:

/* Line 1455 of yacc.c  */
#line 13168 "preproc.y"
    { (yyval.str) = make_str("disconnect"); ;}
    break;

  case 2373:

/* Line 1455 of yacc.c  */
#line 13169 "preproc.y"
    { (yyval.str) = make_str("open"); ;}
    break;

  case 2374:

/* Line 1455 of yacc.c  */
#line 13170 "preproc.y"
    { (yyval.str) = make_str("var"); ;}
    break;

  case 2375:

/* Line 1455 of yacc.c  */
#line 13171 "preproc.y"
    { (yyval.str) = make_str("whenever"); ;}
    break;

  case 2376:

/* Line 1455 of yacc.c  */
#line 13175 "preproc.y"
    { (yyval.str) = make_str("bool"); ;}
    break;

  case 2377:

/* Line 1455 of yacc.c  */
#line 13176 "preproc.y"
    { (yyval.str) = make_str("long"); ;}
    break;

  case 2378:

/* Line 1455 of yacc.c  */
#line 13177 "preproc.y"
    { (yyval.str) = make_str("output"); ;}
    break;

  case 2379:

/* Line 1455 of yacc.c  */
#line 13178 "preproc.y"
    { (yyval.str) = make_str("short"); ;}
    break;

  case 2380:

/* Line 1455 of yacc.c  */
#line 13179 "preproc.y"
    { (yyval.str) = make_str("struct"); ;}
    break;

  case 2381:

/* Line 1455 of yacc.c  */
#line 13180 "preproc.y"
    { (yyval.str) = make_str("signed"); ;}
    break;

  case 2382:

/* Line 1455 of yacc.c  */
#line 13181 "preproc.y"
    { (yyval.str) = make_str("unsigned"); ;}
    break;

  case 2383:

/* Line 1455 of yacc.c  */
#line 13184 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2384:

/* Line 1455 of yacc.c  */
#line 13187 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2385:

/* Line 1455 of yacc.c  */
#line 13188 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2386:

/* Line 1455 of yacc.c  */
#line 13189 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2387:

/* Line 1455 of yacc.c  */
#line 13190 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2388:

/* Line 1455 of yacc.c  */
#line 13191 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2389:

/* Line 1455 of yacc.c  */
#line 13192 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2390:

/* Line 1455 of yacc.c  */
#line 13193 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2391:

/* Line 1455 of yacc.c  */
#line 13194 "preproc.y"
    { (yyval.str) = make_str("values"); ;}
    break;

  case 2392:

/* Line 1455 of yacc.c  */
#line 13207 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2393:

/* Line 1455 of yacc.c  */
#line 13208 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2394:

/* Line 1455 of yacc.c  */
#line 13209 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2395:

/* Line 1455 of yacc.c  */
#line 13210 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2396:

/* Line 1455 of yacc.c  */
#line 13211 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2397:

/* Line 1455 of yacc.c  */
#line 13212 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2398:

/* Line 1455 of yacc.c  */
#line 13213 "preproc.y"
    { (yyval.str) = make_str("values"); ;}
    break;

  case 2399:

/* Line 1455 of yacc.c  */
#line 13218 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2400:

/* Line 1455 of yacc.c  */
#line 13219 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2401:

/* Line 1455 of yacc.c  */
#line 13220 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2402:

/* Line 1455 of yacc.c  */
#line 13221 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2403:

/* Line 1455 of yacc.c  */
#line 13222 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2404:

/* Line 1455 of yacc.c  */
#line 13223 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2405:

/* Line 1455 of yacc.c  */
#line 13229 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2406:

/* Line 1455 of yacc.c  */
#line 13230 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2407:

/* Line 1455 of yacc.c  */
#line 13231 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2408:

/* Line 1455 of yacc.c  */
#line 13232 "preproc.y"
    { (yyval.str) = make_str("current"); ;}
    break;

  case 2409:

/* Line 1455 of yacc.c  */
#line 13233 "preproc.y"
    { (yyval.str) = make_str("input"); ;}
    break;

  case 2410:

/* Line 1455 of yacc.c  */
#line 13234 "preproc.y"
    { (yyval.str) = make_str("int"); ;}
    break;

  case 2411:

/* Line 1455 of yacc.c  */
#line 13235 "preproc.y"
    { (yyval.str) = make_str("to"); ;}
    break;

  case 2412:

/* Line 1455 of yacc.c  */
#line 13236 "preproc.y"
    { (yyval.str) = make_str("union"); ;}
    break;

  case 2413:

/* Line 1455 of yacc.c  */
#line 13237 "preproc.y"
    { (yyval.str) = make_str("values"); ;}
    break;

  case 2414:

/* Line 1455 of yacc.c  */
#line 13238 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2415:

/* Line 1455 of yacc.c  */
#line 13239 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2416:

/* Line 1455 of yacc.c  */
#line 13242 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2417:

/* Line 1455 of yacc.c  */
#line 13243 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2418:

/* Line 1455 of yacc.c  */
#line 13244 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2419:

/* Line 1455 of yacc.c  */
#line 13245 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2420:

/* Line 1455 of yacc.c  */
#line 13246 "preproc.y"
    { (yyval.str) = make_str("connection"); ;}
    break;

  case 2421:

/* Line 1455 of yacc.c  */
#line 13249 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2422:

/* Line 1455 of yacc.c  */
#line 13250 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2423:

/* Line 1455 of yacc.c  */
#line 13251 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2424:

/* Line 1455 of yacc.c  */
#line 13252 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2425:

/* Line 1455 of yacc.c  */
#line 13255 "preproc.y"
    { (yyval.str) = make_str("auto"); ;}
    break;

  case 2426:

/* Line 1455 of yacc.c  */
#line 13256 "preproc.y"
    { (yyval.str) = make_str("const"); ;}
    break;

  case 2427:

/* Line 1455 of yacc.c  */
#line 13257 "preproc.y"
    { (yyval.str) = make_str("extern"); ;}
    break;

  case 2428:

/* Line 1455 of yacc.c  */
#line 13258 "preproc.y"
    { (yyval.str) = make_str("register"); ;}
    break;

  case 2429:

/* Line 1455 of yacc.c  */
#line 13259 "preproc.y"
    { (yyval.str) = make_str("static"); ;}
    break;

  case 2430:

/* Line 1455 of yacc.c  */
#line 13260 "preproc.y"
    { (yyval.str) = make_str("typedef"); ;}
    break;

  case 2431:

/* Line 1455 of yacc.c  */
#line 13261 "preproc.y"
    { (yyval.str) = make_str("volatile"); ;}
    break;

  case 2432:

/* Line 1455 of yacc.c  */
#line 13278 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2433:

/* Line 1455 of yacc.c  */
#line 13279 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2434:

/* Line 1455 of yacc.c  */
#line 13280 "preproc.y"
    { (yyval.str) = make_str("connection"); ;}
    break;

  case 2435:

/* Line 1455 of yacc.c  */
#line 13283 "preproc.y"
    { (yyval.str) = make_str("day"); ;}
    break;

  case 2436:

/* Line 1455 of yacc.c  */
#line 13284 "preproc.y"
    { (yyval.str) = make_str("hour"); ;}
    break;

  case 2437:

/* Line 1455 of yacc.c  */
#line 13285 "preproc.y"
    { (yyval.str) = make_str("minute"); ;}
    break;

  case 2438:

/* Line 1455 of yacc.c  */
#line 13286 "preproc.y"
    { (yyval.str) = make_str("month"); ;}
    break;

  case 2439:

/* Line 1455 of yacc.c  */
#line 13287 "preproc.y"
    { (yyval.str) = make_str("second"); ;}
    break;

  case 2440:

/* Line 1455 of yacc.c  */
#line 13288 "preproc.y"
    { (yyval.str) = make_str("year"); ;}
    break;

  case 2443:

/* Line 1455 of yacc.c  */
#line 13295 "preproc.y"
    {
				reset_variables();
				pacounter = 1;
			;}
    break;

  case 2444:

/* Line 1455 of yacc.c  */
#line 13301 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2445:

/* Line 1455 of yacc.c  */
#line 13302 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2446:

/* Line 1455 of yacc.c  */
#line 13306 "preproc.y"
    { add_variable_to_head(&argsresult, find_variable((yyvsp[(1) - (2)].str)), find_variable((yyvsp[(2) - (2)].str))); ;}
    break;

  case 2447:

/* Line 1455 of yacc.c  */
#line 13308 "preproc.y"
    { add_variable_to_head(&argsresult, find_variable((yyvsp[(1) - (1)].str)), &no_indicator); ;}
    break;

  case 2448:

/* Line 1455 of yacc.c  */
#line 13313 "preproc.y"
    {
			if (find_variable((yyvsp[(2) - (2)].str))->type->type == ECPGt_array)
				mmerror(PARSE_ERROR, ET_ERROR, "arrays of indicators are not allowed on input");

			add_variable_to_head(&argsinsert, find_variable((yyvsp[(1) - (2)].str)), find_variable((yyvsp[(2) - (2)].str)));
			(yyval.str) = create_questionmarks((yyvsp[(1) - (2)].str), false);
		;}
    break;

  case 2449:

/* Line 1455 of yacc.c  */
#line 13323 "preproc.y"
    {
			char *ptr = strstr((yyvsp[(1) - (1)].str), ".arr");

			if (ptr) /* varchar, we need the struct name here, not the struct element */
				*ptr = '\0';
			add_variable_to_head(&argsinsert, find_variable((yyvsp[(1) - (1)].str)), &no_indicator);
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2450:

/* Line 1455 of yacc.c  */
#line 13334 "preproc.y"
    {
			add_variable_to_head(&argsinsert, find_variable((yyvsp[(1) - (1)].str)), &no_indicator);
			(yyval.str) = create_questionmarks((yyvsp[(1) - (1)].str), false);
		;}
    break;

  case 2451:

/* Line 1455 of yacc.c  */
#line 13340 "preproc.y"
    { check_indicator((find_variable((yyvsp[(1) - (1)].str)))->type); (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2452:

/* Line 1455 of yacc.c  */
#line 13341 "preproc.y"
    { check_indicator((find_variable((yyvsp[(2) - (2)].str)))->type); (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2453:

/* Line 1455 of yacc.c  */
#line 13342 "preproc.y"
    { check_indicator((find_variable((yyvsp[(2) - (2)].str)))->type); (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2454:

/* Line 1455 of yacc.c  */
#line 13346 "preproc.y"
    {
			/* As long as multidimensional arrays are not implemented we have to check for those here */
			char *ptr = (yyvsp[(1) - (1)].str);
			int brace_open=0, brace = false;

			for (; *ptr; ptr++)
			{
				switch (*ptr)
				{
					case '[':
							if (brace)
								mmerror(PARSE_ERROR, ET_FATAL, "multidimensional arrays for simple data types are not supported");
							brace_open++;
							break;
					case ']':
							brace_open--;
							if (brace_open == 0)
								brace = true;
							break;
					case '\t':
					case ' ':
							break;
					default:
							if (brace_open == 0)
								brace = false;
							break;
				}
			}
			(yyval.str) = (yyvsp[(1) - (1)].str);
		;}
    break;

  case 2455:

/* Line 1455 of yacc.c  */
#line 13378 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2456:

/* Line 1455 of yacc.c  */
#line 13380 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2457:

/* Line 1455 of yacc.c  */
#line 13382 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2458:

/* Line 1455 of yacc.c  */
#line 13386 "preproc.y"
    {
			/* could have been input as '' or $$ */
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 3);
			(yyval.str)[0]='\'';
			strcpy((yyval.str)+1, (yyvsp[(1) - (1)].str));
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+1]='\'';
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+2]='\0';
			free((yyvsp[(1) - (1)].str));
		;}
    break;

  case 2459:

/* Line 1455 of yacc.c  */
#line 13396 "preproc.y"
    {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 4);
			(yyval.str)[0]='E';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[(1) - (1)].str));
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+3]='\0';
			free((yyvsp[(1) - (1)].str));
		;}
    break;

  case 2460:

/* Line 1455 of yacc.c  */
#line 13406 "preproc.y"
    {
			(yyval.str) = (char *)mm_alloc(strlen((yyvsp[(1) - (1)].str)) + 4);
			(yyval.str)[0]='N';
			(yyval.str)[1]='\'';
			strcpy((yyval.str)+2, (yyvsp[(1) - (1)].str));
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+2]='\'';
			(yyval.str)[strlen((yyvsp[(1) - (1)].str))+3]='\0';
			free((yyvsp[(1) - (1)].str));
		;}
    break;

  case 2461:

/* Line 1455 of yacc.c  */
#line 13415 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2462:

/* Line 1455 of yacc.c  */
#line 13416 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2463:

/* Line 1455 of yacc.c  */
#line 13419 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2464:

/* Line 1455 of yacc.c  */
#line 13421 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2465:

/* Line 1455 of yacc.c  */
#line 13422 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2466:

/* Line 1455 of yacc.c  */
#line 13423 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2467:

/* Line 1455 of yacc.c  */
#line 13427 "preproc.y"
    { (yyval.str) = make3_str(make_str("\""), (yyvsp[(1) - (1)].str), make_str("\"")); ;}
    break;

  case 2468:

/* Line 1455 of yacc.c  */
#line 13429 "preproc.y"
    { (yyval.str) = make3_str(make_str("("), (yyvsp[(1) - (1)].str), make_str(")")); ;}
    break;

  case 2469:

/* Line 1455 of yacc.c  */
#line 13436 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2470:

/* Line 1455 of yacc.c  */
#line 13437 "preproc.y"
    { (yyval.str) = make_str("()"); ;}
    break;

  case 2471:

/* Line 1455 of yacc.c  */
#line 13439 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("("), (yyvsp[(2) - (3)].str), make_str(")")); ;}
    break;

  case 2472:

/* Line 1455 of yacc.c  */
#line 13442 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2473:

/* Line 1455 of yacc.c  */
#line 13444 "preproc.y"
    { (yyval.str) = cat2_str((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str)); ;}
    break;

  case 2474:

/* Line 1455 of yacc.c  */
#line 13447 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2475:

/* Line 1455 of yacc.c  */
#line 13448 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str(","), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2476:

/* Line 1455 of yacc.c  */
#line 13451 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2477:

/* Line 1455 of yacc.c  */
#line 13452 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("{"), (yyvsp[(2) - (3)].str), make_str("}")); ;}
    break;

  case 2478:

/* Line 1455 of yacc.c  */
#line 13455 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2479:

/* Line 1455 of yacc.c  */
#line 13456 "preproc.y"
    { (yyval.str) = make_str("("); ;}
    break;

  case 2480:

/* Line 1455 of yacc.c  */
#line 13457 "preproc.y"
    { (yyval.str) = make_str(")"); ;}
    break;

  case 2481:

/* Line 1455 of yacc.c  */
#line 13458 "preproc.y"
    { (yyval.str) = make_str(","); ;}
    break;

  case 2482:

/* Line 1455 of yacc.c  */
#line 13459 "preproc.y"
    { (yyval.str) = make_str(";"); ;}
    break;

  case 2483:

/* Line 1455 of yacc.c  */
#line 13462 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2484:

/* Line 1455 of yacc.c  */
#line 13463 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2485:

/* Line 1455 of yacc.c  */
#line 13464 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2486:

/* Line 1455 of yacc.c  */
#line 13465 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2487:

/* Line 1455 of yacc.c  */
#line 13466 "preproc.y"
    { (yyval.str) = make_str("*"); ;}
    break;

  case 2488:

/* Line 1455 of yacc.c  */
#line 13467 "preproc.y"
    { (yyval.str) = make_str("+"); ;}
    break;

  case 2489:

/* Line 1455 of yacc.c  */
#line 13468 "preproc.y"
    { (yyval.str) = make_str("-"); ;}
    break;

  case 2490:

/* Line 1455 of yacc.c  */
#line 13469 "preproc.y"
    { (yyval.str) = make_str("/"); ;}
    break;

  case 2491:

/* Line 1455 of yacc.c  */
#line 13470 "preproc.y"
    { (yyval.str) = make_str("%"); ;}
    break;

  case 2492:

/* Line 1455 of yacc.c  */
#line 13471 "preproc.y"
    { (yyval.str) = make_str("NULL"); ;}
    break;

  case 2493:

/* Line 1455 of yacc.c  */
#line 13472 "preproc.y"
    { (yyval.str) = make_str("+="); ;}
    break;

  case 2494:

/* Line 1455 of yacc.c  */
#line 13473 "preproc.y"
    { (yyval.str) = make_str("&&"); ;}
    break;

  case 2495:

/* Line 1455 of yacc.c  */
#line 13474 "preproc.y"
    { (yyval.str) = make_name(); ;}
    break;

  case 2496:

/* Line 1455 of yacc.c  */
#line 13475 "preproc.y"
    { (yyval.str) = make_str("auto"); ;}
    break;

  case 2497:

/* Line 1455 of yacc.c  */
#line 13476 "preproc.y"
    { (yyval.str) = make_str("const"); ;}
    break;

  case 2498:

/* Line 1455 of yacc.c  */
#line 13477 "preproc.y"
    { (yyval.str) = make_str("--"); ;}
    break;

  case 2499:

/* Line 1455 of yacc.c  */
#line 13478 "preproc.y"
    { (yyval.str) = make_str("/="); ;}
    break;

  case 2500:

/* Line 1455 of yacc.c  */
#line 13479 "preproc.y"
    { (yyval.str) = make_str(".*"); ;}
    break;

  case 2501:

/* Line 1455 of yacc.c  */
#line 13480 "preproc.y"
    { (yyval.str) = make_str("=="); ;}
    break;

  case 2502:

/* Line 1455 of yacc.c  */
#line 13481 "preproc.y"
    { (yyval.str) = make_str("extern"); ;}
    break;

  case 2503:

/* Line 1455 of yacc.c  */
#line 13482 "preproc.y"
    { (yyval.str) = make_str("++"); ;}
    break;

  case 2504:

/* Line 1455 of yacc.c  */
#line 13483 "preproc.y"
    { (yyval.str) = make_str("<<"); ;}
    break;

  case 2505:

/* Line 1455 of yacc.c  */
#line 13484 "preproc.y"
    { (yyval.str) = make_str("->"); ;}
    break;

  case 2506:

/* Line 1455 of yacc.c  */
#line 13485 "preproc.y"
    { (yyval.str) = make_str("->*"); ;}
    break;

  case 2507:

/* Line 1455 of yacc.c  */
#line 13486 "preproc.y"
    { (yyval.str) = make_str("%="); ;}
    break;

  case 2508:

/* Line 1455 of yacc.c  */
#line 13487 "preproc.y"
    { (yyval.str) = make_str("*="); ;}
    break;

  case 2509:

/* Line 1455 of yacc.c  */
#line 13488 "preproc.y"
    { (yyval.str) = make_str("!="); ;}
    break;

  case 2510:

/* Line 1455 of yacc.c  */
#line 13489 "preproc.y"
    { (yyval.str) = make_str("||"); ;}
    break;

  case 2511:

/* Line 1455 of yacc.c  */
#line 13490 "preproc.y"
    { (yyval.str) = make_str("register"); ;}
    break;

  case 2512:

/* Line 1455 of yacc.c  */
#line 13491 "preproc.y"
    { (yyval.str) = make_str(">>"); ;}
    break;

  case 2513:

/* Line 1455 of yacc.c  */
#line 13492 "preproc.y"
    { (yyval.str) = make_str("static"); ;}
    break;

  case 2514:

/* Line 1455 of yacc.c  */
#line 13493 "preproc.y"
    { (yyval.str) = make_str("-="); ;}
    break;

  case 2515:

/* Line 1455 of yacc.c  */
#line 13494 "preproc.y"
    { (yyval.str) = make_str("typedef"); ;}
    break;

  case 2516:

/* Line 1455 of yacc.c  */
#line 13495 "preproc.y"
    { (yyval.str) = make_str("volatile"); ;}
    break;

  case 2517:

/* Line 1455 of yacc.c  */
#line 13496 "preproc.y"
    { (yyval.str) = make_str("bool"); ;}
    break;

  case 2518:

/* Line 1455 of yacc.c  */
#line 13497 "preproc.y"
    { (yyval.str) = make_str("enum"); ;}
    break;

  case 2519:

/* Line 1455 of yacc.c  */
#line 13498 "preproc.y"
    { (yyval.str) = make_str("hour"); ;}
    break;

  case 2520:

/* Line 1455 of yacc.c  */
#line 13499 "preproc.y"
    { (yyval.str) = make_str("int"); ;}
    break;

  case 2521:

/* Line 1455 of yacc.c  */
#line 13500 "preproc.y"
    { (yyval.str) = make_str("long"); ;}
    break;

  case 2522:

/* Line 1455 of yacc.c  */
#line 13501 "preproc.y"
    { (yyval.str) = make_str("minute"); ;}
    break;

  case 2523:

/* Line 1455 of yacc.c  */
#line 13502 "preproc.y"
    { (yyval.str) = make_str("month"); ;}
    break;

  case 2524:

/* Line 1455 of yacc.c  */
#line 13503 "preproc.y"
    { (yyval.str) = make_str("second"); ;}
    break;

  case 2525:

/* Line 1455 of yacc.c  */
#line 13504 "preproc.y"
    { (yyval.str) = make_str("short"); ;}
    break;

  case 2526:

/* Line 1455 of yacc.c  */
#line 13505 "preproc.y"
    { (yyval.str) = make_str("signed"); ;}
    break;

  case 2527:

/* Line 1455 of yacc.c  */
#line 13506 "preproc.y"
    { (yyval.str) = make_str("struct"); ;}
    break;

  case 2528:

/* Line 1455 of yacc.c  */
#line 13507 "preproc.y"
    { (yyval.str) = make_str("unsigned"); ;}
    break;

  case 2529:

/* Line 1455 of yacc.c  */
#line 13508 "preproc.y"
    { (yyval.str) = make_str("year"); ;}
    break;

  case 2530:

/* Line 1455 of yacc.c  */
#line 13509 "preproc.y"
    { (yyval.str) = make_str("char"); ;}
    break;

  case 2531:

/* Line 1455 of yacc.c  */
#line 13510 "preproc.y"
    { (yyval.str) = make_str("float"); ;}
    break;

  case 2532:

/* Line 1455 of yacc.c  */
#line 13511 "preproc.y"
    { (yyval.str) = make_str("to"); ;}
    break;

  case 2533:

/* Line 1455 of yacc.c  */
#line 13512 "preproc.y"
    { (yyval.str) = make_str("union"); ;}
    break;

  case 2534:

/* Line 1455 of yacc.c  */
#line 13513 "preproc.y"
    { (yyval.str) = make_str("varchar"); ;}
    break;

  case 2535:

/* Line 1455 of yacc.c  */
#line 13514 "preproc.y"
    { (yyval.str) = make_str("["); ;}
    break;

  case 2536:

/* Line 1455 of yacc.c  */
#line 13515 "preproc.y"
    { (yyval.str) = make_str("]"); ;}
    break;

  case 2537:

/* Line 1455 of yacc.c  */
#line 13516 "preproc.y"
    { (yyval.str) = make_str("="); ;}
    break;

  case 2538:

/* Line 1455 of yacc.c  */
#line 13517 "preproc.y"
    { (yyval.str) = make_str(":"); ;}
    break;

  case 2539:

/* Line 1455 of yacc.c  */
#line 13520 "preproc.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 2540:

/* Line 1455 of yacc.c  */
#line 13521 "preproc.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 2541:

/* Line 1455 of yacc.c  */
#line 13522 "preproc.y"
    { (yyval.str) = make_str("all"); ;}
    break;

  case 2542:

/* Line 1455 of yacc.c  */
#line 13523 "preproc.y"
    { (yyval.str) = make_str("all"); ;}
    break;

  case 2543:

/* Line 1455 of yacc.c  */
#line 13526 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2544:

/* Line 1455 of yacc.c  */
#line 13527 "preproc.y"
    { (yyval.str) = cat_str(3, make_str("("), (yyvsp[(2) - (3)].str), make_str(")")); ;}
    break;

  case 2545:

/* Line 1455 of yacc.c  */
#line 13528 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("+"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2546:

/* Line 1455 of yacc.c  */
#line 13529 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("-"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2547:

/* Line 1455 of yacc.c  */
#line 13530 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("*"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2548:

/* Line 1455 of yacc.c  */
#line 13531 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("/"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2549:

/* Line 1455 of yacc.c  */
#line 13532 "preproc.y"
    { (yyval.str) = cat_str(3, (yyvsp[(1) - (3)].str), make_str("%"), (yyvsp[(3) - (3)].str)); ;}
    break;

  case 2550:

/* Line 1455 of yacc.c  */
#line 13533 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2551:

/* Line 1455 of yacc.c  */
#line 13534 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2552:

/* Line 1455 of yacc.c  */
#line 13537 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2553:

/* Line 1455 of yacc.c  */
#line 13538 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2554:

/* Line 1455 of yacc.c  */
#line 13539 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2555:

/* Line 1455 of yacc.c  */
#line 13540 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2556:

/* Line 1455 of yacc.c  */
#line 13541 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2557:

/* Line 1455 of yacc.c  */
#line 13544 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2558:

/* Line 1455 of yacc.c  */
#line 13545 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2559:

/* Line 1455 of yacc.c  */
#line 13548 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 2560:

/* Line 1455 of yacc.c  */
#line 13550 "preproc.y"
    {
		struct variable *var;

		var = argsinsert->variable;
		remove_variable_from_list(&argsinsert, var);
		add_variable_to_head(&argsresult, var, &no_indicator);
		(yyval.str) = (yyvsp[(1) - (1)].str);
	;}
    break;

  case 2561:

/* Line 1455 of yacc.c  */
#line 13560 "preproc.y"
    { (yyval.str) = EMPTY; ;}
    break;

  case 2562:

/* Line 1455 of yacc.c  */
#line 13561 "preproc.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;



/* Line 1455 of yacc.c  */
#line 47820 "preproc.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 13564 "preproc.y"


void base_yyerror(const char *error)
{
	/* translator: %s is typically the translation of "syntax error" */
	mmerror(PARSE_ERROR, ET_ERROR, "%s at or near \"%s\"",
			_(error), token_start ? token_start : yytext);
}

void parser_init(void)
{
 /* This function is empty. It only exists for compatibility with the backend parser right now. */
}

/*
 * Must undefine base_yylex before including pgc.c, since we want it
 * to create the function base_yylex not filtered_base_yylex.
 */
#undef base_yylex

#include "pgc.c"

